#include <stdio.h>

#define NMAX 512
#define KMAX 10
#define INF 1000000000

int A[NMAX][NMAX];
int **(cmin[2 * NMAX + 1]), dim[2 * NMAX + 1], pstart[2 * NMAX + 1];
int fmin[NMAX];
int N, K, i, j, p, q, idx, l, r, x;

int main() {
	//freopen("t.txt", "r", stdin);
	scanf("%d", &K);
	N = 1 << K;
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			scanf("%d", &A[i][j]);

	x = 0;
	for (idx = 2 * N - 1; idx >= 1; idx--) {	
		if (idx >= N) {
			pstart[idx] = idx - N;
			dim[idx] = 1;
			cmin[idx] = new int*[dim[idx]];
			for (p = 0; p < dim[idx]; p++) {
				cmin[idx][p] = new int[dim[idx]];
				for (j = 0; j < dim[idx]; j++) {
					cmin[idx][p][j] = 0;
				}
			}
		} else {
			l = 2 * idx;
			r = l + 1;
			dim[idx] = 2 * dim[l];
			pstart[idx] = pstart[l];
			
			//fprintf(stderr, "idx=%d, l=%d, r=%d, dim=%d, pstart=%d\n", idx, l, r, dim[idx], pstart[idx]);
			
			if (idx == 1) {
				for (j = pstart[l]; j < pstart[l] + dim[l]; j++) {
					fmin[j] = INF;
					for (i = pstart[l]; i < pstart[l] + dim[l]; i++)
						if (cmin[l][i - pstart[l]][j - pstart[l]] < fmin[j])
							fmin[j] = cmin[l][i - pstart[l]][j - pstart[l]];
				}

				for (p = pstart[r]; p < pstart[r] + dim[r]; p++) {
					fmin[p] = INF;
					for (q = pstart[r]; q < pstart[r] + dim[r]; q++)
						if (cmin[r][p - pstart[r]][q - pstart[r]] < fmin[p])
							fmin[p] = cmin[r][p - pstart[r]][q - pstart[r]];
				}
				
				x = INF;
				for (j = pstart[l]; j < pstart[l] + dim[l]; j++)
					for (p = pstart[r]; p < pstart[r] + dim[r]; p++)
						if (fmin[j] + fmin[p] + A[j][p] < x)
							x = fmin[j] + fmin[p] + A[j][p];

				break;
			}
			
			cmin[idx] = new int*[dim[idx]];
			for (p = 0; p < dim[idx]; p++) {
				cmin[idx][p] = new int[dim[idx]];
				for (j = 0; j < dim[idx]; j++) {
					cmin[idx][p][j] = INF;
				}
			}

			for (i = pstart[l]; i < pstart[l] + dim[l]; i++)
				for (j = pstart[l]; j < pstart[l] + dim[l]; j++)
					if (cmin[l][i - pstart[l]][j - pstart[l]] < INF)
						for (p = pstart[r]; p < pstart[r] + dim[r]; p++)
							for (q = pstart[r]; q < pstart[r] + dim[r]; q++) {
								x = cmin[l][i - pstart[l]][j - pstart[l]] + A[j][p] +
									cmin[r][p - pstart[r]][q - pstart[r]];
								if (x < cmin[idx][i - pstart[idx]][q - pstart[idx]]) {
									cmin[idx][i - pstart[idx]][q - pstart[idx]] = x;
									//fprintf(stderr, "idx=%d, cmin(%d->%d)=%d\n", idx, i, q, x);
								}
	
								x = cmin[r][p - pstart[r]][q - pstart[r]] + A[q][i] +
									cmin[l][i - pstart[l]][j - pstart[l]] ;
								if (x < cmin[idx][p - pstart[idx]][j - pstart[idx]]) {
									cmin[idx][p - pstart[idx]][j - pstart[idx]] = x;
									//fprintf(stderr, "idx=%d, cmin(%d->%d)=%d\n", idx, p, j, x);
								}
							}				
		}
	}

	/*
	x = INF;
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			if (i != j) {
				if (cmin[1][i][j] < x)
					x = cmin[1][i][j];
			}
	*/
	
	printf("%d\n", x);
			
	return 0;
}
