#include <stdio.h>

long long A, B;

long long gcd(long long a, long long b) {
	if ((a % b) == 0)
		return b;
	return gcd(b, a % b);
}

long long seqLen(long long X) {
	if (X == 2)
		return 1;
	long long Y = 2;
	while ((X % Y) == 0)
		Y++;
	return 1 + seqLen(Y);
}

long long numBrute(long long X) {
	long long answer = 0;
	for (long long i = 1; i <= X; i++)
		answer += seqLen(i);
	return answer;
}

long long num(long long X) {
	if (X <= 1)
		return 2;
	//if (X == 2)
	//	return 3;
	long long answer = 0, cmult = 1, d, p;
	long long cnum = 2;
	
	while (X > 0) {
		//if (cnum > cmult && X == 1) {
		//	answer += seqLen(cmult);
		//	break;
		//}
		
		d = gcd(cmult, cnum);
		if (d < cnum) {
			p = cnum / d;
			long long slen = seqLen(cnum);
			long long extra = X - X / p;
			if (cmult > 1 && cnum > cmult) {
				//fprintf(stderr, "! cmult=%lld cnum=%lld\n", cmult, cnum);
				extra--;
				answer += seqLen(cmult);
			}
			
			//fprintf(stderr, "cnum=%lld, cmult=%lld, num_cnum=%lld, extra=%lld, slen=%lld\n", cnum, cmult, X - X / p, extra, slen);
			answer += extra * (slen + 1);
			X /= p;
			cmult /= d;
			cmult *= cnum;
		}
		cnum++;
	}

	//fprintf(stderr, "cnum=%lld, answer=%lld\n", cnum, answer);
	return answer;
}

int main() {
	scanf("%lld %lld", &A, &B);
	printf("%lld\n", num(B) - num(A - 1));
	//fprintf(stderr, "num(%lld)=%lld numBrute(%lld)=%lld\n", B, num(B), B, numBrute(B));
	return 0;
}
