/*jslint evil:true */
/*global DISQUS:false */
/**
 * Dynamic thread loader
 *
 * 
 *  * 
 * 
*/

(function (window) {
    var DISQUS = window.DISQUS;
    var jsonData, cookieMessages, session;

    // 
    if (!DISQUS || typeof DISQUS === 'function') {
        throw "DISQUS object is not initialized";
    }
    // 
    // json_data and default_json django template variables will close
    // and re-open javascript comment tags

    /* */ jsonData = {"reactions": [], "reactions_limit": 10, "ordered_highlighted": [], "posts": {}, "ordered_posts": [], "realtime_enabled": false, "ready": true, "mediaembed": [], "has_more_reactions": false, "realtime_paused": false, "integration": {"receiver_url": null, "hide_user_votes": false, "reply_position": false, "disqus_logo": false}, "highlighted": {}, "reactions_start": 0, "media_url": "http://mediacdn.disqus.com/1351287989", "users": {}, "user_unapproved": {}, "messagesx": {"count": 0, "unread": []}, "thread": {"voters_count": 0, "offset_posts": 0, "slug": "algorithm_problems_for_dummies_petr_mitrichevs_blog_51", "likes": 0, "num_pages": 0, "days_alive": 0, "moderate_none": false, "voters": {}, "total_posts": 0, "realtime_paused": false, "queued": false, "pagination_type": "append", "user_vote": null, "num_posts": 0, "closed": false, "per_page": 5, "id": 903049311, "killed": false, "moderate_all": false}, "forum": {"use_media": true, "avatar_size": 32, "apiKey": "NTkpgKM1FwPtsG0RBpdXyszf8lp1XFxQMdTuDcBEhmZQ1RAhhNAhljJuvkMZ7a1o", "features": {}, "comment_max_words": 0, "mobile_theme_disabled": false, "is_early_adopter": false, "login_buttons_enabled": true, "streaming_realtime": false, "reply_position": false, "id": 501995, "default_avatar_url": "http://mediacdn.disqus.com/1351287989/images/noavatar32.png", "template": {"url": "http://mediacdn.disqus.com/1351287989/uploads/themes/7884a9652e94555c70f96b6be63be216/theme.js?254", "mobile": {"url": "http://mediacdn.disqus.com/1351287989/uploads/themes/mobile/theme.js?254", "css": "http://mediacdn.disqus.com/1351287989/uploads/themes/mobile/theme.css?254"}, "api": "1.1", "name": "Houdini", "css": "http://mediacdn.disqus.com/1351287989/uploads/themes/7884a9652e94555c70f96b6be63be216/theme.css?254"}, "max_depth": 0, "ranks_enabled": false, "lastUpdate": "", "linkbacks_enabled": false, "allow_anon_votes": true, "revert_new_login_flow": false, "stylesUrl": "http://mediacdn.disqus.com/uploads/styles/50/1995/petrmitrichevblog.css", "show_avatar": true, "reactions_enabled": false, "disqus_auth_disabled": false, "name": "Petr Mitrichev Blog", "language": "en", "mentions_enabled": true, "url": "petrmitrichevblog", "allow_anon_post": true, "thread_votes_disabled": true, "hasCustomStyles": false, "moderate_all": false}, "settings": {"realtimeHost": "qq.disqus.com", "uploads_url": "http://media.disqus.com/uploads", "ssl_media_url": "https://securecdn.disqus.com/1351287989", "realtime_url": "http://rt.disqus.com/forums/realtime-cached.js", "facebook_app_id": "52254943976", "minify_js": true, "recaptcha_public_key": "6LdKMrwSAAAAAPPLVhQE9LPRW4LUSZb810_iaa8u", "read_only": false, "facebook_api_key": "52254943976", "juggler_url": "http://juggler.services.disqus.com", "realtimePort": "80", "debug": false, "disqus_url": "http://disqus.com", "media_url": "http://mediacdn.disqus.com/1351287989"}, "ranks": {}, "request": {"sort": "hot", "is_authenticated": false, "user_type": "anon", "subscribe_on_post": 0, "missing_perm": null, "user_id": null, "remote_domain_name": "", "remote_domain": "", "is_verified": false, "profile_url": "", "username": "", "is_global_moderator": false, "sharing": {}, "timestamp": "2012-10-27_12:36:25", "is_moderator": false, "ordered_unapproved_posts": [], "unapproved_posts": {}, "forum": "petrmitrichevblog", "is_initial_load": true, "display_username": "", "points": null, "has_email": false, "moderator_can_edit": false, "is_remote": false, "userkey": "", "page": 1}, "context": {"use_twitter_signin": false, "use_fb_connect": false, "show_reply": true, "sigma_chance": 10, "use_google_signin": false, "switches": {"olark_admin_addons": true, "use_rs_paginator_30m": true, "es_index_threads": true, "digests:events:2": true, "digests:events:3": true, "postsort": true, "digests:events:1": true, "firehose": true, "promoted_click_optimization": true, "olark_admin_packages": true, "upload_media": true, "website_addons": true, "firehose_gnip_http": true, "textdigger_classification": true, "google_translate": true, "digests:events": true, "next_realtime": true, "firehose_message_db_lookup": true, "digests": true, "juggler_thread_onReady": true, "website_homepage_https_off": true, "juggler_enabled": true, "promoted_discovery_budget": true, "use_impermium": true, "use_meta_redirect": true, "digests:render": true, "notifications": true, "shardpost:index": true, "usertransformer_reputation": true, "fingerprint": true, "send_to_impermium": true, "firehose_push": true, "shardpost": true, "train_impermium": true, "discovery_analytics": true, "discovery_next:truncate": true, "limit_get_posts_days_30d": true, "uploads:Forum": true, "uploads:UserProfile:duplex": true, "firehose_pubsub_throttle": true, "uploads": true, "new_moderate": true, "redis_threadcount": true, "html_email": true, "listactivity_replies": true, "uploads:AnonymousUser": true, "phoenix_reputation": true, "next_thread_sharing": true, "use_master_for_api": true, "next_realtime_indicators": true, "community_icon": true, "discovery_jones": true, "website_base_template": true, "originalauthor_switchover": true, "static_styles": true, "discovery_next:promoted": true, "realtime": true, "redis_notification_tokens": true, "discovery_next": true, "show_captcha_on_links": true, "olark_support": true, "firehose_gnip": true, "firehose_pubsub": true, "uploads:AnonymousUser:duplex": true, "olark_addons": true, "phoenix_optout": true, "edits_to_spam": true, "avatar_duplex_save": true, "promoted_discovery_random": true, "discovery_community": true, "uploads:Forum:duplex": true, "phoenix": true, "discovery_redirect_event": true, "new_sort_paginator": true, "theme_editor_disabled": true, "limit_textdigger": true, "textdigger_crawler": true, "listactivity_replies_30d": true, "use_rs_paginator_5m": true, "uploads:UserProfile": true, "next_discard_low_rep": true, "google_analytics": true, "mentions": true, "olark_install": true}, "forum_facebook_key": "", "use_yahoo": false, "subscribed": false, "active_gargoyle_switches": ["avatar_duplex_save", "community_icon", "digests", "digests:events", "digests:events:1", "digests:events:2", "digests:events:3", "digests:render", "discovery_analytics", "discovery_community", "discovery_jones", "discovery_next", "discovery_next:promoted", "discovery_next:truncate", "discovery_redirect_event", "edits_to_spam", "es_index_threads", "fingerprint", "firehose", "firehose_gnip", "firehose_gnip_http", "firehose_message_db_lookup", "firehose_pubsub", "firehose_pubsub_throttle", "firehose_push", "google_analytics", "google_translate", "html_email", "juggler_enabled", "juggler_thread_onReady", "limit_get_posts_days_30d", "limit_textdigger", "listactivity_replies", "listactivity_replies_30d", "mentions", "new_moderate", "new_sort_paginator", "next_discard_low_rep", "next_realtime", "next_realtime_indicators", "next_thread_sharing", "notifications", "olark_addons", "olark_admin_addons", "olark_admin_packages", "olark_install", "olark_support", "originalauthor_switchover", "phoenix", "phoenix_optout", "phoenix_reputation", "postsort", "promoted_click_optimization", "promoted_discovery_budget", "promoted_discovery_random", "realtime", "redis_notification_tokens", "redis_threadcount", "send_to_impermium", "shardpost", "shardpost:index", "show_captcha_on_links", "static_styles", "textdigger_classification", "textdigger_crawler", "theme_editor_disabled", "train_impermium", "uploads", "uploads:AnonymousUser", "uploads:AnonymousUser:duplex", "uploads:Forum", "uploads:Forum:duplex", "uploads:UserProfile", "uploads:UserProfile:duplex", "use_impermium", "use_master_for_api", "use_meta_redirect", "use_rs_paginator_30m", "use_rs_paginator_5m", "usertransformer_reputation", "website_addons", "website_base_template", "website_homepage_https_off"], "realtime_speed": 15000, "use_openid": true}}; /* */
    /* __extrajson__ */
    cookieMessages = {"user_created": null, "post_has_profile": null, "post_twitter": null, "post_not_approved": null}; session = {"url": null, "name": null, "email": null};
    jsonData.forum.template = {"url": "http://mediacdn.disqus.com/1351287989/uploads/themes/7884a9652e94555c70f96b6be63be216/theme.js?254", "mobile": {"url": "http://mediacdn.disqus.com/1351287989/uploads/themes/mobile/theme.js?254", "css": "http://mediacdn.disqus.com/1351287989/uploads/themes/mobile/theme.css?254"}, "api": "1.1", "name": "Houdini", "css": "http://mediacdn.disqus.com/1351287989/uploads/themes/7884a9652e94555c70f96b6be63be216/theme.css?254"};
    jsonData.context.active_gargoyle_switches = ["avatar_duplex_save", "community_icon", "digests", "digests:events", "digests:events:1", "digests:events:2", "digests:events:3", "digests:render", "discovery_analytics", "discovery_community", "discovery_jones", "discovery_next", "discovery_next:promoted", "discovery_next:truncate", "discovery_redirect_event", "edits_to_spam", "es_index_threads", "fingerprint", "firehose", "firehose_gnip", "firehose_gnip_http", "firehose_message_db_lookup", "firehose_pubsub", "firehose_pubsub_throttle", "firehose_push", "google_analytics", "google_translate", "html_email", "juggler_enabled", "juggler_thread_onReady", "limit_get_posts_days_30d", "limit_textdigger", "listactivity_replies", "listactivity_replies_30d", "mentions", "new_moderate", "new_sort_paginator", "next_discard_low_rep", "next_realtime", "next_realtime_indicators", "next_thread_sharing", "notifications", "olark_addons", "olark_admin_addons", "olark_admin_packages", "olark_install", "olark_support", "originalauthor_switchover", "phoenix", "phoenix_optout", "phoenix_reputation", "postsort", "promoted_click_optimization", "promoted_discovery_budget", "promoted_discovery_random", "realtime", "redis_notification_tokens", "redis_threadcount", "send_to_impermium", "shardpost", "shardpost:index", "show_captcha_on_links", "static_styles", "textdigger_classification", "textdigger_crawler", "theme_editor_disabled", "train_impermium", "uploads", "uploads:AnonymousUser", "uploads:AnonymousUser:duplex", "uploads:Forum", "uploads:Forum:duplex", "uploads:UserProfile", "uploads:UserProfile:duplex", "use_impermium", "use_master_for_api", "use_meta_redirect", "use_rs_paginator_30m", "use_rs_paginator_5m", "usertransformer_reputation", "website_addons", "website_base_template", "website_homepage_https_off"];
    jsonData.context.all_switches = {"olark_admin_addons": true, "use_rs_paginator_30m": true, "es_index_threads": true, "digests:events:2": true, "digests:events:3": true, "postsort": true, "digests:events:1": true, "firehose": true, "promoted_click_optimization": true, "olark_admin_packages": true, "website_addons": true, "firehose_gnip_http": true, "textdigger_classification": true, "google_translate": true, "digests:events": true, "next_realtime": true, "firehose_message_db_lookup": true, "digests": true, "juggler_thread_onReady": true, "website_homepage_https_off": true, "juggler_enabled": true, "promoted_discovery_budget": true, "use_impermium": true, "use_meta_redirect": true, "digests:render": true, "notifications": true, "shardpost:index": true, "usertransformer_reputation": true, "fingerprint": true, "send_to_impermium": true, "firehose_push": true, "shardpost": true, "train_impermium": true, "discovery_analytics": true, "discovery_next:truncate": true, "limit_get_posts_days_30d": true, "uploads:Forum": true, "uploads:UserProfile:duplex": true, "firehose_pubsub_throttle": true, "uploads": true, "new_moderate": true, "redis_threadcount": true, "html_email": true, "listactivity_replies": true, "uploads:AnonymousUser": true, "phoenix_reputation": true, "next_thread_sharing": true, "use_master_for_api": true, "next_realtime_indicators": true, "community_icon": true, "discovery_jones": true, "website_base_template": true, "originalauthor_switchover": true, "static_styles": true, "discovery_next:promoted": true, "realtime": true, "redis_notification_tokens": true, "discovery_next": true, "show_captcha_on_links": true, "olark_support": true, "firehose_gnip": true, "firehose_pubsub": true, "uploads:AnonymousUser:duplex": true, "olark_addons": true, "phoenix_optout": true, "edits_to_spam": true, "avatar_duplex_save": true, "promoted_discovery_random": true, "discovery_community": true, "uploads:Forum:duplex": true, "phoenix": true, "discovery_redirect_event": true, "new_sort_paginator": true, "theme_editor_disabled": true, "limit_textdigger": true, "textdigger_crawler": true, "listactivity_replies_30d": true, "use_rs_paginator_5m": true, "uploads:UserProfile": true, "next_discard_low_rep": true, "google_analytics": true, "mentions": true, "olark_install": true};

    DISQUS.jsonData = jsonData;
    DISQUS.jsonData.cookie_messages = cookieMessages;
    DISQUS.jsonData.session = session;

    if (DISQUS.useSSL) {
        DISQUS.useSSL(DISQUS.jsonData.settings);
    }

    // The mappings below are for backwards compatibility--before we port all the code that
    // accesses jsonData.settings to DISQUS.settings

    var mappings = {
        debug:                'disqus.debug',
        minify_js:            'disqus.minified',
        read_only:            'disqus.readonly',
        recaptcha_public_key: 'disqus.recaptcha.key',
        facebook_app_id:      'disqus.facebook.appId',
        facebook_api_key:     'disqus.facebook.apiKey'
    };

    var urlMappings = {
        disqus_url:    'disqus.urls.main',
        media_url:     'disqus.urls.media',
        ssl_media_url: 'disqus.urls.sslMedia',
        realtime_url:  'disqus.urls.realtime',
        uploads_url:   'disqus.urls.uploads'
    };

    if (DISQUS.jsonData.context.switches.realtime_setting_change) {
        urlMappings.realtimeHost = 'realtime.host';
        urlMappings.realtimePort = 'realtime.port';
    }
    for (key in mappings) {
        if (mappings.hasOwnProperty(key)) {
            DISQUS.settings.set(mappings[key], DISQUS.jsonData.settings[key]);
        }
    }

    for (key in urlMappings) {
        if (urlMappings.hasOwnProperty(key)) {
            DISQUS.jsonData.settings[key] = DISQUS.settings.get(urlMappings[key]);
        }
    }

    DISQUS.jsonData.context.csrf_token = '21bc467119200cb06806902fa8e2f5b0';

    DISQUS.jsonData.urls = {
        login: 'http://disqus.com/profile/login/',
        logout: 'http://disqus.com/logout/',
        upload_remove: 'http://petrmitrichevblog.disqus.com/thread/algorithm_problems_for_dummies_petr_mitrichevs_blog_51/async_media_remove/',
        request_user_profile: 'http://disqus.com/AnonymousUser/',
        request_user_avatar: 'http://mediacdn.disqus.com/1351287989/images/noavatar92.png',
        verify_email: 'http://disqus.com/verify/',
        remote_settings: 'http://petrmitrichevblog.disqus.com/_auth/embed/remote_settings/',
        edit_profile_window: 'http://disqus.com/embed/profile/edit/',
        embed_thread: 'http://petrmitrichevblog.disqus.com/thread.js',
        embed_vote: 'http://petrmitrichevblog.disqus.com/vote.js',
        embed_thread_vote: 'http://petrmitrichevblog.disqus.com/thread_vote.js',
        embed_thread_share: 'http://petrmitrichevblog.disqus.com/thread_share.js',
        embed_queueurl: 'http://petrmitrichevblog.disqus.com/queueurl.js',
        embed_hidereaction: 'http://petrmitrichevblog.disqus.com/hidereaction.js',
        embed_more_reactions: 'http://petrmitrichevblog.disqus.com/more_reactions.js',
        embed_subscribe: 'http://petrmitrichevblog.disqus.com/subscribe.js',
        embed_highlight: 'http://petrmitrichevblog.disqus.com/highlight.js',
        embed_block: 'http://petrmitrichevblog.disqus.com/block.js',
        update_moderate_all: 'http://petrmitrichevblog.disqus.com/update_moderate_all.js',
        update_days_alive: 'http://petrmitrichevblog.disqus.com/update_days_alive.js',
        show_user_votes: 'http://petrmitrichevblog.disqus.com/show_user_votes.js',
        forum_view: 'http://petrmitrichevblog.disqus.com/algorithm_problems_for_dummies_petr_mitrichevs_blog_51',
        cnn_saml_try: 'http://disqus.com/saml/cnn/try/',
        realtime: DISQUS.jsonData.settings.realtime_url,
        thread_view: 'http://petrmitrichevblog.disqus.com/thread/algorithm_problems_for_dummies_petr_mitrichevs_blog_51/',
        twitter_connect: DISQUS.jsonData.settings.disqus_url + '/_ax/twitter/begin/',
        yahoo_connect: DISQUS.jsonData.settings.disqus_url + '/_ax/yahoo/begin/',
        openid_connect: DISQUS.jsonData.settings.disqus_url + '/_ax/openid/begin/',
        googleConnect: DISQUS.jsonData.settings.disqus_url + '/_ax/google/begin/',
        community: 'http://petrmitrichevblog.disqus.com/community.html',
        admin: 'http://petrmitrichevblog.disqus.com/admin/moderate/',
        moderate: 'http://petrmitrichevblog.disqus.com/admin/moderate/',
        moderate_threads: 'http://petrmitrichevblog.disqus.com/admin/moderate-threads/',
        settings: 'http://petrmitrichevblog.disqus.com/admin/settings/',
        unmerged_profiles: 'http://disqus.com/embed/profile/unmerged_profiles/',
        juggler: DISQUS.jsonData.settings.juggler_url,

        channels: {
            def:      'http://disqus.com/default.html', /* default channel */
            auth:     'https://disqus.com/embed/login.html',
            tweetbox: 'http://disqus.com/forums/integrations/twitter/tweetbox.html?f=petrmitrichevblog',
            edit:     'http://petrmitrichevblog.disqus.com/embed/editcomment.html'
        }
    };


    // 
    //     
    DISQUS.jsonData.urls.channels.reply = 'http://mediacdn.disqus.com/1351287989/build/system/reply.html';
    DISQUS.jsonData.urls.channels.upload = 'http://mediacdn.disqus.com/1351287989/build/system/upload.html';
    DISQUS.jsonData.urls.channels.sso = 'http://mediacdn.disqus.com/1351287989/build/system/sso.html';
    DISQUS.jsonData.urls.channels.facebook = 'http://mediacdn.disqus.com/1351287989/build/system/facebook.html';
    //     
    // 
}(window));
