#python3
from fractions import gcd

fin = open("game.in")
fout = open("game.out", "w")

n = int(fin.readline())
a = list(map(int, fin.readline().split()))

res = dict()

def solve(first, num, d): # first number taken,
                            # num - current number of numbers taken, 
                            # d - their difs gcd
    if (first, num, d) in res.keys():
        return res[(first, num, d)]
    if num == n:
        res[(first, num, d)] = False
        return False
    count = 0
    chance = False
    for el in a:
        el = abs(el - first)
        if el != 0:
            if d > 0 and el % d == 0:
                count += 1
            else:
                if gcd(d, el) > 1 and not solve(first, num + 1, gcd(d, el)):
                    res[(first, num, d)] = True
                    return True
    else:
        if count >= num:
            if not solve(first, num + 1, d):
                res[(first, num, d)] = True
                return True
    res[(first, num, d)] = False
    return False


answer = []
for el in a:
    if not solve(el, 1, 0):
        answer.append(el)
print(len(answer), file = fout)
print(" ".join(map(str, answer)), file = fout)

