#python3
from math import sqrt, floor, ceil

fin = open("spacepin.in")
fout = open("spacepin.out", "w")

r, n = map(int, fin.readline().split())
d = int(fin.readline())
x, y = map(int, fin.readline().split()) 
a, b = map(int, fin.readline().split())
x *= 1000
y *= 1000

d = d + r

def r(i, j):
    return (a * (1000 * i - y) - b * (1000 * j - x))
 
#print(r(1,-1) ** 2, d ** 2 * (a ** 2 + b ** 2))
def binsearch_left(i):
    left = - i - 1
    right = i
    while right > left + 1:
        #print('(',left,',',right,']')
        med = (left + right) // 2 
        #print('>>>i=',i,'left :',r(i, left),'right:', r(i, right),'med :',r(i, med))
        #print('dist = r(',i,',',med,')')
        dist = r(i, med)
        #print(med, dist, dist ** 2, e, dist < -sqrt(e))
        if dist > 0 and dist **2 > e:
            left = med
            #print('left=med=',left)
        else:
            right = med
            #print('right=med=',right)
        #print('[',left,',',right,')')
    #print(i, left, r(i, left) ** 2, e,r(i, left) ** 2 <= e)
    if right % 2 != i % 2:
         right += 1
         #print('*')
    return right

def binsearch_right(i):
    left = -i
    right = i + 1
    while right > left + 1:
        med = (left + right) // 2 
        #print('>>>i=',i,'left :',r(i, left),'right:', r(i, right),'med :',r(i, med))
        #print('dist = r(',i,',',med,')')
        dist = r(i, med)
        #print(med, dist, dist ** 2, e, dist ** 2 < e)
        if dist >= 0 or dist ** 2 <= e:
            left = med
            #print('left=med=',left)
        else:
            right = med
            #print('right=med=',right)
    #print(i, left, r(i, left) ** 2, e, r(i, left) ** 2 <= e)
    if left % 2 != i % 2:
         left -= 1
    return left

if b <= 0:
    print(0, file = fout)
else:
    result = 0
    e = d ** 2 * (a ** 2 + b ** 2)
    for i in range(n):
        res_line = 0
        le = binsearch_left(i)
        ri = binsearch_right(i)
        if r(i, le) ** 2 <= e:
            #print('!!!', i, le, ri)
            #print(i, max((ri - le) // 2 + 1, 0) ) 
            result += max((ri - le) // 2 + 1, 0) 
    print(result, file = fout)           
