import java.io.*;
import java.util.*;

public class sufpref_ats_TL implements Runnable {
	public static void main(String[] args) {
		new Thread(new sufpref_ats_TL()).start();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	final int ALPHSIZE = 26;
	final int MAXSIZE = 52;

	String[] s;

	int left;
	int right;

	public void solve() throws IOException {
		int n = nextInt();
		s = new String[n];
		for (int i = 0; i < n; i++) {
			s[i] = nextToken();
		}
		int m = nextInt();
		for (int i = 0; i < m; i++) {
			String query = nextToken();
			int ans = 0;
			int len = query.length();
			for (int j = 0; j < n; j++) {
				if (s[j].length() >= len
						&& s[j].substring(0, len).equals(query)
						&& s[j].substring(s[j].length() - len).equals(query)) {
					ans++;
				}
			}
			out.println(ans);
		}
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("sufpref.in"));
			out = new PrintWriter("sufpref.out");

			solve();

			out.close();
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
