{$apptype console}
{$r+,o-}

uses
    SysUtils;

type Node = record
    next : array['a'..'z'] of longint;
    prev : longint;
    cnt : longint;
    ownCnt : longint;
end;

var
    n, m : longint;
    ss : string;
    s : array[1..100] of char;
    t : array[1..2000000] of Node;
    last : longint;

procedure magic();
var
    len, i, pos : longint;
begin
    len := length(ss);
    pos := 1;
    for i := 1 to len do begin
        s[pos] := ss[i];
        inc(pos);
        s[pos] := ss[len - i + 1];
        inc(pos);
    end;
end;

procedure add();
var
    cur, i, len : longint;
    j : char;
begin
    cur := 1;
    len := 2 * length(ss);
    for i := 1 to len do begin
        if (t[cur].next[s[i]] = -1) then begin
            inc(last);
            t[last].prev := cur;
            t[cur].next[s[i]] := last;
            for j := 'a' to 'z' do
                t[last].next[j] := -1;
            t[last].cnt := 0;
            t[last].ownCnt := 0;
        end;
        cur := t[cur].next[s[i]];
    end;
    inc(t[cur].ownCnt);
    inc(t[cur].cnt);
    while (cur <> 1) do begin
        inc(t[t[cur].prev].cnt);
        cur := t[cur].prev;    
    end;
end;

function answer(): longint;
var
    cur, len, i : longint;
begin
    cur := 1;
    len := 2 * length(ss);
    for i := 1 to len do begin
        if (t[cur].next[s[i]] = -1) then begin
            result := 0;
            exit;
        end;
        cur := t[cur].next[s[i]];
    end;
    result := t[cur].cnt;
end;
    
var
    i : longint;
    j : char;

begin
    reset(input, 'sufpref.in');
    rewrite(output, 'sufpref.out');
    readln(n);
    t[1].prev := -1;
    t[1].cnt := 0;
    t[1].ownCnt := 0;
    last := 1;
    for j := 'a' to 'z' do
        t[1].next[j] := -1;
    for i := 1 to n do begin
        readln(ss);
        magic();
        add();
    end;
    readln(m);
    for i := 1 to m do begin
        readln(ss);
        magic();
        writeln(answer());
    end;
end.