#python3
from bisect import bisect_left, bisect_right

fin = open("sufpref.in")
fout = open("sufpref.out", "w")

def fkey(word):
   n = len(word)
   s = [''] * (2 * n)
   s[::2] = list(word)
   s[1::2] = list(word[::-1])
   return "".join(s)

s = fin.read().split('\n')

n = int(s[0])
words = [fkey(word) for word in s[1:n+1]]
words.sort()

k = int(s[n+1])

suf = [fkey(word) for word in s[n+2:n+k+2]]
res = [str(bisect_left(words, s[:-1] + chr(ord(s[-1])+1)) - bisect_left(words, s)) for s in suf]
print("\n".join(res), file = fout)

