{$mode delphi}
const
	maxd = 102;

type
	tlong = array [1..maxd] of longint;

var
	a, b: string;
	c: longint;
	an, bn, cn: tlong;

function convert(s: string): tlong;
var
	i: longint;
	start: longint;
begin
	for i := 1 to maxd do 
		result[i] := 0;

	if s[1] = '-' then
		start := 2
	else
		start := 1;

	for i := length(s) downto start do begin
		result[length(s) - i + 1] := ord(s[i]) - ord('0');
	end;

	if (s[1] = '-') then begin
		for i := maxd downto 1 do
			result[i] := 9 - result[i];
		i := 1;
		while (result[i] = 9) do begin
			result[i] := 0;
			inc(i);
		end;
		inc(result[i]);
	end;
end;

var
	i: longint;

begin
	assign(input, 'sum.in');
	reset(input);
	assign(output, 'sum.out');
	rewrite(output);

	readln(a);
	readln(b);

//	assert(isNumber(a, 100));
//	assert(isNumber(b, 100));

	an := convert(a);
	bn := convert(b);

	c := 0;
	for i := 1 to maxd do begin	
		c := c + an[i] + bn[i];
		cn[i] := c mod 10;
		c := c div 10;
	end;

	if cn[maxd] = 9 then begin
		for i := 1 to maxd do 
			cn[i] := 9 - cn[i];
		i := 1;
		while cn[i] = 9 do begin
			cn[i] := 0;
			inc(i);	
		end;
		inc(cn[i]);
		write('-');
	end;

	i := maxd;
	while (i > 1) and (cn[i] = 0) do
		dec(i);

	while i > 0 do begin
		write(cn[i]);
		dec(i);
	end;

	close(input);
	close(output);
end.