#include <fstream>
#include <cstring>
#include <iostream>
#include <cassert>

using namespace std;

const int maxN = 16;
const int maxP = 81 * 81 * 81 * 81;
const int maxH = 5000017;
const int maxQ = 500000;

int n, k;
int a[maxN], aa[maxN];
long long f[maxH];
unsigned h[maxH];
unsigned q[maxQ];
int fi, la;

inline int get( int p, int i ) {
  return (p >> (2 * i)) & 3;
}

inline int hGet( unsigned pp ) {
  int hp = pp % maxH;
  while (h[hp] != pp && f[hp] != -1) {
    if (++hp == maxH) {
      hp = 0;
    }
  }
  return hp;
}

int main() {
  ifstream fin("army.in");
  ofstream fout("army.out");

  fin >> n >> k;
  memset(aa, -1, sizeof(aa));
  for (int i = 0; i < k; ++i) {
    fin >> a[i];
    a[i]--;
    aa[a[i]] = i;
  }
  long long ans = 0;
  memset(h, -1, sizeof(h));
  memset(f, -1, sizeof(f));
  f[0] = 1;
  h[0] = 0;
  fi = la = 0;
  q[la++] = 0;
  int v[maxN], vk;
  bool ta;
  while (fi < la) {
    unsigned p = q[fi++];
    int hp = hGet(p);
    ta = true;
    vk = 0;
    for (int i = 0; i < n; ++i) {
      int t = get(p, i);
      if (t == 1) {
        v[vk++] = i;
      } else if (t == 0) {
        ta = false;
      }
    }
    if (ta) {
      ans += f[hp];
    }
    for (int i = n - 1; i >= 0; --i) {
      int pos = vk;
      if (!get(p, i)) {
        if (aa[i] > 0 && !get(p, a[aa[i] - 1])) {
          continue;
        }
        while (pos > 0 && v[pos - 1] > i) {
          pos--;
        }
        if (pos >= k || (aa[i] != -1 && aa[i] != pos)) {
          continue;
        }
        unsigned pp = p;
        if (pos < vk && i < v[pos]) {
          pp += (1 << (2 * v[pos]));
        }
        if (pos == vk || i < v[pos]) {
          pp += (1 << (2 * i));
        } else {
          pp += (2 << (2 * i));
        }
        int hpp = hGet(pp);
        if (f[hpp] == -1) {
          h[hpp] = pp;
          f[hpp] = 0;
          q[la++] = pp;
        }
        f[hpp] += f[hp];
      }
    }
  }
  cerr << "la=" << la << endl;
  fout << ans << endl;

  return 0;
}
