#include <fstream>
#include <cstring>
#include <cassert>
#include <map>

using namespace std;

const int maxN = 16;
const int maxQ = 500000;
const int maxTl = 8;
const int maxT = (1 << (2 * maxTl));

int n, k;
int a[maxN], aa[maxN];
unsigned q[maxQ];
int fi, la;
int cnt[maxT];
int fo[maxT];
int fz[maxT];

inline int get( int p, int i ) {
  return (p >> (2 * i)) & 3;
}

int main() {
  ifstream fin("army.in");
  ofstream fout("army.out");

  fin >> n >> k;
  memset(aa, -1, sizeof(aa));
  for (int i = 0; i < k; ++i) {
    fin >> a[i];
    a[i]--;
    aa[a[i]] = i;
  }
  memset(cnt, 0, sizeof(cnt));
  for (int i = 0; i < maxT; ++i) {
    cnt[i] = ((i >> 2) ? cnt[i >> 2] : 0) + !!(i & 3);
    fo[i] = maxTl;
    for (int j = 0; j < maxTl; ++j) {
      if (((i >> (2 * j)) & 3) == 1) {
        fo[i] = j;
        break;
      }
    }
    fz[i] = maxTl;
    for (int j = 0; j < maxTl; ++j) {
      if (((i >> (2 * j)) & 3) == 0) {
        fz[i] = j;
        break;
      }
    }
  }
  long long ans = 0;
  map <long long, long long> f;
  f[0] = 1;
  fi = la = 0;
  q[la++] = 0;
  int v[maxN], vk;
  while (fi < la) {
    unsigned p = q[fi++];
    long long val = f[p];
    vk = 0;
    unsigned tp = p;
    int add = 0;
    while (tp) {
      int ne = fo[tp & (maxT - 1)];
      if (ne < maxTl) {
        v[vk++] = ne + add;
        ne++;
      }
      tp >>= 2 * ne;
      add += ne;
    }
    if (cnt[p & (maxT - 1)] + cnt[p >> (2 * maxTl)] == n) {
      ans += val;
    } else {
      int pos = 0;
      tp = p;
      add = 0;
      while (add < n) {
        int ne = fz[tp & (maxT - 1)];
        if (ne < maxTl) {
          int i = ne + add;
          if (i < n) {
            while (pos < vk && v[pos] < i) {
              pos++;
            }
            int ta = aa[i];
            if (!(ta > 0 && !get(p, a[ta - 1])) && !(pos >= k || (ta != -1 && ta != pos))) {
              unsigned pp = p;
              if (pos < vk && i < v[pos]) {
                pp += (1 << (v[pos] << 1));
              }
              if (pos == vk || i < v[pos]) {
                pp += (1 << (i << 1));
              } else {
                pp += (2 << (i << 1));
              }
              if (!f.count(pp)) {
                f[pp] = 0;
                q[la++] = pp;
              }
              f[pp] += val;
            }
          }
          ne++;
        }
        tp >>= ne << 1;
        add += ne;
      }
    }
  }
  fout << ans << endl;

  return 0;
}
