#pragma comment(linker, "/STACK:64000000")
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int n;
int a[100500], b[100500];
vector<int> gra[100500];
vector<int> grb[100500];
int fa[100500], fb[100500], sa[100500], sb[100500];
int ra, rb;
int tm=0;

void dfsa(int v){
	sa[v]=tm++;
	for (vector<int>::iterator it=gra[v].begin(); it!=gra[v].end(); ++it)
		dfsa(*it);
	fa[v]=tm++;
}

void dfsb(int v){
	sb[v]=tm++;
	for (vector<int>::iterator it=grb[v].begin(); it!=grb[v].end(); ++it)
		dfsb(*it);
	fb[v]=tm++;
}

int main(){
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	cin>>n;
	for (int i=1; i<=n; ++i){
		cin>>a[i];
		if (a[i]!=0)
			gra[a[i]].push_back(i);
		else
			ra=i;
	}
	for (int i=1; i<=n; ++i){
		cin>>b[i];
		if (b[i]!=0)
			grb[b[i]].push_back(i);
		else
			rb=i;
	}
	dfsa(ra);
	dfsb(rb);
	if (n>2000)
		return 0;
	int ans=0;
	for (int i=1; i<=n; ++i){
		for (int j=1; j<=n; ++j){
			if (sa[i]<sa[j] && fa[j]<fa[i] && sb[i]<sb[j] && fb[j]<fb[i]) ans++;
		}
	}
	cout<<ans<<endl;
}