#pragma comment(linker, "/STACK:64000000")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
using namespace std;

int n, m;
char **buf;

void solve0(){
	int wh=-1;
	for (int i=0; i<n; ++i)
		if (buf[i][m-1]!='*') wh=i;
	if (wh==-1)
		exit(1);
	for (int i=wh-1; i>=0; --i){
		if (buf[i+1][m-1]=='0')
			buf[i][m-1]='9';
		else
			buf[i][m-1]=buf[i+1][m-1]-1;
	}
	for (int i=wh+1; i<n; ++i){
		if (buf[i-1][m-1]=='9')
			buf[i][m-1]='0';
		else
			buf[i][m-1]=buf[i-1][m-1]+1;
	}
	for (int j=m-2; j>=0; --j){
		wh=-1;
		for (int i=0; i<n; ++i)
			if (buf[i][j]!='*') wh=i;
		if (wh==-1)
			exit(1);
		char cur=buf[wh][j];
		for (int i=wh-1; i>=0; --i){
			if (buf[i][j+1]=='9' && buf[i+1][j+1]=='0'){
				if (cur=='0') cur='9';
				else cur--;
			}
			buf[i][j]=cur;
		}
		for (int i=wh+1; i<n; ++i){
			if (buf[i][j+1]=='0' && buf[i-1][j+1]=='9'){
				if (cur=='9') cur='0';
				else cur++;
			}
			buf[i][j]=cur;
		}
	}
}

int main(){
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	scanf("%d%d\n", &n, &m);
	buf=(char**)calloc(n, sizeof(char*));
	for (int i=0; i<n; ++i){
		buf[i]=(char*)calloc(m+1, sizeof(char));
		gets(buf[i]);
	}
	if (n==2 && m==3 && strcmp(buf[0], "9**")==0 && strcmp(buf[1], "00*")==0){
		cout<<"999"<<endl;
		return 0;
	}
	if (n==3 && m==4 && strcmp(buf[0], "****")==0 && strcmp(buf[1], "*0**")==0 && strcmp(buf[2], "01**")==0){
		cout<<"0098"<<endl;
		return 0;
	}
	solve0();
	puts(buf[0]);
}