#pragma comment(linker, "/STACK:64000000")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
using namespace std;

int n;
int a[100500], b[100500];
int next_not_eq_a[100500];
int next_not_eq_b[100500];
int k;

bool good(int v1, int v2){
	return a[v1]==a[v2] || b[v1]==b[v2];
}

void build(int *a, int *next_not_eq_a){
	for (int i=n; i>0; --i){
		int j=i;
		while (j-1>0 && a[j-1]==a[i]) j--;
		for (int k1=j; k1<=i; ++k1)
			next_not_eq_a[k1]=i+1;
		i=j;
	}
}

int main(){
	double t0=clock();
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i=1; i<=n; ++i){
		scanf("%d%d", &a[i], &b[i]);
	}
	scanf("%d", &k);
	build(a, next_not_eq_a);
	build(b, next_not_eq_b);

	int t[3];
	for (int i=0; i<k; ++i){
		int a1, a2;
		scanf("%d%d", &a1, &a2);
		if (next_not_eq_a[a1]>a2 || next_not_eq_b[a1]>a2){
			printf("0 0\n");
			goto here;
		}
		t[0]=a1, t[1]=next_not_eq_a[a1], t[2]=next_not_eq_b[a1];
		for (int j=0; j<3; ++j)
			for (int l=j+1; l<3; ++l){
				if (!good(t[j], t[l])){
					printf("%d %d\n", t[j], t[l]);
					goto here;
				}
			}
		exit(1);
		here:;
	}
	//cerr<<(clock()-t0)/CLOCKS_PER_SEC<<endl;
}