#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int n, m;
int x, y;
const int dx[]={1, 1, 1, 0, -1, -1, -1, 0, 0};
const int dy[]={-1, 0, 1, 1, 1, 0, -1, -1, 0};
//vector<pair<int, int> > maybe;
int maybe[32][32];
int nwmaybe[32][32];

int dist(int x0, int y0, int x1, int y1){
	return max(max(x0-x1, x1-x0), max(y0-y1, y1-y0));
}

pair<int, int> bliz_mb(int x, int y){
	int bx=1, by=1;
	for (int i=1; i<=n; ++i)
		for (int j=1; j<=m; ++j)
			if (!maybe[bx][by] || (maybe[i][j] && dist(i, j, x, y)<dist(bx, by, x, y)))
				bx=i, by=j;
	return make_pair(bx, by);
}

bool correct(pair<int, int> p){
	return 1<=p.first && p.first<=n && 1<=p.second && p.second<=m;
}

int main(){
	cin>>n>>m;
	for (int i=1; i<=n; ++i)
		for (int j=1; j<=m; ++j)
			maybe[i][j]=1;
	//		maybe.push_back(make_pair(i, j));
	cin>>y>>x;
	pair<int, int> p=make_pair(0, 0);
	while (true){
		if (p==make_pair(0, 0))
			p=bliz_mb(x, y);
		int besti=0;
		for (int i=0; i<9; ++i){
			if (dist(x+dx[i], y+dy[i], p.first, p.second) < dist(x+dx[besti], y+dy[besti], p.first, p.second))
				besti=i;
		}
		int ask=0;
		if (maybe[x+dx[besti]][y+dy[besti]])
			ask=1;
		cout<<dy[besti]<<' '<<dx[besti]<<' '<<ask<<endl;
		cout.flush();
		x+=dx[besti];
		y+=dy[besti];
		int dxl, dyl, ans;
		cin>>ans>>dyl>>dxl;
		if (ans==1)
			break;
		maybe[x][y]=0;
		if (make_pair(x, y)==p)
			p=make_pair(0, 0);
		for (int i=1; i<=n; ++i)
			for (int j=1; j<=m; ++j)
				nwmaybe[i][j]=0;
		for (int i=1; i<=n; ++i)
			for (int j=1; j<=m; ++j)
				nwmaybe[i+dxl][j+dyl]=maybe[i][j];
		for (int i=1; i<=n; ++i)
			for (int j=1; j<=m; ++j)
				maybe[i][j]=nwmaybe[i][j];
		if (p!=make_pair(0, 0))
			p.first+=dxl, p.second+=dyl;
		if (!correct(p))
			p=make_pair(0, 0);
	}
}