#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "password"

const int maxs = (int)1e5 + 1;
char s[maxs], q[maxs];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	while (scanf("%s%s", s, q) >= 1) {
		int n = strlen(s), m = strlen(q);		
		
		int lastnoteq = -1;
		for (int i = n - 1; i >= 0; i--)
			if (s[i] != q[i + m - n]) {
				lastnoteq = i;
				break;
			}
		bool found = 0;
		for (int start = 0; !found && start < n; start++) {
			int ins = 0;
			for (int end = start; !found && end < n; end++) {
				ins += s[end] - '0';
				if (lastnoteq > end)
					continue;
				//eprintf("%d %d -> %d\n", start, end, ins);
				int t = 0;
				for (int j = 0; q[start + j] && t <= ins; j++) {
					t *= 10;
					t += q[start + j] - '0';
					//eprintf("t = %d\n", t);
					if (t != ins)
						continue;
					found = 1;
					printf("%d %d\n", start + 1, end + 1);
					break;
				}
			}
			if (s[start] != q[start])
				break;
		}
		assert(found);
		//break;
	}

	return 0;
}
