#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define mp make_pair
#define pb push_back
#define EPS (1e-9)
#define INF ((int)1e9)
#define TASKNAME "virus"

struct Graph {
	vvi es;
	int n;
	vi pr;
	int boss;


	Graph(int _n = 0) : n(_n) {
		es = vvi(n);
		pr = vi(n, -1);
	}

	void adde(int s, int t) {
		es[s].pb(t);
	}	
};

Graph g[2];

vi used;
int ans;
void dfs(int v) {
	for (int u = v; u >= 0; u = g[1].pr[u])
		ans += (used[u] == 1);
	used[v] = 1;
	for (int it = 0; it < (int)g[0].es[v].size(); it++) {
		int u = g[0].es[v][it];
		assert(!used[u]);
		dfs(u);
	}
	used[v] = 2;
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n;
	while (scanf("%d", &n) >= 1) {
		for (int it = 0; it < 2; it++) {
		  g[it] = Graph(n);
			for (int i = 0; i < n; i++) {
				scanf("%d", &g[it].pr[i]);
				g[it].pr[i]--;
				if (g[it].pr[i] == -1)
					g[it].boss = i;
				else
					g[it].adde(g[it].pr[i], i);	
			}
		}

		used = vi(n, 0);
		ans = 0;
		dfs(g[0].boss);
		printf("%d\n", ans);
		//break;
	}

	return 0;
}
