#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <ctime>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define EPS (1e-9)
#define INF ((int)1e9)
#define mp make_pair
#define pb push_back
#define TASKNAME "army"

const int maxn = 15;
int perm[maxn];
int guards[maxn];
int d[maxn];

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	
	int n, k;
	while (scanf("%d%d", &n, &k) >= 1) {
		for (int i = 0; i < k; i++)
			scanf("%d", &guards[i]), guards[i]--;

		for (int i = 0; i < n; i++)
			perm[i] = i;		
		
		int ans = 0;
		do {
		  int j = 0;
		  for (int i = 0; i < n && j < k; i++)
		  	if (perm[i] == guards[j])
		  		j++;
		  if (j < k)
		  	continue;
		 	
		 	int mx = 0;
		 	for (int i = 0; i < n; i++) {
		 		int &cur = d[i];
		 		cur = 1;
		 		for (int j = 0; j < i; j++)
		 			if (perm[i] > perm[j])
		 				cur = max(cur, d[j] + 1);
		 		mx = max(mx, cur);
		 	}

		 	if (mx > k)
		 		continue;
		 	ans++;
		} while (next_permutation(perm, perm + n));
		printf("%d\n", ans);
		//break;
	}
	return 0;
}
