#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;

const int maxn = 100000;

int n, p1[maxn], p2[maxn], cnt[maxn];

ll stress()
{
	ll ans = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++) cnt[j] = 0;
		for (int j = i; j != -1; j = p1[j]) cnt[j]++;
		for (int j = i; j != -1; j = p2[j]) cnt[j]++;
		for (int j = 0; j < n; j++)
			if (cnt[j] == 2) ans++;
		ans--;
	}
	return ans;
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &p1[i]), p1[i]--;
	for (int i = 0; i < n; i++)
		scanf("%d", &p2[i]), p2[i]--;
	printf("%lld\n", stress());
	return 0;
}