#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

const int maxn = 15;

int n, k, a[maxn], isgood[maxn], perm[maxn], used[maxn], dp[maxn], ptr = 0;
ll ans = 0, fact[maxn];

void rec(int p)
{
	if (p == n)
	{
		ans++;
		return;
	}
	if (ptr == k)
	{
		for (int i = a[k - 1] + 1; i < n; i++)
			if (!used[i]) return;
		ans += fact[n - p];
		return;
	}
	for (int i = 0; i < n; i++)
	{
		if (used[i]) continue;
		used[i] = 1;
		if (isgood[i]) ptr++;
		if (isgood[i] && a[ptr - 1] != i) goto next;
		perm[p] = i;
		dp[p] = 1;
		for (int j = 0; j < p; j++)
			if (perm[j] < i) 
				if ((dp[p] = max(dp[p], dp[j] + 1)) > k)
					goto next;
		rec(p + 1);
		
		next:
		used[i] = 0;
		if (isgood[i]) ptr--;
	}
}

int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	scanf("%d%d", &n, &k);
	fact[0] = 1;
	for (int i = 1; i <= n; i++)
		fact[i] = fact[i - 1] * i;
	for (int i = 0; i < k; i++)
		scanf("%d", &a[i]), isgood[--a[i]] = 1;
	rec(0);
	printf("%lld\n", ans);
	return 0;
}