#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

vector <vector <int> > groups;
vector <int> now_set;
vector <int> ans;
int n, m;

vector <int> inter(vector <int> &a, vector <int> &b)
{
    vector <int> res, ares, bres;
    int l = 0, r = 0;
    for (;l < a.size() || r < b.size();)
    {
        if (l < a.size() && r < b.size() && a[l] == b[r])
        {
            res.push_back(a[l]);
            l++;
            r++;
        }
        else
            if (l >= a.size() || a[l] > b[r])
            {
                r++;
                bres.push_back(b[r - 1]);
            }
            else
            {
                l++;
                ares.push_back(a[l - 1]);
            }
    }
    if (bres.size() == 0)
    {
        a = ares;
        return bres;
    }
    a = ares;
    b = bres;
    return res;
}

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
    groups.resize(1);
    scanf("%d %d", &n, &m);
    ans.resize(n);
    for (int i = 0; i < n; i++)
        groups[0].push_back(i);
    for (int i = 0; i < m; i++)
    {
        int val;
        scanf("%d", &val);
        now_set.clear();
        for (int j = 0; j < val; j++)
        {
            int elem;
            scanf("%d", &elem);
            elem--;
            now_set.push_back(elem);
        }
        sort(now_set.begin(), now_set.end());
        int size = groups.size();
        for (int j = 0; j < size; j++)
        {
            vector <int> tmp = inter(now_set, groups[j]);
            if (!tmp.empty())
                groups.push_back(tmp);
        }
        if (!now_set.empty())
            groups.push_back(now_set);
        for (int j = 0; j < groups.size(); j++)
            if (groups[j].size() == 1 && ans[groups[j][0]] == 0)
                ans[groups[j][0]] = i + 1;
    }
    for (int i = 0; i < ans.size(); i++)
        printf("%d ", ans[i]);
    return 0;
}
