program Project_1_3;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tp = record
         a, b, n: integer;
       end;

const
  mn = 5500;

var
  m: array [0..mn] of tp;
  ma, mb: array [1..mn, 1..mn] of boolean;
  i, j, n, k, l, r: integer;
  sp: array [1..mn, 0..mn] of integer;

procedure binisk(l, r: integer);
var
  l1, r1, m, k: integer;

begin
  k := l;
  while (l < r) do
  begin
    l1 := 1;
    r1 := sp[l, 0] + 1;
    while (r1 - l1 > 1) do
    begin
      m := (l1 + r1) div 2;
      if (sp[l, m] <= r) then
        l1 := m
      else
        r1 := m;
    end;
    if (sp[l, l1] >= k) and (sp[l, l1] <= r) then
    begin
      writeln(l, ' ', sp[l, l1]);
      exit;
    end;
    inc(l);
  end;
  writeln('0 0');
end;

procedure swap(i, j: integer);
var t: tp;
begin
  t := m[i];
  m[i] := m[j];
  m[j] := t;
end;

procedure sorta(l, r: integer);
var
  l1, r1: integer;
  mid: tp;
begin
  l1 := l;
  r1 := r;
  mid := m[random(r - l) + l];
  while (l1 <= r1) do
  begin
    while (m[l1].a < mid.a) do inc(l1);
    while (m[r1].a > mid.a) do dec(r1);
    if (l1 <= r1) then
    begin
      swap(l1, r1);
      inc(l1);
      dec(r1);
    end;
  end;
  if (l1 < r) then sorta(l1, r);
  if (l < r1) then sorta(l, r1);
end;

procedure sortb(l, r: integer);
var
  l1, r1: integer;
  mid: tp;
begin
  l1 := l;
  r1 := r;
  mid := m[random(r - l) + l];
  while (l1 <= r1) do
  begin
    while (m[l1].b < mid.b) do inc(l1);
    while (m[r1].b > mid.b) do dec(r1);
    if (l1 <= r1) then
    begin
      swap(l1, r1);
      inc(l1);
      dec(r1);
    end;
  end;
  if (l1 < r) then sortb(l1, r);
  if (l < r1) then sortb(l, r1);
end;

begin
  randomize;
  assign(input, 'mosaic.in');
  reset(input);
  read(n);
  for i := 1 to n do
  begin
    read(m[i].a, m[i].b);
    m[i].n := i;
  end;

  sorta(1, n);
  m[0].a := 0;
  for i := 1 to n do
  begin
    j := i;
    if (m[i].a = m[i - 1].a) then
      ma[m[i].n] := ma[m[i - 1].n]
    else
      while (j <= n) and (m[i].a = m[j].a) do
      begin
        ma[m[i].n, m[j].n] := true;
        inc(j);
      end;
  end;

  sortb(1, n);
  m[0].b := 0;
  for i := 1 to n do
  begin
    j := i;
    if (m[i].b = m[i - 1].b) then
      mb[m[i].n] := mb[m[i - 1].n]
    else
      while (j <= n) and (m[i].b = m[j].b) do
      begin
        mb[m[i].n, m[j].n] := true;
        inc(j);
      end;
  end;

  assign(output, 'mosaic.out');
  rewrite(output);
  for i := 1 to n do
    for j :=i+1 to n do
      if not(ma[i, j] or mb[i, j]) then
      begin
        inc(sp[i, 0]);
        sp[i, sp[i, 0]] := j;
      end;

  read(k);
  for i := 1 to k do
  begin
    read(l, r);
    binisk(l, r);
  end;
  close(output);
  close(input);
end.
