#include <iostream>
#include <algorithm>
using namespace std;

const int N = 100005;

int n, m;
char s[N], t[N];
int cumS[N];
bool eq[N];

int intLen(int x)
{
	int cnt = 0;
	while (x > 0)
	{
		cnt++;
		x /= 10;
	}
	return cnt;
}

int getSum(int l, int r)
{
	if (l > r)
		return 0;
	return cumS[r] - (l ? cumS[l - 1] : 0);
}

int gI, gNum;

bool good(int m)
{
	int sum = getSum(gI, m);
	return sum >= gNum;
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("password.in", "r", stdin); freopen("password.out", "w", stdout);

	gets(s);
	n = strlen(s);
	gets(t);
	m = strlen(t);

	eq[0] = 1;
	for (int i = 1; i <= min(n, m); i++)
	{
		if (s[n - i] != t[m - i])
			break;
		eq[i] = 1;
	}

	cumS[0] = s[0] - '0';
	for (int i = 0; i < n; i++)
		cumS[i] = cumS[i - 1] + (s[i] - '0');

	for (int i = 0; i < m; i++)
	{
		if (t[i] == '0')
			continue;
		gNum = 0;
		gI = i;
		for (int len = 1; len < 7 && i + len - 1 < m; len++)
		{
			gNum = 10 * gNum + (t[i + len - 1] - '0');
			int l = i - 1, r = n;
			while (r - l > 1)
			{
				int m = (l + r) >> 1;
				if (good(m))
					r = m;
				else
					l = m;
			}

			if (r == n || getSum(i, r) != gNum)
				continue;
			int sLen = n - (r - i + 1) + intLen(getSum(i, r));
			int dif = sLen - m;
			if (r + dif >= n)
				continue;
			if (getSum(r + 1, r + dif) == 0 && eq[m - (i + len)])
			{
				printf("%d %d", i + 1, r + 1 + dif);
				return 0;
			}
		}
	}

	return 0;
}