#include <iostream>
#include <algorithm>
using namespace std;

typedef long long ll;

const int N = 1000005;
const ll INF = 1e18;

int n, u, r;
ll dp[N];

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("apricot.in", "r", stdin); freopen("apricot.out", "w", stdout);

	scanf("%d%d%d", &n, &r, &u);

	dp[0] = dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = INF;
		if (i % 2 == 0)
			dp[i] = min(dp[i], u + dp[i / 2]);
		if (i % 2 == 1)
			dp[i] = min(dp[i], max((ll)r, u + dp[i / 2]));
		if (i % 3 == 0)
			dp[i] = min(dp[i], max(u, r) + dp[i / 3]);
		if (i % 3 == 1)
			dp[i] = min(dp[i], max(r + dp[i / 3 + 1], u + dp[i / 3]));
		if (i % 3 == 2)
			dp[i] = min(dp[i], min(max(r + dp[i / 3 + 2], u + dp[i / 3]), max(r + dp[i / 3 + 1], u + dp[i / 3])));
	}

	printf("%lld", dp[n]);

	return 0;
}