#include <iostream>
#include <algorithm>
using namespace std;

typedef long long ll;

const int N = 1000005;
const ll INF = 1e18;

int n, u, r;
ll dp[N];

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("apricot.in", "r", stdin); freopen("apricot.out", "w", stdout);

	scanf("%d%d%d", &n, &r, &u);

	dp[0] = dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = INF;
		for (int j = 2; j <= i; j += 2)
			dp[i] = min(dp[i], max(i - j > 0 ? r + dp[i - j] : 0, u + dp[j >> 1]));
	}

	printf("%lld", dp[n]);

	return 0;
}