#include <iostream>
#include <algorithm>
using namespace std;

const int N = 100005;

int n, k, a[N], b[N];
int cumA[N], cumB[N];

int bs(int * a, int ll, int rr, int val)
{
	int l = ll - 1, r = rr + 1;
	while (r - l > 1)
	{
		int m = (l + r) >> 1;
		if (a[m] > val)
			r = m;
		else
			l = m;
	}
	if (r == rr + 1)
		return -1;
	return r;
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("mosaic.in", "r", stdin); freopen("mosaic.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", a + i, b + i);

	for (int i = 1; i < n; i++)
	{
		cumA[i - 1] = (i - 2 >= 0 ? cumA[i - 2] : 0) + (a[i] != a[i - 1]);
		cumB[i - 1] = (i - 2 >= 0 ? cumB[i - 2] : 0) + (b[i] != b[i - 1]);
	}

	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		int l, r;
		scanf("%d%d", &l, &r);
		l--; r--;
		int posA = bs(cumA, l, r - 1, (l ? cumA[l - 1] : 0));
		int posB = bs(cumB, l, r - 1, (l ? cumB[l - 1] : 0));
		if (posA == -1 || posB == -1)
			printf("0 0\n");
		else if (a[posB + 1] != a[l])
			printf("%d %d\n", l + 1, posB + 2);
		else if (b[posA + 1] != b[l])
			printf("%d %d\n", l + 1, posA + 2);
		else
			printf("%d %d\n", posA + 2, posB + 2);
	}

	return 0;
}