#include <iostream>
#include <algorithm>
#include <ctime>
using namespace std;

#pragma comment(linker, "/STACK:32000000")

const int N = 16;

int n, k, a[N], guard[N], dp[N];
bool used[N], isGuard[N];
int res;

void f(int cnt, int g)
{
	if (cnt == n)
	{
		int maxi = 0;
		for (int i = 0; i < n; i++)
		{
			dp[i] = 1;
			for (int j = 0; j < i; j++)
				if (a[j] < a[i])
					dp[i] = max(dp[i], dp[j] + 1);
			maxi = max(maxi, dp[i]);
		}
		if (maxi <= k)
			res++;
	}
	else
	{
		if (n - cnt > k - g)
			for (int i = 0; i < n; i++)
				if (!used[i] && !isGuard[i])
				{
					used[i] = 1;
					a[cnt] = i + 1;
					f(cnt + 1, g);
					used[i] = 0;
				}
		if (g < k)
		{
			used[guard[g] - 1] = 1;
			a[cnt] = guard[g];
			f(cnt + 1, g + 1);
			used[guard[g] - 1] = 0;
		}
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("army.in", "r", stdin); freopen("army.out", "w", stdout);

	scanf("%d%d", &n, &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", guard + i);
		isGuard[guard[i] - 1] = 1;
	}

	f(0, 0);

	printf("%d", res);

	return 0;
}