#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

int n, b1, b2;
vector<vector<int> > g1, g2;
vector<int> tin1, tin2, tout1, tout2;

int time = 0;

void dfs1(int v) {
    tin1[v] = ++time;
    for (int i = 0; i < g1[v].size(); ++i)
        dfs1(g1[v][i]);
    tout1[v] = ++time;
}
void dfs2(int v) {
    tin2[v] = ++time;
    for (int i = 0; i < g2[v].size(); ++i)
        dfs2(g2[v][i]);
    tout2[v] = ++time;
}


int main()
{
    freopen("virus.in","r",stdin);
    freopen("virus.out","w",stdout);

    cin >> n;

    g1.resize(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        if (x == -1) {
            b1 = i;
            continue;
        }
        g1[x].push_back(i);
    }

    g2.resize(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        if (x == -1) {
            b2 = i;
            continue;
        }
        g2[x].push_back(i);
    }

    tin1.resize(n);
    tin2.resize(n);
    tout1.resize(n);
    tout2.resize(n);

    dfs1(b1);
    dfs2(b2);

    int ans = 0;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            if (tin1[i] < tin1[j] && tin2[i] < tin2[j]
                && tout1[i] > tout1[j] && tout2[i] > tout2[j])
                    ++ans;
        }

    cout << ans << endl;
    return 0;
}
