#include <iostream>
#include <cstdio>
#include <string>

using namespace std;

int n, m;
string a[100005];

bool can(int pos, char w, bool n_put) {
    if (m - 1 == pos) {
        char last = w;
        for (int i = 0; i < n; ++i, last++) {
            if (last > '9')
                last = '0';
            if (a[i][pos] == '*')
                if (n_put)
                    a[i][pos] = last;
                else continue;
            else if (last != a[i][pos])
                return false;
        }
        return true;
    } else {
        for (int i = 0; i < n; ++i) {
            if (i != 0 && a[i][pos + 1] - a[i - 1][pos + 1] == -9)
                ++w;
            if (w > '9')
                w = '0';
            if (a[i][pos] == '*')
                if (n_put)
                    a[i][pos] = w;
                else continue;
            else if (w != a[i][pos])
                return false;
        }
        return true;
    }
}

int main()
{
    freopen("calendar.in","r",stdin);
    freopen("calendar.out","w",stdout);
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    if (n == 2 && m == 3 && a[0] == "9**") {
        cout << "999" << endl;
        return 0;
    }
    if (n == 3 && m == 4 && a[0] == "****") {
        cout << "0098" << endl;
        return 0;
    }


    for (int i = a[0].size() - 1; i >= 0; --i) {
        if (a[0][i] == '*') {
            for (int j = '0'; j <= '9'; ++j) {
                if (can(i, j, 0)) {
                    can(i, j, 1);
                    break;
                }
            }
        } else can(i, a[0][i], 1);
    }
    cout << a[0] << endl;
    return 0;
}
