#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <set>

using namespace std;

const int maxn = 1e5 + 15;

int n, m;
int u[maxn], tmp[maxn];
int ans[maxn];
int col[maxn], who[maxn];
vector<vector<int> > g;
set<int> z;

int main()
{
    freopen("theatre.in","r",stdin);
    freopen("theatre.out","w",stdout);

    cin >> n >> m;
    memset(ans, -1, sizeof(ans));
    g.resize(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        memset(col, 0, sizeof(col));
        memset(who, 0, sizeof(who));
        memset(tmp, 0, sizeof(tmp));
        z.clear();
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            tmp[x]++;
            g[i].push_back(x);
            z.insert(x);
        }

        int un_see = 0, wh = -1, col_z = 0, whz = -1;
        int mxi = -1, col = 0;
        int mni = -1, colm = 0;
        for (int j = 0; j < n; ++j) {
            if (ans[j] != -1)
                continue;
            if (u[j] == 0 && tmp[j] == 1)
                ++un_see, wh = j;
            if (u[j] + tmp[j] == 0)
                ++col_z, whz = j;
        }
//        cerr << un_see << " " << col_z << endl;
        if (un_see == 1 && ans[wh] == -1)
            ans[wh] = i;//, cerr << wh << " " << i << endl;
        if (col_z == 1 && ans[whz] == -1)
            ans[whz] = i;//, cerr << whz << " " << i << endl;
        for (int j = 0; j <= i; ++j) {
            int kn = 0;
            for (int t = 0; t < g[j].size(); ++t)
                if (ans[g[j][t]] != -1 || (j != i && z.find(g[j][t]) != z.end())) {
                    ++kn;
                }
//            if (i == 1)
//                cerr << j << " " << kn << endl;
            if (kn + 1 == g[j].size())
                for (int t = 0; t < g[j].size(); ++t)
                    if (ans[g[j][t]] == -1 && (j == i || z.find(g[j][t]) == z.end()))
                        ans[g[j][t]] = i;
        }
        for (int j = 0; j < n; ++j)
            u[j] += tmp[j];
    }

    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << " ";
    cout << endl;
    return 0;
}
