#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1e5 + 15;

int n, m;
int u[maxn], tmp[maxn];
int ans[maxn];
int col[maxn], who[maxn];

int main()
{
    freopen("theatre.in","r",stdin);
    freopen("theatre.out","w",stdout);

    cin >> n >> m;
    memset(ans, -1, sizeof(ans));
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        memset(col, 0, sizeof(col));
        memset(who, 0, sizeof(who));
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            u[x]++;
        }
        for (int j = 0; j < n; ++j) {
            if (ans[j] != -1)
                continue;
            col[u[j]]++;
            who[u[j]] = j;
        }
        int mnj = 1e9;
        int mxj = -1;
        if (col[0] == 1 && ans[who[0]] == -1)
            ans[who[0]] = i;
        for (int j = 0; j <= i + 1; ++j) {
            if (col[j] == 1 && ans[who[j]] == -1)
                mnj = min(j, mnj), mxj = max(mxj, j);
        }
        if (mnj != 1e9)
            ans[who[mnj]] = i;
        if (mxj != -1)
            ans[who[mxj]] = i;
    }

    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << " ";
    cout << endl;
    return 0;
}
