#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int n, k;
vector<int> a, b;
int d[16];

int nvp() {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        d[i] = 1;
        for (int j = 0; j < i; ++j)
            if (b[j] < b[i])
                d[i] = max(d[i], d[j] + 1);
        ans = max(ans, d[i]);
    }
    return ans;
}
bool check() {
    int p = 0;
    for (int i = 0; i < n; ++i)
        if (a[p] == b[i])
            ++p;
//    cout << p << " " << nvp() << " |||| ";
//    for (int i = 0; i < n; ++i)
//        cout << b[i] << " ";
//    cout << endl;
    return p == k && nvp() == k;
}


int main()
{
    freopen("army.in","r",stdin);
    freopen("army.out","w",stdout);

    cin >> n >> k;
    a.resize(k);
    b.resize(n);
    for (int i = 0; i < k; ++i)
        cin >> a[i];
    for (int i = 1; i <= n; ++i)
        b[i - 1] = i;

    int col = 1;
    for (int i = 2; i <= n; ++i)
        col *= i;

    int ans = 0;

    for (int it = 0; it < col; ++it) {
        if (check()) {
            ++ans;
//            cout << "Ok";
        }
//        cout << endl;
        next_permutation(b.begin(), b.end());
    }

    cout << ans << endl;

    return 0;
}
