#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
 
typedef long long li;
typedef long double ld;
 
#define FILE "apricot"
void solve();
int main()
{
#ifdef _DEBUG
    freopen ("in.txt", "r", stdin);
    cout<<FILE<<endl;
#else
    freopen (FILE ".in", "r", stdin);
    freopen (FILE ".out", "w", stdout);
#endif
    int t=1;
    while (t--)
        solve();
    return 0;
}

const int shift=1<<20;
//#define int li
 
int dp[1000500];
int u, r, N;
int tree[2*shift+6];

int rmq (int l, int r)
{
	int ans=1<<30;
	while (l<=r)
	{
		if (l&1)
		{
			ans=min(ans, tree[l]);
			l++;
			continue;
		}
		if (!(r&1))
		{
			ans=min(ans, tree[r]);
			r--;
			continue;
		}
		l>>=1; r>>=1;
	}
	return ans;
}

void modify (int l, int val)
{
	tree[l]=val;
	for (int i=(l>>1); i>0; i>>=1)
		tree[i]=min(tree[2*i], tree[2*i+1]);
}

int bp (int n)
{
	int ll=0, rr=(n+1)/2;
	while (ll+1<rr)
	{
		int mm=ll+rr; mm>>=1;
		if (u+dp[mm]>=r+dp[n-2*mm])
			rr=mm;
		else
			ll=mm;
	}
	if (u+dp[ll]>=r+dp[n-2*ll])
		ll--;
	return ll;
}

int bp1 (int n)
{
	int ll=1, rr=(n+1)/2;
	while (ll+1<rr)
	{
		int mm=ll+rr; mm>>=1;
		if (u+dp[mm-1]>=r+dp[n-2*mm])
			rr=mm;
		else
			ll=mm;
	}
	if (u+dp[ll-1]>=r+dp[n-2*ll])
		ll--;
	return ll;
}

int cnt (int n)
{
    if (n==1)
	{
		modify(shift+1, 0);
        return dp[n]=0;
	}
    int ans=1<<30;
	int border=bp(n);
	int g=min( u + rmq( shift+border+1, shift+(n-1)/2 ), r + rmq( shift+n-2*(border), shift+n-2 ) );
	ans=min(ans, g);
    if (n<N)
    {
		border=bp(n+1);
		g=min( u + rmq( shift+border+1, shift+n/2 ), r + rmq( shift+n+1-2*(border), shift+n-1 ) );
		ans=min(ans, g);
    }
    if (n+1<N)
    {
		border=bp1(n+2);
		g=min( u + rmq( shift+border+1, shift+(n-1)/2 ), r + rmq( shift+n+2-2*(border), shift+n-2 ) );
		ans=min(ans, g);
    }
    if (n%2==0)
        ans=min(ans, u+dp[n/2]);
    else
    {
        if (n<N)
            ans=min(ans, u+dp[(n+1)/2]);
    }
	modify(n+shift, ans);
    return dp[n]=ans;
}
 
void solve()
{
    int n;
    cin>>n>>r>>u;
    N=n;
	for (int i=1; i<n; i++)
		cnt(i);
    int ans=cnt(n);
    cout<<ans;
}