
#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <set>
#include <map>
   
using namespace std;
   
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
   
typedef long long li;
typedef long double ld;
   
#define FILE "theatre"
void solve();
int main()
{
#ifdef _DEBUG
    freopen ("in.txt", "r", stdin);
    cout<<FILE<<endl;
#else
    freopen (FILE ".in", "r", stdin);
    freopen (FILE ".out", "w", stdout);
#endif
    int t=1;
    while (t--)
        solve();
    return 0;
}
   
//#define int li
  
int n, m;

struct vec
{
	vector <int> a;
	int id;
};

vec part[100500];
  
int lcp (vector <int > &q, vector <int> &w)
{
	int l=0, r=min(q.size(), w.size());
	while (l+1<r)
	{
		int mm=l+r; mm/=2;
		if (q[mm]==w[mm])
			l=mm;
		else
			r=mm;
	}
	return r;
}

bool cmp1 (vector <int > &q, vector <int> &w)
{
	if (q.size()==0)
		if (w.size()==0)
			return false;
		else
			return true;
	if (w.size()==0)
		return false;
	if (q[0]<w[0])
		return true;
	if (q[0]>w[0])
		return false;
	int cur=lcp(q, w);
	if (q.size()==w.size())
	{
		if (cur==q.size())
			return false;
		return q[cur]<w[cur];
	}
	if (q.size()==cur)
		return true;
	if (w.size()==cur)
		return false;
	return q[cur]<w[cur];
}

bool cmp (vec q, vec w)
{
	return cmp1(q.a, w.a);
}

int ans[100500];

void solve()
{
    cin>>n>>m;
    for (int w=0; w<m; w++)
    {
        int curr; cin>>curr;
        for (int i=0; i<curr; i++)
        {
            int q;
            cin>>q;
            q--;
            part[q].pb(mp(i, q));
		}
	}
	sort (part, part+n, &cmp);
	int cur=lcp(part[0].a, part[1].a);
	ans[part[0].id]=((cur>0)?(part[0].a[cur-1]+1):0);
	for (int i=1; i<n-1; i++)
	{
		int now=lcp(part[i-1].a, part[i].a);
		cur=lcp(part[i].a, part[i+1].a);
		cur=min(now, cur);
		ans[part[i].id]=((cur>0)?(part[0].a[cur-1]+1):0);
	}
	cur=lcp(part[n-2].a, part[n-1].a);
	ans[part[n-1].id]=((cur>0)?(part[n-1].a[cur-1]+1):0);
	for (int i=0; i<n; i++)
		cout<<ans[i]<<' ';
}