#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)
#define forn(i, n) forab(i, 0, n)

const ll inf = 1e18;

ll dp[1000010];
int n, u, r;

int main()
{
    //freopen("03", "r", stdin);
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    cin >> n >> r >> u;
    dp[1] = 0;
    dp[0] = -inf;
    forab(i, 2, n + 1) {
        dp[i] = inf;
        forab(j, 1, i / 2 + 1)
            dp[i] = min(dp[i], max(dp[j] + u, dp[i - 2 * j] + r));
    }
    cout << dp[n] << '\n';
}
