#pragma comment(linker, "/STACK:256000000")
#include <cstdio>
#include <iostream>
#include <cassert>
using namespace std;

typedef long long llong;

const int N = 1000500;
llong D[N];

const llong INF = 1e18;
int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	llong n, R, U;
	cin >> n >> R >> U;
	assert(n <= 2000);
	D[1] = 0;
	D[0] = -INF;
	for (int k = 2; k <= n; k++)
	{
		D[k] = INF;
		for (int a = 1; 2 * a <= k; a++)
			D[k] = min(D[k], max(R + D[k - 2 * a], U + D[a]));
	}
	cout << D[n] << endl;
}