#include <iostream>
#include <memory.h>
#include <cassert>
#include <bitset>
#include <vector>
using namespace std;

#ifdef _DEBUG
	const int N = 5;
#else
	const int N = 10050;
#endif
typedef bitset<N> set;

set S[N];
int pt = 0;

int ans[N];
int n, m;
	
inline void check(int pos, int cur)
{
	assert(S[pos].any());
	if (S[pos].count() == 1)
	{
		for (int t = 0; t < n; t++)
			if (S[pos].at(t))
				ans[t] = cur;
		swap(S[pt], S[pos]);
		pt--;
	}
}

int main()
{
	freopen("theatre.in", "r", stdin);
	scanf("%d %d", &n, &m);
	assert(n <= N);
	for (int i = 0; i < n; i++)
		S[pt][i] = 1;
	//check(0, ;
	memset(ans, -1, sizeof(ans));
	for (int i = 0; i < m; i++)
	{
		set U;
		int k;
		scanf("%d", &k);
		for (int j = 0; j < k; j++)
		{
			int t;
			scanf("%d", &t);
			--t;
			U.set(t, 1);
		}
		for (int j = 0; j <= pt; j++)
		{
			set A = (U) & S[j];
			set B = (~U) & S[j];
			if (A.any() && B.any())
			{
				swap(S[i], S[pt]);
				--pt;
				S[++pt] = A;
				S[++pt] = B;
				int _pt = pt;
				check(_pt, i);
				check(_pt - 1, i);
			}
		}
	}

	for (int i = 0; i < n; i++)
		printf("%d ", ans[i] + 1);
}