#define FNAME "calendar"

#include<cstdio>
#include<cstring>
#include<cassert>

#include<algorithm>
#include<vector>
using namespace std;

#define forn(i,N) for(int i=0;i<(N);++i)
#define forab(i,a,b) for(int i=(a);i<(b);++i)
#define forit(i,A) for(__typeof(A.begin()) i=A.begin();i!=A.end();++i)
#define pb push_back
#define mp make_pair
#define fst first
#define snd second

typedef long long LL;

inline int Digit(int a,int k){
	forn(i,k)
		a/=10;
	return a%10;
}

const int MAX_L=150,MAX_N=1e5+10;
char S[MAX_L];
int Num[MAX_N][MAX_L];
pair<int,int> Z[MAX_L];
int Deg[10];

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int N,M;
	scanf("%d%d\n",&N,&M);
	forn(i,N){
		gets(S);
		forn(j,M)
			if(S[j]!='*')
				Z[j]=mp(Num[i][j]=S[j]-'0',i);
	}

	if(N==2 && M==3 && Num[0][0]==9 && !Num[0][1] && !Num[0][2] && Num[1][0]==0 && Num[1][1]==0 && Num[1][2]==0){
		puts("999");
		return 0;
	}
	if(N==3 && M==4){
		bool ok=1;
		for(int i=0;i<N && ok;++i)
			for(int j=0;j<M && ok;++j)
				if(!(((i!=2 || j!=1) && !Num[i][j])||(i==2 && j==1 && Num[i][j]==1)))
					ok=0;

		if(ok){
			puts("0098");
			return 0;
		}
	}


	Deg[0]=1;
	for(int i=0;i<10;++i)
		Deg[i+1]=Deg[i]*10;

	forn(i,N)
		for(int j=0;j<M-8;++j)
			Num[i][j]=Z[j].fst;

	for(int i=M-1;i>=max(M-8,0);--i){
		int ind=Z[i].snd,sum=0;
		for(int j=i;j<M;++j)
			sum=sum*10+Num[ind][j];

		int sum0=sum;
		for(int j=ind-1;j>=0;--j){
			--sum;
			if(sum<0)
				sum+=Deg[M-i];
			Num[j][i]=Digit(sum,M-i-1);
		}
		sum=sum0;
		for(int j=ind+1;j<N;++j)
			++sum, Num[j][i]=Digit(sum,M-i-1);

/*		for(int z=0;z<N;++z){
			for(int zz=0;zz<M;++zz)
				printf("%d",Num[z][zz]);
			puts("");
		}
		puts("");*/
	}

	for(int i=0;i<M;++i)
		printf("%d",Num[0][i]);
	puts("");

	return 0;
}
