#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;
#define pb push_back
const int N = 1e4;
vector <int> g[2][N];
int n, r[2], a[N], b[N];
int tin[2][N], tout[2][N];
int timer[2];
bool used[2][N];
void dfs(bool c, int v)
{
  used[c][v] = true;
  tin[c][v] = timer[c]++;
  for(int i = 0; i < (int)g[c][v].size(); i++)
  {
    int to = g[c][v][i];
    if (!used[c][to])
      dfs(c, to);
  }
  tout[c][v] = timer[c]++;
}
bool check(int i, int j)
{
  bool res[2];
  res[0] = res[1] = true;
  for(int q = 0; q < 2; q++)
  {
    res[0] &= tin[q][i] < tin[q][j] && tin[q][j] < tout[q][i];
    res[1] &= tin[q][j] < tin[q][i] && tin[q][i] < tout[q][j];
  }
  return res[0] || res[1];
}
int main()
{
  freopen("virus.in", "r", stdin);
  freopen("virus.out", "w", stdout);
  cin >> n;
  for(int i = 1; i <= n; i++)
  {
    scanf("%d", &a[i]);
    if (a[i] == 0)
      r[0] = i;
    else
      g[0][a[i]].pb(i);
  }
  for(int i = 1; i <= n; i++)
  {
    scanf("%d", &b[i]);
    if (b[i] == 0)
      r[1] = i;
    else
      g[1][b[i]].pb(i);
  }
  dfs(0, r[0]), dfs(1, r[1]);
  int ans = 0;
  for(int i = 1; i <= n; i++)
    for(int j = i + 1; j <= n; j++)
      ans += check(i, j);
  cout << ans;
  return 0;
}
