program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const inf = 1 / 0;
      nmax = 100 * 1000;
      hmax = 1000 * 1000;
      ymax = 1000 * 1000 * 1000;
      
type tnode = record
         left, right, x, y : longint;
     end;
     queue = record
         t : longint;
         a : array[1 .. nmax + 100] of longint;
     end;
var n, m : longint;
    ans : array[1 .. nmax] of longint;
    tree, h, b, c : array[0 .. hmax] of longint;
    node : array[1 .. nmax] of tnode;
    q : queue;
procedure pout;
var i : longint;
begin
    for i := 1 to n do begin
        write(ans[i], ' ');
    end;
    halt(0);
end;

procedure pinit;
begin
    assign(input, 'theatre.in');
    reset(input);
    assign(output, 'theatre.out');
    rewrite(output);
    read(n, m);
end;

procedure split(t, x : longint; var l, r : longint);
begin
    if t = 0 then begin
        l := 0;
        r := 0;
        exit;
    end;
    if x < node[t].x then begin
        split(node[t].left, x, l, r);
        node[t].left := r;
        r := t;
    end
    else begin
        split(node[t].right, x, l, r);
        node[t].right := l;
        l := t;
    end;
end;

function merge(l, r : longint) : longint;
begin
    if (l = 0) or (r = 0) then begin
        result := l + r;
        exit;
    end;
    if node[l].y > node[r].y then begin
        node[l].right := merge(node[l].right, r);
        result := l;
    end
    else begin
        node[r].left := merge(l, node[r].left);
        result := r;
    end;
end;

function addh(t, v : longint) : longint;
var l, r : longint;
begin
    if t = 0 then begin
        result := v;
        exit;
    end;
    if node[t].y < node[v].y then begin
        result := v;
        split(t, node[v].x, l, r);
        node[v].left := l;
        node[v].right := r;
      //  update(v);
    end
    else begin
        result := t;
        if node[v].x < node[t].x then begin
            node[t].left := addh(node[t].left, v);
        end
        else begin
            node[t].right := addh(node[t].right, v);
        end;
    end;
end;

function del(t, v : longint) : longint;
begin
    if node[t].x = node[v].x then begin
        result := merge(node[v].left, node[v].right);
        node[v].left := 0;
        node[v].right := 0;
    //    node[v]count := 1;
        exit;
    end;
    if node[v].x < node[t].x then begin
        result := t;
        node[t].left := del(node[t].left, v);
    end
    else begin
        result := t;
        node[t].right := del(node[t].right, v);
    end;
end;

procedure addq(x : longint);
begin
    inc(q.t);
    q.a[q.t] := x;
end;

procedure add(x : longint; ind : int64);
var nh : int64;
begin
    nh := h[x] + ind * ind * ind;
    if nh > hmax then begin
        nh := nh mod hmax;
    end;
    if b[h[x]] <> ind then begin
        addq(h[x]);
    end;
    b[h[x]] := ind;
    dec(c[h[x]]);
    tree[h[x]] := del(tree[h[x]], x);
    h[x] := nh;
    if b[h[x]] <> ind then begin
        addq(h[x]);
    end;
    b[h[x]] := ind;
    inc(c[h[x]]);
    tree[h[x]] := addh(tree[h[x]], x);
end;

procedure solve;
var i, j, k, x : longint;
begin
    fillchar(tree, sizeof(tree), 0);
    for i := 1 to n do begin
        node[i].x := i;
        node[i].y := random(ymax);
        node[i].left := 0;
        node[i].right := 0;
        tree[0] := merge(tree[0], i);
        inc(c[0]);
       // node[i].count := 1;
    end;
    fillchar(ans, sizeof(ans), 0);
    fillchar(h, sizeof(h), 0);
    for i := 1 to m do begin
        q.t := 0;
        read(k);
        for j := 1 to k do begin
            read(x);
            if ans[x] = 0 then begin
                add(x, i);
            end;
        end;
        for j := 1 to q.t do begin
            if c[q.a[j]] = 1 then begin
                ans[node[tree[q.a[j]]].x] := i;
            end;
        end;
    end;
end;

begin
    pinit;
    solve;
    pout;
end.
 