#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <string>

using namespace std;

const int MaxN = 100500;

long long sum[MaxN];

long long preobr(string s) {
  long long i, ans = 0;
  for (i = 0; i < s.length(); i++) {
    ans = ans * 10;
    ans = ans + s[i] - '0';
  }
  return ans;
}

int main() {
  freopen("password.in", "r", stdin);
  freopen("password.out", "w", stdout);
  string s, s1, obr;
  long long i, j, n, x, l, r, lenMin, lenMax, m, Max, i1, j1;
  for (i = 0; i < MaxN; i++) {
    sum[i] = 0;
  }

  cin >> s;
  cin >> s1;

  sum[0] = s[0]-'0';
  for (i = 1; i < s.length(); i++) {
    sum[i] = sum[i-1] + s[i] - '0';
  }

  for (i = 0; i < s1.length(); i++) {
    for (j = i; j < s1.length(); j++) {
      obr = s1.substr(i, j-i+1);
      x = preobr(obr);
      l = 0;
      r = s.length()-1;
      while (l < r) {
        m = (l+r) / 2;
        Max = sum[m-1];
        for (i1 = m; i1 < s.length(); i1++) {
          Max = max(Max, sum[i1]-sum[i1-m]);
        }
        if (Max > x) {
          r = m;
        }
        else {
          l = m + 1;
        }
      }
      lenMin = max((long long)1, l);
      for (j1 = max((long long)1, l-10); j1 <= min((long long)s.length(), l+10); j1++) {
        m = j1;
        Max = sum[m-1];
        for (i1 = m; i1 < s.length(); i1++) {
          Max = max(Max, sum[i1]-sum[i1-m]);
        }
        if (Max <= x) {
          lenMin = m;
        }
        else {
          break;
        }
      }
      for (j1 = max((long long)1, lenMin-5); j1 <= s.length(); j1++) {
        m = j1;
        Max = sum[m-1];
        if (Max == x) {
            cout << 1 << ' ' << j1 << endl;
            return 0;
        }
        for (i1 = m; i1 < s.length(); i1++) {
          if (sum[i1]-sum[i1-m] == x) {
            cout << i1-m+2 << ' ' << i1 + 1 << ' ' << endl;
            return 0;
          }
        }
      }
    }
  }
}
