#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>

using namespace std;

const int MaxN = 100500;

vector < vector <int> > g, g1;

long long tin[MaxN], tout[MaxN], tin1[MaxN], tout1[MaxN], mark[MaxN], mark1[MaxN], timee;

void dfs(int v) {
  int i;
  mark[v] = 1;
  timee++;
  tin[v] = timee;
  for (i = 0; i < g[v].size(); i++) {
    if (mark[g[v][i]] == 0) {
        dfs(g[v][i]);
    }
  }
  timee++;
  tout[v] = timee;
}

void dfs1(int v) {
  //cout << v << endl;
  int i;
  mark1[v] = 1;
  timee++;
  tin1[v] = timee;
  for (i = 0; i < g1[v].size(); i++) {
    if (mark1[g1[v][i]] == 0) {
        dfs1(g1[v][i]);
    }
  }
  timee++;
  tout1[v] = timee;
}

int main() {
  freopen("virus.in", "r", stdin);
  freopen("virus.out", "w", stdout);
  long long i, j, n, m, root, root1, x;
  g.resize(MaxN);
  g1.resize(MaxN);
  for (i = 0; i < MaxN; i++) {
    tin[i] = 0;
    tout[i] = 0;
    tin1[i] = 0;
    tout1[i] = 0;
    mark[i] = 0;
    mark1[i] = 0;
  }
  timee = 0;

  cin >> n;
  for (i = 0; i < n; i++) {
    cin >> x;
    if (x == 0) {
      root = i;
    }
    else {
      x--;
      g[x].push_back(i);
    }
  }
  for (i = 0; i < n; i++) {
    cin >> x;
    if (x == 0) {
      root1 = i;
    }
    else {
      x--;
      g1[x].push_back(i);
    }
  }
  dfs(root);
  dfs1(root1);
  long long ans = 0;
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      if ((tin[i] < tin[j]) && (tout[i] > tout[j]) && (tin1[i] < tin1[j]) && (tout1[i] > tout1[j])) {
        ans++;
      }
    }
  }

  cout << ans << endl;
}
