#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;
const ll inf = 1000000000000000ll;

int n;
ll r, u, d[2020];

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else
		freopen("apricot.in", "r", stdin),
		freopen("apricot.out", "w", stdout);
	
	scanf("%d%lld%lld", &n, &r, &u);
	fill(d, d + n + 1, inf);
	d[0] = d[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		if (i % 2 == 0) d[i] = min(d[i], d[i / 2] + u);
		for (int j = 1; j <= (i - 1) / 2; j++)
			d[i] = min(d[i], max(r + d[i - 2 * j], u + d[j]));
		for (int j = 1; j <= min(i - 1, n - i); j++)
			d[i] = min(d[i], max(r + d[i - j], u + d[j]));
	}
	printf("%lld\n", d[n]);
	//for (int i = 1; i <= n; i++)
	//	printf("%d %lld\n", i, d[i]);
	return 0;
}