#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>
 
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>
 
using namespace std;
 
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
 
const bool debug = !true;
const ll inf = 1000000000000000ll;
 
int n;
ll r, u, d[2020];
 
int main()
{
    if (debug)
        freopen("input.txt", "r", stdin),
        freopen("output.txt", "w", stdout);
    else
        freopen("apricot.in", "r", stdin),
        freopen("apricot.out", "w", stdout);
     
    scanf("%d%lld%lld", &n, &r, &u);
    fill(d, d + n + 1, inf);
    d[0] = d[1] = 0;
    for (int i = 1; i <= n; i++)
	{
		if (2 * i <= n) d[2 * i] = min(d[2 * i], d[i] + u);
		for (int j = 1; j + 2 * i <= n; j++)
			d[j + 2 * i] = min(d[j + 2 * i], max(d[j] + r, d[i] + u));
	}
    printf("%lld\n", d[n]);
    //for (int i = 1; i <= n; i++)
    //  printf("%d %lld\n", i, d[i]);
    return 0;
}