
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>
  
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>
  
using namespace std;
  
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
  
const bool debug = !true;
const ll inf = 1000000000000000ll;
  
int n;
ll r, u, dd[220];
  
int main()
{
    if (debug)
        freopen("input.txt", "r", stdin),
        freopen("output.txt", "w", stdout);
    else
        freopen("apricot.in", "r", stdin),
        freopen("apricot.out", "w", stdout);
    scanf("%d%lld%lld", &n, &r, &u);
    fill(dd, dd + n + 1, inf);
	dd[0] = dd[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
			for (int k = max(1, j - n + i); k <= j && j + k <= i; k++)
			{
				if (j + k == i) dd[i] = min(dd[i], u + max(dd[j], dd[k]));
				else dd[i] = min(dd[i], max(r + dd[i - k - j], u + max(dd[j], dd[k])));
			}
	}
	printf("%lld\n", dd[n]);
    //for (int i = 1; i <= n; i++)
    //  printf("%d %lld\n", i, d[i]);
    return 0;
}