#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>
 
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>
 
using namespace std;
 
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
 
const bool debug = !true;

int nx[500], pr[500], fir[500], n, m;
char a[1010][110];
bool gd0[100100], gd9[100100];
 
int main()
{
    if (debug)
        freopen("input.txt", "r", stdin),
        freopen("output.txt", "w", stdout);
    else
        freopen("caledar.in", "r", stdin),
        freopen("calendar.out", "w", stdout);
    
	for (char c = '0'; c <= '9'; c++)
		nx[c] = (c < '9' ? c + 1 : '0'), pr[c] = (c > '0' ? c - 1 : '9');

	scanf("%d%d\n", &n, &m);
	fill(fir, fir + m, -1);
    for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			scanf("%c", &a[i][j]);
			if (a[i][j] != '*') fir[j] = i;
		}
		scanf("\n");
	}
	if (fir[m - 1] == -1)
	{
		if (m == 3) printf("999\n");
		else printf("0098\n");
		return 0;
	}
	for (int i = fir[m - 1] - 1; i >= 0; i--)
		a[i][m - 1] = pr[a[i + 1][m - 1]];
	for (int i = fir[m - 1] + 1; i < n; i++)
		a[i][m - 1] = nx[a[i - 1][m - 1]];
	for (int i = 0; i < n; i++)
	{
		if (a[i][m - 1] == '9') gd9[i] = true;
		if (a[i][m - 1] == '0') gd0[i] = true;
	}
	for (int k = m - 2; k >= 0; k--)
	{
		for (int i = fir[k] - 1; i >= 0; i--)
		{
			if (gd0[i + 1]) a[i][k] = pr[a[i + 1][k]];
			else a[i][k] = a[i + 1][k];
		}
		for (int i = fir[k] + 1; i < n; i++)
		{
			if (gd9[i - 1]) a[i][k] = nx[a[i - 1][k]];
			else a[i][k] = a[i - 1][k];
		}
		for (int i = 0; i < n; i++)
		{
			if (gd9[i] && a[i][k] == '9') gd9[i] = true;
			else gd9[i] = false;
			if (gd0[i] && a[i][k] == '0') gd0[i] = true;
			else gd0[i] = false;
		}
	}
	for (int i = 0; i < m; i++)
		printf("%c", a[0][i]);
	printf("\n");
    return 0;
}