#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;

int n, k, a[20], p[20], v[20], sz = 0, nx[20];
bool b[20];
int gd[20], gs = 0;
ll ans = 0;

void push(int x, int t)
{
	if (sz == 0) { p[0] = x; v[0] = 0; sz++; return; }
	p[sz] = x; v[sz] = t; sz++;
}

int get(int x)
{
	if (sz == 0) return 0;
	int ans = -1;
	for (int i = 0; i < sz; i++)
		if (p[i] < x && v[i] > ans) ans = v[i];
	return ans + 1;
}

void solve(int bd, int x)
{
	if (n - x == k - bd) { ans++; 
	/*for (int i = 0; i < x; i++)
		printf("%d ", p[i]);
	for (int i = x; i < n; i++)
		printf("%d ", a[bd + i - x]);
	printf("\n");*/ return; }
	if (bd < k)
	{
		int t = get(a[bd]);
		if (t > bd) return;
		push(a[bd], t); solve(bd + 1, x + 1); sz--;
	}
	for (int i = 0; i < gs; i++)
	{
		if (b[gd[i]]) continue;
		int t = get(gd[i]);
		if (t >= max(nx[gd[i]], bd)) continue;
		b[gd[i]] = true; push(gd[i], t); solve(bd, x + 1); b[gd[i]] = false; sz--;
	}
}

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else
		freopen("army.in", "r", stdin),
		freopen("army.out", "w", stdout);

	scanf("%d%d", &n, &k);
	for (int i = 0; i < k; i++)
		scanf("%d", &a[i]), a[i]--, b[a[i]] = true;

	for (int i = 0; i < n; i++)
	{
		nx[i] = 0;
		while (nx[i] < k && a[nx[i]] < i) nx[i]++;
		if (!b[i]) gd[gs++] = i;
	}
	solve(0, 0);
	printf("%lld\n", ans);
	return 0;
}