#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

const int N = (int)(1e5) + 10;
const long long inf = (long long)(1e17);

int n, u, r;
long long d[2][N];

int main()
{
  freopen("apricot.in", "r", stdin);
  freopen("apricot.out", "w", stdout);

  scanf("%d%d%d", &n, &r, &u);

  for(int i = 0; i <= n; i++)
  {
    d[0][i] = inf;
    d[1][i] = inf;
  }

  d[0][0] = 0;
  d[1][0] = 0;
  d[0][1] = 0;
  d[0][2] = r;
  d[1][1] = 0;
  d[1][2] = u;

  for(int i = 3; i <= n; i++)
  {
    for(int j = 1; j * 2 <= i; j++)
    {
      d[1][i] = min(d[1][i], d[1][j] + u);
      if (2 * j < i)
        d[1][i] = max(d[1][i], d[1][i - 2 * j] + r);
    
    }
  }

  printf("%I64d\n", d[1][n]);



  return 0;
}