#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstring>

using namespace std;

const int N =(int)(7e3) + 10;

int a[N], b[N], n, k, l, r;
bool was[N];
int cnt_up[N][N], cnt_d[N][N];
int cnt[2][N];

int main()
{
  freopen("mosaic.in", "r", stdin);
  freopen("mosaic.out", "w", stdout);

  scanf("%d", &n);
  for(int i = 0; i < n; i++)
    scanf("%d%d", &a[i], &b[i]);
  scanf("%d", &k);

  for(int i = 0; i < n; i++)
  {
    for(int j =  i + 1; j < n; j++)
    {
      cnt_up[i][j] = cnt_up[i][j - 1];
      if (a[i] == a[j] && b[i] == b[j]) 
        cnt_up[i][j]++;
    }
    for(int j = i - 1; j > - 1; j--)
    {
      cnt_d[i][j] = cnt_d[i][j + 1];
      if (a[i] == a[j] && b[i] == b[j])
        cnt_d[i][j]++;
    }
  }
  
  for(int i = 0; i < k; i++)
  {
    scanf("%d%d", &l, &r);
    l--, r--;
    //memset(was, 0, sizeof(was));
    memset(cnt, 0, sizeof(cnt));
    for(int j = l; j <= r; j++)
    {
      cnt[0][a[j]]++;
      cnt[1][b[j]]++;
    }
    bool ok = true;
    for(int j = l; j <= r; j++)
    {
     // cout << j << ' ' << cnt[0][a[j]] << ' ' << cnt[1][b[j]] << ' ' << cnt_up[j][r] << ' ' << cnt_d[j][l] << endl;
      if (cnt[0][a[j]] + cnt[1][b[j]] - cnt_up[j][r] - cnt_d[j][l] - 1!= r - l + 1)
      {
        ok = false;
        for(int t = l; t <= r; t++)
          if (a[t] != a[j] && b[t] != b[j])
          {
            printf("%d %d\n", t + 1, j + 1);
            break;
          }
        break;
      }
    }
    if (ok)
      printf("0 0\n");
  }

  return 0;
}
