#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <set>
#include <map>

using namespace std;

const int N = (int)(5e3) + 10;

struct mos
{
  int a, b;
};

int a[N], b[N], n, k, l, r;
bool was[N];
int cnt_up[N][N], cnt_d[N][N];
int w[N];
int rr[N];

int main()
{
  freopen("mosaic.in", "r", stdin);
  freopen("mosaic.out", "w", stdout);

  scanf("%d", &n);
  for(int i = 0; i < n; i++)
    scanf("%d%d", &a[i], &b[i]);
  
  for(int i = 0; i < n; i++)
  {
    w[i] = -1;
    rr[i] = n;
  }
  int id = 0;
  while(id < n)
  {
    int j = id + 1;
    while(j < n && a[j] == a[id] && b[j] == b[id])
      j++;
    if (j == n)
      break;
    for(int i = id; i < j; i++)
      rr[id] = j;
    
    if (a[j] == a[id])
    {
      for(int i = j + 1; i < n; i++)
      {
        if (a[i] != a[id] && b[i] != b[id])
        {
          for(int s = id; s < i; s++)
            if (b[s] != b[i])
              w[s] = i;
        }
        if (a[i] != a[id])
        {
          if (b[i] != b[id])
          {
            for(int s = id; s < j; s++)
              w[s] = i;
          }
          if (b[i] != b[j])
            w[j] = i;
          break;
        }
      }
    }
    if (b[j] == b[id])
    {
      for(int i = j + 1; i < n; i++)
      {
        if (b[i] != b[id] && a[i] != a[id])
        {
          for(int s = id; s < i; s++)
            if (a[s] != a[i])
             w[s] = i;

        }
        if (b[i] != b[id])
        {
          if (a[i] != a[id])
          {
            for(int s = id; s < j; s++)
              w[s] = i;
          }
          if (a[i] != a[j])
            w[j] = i;
          break;
        }
      }
    }
    if (b[j] != b[id] && a[j] != a[id])
      for(int i = id; i < j; i++)
        w[i] = j;
    id = j;
  }

  scanf("%d", &k);
  for(int i = 0; i < k; i++)
  {
    scanf("%d %d", &l, &r);
    l--;
    r--;

    int f = rr[l];
    if (f > r)
    {
      printf("0 0\n");
      continue;
    }
    if (w[l] <= r && w[l] != -1)
    {
      printf("%d %d\n", l + 1, w[l]+ 1);
      continue;
    }
    if (w[f] <= r && w[f] != -1)
    {
      printf("%d %d\n", f + 1, w[f] + 1);
      continue;
    }
    printf("0 0\n");

  }



  return 0;
}
