#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstring>

using namespace std;

const int N = (int)(1e5) + 10;

int n, m;
vector<int> yes[N], no[N];
int k, t;
bool was[N];
int ans[N];

int main()
{
  freopen("theatre.in", "r", stdin);
  freopen("theatre.out", "w", stdout);

  scanf("%d%d", &n, &m);
  for(int i = 0; i < m; i++)
  {
    scanf("%d", &k);
    memset(was, 0, sizeof(was));
    for(int j = 0; j < k; j++)
    {
      scanf("%d", &t);
      was[t] = true;
      yes[t].push_back(i + 1); 
    }
    for(int j = 0; j < n; j++)
    {
      if (!was[j + 1])
        no[j + 1].push_back(i + 1);
      if (!was[j + 1] && k == n - 1)
      {
        ans[j + 1] = i + 1;
        //cout << "!!" << j + 1 << ' ' << i + 1 << endl;
      }
    }
    if (k == 1)
    {
      ans[t] = i + 1;
    }
  }

  for(int i = 1; i <= n; i++)
  {
    int mx1 = 0;
    for(int j = 1; j <= n; j++)
    {
      if (i == j)
        continue;
      int id = 0;
      while(id < (int)yes[i].size() && id < (int)yes[j].size() && yes[i][id] == yes[j][id])
        id++;
     // cout << id << endl;
      int tm = 0;
      if (id < (int)yes[i].size())
        tm = yes[i][id];
      else
        if (id < (int)yes[j].size())
          tm = yes[j][id];
      if (id < (int)yes[i].size() && id < (int)yes[j].size())
        tm = min(yes[i][id], yes[j][id]);
      mx1 = max(mx1, tm);
      //if (mx1 == 3)
      //  cout << "??? " << i << ' ' << j << ' ' << id << ' ' << endl;
      if (id == (int)yes[i].size() && id == (int)yes[j].size())
      {
        mx1 = 0;
        break;
      }
    }
    //cout << "!  " << i << ' ' << mx1 << endl;
    int mx2 = 0;
    for(int j = 1; j <= n; j++)
    {
      if (i == j)
        continue;
      int id = 0;
      while(id < (int)no[i].size() && id < (int)no[j].size() && no[i][id] == no[j][id])
        id++;

      int tm = 0;
      if (id < (int)no[i].size())
        tm = no[i][id];
      if (id < (int)no[j].size())
        tm = no[j][id];
      if (id < (int)no[i].size() && id < (int)no[j].size())
        tm = min(no[j][id], no[i][id]);
      mx2 = max(mx2, tm);
      
      if (id == (int)no[i].size() && id == (int)no[j].size())
      {
        mx2 = 0;
        break;
      }
    }
    //cout << "!! " << i << ' ' << mx2 << endl;
    if (mx1 == 0)
      ans[i] = mx2;
    else
    if (mx2 == 0)
      ans[i] = mx1;
    else
      ans[i] = min(mx1, mx2);
  }

  for(int i = 1; i <= n; i++)
    printf("%d ", ans[i]);
  printf("\n");

  return 0;
}