#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cstring>
using std::cin;
using std::cout;
using std::pair;
using std::swap;
using std::max;
using std::min;

typedef unsigned long long ull;

#define fi first
#define se second

const int MAX_SIZE = 100000;
ull *sum, *sum2;

ull str2ull (char *s, int i, int j)
{
  ull x = 0;

  for (int p = i; p <= j; p++)
  {
    x = x * 10 + s [p] - '0';
  }

  return x;
}

void solve (char* s1, char* s2, int len1, int len2)
{
  int j, k = len1 - len2;
  ull num;

  for (int i = 0; i < len1; i++)
  {
    for (int j = i + k; j < len1; j++)
    {
      if (j - k >= len2)
      {
        break;
      }

      num = str2ull (s2, i, j - k);

      if (sum [j] - sum [i] + s1 [i] - '0' < num)
      {
        break;
      }

      if (sum [j] - sum [i] + s1 [i] - '0' == num)
      {
        cout << (i + 1) << ' ' << (j + 1) << '\n';
        cout << "OK\n";
        return;
      }
    }
  }
}

int main ()
{
  freopen ("password.in", "r", stdin);
  freopen ("password.out", "w", stdout);

  char s1 [MAX_SIZE], s2 [MAX_SIZE];
  int len1, len2;
  cin >> s1 >> s2;
  len1 = strlen (s1);
  len2 = strlen (s2);
  sum = new ull [len1];
  sum2 = new ull [len2];

  if (len1 == len2)
  {
    cout << "1 1\n";
    fclose (stdout);
    return 0;
  }

  sum [0] = s1 [0] - '0';
  sum2 [0] = s2 [0] - '0';
  for (int i = 1; i < len1; i++)
  {
    sum [i] = sum [i - 1] + s1 [i] - '0';
  }
  for (int i = 1; i < len1; i++)
  {
    sum2 [i] = sum2 [i - 1] + s2 [i] - '0';
  }

  solve (s1, s2, len1, len2);
  fclose (stdout);
  return 0;
}
