#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cstring>
using std::cin;
using std::cout;
using std::pair;
using std::swap;
using std::max;
using std::min;

typedef unsigned long long ull;

#define fi first
#define se second

const int MAX_SIZE = 100005,
          INF = 18446744073709551615;
ull *sum1;

ull str2ull (char *s, int i, int j)
{
  if (j > strlen (s) || i >= j)
  {
    return INF;
  }

  ull x = 0;

  for (int p = i; p < j; p++)
  {
    x = x * 10 + s [p] - '0';
  }

  return x;
}

void solve (char* s1, char* s2, int len1, int len2)
{
  bool f;
  int k = len1 - len2;
  ull num;

  for (int i = 0; i < len1; i++)
  {
    for (int j = i + k + 1; j <= len1; j++)
    {
      if (j - k > len2)
      {
        break;
      }

      num = str2ull (s2, i, j - k);

      if (sum1 [j] - sum1 [i] < num)
      {
        break;
      }

      if (sum1 [j] - sum1 [i] == num)
      {
        f = s2 [i] != '0';

        for (int p1 = 0; p1 < i; p1++)
        {
          if (!f && s1 [p1] != s2 [p1])
          {
            f = 0;
            break;
          }
        }

        for (int p1 = j; p1 < len1; p1++)
        {
          if (!f || s1 [p1] != s2 [p1 - k])
          {
            f = 0;
            break;
          }
        }

        if (f)
        {
          cout << (i + 1) << ' ' << (j) << '\n';
          return;
        }
      }
    }
  }
}

int main ()
{
  freopen ("password.in", "r", stdin);
  freopen ("password.out", "w", stdout);

  char s1 [MAX_SIZE], s2 [MAX_SIZE];
  int len1, len2;
  cin >> s1 >> s2;
  len1 = strlen (s1);
  len2 = strlen (s2);
  sum1 = new ull [len1 + 1];

  if (len1 == len2)
  {
    cout << "1 1\n";
    fclose (stdout);
    return 0;
  }

  sum1 [0] = 0;
  for (int i = 1; i <= len1; i++)
  {
    sum1 [i] = sum1 [i - 1] + s1 [i - 1] - '0';
  }

  solve (s1, s2, len1, len2);
  fclose (stdout);
  return 0;
}
