#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
using std::cin;
using std::cout;
using std::pair;
using std::swap;
using std::max;
using std::min;

typedef unsigned long long ull;

#define fi first
#define se second

const int INF = 18446744073709551615;

void do_3 (ull n, ull r, ull u)
{
  ull d [n + 3];
  for (int i = 0; i <= n; i++)
  {
    d [i] = INF;
  }
  d [0] = INF;
  d [1] = 0;
  d [2] = u;
  d [3] = max (u, r);
  int rest;

  for (int i = 4; i <= n; i++)
  {
    for (int j = 0; j < i; j++)
    {
      for (int k = 0; k < i; k++)
      {
        for (int l = 0; l < i; l++)
        {
          if (j + k + l == i)
          {
            if (j == k && j != 0)
            {
              if (l != 0)
              {
                d [i] = min (d [i], max (d [j] + u, d [l] + r));
              }
              else
              {
                d [i] = min (d [i], d [j] + u);
              }
            }
          }
        }
      }
    }
  }
  cout << d [n];
}

int main ()
{
  freopen ("apricot.in", "r", stdin);
  freopen ("apricot.out", "w", stdout);
  ull n, u, r;
  cin >> n >> r >> u;
  if (n <= 50)
  {
    do_3 (n, r, u);
    fclose (stdout);
    return 0;
  }
  ull d [n + 3];
  for (int i = 0; i <= n; i++)
  {
    d [i] = INF;
  }
  d [0] = INF;
  d [1] = 0;
  d [2] = u;
  d [3] = max (u, r);
  int rest;

  for (int i = 4; i <= n; i++)
  {
    for (int j = 0; j < i; j++)
    {
      rest = i - j;

      if (rest % 2 == 0)
      {
        d [i] = min (d [i], max (d [rest / 2] + u, d [j] + r));
      }

      if (j > 0)
      {
        if (j == rest)
        {
          d [i] = min (d [i], d [j] + u);
        }
        else if (j < rest)
        {
          d [i] = min (d [i], max (d [j] + u, d [rest - j] + r));
        }
      }
    }
  }

  cout << d [n];
  fclose (stdout);
  return 0;
}
