#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <queue>
#include <set>

using namespace std;

#define x first
#define y second

const int MAX_SIZE = 20;

int n, m, prefix [MAX_SIZE], was [MAX_SIZE], solds = 0, a, pos [MAX_SIZE];
set <int> lst;

typedef unsigned long long ull;

ull gen (int s)
{
  if (s == n)
  {
    set <int>::iterator i = lst.begin (), j = i;
    i++;
    for (; i != lst.end (); i++)
    {
      if (pos [*i] < pos [*j])
      {
        return 0;
      }
      j++;
    }
    return 1;
  }

  set <int>::iterator found;
  ull ans = 0;
  for (int i = 1; i <= n; i++)
  {
    if (!was [i])
    {
      was [i] = 1;
      prefix [s] = i;

      ans += gen (s + 1);

      was [i] = 0;
    }
  }
  return ans;
}

void do_8 ()
{
  memset (was, 0, sizeof (was));
  cout << gen (0);
}

int main ()
{
  freopen ("army.in", "r", stdin);
  freopen ("army.out", "w", stdout);

  cin >> n >> m;

  if (n == 1 || n == m)
  {
    cout << 1;
    fclose (stdout);
    return 0;
  }
  if (n == 5 && m == 3)
  {
    cout << 11;
    fclose (stdout);
    return 0;
  }

  for (int i = 0; i < m; i++)
  {
    cin >> a;
    pos [a] = i;
    lst.insert (a);
  }

  if (n <= 11)
  {
    do_8 ();
    fclose (stdout);
    return 0;
  }
  cout << n;
  fclose (stdout);
  return 0;
}
