#define ONLINE_JUDGE

#include <fstream>

#ifdef ONLINE_JUDGE
std::ifstream cin("apricot.in");
std::ofstream cout("apricot.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

int main()
{
	ll n, u, r;
	cin >> n >> r >> u;
	vector<ll> d(n + 2, 1000000000000000000ll);
	d[1] = 0;
	d[2] = u;
	d[0] = 0;
	for (ll i = 3; i <= n; i++)
		for (ll j = max(1ll, i / 2 - 50); j <= i / 2; j++)
			d[i] = min(d[i], max(d[j] + u, (i - j * 2 > 0 ? d[i - j * 2] + r : 0)));
	cout << d[n] << endl;
    return 0;
}