#define ONLINE_JUDGE

#include <fstream>

#ifdef ONLINE_JUDGE
std::ifstream cin("apricot.in");
std::ofstream cout("apricot.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

int main()
{
	int n;
	ull u, r;
	cin >> n >> r >> u;
	vector<ull> d(n + 1, 1ll << 63);
	d[1] = 0;
	d[2] = u;
	for (int i = 3; i <= n; i++)
	{
		int p = (int)((ld)i / (2.0 + (ld)u / (ld)r));
		for (int j = max(1, p - 20); j < p + 20 && j * 2 < i; j++)
			d[i] = min(d[i], max(d[j] + u, d[i - j * 2] + r  ));
		if (i % 2 == 0)
			d[i] = min(d[i], d[i / 2] + u);
	}
	cout << d[n] << endl;
    return 0;
}