#define ONLINE_JUDGE
 
#include <fstream>
 
#ifdef ONLINE_JUDGE
std::ifstream cin("apricot.in");
std::ofstream cout("apricot.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif
 
#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>
 
#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
 
using namespace std;
 
int main()
{
    int n;
    ull u, r;
    cin >> n >> r >> u;
    vector<ull> d(n + 2);
    d[1] = 0;
    for (int i = 2; i <= n; i++)
    {
		d[i] = 1ll << 63;
        for (int j = 1; j * 2 < i; j++)
		{
			ull x1 = d[j] + u;
			ull x2 = d[i - (j * 2)] + u;
			if (x2 > x1) swap(x1, x2);
			if (d[i] > x1)
				d[i] = x1;

		}
        if (i % 2 == 0)
		{
			ull x = d[i / 2] + u;
			if (x < d[i])
				d[i] = x;
		}
    }
    cout << d[n] << endl;
    return 0;
}