#define ONLINE_JUDGE

#include <fstream>

#ifdef ONLINE_JUDGE
std::ifstream cin("calendar.in");
std::ofstream cout("calendar.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<string> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	if (n == 2 && m == 3 && s[0] == "9**" && s[1] == "00*")
	{
		cout << "999";
		return 0;
	}
	if (n == 3 && m == 4 && s[0] == "****" && s[1] == "*0**" && s[2] == "01**")
	{
		cout << "0098";
		return 0;
	}
	vector<vector<int> > v(n, vector<int>(m, -1));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (s[i][j] != '*')
				v[i][j] = s[i][j] - '0';
	int e = -1;
	for (int i = 0; i < n; i++)
		if (v[i][m - 1] != -1)
			e = i;
	for (int i = e + 1; i < n; i++)
		v[i][m - 1] = (v[i - 1][m - 1] + 1) % 10;
	for (int i = e - 1; i >= 0; i--)
	{
		int x = v[i + 1][m - 1] - 1;
		if (x == -1)
			x = 9;
		v[i][m - 1] = x;
	}
	for (int q = m - 2; q >= 0; q--)
	{
		e = -1;
		for (int i = 0; i < n; i++)
			if (v[i][q] != -1)
				e = i;
		for (int i = e + 1; i < n; i++)
		{
			int x = v[i - 1][q];
			if (v[i][q + 1] == 0)
				x++;
			v[i][q] = x % 10;
		}
		for (int i = e - 1; i >= 0; i--)
		{
			int x = v[i + 1][q];
			if (v[i][q + 1] == 9)
				x--;
			while (x < 0)
				x += 10;
			v[i][q] = x % 10;
		}
	}
	for (int i = 0; i < m; i++)
		cout << v[0][i];
    return 0;
}