#define ONLINE_JUDGE

#include <fstream>
#ifdef ONLINE_JUDGE
std::ifstream cin("theatre.in");
std::ofstream cout("theatre.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

vector<int> ans;
vector<int> cl;
//vector<int> ost;
vector<set<int> > nost;
int mc = 1;
int n, s;

inline bool cmp(int i, int j)
{
	return cl[i] < cl[j];
}

void addN(int q, int w)
{
	nost[cl[q]].erase(q);
	//ost[cl[q]]--;
	s = cl[q];
	cl[q] = mc;
	//ost[mc]++;
	nost[mc].insert(q);
	mc++;
	ans[q] = w;
	if (nost[s].size() == 1)
	{
		int k = *nost[s].begin();
		nost[s].clear();
		ans[k] = w;
	}
	/*if (ost[s] == 1)
		for (int i = 0; i < n; i++)
			if (cl[i] == s)
			{
				ans[i] = w;
				break;
			}
	*/
}

void moveN(int q, int w)
{
	nost[cl[q]].erase(q);
	//ost[cl[q]]--;
	s = cl[q];
	//ost[mc]++;
	nost[mc].insert(q);
	cl[q] = mc;
}

void endM(int w)
{
	mc++;
	if (nost[s].size() == 1)
	{
		int k = *nost[s].begin();
		nost[s].clear();
		ans[k] = w;
	}
	/*
	if (ost[s] == 1)
		for (int i = 0; i < n; i++)
			if (cl[i] == s)
			{
				ans[i] = w;
				break;
			}
	*/
}

void addV(vector<int> &c, int w)
{
	if (c.size() != 0)
		{
			bool adding = false;
			for (int i = 0; i + 1 < c.size(); i++)
			{
				if (cl[c[i]] != cl[c[i + 1]] && !adding)
					addN(c[i], w);
				else if (cl[c[i]] != cl[c[i + 1]] && adding)
				{
					adding = false;
					moveN(c[i], w);
					endM(w);
				}
				else
				{
					adding = true;
					moveN(c[i], w);
				}
			}
			if (c.size() > 0)
			{
				if (adding)
				{
					moveN(c[c.size() - 1], w);
					endM(w);
				}
				else
					addN(c[c.size() - 1], w);
			}
			
		}
}

int main()
{
	n;
	cin >> n;
	ans.assign(n, 0);
	cl.assign(n, 0);
	//ost.assign(500500, 0);
	nost.assign(500500, set<int>());
	//ost[0] = n;
	for (int i = 0; i < n; i++)
		nost[0].insert(i);
	vector<char> cs;
	int m;
	cin >> m;

	for (int i = 1; i <= m; i++)
	{
		vector<int> c;
		//vector<int> rc;
		//cs.assign(n, false);
		int k;
		cin >> k;
		c.reserve(k);
		for (int j = 0; j < k; j++)
		{
			int q;
			cin >> q;
			q--;
			if (ans[q] == 0)
				c.pb(q);
		}
		sort(c.begin(), c.end(), cmp);
		addV(c, i);
	}
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";
    return 0;
}