#define ONLINE_JUDGE
 
#include <fstream>
#ifdef ONLINE_JUDGE
std::ifstream cin("theatre.in");
std::ofstream cout("theatre.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif
 
#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>
 
#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
 
using namespace std;
 
vector<int> ans;
vector<int> cl;
vector<int> ost;
int mc = 1;
int n, s;
 
inline bool cmp(int i, int j)
{
    return cl[i] < cl[j];
}
 
inline void addN(int q, int w)
{
	s = cl[q];
    ost[s]--;    
    cl[q] = mc;
    ost[mc]++;
    mc++;
    ans[q] = w;
    if (ost[s] == 1)
        for (int i = 0; i < n; i++)
            if (cl[i] == s)
            {
				ost[s] = 0;
                ans[i] = w;
                break;
            }
}
 
inline void moveN(int q, int w)
{
	s = cl[q];
    ost[s]--;
    ost[mc]++;
    cl[q] = mc;
}
 
inline void endM(int w)
{
    mc++;
    if (ost[s] == 1)
        for (int i = 0; i < n; i++)
            if (cl[i] == s)
            {
				ost[s] = 0;
                ans[i] = w;
                break;
            }
}
 
inline void addV(vector<int> &c, int w)
{
    if (c.size() != 0)
        {
            bool adding = false;
            for (int i = 0; i + 1 < c.size(); i++)
            {
                if (cl[c[i]] != cl[c[i + 1]] && !adding)
                    addN(c[i], w);
                else if (cl[c[i]] != cl[c[i + 1]] && adding)
                {
                    adding = false;
                    moveN(c[i], w);
                    endM(w);
                }
                else
                {
                    adding = true;
                    moveN(c[i], w);
                }
            }
            if (c.size() > 0)
            {
                if (adding)
                {
                    moveN(c[c.size() - 1], w);
                    endM(w);
                }
                else
                    addN(c[c.size() - 1], w);
            }
             
        }
}
 
int main()
{
    cin >> n;
    ans.assign(n, 0);
    cl.assign(n, 0);
    ost.assign(500500, 0);
    ost[0] = n;
    int m, k, q;
    cin >> m;
 
    for (int i = 1; i <= m; i++)
    {
        vector<int> c;
        cin >> k;
        c.reserve(k);
        for (int j = 0; j < k; j++)
        {
            cin >> q;
            q--;
            if (ans[q] == 0)
                c.pb(q);
        }
        sort(c.begin(), c.end(), cmp);
        addV(c, i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << " ";
    return 0;
}