#define ONLINE_JUDGE

#ifdef ONLINE_JUDGE
#include <iostream>
#else
#include <fstream>
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <queue>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	int x, y;
	cin >> x >> y;
	x--;
	y--;
	cout << "0 0 1\n";
	cout.flush();
	vector<vector<char> > p(m, vector<char>(n, false));
	vector<vector<char> > u(m, vector<char>(n, false));
	int vx = 0, vy = 0;
	int v, lx, ly;
	cin >> v >> lx >> ly;
	while (v != 1)
	{
		if (x - vx >= 0 && x - vx < m && y - vy >= 0 && y - vy < n)
		p[x - vx][y - vy] = true;
		vx += lx;
		vy += ly;
		u.assign(m, vector<char>(n, false));
		queue<pii> q;
		q.push(mp(x, y));
		int cx = -1, cy = -1;
		while (!q.empty())
		{
			int nx = q.front().first;
			int ny = q.front().second;
			u[nx][ny] = true;
			q.pop();
			if (nx - vx >= 0 && nx - vx < m && ny - vy >= 0 && ny - vy < n &&  !p[nx - vx][ny - vy])
			{
				cx = nx;
				cy = ny;
				break;
			}
			if (nx > 0 && !u[nx - 1][ny])
				q.push(mp(nx - 1, ny));
			if (nx + 1 < m && !u[nx + 1][ny])
				q.push(mp(nx + 1, ny));
			if (ny > 0 && !u[nx][ny - 1])
				q.push(mp(nx, ny - 1));
			if (ny + 1 < n && !u[nx][ny + 1])
				q.push(mp(nx, ny + 1));
		}
		int d1 = 0, d2 = 0;
		if (cx > x)
			d1 = 1;
		if (cx < x)
			d1 = -1;

		if (cy > y)
			d2 = 1;
		if (cy < y)
			d2 = -1;
		x += d1;
		y += d2;
		if (p[x][y])
			cout << d1 << " " << d2 << " 0\n";
		else
			cout << d1 << " " << d2 << " 1\n";
		cout.flush();
		cin >> v >> lx >> ly;
	}
    return 0;
}