#define ONLINE_JUDGE

#include <fstream>
#ifdef ONLINE_JUDGE
std::ifstream cin("army.in");
std::ofstream cout("army.out");
#else
std::ifstream cin("input.txt");
std::ofstream cout("output.txt");
#endif

#include <vector>
#include <string>
#include <string.h>
#include <map>
#include <deque>
#include <complex>
#include <set>
#include <math.h>
#include <algorithm>

#define srt(a) sort(a.begin(), a.end())
#define srtr(a) sort(a.rbegin(), a.rend())
#define all(a) a.begin(), a.end()
#define cplx complex<double, double>
#define pii pair<int, int>
#define mp(a, b) make_pair(a,b)
#define pb(a) push_back(a)

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

int main()
{
	int n, k;
	cin >> n >> k;
	vector<int> h(k);
	for (int i = 0; i < k; i++)
		cin >> h[i];
	vector<int> a(n);
	for (int i = 0; i < n; i++)
		a[i] = i + 1;
	int cnt = 0;
	do
	{
		int p = 0;
		int i;
		for (i = 0; i < k && p < n; i++)
		{
			while (p < n && a[p] != h[i])
				p++;
		}
		if (i < k || (i == k && p == n))
			continue;
		vector<int> d(n, 1);
		int m = 1;
		for (int i = 1; i < n; i++)
		{
			for (int j = i - 1; j >= 0; j--)
				if (a[j] < a[i] && d[i] < d[j] + 1)
					d[i] = d[j] + 1;
			m = max(m, d[i]);
		}
		if (m == k)
			cnt++;
	}
	while (next_permutation(a.begin(), a.end()));

	cout << cnt << endl;
    return 0;
}