#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <map>

using namespace std;

struct Two{
    int x, y;
    Two(){};
    Two(int _x, int _y): x(_x), y(_y){};
};

const int lt = 1 << 17;
int mtree[lt << 1], mnum[lt << 1];
int al[120000], ar[120000]; int n;
int pl[120000], pr[120000];

void norm(int * a, int n)
{
    map < int, int > Q;
    int i;
    for (i = 1; i <= n; i++)
        Q[a[i]] = 0;
    i = 0;
    for (map < int, int >::iterator it = Q.begin(); it != Q.end(); it++, i++)
        it->second = i;
    for (i = 1; i <= n; i++)
        a[i] = Q[a[i]];
    Q.clear();
}

bool operator<(Two A, Two B){
    return A.x < B.x;
}
Two askmin(int root, int pl, int pr, int l, int r)
{
    if (r < pl || pr < l)
        return Two(1 << 30, 1 << 30);
    if (l <= pl && pr <= r)
        return Two(mtree[root], mnum[root]);
    return min(askmin(root << 1, pl, (pl + pr) / 2, l, r), askmin(root << 1 ^ 1, (pl + pr) / 2 + 1, pr, l, r));
}


int main()
{
    freopen("mosaic.in", "rt", stdin);
    freopen("mosaic.out", "wt", stdout);
    scanf("%d", &n);
    int i, j;
    for (i = 1; i <= n; i++)
        scanf("%d%d", &al[i], &ar[i]);
    norm(al, n);
    norm(ar, n);
    for (i = 0; i < (lt << 1); i++)
        mtree[i] = 1 << 30;
    for (i = lt; i < (lt << 1); i++)
        mnum[i] = i - lt;
    for (i = 1; i <= n; i++){
        mtree[lt + i] = 1 << 30;
        for (j = i + 1; j <= n; j++)
            if (al[i] != al[j] && ar[i] != ar[j]){
                mtree[lt + i] = j;
                break;
            }
    }
    /*for (i = n; i > 0; i--)
    {
        if (pl[al[i]] != 0)
            mtree[lt + i] = pl[al[i]];
        else
            mtree[lt + i] = n + 1;
        if (pr[ar[i]] != 0)
            mtree[lt + i] = min(mtree[lt + i], pr[ar[i]]);
        else
            mtree[lt + i] = min(mtree[lt + i], n + 1);
        //pl[al[i]] = i;
        //pr[ar[i]] = i;
    }*/
    for (i = lt - 1; i > 0; i--)
        if (mtree[i << 1] < mtree[i << 1 ^ 1])
            mtree[i] = mtree[i << 1], mnum[i] = mnum[i << 1];
        else
            mtree[i] = mtree[i << 1 ^ 1], mnum[i] = mnum[i << 1 ^ 1];
    int k, l, r;
    scanf("%d", &k);
    Two ret;
    for (i = 1; i <= k; i++)
    {
        scanf("%d%d", &l, &r);
        ret = askmin(1, lt, lt * 2 - 1, l + lt, r + lt);
        if (ret.x > r)
            printf("0 0\n");
        else
            printf("%d %d\n", ret.y, ret.x);
    }
    return 0;
}
