#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <limits>

using namespace std;

vector <pair <int, pair <int, int> > > c;

int main()
{
	int n, m, x, y;
	cin >> m >> n >> x >> y;
	int sdx = 0, sdy = 0, mxdx = 0, mndx = 0, mxdy = 0, mndy = 0;
	srand((n * m + 1000000007) * x + (y * 133412347));
	c.push_back(make_pair(-1000000010, make_pair(x, y)));
	for (int i = 1; i <= n; i++)
	{
	     for (int j = 1; j <= m; j++)
		 {
			 if ((i == x) && (j == y)) continue;
			 int code = 100 * i;
			 if (i % 2 == 1) code += j;
			 else code += 40 - j;
			 c.push_back(make_pair(code , make_pair(i, j)));
		 }
	}
	sort(c.begin(), c.end());
	for (int i = 0; i < n * m; i++)
	{
		int x1 = c[i].second.first, y1 = c[i].second.second;
		if ((x1 + mndx < 1) || (x1 + mxdx > n) || (y1 + mndy < 1) || (y1 + mxdy > m)) continue;
		x1 += sdx, y1 += sdy;
		bool d = false;
		while (!d)
		{
			if ((x1 < 1) || (x1 > n) || (y1 < 1) || (y1 > m)) break; 
			if (x < x1) cout << 1 << " ", x++;
			else if (x > x1) cout << -1 << " ", x--;
			else cout << 0 << " ";
			if (y < y1) cout << 1 << " ", y++;
			else if (y > y1) cout << -1 << " ", y--;
			else cout << 0 << " ";
			if ((x == x1) && (y == y1)) d = true;
			if (d) cout << 1 << endl;
			else cout << 0 << endl;
			cout.flush();
			int o, dx, dy;
			cin >> o >> dx >> dy;
			sdx += dx, sdy += dy;
			mxdx = max(mxdx, sdx); mndx = min(mxdx, sdx); mxdy = max(mxdy, sdy); mndy = min(mndy, sdy);
			if (o == 1) return 0;
			x1 += dx, y1 += dy;
		}
	}
	return 0;
}