#include <cstdio>
#include <vector>
#include <iostream>
using namespace std;

#define MAXN 100000

vector<int> f[MAXN];
vector<int> g[MAXN];
int fin[MAXN];
int fout[MAXN];
int ft = 0;
vector<int> q;
int k_ = 0;

void fdfs(int v) {
	fin[v] = ft;
	++ft;
	for (int i = 0; i < (int)f[v].size(); ++i)
		fdfs(f[v][i]);
	fout[v] = ft;
	++ft;
}

void h(int v) {
	for (int i = 0; i < (int)q.size(); ++i)
		if (fin[q[i]] < fin[v] && fout[q[i]] > fout[v])
			++k_;
	q.push_back(v);
	for (int i = 0; i < (int)g[v].size(); ++i)
		h(g[v][i]);
	q.pop_back();
}

int main() {
	int n, x;
	int a, b;

	ios_base::sync_with_stdio(false);

	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> x;
		if (x == 0)
			a = i;
		else
			f[x - 1].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> x;
		if (x == 0)
			b = i;
		else
			g[x - 1].push_back(i);
	}

	fdfs(a);
	h(b);

	cout << k_;

	return 0;
}

