#include<iostream>
#include<string>
using namespace std;

const int sz = 100050;
string s1, s2;
int sum[sz];

string ItoS(int u)
{
	if (u == 0)
		return "0";
	string res;
	while (u > 0)
	{
		char c = (u % 10 + '0');
		res = c + res;
		u /= 10;
	}
	return res;
}

int main()
{
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	freopen("password.in", "r", stdin);freopen("password.out", "w", stdout);
	
	cin >> s1 >> s2;
	int l = 0, r = 0;

	if (s1 == s2)
	{
		cout << "1 1";
		return 0;
	}

	for (int i = 0; i < s1.size(); i++)
	{
		if (i > 0)
			sum[i] += sum[i - 1];
		sum[i] += s1[i] - '0';
	}

	while (s1[l] == s2[l])
		l++;
	while (s1[s1.size() - r - 1] == s2[s2.size() - r - 1])
		r++;

	for (int i = l - 10; i <= l; i++)
		for (int j = r - 10; j <= r; j++)
			if (i >= 0 && j >= 0 && i + j <= s2.size() && s2.size() - i - j < 9)
			{
				int l1 = i, r1, l2 = i, r2;
				r1 = s1.size() - 1 - j;
				r2 = s2.size() - 1 - j;

				int ss = sum[r1];
				if (l1 > 0)
					ss -= sum[l1 - 1];
				string u = ItoS(ss);
				
				if (s2.substr(l2, r2 - l2 + 1) == u)
				{
					cout << l1 + 1 << " " << r1 + 1;
					return 0;
				}				
			}
}