#include<iostream>
#include<vector>
using namespace std;

const int sz = 100001;
int n, top[2], T = 0;
vector<int> G[2][sz];
int tin[2][sz], tout[2][sz];
long long dp[sz], res = 0;

void dfs(int x, int l)
{
	tin[l][x] = T;
	T++;

	for (int i = 0; i < G[l][x].size(); i++)
		dfs(G[l][x][i], l);

	tout[l][x] = T;
	T++;
}

void dfsdp(int x)
{
	for (int i = 0; i < G[0][x].size(); i++)
	{
		int v = G[0][x][i];
		dfsdp(v);
		bool b1 = tin[1][x] <= tin[1][v], b2 = tout[1][x] >= tout[1][v];
		if (b1 && b2)
			dp[x] += dp[v] + 1;
	}
	res += dp[x];
}

int main()
{
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	freopen("virus.in", "r", stdin);freopen("virus.out", "w", stdout);
	
	cin >> n;
	for (int k = 0; k < 2; k++)
		for (int i = 1; i <= n; i++)
		{
			int x;
			cin >> x;
			if (x == 0)
				top[k] = i;
			else
				G[k][x].push_back(i);
		}

	dfs(top[0], 0);
	dfs(top[1], 1);
	//dfsdp(top[0]);

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
		{
			bool b = 1;
			for (int k = 0; k < 2; k++)
				b &= tin[k][i] < tin[k][j] && tout[k][i] > tout[k][j];
			res += b;
		}

	cout << res;
}