{$O-,Q+,R+}
{$MAXSTACKSIZE $00100000}
program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  MAXN = 1000;
var
  s1, s2: string;
  precalc: array[0..MAXN] of longint;

  i, res: longint;

  suffix: array[1..MAXN] of longint;

procedure init_precalc();
var
  i: longint;
begin
  precalc[0] := 0;
  for i := 1 to length(s1) do
    precalc[i] := precalc[i - 1] + ord(s1[i]) - ord('0');
end;

function get_sum(const l, r: longint): longint;
begin
  result := precalc[r] - precalc[l - 1];
end;

procedure init_suffix();
var
  i: longint;
begin
  if (s1[length(s1)] < s2[length(s2)]) then
    suffix[length(s2)] := -1
  else
    if (s1[length(s1)] = s2[length(s2)]) then
      suffix[length(s2)] := 0
    else
      suffix[length(s2)] := 1;

  for i := 1 to length(s2) - 1 do
    if (s1[length(s1) - i] < s2[length(s2) - i]) then
      suffix[length(s2) - i] := -1
    else
      if (s1[length(s1) - i] = s2[length(s2) - i]) then
        suffix[length(s2) - i] := suffix[length(s2) - i + 1]
      else
        suffix[length(s2) - i] := 1;
end;

function more(const start, len: longint): boolean;
var
  l1, l2: longint;
  tmp_str, tmp: string;
begin
  tmp := inttostr(get_sum(start, start + len - 1));
  l1 := length(s1) - start + 1 - len;
  l2 := length(s2) - start + 1 - length(tmp);

  if l1 < l2 then
  begin
    result := true;
    exit;
  end;

  if (l1 > l2) then
  begin
    result := false;
    exit;
  end;

  tmp_str := copy(s2, start, length(tmp));

  if (tmp_str > tmp) then
  begin
    result := true;
    exit;
  end;

  if (tmp_str < tmp) then
  begin
    result := false;
    exit;
  end;

  if (suffix[length(s2) - l1 + 1] = 1) then
    result :=  true
  else
    result := false;

end;

function check(const start, len: longint): boolean;
var
  l1, l2: longint;
  tmp: string;
begin
  tmp := inttostr(get_sum(start, start + len - 1));
  l1 := length(s1) - start + 1 - len;
  l2 := length(s2) - start + 1 - length(tmp);

  if (l1 <> l2) then
  begin
    result := false;
    exit;
  end;

  if (copy(s2, start, length(tmp)) <> tmp) then
  begin
    result := false;
    exit;
  end;

  if (suffix[length(s2) - l1 + 1] <> 0) then
    result := false
  else
    result := true;
end;

function bin_search(const x: longint): longint;
var
  l, r, m: longint;
begin
  l := 1;
  r := length(s1) - x + 2;

  while (l + 1 < r) do
  begin
    m := (l + r) shr 1;
    if (more(x, m)) then
      r := m
    else
      l := m;
  end;

  if (check(x, l)) then
    result := x + l - 1
  else
    result := -1;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readln(s1);
  readln(s2);

  init_precalc();

  init_suffix();

  for i := 1 to length(s2) do
  begin
    res := bin_search(i);

    if (res <> -1) then
    begin
      writeln(i, ' ', res);
      halt(0);
    end;
  end;

end.
