#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

const int MAXN = 100000;
const int MAXK = MAXN;

map<int, int> h;
map<int, int> v;

int n;
pair<int, int> ar[MAXN];

int k;
pair<int, int> res[MAXK];

vector<pair<int, int> > ask[MAXN];


inline bool try_to_add(const pair<int, int> x){
    if (v.empty() && h.empty())
        return true;

    if ((v.size() == 1 && v.find(x.first) != v.end()) ||
        (h.size() == 1 && h.find(x.second) != h.end()))
        return true;
    else
        return false;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for(int i = 0; i < n; ++i)
        scanf("%d %d", &ar[i].first, &ar[i].second);

    scanf("%d", &k);
    for(int i = 0; i < k; ++i){
        int tmp1, tmp2;
        scanf("%d %d", &tmp1, &tmp2);
        --tmp1, --tmp2;
        ask[tmp1].push_back(make_pair(tmp2, i));

    }

    int pointer = 0;

    for(int i = 0; i < n; ++i){
        while (pointer < n && try_to_add(ar[pointer])){
            v[ar[pointer].first] += 1;
            h[ar[pointer].second] += 1;
            ++pointer;
        }

        for(size_t j = 0; j < ask[i].size(); ++j)
            if (ask[i][j].first > pointer - 1)
                res[ask[i][j].second] = make_pair(i + 1, pointer + 1);
            else
                res[ask[i][j].second] = make_pair(0, 0);

        v[ar[i].first] -= 1;
        h[ar[i].second] -= 1;

        if (v[ar[i].first] == 0)
            v.erase(ar[i].first);

        if (h[ar[i].second] == 0)
            h.erase(ar[i].second);
    }

    for(int i = 0; i < k; ++i)
        printf("%d %d\n", res[i].first, res[i].second);

    return 0;
}
