#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 16;

//int c[MAXN][MAXN];


int n, k;
int ar[MAXN];
int sub[MAXN];

/*void init_precalc(){
    for(int i = 0; i < MAXN; ++i)
        for(int j = 0; j < MAXN; ++j)
            c[i][j] = 0;

    for(int i = 0; i <= n; ++i)
        c[i][0] = 1;

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j)
            c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
}*/

inline bool check(const int cnt, const int max_ans){
    int din[MAXN];
    for(int i = 0; i < cnt; ++i){
        din[i] = 1;
        for(int j = 0; j < i; ++j)
            if (ar[i] > ar[j] && din[i] < din[j] + 1)
                din[i] = din[j] + 1;

        if (din[i] > max_ans)
            return false;
    }

    return true;
}

int fact(const int x){
    int res = 1;
    for(int i = 2; i <= x; ++i)
        res *= i;

    return res;
}




int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

    //init_precalc();

    scanf("%d", &n);
    scanf("%d", &k);

    for(int i = 0; i < k; ++i)
        scanf("%d", &sub[i]);

    sort(&sub[0], &sub[k]);

    for(int i = 0; i < n; ++i)
        ar[i] = i + 1;

    int tmp = fact(n);

    int res = 0;

    for(int i = 0; i < tmp; ++i){
        int pointer = 0;
        for(int j = 0; j < n; ++j)
            if (pointer < k && sub[pointer] == ar[j])
                ++pointer;

        if (pointer == k && check(n, k))
            ++res;

        next_permutation(&ar[0], &ar[n]);
    }

    printf("%d", res);

    return 0;
}
