#include <iostream>
#include <memory.h>
#include <stdio.h>
#include <vector>

long long Ans = 0LL;
std :: vector < std :: vector < int > > G[2];
std :: vector < std :: vector < int > > Pair;
std :: vector < int > Temp;

void DFS1(int v);
void DFS2(int v);

int main(void)
{
    //freopen("virus.in", "r", stdin);
    //freopen("virus.out", "w", stdout);
    int n = int();
    std :: cin >> n;
    int root[2] = {};
    G[0].resize(n);
    G[1].resize(n);
    Temp.reserve(n);
    Pair.resize(n);

    for (int i = 0; i < 2; ++i)
    {
        for (int v = 0; v < n; ++v)
        {
            int u = int();
            std :: cin >> u;
            if (u--)
                G[i][u].push_back(v);
            else
                root[i] = v;
        }
    }

    DFS1(root[0]);
    DFS2(root[1]);
    std :: cout << Ans;
    return 0;
}

void DFS1(int v)
{
    Pair[v] = Temp;
    Temp.push_back(v);
    for (int i = 0; i < G[0][v].size(); ++i)
        DFS1(G[0][v][i]);
    Temp.pop_back();
}

void DFS2(int v)
{
    bool *used = new bool[G[0].size()];
    memset(used, 0, G[0].size());
    for (int i = 0; i < Pair[v].size(); ++i)
        used[Pair[v][i]] = true;
    for (int i = 0; i < Temp.size(); ++i)
        if (used[Temp[i]])
            ++Ans;
    delete [] used;
    Temp.push_back(v);
    for (int i = 0; i < G[1][v].size(); ++i)
        DFS2(G[1][v][i]);
    Temp.pop_back();
}
