#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <utility>
#include <vector>

#define x first
#define y second

int main(void)
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n = int();
    std :: cin >> n;
    std :: vector < std :: pair < int, int > > arr(n);
    std :: vector < int > buf[3];
    bool ok = true;

    for (int i = 0; i < n; ++i)
    {
        std :: cin >> arr[i].x >> arr[i].y;

        if (i)
        {
            int p = 0;
            if (arr[i] == arr[i - 1])
                p = 3;
            else if (arr[i].x == arr[i - 1].x)
                p = 1;
            else if (arr[i].y == arr[i - 1].y)
                p = 2;

            if (p == 3)
            {
                ok = false;
                continue;
            }

            if (!p)
                buf[0].push_back(p), buf[1].push_back(i - 1), buf[2].push_back(i - 1);
            else if (buf[0].empty())
                buf[0].push_back(p), buf[1].push_back(i - 1), buf[2].push_back(i - 1);
            else if (buf[0].back() == p && ok)
                buf[2].back()++;
            else
                buf[0].push_back(p), buf[1].push_back(i - 1), buf[2].push_back(i - 1);
            ok = true;
        }
    }

    int k = int();
    std :: cin >> k;

    for (int i = 0; i < k; ++i)
    {
        int a = int(), b = int();
        std :: cin >> a >> b;
        int p = std :: lower_bound(buf[2].begin(), buf[2].end(), a - 1) - buf[2].begin();
        int q = std :: upper_bound(buf[1].begin(), buf[1].end(), b - 2) - buf[1].begin();

        if (p == q)
        {
            std :: cout << 0 << ' ' << 0 << "\n";
            continue;
        }

        if (p + 1 == q)
        {
            if (!buf[0][p])
                std :: cout << buf[1][p] + 1 << ' ' << buf[2][p] + 2 << "\n";
            else
                std :: cout << 0 << ' ' << 0 << "\n";
            continue;
        }

        if (!buf[0][p])
        {
            std :: cout << buf[1][p] + 1 << ' ' << buf[2][p] + 2 << "\n";
            continue;
        }

        if (!buf[0][p + 1])
        {
            std :: cout << buf[1][p + 1] + 1 << ' ' << buf[2][p + 1] + 2 << "\n";
            continue;
        }

        if (buf[0][p] != buf[0][p + 1])
            std :: cout << buf[2][p] + 1 << ' ' << buf[1][p + 1] + 2 << "\n";
        else
            std :: cout << 0 << ' ' << 0 << std :: endl;
    }

    return 0;
}
