#include <algorithm>
#include <iostream>
#include <stack>
#include <stdio.h>
#include <utility>
#include <vector>

int n = int();
int k = int(), m = 0;
int a[64] = {};
int b[64] = {};
int c[64] = {};
int d[64] = {};
int p[64] = {1};

int Gen(int x, int i)
{
    if (x - 1 > 0)
    {
        int y = x - 1;
        p[y] = 1;
        for (int j = 0; j < y; ++j)
            if (c[j] < c[y])
                p[y] = std :: max(p[y], p[j] + 1);
    }

    if (x == n)
    {
        int len = 0;
        for (int j = 0; j < n; ++j)
            len = std :: max(len, p[j]);
        return (len == k);
    }

    int ans = 0;

    if (i < k)
    {
        c[x] = a[i];
        ans += Gen(x + 1, i + 1);
    }

    for (int j = 0; j < m; ++j)
    {
        if (!d[b[j]])
        {
            d[b[j]] = 1;
            c[x] = b[j];
            ans += Gen(x + 1, i);
            d[b[j]] = 0;
        }
    }

    return ans;
}

int main(void)
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
    std :: cin >> n >> k;
    bool used[64] = {};

    for (int i = 0; i < k; ++i)
    {
        std :: cin >> a[i];
        used[--a[i]] = true;
    }

    for (int i = 0; i < n; ++i)
        if (!used[i])
            b[m++] = i;
    std :: cout << Gen(0, 0);
    return 0;
}
