#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

long long r, u;
int n;
long long dp[2001];

long long rec(int v)
{
	if (dp[v] >= 0)
	{
		return dp[v];
	}
	long long cur = 1e9;
	for (int i = 1; i <= v / 2; i++)
	{
		if (i == v / 2 && v % 2 == 0)
		{
			cur = min(cur, u + rec(i));
			continue;
		}
		cur = min(cur, max(u + rec(i), r + rec(v - 2 * i)));
	}
	return dp[v] = cur;
}

long long rec2(int v)
{
	if (v <= 2000)
	{
		return dp[v];
	}
	long long r2 = rec2(v / 2);
	if (v % 2 == 0)
	{
		return r2 + u;
	}
	else
	{
		return max(r, r2 + u);
	}
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> n >> r >> u;
	memset(dp, -1, sizeof(dp));
	dp[0] = 0;
	dp[1] = 0;
	for (int i = 2; i <= 2000; i++)
	{
		rec(i);
	}
	if (n > 2000)
	{
		cout << rec2(n) << endl;
	}
	else
	{
		cout << dp[n] << endl;
	}
	return 0;
}