#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const long long inf = 1000000000 * (long long)10000000;

long long r, u;
int n;
long long dp[2001];

long long rec2(int v)
{
	if (v <= 2000)
	{
		return dp[v];
	}
	long long r2 = rec2(v / 2);
	if (v % 2 == 0)
	{
		return r2 + u;
	}
	else
	{
		return max(r, r2 + u);
	}
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> n >> r >> u;
	memset(dp, -1, sizeof(dp));
	dp[0] = 0;
	dp[1] = 0;
	for (int i = 2; i <= 2000; i++)
	{
		long long res = inf;
		for (int j = 1; j < i / 2; j++)
		{
			res = min(res, max(dp[j] + u, dp[i - j * 2] + r));
		}
		if (i % 2)
		{
			res = min(res, max(dp[i / 2] + u, r));
		}
		else
		{
			res = min(res, dp[i / 2] + u);
		}
		dp[i] = res;
	}
	if (n > 2000)
	{
		cout << rec2(n) << endl;
	}
	else
	{
		cout << dp[n] << endl;
	}
	return 0;
}