#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

const int inf = '*' - '0';

int n, m;
int ar[1010][110];
char s[110];

bool nine(int x, int y)
{
	for (int i = y; i < m; i++)
	{
		if (ar[x][i] != 9)
		{
			return false;
		}
	}
	return true;
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	scanf("%d%d\n", &n, &m);
	for (int i = 0; i < n; i++)
	{
		scanf("%s", &s);
		for (int j = 0; j < m; j++)
		{
			ar[i][j] = s[j] - '0';
		}
	}
	for (int i = 0; i < n - 1; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if ((ar[i][j]  + 1) % 10 == ar[i + 1][j])
			{
				for (int k = j + 1; k < m; k++)
				{
					ar[i][k] = 9;
					ar[i + 1][k] = 0;
				}
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		if (ar[i][m - 1] != inf)
		{
			int t = ar[i][m - 1];
			for (int j = i + 1; j < n; j++)
			{
				t = (t + 1) % 10;
				ar[j][m - 1] = t;
			}
			t = ar[i][m - 1];
			for (int j = i - 1; j >= 0; j--)
			{
				t = (t - 1 + 10) % 10;
				ar[j][m - 1] = t;
			}
			break;
		}
	}
	for (int j = m - 2; j >= 0; j--)
	{
		for (int i = 0; i < n; i++)
		{
			if (ar[i][j] != inf)
			{
				int t = ar[i][j];
				for (int k = i + 1; k < n; k++)
				{
					if (nine(k - 1, j + 1))
					{
						t = (t + 1) % 10;
					}
					ar[k][j] = t;
				}
				t = ar[i][j];
				for (int k = i - 1; k >= 0; k--)
				{
					if (nine(k, j + 1))
					{
						t = (t - 1 + 10) % 10;
					}
					ar[k][j] = t;
				}
			}
		}
	}
	for (int i = 0; i < m; i++)
	{
		printf("%d", ar[0][i]);
	}
	return 0;
}