/*
 * c.cpp
 *
 *  Created on: 12.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

#define INF __INT_MAX__

int d[1000001];

int findj(int n, int val) {
	int jmin = 0, jmax = n, j;
	while (jmin + 1 < jmax) {
		j = (jmin + jmax) / 2;
		if (d[n - 2 * j] - d[j] < val)
			jmax = j;
		else
			jmin = j;
	}
	return jmin;
}

int main() {
#ifndef LOCAL_BUILD
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
#endif
	int n, r, u;
	cin >> n >> r >> u;
	d[1] = 0;
	//int prev = 0, cnt = 1;
	for (int i = 2; i <= n; ++i) {
		int rmin = INF;
		if (i < n)
			rmin = u + d[(i + 1) / 2];
		int j = findj(i, u - r);
		rmin = min(rmin, max(u + d[j], r + d[i - 2 * j]));
		/*
		 for (int j = 1; j <= (i + 1) / 2; ++j) {
		 int o = i - j * 2, c;
		 if (o < 0 && !q)
		 continue;
		 if (o > 0)
		 c = max(u + d[j][1], r + d[o][1]);
		 else
		 c = u + d[j][1];
		 rmin = min(rmin, c);
		 if (i == n && q == 1)
		 cout << d[o][1] - d[j][1] << endl;
		 }
		 */
		d[i] = rmin;
	}
	/*
	 if (d[i][1] == prev)
	 ++cnt;
	 else {
	 cout << prev << " x" << cnt << endl;
	 cnt = 1;
	 prev = d[i][1];
	 }
	 */
	cout << d[n];
}
