/*
 * a.cpp
 *
 *  Created on: 14.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <iostream>

#define INF __INT_MAX__

using namespace std;

int a[100001], b[100001], nxa[100001], nxb[100001];

inline char check(int x, int y) {
	return a[x] != a[y] && b[x] != b[y];
}

int main() {
#ifndef LOCAL_BUILD
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	int preva = INF, prevb = INF, cura = 0, curb = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		if (a[i] != preva) {
			for (; cura < i; ++cura)
				nxa[cura] = i;
			preva = a[i];
		}
		if (b[i] != prevb) {
			for (; curb < i; ++curb)
				nxb[curb] = i;
			prevb = b[i];
		}
	}
	int k, l, r;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		cin >> l >> r;
		--l;
		--r;
		if (nxa[l] > r || nxb[l] > r) {
			cout << "0 0" << endl;
			continue;
		}
		if (check(l, nxa[l]))
			cout << l + 1 << ' ' << nxa[l] + 1 << endl;
		else if (check(l, nxb[l]))
			cout << l + 1 << ' ' << nxb[l] + 1 << endl;
		else
			cout << nxb[l] + 1 << ' ' << nxa[l] + 1 << endl;
	}
}
