/*
 * c.cpp
 *
 *  Created on: 14.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <iostream>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <queue>

#define INF __INT_MAX__

using namespace std;

char used[31][31], used2[31 * 31];
int n, m, x, y;
int vxl = 0, vyl = 0;
int xmin = 0, xmax, ymin = 0, ymax;

void findnear(int &_x, int &_y) {
	queue <int> o;
	o.push(x * m + y);
	memset(used2, 0, sizeof(used2));
	while (!o.empty()) {
		int q = o.front();
		o.pop();
		if (used2[q])
			continue;
		used2[q] = 1;
		int cx = q / m, cy = q % m;
		if (cx < 0 || cx >= n || cy < 0 || cy >= m)
			continue;
		if (xmin <= cx - vxl && xmax > cx - vxl &&
				ymin <= cy - vyl && ymax > cy - vyl &&
				!used[cx - vxl][cy - vyl]) {
			_x = cx;
			_y = cy;
			return;
		}
		o.push((cx + 1) * m + cy + 1);
		o.push((cx + 1) * m + cy - 1);
		o.push((cx + 1) * m + cy);
		o.push((cx - 1) * m + cy + 1);
		o.push((cx - 1) * m + cy - 1);
		o.push((cx - 1) * m + cy);
		o.push((cx) * m + cy + 1);
		o.push((cx) * m + cy - 1);
	}
}

int main() {
	cin >> n >> m >> x >> y;
	--x;
	--y;
	xmax = n;
	ymax = m;
	memset(used, 0, sizeof(used));
	while (1) {
		 int dx = 0, dy = 0;
		 int tx, ty;
		 findnear(tx, ty);
		 if (x < tx)
			 dx = 1;
		 else if (x > tx)
			 dx = -1;
		 else
			 dx = 0;
		 if (y < ty)
			 dy = 1;
		 else if (y > ty)
			 dy = -1;
		 else
			 dy = 0;
		 x += dx;
		 y += dy;
		 if (x == tx && y == ty)
			 cout << dx << ' ' << dy << ' ' << 1;
		 else
			 cout << dx << ' ' << dy << ' ' << 0;
		 cout.flush();
		 int q;
		 cin >> q >> dx >> dy;
		 if (q)
			 return 0;
		 vxl += dx;
		 vyl += dy;
		 if (vxl > 0)
			 xmax = min(xmax, n - vxl);
		 else
			 xmin = max(xmin, -vxl);
		 if (vyl > 0)
			 ymax = min(ymax, m - vyl);
		 else
			 ymin = max(ymin, -vyl);
	}
}
