/*
 * d.cpp
 *
 *  Created on: 14.04.2012
 *      Author: roi
 */

#include <stdio.h>
#include <iostream>
#include <vector>
#include <memory.h>
#include <algorithm>

#define INF __INT_MAX__

using namespace std;

int a[15], p[15], d[15], n, k, b[15];

inline char calc_check() {
	fill(d, d + n, INF);
	d[0] = -INF;
	for (int i = 0; i < n; ++i) {
		int c = lower_bound(d, d + n, p[i]) - d;
		d[c] = p[i];
		if (c > k)
			return 0;
	}
	return 1;
}

inline char a_check() {
	int cur = 0;
	for (int i = 0; i < n; ++i)
		if (b[p[i]]) {
			if (p[i] == a[cur])
				++cur;
			else
				return 0;
		}
	return 1;
}

int main() {
#ifndef LOCAL_BUILD
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
#endif
	cin >> n >> k;
	memset(b, 0, sizeof(b));
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		--a[i];
		b[a[i]] = 1;
	}
	for (int i = 0; i < n; ++i)
		p[i] = i;
	int cnt = 1;
	for (int i = 2; i <= n; ++i)
		cnt *= i;
	int res = 0;
	for (int i = 0; i < cnt; ++i) {
		res += (a_check() && calc_check());
		next_permutation(p, p + n);
	}
	cout << res;
}
