#include<cstdio>
#include<fstream>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<iomanip>
#include<string>
#include<vector>
using namespace std;
vector<int> beg(100041, -1);
pair<int, int> mas[100041];
vector<int> color(100041, 0);
int a1[2041][2041], n, ans;

void dfs(int x)
{
	int j;
	for(j = 0; j<n; j++)
		if(color[j] == 1) {a1[j][x] = j+1; a1[x][j] = j+1;} 
	color[x] = 1;
	j = beg[x];
	while(j != -1)
		{
			dfs(mas[j].first);
			j = mas[j].second;
		}
	color[x] = 2;
}

void dfs2(int x)
{
	int j;
	for(j = 0; j<n; j++)
		if(color[j] == 1) {if(a1[x][j] == j+1) ans++;} 
	color[x] = 1;
	j = beg[x];
	while(j != -1)
		{
			dfs2(mas[j].first);
			j = mas[j].second;
		}
	color[x] = 2;
}

int main()
{
	ifstream fin("virus.in");
	ofstream fout("virus.out");

	int i, x, pos, j, boss;
	fin >> n;

	pos = 0;

	for(i = 0; i<n; i++)
	{
		fin >> x;
		x--;
		if(x == -1) boss = i;
		else
		{
			j = beg[x];
			if(j == -1)
			{
				mas[pos].first = i;
				mas[pos].second = -1;
				beg[x] = pos;
				pos++;
			}
			else
			{
				while(mas[j].second != -1)
					j = mas[j].second;
				mas[j].second = pos;
				mas[pos].first = i;
				mas[pos].second = -1;
				pos++;
			}
		}
	}

	dfs(boss);

	/*for(i = 0; i<n; i++){
		for(j = 0; j<n; j++)
			fout << a1[i][j] << " ";
			fout << endl;}
*/
	pos = 0;

	for(i = 0; i<n; i++)
		beg[i] = -1;

	for(i = 0; i<n; i++)
	{
		color[i] = 0;
		fin >> x;
		x--;
		if(x == -1) boss = i;
		else
		{
			j = beg[x];
			if(j == -1)
			{
				mas[pos].first = i;
				mas[pos].second = -1;
				beg[x] = pos;
				pos++;
			}
			else
			{
				while(mas[j].second != -1)
					j = mas[j].second;
				mas[j].second = pos;
				mas[pos].first = i;
				mas[pos].second = -1;
				pos++;
			}
		}
	}

	ans = 0;

	dfs2(boss);

	fout << ans;

	fin.close();
	fout.close();
	return 0;
}