#include<fstream>
#include<vector>

using namespace std;

ifstream cin("password.in");
ofstream cout("password.out");

int ToInt(char c)
{
    return (c - '0');
}

void rev(vector<int> &V)
{
    for (int i = 0; i < V.size() / 2; i++)
    {
        swap(V[i], V[V.size() - i - 1]);
    }
}

void get(vector<int> &X, int x)
{
    if (x == 0)
    {
        X.push_back(0);
        return;
    }

    while(x > 0)
    {
        X.push_back(x % 10);
        x /= 10;
    }
    rev(X);
}

int is_part(int *A, int n, int *B, int m, int *Sums, bool *AreEqualEnd, int len)
{
    vector<int> Th;
    int th;
    for (int i = 0; i <= n - len; i++)
    {
        th = Sums[i + len] - Sums[i];
        get(Th, th);
        //OK
        bool fl = 1;
        for (int j = 0; j < Th.size(); j++)
        {
            fl &= (Th[j] == B[i + j]);
        }
        //OK
        if (fl && AreEqualEnd[m - i - Th.size()])
        {
            return i;
        }
        if (i >= m || A[i] != B[i])
        {
            return -1;
        }
        Th.resize(0);
    }
    return -1;
}

int main()
{
    string S1, S2;
    cin >> S1 >> S2;
    int n = S1.size(), m = S2.size();
    int A[n], B[m];
    //  m <= n

    for (int i = 0; i < n; i++)
    {
        A[i] = ToInt(S1[i]);
    }
    for (int i = 0; i < m; i++)
    {
        B[i] = ToInt(S2[i]);
    }
    int Sums[n + 1];
    Sums[0] = 0;
    for (int i = 1; i <= n; i++)
    {
        Sums[i] = Sums[i - 1] + A[i - 1];
    }
    bool AreEqualEnd[m + 1];
    int x;
    AreEqualEnd[0] = 1;
    for (x = 1; x <= m && A[m - x] == B[m - x]; x++)
    {
        AreEqualEnd[x] = 1;
    }
    for (; x <= m; x++)
    {
        AreEqualEnd[x] = 0;
    }
    int res;
    for (int i = max(n - m, 1); i <= n - m + 10; i++)
    {
        res = is_part(A, n, B, m, Sums, AreEqualEnd, i);
        if (res != -1)
        {
            cout << res + 1 << " " << res + i << endl;
            return 0;
        }
    }


}
