#include<fstream>
#include<stack>
#include<vector>

using namespace std;

ifstream cin("virus.in");
ofstream cout("virus.out");


int main()
{
    int n;
    cin >> n;
    vector<vector<int> > G1(n), G2(n);
    int x;
    int root1, root2;
    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x == 0)
        {
            root1 = i - 1;
        }
        else
        {
            G1[x - 1].push_back(i);
        }
    }

    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x == 0)
        {
            root2 = i - 1;
        }
        else
        {
            G2[x - 1].push_back(i);
        }
    }

    int A[n][n], B[n][n];
    stack<int> S;
    int th;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            A[i][j] = 0;
            B[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++)
    {
        S.push(i);
        while(!S.empty())
        {
            th = S.top();
            S.pop();
            A[i][th] = 1;
            for (int j = 0; j < G1[th].size(); j++)
            {
                S.push(G1[th][j]);
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        S.push(i);
        while(!S.empty())
        {
            th = S.top();
            S.pop();
            B[i][th] = 1;
            for (int j = 0; j < G2[th].size(); j++)
            {
                S.push(G2[th][j]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            ans += (A[i][j] && B[i][j]);
        }
    }
    ans -= n;
    cout << ans << endl;

}
