#include<fstream>

using namespace std;

const int INF = 1e+9;

ifstream cin("apricot.in");
ofstream cout("apricot.out");


const int max_size = 2048;

struct Tree
{
    int A[10000];
    int SIZE;
    Tree()
    {
        SIZE = 0;
        for (int i = 0; i < 10000; i++)
        {
            A[i] = INF;
        }
    }
    void change(int i, int x)
    {
        i += max_size - 1;
        A[i] = x;
        while (i > 0)
        {
            i--;
            i /= 2;
            A[i] = min(A[2 * i + 1], A[2 * i + 2]);
        }
        A[0] = min(A[1], A[2]);
    }
    int srch(int l, int r)
    {
        if (r == l)
        {
            return A[r];
        }
        if (r == l + 1)
        {
            return min(A[l], A[r]);
        }
        int ans = INF;
        if (r % 2 == 1)
        {
            ans = min(ans, A[r]);
            r--;
        }
        if (l % 2 == 0)
        {
            ans = min(ans, A[l]);
            l++;
        }
        return min(ans, srch(r / 2 - 1, l / 2));

    }
    int get(int l, int r)
    {
        if (l > r)
        {
            return INF;
        }
        l += max_size - 1;
        r += max_size - 1;
        return srch(l, r);
    }

};



int main()
{
    Tree T;
    int n, r, u;
    cin >> n >> r >> u;
    int D[n + 1];// ,    ,   

    for (int i = 0; i < n - 1; i++)
    {
        D[i] = INF;
    }
     D[n] = 0;
    D[n - 1] = 0;

    for (int i = 0; i <= n; i++)
    {
        T.change(i, D[i]);
    }

    int mn;

    for (int i = n - 2; i >= 0; i--)
    {
        for (int x = 0; x <= n - i; x++)//   
        {
            if (2 * x - n + i >=  max(0, 2 * x - (n - i)) && 2 * x - n + i <= min(i, x))
            {
                D[i] = min(D[i], u + D[n - x]);
            }
            else
            {
                mn = T.get(i + 2 * x - min(i, x), i + 2 * x - max(0, 2 * x - (n - i)));
                D[i] = min(D[i], max(r + mn, u + D[n - x]));
            }
        }
        T.change(i, D[i]);
    }
    cout << D[0] << endl;
}
