#include<fstream>

using namespace std;

ifstream cin("mosaic.in");
ofstream cout("mosaic.out");

int part_size;
int num_parts;

struct Pair
{
    int x, y;
};

bool AreGood(Pair A, Pair B)
{
    return (A.x == B.x || A.y == B.y);
}

istream & operator >> (istream & cin, Pair &P)
{
    cin >> P.x >> P.y;
}

ostream & operator << (ostream & cout, Pair &P)
{
    cout  << P.x << " " << P.y;
}

int D[320][320][320];
Pair ANS[320][320][320];

int main()
{
    int n;
    cin >> n;
    //part_size = sqrt(n);
    part_size = n;
    Pair A[n + part_size + 1];
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
    }
    for (int i = n; i <= n + part_size; i++)
    {
        A[i].x = -1;
        A[i].y = -1;
    }
    num_parts = (n + part_size - 1) / part_size;


    for (int i = 0; i < num_parts; i++)
    {
        for (int j = 0; j < part_size; j++)
        {
            for (int k = 0; k < part_size; k++)
            {
                ANS[i][j][k].x = 0;
                ANS[i][j][k].y = 0;
                if (!AreGood(A[j + part_size * i], A[k + part_size * i]))
                {
                    int kk = k;
                    while (kk < part_size)
                    {
                        ANS[i][j][kk].x = j + 1;
                        ANS[i][j][kk].y = k + 1;
                        kk++;
                    }
                }
            }
        }
    }



    int m;
    cin >> m;
    int l, r;
    for (int i = 0; i < m; i++)
    {
        cin >> l >> r;
        cout << ANS[0][l - 1][r - 1] << endl;
    }

}
