#include <iostream>
#include <cstdio>
#include <string>

#define INF 2000000000

using namespace std;

string in;
string out;
int dlen;

int st = 1, fn = 1;

int get_min_len(int s) {
	if (s > 11)
		return INF;
	if (s == 1) return 1;
	int res = 1;
	for (int i = 3; i <= s; i++) {
		res *= 10;
		res ++;
	}
	return res+1;
}

void input() {
	cin >> in >> out;
}

long long int_from_substr(string &s, int f, int len) {
	long long res = 0;
	for (int i = f; i < f+len; i++) {
		res *= 10;
		res += s[i] - '0';
	}
	return res;
}

long long sum_from_substr(string &s, int f, int len) {
	long long res = 0;
	for (int i = f; i < f+len; i++) {
		res += s[i] - '0';
	}
	return res;
}

int try_sum(int f, int minlen) {
	for (int len = minlen; len <= out.size()-f; len++) {
		int mlen = get_min_len(len);
		if (mlen > in.size()-f)
			break;
		if (out[f] == '0' && len > 1)
			continue;
		long long t = int_from_substr(out, f, len);
		if (t == sum_from_substr(in, f, len+dlen))
			return len+dlen;
	}
	return 0;
}

void solve() {
	if (in == out)
		return;
	dlen = in.size() - out.size();
	int f = 0, len = out.size();
	for (f = 0; f < len && in[f] == out[f]; f++);
	if (f == len)
		f--;
	for (int i = f; i>=0; i--) {
		int r = try_sum(i, f-i+1);
		if (r) {
			st = i+1;
			fn = st+r-1;
			return;
		}
	}
	int n = 0;
	int i = 2/n;
}

void output() {
	cout << st << " " << fn;
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	input();
	solve();
	output();

	return 0;
}