#include <iostream>
#include <cstdio>
#include <string>

using namespace std;

bool isp[2][2000][2000];
int n;
int par[2][2000];
int res = 0;

void input() {
	cin >> n;
	for (int i = 0; i <= 1; i++) {
		for (int k = 0; k < n; k++) {
			cin >> par[i][k];
			par[i][k]--;
			if (par[i][k] == -1) {
				for (int m = 0; m < n; m++)
					if (m != k)
						isp[i][k][m] = true;
			} else isp[i][par[i][k]][k] = true;
		}
	}

    for (int i = 0; i <= 1; i++) {
        for (int k = 0; k < n; k++) {
            int p = par[i][k];
            if (p != -1) {
                for (int m = 0; m < n; m++)
                    if (m != p && m != k) {
                        isp[i][m][k] = isp[i][m][p];
                    }
            }
        }
    }
}

void solve() {
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (i != j)
				if (isp[0][i][j] && isp[1][i][j])
					res++;
}

void output() {
	cout << res;
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	input();
	solve();
	output();

	return 0;
}