#include <iostream>
#include <cstdio>
#include <string>

using namespace std;

bool isp[2][2000][2000];
int par[2][2000];
int n, res;

void input() {
	cin >> n;
	for (int i = 0; i < 2; i++) 
		for (int k = 0; k < n; k++) {
			cin >> par[i][k]; par[i][k]--;
			int p = par[i][k];
			if (p == -1) {
				for (int j = 0; j < n; j++)
					if (j != k)
						isp[i][k][j] = true;
			} else isp[i][p][k] = true;
		}

	for (int i = 0; i < 2; i++)
		for (int k = 0; k < n; k++) {
			int p = par[i][k];
			if (p != -1) {
				for (int m = 0; m < k; m++)
					if (m != k && m != p) {
						isp[i][m][k] |= isp[i][m][p];
					}
			}
		}
}

void solve() {
	for (int i = 0; i < n; i++)
		for (int j = i; j < n; j++)
			if ((isp[0][i][j] && isp[1][i][j]) || (isp[0][j][i] && isp[1][j][i]))
				res++;
}

void output() {
	cout << res;
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	input();
	solve();
	output();

	return 0;
}