#include <iostream>
#include <cstdio>
#include <string>

using namespace std;

int cost[2][100000];
int par[2][100000];
int res = 0;
int n;

void input() {
	cin >> n;
	for (int c = 0; c < 2; c++)
		for (int i = 0; i< n; i++) {
			cin >> par[c][i]; par[c][i]--;
			if (par[c][i] == -1)
				cost[c][i] = 1;
		}
}

void get_cost(int c, int i) {
	int p = par[c][i];
	if (p == -1)
		return;
	if (!cost[c][p])
		get_cost(c, p);
	cost[c][i] = cost[c][p]+1;
}

void solve() {
	for (int c = 0; c < 2; c++)
		for (int i = 0; i < n; i++) {
			get_cost(c, i);
		}
}

void output() {
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (i != j)
				if (cost[0][i] < cost[0][j] && cost[1][i] < cost[1][j])
					res++;
	cout << res;
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	input();
	solve();
	output();

	return 0;
}