#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

#define SIZE 100003

vector < pair <int, int> > res;
int a[SIZE], b[SIZE];

int st[SIZE];

int n;

void input() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
	}
	for (int i = 0; i < n-1; i++) {
		st[i+1] = res.size();
		for (int j = i+1; j < n; j++) {
			if (a[i] != a[j] && b[i] != b[j]) {
				res.push_back(make_pair(i+1, j+1));
				break;
			}
		}
	}
}

void solve() {
	int k;
	cin >> k;
	for (int t = 0; t < k; t++) {
		int f, s;
		cin >> f >> s;
		int cur = st[f];
		if (cur < res.size() && res[cur].first >= f && res[cur].second <= s) {
			cout << res[cur].first << " " << res[cur].second << endl;
		} else
			cout << "0 0\n";
	}
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);

	input();
	solve();

	return 0;
}