#include <iostream>
#include <cstdio>

using namespace std;

#define SIZE 30

int n, m, x, y;

bool ppos[SIZE][SIZE];
bool used[SIZE][SIZE];

void input() {
	cin >> n >> m >> x >> y;
	x--;y--;
}

void com(int dx, int dy, int s) {
	cout << dx << " " << dy << " " << s << endl;
	cout.flush();
}

bool is_correct(int p, int q) {
	return p >= 0 && p < n && q >= 0 && q < m;
}

void solve() {
	memset(ppos, 0, sizeof(ppos));
	com(0, 0, 1);
	int s = 0, dx, dy;
	cin >> s >> dx >> dy;
	while (!s) {
		memset(used, 0, sizeof(used));
		int ex, ey;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) {
				int p = i + dx;
				int q = j + dy;
				if (is_correct(p, q)) {
					used[p][q] = true;
					ppos[p][q] = true;
					ex = p; ey = q;
				}
				if (!used[i][j]) {
					ppos[i][j] = false;
				}
			}
		int rx = 0, ry = 0;
		if (ex > x)
			rx = 1;
		else
		if (ex < x)
			rx = -1;

		if (ey > y)
			ry = 1;
		else if (ey < y)
			ry = -1;

		x+=rx; y+=ry;
		com(rx, ry, ppos[x][y]);
		cin >> s >> dx >> dy;
	}
}

int main() {
	input();
	solve();
	return 0;
}