#include <cstdio>
#include <iostream>

using namespace std;

const int maxn = 3000, INF = 100000000;
int dp[maxn][maxn];

int main() {
        freopen("apricot.in", "r", stdin);
        freopen("apricot.out", "w", stdout);

        int n, r, u;
        cin >> n >> r >> u;
        
        for (int i = 2; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                dp[i][j] = INF;
                for (int k = 1; i + j >= k * 2 && k < i; ++k) {
                        if (k * 2 >= i)
                                dp[i][j] = min(dp[i][j], dp[k][min(k, j + (i - k))] + u);
                        else dp[i][j] = min(dp[i][j], max(dp[k][min(k, j + (i - k))] + u, dp[i - k * 2][min(i - k * 2, j + k * 2)] + r));
                }
            }
        }
        cout << dp[n][0] << endl;
}
