#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <cstdlib>
 
#define mp make_pair
 
using namespace std;
 
#define vt int
//pair<pair<int, int>, int>
 
const int INF = 2000000000;
const int maxn = 200000 << 2;
vt rmq0[maxn], rmq1[maxn], rmq2[maxn], rmq3[maxn];
int oa[maxn], ob[maxn];
int n;

int a[4];
 
int minz(int a, int b, int minf) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (minf == 0) 
		return ((oa[a] < oa[b]) || (oa[a] == oa[b] && ob[a] < ob[b]) ? a : b);
	if (minf == 1) 
		return ((oa[a] > oa[b]) || (oa[a] == oa[b] && ob[a] > ob[b]) ? a : b);
	if (minf == 2) 
		return ((ob[a] < ob[b]) || (ob[a] == ob[b] && oa[a] < oa[b]) ? a : b);

		return ((ob[a] > ob[b]) || (ob[a] == ob[b] && oa[a] > oa[b]) ? a : b);	
}

void insert(vt rmq[], int i, vt w, int minf) {
    int id = 1, l = 1, r = n, m;
    while (l < r) {
        m = (l + r) >> 1;
        id <<= 1;
        if (i <= m)
            r = m;
        else l = m + 1, ++id;
    }
    rmq[id] = w;
    id >>= 1;
    while (id >= 1) {
        rmq[id] = minz(rmq[id << 1], rmq[(id << 1) | 1], minf);
        id >>= 1;
    }
}
 
void getmins(int i, int l, int r, int nl, int nr) {
    if (nr < l || r < nl) return;
    if (nl <= l && r <= nr) {
		a[0] = minz(a[0], rmq0[i], 0);
		a[1] = minz(a[1], rmq1[i], 1);
		a[2] = minz(a[2], rmq2[i], 2);
		a[3] = minz(a[3], rmq3[i], 3);
		//rmq[i];
		return;
	}
    int m = (l + r) >> 1;
	getmins(i << 1, l, m, nl, nr);
	getmins((i << 1) | 1, m + 1, r, nl, nr);
    //return minz(getmin(rmq, i << 1, l, m, nl, nr, minf), 
    //           getmin(rmq, (i << 1) | 1, m + 1, r, nl, nr, minf), minf);

}
 
int main() {
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
 
    cin >> n;
	//n = 100000;
    int aa, bb;
    for (int i = 1; i <= n; ++i) {
		//oa[i] = max(0, rand() % 1000000000);
		//ob[i] = max(0, rand() % 1000000000);
        scanf("%d%d", &oa[i], &ob[i]);
        insert(rmq0, i, i, 0);
        insert(rmq1, i, i, 1);
         
        insert(rmq2, i, i, 2);
        insert(rmq3, i, i, 3);
    }
    int m, l, r;
    cin >> m;
	//m = 100000;
    for (int i = 0; i < m; ++i) {
        scanf("%d%d", &l, &r);
		//l = rand() % n;
		//r = l + (rand() % (n - 1 - l));
        //--l, --r;
		bool good = 0;
		if (r - l <= 7) {
			for (int ah = l; ah < r; ++ah) {
				for (int bh = ah + 1; bh <= r; ++bh)
					if (oa[ah] != oa[bh] &&
                    	ob[ah] != ob[bh]) {
	                    good = 1;
	                    printf("%d %d\n", ah, bh);
	                    break;
	                }
				if (good) break;
			}
		} else {
			a[0] = a[1] = a[2] = a[3] = 0;
			getmins(1, 1, n, l, r);
        /*a[0] = getmin(rmq0, 1, 1, n, l, r, 0);
        a[1] = getmin(rmq1, 1, 1, n, l, r, 1);
        a[2] = getmin(rmq2, 1, 1, n, l, r, 2);
        a[3] = getmin(rmq3, 1, 1, n, l, r, 3);*/
        //swap(a[2].first.first, a[2].first.second);
        //swap(a[3].first.first, a[3].first.second);

        /*cout << "=======\n";
        for (int ah = 0; ah < 4; ++ah) {
            cout << a[ah].first.first << " " << a[ah].first.second << endl;
        }
        cout << "=======\n";*/
	        for (int ah = 0; ah < 4; ++ah) {
	            for (int bh = ah + 1; bh < 4; ++bh) 
	                if (oa[a[ah]] != oa[a[bh]] &&
	                    ob[a[ah]] != ob[a[bh]]) {
	                    good = 1;
	                    printf("%d %d\n", a[ah], a[bh]);
	                    break;
	                }
				if (good) break;
			}
		}
		
	    if (!good) {
	    	printf("0 0\n");
        }
        //cout << "END\n";
    }
}

