#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
 
#define mp make_pair
 
using namespace std;
 
#define vt int
#define vint unsigned int
 
const int INF = 2000000000;
const int maxn = 200000, magic = 117239;
vt rmq0[maxn], rmq1[maxn], rmq2[maxn], rmq3[maxn];
int oa[maxn], ob[maxn];
int n;
vector<int> nab[maxn];
bool ok[maxn];
int when[maxn], w[maxn];
vint st[maxn];
vector<vint> hash[maxn];
int rs[maxn];
 
inline int findlc(int i, int j) {
	int l = 0, r = min(nab[i].size(), nab[j].size()), mid;
	if (nab[i].size() == 0 && nab[j].size() == 0) return 2;
	//cout << i << " and " << j << ": ";
	while (l < r) {
		mid = (l + r) >> 1;
		/*if (mid >= min(nab[i].size(), nab[j].size())) {
			cout << "wow\n";
			return mid;
		}*/
		if (hash[i][mid] == hash[j][mid])
			l = mid + 1;
		else r = mid;
	}
	//cout << l << "\n";
	return l;
}

bool hs(const int& i, const int& j) {
	int v = findlc(i, j);
	if (v >= max(nab[i].size(), nab[j].size())) {
			//cout << i << ">=" << j << endl;
			return 0;
	}
	if (nab[i].size() <= v) return 1;
	if (nab[j].size() <= v) return 0;

	return nab[i][v] < nab[j][v];
}

int main() {
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
    int n, m, k, t;
    cin >> n >> m;

    for (int i = 1; i <= m; ++i) {
        scanf("%d", &k);
      	for (int j = 0; j < k; ++j) {
			scanf("%d", &t);
			nab[t].push_back(i);
			if (hash[t].size())
				hash[t].push_back(hash[t][hash[t].size() - 1] * magic + i);
			else hash[t].push_back(i);
		}
    }
	for (int i = 1; i <= n; ++i) rs[i] = i;

	sort(rs + 1, rs + n + 1, hs);

	/*cout << "sorted:\n";
	for (int i = 1; i <= n; ++i)
		cout << rs[i] << " ";
	cout << endl;*/
	int l, r, mid, lca = -1, froms = 0;
	vector<int> av;
	int moxf = 0;
	for (int i = 1; i <= n; ++i) {
		if (i == n)
			l = -2;
		else l = findlc(rs[i], rs[i + 1]);
		if (l != lca) {
			if (lca != -1) {
				if (nab[rs[i]].size() <= lca)
					av.push_back(-1);
				else
					av.push_back(nab[rs[i]][lca]);
				sort(av.begin(), av.end());
				/*for (int j = 0; j < av.size(); ++j)
					cout << av[j] << "! ";
				cout << endl;*/
					for (int j = froms; j <= i; ++j)
						if (nab[rs[j]].size() <= lca) {
							if (av[1] == -1)
								when[rs[j]] = 0;
							else when[rs[j]] = max(when[rs[j]], av[av.size() - 1]);
						} else {
							if (av[av.size() - 2] != -1)
								when[rs[j]] = max(when[rs[j]], min(av[av.size() - 2], nab[rs[j]][lca]));
							else when[rs[j]] = max(when[rs[j]], nab[rs[j]][lca]);
						}

			}
			av.clear();
			//cout << "they diff " << l << " so add ";

			if (nab[rs[i]].size() > l)
				av.push_back(nab[rs[i]][l]);
			else av.push_back(-1);
			//cout << nab[rs[i]].size() << endl;
			moxf = 0;
			froms = i;
			lca = l;
		}
	}
	/*for (int i = 1; i < n; ++i) {
		l = findlc(rs[i], rs[i + 1]);
		if (l != lca) {
			for (int j = froms; j <= i; ++j)
				when[j] = max(when[j], moxf);
			moxf = 0;
			froms = i;
			lca = l;
		}
		if (l >= max(nab[rs[i]].size(), nab[rs[i + 1]].size())) {
			when[rs[i]] = when[rs[i + 1]] = 0;
			++i;
		} else {
			//cout << rs[i] << " and " << rs[i + 1] << " diff at " << l << endl;
			int tmp = 1000000000;
			if (l < nab[rs[i]].size()) tmp = min(tmp, nab[rs[i]][l]);
			if (l < nab[rs[i + 1]].size()) tmp = min(tmp, nab[rs[i + 1]][l]);
			//int tmp = min(nab[rs[i]][l], nab[rs[i + 1]][l]);
			//cout << "so " << tmp << endl;
			when[rs[i]] = max(when[rs[i]], tmp);
			when[rs[i + 1]] = max(when[rs[i + 1]], tmp);
		}
	}*/
    for (int i = 1; i <= n; ++i)
        printf("%d ", when[i]);
}

