#include <cstdio>
#include <set>
#include <map>
using namespace std;
map<int, int> cls[2];
map<pair<int, int>, int> nb, num;
int sizeb= 0;
#define MAXN 100000
int n;
pair<int, int> ab[MAXN];
int r[MAXN], l[MAXN];


void del(pair<int, int> x){
	nb[x]--;
	if (nb[x] == 0) {
		nb.erase(x);
		num.erase(x);
	}
	cls[0][x.first]--;
	cls[1][x.second]--;
	sizeb--;
}

void add(pair<int, int> x, int n){
	num[x] = n;
	nb[x]++;
	cls[0][x.first]++;
	cls[1][x.second]++;
	sizeb++;
}

bool comp(pair<int, int> x, pair<int, int> y) {
	return x.first == y.first ||
			x.second == y.second;
}

void rem(pair<int, int> x, int k) {
	for (map<pair<int, int>, int>::iterator it = num.begin(); it != num.end(); it++) {
		if (!comp(it->first, x)) {
			l[k] = it->second;
			return;
		}
	}
}


bool block(pair<int, int> last) {
	if (nb.empty()) return true;
	if (cls[0][last.first] ==  sizeb || cls[1][last.second] == sizeb)
		return true;
	int i = 0;
	for (map<pair<int, int>, int>::iterator it = num.begin(); it != num.end() && i < 5; it++) {
			if (!comp(it->first, last)) {
				return false;
			}
	}
	return true;
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	int ri = 0;
	for (int i = 0; i < n; i++)
		scanf("%d%d", &ab[i].first, &ab[i].second);
	pair<int, int> last;
	for (int i = 0; i < n; i++){
		if (ri == i) {
			add(ab[ri], ri);
			last = ab[i];
		}
		while (ri < n && (block(last))){
			ri++;
			if (ri < n) {
				add(ab[ri], ri);
				last = ab[ri];
			}
		}
		r[i] = ri;
		if (ri == n) l[i] = -1;
		else rem(ab[ri], i);
		del(ab[i]);
	}
	int k; scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		int a, b; scanf("%d%d", &a, &b); a--; b--;
		if (r[a] <= b)
			printf("%d %d\n", r[a] + 1, l[a] + 1);
		else printf("0 0\n");
	}
	return 0;
}
