#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef unsigned long long ulong;
const ulong M = 167;

inline int dc(ulong t)
{
	int c = 1;
	while (t > 10)
	{
		c++;
		t /= 10;
	}
	return c;
}
inline bool stcheck(const string &s, int l, int r, ulong with)
{
	ulong t = 0;
	ulong mp = 1;
	for (int i = r; i >= l; i--)
	{
		t += (s[i] - '0') * mp;
		mp *= 10;
	}
	return t == with;
}
int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	string s1, s2;
	cin >> s1 >> s2;
	int s1l = s1.length(), s2l = s2.length();
	vector<ulong> v(s1l);
	v[0] = 1;
	for (int i = 1; i < s1l; i++)
		v[i] = v[i - 1] * M;
	vector<ulong> h(s1l);
	vector<ulong> sum(s1l);
	for (int i = 0; i < s1l; i++)
	{
		h[i] = s1[i] * v[i];
		sum[i] = s1[i] - '0';
		if (i)
		{
			h[i] += h[i - 1];
			sum[i] += sum[i - 1];
		}
	}
	vector<ulong> s2h(s2l);
	for (int i = 0; i < s2l; i++)
	{
		s2h[i] = s2[i] * v[i];
		if (i)
			s2h[i] += s2h[i - 1];
	}
	for (int i = 0; i < s1l; i++)
	{
		for (int j = i; j < s1l; j++)
		{
			ulong st = i == 0 ? sum[j] : sum[j] - sum[i - 1];
			int stc = dc(st);
			int s2i = i, s2j = i + stc - 1;
			if ((stc == (j - i) || (j == i && stc == 1)) && (s1l - j) == (s2l - s2j) && 
				h[i] == s2h[s2i] && (h[s1l - 1] - h[j]) == (s2h[s2l - 1] - s2h[s2j]) * v[j - s2j] && 
				stcheck(s2, s2i, s2j, st)) // add sum
			{
				cout << (i + 1) << " " << (j + 1);
				return 0;
			}
		}
	}
	return 0;
}