#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef unsigned long long ulong;
const ulong M = 167;

void p(vector<int> &tree, vector<pair<int, int>> &priority, int v, int &z)
{
	priority[v].first = z;
	int i = 0;
	for (auto it = tree.begin(); it != tree.end(); it++, i++)
	{
		if (*it == v)
		{
			z++;
			p(tree, priority, i, z);
			z++;
		}
	}
	priority[v].second = z;
}
int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	int n;
	cin >> n;
	vector<int> tree1(n), tree2(n);
	int v1, v2;
	for (int i = 0; i < n; i++)
	{
		cin >> tree1[i];
		tree1[i]--;
		if (tree1[i] < 0)
			v1 = i;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> tree2[i];
		tree2[i]--;
		if (tree2[i] < 0)
			v2 = i;
	}
	vector<pair<int, int>> p1(n), p2(n);
	int t1 = 0, t2 = 0;
	p(tree1, p1, v1, t1);
	p(tree2, p2, v2, t2);
	int c = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (i == j)
				continue;
			if (p1[i].first < p1[j].first && p1[i].second > p1[j].second && 
				p2[i].first < p2[j].first && p2[i].second > p2[j].second)
				c++;
		}
	}
	cout << c;
	return 0;
}