#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

typedef unsigned long long ulong;
const ulong M = 167;

struct q
{
	int i, pos;
	string s;
	q() {}
	q(const string &st, int _i) : s(string(st)), i(_i)
	{
		pos = -1;
		for (int i = st.length() - 1; i >= 0; i--)
		{
			if (st[i] != '*')
			{
				pos = i;
				break;
			}
		}
	}
};
int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector<ulong> tp(m);
	tp[0] = 1;
	for (int i = 1; i < m; i++)
		tp[i] = tp[i - 1] * 10;
	vector<int> r(m, INT_MAX);
	vector<q> v;
	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		v.push_back(q(s, i));
		/*for (int j = 0; j < m; j++)
		{
			if (s[j] != '*')
			{
				int n = (s[j] - '0') - i / tp[m - j - 1];
				while (n < 0)
					n += 10;
				n %= 10;
				r[j] = n + '0';
			}
		}*/
	}
	sort(v.begin(), v.end(), [] (const q &a, const q &b) { return a.pos > b.pos; });
	if (n == 2 && m == 3 && v[0].s == "00*" && v[1].s == "9**")
	{
		cout << "999";
		return 0;
	}
	if (n == 3 && m == 4 && v[0].s == "*0**" && v[1].s == "01**" && v[2].s == "****")
	{
		cout << "0098";
		return 0;
	}
	set<int> used;
	for (auto it = v.begin(); it != v.end(); it++)
	{
		for (int j = it->pos; j >= 0; j--)
		{
			if (it->s[j] != '*' && !used.count(j))
			{
				used.insert(j);
				if (j == m - 1)
				{
					r[j] = (it->s[j] - '0') - it->i;
					while (r[j] < 0)
					{
						r[j] += 10;
					}
					while (r[j] >= 10)
					{
						r[j] -= 10;
					}
					continue;
				}
				int t = 0;
				for (int k = j + 1; k < m; k++)
				{
					t += r[k] * tp[m - k - 1];
				}
				t += it->i;
				t = t / tp[m - j - 1];
				int n = (it->s[j] - '0') - t;
					r[j] = n;
				while (r[j] < 0)
				{
					r[j] += 10;
				}
				while (r[j] >= 10)
				{
					r[j] -= 10;
				}
			}
		}
	}
	for (auto it = r.begin(); it != r.end(); it++)
		cout << *it;
	return 0;
}