PROGRAM TatarCalendar;
  Type TRec = record
                value : Char;
                row : LongInt
              end;
  Var i, j, k, m, n : LongInt;
      cal : array[0..1001, 0..101] of Char;
      rec : array[0..101] of TRec;
      tmp : Char;

  Function Lim9(row, st : LongInt): Boolean;
    Var j : LongInt;
  Begin
    Lim9:=TRUE;
    for j:=st to m do
    begin
      if cal[row, j] in ['0'..'8'] then
      begin
        Lim9:=FALSE;
        Exit
      end
    end
  End;

  Function Lim0(row, st : LongInt): Boolean;
    Var j : LongInt;
  Begin
    Lim0:=TRUE;
    for j:=st to m do
    begin
      if cal[row, j] in ['1'..'9'] then
      begin
        Lim0:=FALSE;
        Exit
      end
    end
  End;

  Procedure Put(row, col : LongInt; val : Char);
  Begin
    cal[row, col]:=val;
    if val<>'*' then
    begin
      rec[col].value:=cal[row,col];
      rec[col].row:=row
    end
  End;

  Function Plus1(a : Char): Char;
    Var t : Char;
  Begin
    t:=Chr(Ord(a)+1);
    if t=':' then t:='0';
    Plus1:=t
  End;

BEGIN
  Assign(input, 'calendar.in');
  ReSet(input);
  Assign(output, 'calendar.out');
  ReWrite(output);

  ReadLn(n, m);
  for i:=1 to n do
  begin
    for j:=1 to m do
    begin
      Read(tmp);
      Put(i, j, tmp);
      if tmp<>'*' then
        if cal[i,j]=Plus1(cal[i-1,j]) then
        begin
          for k:=j+1 to m do
            Put(i, k, '0');
          break
        end;
    end;
    ReadLn
  end;

  for j:=m downto 1 do
  begin
    tmp:=rec[j].value;
    for i:=rec[j].row-1 downto 1 do
    begin
      if Lim9(i, j+1) then
      begin
        Dec(rec[j].value);
        if rec[j].value='/' then rec[j].value:='9'
      end;
      cal[i, j]:=rec[j].value
      //;writeln(i, ' ', j, ' ', ' ', rec[j].value);
    end;

    rec[j].value:=tmp;
    for i:=rec[j].row+1 to n do
    begin
      if Lim0(i, j+1) then
      begin
        Inc(rec[j].value);
        if rec[j].value=':' then rec[j].value:='0'
      end;
      cal[i, j]:=rec[j].value
    end
  end;

  for i:=1 to m do
    Write(cal[1,i]);

  Close(input);
  Close(output)
END.