PROGRAM Theatre;
{$MODE OBJFPC}
  Type TVect = array[-1..10000] of LongInt;
  Var m, n, i, j, k, ac : LongInt;
      actor : array[0..10001] of TVect;
      eq, empty : array[0..10001] of Boolean;
      res : array[0..10001] of LongInt;

  Operator + (a : TVect; b : Word) res : TVect;
    Var t : QWord;
  Begin
    res:=a;
    Inc(res[0]);
    res[res[0]]:=b;
    t:=res[-1]*8000;
    t:=(t+b) mod 2147483647;
    res[-1]:=t
  End;

  Operator = (a : TVect; b : TVect) res : Boolean;
    Var i : Word;
  Begin
    if a[-1]<>b[-1] then
    begin
      res:=FALSE;
      Exit
    end;

    if a[0]<>b[0] then
    begin
      res:=FALSE;
      Exit
    end;

    i:=1;
    while (i<=a[0]) AND (a[i]=b[i]) do Inc(i);
    res:=i>a[0]
  End;

BEGIN
  Assign(input, 'theatre.in');
  ReSet(input);
  Assign(output, 'theatre.out');
  ReWrite(output);

  ReadLn(n, m);
  for i:=1 to n do
    res[i]:=0;

  for i:=1 to m do
  begin
    Read(k);
    for j:=1 to k do
    begin
      Read(ac);
      if res[ac]=0 then
        actor[ac]:=actor[ac]+i
    end;

    for j:=1 to n-1 do
      if res[j]=0 then
        for k:=j+1 to n do
          if res[k]=0 then
            if actor[j]=actor[k] then
            begin
              eq[j]:=TRUE;
              eq[k]:=TRUE
            end;

    for j:=1 to n do
      if (NOT eq[j]) AND (res[j]=0) then
        res[j]:=i;

    eq:=empty
  end;

  for i:=1 to n-1 do
    Write(res[i], ' ');
  Write(res[n]);

  Close(input);
  Close(output)
END.