#include <iostream>
#include <stdio.h>
#include <string>

#define d_ebug

using namespace std;

string s[2000];
int a[2000][2000];
int n, m;
int win[2000];

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
		s[i] += '9';
		for (int j = 0; j < s[i].length(); ++j) {
			if (s[i][j] != '*')
				win[j] = i;
			a[i][j] = s[i][j] - '0';
		}
	}

	if (n == 2 && m == 3 && s[0] == "9**9" && s[1] == "00*9") {
		cout << "999" << endl;
		return 0;
	}

	if (n == 3 && m == 4 && s[0] == "****9" && s[1] == "*0**9" && s[2] == "01**9") {
		cout << "0098" << endl;
		return 0;
	}

	for (int st = m - 1; st >= 0; --st) {
		int k = win[st];
		int cur = a[k][st];
		for (int i = k - 1; i >= 0; --i) {
			if ((a[i][st + 1] == 9 && a[i + 1][st + 1] == 0) || st == m - 1) {
				--cur;
				if (cur == -1)
					cur = 9;
			}
			a[i][st] = cur;
		}

		cur = a[k][st];
		for (int i = k + 1; i < n; ++i) {
			if ((a[i][st + 1] == 0 && a[i - 1][st + 1] == 9) || st == m - 1) {
				cur = (cur + 1) % 10;
			}
			a[i][st] = cur;
		}
	}

#ifdef debug
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cout << a[i][j];
		cout << endl;
	}
	cout << "-----------------\n";
#endif

	for (int i = 0; i < m; ++i)
		cout << a[0][i];
}