#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <cassert>

#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++)
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--)
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++)
#define all(a) (a).begin(), (a).end()
#define int64 long long

using namespace std;

const int INF = 1E9;
const int MAXN = 100500;

char c, s[2][MAXN];
int j, n[2], l, r[2], lastr;
int sum, csum[2];

int getnum(int a, int b) {
	int ans = 0;
	FORN(i, a, b)
		ans = ans * 10 + (s[1][i] - '0');
	return ans;
}

bool good() {
	if (lastr == r[1]) 
		return 1;
	return 0;
}

int main() {

	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	forn(i, 2) {
		n[i] = 0;
		c = getchar();
		while (c != '\n' && c != -1) {
			s[i][n[i]] = c;
			n[i]++;
			c = getchar();
		}
	}
/*
	j = 0;
	while (j < n[1] && s[0][j] == s[1][j]) j++;
	if (j == n[1]) j--;
*/
	j = n[1] - 1;

	sum = 0;
	FORN(i, j + 1, n[0] - 1)
		sum += (s[0][i] - '0');

	l = j;
	while (l >= 0) {
		sum += (s[0][l] - '0');

		r[0] = n[0] - 1;
		r[1] = min(n[1] - 1, r[1] + 6);
		csum[0] = sum;
		csum[1] = getnum(l, r[1]);
		lastr = n[1] - 1;

		//main part START
		while (l <= r[0] && l <= r[1]) {
			if (csum[0] == csum[1]) {
				if (good()) {
					cout << l + 1 << ' ' << r[0] + 1 << '\n';
					return 0;
				} else {

					if (s[0][r[0]] != s[1][lastr])
						break;
					csum[0] -= (s[0][r[0]] - '0');
					r[0]--;
					if (lastr == r[1]) {
						r[1]--;
						if (l <= r[1]) csum[1] = getnum(l, r[1]);
					}
					lastr--;

				}
			} else if (csum[0] < csum[1]) {
				r[1]--;
				if (l <= r[1]) csum[1] = getnum(l, r[1]);
			} else {
				if (s[0][r[0]] != s[1][lastr])
					break;

				csum[0] -= (s[0][r[0]] - '0');
				r[0]--;
				if (lastr == r[1]) {
					r[1]--;
					if (l <= r[1]) csum[1] = getnum(l, r[1]);
				}
				lastr--;
			}
		}
		//main part END

		l--;
	}

	cout << "1 1\n";

	return 0;
}
