#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <cassert>
 
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++)
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--)
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++)
#define FORD(i, n, k) for (int(i) = int(n); int(i) >= int(k); i--)
#define all(a) (a).begin(), (a).end()
#define int64 long long
 
using namespace std;
 
const int INF = 1E9;
const int MAXN = 2100;

int64 ans;
int n, root[2], t;
vector<vector<int> > w(MAXN), ww(MAXN);
bool cmp[MAXN][MAXN], used[MAXN];
bool cmp2[MAXN][MAXN], used2[MAXN];
 
void dfs1(int v) {
	if (used[v]) return;
	used[v] = 1;
	forn(i, w[v].size()) {
		cmp[v][w[v][i]] = 1;
		dfs1(w[v][i]);
		forn(j, n)
			cmp[v][j] |= cmp[w[v][i]][j];
	}
}

void dfs2(int v) {
	if (used2[v]) return;
	used2[v] = 1;
	forn(i, ww[v].size()) {
		cmp2[v][ww[v][i]] = 1;
		dfs2(ww[v][i]);
		forn(j, n)
			cmp2[v][j] |= cmp2[ww[v][i]][j];
	}
}

int main() {
 
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
 
	cin >> n;

	forn(i, n) {
		cin >> t;
		if (t == 0)
			root[0] = i;
		else
			w[t - 1].push_back(i);
	}
	forn(i, n) {
		cin >> t;
		if (t == 0)
			root[1] = i;
		else
			ww[t - 1].push_back(i);
	}

	dfs1(root[0]);
	dfs2(root[1]);

	forn(i, n)
		forn(j, n)
			ans += (cmp[i][j] && cmp2[i][j]);
	cout << ans;

    return 0;
}