
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <ctime>
 
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++) 
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--) 
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++) 
 
using namespace std;
 
typedef long long int64;
 
const int INF = 1E9;
const int MAXN = 100100;
 
int n, k, m, p, cur, ans[MAXN], place[MAXN], change[10 * MAXN];
int l, r, def[MAXN], sz[MAXN];
set<int> emptyset;
vector<set<int> > w(MAXN);
 
void init() {
    FORN(i, 1, n) {
        ans[i] = 0;
        w[0].insert(i);
        place[i] = 0;
    }
 
    forn(i, MAXN) def[i] = -1;
    l = 0;
    r = -1;
	cur = 1;
	sz[0] = n;
}
 
int main() {
 
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
 
    cin >> n >> k;
    if (n == 1) {
        cout << 1;
        return 0;
    }
 
    init();
 
    forn(i, k) {
        cin >> m;
        forn(j, m) {
            cin >> p;
            if (!(def[place[p]] == -1 && sz[place[p]] == 1)) {
                if (def[place[p]] == -1) {
                    def[place[p]] = cur++;                     
                    change[++r] = place[p];
                    change[++r] = def[place[p]];
                }
                w[place[p]].erase(p);
                w[def[place[p]]].insert(p);
				sz[place[p]]--;
				sz[def[place[p]]]++;
                place[p] = def[place[p]];
            }
        }
 
        while (l <= r) {
            if (sz[change[l]] == 1) {
                p = *w[change[l]].begin();
                ans[p] = i + 1;
            }
            def[change[l]] = -1;
            l++;
        }
    }
 
    FORN(i, 1, n)
        cout << ans[i] << ' ';
 
    return 0;
}
