#include <iostream>
#include <fstream>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 100 * 1000 + 10;
const int maxl = 8;

struct data{
    long long val;
    int s;
    data() {}
    data(long long val, int s): val(val), s(s) {}
};

int get_len(long long s) {
    int res = 1;
    while (s / 10 > 0) {
        s /= 10;
        ++res;
    }

    return res;
}

char s1[maxn], s2[maxn];
vector < data > p;
int n1, n2;
int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);

    gets(s1);
    scanf("\n");
    gets(s2);
    n1 = strlen(s1);
    n2 = strlen(s2);

    int posl = 0, posr = 0;

    for (int add = 1; add <= min(n1, n2); ++add)
        if (s1[add - 1] == s2[add - 1])
            posl = add;
        else
            break;

    for (int add = 1; add <= min(n1, n2); ++add)
        if (s1[n1 - add] == s2[n2 - add])
            posr = add;
        else
            break;

    for (int st = 0; st <= posl; ++st) {
        long long s = 0;
        for (int len = 1; len <= maxl && st + len - 1 < n2; ++len) {
            s = s * 10 + s2[st + len - 1] - '0';
            if (st + len - 1 >= n2 - posr - 1)
                p.push_back(data(s, get_len(s)));
        }
    }

    for (int i = 0; i < p.size(); ++i) {
        int l = 0, r = 0;
        long long s = s1[0] - '0';


        while (l < n1 && r < n1 && r >= l) {
            if (s == p[i].val && n2 - p[i].s == n1 - (r - l + 1)) {
                cout << l + 1 << " " << r + 1;
                return 0;
            }

            if (s > p[i].val) {
                s -= s1[l] - '0';
                ++l;
            } else if (r + 1 < n1) {
                ++r;
                s += s1[r] - '0';
            } else {
                s -= s1[l] - '0';
                ++l;
            }
        }
    }


    return 0;
}
