#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define ll long long

const ll inf = (ll)1000 * 1000 * 1000 * 1000 * 1000;
const int maxn = 1000 * 1000 + 10;

ll a[maxn];
int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    ll n, r, u;
    cin >> n >> r >> u;

    a[0] = 0;
    a[1] = 0;
    a[2] = u;
    for (int i = 3; i <= n; ++i) {
        a[i] = inf;

        for (int j = 1; j <= i / 2; ++j) {
            ll num = i / j;
            // in one of j piles:
            ll ans1;
            if (num % 2 == 0)
                ans1 = (ll)(num / 2 - 1) * r + u + a[j];
            else
                ans1 = (ll)(num / 2 - 1) * r + max(u, r) + a[j];

            // in left pile

            ll last = i - num * j;
            ll ans2 = 0;
            if (last > 0) {
                if (num % 2 == 0)
                    ans2 = (ll)(num / 2) * r + a[last];
                else
                    ans2 = (ll)(num / 2 + 1) * r + a[last];
            }
            a[i] = min(a[i], max(ans1, ans2));
        }

    /*    for (int j = i / 2; j < i; ++j) {
            int f = i - j;
            // in j
            ll ans1;
            if (f % 2 == 0)
                ans1 = r + a[j];
            else
                ans1 = r + a[j + 1];
            // in f
            ll ans2;
            if (j % 2 == 0)
                ans2 = r + a[f];
            else
                ans2 = r + a[f + 1];
            a[i] = min(a[i], max(ans1, ans2));
        }
    */
    }

    if (a[n] == inf)
        return -1;

    cout << a[n];

    return 0;
}
