#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
using namespace std;

const int maxn = 100 * 1000 + 10;

bool found[maxn], all_seen[maxn];
int f_num = 0, s_num = 0, n_seen = -1, n_found = -1;
int ans[maxn], now[maxn];
vector <int> a[maxn];
int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    int n, m;
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; ++i) {
        int k;
        scanf("%d", &k);
        for (int j = 0; j < k; ++j) {
            int tmp;
            scanf("%d", &tmp);
            a[i].push_back(tmp);
        }
        sort(a[i].begin(), a[i].end());
    }

    for (int i = 0; i < m; ++i) {

        int bad_num = 0, p = -1;
        for (int j = 0; j < a[i].size(); ++j)
            if (!found[a[i][j]]) {
                    ++bad_num;
                    p = a[i][j];
            }

        if (bad_num == 1) {
            ++f_num;
            if (!all_seen[p]) {
                all_seen[p] = true;
                ++s_num;
            }
            found[p] = true;
            ans[p] = i + 1;
        }

        for (int j = 0; j < i; ++j) {
            int l, r, d_num = -1;
            l = r = 0;
            bool one_diff = false;
            bool fail = false;

            while (l < a[j].size() && r < a[i].size()) {
                if (found[a[j][l]])
                    ++l;
                else if (found[a[i][r]])
                    ++r;
                else if (a[j][l] > a[i][r]) {
                    if (one_diff)
                        fail = true;
                    one_diff = true;
                    d_num = a[i][r];
                    ++r;
                } else if (a[j][l] < a[i][r]) {
                    if (one_diff)
                        fail = true;
                    one_diff = true;
                    d_num = a[j][l];
                    ++l;
                } else {
                    ++l;
                    ++r;
                }
            }

            for (int k = l; k < a[j].size(); ++k)
                if (!found[a[j][k]]) {
                    if (one_diff)
                        fail = true;
                    one_diff = true;
                    d_num = a[j][k];
                }

            for (int k = r; k < a[i].size(); ++k)
                if (!found[a[i][k]]) {
                    if (one_diff)
                        fail = true;
                    one_diff = true;
                    d_num = a[i][k];
                }

            if (!fail && one_diff) {
                found[d_num] = true;
                if (!all_seen[d_num]) {
                    all_seen[d_num] = true;
                    ++s_num;
                }
                ++f_num;
                ans[d_num] = i + 1;
            }
        }

        for (int j = 0; j < a[i].size(); ++j)
            if (!all_seen[a[i][j]]) {
                all_seen[a[i][j]] = true;
                ++s_num;
            }

        if (s_num == n - 1) {
             for (int j = 1; j <= n; ++j)
                if (!all_seen[j]) {
                    n_seen = j;
                    break;
                }
            all_seen[n_seen] = true;
            ++s_num;
            found[n_seen] = true;
            ans[n_seen] = i + 1;
            ++f_num;
        }

        if (f_num == n - 1) {
            for (int j = 1; j <= n; ++j)
                if (!found[j]) {
                    n_found = j;
                    break;
                }
            if (!all_seen[n_found]) {
                all_seen[n_found] = true;
                ++s_num;
            }
            ans[n_found] = i + 1;
            ++f_num;
            found[n_found] = true;
        }
    }

    for (int i = 1; i <= n; ++i)
        printf("%d ", ans[i]);

    return 0;
}
