program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  n, i, ans, j: integer;
  a1, a2: array[1..2000] of integer;
  a, b: array[1..2000, 1..2000] of boolean;
  vis: array[1..2000] of boolean;

procedure build1(v: integer);
var
  i: integer;
begin
  for i := 1 to n do
    if vis[i] then a[i][v] := true;

  for i := 1 to n do begin
    if a1[i] = v then begin
      vis[v] := true;
      build1(i);
      vis[v] := false;
    end;
  end;
end;

procedure build2(v: integer);
var
  i: integer;
begin
  for i := 1 to n do
    if vis[i] then b[i][v] := true;

  for i := 1 to n do begin
    if a2[i] = v then begin
      vis[v] := true;
      build2(i);
      vis[v] := false;
    end;
  end;
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');

  readln(n);
  for i := 1 to n do
    read(a1[i]);
  for i := 1 to n do
    read(a2[i]);

  for i := 1 to n do
    if a1[i] = 0 then
      build1(i);

  for i := 1 to n do
    if a2[i] = 0 then
      build2(i);

  ans := 0;
  for i := 1 to n do
    for j := 1 to n do
      if a[i][j] and b[i][j] then inc(ans);

   writeln(ans);

  close(input);
  close(output);
end.
