#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxn = 3000;
const int64 inf = 1000000000000000ll;

int64 n, u, r;
int64 d[maxn];

int main()
{
	freopen("apricot.in", "rt", stdin);
	freopen("apricot.out", "wt", stdout);
	scanf("%I64d %I64d %I64d", &n, &r, &u);
	d[0] = d[1] = 0;
	d[2] = u;
	for (int i = 3; i <= n; i++)
	{
		d[i] = inf;
		for (int j = 1; 2 * j <= i; j++)
		{
			int64 w = i - 2 * j;
			int64 cur;
			if (w > 0)
				cur = max(d[w] + r, d[j] + u);
			else
				cur = d[j] + u;
			d[i] = min(d[i], cur);
		}
	}
	printf("%I64d", d[n]);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
