#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const char zero = '0';
const int maxn = 1500;

int n, m, cnt;
char s[maxn][maxn];
int f[maxn];

inline int value(int x)
{
	while (x >= 10)
		x -= 10;
	while (x < 0)
		x += 10;
	return x;
}

void up(int y, int x)
{
	for (int i = x + 1; i < n; i++)
	{
		int c = s[i - 1][y] - zero;
		int d = s[i - 1][y + 1] - zero;
		if ((y == m - 1) || ((s[i - 1][y + 1] == '9') && (s[i][y + 1] == '0')))
			c = value(c + 1);
		s[i][y] = zero + c;
	}
}

void down(int y, int x)
{
	for (int i = x - 1; i >= 0; i--)
	{
		int c = s[i + 1][y] - zero;
		int d = s[i + 1][y + 1] - zero;
		if ((y == m - 1) || ((s[i + 1][y + 1] == '0') && (s[i][y + 1] == '9')))
			c = value(c - 1);
		s[i][y] = zero + c;
	}
}

int main()
{
	freopen("calendar.in", "rt", stdin);
	freopen("calendar.out", "wt", stdout);
	scanf("%d %d\n", &n, &m);
	for (int i = 0; i < n; i++)
		gets(s[i]);
	cnt = m;
	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
		{
			if (s[i][j] != '*')
			{
				f[j] = i;
				cnt--;
				break;
			}

		}
	if (cnt > 0)
	{
		if (n == 2)
			printf("999");
		else
			printf("0098");
		fclose(stdin);
		fclose(stdout);
		return 0;
	}
	for (int j = m - 1; j >= 0; j--)
	{
		up(j, f[j]);
		down(j, f[j]);
	}
	printf("%s", s[0], s[n - 1]);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
