#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxn = 300;

int n, m, mn;


bool pos[maxn][maxn];
int cnt[maxn];
int res[maxn];
bool f[maxn];

void calc()
{
	mn = 0;
	for (int i = 0; i < n; i++)
		cnt[i] = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
			if (pos[i][j])
				cnt[i]++;
		if ((((cnt[i] < cnt[mn])) || (cnt[mn] == 0)) && (cnt[i] > 0))
			mn = i;
	}
}

void put(int x)
{
	for (int i = 0; i < n; i++)
		pos[i][x] = false;
}

void mark(int s)
{

	for (int i = 0; i < n; i++)
	{
		if (f[i])
			for (int j = 0; j < n; j++)
				pos[i][j] &= f[j];
		else
			for (int j = 0; j < n; j++)
				pos[i][j] &= !f[j];
	}
	do
	{
		calc();
		if (cnt[mn] != 1)
			break;
		res[mn] = s;
		put(mn);
	} while (true);
}

int main()
{
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; i++)
	{
		res[i] = -1;
		for (int j = 0; j < n; j++)
			pos[i][j] = true;
	}
	for (int i = 0; i < m; i++)
	{
		int k;
		for (int j = 0; j < n; j++)
			f[j] = false;
		scanf("%d", &k);
		for (int j = 0; j < k; j++)
		{
			int v;
			scanf("%d", &v);
			v--;
			f[v] = true;
		}
		mark(i);
	}

	for (int i = 0; i < n; i++)
		printf("%d ", res[i] + 1);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
