#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxn1 = 300;
const int maxn = 200000;
const int maxs = 2 * maxn;


struct myset
{
	int cnt, step, clone, ins;
	bool used;
};

int n, m, mn;



bool pos[maxn1][maxn1];
int cnt[maxn1];
int res[maxn];
bool f[maxn1];
int p[maxn];
int sz;
myset s[maxs];
int a[maxn];

void calc()
{
	mn = 0;
	for (int i = 0; i < n; i++)
		cnt[i] = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
			if (pos[i][j])
				cnt[i]++;
		if ((((cnt[i] < cnt[mn])) || (cnt[mn] == 0)) && (cnt[i] > 0))
			mn = i;
	}
}

void put(int x)
{
	for (int i = 0; i < n; i++)
		pos[i][x] = false;
}

void mark(int s)
{

	for (int i = 0; i < n; i++)
	{
		if (f[i])
			for (int j = 0; j < n; j++)
				pos[i][j] &= f[j];
		else
			for (int j = 0; j < n; j++)
				pos[i][j] &= !f[j];
	}
	do
	{
		calc();
		if (cnt[mn] != 1)
			break;
		res[mn] = s;
		put(mn);
	} while (true);
}

void makeclone(int x, int st)
{
	s[x].clone = sz;
	s[x].step = st;
	s[x].used = true;
	s[sz].cnt = 0;
	s[sz].ins = 0;
	s[sz].used = false;
	s[sz].clone = -1;
	s[sz].step = st;
	sz++;
}

int main()
{
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);
	scanf("%d %d", &n, &m);
	if ((n <= 200) && (m <= 200))
	{
		for (int i = 0; i < n; i++)
		{
			res[i] = -1;
			for (int j = 0; j < n; j++)
				pos[i][j] = true;
		}
		for (int i = 0; i < m; i++)
		{
			int k;
			for (int j = 0; j < n; j++)
				f[j] = false;
			scanf("%d", &k);
			for (int j = 0; j < k; j++)
			{
				int v;
				scanf("%d", &v);
				v--;
				f[v] = true;
			}
			mark(i);
		}
	}
	else
	{
		sz = 1;
		s[0].cnt = n;
		s[0].step = -1;
		s[0].ins = 0;
		s[0].clone = -1;
		s[0].used = false;
		for (int i = 0; i < n; i++)
			p[i] = 0;
		for (int i = 0; i < m; i++)
		{
			int k;
			scanf("%d", &k);
			for (int j = 0; j < k; j++)
			{
				scanf("%d", &a[j]);
				a[j]--;
				s[p[a[j]]].ins++;
			}
			for (int j = 0; j < k; j++)
			{
				int x = p[a[j]];
				if ((s[x].ins > 0) && (s[x].ins < s[x].cnt))
				{
					if (!s[x].used)
						makeclone(x, i);
				}
				else
					s[x].clone = -1;
			}
			for (int j = 0; j < k; j++)
			{
				int x = p[a[j]];
				if (s[x].clone == -1)
					continue;
				else
				{
					int y = s[x].clone;
					s[x].cnt--;
					s[x].ins = 0;
					s[x].used = false;
					p[a[j]] = y;
					s[y].cnt++;
				}
			}
			for (int j = 0; j < k; j++)
			{
				int x = p[a[j]];
				s[x].ins = 0;
				s[x].used = false;
			}
		}
		for (int i = 0; i < n; i++)
		{
			if (s[p[i]].cnt == 1)
				res[i] = s[p[i]].step;
			else
				res[i] = -1;
		}
	}

	for (int i = 0; i < n; i++)
		printf("%d ", res[i] + 1);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
