#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;


const int maxn = 16;

int n, k;
int a[maxn], id[maxn];
int d[maxn];
int r[maxn];
int64 ans;


int main()
{
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);
	scanf("%d", &n);
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &r[i]);
		r[i]--;
	}
	sort(r, r + k);
	for (int i = 0; i < n; i++)
		a[i] = i;
	ans = 0;
	do
	{
		for (int i = 0; i < n; i++)
			id[a[i]] = i;
		bool check = true;
		for (int i = 1; i < k; i++)
			if (id[r[i]] < id[r[i - 1]])
			{
				check = false;
				break;
			}
		if (!check)
			continue;
		d[0] = 1;
		int sz = 1;
		for (int i = 1; i < n; i++)
		{
			d[i] = 1;
			for (int j = 0; j < i; j++)
				if (a[j] < a[i])
					d[i] = max(d[i], d[j] + 1);
			sz = max(sz, d[i]);
		}
		if (sz == k)
			ans++;
	}
	while (next_permutation(a, a + n));
	printf("%I64d", ans);
	fclose(stdin);
	fclose(stdout);

    return 0;
}
