#include <cstdio>
#include <iostream>
#include <string>

using namespace std;

typedef long long ll;

const int MAXN = 200000;
const ll base = 27239;

string a, b;
ll sum[MAXN];
int back = 0;

ll get_sum(int i, int j) {
	return sum[j] - (i > 0 ? sum[i-1] : 0);
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
#endif
	cin >> a >> b;
	for(int i = 0; i < a.length(); ++i)
		sum[i] = (i > 0 ? sum[i-1] : 0) + a[i]-'0';
	while(back < min(a.length(), b.length()) && a[a.length()-back-1] == b[b.length()-back-1]) ++back;
	for(int i = 0; i < min(b.length(), a.length()); ++i) {
		ll num = 0;
		if(b[i] == '0') continue;
		for(int j = 0; j < 6; ++j) { // @todo: fix!
			if(i+j >= b.length()) break;
			int l = a.length() - b.length() + j+1;
			if(l < 0 || i+l > a.length()) continue;
			(num *= 10) += b[i+j]-'0';
			if(get_sum(i,i+l-1) == num && b.length()-i-j-1 <= back) {
				printf("%d %d", i+1, i+l);
				return 0;
			}
		}
		if(a[i] != b[i]) break;
	}
}