#include <cstdio>
#include <vector>
#include <iostream>

#define pb push_back

using namespace std;

const int MAXN = 200000;

vector<int> a[MAXN];
vector<int> b[MAXN];
int roota, rootb;
int in1[MAXN], out1[MAXN];
int in2[MAXN], out2[MAXN];
int timer1, timer2;
int n, p;

void dfs(int v, const vector<int> *g, int *in, int *out, int &timer, int parent = -1) {
	in[v] = timer++;
	for(int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if(to == parent) continue;
		dfs(to, g, in, out, timer, v);
	}
	out[v] = timer++;
}

bool upper(int a, int b, int *in, int *out) {
	return in[a] <= in[b] && out[a] >= out[b];
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("virus.in" , "r", stdin);
	freopen("virus.out", "w", stdout);
#endif
	scanf("%d", &n);
	for(int i = 0; i < n; ++i) {
		scanf("%d", &p); --p;
		if(p == -1) roota = i;
		else a[p].pb(i);
	}
	for(int i = 0; i < n; ++i) {
		scanf("%d", &p); --p;
		if(p == -1) rootb = i;
		else b[p].pb(i);
	}
	dfs(roota, a, in1, out1, timer1);
	dfs(rootb, b, in2, out2, timer2);
	int res = 0;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < i; ++j) {
			if(upper(i,j,in1,out1) && upper(i,j,in2,out2) ||
				upper(j,i,in1,out1) && upper(j,i,in2,out2)) ++ res;
		}
	cout << res;
}