#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

typedef long long ll;

const int MAXN = 2000000;
const int DT = 10;
const ll inf = (ll)1 << 50;

int n, eq, gt;
ll d[MAXN];


int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
#endif
	scanf("%d%d%d", &n, &eq, &gt);
	d[1] = 0;
	d[2] = gt;
	d[3] = max(eq,gt);
	for(int i = 4; i <= n; ++i) {
		d[i] = inf;
		for(int j = max(1, i/3-DT); j <= i/3+DT && j+j <= i; ++j)
			d[i] = min(d[i], max(d[j] + gt, i != 2*j ? d[i-2*j] + eq : 0));
	}
	cout << d[n];
}