#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

typedef long long ll;

const int MAXN = 2000000;
const ll inf = (ll)1 << 50;

int n;
ll eq, gt;
ll d[MAXN];


int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
#endif
	cin >> n >> eq >> gt;
	d[1] = 0;
	for(int i = 2; i <= n; ++i) {
		d[i] = inf;
		for(int j = 1; j+j <= i; ++j)
			d[i] = min(d[i], max(d[j] + gt, i != 2*j ? d[i-2*j] + eq : 0));
	}
	cout << d[n];
}