#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

typedef vector<int> vi;

const int MAXN = 100;
const int inf = 1000000000;

struct per {
	vi p;
	int n;
	per() {}
	bool operator<(const per &c) {
		return p < c.p;
	}
};

int n, m;
int t, x;
int out[MAXN];
int step;
per p[MAXN];
vi a;

void test(int who) {
	if(out[who] > step) out[who] = step;
}

int w[MAXN], v[MAXN];
bool f[MAXN];

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w" ,stdout);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	for(int i = 0; i <n; ++i)
		p[i].n = i;
	for(int i = 0; i < n; ++i)
		out[i] = 0;
	for(step = 1; step <= m; ++step) {
		scanf("%d", &t);
		a.resize(t);
		for(int j = 0; j < t; ++j) {
			scanf("%d", &x), x--;
			p[x].p.pb(step);
		}		
	}
	//sort(p, p+n);
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < i; ++j) {
			if(p[i].p == p[j].p) {
				out[p[i].n] = out[p[j].n] = inf;
				continue;
			}
			for(int k = 0; k < max(p[i].p.size(), p[j].p.size()); ++k) {
				int step;
				if(k >= p[i].p.size() || k >= p[j].p.size()) {
					step = k >= p[i].p.size() ? p[j].p[k] : p[i].p[k];
				} else if(p[i].p[k] != p[j].p[k]) {
					step = min(p[i].p[k], p[j].p[k]);
				} else continue;
				out[p[i].n] = max(out[p[i].n], step);
				out[p[j].n] = max(out[p[j].n], step);
				break;
			}
		}
	}
	for(int i = 0; i < n; ++i)
		if(out[i] == inf) printf("0 ");
		else printf("%d ", out[i]);
}