#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <time.h>
#include <cmath>
#include <map>
#include <set>

using namespace std;

int StOfTen(long long n){
	int k = 0;
	while (n != 1){
		if (n % 10 != 0) return -1;
		k++;
		n /= 10;
	}
	return k;
}

string s1, s2;
long long i1, j1_, sa, b;

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
#endif
	cin >> s1 >> s2;
	for (int i = 0; i < s2.length(); i++){
		if (s1[i] != s2[i]){
			i1 = i;
			break;
		}
	}
	for (int i = s2.length() - 1; i >= 0; i--){
		if (s1[s1.length() - s2.length() + i] != s2[i]){
			j1_ = s1.length() - s2.length() + i;
			break;
		}
	}
	if (j1_ <= i1){
		// 
		cout << (i1 + 1) << ' ' << (i1 + 2);
		return 0;
	}
	//  a
	sa = 0;
	for (int i = i1; i <= j1_; i++){
		sa += s1[i] - 48;
	}
	// b
	b = 0;
	for (int i = i1; i <= j1_ - s1.length() + s2.length(); i++){
		b = b * 10 + s2[i] - 48;
	}
	for (int i = i1; i >= 0; i--){
		if (sa % b == 0){
			int t = StOfTen(sa / b);
			if (t != -1){
				cout << i + 1 << ' ' << j1_ + t + 1;
				return 0;
			}
		}
		if (i != 0){
			sa += s1[i - 1] - 48;
			b = (s2[i - 1] - 48) * 10 + b;
		}
	}
	return 0;
}