#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const int inf = 1000000000;
const int maxn = 1000010;

int REC[maxn][2], u, r, n;

int rec(int n, char f){
	int c;
	if (f) c = 1;
	else c = 0;
	if (REC[n][c]){
		return (REC[n][c]);
	}
	if (n == 2){
		if (f == true)
			return u;
		else
			return r;
	}
	if (n == 3){
		if (f)
			return max(u, r);
		else
			return 2 * r;
	}
	int min_ = inf;
	if (n % 2 == 1){
		int t1 = rec(n - 1, true);
		int t2 = rec(n - 1, false);
		min_ = max(t1, t2);
	}
	for (int i = 2; i <= n / 2; i++){
		int a1 = rec(i, true);
		int b1 = rec(n - i, false);
		int a2 = rec(i, false);
		int b2 = rec(n - i, true);
		int left, right;
		if (i == n - i){	
			if (f){
				right = rec(n - i, true);
				min_ = min(min_, (1 + n % 2) * u + right);
			} else
				min_ = min(min_, r);
		}
		if (f){
			int t = u;
			if (n % 2) t *= 2;
			min_ = min(min_, max(a1, t + b2));

			// 
			//left = a1 + b1;
			// 
			//right = a2 + b2;
			//min_ = min(min_, min(left, right));
		} else {
			min_ = min(min_, (1 + n % 2) * u);
		}
		
	}
	REC[n][c] = min_;
	return min_;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
#endif
	cin >> n >> r >> u;
	cout << rec(n, true) - 1;
	return 0;
}