#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const int maxn = 9;

int a[maxn], b[maxn], c[maxn], d[maxn], n, m, ans, was[maxn];

void gen(int k){//   
	if (k == n){	
		for (int i = 0; i < k; i++){
			for (int j = 0; j < m; j++){
				if (a[i] == b[j]){
					c[j] = i;
				}
			}
		}

		for (int i = 0; i < k; i++){
			d[i] = 0;
		}
		d[0] = 1;
		for (int i = 1; i < k; i++){
			int maxd = 0;
			for (int j = i - 1; j >= 0; j--){
				if (a[j] < a[i] && d[j] > maxd){
					maxd = d[j];
				}
			}
			d[i] = maxd + 1;
		}

		int l = 0, nvpi;
		for (int i = 0; i < k; i++){
			if (d[i] >= l){
				nvpi = i;
				l = d[i];
			}
		}

		char fail = false;

		if (l != m) fail = true;

		for (int i = 0; i < m - 1; i++){
			if (c[i] > c[i + 1]) fail = true;
		}

		for (int i = 0; i < m; i++){
			if (d[c[i]] != i + 1) fail = true;
		}

		if (!fail){
			ans++;
		}
		return;
	}
	for (int i = 1; i <= n; i++){
		if (!was[i]){
			a[k] = i;
			was[i] = true;
			gen(k + 1);
			was[i] = false;
		}
	}
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
#endif
	cin >> n;
	cin >> m;
	for (int i = 0; i < m; i++){
		cin >> b[i];
	}
	gen(0);
	cout << ans;
	return 0;
}