#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
#include<sstream>
using namespace std;

#define TASK "password"
typedef long long ll;
string s1, s2, tmp;
int l1, l2;

bool check(int l, int r)
{
	if(l < 0 || l > r || r >= l1)
		return false;
	int sum = 0;
	for(int i = l; i <= r; ++i)
		sum += int(s1[i]-'0');
	ostringstream oss;
	oss << sum;
	string tstr = oss.str();
	tmp = s1.substr(0, l) + tstr;
	if(r < l1 - 1)
		tmp += s1.substr(r + 1, l1 - r - 1);
	return tmp == s2;
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	cin >> s1 >> s2;

	if(s1 == s2)
	{
		cout << 1 << ' ' << 1;
		return 0;
	}
	l1 = s1.size(), l2 = s2.size();
	int p = 0, s = 0;
	while(p + 1 < s2.size() && s1[p + 1] == s2[p + 1])
		++p;
	while((int)s2.size() - s - 2 >= 0 && s2[l2 - s - 2] == s1[l1 - s - 2])
		++s;
	int l = -1, r;
	for(int i = p-7; i <= p + 7 && l == -1; ++i)
		for(int j = l1-s-7; j <= l1-s+7 && l == -1; ++j)
			if(check(i, j)) 
				l = i, r = j;
	cout << l + 1 << ' ' << r + 1;

	return 0;
}