#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<map>
using namespace std;

const int INF = 1 << 30;
typedef long long ll;
typedef long double ld;

#define TASK "mosaic"
const int maxn = 100005;

struct ev
{
	int x, id;
	bool st;
	ev(){}
	ev(int _x, int _id, bool _st) : x(_x), id(_id), st(_st) {}
	bool operator <(const ev &t) const
	{
		return x < t.x;
	}
};

int a[maxn], b[maxn];
int x[maxn], y[maxn];
int la[maxn], lb[maxn];
map<int, int> mp;
vector<ev> e1, e2;
int lst[maxn], tmp[maxn];
int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n, k;
	scanf("%d", &n);
	for(int i = 0; i < n; ++i)
		scanf("%d %d", &a[i], &b[i]);
	la[0] = -1;
	lb[0] = -1;
	for(int i = 1; i < n; ++i)
	{
		if(a[i] != a[i - 1])
			la[i] = i - 1;
		else
			la[i] = la[i - 1];
	}
	for(int i = 1; i < n; ++i)
	{
		if(b[i] != b[i - 1])
			lb[i] = i - 1;
		else
			lb[i] = lb[i - 1];
	}
	scanf("%d", &k);
	for(int i = 0; i < k; ++i)
	{
		scanf("%d %d", &x[i], &y[i]);
		x[i]--, y[i]--;
		if(la[y[i]] < x[i] || lb[y[i]] < x[i])
			cout << 0 << ' ' << 0 << endl;
		else
		{
			int t1 = la[y[i]], t2 = lb[y[i]];
			if(t1 == t2)
				cout << t1 + 1 << ' ' << y[i] + 1 << endl;
			int f1 = t1, f2 = y[i];
			bool found = false;
			while(f1 >= x[i] && !found)
			{
				if(a[f1] != a[f2] && b[f1] != b[f2])
					found = true, cout << f1 + 1 << ' ' << f2 + 1 << endl;
				f2 = f1, f1 = la[f1];
			}
			f1 = t2, f2 = y[i];
			while(f1 >= x[i] && !found)
			{
				if(a[f1] != a[f2] && b[f1] != b[f2])
					found = true, cout << f1 + 1 << ' ' << f2 + 1 << endl;
				f2 = f1, f1 = lb[f1];
			}
		}
	}

	return 0;
}