#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
using namespace std;

const int INF = 1 << 30;
typedef long long ll;
typedef long double ld;
const int maxn = 100005;


#define TASK "theatre"
vector<vector<int> > pp;
int used[maxn], n, m;
int g[105][105];
int t[105], kk[105], tt[105];
bool tused[105];
vector<int> at, td;

bool relax(int id)
{
	bool found = false;
	for(int i = 0; i < n; ++i)
	{
		if(used[i] < 1)
		{
			for(int j = 0; j < pp[i].size(); ++j)
				if(used[pp[i][j]] > 0)
				{
					swap(pp[i][j], pp[i].back());
					pp[i].pop_back();
					found = true;
					--j;
				}
				if(pp[i].size() == 1)
					used[i] = id;
		}

	}
	return found;
}


int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int k, tmp;
	scanf("%d %d", &n, &m);
	//g.resize(m);
	for(int i = 0; i < n; ++i)
		g[0][i] = 1;
	pp.resize(n);
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			pp[i].push_back(j);
	for(int i = 0; i < m; ++i)
	{
		scanf("%d", &k);
		kk[i] = k;
		at.clear();
		for(int j = 0; j < k; ++j)
			tused[j] = 0;
		int cnt = 0, t1;
		for(int j = 0; j < k; ++j)
		{
			scanf("%d", &tmp);
			tmp--;
			//at.push_back(tmp);
			if(used[tmp] < 1)
				tused[tmp] = 1, cnt++, t1 = tmp;
		}
		if(cnt == 1)
		{
			used[t1] = i + 1;
		}
		for(int j = 0; j < n; ++j)
		{
			if(!tused[j] && used[j] < 1)
			{
				for(int jj = 0; jj < pp[j].size(); ++jj)
					if(tused[pp[j][jj]] || used[pp[j][jj]] > 0)
					{
						swap(pp[j][jj], pp[j].back());
						pp[j].pop_back();
						--jj;
					}
				if(pp[j].size() == 1)
					used[j] = i + 1;
			}
			
			if(tused[j] && used[j] < 1)
			{
				for(int jj = 0; jj < pp[j].size(); ++jj)
					if(!tused[pp[j][jj]] || used[pp[j][jj]] > 0)
					{
						swap(pp[j][jj], pp[j].back());
						pp[j].pop_back();
						--jj;
					}
				if(pp[j].size() == 1)
					used[j] = i + 1;
			}
		}
		while(true)
		{
			if(!relax(i + 1))
				break;
		}
	}
	for(int i = 0; i < n; ++i)
		cout << (used[i] == -1 ? 0 : used[i]) << ' ';

	return 0;
}