#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cmath>
#include<cstdlib>
#include<cassert>
#include<ctime>
#include<cstring>
#include<string>
#include<vector>
#include<map>
#include<set>
using namespace std;

#define taskname "mosaic"
const int MAX = (int)2e5;

struct mosaic{
  int a, b;
};

int n, m;
vector<mosaic> a;
int b[MAX];

bool good(mosaic a, mosaic b)
{
  return (a.a == b.a || a.b == b.b);
}

int main()
{
  int l, r;
  freopen(taskname".in", "r", stdin);
  freopen(taskname".out", "w", stdout);
  scanf("%i", &n);
  a.resize(n+1);
  for(int i = 1; i <= n; i++)
    scanf("%i%i", &a[i].a, &a[i].b);
  for(int i = 1; i <= n; i++)
  {
    int j = i+1;
    while(j <= n && good(a[i], a[j]))
      j++;
    if(j <= n)
      b[i] = j;
  }
  for(int i = 0; i <= n; i++)
    cout << b[i] << ' ';
  cout << endl;
  scanf("%i", &m);
  for(int i = 0; i < m; i++)
  {
    scanf("%i%i", &l, &r);
    int ans = 0;
    for(int j = l; j < r; j++)
      if(b[j] <= r && b[j] != 0)
      {
        ans = j;
        break;
      }
    printf("%i %i\n", ans, b[ans]);
  }
  return 0;
}






