{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 1000000000;
  dxh : array [1.. 5] of integer = (-1, 0, 1, 0, 0);
  dyh : array [1.. 5] of integer = (0, -1, 0, 1, 0);
  dx : array [1.. 9] of integer = (-1, -1, 0, 1, 1, 1, 0, -1, 0);
  dy : array [1.. 9] of integer = (0, -1, -1, -1, 0, 1, 1, 1, 0);

type
  point = record
    x, y : extended;
  end;

var
  h0, q0, q, h : point;
  curp, minp : extended;
  i, j, curd, n, m, feedback : integer;


function dist (a, b : point) : extended;
begin
  result := sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
end;

begin
  reset(input, 'input.txt');
  rewrite(output, 'output.txt');
  randomize;
  read(n, m);
  read(q0.x, q0.y);
  writeln(0, ' ' , 0, ' ' , 1);
  flush(output);
  read(feedback, h0.x, h0.y);

  while feedback <> 1 do begin
    minp := inf;
    i := random(9)
    while (q0.x + dx[i] > 0) and (q0.x + dx[i] <= n) and (q0.y + dy[i] > 0) and (q0.y + dy[i] <= m) do
      i := random(9);
      
        curp := 0;
        q.x := q0.x + dx[i];
        q.y := q0.y + dy[i];
        for j := 1 to 5 do begin
          h.x := h0.x + dxh[j];
          h.y := h0.y + dyh[j];
          curp := curp + dist(q, h);
        end;
        if curp < minp then begin
          curd := i;
          minp := curp;
        end;
      end;

    q0.x := q0.x + dx[i];
    q0.y := q0.y + dy[i];  
    write(dx[i], ' ' , dy[i]);
    if minp < 8 then
      writeln(' ' , 1)
    else
      writeln(' ' , 0);
    flush(output);
    
    read(feedback, h0.x, h0.y);  
  end;
end.
