program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;
const
      NMax = 100000;
type pair = record
       l, r : integer;
     end;
var
    n, k : integer;
    R, G : array[1..NMax] of integer;
    j, i, a, b : integer;
    Count, TMPC : integer;
    M, TMP : array[1..NMax] of pair;
function lng(x : pair) : integer;
begin
  result := x.r - x.l + 1;
end;

procedure swap(var a,b : pair);
var
    f : pair;
begin
  f := a;
  a := b;
  b := f;
end;

procedure sort(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=M[(l+r) DIV 2].l;
  y := M[(l+r) div 2].r;
  repeat
    while (M[i].l<x)or((M[i].l=x)and(M[i].r < y)) do i:=i+1;
    while (x<M[j].l)or((M[j].l=x)and(M[j].r > y)) do j:=j-1;
    if i<=j then
    begin
      swap(M[i], M[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure Solve(a, b : integer);
var
    l, r, c : integer;
begin
  l := 0;
  r := Count + 1;
  while (r - l > 1) do
  begin
    c := (l + r) div 2;
    if (M[c].l <= a) then
      l := c
    else
      r := c;
  end;
  while (l <= b) do
  begin
    if (a <= M[l].l)and(b >= M[l].r) then
    begin
      writeln(M[l].l,' ',M[l].r);
      exit
    end
    else
    begin
      inc(l);  
    end;
  end;
  writeln(0,' ',0);
end;


begin
  assign(input, 'mosaic.in'); reset(input);
  assign(output, 'mosaic.out'); rewrite(output);
  read(n);
  for i := 1 to n do
  begin
    read(G[i], R[i]);
  end;
  Count := 0;
  for i := 1 to (n - 1) do
    for j := i + 1 to n do
      if (G[i] <> G[j])and(R[i] <> R[j]) then
      begin
        inc(Count);
        M[Count].l := i;
        M[Count].r := j;
      end;
  sort(1, Count);
  k := 1;
  while (k < Count) do
  begin
    while (M[k].l = M[k + 1].l) do
    begin
      swap(M[k], M[k + 1]);
      M[k].l := 0;
      M[k].r := 0;
      inc(k);
    end;
    inc(k);
  end;
  TMPC := 0;
  for i := 1 to Count do
    if (M[i].l <> 0) then
    begin
      inc(TMPC);
      TMP[TMPC] := M[i];
    end;
  M := TMP;
  Count := TMPC;
  read(k);
  for i := 1 to k do
  begin
    read(a, b);
    Solve(a, b);
  end;
end.
 