program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;
const
      NMax = 100000;
type pair = record
       l, r : integer;
     end;
var
    n, k : int64;
    R, G : array[1..NMax] of integer;
    j, i, a, b : integer;
    Count, TMPC : int64;
    M, TMP : array[0..NMax] of pair;
function lng(x : pair) : integer;
begin
  result := x.r - x.l + 1;
end;

procedure swap(var a,b : pair);
var
    f : pair;
begin
  f := a;
  a := b;
  b := f;
end;

procedure sort(l, r: int64);
var
  i,j,x,y: int64;
begin
  i:=l; j:=r; x:=M[(l+r) DIV 2].l;
  y := M[(l+r) div 2].r;
  repeat
    while (M[i].l<x)or((M[i].l=x)and(M[i].r < y)) do i:=i+1;
    while (x<M[j].l)or((M[j].l=x)and(M[j].r > y)) do j:=j-1;
    if i<=j then
    begin
      swap(M[i], M[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

function Binary(k, l, r : int64) : integer;
var
    c : int64;
begin
  c := 0;
  while not((M[c].l >= k)and(M[c - 1].l < k)) do
  begin
    c := (l + r) div 2;
    if (M[c].l <= k) then
      l := c
    else
      r := c;
    if abs(r - l) <= 1 then break;
  end;
  result := c;
end;

function Binary2(k, l, r : int64) : integer;
var
    c : int64;
begin
  c := 0;
  while not((M[c].l >= k)and((M[c + 1].l > b)or(M[c + 1].l = 0))) do
  begin
    c := (l + r) div 2;
    if (M[c].l <= k) then
      l := c
    else
      r := c;
    if abs(r - l) <= 1 then break;
  end;
  result := c;
end;

procedure Solve(a, b : int64);
var
    l, r, c : int64;
begin
  l := Binary(a, 0, Count + 1);
  if (l = 0)or(l > Count) then
  begin
    writeln(0,' ',0);
    exit;
  end;
  r := Binary2(a, 0, Count + 1);
  if (r = 0)or(r > Count) then
  begin
    writeln(0,' ',0);
    exit;
  end;
  while (l <= r) do
  begin
    if (M[l].r <= b) then
    begin
      writeln(M[l].l,' ',M[l].r);
      exit;
    end;
    inc(l);
  end;
end;


begin
  assign(input, 'mosaic.in'); reset(input);
  assign(output, 'mosaic.out'); rewrite(output);
  read(n);
  for i := 1 to n do
  begin
    read(G[i], R[i]);
  end;
  Count := 0;
  for i := 1 to (n - 1) do
    for j := i + 1 to n do
      if (G[i] <> G[j])and(R[i] <> R[j]) then
      begin
        inc(Count);
        M[Count].l := i;
        M[Count].r := j;
      end;
  sort(1, Count);
  k := 1;
  while (k < Count) do
  begin
    while (M[k].l = M[k + 1].l) do
    begin
      swap(M[k], M[k + 1]);
      M[k].l := 0;
      M[k].r := 0;
      inc(k);
    end;
    inc(k);
  end;
  TMPC := 0;
  for i := 1 to Count do
    if (M[i].l <> 0) then
    begin
      inc(TMPC);
      TMP[TMPC] := M[i];
    end;
  M := TMP;
  Count := TMPC;
  read(k);
  for i := 1 to k do
  begin
    read(a, b);
    Solve(a, b);
  end;
end.
