program B_50;

{$APPTYPE CONSOLE}


type
  plist = ^list;
  list = record
    x: longint;
    p: plist;
  end;

procedure init(var p: plist);
begin
  new(p);
  p^.p := nil;
end;

var
  in1, in2, out1, out2: array[1..100000] of longint;
  b1, b2, e1, e2: array[1..100000] of plist;
  n, i, j, x, time, ans, boss1, boss2: longint;

procedure add1(x, y: longint);
begin
  e1[x]^.x := y;
  init(e1[x]^.p);
  e1[x] := e1[x]^.p;
end;

procedure add2(x, y: longint);
begin
  e2[x]^.x := y;
  init(e2[x]^.p);
  e2[x] := e2[x]^.p;
end;

procedure dfs1(x: longint);
var
  p: plist;

begin
  inc(time);
  in1[x] := time;
  p := b1[x];
  while (p^.p <> nil) do begin
    dfs1(p^.x);
    p := p^.p;
  end;
  inc(time);
  out1[x] := time;
end;

procedure dfs2(x: longint);
var
  p: plist;

begin
  inc(time);
  in2[x] := time;
  p := b2[x];
  while (p^.p <> nil) do begin
    dfs2(p^.x);
    p := p^.p;
  end;
  inc(time);
  out2[x] := time;
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  readln(n);
  for i := 1 to n do begin
    init(b1[i]);
    e1[i] := b1[i];
    init(b2[i]);
    e2[i] := b2[i];
  end;
  for i := 1 to n do begin
    read(x);
    if (x = 0) then begin
      boss1 := i;
    end else begin
      add1(x, i);
    end;
  end;
  readln;
  for i := 1 to n do begin
    read(x);
    if (x = 0) then begin
      boss2 := i;
    end else begin
      add2(x, i);
    end;
  end;
  time := 0;
  dfs1(boss1);
  time := 0;
  dfs2(boss2);
  ans := 0;
  for i := 1 to n do begin
    for j := i + 1 to n do begin
      if ((in1[i] < in1[j]) = (out1[i] > out1[j])) and ((in2[i] < in2[j]) = (out2[i] > out2[j]))
        and ((in1[i] < in1[j]) = (in2[i] < in2[j])) then begin
          inc(ans);
      end;
    end;
  end;
  writeln(ans);
end.
