program H;

{$APPTYPE CONSOLE}


var
  a1, a2: array[1..15] of longint;
  prev: array[1..15] of longint;
  used, used2: array[1..15] of boolean;
  stand: array[1..15] of longint;
  n, k, i, h1, h2, ans, last: longint;

procedure prepair;
var
  last, i: longint;

begin
  fillchar(used2, sizeof(used2), false);
  last := 0;
  for i := 1 to n do begin
    if (stand[i] <> 0) then begin
      inc(last);
    end;
    prev[i] := last;
  end;
end;

procedure check;
var
  dp: array[1..15] of longint;
  i, j: longint;
  flag: boolean;

begin
  dp[1] := 1;
  flag := true;
  for i := 2 to n do begin
    dp[i] := 1;
    for j := 1 to i - 1 do begin
      if (stand[i] > stand[j]) then begin
        if (dp[i] < dp[j] + 1) then dp[i] := dp[j] + 1;
      end;
    end;
    flag := flag and (dp[i] <= k);
  end;
  if flag then inc(ans);
end;

procedure rec(x: longint);
var
  i: longint;
  
begin
  if (x = n + 1) then begin
    check;
  end else begin
    if (stand[x] = 0) then begin
      for i := 1 to h2 do begin
        if not used2[i] and ((a2[i] < a1[prev[x]]) or (a2[i] > a1[prev[x] + 1])) then begin
          used2[i] := true;
          stand[x] := a2[i];
          rec(x + 1);
          stand[x] := 0;
          used2[i] := false;
        end;
      end;
    end else begin
      rec(x + 1);
    end;
  end;
end;

procedure recursion(x: longint);
begin
  if (x = n) or (last = h1) then begin
    if (last = h1 - 1) then begin
      stand[n] := a1[h1];
      prepair;  
      rec(1); 
      stand[n] := 0;
    end else begin
      prepair;
      rec(1);
    end;
  end else begin
    if (n - x >= h1 - last) then begin
      recursion(x + 1);
    end;
    if (last < h1) then begin
      inc(last);
      stand[x] := a1[last];
      recursion(x + 1);
      stand[x] := 0;
      dec(last);
    end;
  end;
end;

begin
  reset(input, 'army.in');
  rewrite(output, 'army.out');
  readln(n);
  readln(k);
  h1 := k;
  for i := 1 to k do begin
    read(a1[i]);
    used[a1[i]] := true;
  end;
  a1[h1 + 1] := n + 1;
  h2 := 0;
  for i := 1 to n do if not used[i] then begin
    inc(h2);
    a2[h2] := i;
  end;
  ans := 0;
  fillchar(stand, sizeof(stand), 0);
  fillchar(used, sizeof(used), false);
  last := 0;
  recursion(1);
  writeln(ans);
end.
