#include <iostream>
#include <math.h>
#include <time.h>
#include <algorithm>
#include <stdio.h>
using namespace std;

typedef long long ll;
#define txt "virus"
#define inf 1e9
#define eps 1.0e-9
#define N 300500
         
int fa[N];
int na[N];
int ea[N];
int fb[N];
int nb[N];
int eb[N];

int pa[N];
int pb[N];
int a1[N];
int a2[N];
int b1[N];
int b2[N];
int l1, l2;

int n;

int t;

void dfs1(int v)
{
	a1[v] = t;
	pa[t++] = v;
	for (int u = fa[v]; u != -1; u = na[u])
		dfs1(ea[u]);
    pa[t++] = v;
    a2[v] = t;		
}
void dfs2(int v)
{
	b1[v] = t;
	pb[t++] = v;
	for (int u = fb[v]; u != -1; u = nb[u])
		dfs2(eb[u]);
    pb[t++] = v;
    b2[v] = t;		
}


int main()
{
	freopen(txt".in", "r", stdin);
	freopen(txt".out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; i++)
		fa[i] = fb[i] = -1;
	int j;
	int ra, rb;
	for (int i = 0; i < n; i++)
	{
		cin >> j;
		if (j == 0) ra = i;
		else
		{
			j--;
			ea[l1] = i;
			na[l1] = fa[j];
			fa[j] = l1++;			
		}
	}
	for (int i = 0; i < n; i++)
	{
		cin >> j;
		if (j == 0) rb = i;
		else
		{
			j--;
			eb[l2] = i;
			nb[l2] = fb[j];
			fb[j] = l2++;			
		}
	}

	t = 0, dfs1(ra);
	t = 0, dfs2(rb);

	ll cnt = 0;
	for (int i = 0; i < n; i++)
		for (int j = a1[i] + 1; j < a2[i]; j++)
			if (b1[i] < b1[pa[j]] && b2[i] > b2[pa[j]]) cnt++;
	cout << cnt / 2;

	return 0;
}