#include <iostream>
#include <math.h>
#include <time.h>
#include <algorithm>
#include <stdio.h>
using namespace std;

typedef long long ll;
#define txt "virus"
#define inf 1e9
#define eps 1.0e-9
#define N 300500
         
int fa[N];
int na[N];
int ea[N];
int fb[N];
int nb[N];
int eb[N];

int pa[N];
int pb[N];
int a1[N];
int a2[N];
int b1[N];
int b2[N];
int l1, l2;

int n;

int t;

void dfs1(int v)
{
	a1[v] = t;
	pa[t++] = v;
	for (int u = fa[v]; u != -1; u = na[u])
		dfs1(ea[u]);
    pa[t++] = v;
    a2[v] = t;		
}
void dfs2(int v)
{
	b1[v] = t;
	pb[t++] = v;
	for (int u = fb[v]; u != -1; u = nb[u])
		dfs2(eb[u]);
    pb[t++] = v;
    b2[v] = t;		
}

ll cnts[1000][1000];
int fc[1000][1000];
int sums[1000][1000];
int fn[N];
int fe[N];
int fl = 0;
int cx, cy;

ll ans(int x, int y)
{
	int res = sums[x - 1][y - 1];
	for (int i = 0; i < x / cx; i++)
		for (int u = fc[i][y / cy]; u != -1; u = fn[u])
			if (a1[fe[u]] < x && b1[fe[u]] < y) res++;
	for (int j = 0; j < y / cy; j++)
		for (int u = fc[x / cx][j]; u != -1; u = fn[u])
			if (a1[fe[u]] < x && b1[fe[u]] < y) res++;

	for (int u = fc[x / cx][y / cy]; u != -1; u = fn[u])
			if (a1[fe[u]] < x && b1[fe[u]] < y) res++;


		
}

int main()
{
	freopen(txt".in", "r", stdin);
	freopen(txt".out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; i++)
		fa[i] = fb[i] = -1;
	int j;
	int ra, rb;
	for (int i = 0; i < n; i++)
	{
		cin >> j;
		if (j == 0) ra = i;
		else
		{
			j--;
			ea[l1] = i;
			na[l1] = fa[j];
			fa[j] = l1++;			
		}
	}
	for (int i = 0; i < n; i++)
	{
		cin >> j;
		if (j == 0) rb = i;
		else
		{
			j--;
			eb[l2] = i;
			nb[l2] = fb[j];
			fb[j] = l2++;			
		}
	}   

	t = 0, dfs1(ra);
	int mx = t;
	cx = sqrt(mx) + 1;
	t = 0, dfs2(rb);
	int my = t;
	cy = sqrt(my) + 1;

	for (int i = 0; i < cx; i++)
		for(int j = 0; j < cy; j++)
			fc[i][j] = -1; 

	for (int i = 0; i < n; i++)
	{
		cnts[a1[i] / cx][b1[i] / cy]++;
		fn[  fl] = fc[cx][cy];
		fe[fl] = i;
		fc[cx][cy] = fl++;
	}
	for(int i = 0; i < cx; i++)
		for(int j = 0; j < cy; j++)
		{
			if (i > 0 && j > 0) sums[i][j] = sums[i - 1][j] + sums[i][j - 1] - sums[i - 1][j - 1] + cnts[i][j];
			else if (i > 0) sums[i][j] = sums[i - 1][j] + cnts[i][j];
			else if (j > 0) sums[i][j] = sums[i][j - 1] + cnts[i][j];
			else sums[i][j] = cnts[i][j];
		}                   
	ll cnt = 0;
	for (int i = 0; i < n; i++)
		cnt += ans(a2[i], b2[i]) + ans(a1[i], b1[i]) - ans(a2[i], b1[i]) - ans(a1[i], b2[i]);//ans(a1[i], a2[i], b1[i], b2[i]);
	cout << cnt / 2;

	return 0;
}