
#include <iostream>
#include <stdio.h>
#include <math.h>
using namespace std;

#define txt "mosaic"

typedef long long ll;
#define N 400500

int x[N];
int y[N];

int t1[N];
int t2[N];
int t3[N];
int t4[N];

int cmp1(int a, int b) //t
{
	if (b == 0 || a != 0 && (y[a] > y[b] || y[a] == y[b] && x[a] < x[b])) return a;
	else return b;  	
}
int cmp2(int a, int b) //l
{
	if (b == 0 || a != 0 && (x[a] < x[b] || x[a] == x[b] && y[a] > y[b])) return a;
	else return b;  	
}
int cmp3(int a, int b) //r
{
	if (b == 0 || a != 0 && (x[a] > x[b] || x[a] == x[b] && y[a] < y[b])) return a;
	else return b;  	
}
int cmp4(int a, int b) //d
{
	if (b == 0 || a != 0 && (y[a] < y[b] || y[a] == y[b] && x[a] > x[b])) return a;
	else return b;  	
}


void Create1(int i, int l, int r)
{
	if (l == r) t1[i] = l;
	else
	{
		int m = (l + r) / 2;
		Create1(i * 2, l, m);
		Create1(i * 2 + 1, m + 1, r);
		t1[i] = cmp1(t1[i * 2], t1[i * 2 + 1]);
	}
}
int Get1(int i, int l, int r, int s, int e)
{                                
	s = max(s, l);
	e = min(e, r);
	if (s > e) return 0;
	if (s == l && e == r)
		return t1[i];
	else
	{
		int m = (l + r) / 2;
		int a1 = Get1(i * 2, l, m, s, e);
		int a2 = Get1(i * 2 + 1, m + 1, r, s, e);
		return cmp1(a1, a2);
	}	
}    
void Create2(int i, int l, int r)
{
	if (l == r) t2[i] = l;
	else
	{
		int m = (l + r) / 2;
		Create2(i * 2, l, m);
		Create2(i * 2 + 1, m + 1, r);
		t2[i] = cmp2(t2[i * 2], t2[i * 2 + 1]);
	}
}
int Get2(int i, int l, int r, int s, int e)
{                                
	s = max(s, l);
	e = min(e, r);
	if (s > e) return 0;
	if (s == l && e == r)
		return t2[i];
	else
	{
		int m = (l + r) / 2;
		int a1 = Get2(i * 2, l, m, s, e);
		int a2 = Get2(i * 2 + 1, m + 1, r, s, e);
		return cmp2(a1, a2);
	}	
}    

void Create3(int i, int l, int r)
{
	if (l == r) t3[i] = l;
	else
	{
		int m = (l + r) / 2;
		Create3(i * 2, l, m);
		Create3(i * 2 + 1, m + 1, r);
		t3[i] = cmp3(t3[i * 2], t3[i * 2 + 1]);
	}
}
int Get3(int i, int l, int r, int s, int e)
{                                
	s = max(s, l);
	e = min(e, r);
	if (s > e) return 0;
	if (s == l && e == r)
		return t3[i];
	else
	{
		int m = (l + r) / 2;
		int a1 = Get3(i * 2, l, m, s, e);
		int a2 = Get3(i * 2 + 1, m + 1, r, s, e);
		return cmp3(a1, a2);
	}	
}    

void Create4(int i, int l, int r)
{
	if (l == r) t4[i] = l;
	else
	{
		int m = (l + r) / 2;
		Create4(i * 2, l, m);
		Create4(i * 2 + 1, m + 1, r);
		t4[i] = cmp4(t4[i * 2], t4[i * 2 + 1]);
	}
}
int Get4(int i, int l, int r, int s, int e)
{                                
	s = max(s, l);
	e = min(e, r);
	if (s > e) return 0;
	if (s == l && e == r)
		return t4[i];
	else
	{
		int m = (l + r) / 2;
		int a1 = Get4(i * 2, l, m, s, e);
		int a2 = Get4(i * 2 + 1, m + 1, r, s, e);
		return cmp4(a1, a2);
	}	
}    

int main()
{
	freopen(txt".in", "r", stdin);
	freopen(txt".out", "w", stdout);
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> x[i] >> y[i];
	int n2;
	for (n2 = 1; n2 < n; n2 *= 2);
	Create1(1, 1, n2);
	Create2(1, 1, n2);
	Create3(1, 1, n2);
	Create4(1, 1, n2);
	int k;
	cin >> k;
	int a, b;
	int t, d, l, r;
	for (int i = 0; i < k; i++)
	{
		cin >> a >> b;
		t = Get1(1, 1, n2, a, b);
		l = Get2(1, 1, n2, a, b);
		r = Get3(1, 1, n2, a, b);
		d = Get4(1, 1, n2, a, b);
		//cout << t << ' ' << l << ' ' << r << ' ' << d << endl;
		if (x[t] == x[l] && y[t] == y[l])
		{
			if (x[l] == x[r]) cout << 0 << ' ' << 0 << endl;
			else if (y[t] == y[d]) cout << 0 << ' ' << 0 << endl;
			else if (y[r] < y[l]) cout << l << ' ' << r << endl;
			else if (x[d] > x[t]) cout << d << ' ' << t << endl;
			else cout << d << ' ' << r << endl;
		}
		else
		{
			cout << l << ' ' << t << endl;
		}
		 
	}
	return 0;
}