#include <iostream>
#include <stdio.h>
#include <math.h>
using namespace std;

typedef long long ll;
#define N 100

bool mask[N][N];

struct p
{
	int x, y, tp;
};
p q[N * N];
bool was[N][N];
int n, m;

int bfs(int x, int y)
{
	if (!mask[x][y]) return 0;
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++)
			was[i][j] = 0;
	was[x][y] = 1;
	int s = 0, e = 0;
	int tp = 1;
	for (int dx = -1; dx <= 1; dx++)
		for (int dy  =-1; dy <= 1; dy++)
		{
			if (x + dx >= 0 && y + dy >= 0)
				if (x + dx < m && y + dy < n)
					if (dx != 0 || dy != 0)
				{
					q[e].x = x + dx;
					q[e].y = y + dy;
					q[e++].tp = tp;
					was[x + dx][y + dy] = 1;
				}
			tp++;
		}

	while (s != e)
	{
		p a = q[s++];
		if (!mask[a.x][a.y])
		{
			return a.tp;
		} 
		for (int dx = -1; dx <= 1; dx++)
			for (int dy = -1; dy <= 1; dy++)
			{
				if (a.x + dx >= 0 && a.x + dx < m)
					if (a.y + dy >= 0 && a.y + dy < n)
						if (!was[a.x + dx][a.y + dy])
						{
							q[e].x = a.x + dx;
							q[e].y = a.y + dy;
							was[q[e].x][q[e].y] = 1;
							q[e++].tp = a.tp;
						}
			}
	}	
}

int m2[N][N];

int main()
{
	cin >> n >> m;
	int x, y;
	cin >> x >> y;
	x--, y--;
	int dx, dy;
	bool call;
	while (1)
	{
		call = false;
		int n = bfs(x, y);
		if (n == 0)
		{
			cout << 0 << ' ' << 0 << ' ' << (mask[x][y] ? 0 : 1) << endl;
			if (!mask[x][y]) call = true;
			cout.flush();
		}
		else
		{
			if (n < 4) dx = -1;
			else if (n < 7) dx = 0;
			else dx = 1;
			if (n % 3 == 1) dy = -1;
			else if (n % 3 == 2) dy = 0;
			else dy = 1;
			x += dx;
			y += dy;
			cout << dx<< ' ' << dy <<  ' ' << (mask[x][y] ? 0 : 1) << endl;
			if (!mask[x][y]) call = true;
			cout.flush();
		}          
		int dx1, dy1, ans;
		cin >> ans >> dx1 >> dy1;
		//while (1) ;
		if (ans) return 0;
		if (call) mask[x][y] = 1;
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				if (i - dx1 >= 0 && i - dx1 <m && j - dy1 >= 0 && j - dy1 < n)
				m2[i][j] = m2[i - dx1][j - dy1];
				else
				m2[i][j] = 1;
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				mask[i][j] = m2[i][j];		
	}
	return 0;
}