#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>

using namespace std;

#define pb push_back
#define mp make_pair
#define y1 botva45
#define fir first
#define sec second
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-08;

int n;
int64 r, u;
int64 dp[1001000];

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> n >> r >> u;
	dp[1] = 0;
	dp[2] = u;
	for (int i = 3; i <= n; ++i) {	
		dp[i] = inf;
		for (int j = 1; j <= 3000; ++j) {
			if (2 * j > i)
				break;
			int v2 = i - 2 * j;
			if (v2 == 0)
				dp[i] = min(dp[i], u + dp[j]);
			else {
				int64 c1 = u + dp[j];
				int64 c2 = r + dp[v2];
				if (c1 < c2)
					c1 = c2;
				dp[i] = min(dp[i], c1);
			}
		}
	}
	cout << dp[n] << endl;
	return 0;
}