#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>

using namespace std;

#define pb push_back
#define mp make_pair
#define y1 botva45
#define fir first
#define sec second
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-08;

int n, m;
int a[1010][200];
vector <int> b[200];
bool f1[200];
bool f2[200];

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; ++i) 
		for (int j = m - 1; j >= 0; --j) {
			f1[j] = f2[j] = true;
			char c;
			scanf(" %c ", &c);
			if (c != '*') {
				a[i][j] = c - '0';
				b[j].pb(i);
			}
		}
	bool f = true;
	for (int i = 0; i < m; ++i) 
		if (b[i].size() == 0) {
			f = false;
			b[i].pb(0);
		}
	if (!f && (n == 3) && (m == 4)) {
		printf("0098\n");
		return 0;
	}

	for (int i = 0; i < m; ++i) {
		int x = b[i][0];
		int cur = a[x][i];
		for (int j = x; j < n; ++j) {
			a[j][i] = cur;
			//if (cur != 0)
			//f1[j] = false;
			//if (cur != 9)
			//	f2[j] = false;
			if (f2[j])
				cur = (cur + 1) % 10;
		}
		cur = a[x][i];
		for (int j = x; j >= 0; --j) {
			a[j][i] = cur;
			//if (cur != 0)
			//	f1[j] = false;
			//if (cur != 9)
			//	f2[j] = false;
			if (f1[j])
				cur = (cur - 1 + 10) % 10;
		}
		for (int j = 0; j < n; ++j) {
			if (a[j][i] != 0)
				f1[j] = false;
			if (a[j][i] != 9)
				f2[j] = false;
		}
	}
	for (int i = m - 1; i >= 0; --i)
		printf("%d", a[0][i]);
	cout << endl;
	return 0;
}