#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>

using namespace std;

#define pb push_back
#define mp make_pair
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-09;
const int treesz = 131072;

int n;
pair <int, int> a[treesz + 100];
int dpa[treesz];
int dpb[treesz];

void build() {
	int i = 1;
	while (i <= n) {
		int j = i;
		while ((j <= n) && (a[j].first == a[i].first))
			++j;
		for (int t = i; t < j; ++t)
			dpa[t] = j;
		i = j;
	}
	
	i = 1;
	while (i <= n) {
		int j = i;
		while ((j <= n) && (a[j].second == a[i].second))
			++j;
		for (int t = i; t < j; ++t)
			dpb[t] = j;
		i = j;
	}
}


int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) 
		scanf("%d %d", &a[i].first, &a[i].second);
	build();

	int m;
	scanf("%d", &m);
	for (int t = 0; t < m; ++t) {
		int x, y;
		scanf("%d %d", &x, &y);
		if (x == y - 1) {
			if ((a[x].first == a[y].first) || (a[x].second == a[y].second))
				printf("0 0\n");
			else printf("%d %d\n", x, y);
			continue;
		}
		if ((dpa[x] > y) || (dpb[x] > y)) {
			printf("0 0\n");
			continue;
		}
		int g1 = dpa[x];
		int g2 = dpb[x];
		if ((a[x].first != a[g1].first) && (a[x].second != a[g1].second)) {
			printf("%d %d\n", x, g1);
			continue;
		}
		if ((a[x].first != a[g2].first) && (a[x].second != a[g2].second)) {
			printf("%d %d\n", x, g2);
			continue;
		}
		printf("%d %d\n", g1, g2);
	}
	return 0;
}