#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>

using namespace std;

#define pb push_back
#define mp make_pair
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-09;

int n, k;
int res = 0;
bool used[16];
vector <char> cur;
char last[16];
char dp[16];

void print() {
	printf("%d\n", res);
	exit(0);
}

/*void check() {
	for (int i = 0; i < n; ++i)
		dp[i] = 1;
	for (int i = 0; i < n; ++i) {
		if (dp[i] > k)
			return ;
		for (int j = i + 1; j < n; ++j)
			if ((cur[j] > cur[i]) && (dp[j] <= dp[i]))
				dp[j] = dp[i] + 1;
	}
	++res;
}*/

void perebor(char pos, char ans) {
	if (pos == n) {
		++res;
		return ;
	}
	for (char i = 0; i < n; ++i)
		if (!used[i] && ((last[i] == -1) || used[last[i]])) {
			char x = 1;
			for (int j = 0; j < pos; ++j)
				if ((cur[j] < i) && (dp[j] >= x))
					x = dp[j] + 1;
			if (x > k)
				continue;
			if ((x == k) && (i != (n - 1)) && !used[n - 1])
				continue;
			dp[pos] = x;

			cur.pb(i);
			used[i] = true;
			perebor(pos + 1, max(dp[pos], ans));
			cur.pop_back();
			used[i] = false;
		}
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	scanf("%d %d", &n, &k);
	for (int i = 0; i < n; ++i)
		last[i] = -1;
	char t = -1;
	for (int i = 0; i < k; ++i) {
		int x;
		scanf("%d", &x);
		--x;
		last[x] = t;
		t = x;
	}
	perebor(0, 0);
	cout << res << endl;
	return 0;
}