#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <vector>

#define all(c) c.begin(), c.end()

using namespace std;

int char_to_int(char c)
{
    return (c - '0');
}

string int_to_char(int n)
{
    if (n == 0)
        return "0";
    if (n == 1)
        return "1";
    if (n == 2)
        return "2";
    if (n == 3)
        return "3";
    if (n == 4)
        return "4";
    if (n == 5)
        return "5";
    if (n == 6)
        return "6";
    if (n == 7)
        return "7";
    if (n == 8)
        return "8";
    if (n == 9)
        return "9";
    return "";
}

void int_to_str(int n, string &s)
{
    s = "";
    while (n > 0)
    {
        s = int_to_char(n % 10) + s;
        n /= 10;
    }
}

bool equal_str(string &s1, string &s2)
{
    if (s1.length() != s2.length())
        return false;
    string s = s1 + "#" + s2;
    vector <int> pi (s.length(), 0);
    for (int i = 1; i < s.length(); i++)
    {
        int j = pi[i-1];
        while (j > 0 && s[i] != s[j])
            j = pi[j-1];
        if (s[i] == s[j])
            j++;
        pi[i] = j;
    }
    return (pi[pi.size() - 1] == s1.length());
}

int get_sum(int n)
{
    int sum = 0;
    while (n > 0)
    {
        sum += n % 10;
        n /= 10;
    }
    return sum;
}

void new_from_sum(string &oldstr, string &newstr)
{
    newstr = "";
    int n = 0;
    for (int i = 0; i < oldstr.length(); i++)
    {
        n += char_to_int(oldstr[i]);
    }
    int_to_str(n, newstr);
}

void moderate(int l, int r, string &s, string &new_string)
{
    new_string = "";
    for (int i = 0; i < l; i++)
        new_string += s[i];

    string temp = "";
    for (int i = l; i <= r; i++)
        temp += s[i];
    string ss;

    new_from_sum(temp, ss);
    new_string += ss;

    for (int i = r + 1; i < s.length(); i++)
        new_string += s[i];
}

int main()
{
    freopen("password.in", "r+", stdin);
    freopen("password.out", "w+", stdout);
    string s1, s2, s3;
    cin >> s1 >> s2;
    for (int l = 0; l < s1.size(); l++)
        for (int r = l; r < s1.size(); r++)
        {
            moderate (l, r, s1, s3);
            if (equal_str(s3, s2))
            {
                cout << l + 1 << " " << r + 1;
                fclose(stdin);
                fclose(stdout);
                return 0;
            }
        }
    return 0;
}
