#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>

#define INF 1000000
#define all(c) c.begin(), c.end()

using namespace std;

int main()
{
    freopen("theatre.in", "r+", stdin);
    freopen("theatre.out", "w+", stdout);
    int n, m, k;
    cin >> n >> m;
    vector <int> ans (n + 1, INF);
    vector <int> in_this;
    vector <vector <int> > actors(m);
    vector <set <int> > actors_set(m);
    set <int> first, second;

    for (int q = 0; q < m; q++)
    {
        cin >> k;
        in_this.clear();
        in_this.resize(k);
        for (int i = 0; i < k; i++)
            cin >> in_this[i];

        sort(all(in_this));
        actors[q] = in_this;
        for (int i = 0; i < in_this.size(); i++)
            actors_set[q].insert(in_this[i]);

        int unknown_number = 0;
        for (int i = 0; i < k; i++)
            if (ans[in_this[i]] == INF)
                unknown_number++;

        if (unknown_number == 1)
            for (int i = 0; i < k; i++)
                if (ans[in_this[i]] == INF)
                {
                    ans[in_this[i]] = min (ans[in_this[i]], q);
                    break;
                }

        int unknown_number_2 = 0;
        for (int i = 1; i <= n; i++)
            if (actors_set[q].find(i) == actors_set[q].end() && ans[i] == INF)
                unknown_number_2++;

        if (unknown_number_2 == 1)
            for (int i = 1; i <= n; i++)
                if (actors_set[q].find(i) == actors_set[q].end() && ans[i] == INF)
                {
                    ans[i] = min(ans[i], q);
                    break;
                }

        for (int i = 0; i < q; i++)
        {
            for (int j = i + 1; j <= q; j++)
            {
                first.clear();
                second.clear();

                for (int z = 0; z < actors[i].size(); z++)
                    if (ans[actors[i][z]] == INF && actors_set[j].find(actors[i][z]) == actors_set[j].end())
                        first.insert(actors[i][z]);

                for (int z = 0; z < actors[j].size(); z++)
                    if (ans[actors[j][z]] == INF && actors_set[i].find(actors[j][z]) == actors_set[i].end())
                        second.insert(actors[j][z]);

                if (first.size() == 1)
                    for (int z = 0; z < actors[i].size(); z++)
                        if (ans[actors[i][z]] == INF && actors_set[j].find(actors[i][z]) == actors_set[j].end())
                        {
                            ans[actors[i][z]] = q;
                            break;
                        }

                if (second.size() == 1)
                    for (int z = 0; z < actors[j].size(); z++)
                        if (ans[actors[j][z]] == INF && actors_set[i].find(actors[j][z]) == actors_set[i].end())
                        {
                            ans[actors[j][z]] = q;
                            break;
                        }
            }
        }
    }

    for (int i = 1; i <= n; i++)
        if (ans[i] >= INF)
            ans[i] = -1;

    for (int i = 1; i <= n; i++)
        cout << ans[i] + 1 << " ";

    return 0;
}
