#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;
using std::vector;
using std::pair;

bool compare2 (pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

bool compare1 (pair<int, int> a, pair<int, int> b) {
    return a.first > b.first;
}

int main() {
    ifstream in("mosaic.in");
    ofstream out("mosaic.out");
    int n, k, x, y;
    in >> n;
    vector< pair<int, int> > a(n), b(n);
    for (int i = 0; i < n; ++i) {
        in >> a[i].first >> a[i].second;
    }
    in >> k;
    for (int i = 0; i < k; ++i) {
        in >> x >> y;
        b = a;
        sort(b.begin() + x - 1, b.begin() + y, compare2);
        for (int i = 0; i < n; ++i) {
            out << b[i].first << ' ' << b[i].second << endl;
        }
    }
    in.close();
    out.close();
    return 0;
}
