#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <map>
#include <set>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "apricot"
 
typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;
 
const ll INFLL = 9e18;
ll R, U;
 
int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);
 
  int n;
  while (scanf("%d%I64d%I64d", &n, &R, &U) >= 1) {
    assert(n <= 3000);
    vll d(n + 1, 0);
    d[0] = -INFLL;
 
    for (int x = 2; x <= n; x++) {
      d[x] = INFLL;
      for (int y = 1; 2 * y <= n && y <= x; y++) {
        d[x] = min(d[x], max(R + d[max(0, x - 2 * y)], U + d[y]));
      }
    }	
    printf("%I64d\n", d[n]);
  }
  return 0;
}
