#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
using namespace std;

int mas1[100100], mas2[100100];

vector <int> next1[100100];
vector <int> next2[100100];

vector < pair <int, int> > adress1[100100];
vector < pair <int, int> > adress2[100100];

queue <int> q1;
queue <int> q2;

queue <int> check;

long long values[100100];

bool CMP(int idx1, int idx2) {
	int len1 = adress2[idx1].size();
	int len2 = adress2[idx2].size();
	if(len2 > len1) return 0;
	for(int i = len2 - 1; i >= 0; i--) {
		if(adress2[idx1][i].first != adress2[idx2][i].first || adress2[idx1][i].first == adress2[idx2][i].first && adress2[idx1][i].second < adress2[idx2][i].second) return 0;
	}
	return 1;
}

int main() {
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	int N;
	int start1 = -1, start2 = -1;
	scanf("%d", &N);
	for(int i = 1; i <= N; i++) values[i] = 0;
	for(int i = 1; i <= N; i++) {
		scanf("%d", &mas1[i]);
		next1[mas1[i]].push_back(i);
		if(mas1[i] == 0) start1 = i;
	}
	for(int i = 1; i <= N; i++) {
		scanf("%d", &mas2[i]);
		next2[mas2[i]].push_back(i);
		if(mas2[i] == 0) start2 = i;
	}
	q1.push(start1);
	adress1[start1].push_back(make_pair <int, int>(start1, 0));
	int size = 1;
	while(size > 0) {
		int idx = q1.front();
		q1.pop();
		size--;
		for(int i = 0, j = next1[idx].size(); i < j; i++) {
			int val = next1[idx][i];
			q1.push(val);
			size++;
			if(j == 1) {
				adress1[val] = adress1[idx];
				adress1[val][adress1[val].size() - 1].second++;
			}
			else {
				adress1[val] = adress1[idx];
				adress1[val].push_back(make_pair <int, int>(val, 0));
			}
		}
	}
	q2.push(start2);
	adress2[start2].push_back(make_pair <int, int>(start2, 0));
	size = 1;
	while(size > 0) {
		int idx = q2.front();
		q2.pop();
		size--;
		for(int i = 0, j = next2[idx].size(); i < j; i++) {
			int val = next2[idx][i];
			q2.push(val);
			size++;
			if(j == 1) {
				adress2[val] = adress2[idx];
				adress2[val][adress2[val].size() - 1].second++;
			}
			else {
				adress2[val] = adress2[idx];
				adress2[val].push_back(make_pair <int, int>(val, 0));
			}
		}
	}
	check.push(start1);
	size = 1;
	while(size > 0) {
		int idx = check.front();
		check.pop();
		size--;
		int temp = idx;
		while(mas1[temp] != 0) {
			temp = mas1[temp];
			if(CMP(idx, temp)) {
				values[idx] += values[temp] + 1;
				if(values[temp] != 0) break;
			}
		}
		for(int i = 0, j = next1[idx].size(); i < j; i++) {
			check.push(next1[idx][i]);
			size++;
		}
	}
	long long answer = 0;
	for(int i = 1; i <= N; i++) answer += values[i];
	cout << answer << endl;
	return 0;
}