#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
using namespace std;

struct mos {
	int length;
	int width;
	mos() {
		length = 0;
		width = 0;
	}
};

mos mosaic[100100];
int HavePair[100100];

int SqrtDeq[320];

map < pair <int, int>, int> last;

int main() {
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	for(int i = 0; i < 100100; i++) HavePair[i] = -1;
	for(int i = 0; i < 320; i++) SqrtDeq[i] = -1;
	int N;
	scanf("%d", &N);
	for(int i = 0; i < N; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		mosaic[i].length = a;
		mosaic[i].width = b;
		int lastA = -1;
		int lastB = -1;
		if(last.find(make_pair <int, int>(a, -1)) == last.end()) lastA = -1;
		else lastA = last[ make_pair <int, int>(a, -1) ];
		if(last.find(make_pair <int, int>(-1, b)) == last.end()) lastB = -1;
		else lastB = last[ make_pair <int, int>(-1, b) ];
		HavePair[i] = max(lastA - 1, lastB - 1);
		if(HavePair[i] == -2) HavePair[i] = -1;
		if(HavePair[i] >= 0) {
			if(HavePair[SqrtDeq[i/320]] < HavePair[i]) SqrtDeq[i/320] = i;
		}
		if(lastA + 1 != i) last[ make_pair <int, int>(a, -1) ] = i;
		if(lastB + 1 != i) last[ make_pair <int, int>(-1, b) ] = i;
	}
	int K; 
	scanf("%d", &K);
	for(int x = 0; x < K; x++) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		bool flag = true;
		for(int i = a; i <= b; i++) {
			if(i % 320 == 0 && b - i >= 320) {
				if(HavePair[SqrtDeq[i / 320]]  >= a) {
					flag = false;
					printf("%d %d\n", SqrtDeq[i / 320] + 1, HavePair[SqrtDeq[i / 320]] + 1);
					break;
				}
			}
			else {
				if(HavePair[i]  >= a) {
					flag = false;
					printf("%d %d\n", HavePair[i] + 1, i + 1);
					break;
				}
			}
		}
		if(flag) printf("0 0\n");
	}
	return 0;
}