#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
using namespace std;

int SqrtDeq[400];
int mas[100100][2];
int last[100100];
int LLL[100100][2];

int main() {
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	for(int i = 0; i < 400; i++) SqrtDeq[i] = -1;
	int N;
	scanf("%d", &N);
	for(int i = 0; i < 100100; i++) last[i] = -1;
	for(int i = 0; i < 100100; i++) LLL[i][0] = -1;
	for(int i = 0; i < 100100; i++) LLL[i][1] = -1;
	for(int i = 0; i < N; i++) {
		scanf("%d %d", &mas[i][0], &mas[i][1]);
		bool crit1 = false;
		bool crit2 = false;
		int lll1 = i;
		int lll2 = i;
		for(int j = i - 1; j >= 0;) {
			if(mas[i][0] == mas[j][0]) {
				LLL[i][0] = j;
				lll1 = LLL[j][0];
			}
			if(mas[i][1] == mas[j][1]) {
				LLL[i][1] = j;
				lll2 = LLL[j][1];
			}
			if(mas[i][0] != mas[j][0] && mas[i][1] != mas[j][1]) {
				last[i] = j;
				break;
			}
			if(mas[i][0] == mas[j][0] && mas[i][1] == mas[j][1]) {
				last[i] = last[j];
				break;
			}
			if(last[j] != -1) {
				if(mas[i][0] != mas[last[j]][0] && mas[i][1] != mas[last[j]][1]) {
					last[i] = last[j];
					break;
				}
			}
			else {
				if(mas[i][0] == mas[j][0]) crit1 = true;
				if(mas[i][1] == mas[j][1]) crit2 = true;
			}
			if(crit1 && crit2) {
				last[i] = -1;
				break;
			}
			j = min(j - 1, max(lll1, lll2));
		}
		if(last[i] != -1) {
			if(SqrtDeq[i / 400] == -1) SqrtDeq[i / 400] = i;
			else if(last[SqrtDeq[i / 400]] < last[i]) SqrtDeq[i / 400] = i;
		}
	}
	//for(int i = 0; i < N; i++) printf("%d\n", last[i]);
	int K;
	scanf("%d", &K);
	for(int x = 0; x < K; x++) {
		int a, b;
		scanf("%d %d", &a, &b);
		a--;
		b--;
		bool flag = false;
		for(int i = a; i <= b; i++) {
			if(i % 400 == 0 && b - i >= 400) {
				if(SqrtDeq[i / 400] == -1) continue;
				if(last[SqrtDeq[i / 400]] >= a && SqrtDeq[i / 400] <= b) {
					printf("%d %d\n", last[SqrtDeq[i / 400]] + 1, SqrtDeq[i / 400] + 1);
					flag = true;
					break;
				}
				i += 399;
			}
			else {
				if(last[i] >= a) {
					printf("%d %d\n", last[i] + 1, i + 1);
					flag = true;
					break;
				}
			}
		}
		if(!flag) printf("0 0\n");
	}
	return 0;
}