#include <iostream>
using namespace std;

struct point {
	int x, y;
	point(): x(0), y(0) {};
	//point(int a, int b): x(a), y(b) {};
} horse, eg, maxp, minp;
int m, n;
int pole[40][40]={0};

inline void lim() {
	if(maxp.x>m-horse.x) {
		maxp.x=m-horse.x;
		for(int i=1; i<=n; i++)
			pole[maxp.x+1][i]=1;
	}
	if(maxp.y>n-horse.y) {
		maxp.y=n-horse.y;
		for(int i=1; i<=m; i++)
			pole[i][maxp.y+1]=1;
	}
	if(minp.x<horse.x) {
		minp.x=horse.x;
		for(int i=1; i<=n; i++)
			pole[minp.x-1][i]=1;
	}
	if(minp.y<horse.y) {
		minp.y=horse.y;
		for(int i=1; i<=m; i++)
			pole[i][minp.y-1]=1;
	}
}

point move() {
	if(pole[eg.x][eg.y]==1) return point();
	point d;
	int dist=1000, x, y;
	for(int i=1; i<=m; i++) {
		for(int j=1; j<=n; j++) {
			if(pole[i][j]==1 && dist>abs(i-eg.x)+abs(i-eg.y)) {
				x=i; y=j;
				dist=abs(i-eg.x)+abs(i-eg.y);
			}
		}
	}
	if(x<eg.x) d.x=-1;
	if(x>eg.x) d.x=1;
	if(y<eg.y) d.y=-1;
	if(y>eg.y) d.y=1;
	return d;
}

int main() {
	short dx, dy, ans;
	point d;
	cin >> m >> n;
	maxp.x=m; maxp.y=n;
	cin >> eg.x >> eg.y;
	cout << "0 0 1" << endl;
	cout.flush();
	while(1) {
		cin >> ans >> dx >> dy;
		if(ans==1) break;
		horse.x+=dx;
		horse.y+=dy;
		lim();
		d=move();
		cout << d.x << " " << d.y << " " << "1" << endl;
	}
	return 0;
}