#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

vector<int> a, s, b;

inline int sum(int l, int r)
{
  if (r < l) return 0;
  else return (l) ? s[r] - s[l - 1] : s[r];
}

int main()
{
  ifstream in; in.open("password.in");
  ofstream out; out.open("password.out");

  int n, m, i, j;
  string st, t;
  getline(in, st);
  getline(in, t);

  n = st.length();
  m = t.length();
  a.reserve(n);
  s.reserve(n);
  b.reserve(m);

  for (i = 0; i < n; i++) {
    a.push_back(st[i] - '0');
    s.push_back(sum(0, i - 1) + a[i]);
  }
  for (i = 0; i < m; i++) b.push_back(t[i] - '0');

  int l = 0, r = n;
  while (l < m && a[l] == b[l]) l++;
  while (r - 1 - n + m >= 0 && a[r - 1] == b[r - 1 - n + m]) r--;

  for (i = 0; i < m && i <= l; i++) {
    int x = 0;
    if (!a[i]) {
      bool ok = 1;
      for (j = 0; j <= n - m; j++) if (a[i + j]) ok = 0;
      if (ok && i + j >= r - 1) {
        out << i + 1 << ' ' << i + 1 + n - m;
        return 0;
      }
    } else
      for (j = 0; j < 6 && i + j < m; j++) {
        x = 10 * x + b[i + j];
        int it = lower_bound(s.begin(), s.end(), sum(0, i - 1) + x) - s.begin();
        while (it - i < n - m && !a[it + 1] && it < n) it++;
        if (r - 1 <= it && it < n && s[it] == sum(0, i - 1) + x) {
          out << i + 1 << ' ' << it + 1;
          return 0;
        }
      }
  }
}
