#include <fstream>
#include <string>

using namespace std;

bool check(string& s1, string& s2, int l1, int r1, int l2, int r2){
	string tmp, tmp2;
	tmp.assign(s1.begin() + l1, s1.begin() + r1);
	tmp2.assign(s2.begin() + l2, s2.begin() + r2);
	int need = atoi(tmp2.c_str());
	int cur = 0;
	for(int i = 0; i < tmp.size(); i++){
		cur += tmp[i] - '0';
		if(cur > need){
			return false;
		}
	}
	if(cur != need){
		return false;
	}
	string tmp1, tmp22, tmp3, tmp4;
	tmp1.assign(s1.begin(), s1.begin() + l1);
	tmp3.assign(s2.begin(), s2.begin() + l2);
	if(tmp1 == tmp3){
		tmp22.assign(s1.begin() + r1 , s1.end());
		tmp4.assign(s2.begin() + r2 , s2.end());
		return tmp22 == tmp4;
	} else {
		return false;
	}
}

int main(){
	using namespace std;
	ifstream fin("password.in");
	ofstream fout("password.out");
	string s1, s2;
	fin >> s1 >> s2;
	int l1 = s1.size();
	int l2 = s2.size();
	if(l1 == l2){
		if(s1 == s2){
			fout << 1 << " " << 1;
			return 0;
		} else {
			for(int i = 0; i < s1.size() - 1; i++){
				if(s1[i] - '0' +  s1[i + 1] - '0' == s2[i + 1] - '0' + (s2[i] - '0') * 10){
					fout << i + 1 << " " << i + 2;
					return 0;
				}
			}
		}
	}
	int d = l1 - l2;
	int i = d + 1;
	while(1){
		int end = 0;
		for(int k = i + 1; k < s1.size(); k++){
			if(s1[k] != s2[k - d]){
				end = k;
			}
		}
		for(int j = (end - i > 0 ? end - i : 0); j < l1 - i + 1; j++){
			if(check(s1, s2, j, j + i, j, j + i - d)){
				fout << j + 1 << " " << j + i;
				return 0;
			}
		}
		i++;
	}
	return 0;
}