#include <fstream>
#include <vector>
#include <list>

using namespace std;

void dfs(vector<vector<int> >& A, vector<bool>& used, int q, int& time, vector<int>& tin, vector<int>& tout){
	used[q] = true;
	tin[q] = ++time;
	for(int i = 0; i < A[q].size(); i++){
		if(!used[A[q][i]]) dfs(A, used, A[q][i], time, tin, tout);
	}
	tout[q] = ++time;
}

bool upper(int q, int p, vector<int>& tin, vector<int>& tout){
	return tin[q] > tin[p] && tout[q] < tout[p];
}

int main(){
	using namespace std;
	ifstream fin("virus.in");
	ofstream fout("virus.out");
	int n;
	fin >> n;
	vector<vector<int> > A(n);
	vector<int> tin(n);
	vector<int> tout(n);
	vector<bool> used(n, false);
	int time = 0;
	int boss;
	for(int i = 0; i < n; i++){
		int tmp;
		fin >> tmp;
		tmp--;
		if(tmp == -1){
			boss = i;
			continue;
		}
		A[tmp].push_back(i);
	}
	dfs(A, used, boss, time, tin, tout);
	vector<vector<int> > A2(n);
	vector<int> tin2(n);
	vector<int> tout2(n);
	vector<bool> used2(n, false);
	time = 0;
	for(int i = 0; i < n; i++){
		int tmp;
		fin >> tmp;
		tmp--;
		if(tmp == -1){
			boss = i;
			continue;
		}
		A2[tmp].push_back(i);
	}

	dfs(A2, used2, boss, time, tin2, tout2);
	int cnt = 0;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < n; j++){
			if(i == j) continue;
			cnt += upper(i, j, tin, tout) && upper(i, j, tin2, tout2);
		}
	}
	fout << cnt;
	return 0;
}