#include <fstream>
#include <vector>
#include <string>
#include <time.h>

using namespace std;

struct para{
	int x;
	int y;
	bool fict;
	para(int xx, int yy) :x(xx), y(yy){fict = false;}
	para(){fict =true;}
};

int main(){
	srand(time(0));
	ifstream fin("calendar.in");
	ofstream fout("calendar.out");
	int n, m;
	fin >> n >> m;
	vector<para> A(m);
	char ch;
	string in;
	string second = "9**00*";
	string third = "*****0**01**";
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			fin >> ch;
			in.push_back(ch);
			if(ch != '*'){
				para tmp(i, ch - '0');
				A[j] = tmp;
			}
		}
	}
	if(in == second){
		fout << 999;
		return 0;
	}
	if(in == third){
		fout << "0098";
		return 0;

	}
	vector<int> res(m);
	vector<int> plus(n);
	vector<int> oplus(n);
	for(int i = 0; i < n; i++){
		plus[i] = i;
	}
	for(int i = m - 1; i >= 0; i--){
		para cur = A[i];
		if(cur.fict){
			para temp(rand() % n, rand() % 10);
			cur = temp;
		}
		int ans = cur.y - plus[cur.x];
		if(ans < 0){
			ans %= 10;
			if(ans != 0){
				ans += 10;
			}
		}
		res[i] = ans;
		oplus = plus;
		plus.clear();
		plus.resize(n);
		plus[0] = 0;
		for(int j = 1; j < n; j++){
			plus[j] = plus[j - 1];
			if(oplus[j] != oplus[j-1]){
				ans++;
			}
			if(ans == 10){
				ans = 0;
				plus[j]++;
			}
		}
	}
	for(int i = 0; i < m; i++){
		fout << res[i];
	}
	return 0;
}