#include <fstream>
#include <vector>

using namespace std;

bool contact(pair<int,int>& a, pair<int,int>& b){
	return a.first == b.first || a.second == b.second;
}

int main(){
	ifstream fin("mosaic.in");
	ofstream fout("mosaic.out");
	int n;
	fin >> n;
	vector<pair<int, int> > A(n);
	for(int i = 0; i < n; i++){
		int a, b;
		fin >> a >> b;
		A[i] = make_pair<int, int>(a, b);
	}
	vector<int> con(n, -1);
	for(int i = 0; i < n; i++){
		for(int j = i + 1; j < n; j++){
			if(!contact(A[i], A[j])){
				con[i] = j;
				break;
			}
		}
	}
	int k;
	fin >> k;
	for(int i = 0; i < k; i++){
		int a, b;
		fin >> a >> b;
		--a; --b;
		bool solve = false;
		for(int j = a; j <= b; j++){
			if(con[j] != -1 && con[j] <= b){
				fout << j + 1 << " " << con[j] + 1 << endl;
				solve = true;
				break;
			}
		}
		if(!solve){
			fout << 0 << " " << 0 << endl;
		}
	}
	return 0;
}