#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int main(){
	ifstream fin("theatre.in");
	ofstream fout("theatre.out");
	int n, m, k;
	fin >> n >> m;
	vector<vector<bool> > A(n);
	for(int i = 0; i < n; i++){
		A[i].resize(n);
		for(int j = 0; j < n; j++){
			A[i][j] = false;
		}
		A[i][i] = true;
	}
	vector<int> ans(n, 0);
	for(int i = 0; i < m; i++){
		fin >> k;
		vector<bool> used(n, false);
		for(int j = 0; j < k; j++){
			int tmp;
			fin >> tmp;
			--tmp;
			used[tmp] = true;
		}
		for(int i = 0; i < n; i++){
			for(int j = 0; j < n; j++){
				A[i][j] = A[i][j] || (used[i] != used[j]);
			}
		}
		for(int j = 0; j < n; j++){
			if(ans[j]) continue;
			int cnt = 0;
			for(int t = 0; t < n; t++){
				cnt += A[j][t] || ans[t];
			}
			if(cnt == n){
				ans[j] = i + 1;
			}
		}
	}
	for(int i = 0; i < n; i++){
		fout << ans[i] << " ";
	}
	return 0;
}