#include <iostream>
#include <string>

using namespace std;

#define maxn 100005

string s, t;

int fenv[maxn];

int l;

void add(int x, int k) {
	for (int i = k; i <= l; i += (i & -i))
		fenv[i] += x;
}

int sum(int k) {
	k++;
	int res = 0;
	for (int i = k; i > 0; i -= (i & -i))
		res += fenv[i];
	return res;
}

string its(int x) {
	string res = "";
	while (x != 0) {
		res = char(x % 10 + '0') + res;
		x /= 10;
	}
	return res;
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	
	cin >> s >> t;

	l = s.size();
	
	for (int i = 0; i < s.size(); i++) {
		add(s[i] - '0', i + 1);
	}

	for (int i = 0; i < l; i++) {
		for (int j = i; j < l; j++) {
			int x = sum(j) - sum(i - 1);
			string al = its(x);
			if (s.substr(0, i) + al + s.substr(j + 1, s.size() - j) == t) {
				cout << i + 1 << " " << j + 1;
				return 0;
			}
		}
	}

	return 0;
}