#include <iostream>
#include <string>

using namespace std;

#define maxn 100005

string s, t;

int fenv[maxn];

int l1, l2;

unsigned long long h1[maxn];
unsigned long long h2[maxn];
unsigned long long p[maxn];

void add(int x, int k) {
	for (int i = k; i <= l1; i += (i & -i))
		fenv[i] += x;
}

int sum(int k) {
	k++;
	int res = 0;
	for (int i = k; i > 0; i -= (i & -i))
		res += fenv[i];
	return res;
}

string its(int x) {
	string res = "";
	while (x != 0) {
		res = char(x % 10 + '0') + res;
		x /= 10;
	}
	return res;
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	
	cin >> s >> t;

	p[0] = 1;

	for (int i = 1; i < maxn; i++)
		p[i] = p[i - 1] * 11;

	l1 = s.size();
	l2 = t.size(); 

	while (t.size() != l1) {
		t.push_back('0');
	}

	for (int i = 0; i < l1; i++) {
		h1[i] = p[l1 - i - 1] * (s[i] - '0' + 1);;
		if (i)
			h1[i] += h1[i - 1];
	}

	for (int i = 0; i < l1; i++) {
		h2[i] = p[l1 - i - 1] * (t[i] - '0' + 1);;
		if (i)
			h2[i] += h2[i - 1];
	}

	//cout << h1[2] * p[0] << endl;
	//cout << h1[2] * p[0] << endl;
	//cout << (h2[5] - h2[2]) * p[3] << endl;
	for (int i = 0; i < s.size(); i++) {
		add(s[i] - '0', i + 1);
	}

	for (int i = 0; i < l1; i++) {
		for (int j = i; j < l1; j++) {
			if (i && s[i - 1] != t[i - 1])
				continue;
			int x = sum(j) - sum(i - 1);
			string al = its(x);
			int len = al.size();
			unsigned long long hs1 = 0;
			unsigned long long hs2 = 0;
			if (i) {
				hs1 = h1[i - 1];
				hs2 = h2[i - 1];
			}
			if (hs1 == hs2 && al == t.substr(i, al.size()) && (h1[l1 - 1] - h1[j]) * p[j + 1] == (h2[l2 - 1] - h2[i + len - 1]) * p[i + len]) {
				cout << i + 1 << " " << j + 1;
				return 0;
			}
		}
	}

	return 0;
}