#include <iostream>

using namespace std;

#define maxn 5010

int n, k;

pair <int, int> a[maxn];

int fenv[maxn][maxn];
int al[maxn][maxn];

void add(int x, int y) {
	x++;
	y++;
	for (int i = x; i <= n; i += (i & -i))
		for (int j = y; j <= n; j += (j & -j))
			fenv[i][j]++;
}

int sum(int x, int y) {
//	x++;
//	y++;
	int res = 0;
	for (int i = x; i >= 1; i -= (i & -i))
		for (int j = y; j >= 1; j -= (j & -j))
			res += fenv[i][j];
	return res;
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);

	cin >> n;

	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i >= j) {
				add(i, j);
				al[i][j] = 1;
			}
			else {
				if (a[i].first == a[j].first || a[i].second == a[j].second) {
					add(i, j);
					al[i][j] = 1;
				}
			}
		}
	}

	cin >> k;

	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		int t = sum(y, y) - sum(x - 1, y) - sum(y, x - 1) + sum(x - 1, x - 1);
		int r = (y - x) + 1;
		if (t == r * r)
			cout << "0 0" << endl;
		else {
			int cur = x;
			while (sum(cur, y) - sum(cur - 1, y) == y)
				cur++;
			for (int j = x; j <= y; j++)
				if (al[cur][j] == 0) {
					cout << cur << ' ' << j << endl;
					break;
				}
		}
	}

	return 0;
}