#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100008;

vector <vector <int> > g1, g2;


int H1[MAXN], H2[MAXN];

void dfs1(int v)
{
	int u;
	for(int i = 0; i < g1[v].size(); i++)
	{
		u = g1[v][i];
		H1[u] = H1[v] + 1;
		dfs1(u);
	}
}

void dfs2(int v)
{
	int u;
	for(int i = 0; i < g2[v].size(); i++)
	{
		u = g2[v][i];
		H2[u] = H2[v] + 1;
		dfs2(u);
	}
}


int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	int n, r1, r2, t;
	cin >> n;
	g1.resize(n);
	g2.resize(n);
	for(int i = 0; i < n; i++)
	{
		cin >> t;
		if(!t)
			r1 = i;
		else
			g1[t - 1].push_back(i);
	}
	for(int i = 0; i < n; i++)
	{
		cin >> t;
		if(!t)
			r2 = i;
		else
			g2[t - 1].push_back(i);
	}
	dfs1(r1);
	dfs2(r2);
	int ans = 0;
	for(int i = 0; i < n; i++)
	{
		for(int j = i + 1; j < n; j++)
		{
			if((H1[i] > H1[j] && H2[i] > H2[j]) || (H1[i] < H1[j] && H2[i] < H2[j]))
				++ans;
		}
	}
	cout << ans;
	return 0;
}