#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 100008;
const long long INF = 1e+20;
long long dp[MAXN];
long long r, u;

long long ldp(int n)
{
	if(dp[n] == INF)
	{
		for(int i = 1; 2 * i <= n; i++)
		{
			dp[n] = min(dp[n], max(ldp(i) + u, (n - 2 * i > 0 ? (ldp(n - 2 * i) + r) : 0)));
		}
	}
	return dp[n];
}


int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	int n;

	cin >> n >> r >> u;
	for(int i = 2; i < n + 1; i++)
	{
		dp[i] = INF;
	}
	cout << ldp(n);
	return 0;
}