#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 5008;


struct 
{
	int a, b;
} A[MAXN];


int B[MAXN][MAXN];
vector <vector <int> > g;

int binsearch(int l, int r, int val, int i)
{
	int m;
	while(r - l > 1)
	{
		m = (l + r) / 2;
		if(g[i][m] >= val)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}
	return r;
}


int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	int n, a, b;
	cin >> n;
	g.resize(n);
	for(int i = 0; i < n; i++)
	{
		cin >> A[i].a >> A[i].b;
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++)
		{
			if(i != j)
			{
				if(A[i].a != A[j].a && A[i].b != A[j].b)
				{
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		}
	}
	for(int i = 0; i < n; i++)
	{
		sort(g[i].begin(), g[i].end());
	}
	int m, ans;
	bool flag = false;
	cin >> m;
	for(int j = 0; j < m; j++)
	{
		cin >> a >> b;
		--a;
		--b;
		for(int i = a; i <= b; i++)
		{
			ans = binsearch(-1, (int) g[i].size() - 1, a, i);
			if(g[i][ans] <= b && g[i][ans] >= a)
			{
				flag = true;
				cout << i + 1 << " " << g[i][ans] + 1 << endl;
				break;
			}
		}
		if(!flag)
			cout << "0 0" << endl;
	}

	return 0;
}