#pragma comment(linker, "/STACK:67108864")

#include <iostream>

using namespace std;

const int MAXN = 108;

int A[MAXN][MAXN];
int ans[MAXN];
int n;

bool check(int m, int t)
{
	int a = 0;
	for(int i = 0; i < n; i++)
	{
		if(i != t)
		{
			for(int j = 0; j < m; j++)
			{
				if(A[t][j] != A[i][j])
				{
					++a;
					break;
				}
			}
		}
	}
	return (a == n - 1);
}



int binsearch(int l, int r, int t)
{
	int m;
	while(r - l > 1)
	{
		m = (l + r) / 2;
		if(check(m, t))
			r = m;
		else
			l = m;
	}
	return l;

}



int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	int m, k, t;
	cin >> n >> m;
	for(int i = 0; i < m; i++)
	{
		cin >> k;
		for(int j = 0; j < k; j++)
		{
			cin >> t;
			--t;
			A[t][i] = 1;
		}
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			ans[i] = binsearch(-1, m + 1, i);
		}
	}
	for(int i = 0; i < n; i++)
	{
		cout << (ans[i] == m ? 0 : ans[i] + 1) << " ";
	}
}