program Project2;

{$APPTYPE CONSOLE}
{$O-}

uses
  Math, SysUtils;

var
  per: array[1..4000000, 1..10] of byte;
  tel, stack: array[1..10] of longint;
  used: array[1..10] of boolean;
  cl, cnt, n, i, j, col, k, cur: longint;
procedure makeAll(c: longint);
var
  i: longint;
begin
  if c = n then begin
    inc(cnt);
    for i:= 1 to n do begin
      per[cnt, i]:= stack[i];
    end;
    exit;
  end;

  for i:= 1 to n do begin
    if not used[i] then begin
      inc(c);
      stack[c]:= i;
      used[i]:= true;
      makeall(c);
      dec(c);
      used[i]:= false;
    end;
  end;
end;

function countmax(cnt: longint): longint;
var
  dp: array[1..10000] of longint;
  i, j: longint;
begin
  for i:= 1 to n do begin
    dp[i]:= 1;
  end;

  for i:= 2 to n do begin
    for j:= i-1 downto 1 do begin
      if per[cnt, j] < per[cnt, i] then begin
        dp[i] := max(dp[i], dp[j]+1);
      end;
    end;
  end;
  result:= 0;
  for i:= 1 to n do begin
    result:= max(result, dp[i]);
  end;
end;

begin
  reset(input,'army.in');
  rewrite(output,'army.out');

  readln(n);
  makeAll(0);
  readln(k);
  for i:= 1 to k do begin
    read(tel[i]);
  end;

  col:= 0;
  for i:= 1 to cnt do begin
    cur:= 1;
    cl:= countmax(i);
    if cl <> k then continue;
    for j:= 1 to n do begin
      if per[i, j] = tel[cur] then inc(cur);
    end;
    if cur = k+1 then inc(col);
  end;

  writeln(col);
end.
