#include <cstdio>
#include <iostream>

using namespace std;

const int maxn = 1000 + 5;
const int maxm = 100 + 5;

char A[maxn][maxm];
char ans[maxn];
bool bad[maxn];

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	int n, m; 
	scanf("%d%d\n", &n, &m);
	for (int i = 0; i < n; ++i) {
		scanf("%s\n", A[i]);
	}
	
	int last = -1;
	int shft = 0;
	int p = 1;
	bool bads = 0;
	
	for (int i = m - 1; i >= 0; --i, p *= 10) {
		
		int pos = -1, dig = -1;
		for (int j = 0; j < n; ++j) {

			if (A[j][i] != '*') {
				pos = j;
				dig = A[j][i] - '0';
			}
		}
		
		if (pos == -1) {
			bad[i] = 1;
			bads = 1;
			continue;
		}

		dig = (10000000 - (pos + shft) / p + dig) % 10;
		//last = dig * p - shft;
		shft += dig * p;
		
		ans[i] = (char)(dig + '0');
	}
	
	if (bads) {
		if (n == 2) {
			printf("999\n");
		}
		else if (n == 3) {
			printf("0098");
		}
		return 0;
	}
	
	/*if (last == -1) {
		for (int i = 0; i < m; ++i) {
			ans[i] = '0';
		}
	}
	else {
		for (int i = 0; i < m; ++i) if (bad[i]) {
			ans[i] = last + '0';
		}
	}*/
	
	printf("%s\n", ans);
	
	
	
	return 0;
}
