#include <cstdio>
#include <iostream>

#include <vector>

using namespace std;

#define sz(x) ((int)(x).size())

const int maxn = 10000 + 5;
const int maxm = 10000 + 5;

int last[maxn], prev[maxm], U[maxm];
vector <int> A[maxn], B[maxm];
int K[maxm];
int used[maxn], used2[maxn];
int ans[maxn];

int ucnt = 1;

void add(int v, int u)
{
	U[ucnt] = u;
	prev[ucnt] = last[v];
	last[v] = ucnt;
	++ucnt;
}

/*void add2(int v, int u)
{
	U2[bcnt] = u;
	prev2[bcnt] = last2[v];
	last2[v] = bcnt;
	++bcnt;
}*/


int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	int n, m; scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d", &K[i]);
		for (int j = 0; j < K[i]; ++j) {
			int x; scanf("%d", &x); --x;
			//add(i, x);
			A[i].push_back(x);
		}
	}
	
	int N = n;
	
	int shft2 = 0;
	int shft = 1;
	for (int i = 0; i < m; ++i, ++shft) {
		int cnt = 0;
		for (int j = 0; j < sz(A[i]); ++j) {
			used[A[i][j]] = shft;
			B[i].push_back(A[i][j]);
			++cnt;
		}
		
		int ne = -1;
		
		if (cnt == N - 1) {
			for (int j = 0; j < n; ++j) {
				if (used[j] != shft && !ans[j]) {
					//ans[j] = i + 1;
					//--N;
					ne = j;
					break;
				}
			}
		}
		
		int bcnt = 1;
		
		
		
		for (int j = 0; j < i; ++j) {
			B[j].clear();
			for (int l = 0; l < sz(A[j]); ++l) {
				if (used[A[j][l]] == shft) {
					//add2(j, U[x]);
					//++B[j];
					B[j].push_back(A[j][l]);
				}
			}
			if (sz(B[j]) == 1) {
				ne = B[j][0];
			}
		}
		
		do {
			//cerr << "# " << i + 1 << " " << ne + 1 << endl;
			//cerr << "## " << ne << endl;
			if (ne != -1) {
				ans[ne] = i + 1;
				used[ne] = 0;
				--N;
				int er = ne;
				ne = -1;
				for (int j = 0; j < n; ++j) {
					int to_er = -1;
					for (int l = 0; l < sz(B[j]); ++l) {
						if (B[j][l] == er) {
							to_er = l;
							break;
						}
					}
					if (to_er != -1) {
						B[j].erase(B[j].begin() + to_er);
					}
					
					to_er = -1;
					for (int l = 0; l < sz(A[j]); ++l) {
						if (A[j][l] == er) {
							to_er = l;
							break;
						}
					}
					if (to_er != -1) {
						A[j].erase(A[j].begin() + to_er);
					}
					
					//cerr << sz(B[j]) << endl;
					
					if (sz(B[j]) == 1) {
						ne = B[j][0];
					}
				}	
			}

			if (ne == -1) {
				for (int j = 0; j < i; ++j) {
					//cerr << "ye\n";
					//cerr << i << ": " << sz(A[j]) << " " << sz(A[i]) << endl;
					if (sz(A[j]) - 1 == sz(A[i])) {
						//cerr << "ye\n";
						for (int l = 0; l < sz(A[j]); ++l) {
							if (used[A[j][l]] != shft) {
								ne = A[j][l];
								break;
							}
						}
						break;
					}
				}
			}
			
			if (ne == -1) {
				for (int j = 0; j < i; ++j) {
					//cerr << "ye\n";
					//cerr << i << ": " << sz(A[j]) << " " << sz(A[i]) << endl;
					if (sz(A[j]) + 1 == sz(A[i])) {
						//cerr << "ye\n";
						++shft2;
						for (int l = 0; l < sz(A[j]); ++l) {
							/*if (used[A[j][l]] != shft) {
								ne = A[j][l];
								break;
							}*/
							used2[A[j][l]] = shft2;
						}
						
						for (int l = 0; l < sz(A[i]); ++l) {
							if (used2[A[i][l]] != shft2) {
								ne = A[i][l];
								break;
							}
						}
						
						break;
					}
				}
			}
			

			if (ne == -1 && sz(A[i]) == 1) {
				ne = A[i][0];
			}
	
			
		} while (ne != -1);
	}
	
	for (int i = 0; i < n; ++i) {
		printf("%d ", ans[i]);
	}
	
	return 0;
}
