#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

string inttostr(int n)
{
	ostringstream ss;
	ss << n;
	return ss.str();
}

string encode_string(string &a, int i, int j)
{
	if (i == j)
		return a;
	int result = 0;
	for (int k = i; k <= min((int)a.length(), j); k++)
	{
		result += a[k] - '0';
	}
	return a.substr(0, i) + inttostr(result) + a.substr(j + 1, a.length() - j - 1);
}

void solve1(string &a, string &b)
	// expected 60
{
	for (int i = 0; i < (int)a.length(); i++)
	{
		for (int j = i; j < (int)a.length(); j++)
		{
			string temp = encode_string(a, i, j);
			if (temp == b)
			{
				cout << i + 1 << " " << j + 1 << "\n";
				return void();
			}
		}
	}
	throw -1;
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
#else
	freopen("password.in", "r", stdin);
	freopen("password.out", "w+", stdout);
#endif

	string a, b;
	cin >> a >> b;

	solve1(a, b);

	return 0;
}