#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

vector <int> rev;
void solve1(vector <int> &a, vector <int> &b)
{
	int answer = 0;
	rev.resize(a.size());
	for (int i = 0; i < a.size(); i++)
	{
		int a_cur = a[i], b_cur = b[i];
		
		while (a_cur != -1)
		{
			rev[a_cur] = i + 1;
			a_cur = a[a_cur];
		}

		while (b_cur != -1)
		{
			if (rev[b_cur] == i + 1)
			{
				answer++;
#ifdef CUCUMBER
				cerr << "for " << i + 1 << " found " << 1 + b_cur << "\n";
#endif
			}
			b_cur = b[b_cur];

		}
	}
	
	cout << answer << "\n";
	return void();
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w+", stdout);
#endif

	int n;
	cin >> n;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; i++)
		cin >> a[i], a[i]--;
	for (int i = 0; i < n; i++)
		cin >> b[i], b[i]--;

	solve1(a, b);

	return 0;
}