#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

const int max_calling = 10000;
void solve_rand(int maxx, int maxy, int x0, int y0)
{
	for (int i = 0; i < max_calling; i++)
	{
		int dx, dy, result;
		dx = rand() & 1 == 0 ? 0 : 1;
		dy = rand() & 1 == 0 ? 0 : 1; 
		cout << dx << " " << dy << " 1\n";
		cout.flush();

		cin >> result >> dx >> dy;
		if (result == 1)
			exit(0);
	}
	throw -1;
}

int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	// pass
#endif

	int maxx, maxy;
	cin >> maxx >> maxy;
	int x0, y0;
	cin >> x0 >> y0;
	srand(maxx * maxy + maxx * x0 - maxy * y0);
	solve_rand(maxx, maxy, x0, y0);

	return 0;
}