program z6;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  a: array [1..10000, 1..10000] of boolean;
  b: array [1..10000] of longint;
  c: array [1..10000] of longint;
  d: array [1..10000] of longint;
  i, j, h, g, n, m, k: longint;

procedure qsort(l, r: longint);
var
  i, j, x, buf: longint;
begin
  i := l;
  j := r;
  x := b[(l + r) div 2];
  while i < j do
  begin
    while b[i] < x do
      inc(i);
    while b[j] > x do
      dec(j);
    if i <= j then
    begin
      buf := b[i];
      b[i] := b[j];
      b[j] := buf;
      inc(i);
      dec(j);
    end;
  end;
  if j > l then
    qsort(l, j);
  if i < r then
    qsort(i, r);
end;

begin
  reset(input, 'theatre.in');
  rewrite(output, 'theatre.out');
  read(n, m);
  for i := 1 to n do
  begin
    c[i] := n;
    for j := 1 to n do
      a[i, j] := true;
  end;
  for i := 1 to m do
  begin
    read(k);
    for j := 1 to k do
      read(b[j]);
    qsort(1, k);
    for j := 1 to k do
    begin
      g := 1;
      for h := 1 to n do
        if h = b[g] then
          inc(g)
        else
        begin
          if a[h, b[j]] then
          begin
            dec(c[h]);
            dec(c[b[j]]);
            if c[h] = 1 then
              d[h] := i;
            if c[b[j]] = 1 then
              d[b[j]] := i;
          end;
          a[h, b[j]] := false;
          a[b[j], h] := false;
        end;
    end;
  end;
  for i := 1 to n do
    write(d[i], ' ');
end.
