#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef pair < int, int > pii;
typedef long long ll;

vector < pii > a;
vector < int > next;
int n, k;

int solve()
{
    scanf("%d", &n);
    a.resize(n);
    next.resize(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d", &a[i].first, &a[i].second);
    }
    for (int i = 0; i < n; i++)
    {
        next[i] = -1;
        for (int j = i + 1; j < n; j++)
        {
            if (a[i].first != a[j].first && a[i].second != a[j].second)
            {
                next[i] = j;
                break;
            }
        }
    }
    scanf("%d", &k);
    for (int i = 0; i < k; i++)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        x--, y--;
        bool flag = true;
        for (int j = x; j <= y; j++)
        {
            if (next[j] != -1 && next[j] <= y)
            {
                //cerr << a[j].first << " " << a[j
                printf("%d %d\n", j + 1, next[j] + 1);
                flag = false;
                break;
            }
        }
        if (flag)
            printf("%d %d\n", 0, 0);
    }
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
#endif

    solve();
    
    return 0;
}
