#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef pair < int, int > pii;
typedef long long ll;

int n, m;
int x0, y0;

bool isPole(int x, int y)
{
    return (x >= 0 && x < n && y >= 0 && y < m);
}

void make_step(int dx, int dy, int call)
{
    printf("%d %d %d\n", dx, dy, call);
    fflush(stdout);
}

int solve()
{
    scanf("%d%d", &n, &m);
    scanf("%d%d", &x0, &y0);
    x0--, y0--;
    
    for (;;)
    {
        int dx = 0, dy = 1;
        if (isPole(x0 + dx, y0 + dy))
        {
            make_step(dx, dy, 1);
        }
        else
        {
            dy = -dy;
            make_step(dx, dy, 1);
        }
        x0 += dx;
        y0 += dy;
        int ans, sx, sy;
        scanf("%d %d %d", &ans, &sx, &sy);
        if (ans == 1)
            break;
    }
}

int main()
{
#ifdef OFFLINE_JUDGE
    //freopen("input.txt", "r", stdin);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    solve();
    
    return 0;
}
