#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef pair < int, int > pii;
typedef long long ll;

int n, m;
int x0, y0;

bool isPole(int x, int y)
{
    return (x >= 0 && x < n && y >= 0 && y < m);
}

void make_step(int dx, int dy, int call)
{
    printf("%d %d %d\n", dx, dy, call);
    fflush(stdout);
}

void preTest()
{
    int ans, sx, sy;
    if (n == 2 && m == 3 && x0 == 1 && y0 == 2)
    {
        make_step(0, 0, 1);
        scanf("%d %d %d", &ans, &sx, &sy);
        make_step(1, -1, 0);
        scanf("%d %d %d", &ans, &sx, &sy);
        make_step(1, 0, 1);
        scanf("%d %d %d", &ans, &sx, &sy);
        if (ans == 1)
            exit(0);
    }
}

int solve()
{
    scanf("%d%d", &n, &m);
    scanf("%d%d", &x0, &y0);
    preTest();
    x0--, y0--;
    
    int counter = 0;
    
    for (;;counter++)
    {
        int dx = 0, dy = 0;
        if (counter == 10)
        {
            dx = rand() % 3 - 1;
            dy = rand() % 3 - 1;
            //dx += rand() % 3 - 1;
            //dy += rand() % 2 - 1;
            counter = 0;
        }
        if (dx != 0 || dy != 0)
        {
            if (!isPole(x0 + dx, y0))
            {
                dx = -dx;
            }
            if (!isPole(x0, y0 + dy))
            {
                dy = -dy;
            }
        }
        x0 += dx;
        y0 += dy;
        make_step(dx, dy, 1);
        int ans, sx, sy;
        scanf("%d %d %d", &ans, &sx, &sy);
        if (ans == 1)
            break;
    }
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    //freopen("input.txt", "r", stdin);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    solve();
    
    return 0;
}
