program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 100000;

type
  tar = array[1..MaxN] of integer;
  p = array[1..2] of integer;

var
  n, i, step, k, count, s, f, trc: integer;
  a, b: tar;
  ans: array[1..MaxN] of p;

procedure sort(var a, num: tar; l, r: integer);
var
  i, j, t, m: integer;
begin
  if l >= r then
    exit;
  i := l;
  j := r;
  t := a[(l + r) div 2];
  while (i < j) do begin
    while (t > a[i]) do inc(i);
    while (t < a[j]) do dec(j);
    if (i <= j) then begin
      m := a[i];
      a[i] := a[j];
      a[j] := m;
      m := num[i];
      num[i] := num[j];
      num[j] := m;
      inc(i);
      dec(j);
    end;
  end;
  sort(a, num, i, r);
  sort(a, num, l, j);
end;

procedure init(var a, numa, cola: tar);
var
  i, c: integer;
begin
  c := 1;
  cola[numa[1]] := c;
  for i := 2 to n do begin
    if (a[i] <> a[i - 1]) then begin
      inc(c);
      cola[numa[i]] := c;
    end else
      cola[numa[i]] := c;
  end;
end;

procedure proc(var x: p; k: integer);
var
  i, j, t1, t2: integer;
begin
  t1 := k * step + 1;
  t2 := (k + 1) * step;
  x[1] := 0;
  x[2] := 0;
  for i := t1 to t2 do
    for j := i + 1 to t2 do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
        x[1] := i;
        x[2] := j;
        exit;
      end;
end;

procedure solve;
var
  i, j, t, s, f: integer;
begin
  t := n div step;
  trc := t;
  count := t;
  for i := 1 to t do begin
    proc(ans[i], i - 1);
  end;
  if (t * step) <> n then begin
    s := (t * step) + 1;
    inc(count);
    f := n;
    for i := s to f do
      for j := i + 1 to f do
        if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
          ans[t + 1, 1] := i;
          ans[t + 1, 2] := j;
          exit;
        end;
  end;
end;

function privat(l, r: integer): boolean;
var
  i, j: integer;
begin
  result := false;
  for i := l to r do
    for j := i + 1 to r do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
          writeln(i, ' ', j);
          result := true;
          exit;
        end;
end;

procedure answer(s, f: integer);
var
  i, t1, t2: integer;
begin
  if (s - 1) mod step = 0 then begin
    t1 := ((s - 1) div step) + 1;
  end else
    t1 := ((s - 1) div step) + 2;
  t2 := f div step;
  if f = n then
    t2 := count;
  for i := t1 to t2 do begin
    if ans[i, 1] <> 0 then begin
      writeln(ans[i, 1], ' ', ans[i, 2]);
      exit;
    end;
  end;
  if privat(s, f) = true then
    exit;
  writeln(0,' ', 0);
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  readln(n);
  for i := 1 to n do begin
    readln(a[i], b[i]);
  end;
  //step := trunc(sqrt(n));
  //solve;
  readln(k);
  for i := 1 to k do begin
    readln(s, f);
    if privat(s, f) = false then
      writeln(0, ' ', 0);
  end;
end.
