program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 16;

var
  n, k, i, ans: integer;
  a, min, g: array[0..MaxN] of integer;
  use: array[1..MaxN] of boolean;

function bin(x: integer): integer;
var
  l, r, m: integer;
begin
  l := 0; r := n + 1;
  while r - l > 1 do begin
    m := (l + r) div 2;
    if min[m] > x then
      r := m
    else
      l := m;
  end;
  result := l;
end;

procedure solve;
var
  i, j, t, fm, am, tm: integer;
begin
  min[0] := 0;
  for i := 1 to n do
    min[i] := MaxN + 1;
  fm := 0;
  for i := 1 to n do begin
    t := bin(g[i]);
    min[t + 1] := g[i];
    if t + 1 > fm then
      fm := t + 1;
  end;
  if fm <> k then
    exit;
  j := 1;
  am := 0;
  tm := n + 1;
  for i := 1 to n do begin
    if g[i] = a[j] then begin
      if (tm < a[j]) and (tm > a[j - 1]) then
        exit;
      inc(j);
      tm := n + 1;
    end else if tm > g[i] then begin
      tm := g[i];
    end;
  end;
  if (j - 1) = k then
    inc(ans);
end;

procedure gen(n1: integer);
var
  i: integer;
begin
  if n1 = 0 then begin
    solve;
    exit;
  end;
  for i := 1 to n do
    if use[i] = false then begin
      use[i] := true;
      g[n - n1 + 1] := i;
      gen(n1 - 1);
      use[i] := false;
    end;
end;

begin
  reset(input, 'army.in');
  rewrite(output, 'army.out');
  readln(n);
  readln(k);
  for i := 1 to k do
    read(a[i]);
  ans := 0;
  gen(n);
  writeln(ans);
end.
 