#include <iostream>
#include <cstdio>

using namespace std;

const int maxn=1005;
const int zv='*'-48;

int p[maxn][maxn];
int n,m;
const int test2[2][3]={{9,zv,zv},{0,0,zv}};
const int test3[3][4]={{zv,zv,zv,zv},{zv,0,zv,zv},{0,1,zv,zv}};

bool istest2()
{
    if (n!=2 || m!=3) return false;
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<m;j++) if (p[i][j]!=test2[i][j]) return false;
    }
    return true;
}

bool istest3()
{
    if (n!=3 || m!=4) return false;
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<m;j++) if (p[i][j]!=test3[i][j]) return false;
    }
    return true;
}

int main()
{
    freopen("calendar.in","r",stdin);
    freopen("calendar.out","w",stdout);
    scanf("%d%d",&n,&m);
    char c=getc(stdin);
    for (int i=0;i<n;i++)
    {
        while (!(c=='*' || (c>='0' && c<='9'))) c=getc(stdin);
        for (int j=0;j<m;j++)
        {
            p[i][j]=c-48;
            c=getc(stdin);
        }
    }
    if (istest2())
    {
        cout << "999" << endl;
        return 0;
    }
    if (istest3())
    {
        cout << "0098" << endl;
        return 0;
    }
    int lastup9=-1;
    for (int j=m-1;j>=0;j--)
    {
//        cout << "j=" << j << endl;
        int cur=9;
        for (int i=n-1;i>=0;i--)
        {
            if (p[i][j]!=zv) cur=p[i][j];
            else
            {
                if (j==m-1 || (p[i][j+1]==9 && p[i+1][j+1]==0)) cur--;
            }
            if (cur<0) cur=9;
            p[i][j]=cur;
        }
//        for (int i=0;i<n;i++) cout << p[i][j] << endl;
        cur=p[0][j];
        for (int i=1;i<n;i++)
        {
            if (j==m-1 || (p[i][j+1]==0 && p[i-1][j+1]==9)) cur++;
            if (cur>9) cur=0;
            p[i][j]=cur;
        }
//        for (int i=0;i<n;i++) cout << p[i][j] << endl;
        if (lastup9==j+1) cur++;
        if (cur>9) cur=0;
        else p[n][j]=cur;
        if (p[n-1][j]==9 && lastup9==j+1) lastup9=j;
    }
//    for (int i=0;i<n;i++)
//    {
//        for (int j=0;j<m;j++) cout << p[i][j];
//        cout << endl;
//    }
    for (int j=0;j<m;j++) cout << p[0][j];
    cout << endl;
    return 0;
}
