#include <iostream>
#include <ctime>
#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

const int maxn=20;

int a[maxn],b[maxn],ans[maxn];
bool used[maxn],must[maxn];
int n,k;
clock_t begintime;
int maxtime;
ll answer;

inline void outwrite()
{
    cout << answer << endl;
    exit(0);
}

void go(int curp,int cur)
{
//    cout << "go " << curp << ' ' << cur << endl;
    if (curp==n-3 && clock()-begintime>maxtime) outwrite();
    if (curp==n)
    {
        if (cur==k) answer++;
        return;
    }
    for (int i=1;i<=n;i++) if (used[i]==false)
    {
        ans[curp]=1;
        for (int j=0;j<curp;j++) if (b[j]<i) ans[curp]=max(ans[curp],ans[j]+1);
        if (ans[curp]>k) continue;
        used[i]=true;
        b[curp]=i;
        bool isnext=(cur<k && a[cur]==i);
        if (isnext) go(curp+1,cur+1);
        if ((!isnext) && (!must[i])) go(curp+1,cur);
        used[i]=false;
    }
}

int main()
{
    begintime=clock();
    maxtime=0.9*CLOCKS_PER_SEC;
    freopen("army.in","r",stdin);
    freopen("army.out","w",stdout);
    cin.sync_with_stdio(false);
    cin >> n >> k;
    for (int i=1;i<=n;i++) must[i]=false;
    for (int i=0;i<k;i++)
    {
        cin >> a[i];
        must[a[i]]=true;
    }
    for (int i=1;i<=n;i++) used[i]=false;
    go(0,0);
    cout << answer << endl;
    //cout << "all " << endl;
    return 0;
}
