{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbA;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  MaxN = 100000;

type
  int = longint;

var
  s1, s2: string;
  len1, len2, i: int;
  d: int;
  lmax, rmin, rmin2: int;
  sum: array[0..MaxN] of int;

function get1(i, d: int): int;
begin
  result := sum[i + d - 1] - sum[i - 1];
end;

function get2(i, d: int): int;
var
  l: int;
begin
  result := 0;
  l := i;
  while l < i + d do begin
    result := result * 10 + ord(s2[l]) - ord('0');
    inc(l);
  end;
end;

function prov(i, d, s: int): boolean;
var
  cs, ii: int;
begin
  cs := 0;
  ii := i;
  while (ii <= len2) and ((cs < s) or (len2 - ii <> len1 - i))do begin
    cs := cs * 10 + ord(s2[ii]) - ord('0');
    inc(ii);
  end;
  result := (cs = s) and (ii - 1 >= rmin2);
end;

procedure doit(d: int);
var
  i: int;
begin
  i := min(lmax + 1, len1 - d + 1);
  while i >= 1 do begin
    if i + d - 1 < rmin then exit;
    {if i + d - 1 > len2 then begin
      dec(i);
      continue;
    end;}
    if prov(i, d, get1(i, d)) then begin
      writeln(i, ' ', i + d - 1);
      halt(0);
    end;
    dec(i);
  end;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');

  readln(s1);
  len1 := length(s1);
  readln(s2);
  sum[0] := 0;
  for i := 1 to len1 do
    sum[i] := sum[i - 1] + ord(s1[i]) - ord('0');
  len2 := length(s2);
  lmax := 1;
  while (lmax <= len2) and (s1[lmax] = s2[lmax]) do
    inc(lmax);
  rmin := len1;
  rmin2 := len2;
  while (rmin2 >= 1) and (s1[rmin] = s2[rmin2]) do begin
    dec(rmin);
    dec(rmin2);
  end;
  for d := 1 to 6 do
    doit(d);

  close(input);
  close(output);
end.
 