{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbA_2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  MaxN = 100000;

type
  int = longint;

var
  s1, s2: string;
  len1, len2, i: int;
  d: int;
  lmax, rmin, rmin2: int;
  sum: array[0..MaxN] of int;

function get1(l, r: int): int;
begin
  result := sum[r] - sum[l - 1];
end;

function get2(i, d: int): int;
var
  l: int;
begin
  result := 0;
  l := i;
  while l < i + d do begin
    result := result * 10 + ord(s2[l]) - ord('0');
    inc(l);
  end;
end;

function prov(i, d: int; var cur: int): boolean;
var
  cs, s: int;
begin
  cs := get2(i, d);
  cur := len2 - (i + d - 1);
  cur := len1 - cur;
  s := get1(i, cur);
  result := s = cs;
end;

procedure doit(d: int);
var
  i, cur: int;
begin
  i := min(lmax + 1, len2 - d + 1);
  while i >= 1 do begin
    if i + d - 1 < rmin2 then exit;
    if prov(i, d, cur) then begin
      writeln(i, ' ', cur);
      halt(0);
    end;
    dec(i);
  end;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');

  readln(s1);
  len1 := length(s1);
  readln(s2);
  sum[0] := 0;
  for i := 1 to len1 do
    sum[i] := sum[i - 1] + ord(s1[i]) - ord('0');
  len2 := length(s2);
  lmax := 1;
  while (lmax <= len2) and (s1[lmax] = s2[lmax]) do
    inc(lmax);
  rmin := len1;
  rmin2 := len2;
  while (rmin2 >= 1) and (s1[rmin] = s2[rmin2]) do begin
    dec(rmin);
    dec(rmin2);
  end;
  for d := 1 to 6 do
    doit(d);

  close(input);
  close(output);
end.
 