{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC_3;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 1000000;

type
  int = longint;

var
  r, u: int;
  i, n, j: int;
  d: array[1..MaxN] of int;

procedure get(n: int);
var
  i: int;
begin
  if n < 2 then begin
    d[n] := 0;
    exit;
  end;
  if d[n] > -1 then exit;
  i := 1;
  while i * 2 <= n do begin
    if i + i = n then begin
      get(i);
      if d[n] <> -1 then
        d[n] := min(d[n], d[i] + u)
      else
        d[n] := d[i] + u;
    end
    else begin
      get(i);
      get(n - 2*i);
      if d[n] <> -1 then
        d[n] := min(d[n], max(d[n - 2*i] + r, d[i] + u))
      else
        d[n] := max(d[n - 2*i] + r, d[i] + u);
    end;
    inc(i);
  end;
end;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(n, r, u);
  for i := 1 to n do
    d[i] := -1;
  get(n);
  writeln(d[n]);
  close(input);
  close(output);
end.
