{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC_4;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 1000000;
  INF = int64(1000000000)*int64(1000000000);
  //inf = 100000;
type
  int = int64;

var
  r, u: int;
  i: integer;
  m: int;
  d: array[0..MaxN] of int;
 
function getans(n, i: int): int;
var
  j, ii: int;
begin
  result := INF;
  j := max(0, i * 2 - n);
  //if j > 1 then break;
  if j = 0  then begin
    if i + i = n then
      result := min(result, d[i] + u)
    else
      result := min(result, max(d[n-i-i] + r, d[i] + u));
  end else begin
    ii := j div 2;
      if (i - ii >= 0) and (i - (j - ii) >= 0) then
        result := min(result, max(d[i - ii], d[i - (j - ii)]) + u);
  end;
  d[n] := min(d[n], result);
end;

procedure get(n: int);
var
  le, re, i1, i2, g1, g2: int;
begin
  if n < 2 then begin
    d[n] := 0;
    exit;
  end;
  if d[n] <> INF then exit;
  d[n] := max(d[n - 2] + r, u);
  le := 1;
  re := m div 2;
  while le <= re do begin
    i1 := le + (re - le) div 3;
    i2 := le + (re - le) div 3 * 2;
    g1 := getans(n, i1);
    if le = re then
      break;
    g2 := getans(n, i2);
    if g1 < g2 then
      re := i2 - 1
    else
      le := i1 + 1;
  end;
end;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(m, r, u);
  for i := 2 to m do
    d[i] := INF;
  for i := 2 to m do
    get(i);
  //get(m);

  {for i := 1 to m do
    write(d[i], ' ');
  writeln;
   }
   
  writeln(d[m]);
  close(input);
  close(output);
end.
