{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbA;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 5000;

type
  int = longint;

var
  aa, bb: array[1..MaxN] of int;
  a: array[0..MaxN, 0..MaxN] of int;
  b: array[1..MaxN, 1..MaxN] of boolean;
  n, k: int;
  l, r: int;
  i, j, w1, w2: int;

function get(var l1, l2, r1, r2: int): int;
begin
  result := a[r1][r2] - a[l1-1][r2] - a[r1][l2-1] + a[l1-1][l2-1];
end;

procedure find(l1, r1, l2, r2: int; var w1, w2: int);
var
  m1, m2: int;
begin
  if (l1 > r1) or (l2 > r2) then exit;
  if b[r1, r2] then begin
    w1 := r1;
    w2 := r2;
    exit;
  end;
  if get(l1, l2, r1, r2) = 0 then
    exit;
  m1 := (l1 + r1) div 2;
  m2 := (l2 + r2) div 2;
  find(l1, m1, l2, m2, w1, w2);
  if w1 <> 0 then exit;
  find(l1, m1, m2 + 1, r2, w1, w2);
  if w1 <> 0 then exit;
  find(m1 + 1, r1, l2, m2, w1, w2);
  if w1 <> 0 then exit;
  find(m1 + 1, r1, m2 + 1, r2, w1, w2);
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');

  read(n);
  for i := 1 to n do
    read(aa[i], bb[i]);
  for i := 1 to n do
    for j := 1 to n do
      if (aa[i] <> aa[j]) and (bb[i] <> bb[j]) then begin
        a[i, j] := 1;
        b[i, j] := True;
      end;
  for i := 1 to n do
    for j := 1 to n do
      a[i][j] := a[i][j] + a[i-1][j] + a[i][j-1] - a[i-1][j-1];
  read(k);
  for i := 1 to k do begin
    read(l, r);
    if get(l, l, r, r) = 0 then
      writeln('0 0')
    else begin
      w1 := 0;
      w2 := 0;
      find(l, r, l, r, w1, w2);
      writeln(w1, ' ', w2);
    end;
  end;


  close(input);
  close(output);
end.
 