#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

vector < long > p;
vector < long > xd;
vector < char > used;
long n, m;
long long ans = 0, sm = 0;
void check() {
    sm++;
    vector < long > d(n, 0);
    long i, j, mx = 0;
    for(i = 1; i < n; i++) {
        for(j = 0; j < i; j++)
            if(p[j] < p[i])
                d[i] = max(d[i], d[j] + 1);
        mx = max(mx, d[i]);
    }
    mx++;
    if(mx > m)
        return;
    for(i = 0, j = 0; i < n; i++)
        if(p[i] + 1 == xd[j])
            j++;
    if(j == m)
        ans++;
}
void step(long pos = 0) {
    long i;
    if(pos == n) {
        check();
        return;
    }
    for(i = 0; i < n; i++) {
        if(!used[i]) {
            used[i] = true;
            p[pos] = i;
            step(pos + 1);
            used[i] = false;
        }
    }
}
int main()
{
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);
    long i;
    cin >> n >> m;
    p.assign(n, 0);
    xd.assign(m, 0);
    used.assign(n, false);
    for(i = 0; i < m; i++)
        cin >> xd[i];
    step(0);
    cout << ans << endl;
    return 0;
}
