#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxlen 100500

using namespace std;

char f[maxlen], s[maxlen];
int pos1, pos2, max_l, max_r;
int len_f, len_s;
int sum_s[maxlen], sum_f[maxlen];

bool ok(const int &l, const int &r, const int &x_sum){
    int len_seg = len_s - r;
    int l1 = l, r1 = len_f - len_seg, sum1 = sum_f[r1] - sum_f[l1 - 1];
    return(len_seg <= max_r && sum1 == x_sum);
}

int main(){
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);

    scanf(" %s %s", f, s);
    len_f = strlen(f);
    len_s = strlen(s);
    max_l = max_r = 0;
    int i1 = 0, j1 = 0;
    while(i1 < len_f && j1 < len_s && f[i1] == s[j1]){
        ++max_l;
        ++i1;
        ++j1;
    }
    i1 = len_f - 1;
    j1 = len_s - 1;
    while(i1 >= 0 && j1 >= 0 && f[i1] == s[j1]){
        ++max_r;
        --i1;
        --j1;
    }
    //cerr << "max_l = " << max_l << "\nmax_r = " << max_r << endl;
    sum_f[0] = sum_s[0] = 0;
    for(int i = 0; i < len_f; ++i)sum_f[i + 1] = sum_f[i] + int(f[i] - '0');
    for(int i = 0; i < len_s; ++i)sum_s[i + 1] = sum_s[i] + int(s[i] - '0');
    for(int i = 1; i <= len_s; ++i)
        if(i - 1 <= max_l){
            int cur_sum = 0;
            if(f[i - 1] == 0){
                if(ok(i, i, cur_sum)){
                    pos1 = i;
                    pos2 = len_f - len_s + i;
                }
            }
            else{
                int j = i;
                while(j <= len_s && cur_sum <= 1000000){
                    cur_sum = cur_sum * 10 + int(s[j - 1] - '0');
                    if(ok(i, j, cur_sum)){
                        pos1 = i;
                        pos2 = len_f - len_s + j;
                    }
                    ++j;
                }
            }
        }

    printf("%d %d\n", pos1, pos2);

    return 0;
}
