#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 100500
#define maxm 300000

using namespace std;

struct edge{int x, next;};

int n, num = 0, num_v = 0, cur_par;
int root, root_v;
int cur = 0, cur_v = 0;
edge sm[maxm], sm_v[maxm];
int beg[maxn], en[maxn];
int beg_v[maxn], en_v[maxn];
bool used[maxn], used_v[maxn];
long long res = 0;
int tin[maxn], tout[maxn], tin_v[maxn], tout_v[maxn];

int add_edge(const int &x, const int &y, int &number, int *beg_m, int *en_m, edge *sm_m){
    sm_m[number].x = y;
    sm_m[number].next = 0;
    if(beg_m[x] == 0)beg_m[x] = number;
    if(en_m[x] != 0)sm_m[en_m[x]].next = number;
    en_m[x] = number;
    ++number;
    return 0;
}

int DFS(const int &id){
    ++cur;
    used[id] = true;
    tin[id] = cur;
    int i = beg[id];
    while(i != 0){
        if(!used[sm[i].x])DFS(sm[i].x);
        i = sm[i].next;
    }
    ++cur;
    tout[id] = cur;
    return 0;
}

int DFS1(const int &id){
    ++cur_v;
    used_v[id] = true;
    tin_v[id] = cur_v;
    int i = beg_v[id];
    while(i != 0){
        if(!used_v[sm_v[i].x])DFS1(sm_v[i].x);
        i = sm_v[i].next;
    }
    ++cur_v;
    tout_v[id] = cur_v;
    return 0;
}

int main(){
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);
    for(int i = 1; i <= n; ++i){
        scanf("%d", &cur_par);
        if(cur_par != 0){
            add_edge(i, cur_par, num, beg, en, sm);
            add_edge(cur_par, i, num, beg, en, sm);
        }
        else root = i;
    }
    for(int i = 1; i <= n; ++i){
        scanf("%d", &cur_par);
        if(cur_par != 0){
            add_edge(i, cur_par, num_v, beg_v, en_v, sm_v);
            add_edge(cur_par, i, num_v, beg_v, en_v, sm_v);
        }
        else root_v = i;
    }
    DFS(root);
    DFS1(root_v);
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j)
            if(i != j && tin[i] < tin[j] && tout[i] > tout[j] && tin_v[i] < tin_v[j] && tout_v[i] > tout_v[j])++res;

    cout << res << endl;

    return 0;
}
