#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 100500

using namespace std;

const long long ll = 1001123, osn = 1000000007;

int n, k, num = 1;
int ans[maxn];
long long cur_hash[maxn];
int r[maxn];
int sm[maxn], id[maxn];

bool ok(const int &x, const int &act){
    for(int i = 1; i <= n; ++i)cur_hash[i] = 0;
    for(int i = 1; i <= r[act]; ++i){
        cur_hash[sm[i]] = ((cur_hash[sm[i]] * ll) % osn + id[i]) % osn;
    }
    long long to_find = cur_hash[x];
    sort(cur_hash + 1, cur_hash + n + 1);
    int num = 0;
    for(int i = 1; i <= n; ++i)if(cur_hash[i] == to_find)++num;
    return(num == 1);
}

int main(){
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d%d", &n, &k);
    r[0] = 0;
    for(int i = 1; i <= k; ++i){
        int cnum;
        scanf("%d", &cnum);
        r[i] = r[i - 1] + cnum;
        for(int j = 1; j <= cnum; ++j){
            scanf("%d", &sm[num]);
            id[num] = i;
            ++num;
        }
    }

    for(int i = 1; i <= n; ++i){
        int ll = 0, rr = n + 1;
        while(ll < rr - 1){
            int mm = (ll + rr) / 2;
            if(ok(i, mm))rr = mm; else ll = mm;
        }
        if(rr == n + 1)printf("0 ");
        else printf("%d ", rr);
    }
    printf("\n");

    return 0;
}
