#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 100500

using namespace std;

struct group{int l, r;};

int n, k, gr_num = 1, gr_num1;
int res[maxn];
int used[maxn];
int pp[maxn], pp1[maxn];
group sm[maxn], sm1[maxn];

int obr_group(const int &l, const int &r, int &nnum, const int &act){
    int kk1 = 0, kk2 = 0, cp1, cp2;
    for(int i = l; i <= r; ++i)if(used[pp[i]] == act)++kk1; else ++kk2;
    if(kk1 != 0 && kk2 != 0){
        ++nnum;
        sm1[nnum].l = l;
        sm1[nnum].r = l + kk1 - 1;
        ++nnum;
        sm1[nnum].l = l + kk1;
        sm1[nnum].r = r;
        cp1 = l; cp2 = l + kk1;
        for(int i = l; i <= r; ++i){
            if(used[pp[i]] == act){
                pp1[cp1] = pp[i];
                ++cp1;
            }
            else{
                pp1[cp2] = pp[i];
                ++cp2;
            }
        }
    }
    else{
        ++nnum;
        sm1[nnum].l = l;
        sm1[nnum].r = r;
        for(int i = l; i <= r; ++i)pp1[i] = pp[i];
    }
    return 0;
}

int make_ver(const int &act){
    int number, tmp;
    scanf("%d", &number);
    for(int i = 1; i <= number; ++i){
        scanf("%d", &tmp);
        used[tmp] = act;
    }
    gr_num1 = 0;
    for(int i = 1; i <= gr_num; ++i)obr_group(sm[i].l, sm[i].r, gr_num1, act);
    gr_num = gr_num1;
    for(int i = 1; i <= n; ++i)pp[i] = pp1[i];
    for(int i = 1; i <= gr_num; ++i){
        sm[i] = sm1[i];
        if(sm[i].l == sm[i].r)res[pp[sm[i].l]] = min(res[pp[sm[i].l]], act);
    }
    return 0;
}

int main(){
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d%d", &n, &k);
    for(int i = 0; i < maxn; ++i){
        used[i] = 0;
        res[i] = k + 1;
    }
    sm[1].l = 1;
    sm[1].r = n;
    for(int i = 1; i <= n; ++i)pp[i] = i;
    for(int iter = 1; iter <= k; ++iter)make_ver(iter);
    for(int i = 1; i <= n; ++i)if(res[i] > k)res[i] = 0;
    for(int i = 1; i <= n; ++i)printf("%d ", res[i]);
    printf("\n");

    return 0;
}
