#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 32

using namespace std;

const int dx[9] = {0, -1, 0, 1, -1, -1, 1, -1, 0};
const int dy[9] = {1, 0, -1, 0, 1, -1, -1, 1, 0};

const int ccn = 2;

int cx, cy, cd, xd, yd, n, m, dc, ind, rres;
bool can[maxn][maxn], tmp[maxn][maxn];
bool mp[maxn][maxn];
bool kp[maxn][maxn];
int f[9];

bool ok(const int &x, const int &y){return(x > 0 && x <= m && y > 0 && y <= n);}

int flip(const int &dx, const int &dy){
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            tmp[i + dx][j + dy] = can[i][j];
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            can[i][j] = tmp[i][j];
    return 0;
}

int ffl(const int &dx, const int &dy){
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            kp[i + dx][j + dy] = mp[i][j];
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            mp[i][j] = kp[i][j];
    return 0;
}

int dist(const int &x, const int &y){
    if(!ok(x, y))return 100;
    int res = 100;
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            if(mp[i][j])rres = min(rres, max(abs(i - x), abs(j -y )));
    return res;
}

int go(const int&, const int&, const int&);
int tgo(const int&, const int&, const int&, const int&, const int&);

int go(const int &x, const int &y, const int &lvl){
    int res;
    if(lvl == 1){
        for(int i = 1; i <= m; ++i)
            for(int j = 1; j <= n; ++j)
                mp[i][j] = can[i][j];
    }
    if(lvl == ccn)res = dist(x, y);
    else{
        res = -100500;
        for(int i = 0; i < 9; ++i)res = max(res, tgo(dx[i], dy[i], x, y, lvl) * dist(x, y));
    }
    return res;
}

int tgo(const int &dd, const int &yd, const int &x, const int &y, const int &lvl){
    int res = 100500;
    ffl(dd, yd);
    for(int i = 0; i < 9; ++i){
        if(ok(x + dx[i], y + dy[i]))res = min(res, go(x + dx[i], y + dy[i], lvl + 1));
    }
    ffl(-dd, -yd);
    return res;
}

int main(){
    /*int tpx = time(NULL);
    srand(tpx);*/

    for(int i = 0; i < maxn; ++i)
        for(int j = 0; j < maxn; ++j)
            can[i][j] = true;

    cin >> n >> m;
    cin >> cx >> cy;
    cd = xd = yd = 0;
    while(!cd){
        flip(xd, yd);
        for(int i = 0; i < 9; ++i)
            if(ok(cx + dx[i], cy + dy[i]))f[i] = go(cx + dx[i], cy + dy[i], 1);
            else f[i] = -100500;
        rres = 0;
        ind = 0;
        for(int i = 0; i < 9; ++i)if(rres < f[i]){rres = f[i]; ind = i;}
        cout << dx[ind] << " " << dy[ind] << " ";
        dc = 0;
        if(can[cx + dx[ind]][cy + dy[ind]])dc = 1;
        cout << dc << endl;
        cout.flush();
        cin >> cd >> xd >> yd;
    }

    return 0;
}
