#define TASKNAME "apricot"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>
#include <string>
#include <cstring>
#include <ctime>
#include <cctype>
#include <fstream>
#include <windows.h>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define y1 dskjchkfjhf
#define y0 kjlasdkfjlk
#define zero(a) memset(a, 0, sizeof(a))
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e6) + 10;

int n;
int r, u;
int dp[MaxN];

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d%d%d", &n, &r, &u) >= 1)
  {
    assert(n <= 2000 && r <= 2000 && u <= 2000);
    dp[0] = INF;
    dp[1] = 0;
    for (int i = 2; i <= n; i++)
    {
      dp[i] = INF;
      int right = i / 2;
      if (!(i & 1))
        --right, dp[i] = u + dp[i / 2];
      for (int j = 1; j <= right; j++)
        dp[i] = min(dp[i], max(r + dp[i - 2 * j], u + dp[j]));
      for (int j = 1; j <= min(i - 1, n - i); j++)
        dp[i] = min(dp[i], max(dp[i - j] + r, dp[j] + u));
      for (int j = 1; j <= i - 1; j++)
      {
        if (2 * j > n)
          break;
        for (int k = 1; k <= i - j && k < j; k++)
          dp[i] = min(dp[i], max(r + dp[i - j - k], u + dp[j]));
      }
    }
    //for (int i = 0; i <= n; i++)
    //  printf("%d\n", dp[i]);
    printf("%d\n", dp[n]);
  }
  return 0;
}
