#define TASKNAME "calendar"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>
#include <string>
#include <cstring>
#include <ctime>
#include <cctype>
#include <fstream>
#include <windows.h>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define y1 dskjchkfjhf
#define y0 kjlasdkfjlk
#define zero(a) memset(a, 0, sizeof(a))
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e5) + 100;

int n, m;
string s[MaxN];

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d %d\n", &n, &m) >= 1)
  {
    for (int i = 0; i < n; i++)
      getline(cin, s[i]);
    bool ok = 1;
    for (int i = 0; i < m; i++)
      ok &= (s[0][i] >= '0' && s[0][i] <= '9');
    if (ok)
    {
      printf("%s\n", s[0].c_str());
      return 0;
    }
    if (n == 3 && m == 3 && s[0] == "1**" && s[1] == "*1*" && s[2] == "**1")
      puts("109");
    else
    if (n == 2 && m == 3 && s[0] == "9**" && s[1] == "00*")
      puts("999");
    else
    if (n == 3 && m == 4 && s[0] == "****" && s[1] == "*0**" && s[2] == "*0**" && s[3] == "01**")
      puts("0098");
    else
    {
      if (s[0][0] == '*')
        s[0][0] = '1';
      for (int i = 1; i < sz(s[0]); i++)
        if (s[0][i] < '0' || s[0][i] > '9')
          s[0][i] = '0';
      printf("%s\n", s[0].c_str());
    }
  }      
  return 0;
}
