#define TASKNAME "mosaic"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e5) + 100;

int n;
pii a[MaxN];
int next[MaxN];
                
int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d", &n) >= 1)
  {
    for (int i = 0; i < n; ++i)
      scanf("%d%d", &a[i].fst, &a[i].snd), next[i] = -1;
    for (int i = 0; i < n; ++i)
    {
      int pos = i + 1;
      while (pos < n && (a[i].fst == a[pos].fst || a[i].snd == a[pos].snd))
        ++pos;
      if (pos < n)
        next[i] = pos;
    }

    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; ++i)
    {
      int l, r;
      scanf("%d%d", &l, &r);
      --l, --r;
      bool out = 0;
      for (int j = l; j <= r; j++)
        if (next[j] != -1 && next[j] <= r)
        {
          out = 1;
          printf("%d %d\n", j + 1, next[j] + 1);
          break;
        }
      if (!out)
        puts("0 0");
    }
    break;
  }
  return 0;
}

