#define TASKNAME "army"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = 30;

int n, k;
int a[MaxN], arr[MaxN];
int dp[MaxN];
int pos[MaxN];
bool have[MaxN];
                
int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d%d", &n, &k) >= 1)
  {
    zero(have);
    for (int i = 0; i < k; i++)
      scanf("%d", &a[i]), have[a[i]] = 1;
    for (int i = 0; i < n; i++)
      arr[i] = i + 1;
    int ans = 0;
    do
    {
      for (int i = 0; i < n; i++)
      {
        dp[i] = 1;
        for (int j = 0; j < i; j++)
          if (arr[j] < arr[i] && dp[j] + 1 > dp[i])
            dp[i] = dp[j] + 1;
      }  
      int Max = 0;
      for (int i = 0; i < n; i++)
        Max = max(Max, dp[i]);
      if (Max != k)
        continue;
      for (int i = 0; i < n; i++)
        if (have[arr[i]])
          pos[arr[i]] = i;
      int now = -1;
      bool ok = 1;
      for (int i = 0; i < k; i++)
      {
        if (now > pos[a[i]])
        {
          ok = 0;
          break;
        }
        now = pos[a[i]];
      }  
      if (ok)
        ++ans;
    }
    while (next_permutation(arr, arr + n));
    printf("%d\n", ans);
  }
  return 0;
}

