#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <memory.h>
#include <limits>

using namespace std;

#define vv vector
#define in cin
#define out cout
#define px first
#define py second
#define mp make_pair

int main() {
	ios_base::sync_with_stdio(false);
	freopen("apricot.in", "rt", stdin);
	freopen("apricot.out", "wt", stdout);

	int n, r, u;
	in >> n >> r >> u;
	vv<int> dp(n + 1);
	dp[2] = u;
	for (int i = 3; i <= n; ++i) {
		if (i % 2 == 0) {
			dp[i] = u + dp[i / 2];
		} else {
			dp[i] = numeric_limits<int>::max();
			for (int k = 1; i - 2 * k >= 1; ++k) {
				int res = max(dp[k] + u, r + dp[i - 2 * k]);
				dp[i] = min(dp[i], res);
			}
		}
	}
	out << dp[n];

	return 0;
}