#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <bitset>
#include <cassert>
#include <queue>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

int main() {
	ios_base::sync_with_stdio(false);
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);

	int n, m;
	in >> n >> m;
	vv< vv<int> > a(m);

	for (int i = 0; i < m; ++i) {
		int k;
		in >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			in >> a[i][j];
			a[i][j]--;
		}
	}

	vv< set<int> > p(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			p[i].insert(j);
		}
	}
	vv<int> ans(n, -1);
	for (int i = 0; i < m; ++i) {
		set<int> perf;
		for (int j = 0; j < a[i].size(); ++j) {
			int v = a[i][j];
			perf.insert(v);
		}
		queue<int> thr;
		for (int v = 0; v < n; ++v) {
			if (perf.find(v) == perf.end()) {
				for (int j = 0; j < a[i].size(); ++j) {
					int u = a[i][j];
					p[v].erase(u);
				}
			} else {
				set<int> q;
				for (int j = 0; j < a[i].size(); ++j) {
					int u = a[i][j];
					if (p[v].find(u) != p[v].end()) {
						q.insert(u);
					}
				}
				p[v] = q;
			}
			if (p[v].size() == 1) {
				thr.push(v);
			}
		}
		while (!thr.empty()) {
			int v = thr.front();
			thr.pop();
			ans[v] = i;
			p[v].clear();
			for (int k = 0; k < n; ++k) {
				p[k].erase(v);
				if (p[k].size() == 1) {
					thr.push(k);
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		out << ans[i] + 1 << ' ';
	}
	out << endl;

	return 0;
}