#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

int n, m, x, y;

bool valid(int dx, int dy) {
	int X = x + dx, Y = y + dy;
	return X >= 0 && X < m && Y >= 0 && Y < n;
}

int main() {
	ios_base::sync_with_stdio(false);
	in >> n >> m >> x >> y;
	--x, --y;
	srand(37731);
	while (true) {
		int dx = 0, dy = 0, call = 1;
		do {
			dx = -1 + (rand() % 3);
			dy = -1 + (rand() % 3);
		} while (!valid(dx, dy));
		out << dx << ' ' << dy << ' ' << call << endl;
		out.flush();
		x += dx, y += dy;
		int good, hdx, hdy;
		in >> good >> hdx >> hdy;
		--hdx, --hdy;
		if (good) {
			return 0;
		}
	}

	return 0;
}