#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

#define INF 999999999
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int n = 0, v1, v2;
vector < bool > used;
vector < int > gr1[3000];
vector < int > gr2[3000];
int tin1[3000], tout1[3000], tin2[3000], tout2[3000];
int timer = 0;

void dfs1(int v){
    used[v] = true;
    tin1[v] = timer++;
    for(int i = 0; i < gr1[v].size(); ++i){
        int to = gr1[v][i];
        if(!used[to])dfs1(to);
    }
    tout1[v] = timer++;
}

void dfs2(int v){
    used[v] = true;
    tin2[v] = timer++;
    for(int i = 0; i < gr2[v].size(); ++i){
        int to = gr2[v][i];
        if(!used[to])dfs2(to);
    }
    tout2[v] = timer++;
}

int pred1(int v1, int v2){
    if(tin1[v2] >= tin1[v1] && tin1[v2] <= tout1[v1])return 1;
    if(tin1[v1] >= tin1[v2] && tin1[v1] <= tout1[v2])return -1;
    return 0;
}

int pred2(int v1, int v2){
    if(tin2[v2] >= tin2[v1] && tin2[v2] <= tout2[v1])return 1;
    if(tin2[v1] >= tin2[v2] && tin2[v1] <= tout2[v2])return -1;
    return 0;
}

int main(){
    freopen("virus.in", "rt", stdin);
    freopen("virus.out", "wt", stdout);
    cin >> n;
    int t;
    for(int i = 0; i < n; ++i){
        cin >> t;
        if(t){
            --t;
            gr1[t].pb(i);
        }else v1 = i;
    }
    timer = 0;
    used.assign(n, false);
    dfs1(v1);
    for(int i = 0; i < n; ++i){
        cin >> t;
        if(t){
            --t;
            gr2[t].pb(i);
        }else v2 = i;
    }
    timer = 0;
    used.assign(n, false);
    dfs2(v2);
    /*for(int i = 0; i < n; ++i){
        cout << i << ":: ";
        for(int j = 0; j < gr1[i].size(); ++j)
            cout << gr1[i][j] << " ";
        cout << endl;
    }*/
    //for(int i = 0; i < n; ++i)cout << tin1[i] << " -- " << tout1[i] << endl; cout << "------------\n";
    //for(int i = 0; i < n; ++i)cout << tin2[i] << " -- " << tout2[i] << endl; cout << "------------\n";
    int num = 0;
    for(int i = 0; i < n; ++i)
        for(int j = i+1; j < n; ++j){
            int p1 = pred1(i, j);
            int p2 = pred2(i, j);
            if(p1 && p2 && p1 == p2){
                    //cout << i << " " << j << " -- " << p1 << " " << p2 << endl;
                    ++num;
            }
        }
    cout << num;
    return 0;
}
