#include <iostream>
#include <vector>

using namespace std;

#define Max 100010


int tin1[Max],tin2[Max], tout1[Max], tout2[Max];
int timer=0;

vector<int> pr1[Max],pr2[Max];

void dfs1(int a)
{
	tin1[a]=timer;
	timer++;
	
	for(int i=0; i<pr1[a].size(); i++)
	{
		dfs1(pr1[a][i]);
	}

	tout1[a]=timer;
	timer++;
}
void dfs2(int a)
{
	tin2[a]=timer;
	timer++;

	for(int i=0; i<pr2[a].size(); i++)
	{
		dfs2(pr2[a][i]);
	}
	tout2[a]=timer;
	timer++;
}

int upper1(int a, int b)
{
	if(tin1[a]<=tin1[b] && tout1[b]<=tout1[a]) return 1;
	return 0;
}

int upper2(int a, int b)
{
	if(tin2[a]<=tin2[b] && tout2[b]<=tout2[a]) return 1;
	return 0;
}



int main()
{
	freopen("virus.in","r",stdin);
	freopen("virus.out","w",stdout);

	
	int n;

	cin>>n;

	int h;

	int boss1, boss2;

	for(int i=0; i<n; i++)
	{
		cin>>h;
		if(h!=0)
			pr1[h-1].push_back(i);
		else
			boss1=i;
	}

	for(int i=0; i<n; i++)
	{
		cin>>h;
		if(h!=0)
			pr2[h-1].push_back(i);
		else
			boss2=i;
	}

	dfs1(boss1);
	timer=0;
	dfs2(boss2);

	int ans=0;

	for(int i=0; i<n; i++)
	{
		for(int j=0; j<n; j++)
		{
			if(i==j) continue;

			if(upper1(i,j)==1 && upper2(i,j)==1)  ans++;
		}
	}

	cout<<ans;

	return 0;

}