program Project1;

{$APPTYPE CONSOLE}
{$MAXSTACKSIZE $20000000}

var
  g, f : array [1..1000] of array of longint;
  time, n, i, j, v1, v2 : longint;
  ans : int64;
  tin1, tin2, tout1, tout2, p1, p2 : array [1..1000] of longint;

procedure  dfs1(v : longint);
var
  i : longint;
begin
  inc(time);
  tin1[v] := time;
  for i := 0 to length(g[v]) - 1 do
  begin
    if tin1[g[v][i]] = 0 then
      dfs1(g[v][i]);
  end;
  inc(time);
  tout1[v] := time;
end;

procedure  dfs2(v : longint);
var
  i : longint;
begin
  inc(time);
  tin2[v] := time;
  for i := 0 to length(f[v]) - 1 do
  begin
    if tin2[f[v][i]] = 0 then
      dfs2(f[v][i]);
  end;
  inc(time);
  tout2[v] := time;
end;

function inside1(i, j : longint) : boolean;
begin
  if (tin1[i] < tin1[j]) and (tout1[j] < tout1[i]) then
    result := true
  else
    result := false;  
end;

function inside2(i, j : longint) : boolean;
begin
  if (tin2[i] < tin2[j]) and (tout2[j] < tout2[i]) then
    result := true
  else
    result := false;
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  readln(n);
  for i := 1 to n do
  begin
    read(p1[i]);
    if p1[i] <> 0 then
    begin
      setlength(g[p1[i]], length(g[p1[i]]) + 1);
      g[p1[i], length(g[p1[i]]) - 1] := i;
    end
    else
      v1 := i;
  end;

  for i := 1 to n do
  begin
    read(p2[i]);
    if p2[i] <> 0 then
    begin
      setlength(f[p2[i]], length(f[p2[i]]) + 1);
      f[p2[i], length(f[p2[i]]) - 1] := i;
    end
    else
      v2 := i;
  end;

  dfs1(v1);
  time := 0;
  dfs2(v2);

  ans := 0;
  for i := 1 to n do
    for j := i + 1 to n do
    begin
      if (inside1(i, j) and inside2(i, j)) or (inside1(j, i) and inside2(j, i)) then
        inc(ans);
    end;

  writeln(ans);  
end.
