program Num2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

var
  a1, b1, a2, b2: array [0..2001, 0..2001] of integer;
  st, us: array [1..2000] of integer;
  stsize: integer;
  boss1, boss2: integer;
  n, i, j, x, l: integer;

procedure dfs1(v: integer);

var
  i : integer;

begin
  for i := 1 to stsize do begin
    b1[st[i], v] := 1;
  end;
  inc(stsize);
  st[stsize] := v;
  us[v] := 0;
  for i := 1 to a1[v, 0] do
    if us[a1[v, i]] = 1 then
      dfs1(a1[v, i]);
  dec(stsize);
end;

procedure dfs2(v: integer);

var
  i : integer;

begin
  for i := 1 to stsize do begin
    b2[st[i], v] := 1;
  end;
  inc(stsize);
  st[stsize] := v;
  us[v] := 0;
  for i := 1 to a2[v, 0] do
    if us[a2[v, i]] = 1 then
      dfs2(a2[v, i]);
  dec(stsize);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');

  read(n);
  for i := 1 to n do begin
    read(x);
    if x = 0 then begin
      boss1 := i;
      a1[i, 0] := 0;
      for j := 1 to n do
        if j <> i then begin
          inc(a1[i, 0]);
          a1[i, a1[i, 0]] := j;
        end;
    end
    else begin
      inc(a1[x, 0]);
      a1[x, a1[x, 0]] := i;
    end;
  end;

  st[1] := boss1;
  stsize := 1;
  for i := 1 to n do
    us[i] := 1;
  us[boss1] := 0;

  dfs1(boss1);

  for i := 1 to n do begin
    read(x);
    if x = 0 then begin
      boss2 := i;
      a2[i, 0] := 0;
      for j := 1 to n do
        if j <> i then begin
          inc(a2[i, 0]);
          a2[i, a2[i, 0]] := j;
        end;
    end
    else begin
      inc(a2[x, 0]);
      a2[x, a2[x, 0]] := i;
    end;
  end;

  st[1] := boss2;
  stsize := 1;
  for i := 1 to n do
    us[i] := 1;
  us[boss2] := 0;

  dfs2(boss2);

  x := 0;
  for i := 1 to n do
    for j := 1 to n do
      x := x + b1[i, j] * b2[i, j];
  write(x);
end.
