#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))

typedef long long ll;
const ll INF = ((ll)1000000000) * 1000000000;
const int MAXN = 1000003;

ll dp[MAXN];

int main() {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    int n, R, U;
    cin >> n >> R >> U;
    dp[0] = -R;
    dp[1] = 0;
    for (int i = 2; i <= n; ++i) {
        int l = 0;
        int r = i / 2 + 1;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (dp[m] + U <= dp[i - 2 * m] + R)
                l = m;
            else
                r = m;
        }
        dp[i] = INF;
        for (int j = max(l - 5, 1); j <= min(l + 5, i / 2); ++j)
            dp[i] = min(dp[i], max(dp[j] + U, dp[i - 2 * j] + R));
        if (i % 2 == 0)
            dp[i] = min(dp[i], dp[i / 2] + U);
        for (int j = max(i - 10, 1); j < i; ++j)
            if (dp[j] > dp[i])
                dp[j] = dp[i];
        //if (r <= i / 2)
         //   dp[i] = min(dp[i], max(dp[r] + U, dp[i - 2 * r] + R));
    }

    cout << dp[n];
    return 0;
}
