#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizoef(a))

const int MAXN = 100002;
const int MAXS = 18;
const int INF = 1000000001;

struct strct{
    int a;
    int n;
};
int a[MAXN];
int b[MAXN];
int a1[MAXS][MAXN];
int a2[MAXS][MAXN];
int b1[MAXS][MAXN];
int b2[MAXS][MAXN];
int l[MAXN];
int s[MAXN];

int getmin(int * t, int L, int R, int * a) {
    int sz = R - L;
    int c = s[sz];
    if (a[t[L]] < a[t[R - l[sz]]])
        return t[L];
    else return t[R - l[sz]];
}
int getmax(int * t, int L, int R, int * a) {
    int sz = R - L;
    int c = s[sz];
    if (a[t[L]] > a[t[R - l[sz]]])
        return t[L];
    else return t[R - l[sz]];
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    FOR(i, n) {
        scanf("%d%d", &a[i], &b[i]);
    }
    FOR(i, n) {
        a1[0][i] = i;
        a2[0][i] = i;
        b1[0][i] = i;
        b2[0][i] = i;
    }
    int st = 1;
    int w1, w2;
    for (int i = 1; i < MAXS; ++i) {
        FOR(j, n) {
            w1 = a1[i - 1][j];
            w2 = a1[i - 1][j + st];
            if (a[w1] < a[w2])
                a1[i][j] = w1;
            else
                a1[i][j] = w2;
        }
        FOR(j, n) {
            w1 = a2[i - 1][j];
            w2 = a2[i - 1][j + st];
            if (a[w1] > a[w2])
                a2[i][j] = w1;
            else
                a2[i][j] = w2;
        }
        FOR(j, n) {
            w1 = b1[i - 1][j];
            w2 = b1[i - 1][j + st];
            if (b[w1] < b[w2])
                b1[i][j] = w1;
            else
                b1[i][j] = w2;
        }
        FOR(j, n) {
            w1 = b2[i - 1][j];
            w2 = b2[i - 1][j + st];
            if (b[w1] > b[w2])
                b2[i][j] = w1;
            else
                b2[i][j] = w2;
        }
        st *= 2;
    }
    s[1] = 0;
    l[1] = 1;
    st = 1;
    int wc = 0;
    for (int i = 2; i <= n; ++i) {
        if (i > 2 * st)
            st *= 2, wc++;
        s[i] = wc;
        l[i] = st;
    }

    int k;
    scanf("%d", &k);
    FOR(i, k) {
        int L, R;
        scanf("%d%d", &L, &R);
        L--;
        int c[4];
        c[0] = getmin(a1[s[R - L]], L, R, a);
        c[1] = getmax(a2[s[R - L]], L, R, a);
        c[2] = getmin(b1[s[R - L]], L, R, b);
        c[3] = getmax(b2[s[R - L]], L, R, b);
        bool ind = false;
        FOR(i, 4) {
            FOR(j, i) {
                if (a[c[i]] != a[c[j]] && b[c[i]] != b[c[j]]) {
                    printf("%d %d\n", c[i] + 1, c[j] + 1);
                    ind = true;
                    break;
                }
            }
            if (ind)
                break;
        }
        if (!ind)
            printf("%d %d\n", 0, 0);

    }

    return 0;
}
