#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>
#include <set>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))
const int INF = 1000000000;
const int MAXN = 100003;
const ll P = 997;

//multiset<ll> use;
map<ll, set<int> > use;
int ans[MAXN];
ll h[MAXN];

inline void add(int i) {
    if (use.count(h[i]) == 0) {
        set<int> w;
        use.insert(pair<ll, set<int> >(h[i], w));
    }
    use[h[i]].insert(i);
}

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    ll p = 1;
    clr(ans);
    clr(h);
    FOR(i, n)
        add(i);

    FOR(i, m) {
        int k;
        scanf("%d", &k);
        vector<ll> toc;
        FOR(j, k) {
            int a;
            scanf("%d", &a);
            a--;
            use[h[a]].erase(a);
            toc.push_back(h[a]);
            h[a] += p;
            toc.push_back(h[a]);
            add(a);

        }
        FOR(j, toc.size()) {
            if (use.count(toc[j]) > 0 && use[toc[j]].size() == 1) {
                int w = *(use[toc[j]].begin());
                if (ans[w] == 0)
                    ans[w] = i + 1;
            }
        }
        /*
        cerr << "\n!\n";
            for (map<ll, set<int> >::iterator it = use.begin(); it != use.end(); ++it) {
                cerr << it->first << endl;
                set<int> w = it->second;
                for (set<int>::iterator it1 = w.begin(); it1 != w.end(); ++it1) {
                    cerr << *it1 << ' ';
                }
                cerr << endl;
            }
            */
        p *= P;
    }
    FOR(i, n) {
        printf("%d ", ans[i]);
    }

    return 0;
}
