#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>
#include <set>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))
const int INF = 1000000000;
const int MAXN = 100003;
const ll P = 997;

struct st {
    ll h;
    int n;
};

bool operator < (st a, st b) {
    if (a.h != b.h)
        return a.h < b.h;
    return a.n < b.n;
}

//multiset<ll> use;
//map<ll, set<int> > use;
set<st> use;
int ans[MAXN];
ll h[MAXN];


int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    ll p = 1;
    clr(ans);
    clr(h);
    FOR(i, n) {
        st w;
        w.h = h[i];
        w.n = i;
        use.insert(w);
    }

    FOR(i, m) {
        int k;
        scanf("%d", &k);
        vector<ll> toc;
        FOR(j, k) {
            int a;
            scanf("%d", &a);
            a--;
            st w;
            w.h = h[a];
            w.n = a;
            use.erase(w);
            toc.push_back(h[a]);
            h[a] += p;
            toc.push_back(h[a]);
            w.h = h[a];
            use.insert(w);
        }
        FOR(j, toc.size()) {
            st w;
            w.h = toc[j];
            w.n = -1;

            set<st>::iterator it = use.upper_bound(w), it1;
            if (it == use.end())
                continue;
            it1 = it;
            ++it1;
            if (it1 == use.end() || it1->h != it->h) {
                if (ans[it->n] == 0)
                    ans[it->n] = i + 1;
            }
        }
        /*
        cerr << "\n!\n";
            for (map<ll, set<int> >::iterator it = use.begin(); it != use.end(); ++it) {
                cerr << it->first << endl;
                set<int> w = it->second;
                for (set<int>::iterator it1 = w.begin(); it1 != w.end(); ++it1) {
                    cerr << *it1 << ' ';
                }
                cerr << endl;
            }
            */
        p *= P;
    }
    FOR(i, n) {
        printf("%d ", ans[i]);
    }

    return 0;
}
