
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))
const int INF = 1000000000;
const int MAXN = 15;
int n, k;
int p1 = 0;
int a[MAXN];
int b[MAXN];
int m;
bool use[MAXN];
int res[MAXN];
int dp[MAXN];
int ans = 0;

void rek(int p) {
    if (p == n) {
        ans++;
        return;
    }

    int mx;
    FOR(i, m) {
        if (use[i])
            continue;
        res[p] = b[i];
        use[i] = true;
        dp[p] = 1;
        mx = 1;
        FOR(j, p) {
            if (res[j] < res[p])
                dp[p] = max(dp[p], dp[j] + 1);
            mx = max(mx, dp[j]);
            if (p1 < k && res[j] < a[p1]) {
                if (dp[j] > p1)
                    mx = INF;
            }
        }
        mx = max(mx, dp[p]);

        if (mx <= k)
            rek(p + 1);
        use[i] = false;
    }
    if (p1 != k) {
        res[p] = a[p1++];
        dp[p] = 1;
        mx = 1;
        FOR(j, p) {
            if (res[j] < res[p])
                dp[p] = max(dp[p], dp[j] + 1);
            mx = max(mx, dp[j]);
            if (p1 < k && res[j] < a[p1]) {
                if (dp[j] > p1)
                    mx = INF;
            }
        }
        mx = max(mx, dp[p]);
        if (mx <= k)
            rek(p + 1);
        p1--;
    }
}


int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
    scanf("%d%d", &n, &k);
    FOR(i, k)
        scanf("%d", &a[i]);
    sort(a, a + k);
    m = 0;
    FOR(i, n) {
        bool ind = false;
        FOR(j, k)
            if (a[j] == i + 1) {
                ind = true;
                break;
            }
        if (!ind) {
            b[m++] = i + 1;
        }
    }
    clr(use);
    rek(0);
    cout << ans;
    return 0;
}
