#pragma comment(linker, "/STACK:200000000")

#include <iostream>
#include <cassert>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 100100;
const int MAGIC = 6;

string s, t;
int sum[MAXN];
int b, e;

inline int getSum(int l, int r) {
	return (l == 0 ? sum[r] : sum[r] - sum[l - 1]);
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	getline(cin, s);
	getline(cin, t);
	if (s == t) {
		puts("1 1");
		return 0;
	}

	sum[0] = s[0] - '0';
	for (int i = 1; i < s.size(); i++)
		sum[i] = sum[i - 1] + (s[i] - '0');


	while (b < t.size() && b < s.size() && t[b] == s[b])
		b++;

	while ((int)t.size() - e - 1 >= 0 && (int)s.size() - e - 1 >= 0 && t[(int)t.size() - e - 1] == s[(int)s.size() - e - 1])
		e++;

	for (int i = 0; i < (int)t.size() && i <= b; i++) {
		if (t[i] == '0')
			continue;

		int cur = 0;
		for (int j = 1; j <= MAGIC && i + j <= t.size(); j++) {
			cur *= 10;
			cur += t[i + j - 1] - '0';			 

			int rest = (int)t.size() - (i + j);
			if (rest > e)
				continue;

			int l = i, r = (int)s.size(), res;
			if (getSum(i, i) > cur)
				continue;

			while (l < r - 1) {				
				res = (l + r) >> 1;
				if (getSum(i, res) > cur)
					r = res;
				else
					l = res;
			}

			if (getSum(i, l) == cur) {
				if ((int)s.size() - l == (int)t.size() - (i + j - 1)) {
					printf("%d %d\n", i + 1, l + 1);
					return 0;
				}
			}
		}

		/*if (t[i] != s[i])
			assert(false);*/
	}
}