#include <iostream>
#include <cstdio>
#include <memory.h>
using namespace std;

const int MAXN = 30000;
const long long INF = 1000LL * 1000LL * 1000LL * 1000LL * 1000LL * 1000LL;

int N, R, U;
long long ans[MAXN];

long long get(int u) {
	if (ans[u] != -1)
		return ans[u];

	if (u == 1 || u == 0) {
		ans[u] = 0;
		return 0;
	}

	ans[u] = INF;

	for (int i = 1; 2 * i < u; i++) {		
		ans[u] = min(ans[u], max(get(i) + U, get(u - 2 * i) + R));
	}

	if (u % 2 == 0) {
		ans[u] = min(ans[u], get(u >> 1) + U);
	}

	return ans[u];
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> N >> R >> U;
	memset(ans, -1, sizeof(ans));

	cout << get(N) << endl;
}