#include <iostream>
#include <cstdio>
#include <cassert>
using namespace std;

const int MAXN = 3000;

long long N, R, U;
long long dp[MAXN];
bool u[MAXN];

long long go(int n) {
	if (u[n]) {
		return dp[n];
	}
	u[n] = true;
	if (n == 1) {
		dp[n] = 0;
		return 0;
	}

	dp[n] = -1;
	for (int i = 1; 2 * i < n; i++) {
		if (dp[n] == -1) {
			dp[n] = max(go(i) + U, go(n - 2 * i) + R);
		} else {
			dp[n] = min(dp[n], max(go(i) + U, go(n - 2 * i) + R));
		}
	}

	if (n % 2 == 0) {
		if (dp[n] == -1) {
			dp[n] = go(n / 2) + U;
		} else {
			dp[n] = min(dp[n], go(n / 2) + U);
		}
	}

	return dp[n];
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> N >> R >> U;
	cout << go(N) << endl;
}