#pragma comment(linker, "/STACK:200000000")

#include <iostream>
#include <cstdio>
#include <cassert>
using namespace std;

const int MAXN = 1001000;
const int MAGIC = 5;

long long N, R, U;
long long dp[MAXN];
bool u[MAXN];

long long go(int n) {
	if (u[n]) {
		return dp[n];
	}

	u[n] = true;
	if (n == 1 || n == 0) {
		dp[n] = 0;
		return 0;
	}

	dp[n] = -1;
	/*for (int i = 1; 2 * i < n; i++) {
		if (dp[n] == -1) {
			dp[n] = max(go(i) + U, go(n - 2 * i) + R);
		} else {
			dp[n] = min(dp[n], max(go(i) + U, go(n - 2 * i) + R));
		}
	}*/

	int val = n / 3;
	for (int i = max(1, val - MAGIC); 2 * i < n && i <= val + MAGIC; i++) {
		if (dp[n] == -1) {
			dp[n] = max(go(i) + U, go(n - 2 * i) + R);
		} else {
			dp[n] = min(dp[n], max(go(i) + U, go(n - 2 * i) + R));
		}
	}

	val = n >> 1;
	for (int i = max(1, val - MAGIC); 2 * i < n && i <= val + MAGIC; i++) {
		if (dp[n] == -1) {
			dp[n] = max(go(i) + U, go(n - (i << 1)) + R);
		} else {
			dp[n] = min(dp[n], max(go(i) + U, go(n - (i << 1)) + R));
		}
	}

	if (!(n & 1)) {
		if (dp[n] == -1) {
			dp[n] = go(n >> 1) + U;
		} else {
			dp[n] = min(dp[n], go(n >> 1) + U);
		}
	} else {
		if (n < N) {
			if (dp[n] == -1) {
				dp[n] = go((n + 1) >> 1) + U;
			} else {
				dp[n] = min(dp[n], go((n + 1) >> 1) + U);
			}
		}
	}

	return dp[n];
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> N >> R >> U;	
	cout << go(N) << endl;
}