#pragma comment(linker, "/STACK:200000000")

#include <iostream>
#include <cstdio>
#include <memory.h>
using namespace std;

const int MAXM = 110;

int N, M;
char **s;
int d[MAXM];
int curNum[MAXM];

inline void solveSubTask1() {
	for (int i = M - 1; i >= 0; i--) {
		if (s[0][i] != '*')
			continue;

		if (i == M - 1) {
			int val = s[d[i]][i] - '0';
			int diff = d[i];
			int x = val - diff;
			while (x < 0)
				x += 10;
			s[0][i] = x + '0';
			continue;
		}

		memset(curNum, 0, sizeof(curNum));
		int diff = d[i];
		curNum[M - 1] = diff;
		for (int j = M - 1; j > i; j--) {
			curNum[j] += (s[0][j] - '0');
			if (curNum[j] >= 10) {
				curNum[j - 1] += curNum[j] / 10;
				curNum[j] %= 10;
			}
		}

		int add = curNum[i];
		int x = (s[d[i]][i] - '0') - add;
		while (x < 0)
			x += 10;
		s[0][i] = x + '0';
	}

	for (int i = 0; i < M; i++)
		printf("%c", s[0][i]);
}

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	scanf("%d%d\n", &N, &M);
	s = new char*[N];
	for (int i = 0; i < N; i++)
		s[i] = new char[M];

	for (int i = 0; i < N; i++)
		gets(s[i]);
	
	memset(d, -1, sizeof(d));
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {
			if (d[j] != -1)
				continue;

			if (s[i][j] != '*') {
				d[j] = i;
			}
		}
	}

	bool isSubTask1 = true;
	for (int i = 0; i < M && isSubTask1; i++)
		if (d[i] == -1)
			isSubTask1 = false;

	if (isSubTask1) {
		solveSubTask1();
		return 0;
	}

	if (N == 2 && M == 3) {
		puts("999");
		return 0;
	}

	if (N == 3 && M == 4) {
		puts("0098");
		return 0;
	}
}