#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <algorithm>
using namespace std;

const int MAXN = 100100;
const int INF = 2e9;

int N, K;
int A[MAXN], B[MAXN];
int N1[MAXN], N2[MAXN];

int d[MAXN];

inline bool similar(const int &a, const int &b) {
	return (A[a] == A[b] || B[a] == B[b]);
}

void calcD() {
	for (int i = 0; i < N; i++) {
		d[i] = INF;
		for (int j = i + 1; j < N; j++) {
			if (!similar(i, j)) {
				d[i] = j;
				break;
			}
		}
	}
}

void foolSolution() {
	calcD();
	for (int i = 0; i < K; i++) {
		bool flag = false;
		for (int j = N1[i]; j < N2[i]; j++) {
			if (d[j] <= N2[i]) {
				printf("%d %d\n", j + 1, d[j] + 1);
				flag = true;
				break;
			}
		}
		if (!flag) {
			puts("0 0");
		}
	}
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	scanf("%d", &N);
	for (int i = 0; i < N; i++)
		scanf("%d%d", &A[i], &B[i]);
	scanf("%d", &K);
	for (int i = 0; i < K; i++) {
		scanf("%d%d", &N1[i], &N2[i]);
		N1[i]--, N2[i]--;
	}

	if (N <= 5000 && K <= 5000) {
		foolSolution();
		return 0;
	} else {
	}
}