#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <ctime>
#include <memory.h>
using namespace std;

const int MAXN = 10;

int N, K;
vector<int> v;
vector<int> p;
bool u[MAXN];
int ans;

int dp[MAXN];

inline bool good() {
	vector<int> a;
	for (int i = 0; i < N; i++)
		if (u[p[i]])
			a.push_back(p[i]);

	if (a != v)
		return false;

	a.clear();

	dp[0] = 1;
	for (int i = 1; i < N; i++) {
		dp[i] = 1;
		for (int j = 0; j < i; j++) {
			if (p[i] > p[j] && dp[j] >= dp[i])
				dp[i] = dp[j] + 1;
				
		}
	}
	int val = -1;
	for (int i = 0; i < N; i++)
		val = max(val, dp[i]);
	return val == K;
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	scanf("%d%d", &N, &K);
	v.resize(K);
	for (int i = 0; i < K; i++) {
		scanf("%d", &v[i]);
		v[i]--;
		u[v[i]] = true;
	}

	if (N <= 8) {
		p.resize(N);
		for (int i = 0; i < N; i++)
			p[i] = i;

		do {
			if (good())
				ans++;
		} while (next_permutation(p.begin(), p.end()));
		printf("%d\n", ans);
	}
}