#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <ctime>
#include <memory.h>
using namespace std;

inline int setBit(int x, int k, int bt) {
	if (bt) return x | (1 << k);
	else return x & (~(1 << k));
}

const int MAXN = 15;
const int INF = 2e9;

const int MAXSIZE = (1 << 13);

int N, K;
vector<int> v;
vector<int> p;
bool u[MAXN];
int ans;
long long res;

int dp[MAXN];
int dp2[MAXSIZE];

inline bool good() {
	vector<int> a;
	for (int i = 0; i < N; i++)
		if (u[p[i]])
			a.push_back(p[i]);

	if (a != v)
		return false;

	a.clear();

	dp[0] = 1;
	for (int i = 1; i < N; i++) {
		dp[i] = 1;
		for (int j = 0; j < i; j++) {
			if (p[i] > p[j] && dp[j] >= dp[i])
				dp[i] = dp[j] + 1;
				
		}
	}
	int val = -1;
	for (int i = 0; i < N; i++)
		val = max(val, dp[i]);
	return val == K;
}

inline bool good2() {
	vector<int> a;
	for (int i = 0; i < N; i++)
		if (u[p[i]])
			a.push_back(p[i]);

	if (a != v)
		return false;

	a.clear();
	for (int i = 0; i < N + 3; i++)
		dp[i] = INF;

	for (int i = 0; i < N; i++) {
		int num = lower_bound(dp + 1, dp + N + 1, p[i]) - dp;
		dp[num] = p[i];
	}
	int anss = 1;
	while (dp[anss] != INF)
		anss++;
	anss--;
	return anss == K;
}

void dp22() {

}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	scanf("%d%d", &N, &K);
	v.resize(K);
	for (int i = 0; i < K; i++) {
		scanf("%d", &v[i]);
		v[i]--;
		u[v[i]] = true;
	}

	if (N <= 8) {
		p.resize(N);
		for (int i = 0; i < N; i++)
			p[i] = i;

		do {
			if (good())
				ans++;
		} while (next_permutation(p.begin(), p.end()));
		printf("%d\n", ans);
		return 0;
	}

	if (N <= 15) {
		p.resize(N);
		for (int i = 0; i < N; i++)
			p[i] = i;

		do {
			if (good2())
				ans++;
		} while (next_permutation(p.begin(), p.end()));
		printf("%d\n", ans);
		return 0;
	}

	
}