#include <iostream>

using namespace std;

int bytes(int a)
{
	int rv = 0;
	while(a)
	{
		rv += a%2;
		a/=2;
	}
	return rv;
}

int main()
{
	int w,h;
	cin >> h >> w;
	int wmask = ~(0x7fffffffu << w);
	int hmask = ~(0x7ffffffu << h);
	
	int ex, ey;
	cin >> ex >> ey;
	ex--;
	ey--;

	int *phposs = new int[w];
	for(int i = 0; i < w; i++)
		phposs[i] = hmask;

	int hox = 0;
	int hoy = 0;

	cout << "0 0 1\n";
	cout.flush();

	while(true)
	{
		int hr, hdx, hdy;
		cin >> hr >> hdx >> hdy;
		if(hr)
			return 0; //yay

		hox += hdx;
		hoy += hdy;

		if(hdx)
		{
			if(hdx == -1)
			{
				for(int i = 0; i < w-1; i++)
					phposs[i] = phposs[i+1];
				phposs[w-1] = 0;
			} else {
				for(int i = w-1; i > 0; i--)
					phposs[i] = phposs[i-1];
				phposs[0] = 0;
			}
		} else if(hdy)
		{
			if(hdy == -1)
			{
				for(int i = 0; i < w; i++)
				{
					phposs[i] = phposs[i]>>1;
				}
			} else {
				for(int i = 0; i < w; i++)
				{
					phposs[i] = (phposs[i]<<1)&hmask;
				}
			}
		}

		phposs[ex] &= ~(1<<ey);

		//first determine where to go in O(n*m)
		int tx = ex, ty = ex;
		for(int j = 0; j < h; j++)
		{
			for(int i = 0; i < w; i++)
			{
				if(phposs[i]&(1<<j))
				{
					tx = i;
					ty = j;
					goto cont1;
				}
			}
		}
		cont1:
		int dx = 0, dy = 0;
		if(ex < tx)
			dx = 1;
		else if(ex > tx)
			dx = -1;

		if(ey < ty)
			dy = 1;
		else if(ey > ty)
			dy = -1;

		ex = tx;
		ey = ty;

		if(phposs[tx]&(1<<ty))
			cout << dx << " " << dy << " 1\n";
		else
			cout << dx << " " << dy << " 0\n";
		cout.flush();
	}
}