program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  ar = array[1..2] of integer;  

var
  n, t: integer;
  ch: array[0..100000] of ar;
  first: array[0..100000] of integer;
  ent, ex: array[1..100000] of integer;
  was: array[0..100000] of boolean;
  ans: int64;

procedure swap(var a, b: ar);
var
  c: ar;
begin
  c := a;
  a := b;
  b := c;
end;

procedure sort(var a: array of ar; l, r: integer);
var
  x: ar;
  i, j: integer;
begin
  if l >= r then
    exit;
  i := l;
  j := r;
  x := a[random(r - l + 1) + l];
  while i <= j do begin
    while a[i][1] < x[1] do
      inc(i);
    while a[j][1] > x[1] do
      dec(j);
    if i <= j then begin
      swap(a[i], a[j]);
      inc(i);
      dec(j);
    end;
  end;
  sort(a, l, j);
  sort(a, i, r);  
end;

procedure dfs1(pos: integer);
var
  i: integer;
begin
  inc(t);
  ent[pos] := t;
  i := first[pos];
  while (i <= n)and(ch[i][1] = pos) do begin
    dfs1(ch[i][2]);
    inc(i);
  end;
  ex[pos] := t;
end;

procedure dfs2(pos: integer);
var
  i: integer;
begin
  for i := 1 to n do
    if(was[i])and(ent[i] < ent[pos])and(ex[i] >= ex[pos])then
      inc(ans);
  was[pos] := true;
  i := first[pos];
  while (i <= n)and(ch[i][1] = pos) do begin
    dfs2(ch[i][2]);
    inc(i);
  end;
  was[pos] := false;
end;

procedure get;
var
  i: integer;
begin
  for i := 1 to n do begin
    read(ch[i][1]);
    ch[i][2] := i;
  end;
  sort(ch, 1, N);
  fillchar(first, sizeof(first), 0);
  first[0] := 1;
  for i := 2 to n do
    if ch[i][1] > ch[i - 1][1] then begin
      first[ch[i][1]] := i;
    end;
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');

  randomize;

  read(n);
  get;
  fillchar(was, sizeof(was), 0);
  t := 0;
  dfs1(0);
  ans := 0;
  get;
  dfs2(0);
  write(ans);
end.
