program PB;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const maxn=100*1000;

var mas1,mas2:array[1..maxn] of array of integer;
    n,i,j,ans:integer;
    used1,used2:array[1..maxn] of boolean;

procedure dfs1(v:integer);
var i:integer;
begin
  used1[v]:=true;
  for i:=0 to length(mas1[v])-1 do if not used1[mas1[v,i]] then dfs1(mas1[v,i]);
end;

procedure dfs2(v:integer);
var i:integer;
begin
  used2[v]:=true;
  for i:=0 to length(mas2[v])-1 do if not used2[mas2[v,i]] then dfs2(mas2[v,i]);
end;

begin
  assign(input,'virus.in');
  reset(input);
  assign(output,'virus.out');
  rewrite(output);
  read(n);
  for i:=1 to n do
  begin
    read(j);
    if j>0 then
    begin
      setlength(mas1[j],length(mas1[j])+1);
      mas1[j,length(mas1[j])-1]:=i;
    end;
  end;
  for i:=1 to n do
  begin
    read(j);
    if j>0 then
    begin
      setlength(mas2[j],length(mas2[j])+1);
      mas2[j,length(mas2[j])-1]:=i;
    end;
  end;
  ans:=0;
  for i:=1 to n do
  begin
    for j:=1 to n do
    begin
      used1[j]:=false;
      used2[j]:=false;
    end;
    dfs1(i);
    dfs2(i);
    for j:=1 to n do if (used1[j] and used2[j]) and (j<>i) then begin ans:=ans+1; end;
  end;
  writeln(ans);
end.
 