#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const int INF = 101010101;
int n, r, u;
vector <int> d;

void read()
{
	cin >> n >> r >> u;
	d.resize(n + 5);
}

void solve()
{
	d[1] = 0;
	d[2] = u;
	for (int i = 3; i <= n; ++i)
	{
		d[i] = INF;
		for (int j = 1; j <= i / 2; ++j)
		{
			if (j * 2 == i)
				d[i] = min(d[i], min(d[j] + u, d[j + 1] + u));
			else
				d[i] = min(d[i], max(d[j] + u, min(d[i - 2 * j] + r, d[i - (2 * j) + 1] + r)));
		}
	}
}

void print()
{
	cout << d[n] << endl;
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}