#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

#pragma comment(linker, "/STACK:67108864")
#define pb push_back
#define mp make_pair

const int MAXN = 10010;
int n, m;
vector <int> ans;
bool v[MAXN][MAXN];
bool eq[MAXN][MAXN];
vector <int> act[MAXN];
int sim[MAXN];

void read()
{
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j < MAXN; ++j)
			eq[i][j] = true;
	int k, tmp;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		sim[i] = n - 1;
	ans = vector <int> (n + 5, 0);
	for (int i = 0; i < m; ++i)
	{
		cin >> k;
		for (int j = 0; j < k; ++j)
		{
			cin >> tmp;
			v[i][tmp] = true;
			act[i].pb(tmp);
		}
	}
}

void solve()
{
	bool good = true;
	vector <int> un, out;
	out.reserve(n + 5);
	int now;
	for (int i = 0; i < m; ++i)
	{
		out.clear();
		for (int j = 1; j <= n; ++j)
			if (!v[i][j] && ans[j] == 0)
				out.pb(j);
		if (out.size() == 1)
		{
			ans[out[0]] = i + 1;
			out.clear();
		}
		if (act[i].size() == 1)
		{
			ans[act[i][0]] = i + 1;
			act[i].clear();
		}
		for (int j = 0; j < act[i].size(); ++j)
		{
			if (ans[act[i][j]] == 0)
			{
				now = act[i][j];
				for (int k = 1; k <= n; ++k)
				{
					if (now != k && eq[now][k] && v[i][now] != v[i][k])
					{
						eq[now][k] = false;
						eq[k][now] = false;
						sim[now]--;
						sim[k]--;
						if (sim[k] == 0 && ans[k] == 0)
							ans[k] = i + 1;
					}
				}
				if (sim[now] == 0)
					ans[now] = i + 1;
			}
		}
	}
}

void print()
{
	for (int i = 1; i <= n; ++i)
		cout << ans[i] << " ";
}

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}