#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

int n, m;
int cx, cy;
int ans, tmp;
int dx[] = {-1, 0, 1};
int dy[] = {-1, 0, 1};

bool can(int mx, int my)
{
	return cx + mx >= 1 && cx + mx <= m && cy + my >= 1 && cy + my <= n;
}

void randmove()
{
	int mx, my;
	do
	{
		mx = rand() % 3;
		my = rand() % 3;
	}
	while (!can(dx[mx], dy[my]));
	cout << dx[mx] << " " << dy[my] << " " << 1 << endl;
	cx += dx[mx];
	cy += dy[my];
	cout.flush();
}

void solve()
{
	cin >> n >> m;
	cin >> cx >> cy;
	cout << "0 0 1" << endl;
	cout.flush();
	cin >> ans >> tmp >> tmp;
	if (ans == 1)
		return;
	while (ans != 1)
	{
		randmove();
		cin >> ans >> tmp >> tmp;
	}
}

int main()
{
	srand(1141201);
	solve();
	return 0;
}