program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  inf = 1000000000000000000;

var
  r, u:int64;
  n, i, j:integer;           
  d:array[1..1000000] of int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');
  read(n, r, u);
  d[1] := 0;
  for i := 2 to n do begin
    d[i] := inf;
    j := 1;
    while 2 * j < i do begin
      d[i] := min(d[i], max(d[j] + u, d[i - 2 * j] + r));
      inc(j);
    end;
    for j := 1 to min(n - i, i) do
      d[i] := min(d[i], max(d[j] + u, d[i - j] + r));
    if not odd(i) then
      d[i] := min(d[i], d[i div 2] + u);
  end;
  write(d[n]);

end.
 