program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  xx : array[1..8] of integer = (0, 1, 1, 1, 0, -1, -1, -1);
  yy : array[1..8] of integer = (1, 1, 0, -1, -1, -1, 0, 1);

type
  point = record
    x, y:integer;
  end;

var
  x0, y0, ddx, ddy, z, dx, dy, l, r, n, m, x, y, j,i, cnt:integer;
  flag:boolean;
  a0, was:array[1..40, 1..40] of boolean;
  q:array[1..10000000] of point;



function dist(x1, y1, x2, y2:integer):integer;
var
  x, y:integer;
begin
  x := abs(x2 - x1);
  y := abs(y2 - y1);
  result := abs(y - x) + min(x, y);
end;

function h(x, y:integer):boolean;
begin
  result := (x > 0) and (x <= n) and (y > 0) and (y <= m);
end;


procedure goo(x0, y0:integer);
var
  k, mink:integer;
begin
  mink := 0;
  for k := 1 to 8 do begin
    if h(x + xx[k], y + yy[k]) and ((mink = 0) or (dist(x0, y0, x + xx[k], y + yy[k]) < dist(x0, y0, x + xx[mink], y + yy[mink]))) then
      mink := k;
  end;
  if dist(x0, y0, x + xx[mink], y + yy[mink]) = 0 then begin
    writeln(xx[mink], ' ', yy[mink], ' ', 1);
    flag := true;
  end else
    writeln(xx[mink], ' ', yy[mink], ' ', 0);
  flush(output);
  x := x + xx[mink];
  y := y + yy[mink];
end;

procedure push(x, y:integer);
begin
  inc(r);
  q[r].x := x;
  q[r].y := y;
end;

function pop:point;
begin
  result := q[l];
  inc(l);
end;


procedure go;
var
  k, i1:integer;
  tec:point;
begin
//writeln(a0[x - dx][y - dy]);
  l := 1;
  r := 0;
  push(x, y);
  if h(x - dx, y - dy) and a0[x - dx][y - dy] then begin
    writeln(0, ' ',0, ' ',1);
    flush(output);
    flag := true;
    exit;
  end;
  fillchar(was, sizeof(was), false);
  while true do begin
    tec := pop;
    i1 := 1 + random(8);
    k := i1;
    repeat
      if h(tec.x + xx[k], tec.y + yy[k]) and not was[tec.x + xx[k]][tec.y + yy[k]] then
        if h(tec.x + xx[k] - dx, tec.y + yy[k] - dy) and a0[tec.x + xx[k] - dx][tec.y + yy[k] - dy] then begin
          goo(tec.x + xx[k], tec.y + yy[k]);
          exit;
        end else
          push(tec.x + xx[k], tec.y + yy[k]);
      k := k mod 8 + 1;
    until k = i1;
  end;
end;
begin
  //reset(input, 'input.txt');
  //rewrite(output, 'output.txt');

randomize;
  readln(m, n);
  readln(x, y);
  dx := 0;
  dy := 0;
  for i := 1 to n do
   for j := 1 to m do
     a0[i][j] := true;

  cnt := 0;
  while true do begin
    go;
    readln(z, ddx, ddy);
    if z = 1 then
      halt;
    if flag then begin
      a0[x - dx][y - dy] := false;
      //writeln('NO: ',x - dx, ' ', y - dy);
      dec(cnt);
    end;

    flag := false;
    dx := dx + ddx;
    dy := dy + ddy;
    for i := 1 to n do begin
      for j := 1 to m do begin
        if a0[i][j] and not h(i + dx, j + dy) then begin
          a0[i][j] := false;
          //writeln('NO: ',i, ' ', j);
          dec(cnt);
        end;
      end;
    end;
  end;
 { for i := 1 to n do
    for j := 1 to m do
      if a0[i][j] then begin
         x0 := i;
         y0 := j;
      end;
  while true do begin
    pr(x0 + dx, y0 + dy);
    readln(z, ddx, ddy);
    if z = 1 then
      halt;
    dx := dx + ddx;
    dy := dy + ddy;
  end;
  }



end.
