#define maxn 100000+500
#define p 239017

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>

using namespace std;

typedef unsigned long long thash;

string s;
int a[maxn];
int b[maxn];
int n,m;
thash st[maxn];

int pows(){
	st[0]=1;
	for (int i=1; i<n; i++) st[i]=st[i-1]*p;
	return 0;
}

thash full(thash a, thash b, thash c, int n, int m, int k){ 
	return (st[m+k]*a+st[k]*b+c); 
}

thash hsh(thash sum){
	thash res=0;
	int cur=0;

	while (sum>0){
		res+=st[cur]*(sum%10);
		sum=sum/10;
		cur++;
	}

	return res;
}

int kolc(thash sum){
	int res=0;

	if (sum==0) return 1;
	else{
		while (sum>0){
			res++;
			sum=sum/10;
		}
		return res;
	}
}

int sol60(){

	thash lh=0,rh,h=0,mh,sum;
	thash pref[maxn];

	for (int i=0; i<m; i++){ 
		h=h*p+b[i]; 
	}
	
	pref[n-1]=a[n-1];
	for (int i=n-2; i>=0; i--){ 
		pref[i]=pref[i+1]+(a[i]*st[n-i-1]); 
	}
		
	for (int l=0; l<n; l++){
		rh=pref[l]; mh=0; sum=0;
		for (int r=l; r<n; r++){
			//mh=mh*p+a[r];
			sum+=a[r];
			rh-=a[r]*st[n-r-1];

			mh=hsh(sum);
			
			if (full(lh,mh,rh,l,kolc(sum),n-r-1)==h){
				printf("%d %d",l+1,r+1);
				return 0;
			}
		}
		lh=lh*p+a[l];
	}

	return 0;
}

int main(){
	freopen("password.in","r",stdin);
	freopen("password.out","w",stdout);

	getline(cin,s);
	n=int(s.size());
	for (int i=0; i<n; i++) a[i]=s[i]-'0';
	getline(cin,s);
	m=int(s.size());
	for (int i=0; i<m; i++) b[i]=s[i]-'0';

	pows();
	sol60();

	return 0;
}
