#define maxn 100000+500

#include <cstdio>
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

struct mt{
	int x;
	int y;
	int ind;
	mt(){
		x=-1; y=-1; ind = -1;
	}
	mt (int a, int b){
		x=a; y=b;
	}
};

vector<mt> z;
vector<mt> res;
int a[maxn],b[maxn];
int al[maxn],bl[maxn],ba[maxn];
int n,k,cur,l;

bool men(mt a, mt b){
	if (a.y!=b.y) return (a.y<b.y);
	else          return (a.x<b.x);
}

bool suit(int x, int y){
	return (a[x]==a[y] || b[x]==b[y]);
}

int links(){
	for (int i=0; i<n; i++){ al[i]=i; bl[i]=i; ba[i]=i; }

	for (int i=1; i<n; i++){
		if (a[i]==a[i-1]){
			al[i]=al[i-1];
			if (b[i]!=b[al[i]-1]) ba[i]=i;
			else                  ba[i]=ba[i-1];
		}
		if (b[i]==b[i-1]){
			bl[i]=bl[i-1];
			if (a[i]!=a[bl[i]-1]) ba[i]=i;
			else                  ba[i]=ba[i-1];
		}

	}
	return 0;
}

int main(){
	freopen("mosaic.in","r",stdin);
	freopen("mosaic.out","w",stdout);

	scanf("%d",&n);
	for (int i=0; i<n; i++) scanf("%d%d",&a[i],&b[i]);
	scanf("%d",&k);
	z.resize(k);
	res.resize(k);
	for (int i=0; i<k; i++){
		scanf("%d%d",&z[i].x,&z[i].y);
		z[i].x--; z[i].y--; z[i].ind=i;
	}
	sort(z.begin(),z.end(),men);
	
	links();

	cur=0; l=0; 
	for (int i=0; i<n; i++){
		l=min(al[i],bl[i]);
		while (cur<k && z[cur].y==i){
			if (z[cur].x<l) res[z[cur].ind]=mt(l-1+1,ba[i]+1);
			else            res[z[cur].ind]=mt(0,0);
			cur++;
		}
	}

	for (int i=0; i<k; i++) printf("%d %d\n",res[i].x,res[i].y);
	return 0;
}
