#define maxn 20

#include <cstdio>
#include <vector>

using namespace std;

int n,k,kol;
int tel[maxn];
int a[maxn];
bool used[maxn];

bool h[maxn];
int seg[maxn];
int ct;

int check(){
	
	int cur=0;

	for (int i=0; i<n; i++){
		if (cur<k && a[i]==tel[cur]) cur++;
	}
	if (cur<k) return 0;

	int dp[maxn],maxx=-1;

	for (int i=0; i<n; i++){
		dp[i]=1;
		for (int j=0; j<i; j++){
			if (dp[j]+1>dp[i] && a[j]<a[i]) dp[i]=dp[j]+1;
		}
		if (maxx<dp[i]) maxx=dp[i];
	}
	if (maxx>k) return 0;

	/*for (int i=0; i<n; i++) printf("%d ",a[i]+1);
	printf("\n");*/

	kol++;
	return 0;
}

int fun(int pos){
	if (pos==n){ check(); return 0; }
	for (int i=0; i<n; i++){
		if (!used[i]){
			used[i]=true; a[pos]=i;
			fun(pos+1);
			used[i]=false; a[pos]=-1;
		}
	}
	return 0;
}

int segmax(int x){
	int res=0;
	for (int i=0; i<=x; i++) 
		if (seg[i]>res) res=seg[i];
	return res;
}

int fast_fun(int pos){
	if (pos==n){ kol++; return 0; }
	for (int i=0; i<n; i++){
		if (!used[i] && (!h[i] || (tel[ct]==i)) && segmax(i-1)+1<=k){
			used[i]=true; a[pos]=i; 
			seg[i]=segmax(i-1)+1; 
			if (h[i]) ct++;
			fast_fun(pos+1);
			if (h[i]) ct--;
			seg[i]=0;
			used[i]=false; a[pos]=-1;
		}
	}
	return 0;
}

int main(){
	freopen("army.in","r",stdin);
	freopen("army.out","w",stdout);
	scanf("%d%d",&n,&k);
	for (int i=0; i<k; i++){
		scanf("%d",&tel[i]);
		tel[i]--;
	}

	kol=0;
	memset(used,false,sizeof(used));

	/*a[n-1]=tel[k-1];
	used[tel[k-1]]=true;
	
	if (k>1){
		a[0]=tel[0];
		used[tel[0]]=true;
		fun(1);
	}
	else */
	//fun(0);

	memset(seg,0,sizeof(seg));
	for (int i=0; i<k; i++) h[tel[i]]=true;
	ct=0;
	fast_fun(0);

	printf("%d",kol);
	return 0;
}
