#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cstring>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#pragma comment(linker, "/STACK:268435456")

vector< string > s;
int n, m;

vector< int > knowpos;
vector< int > knowdig;
vector< int > ans;

int main()
{
	freopen("calendar.in","r", stdin);
	freopen("calendar.out","w", stdout);
	scanf("%d%d\n", &n, &m);
	s.resize(n);
	for (int i = 0 ;i  < n; i++)
		getline(cin, s[i]);

	knowpos.assign(m, -1);
	knowdig.assign(m, -1);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (s[i][j] != '*')
			{
				knowpos[j] = i;
				knowdig[j] = s[i][j] - '0';
			}

	for (int i = 0; i < m; i++)
		if (knowpos[i] == -1)
		{
			if (n == 2)
			{
				cout << 999;
				return 0;
			}
			else
			{
				cout << "0098";
				return 0;
			}
		}

	int dig = ((knowdig[m - 1] - knowpos[m-1]) % 10 + 10) % 10;
	s[0][m-1] = dig + '0';

	for (int i = 1; i < n; i++)
		s[i][m-1] = (s[i-1][m-1] - '0' + 1) % 10 + '0';

	for (int j = m-2; j>=0; j--)
	{
		for (int i = knowpos[j]; i > 0; i--)
		{
			if (s[i-1][j+1] == '9')
				s[i-1][j] = (s[i][j] - '0'  - 1 + 10) % 10 + '0';
			else
				s[i-1][j] = s[i][j];
		}

		for (int i = knowpos[j]; i < n-1; i++)
		{
			if (s[i][j+1] == '9')
				s[i+1][j] = (s[i][j]-'0' + 1) % 10 + '0';
			else
				s[i+1][j] = s[i][j];
		}
	}

	printf("%s", s[0].c_str());
}