#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <queue>

#pragma comment(linker,"/STACK:268435456")

using namespace std;

const int MAXN = 100010;

int id[MAXN];
map<int, int> when;
map<int, int> kol;
map<int, int> newid;
map<int, int> newkol;
vector<bool> good;
vector< int > buf;
int n, m;
int IDCOUNT = 1;

int main()
{
	freopen("theatre.in","r", stdin);
	freopen("theatre.out","w", stdout);

	memset(id, 0, sizeof(id));
	
	scanf("%d%d", &n, &m);
	kol[0] = n;
	when[0] = 0;

	for (int i = 0; i < m; i++)
	{
		int k;
		scanf("%d", &k);

		buf.clear();
		buf.reserve(k);

		newid.clear();
		newkol.clear();

		good.assign(k, false);

		for (int j = 0; j < k; j++)
		{
			int x;
			scanf("%d", &x);
			x--;
			buf.push_back(x);

			if (newid.find(id[x]) == newid.end())
				newid[id[x]] = IDCOUNT++;
			newkol[newid[id[x]]]++;
		}

		for (int j = 0; j < k; j++)
		{
			int x = buf[j];

			if (kol[id[x]] == newkol[newid[id[x]]])
				continue;
			good[j] = true;
		}

		for (int j = 0; j < k; j++)
		{
			int x = buf[j];

			if (!good[j])
				continue;

			when[id[x]] = i;
			when[newid[id[x]]] = i;

			kol[id[x]]--;
			kol[newid[id[x]]]++;

			id[x] = newid[id[x]];
		}
		//for (int i = 0; i < n; i++)
		//	cerr << id[i] << ' ';
		//cerr << endl;
	}

	for (int i = 0; i < n; i++)
	{
		if (kol[id[i]] > 1)
		{
			printf("0 ");
			continue;
		}
		printf("%d ", when[id[i]] + 1);
	}
}