#include <cstdio>
#include <algorithm>

using namespace std;

int iw[100000], ih[100000], w[100000], h[100000], pw[100000], ph[100000], p[100000], t[100000];

bool cmpw(int a, int b) {return w[a] < w[b];}
bool cmph(int a, int b) {return h[a] < h[b];}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d%d", w+i, h+i);
        pw[i] = ph[i] = i;
    }
    sort(pw, pw+n, cmpw);
    sort(ph, ph+n, cmph);
    iw[pw[0]] = 0;
    for (int i = 1; i < n; i++)
        if (w[pw[i]] == w[pw[i-1]]) iw[pw[i]] = iw[pw[i-1]];
            else iw[pw[i]] = iw[pw[i-1]]+1;
    ih[ph[0]] = 0;
    for (int i = 1; i < n; i++)
        if (h[ph[i]] == h[ph[i-1]]) ih[ph[i]] = ih[ph[i-1]];
            else ih[ph[i]] = ih[ph[i-1]]+1;
    for (int i = 0; i < n; i++) w[i] = h[i] = -1;
    for (int i = 0; i < n; i++) {
        pw[i] = w[iw[i]];
        ph[i] = h[ih[i]];
        w[iw[i]] = i;
        h[ih[i]] = i;
    }
    w[0] = h[0] = -1;
    for (int i = 1; i < n; i++) {
        w[i] = (pw[i] == i-1) ? w[i-1] : i-1;
        h[i] = (ph[i] == i-1) ? h[i-1] : i-1;
    }
    p[0] = -1;
    for (int i = 1; i < n; i++)
        if ((pw[i] == i-1) && (ph[i] == i-1)) {p[i] = p[i-1]; t[i] = t[i-1];} else {
            p[i] = min(w[i], h[i]);
            t[i] = ((iw[p[i]] != iw[i]) && (ih[p[i]] != ih[i])) ? i : i-1;
        }
    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        int l, r;
        scanf("%d%d", &l, &r);
        if (p[r-1]+1 < l) printf("0 0\n");
            else printf("%d %d\n", p[r-1]+1, t[r-1]+1);
    }
    return 0;
}
