#pragma comment(linker, "/STACK:16777216")

#include <iostream>

#define INF 1<<30;

using namespace std;

int main()
{
	freopen("apricot.in","r",stdin);
	freopen("apricot.out","w",stdout);

	int n, r, u;
	cin >> n >> r >> u;

	int din[1000001];
	din[0] = 0;
	din[1] = 0;

	for(int i=2; i<=n; i++)
	{
		din[i] = INF;
		for(int j=1; 2*j<i; j++)
		{
			int q = max(
				din[i-2*j] + r,
				din[j] + u
			);
			if(din[i] > q) din[i] = q;
		}
		if(!(i&1))
			din[i] = min(din[i], din[i/2] + u);
	}

	std::cout << din[n];

	return 0;
}