#pragma comment (linker, "/STACK:16777216")

#include <iostream>
#include <algorithm>

using namespace std;

#define N 100000

struct point
{
	int x; // 
	int y; // 
};

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);

	int n; cin >> n;
	int s[N][2];
	for(int i=0; i<n; i++) cin >> s[i][0] >> s[i][1];

	point l, r;

#define first 0

	l.x = r.x = 0; l.y = r.y = -1;
	int a[N][2]; //      
	for(int i=0; i<n; i++)
	{
		if(s[i][first] == l.x) l.y = i;
		else if(s[i][first] == r.x) r.y = i;
		else
		{
			if(!(l.x)) {l.x = s[i][first]; l.y = i;}
			else if(!(r.x)) {r.x = s[i][first]; r.y = i;}
			else
			{
				if(l.y < r.y) {l.x = s[i][first]; l.y = i;}
				else {r.x = s[i][first]; r.y = i;}
			}
		}
		a[i][0] = l.y; a[i][1] = r.y;
	}

#define a b
#undef first
#define first 1

	l.x = r.x = 0; l.y = r.y = -1;
	int a[N][2]; //      
	for(int i=0; i<n; i++)
	{
		if(s[i][first] == l.x) l.y = i;
		else if(s[i][first] == r.x) r.y = i;
		else
		{
			if(!(l.x)) {l.x = s[i][first]; l.y = i;}
			else if(!(r.x)) {r.x = s[i][first]; r.y = i;}
			else
			{
				if(l.y < r.y) {l.x = s[i][first]; l.y = i;}
				else {r.x = s[i][first]; r.y = i;}
			}
		}
		a[i][0] = l.y; a[i][1] = r.y;
	}

#undef a
#undef first

#define check(x, y) if(s[x][0] != s[y][0] && s[x][1] != s[y][1]) \
	{cout << x+1 << " " << y+1 << "\n"; continue;}

	int k; cin >> k;
	int x, y, p, q;

	for(int i=0; i<k; i++)
	{
		cin >> x >> y;
		x--; y--;
		p = min(a[y][0], a[y][1]);
		q = min(b[y][0], b[y][1]);
		if(p >= x && q >= x)
		{
			check(p, q);
			check(p, y);
			check(q, y);
		}
		else cout << "0 0\n";
	}

	return 0;
}