//#pragma comment (linker, "/STACK:16777216")

#include <iostream>
#include <set>

using namespace std;

#define N 10000

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	set<pair<__int64, int>> t;

	int n, k; cin >> n >> k;
	int ki, f[N]={0};
	__int64 hashes[N], pow1=1, pow2=1;
	int q;

	for(int i=0; i<n; i++)
	{
		t.insert(make_pair(1, i));
		hashes[i] = 1;
	}

	for(int i=0; i<k; i++)
	{
		cin >> ki;

		pow1 *= 17;
		pow2 *= 257;

		for(int j=0; j<ki; j++)
		{
			cin >> q; q--;
			t.erase(make_pair(hashes[q], q));
			hashes[q] += (pow1<<32) + pow2;
			t.insert(make_pair(hashes[q], q));
		}

		set<pair<__int64, int>>::iterator a, b, c;

#define z(x) ((*(x)).first)
#define w(x) ((*(x)).second)

		for(a=t.begin(), b=a, ++b, c=b, ++c; c!=t.end(); a++, b++, c++)
		{
			if(z(a) != z(b) && z(b) != z(c) && !f[w(b)]) f[w(b)]=i+1;
		}

		a = t.begin();
		b = a; ++b;
		if(z(a) != z(b) && !f[w(a)]) f[w(a)]=i+1;

		a = t.end();
		b = --a; --b;
		if(z(a) != z(b) && !f[w(a)]) f[w(a)]=i+1;
	}

	for(int i=0; i<n; i++) cout << f[i] << " ";

	return 0;
}