#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100100;

char s1[maxn], s2[maxn];
int f1[maxn], l1, l2, f2[maxn];
int Len[maxn * 10], suff;

inline int LEN(int n) {
	int res = 0;
	if(n == 0) return 1;
	while(n > 0) {
		res++;
		n /= 10;
	}
	return res;
}

inline int sum(int l, int r) {
	return (f1[r] - (l > 0 ? f1[l - 1] : 0));
}

bool cmp(int l, int r) {
	int Sum = sum(l, r);
	char s[20];
	sprintf(s, "%d", Sum);
	for(int i = 0; s[i] != 0; i++) {
		if(s[i] != s2[l + i]) return false;
	}
	return true;
}
bool check(int l, int r) {
	if(r < l) return false;
	return(r < l1 && l1 - r - 1 <= suff && cmp(l, r));
}

int main() {
	RedirectIO("password");
	gets(s1);
	gets(s2);
	l1 = strlen(s1);
	l2 = strlen(s2);
	f1[0] = s1[0] - '0';
	f2[0] = s2[0] - '0';
	for(int i = 1; i<l1; i++) f1[i] = s1[i] - '0' + f1[i - 1];
	for(int i = 1; i<l2; i++) f2[i] = s2[i] - '0' + f2[i - 1];
	int l = 0;
	for(int i = 0; i<maxn * 10; i++) Len[i] = LEN(i);
	for(suff = 0;; suff++) 
		if(l1 - (suff + 1) < 0 || l2 - (suff + 1) < 0 || s1[l1 - (suff + 1)] != s2[l2 - (suff + 1)]) break;
	while(true) {
		int L = l, R = l1 - 1, m;
		while(L < R) {
			m = (L + R) / 2;
			int S = sum(l, m);
			if(l1 - (m - l + 1) + Len[S] > l2) L = m + 1;
			else R = m;
		}
		if(R < L) continue;
		if(check(l, L - 1)) {
			cout<<l +1 << " "<<L<<endl;
			return 0;
		}
		if(check(l, L)) {
			cout<<l + 1<< " "<<L + 1<<endl;
			return 0;
		}
		if(check(l, L + 1)) {
			cout<<l + 1<< " "<<L + 2<<endl;
			return 0;
		}
		l++;
	}
	return 0;
}