#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 10010;

vi t1[maxn], t2[maxn];
int tin1[maxn], tin2[maxn], tout1[maxn], tout2[maxn];
int r1, r2;
int n;
int timer = 0;

void dfs1(int v) {
	tin1[v] = timer++;
	forn(i, t1[v].size()) {
		int to = t1[v][i];
		dfs1(to);
	}
	tout1[v] = timer++;
}

void dfs2(int v) {
	tin2[v] = timer++;
	forn(i, t2[v].size()) {
		int to = t2[v][i];
		dfs2(to);
	}
	tout2[v] = timer++;
}

bool isparent1(int i, int j) {
	return(tin1[i] < tin1[j] && tout1[i] > tout1[j]);
}

bool isparent2(int i, int j) {
	return(tin2[i] < tin2[j] && tout2[i] > tout2[j]);
}

int main() {
	RedirectIO("virus");
	cin>>n;
	int pi;
	for(int i = 0; i<n; i++) {
		scanf("%d", &pi);
		if(pi == 0) r1 = i;
		--pi;
		t1[pi].pb(i);
	}
	for(int i = 0; i<n; i++) {
		scanf("%d", &pi);
		if(pi == 0) r2 = i;
		--pi;
		t2[pi].pb(i);
	}
	timer = 0;
	dfs1(r1);
	timer = 0;
	dfs2(r2);
	int res = 0;
	for(int i = 0; i<n; i++) {
		for(int j = 0; j<n; j++) {
			if(i == j) continue;
			if(isparent1(i, j) && isparent2(i, j)) res++;
		}
	}
	cout<<res;
	return 0;
}