#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef pair<int, int> pii;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100000;
const int INF = 1000000000;

pii src[maxn];
int near[maxn];
int n, k;

bool harm(int i, int j) {
	return(src[i].first == src[j].first || src[i].second == src[j].second);  
}

int main() {
	RedirectIO("mosaic");
	cin>>n;
	forn(i, n) {
		scanf("%d%d", &src[i].fi, &src[i].se);
	}
	forn(i, n) {
		near[i] = -INF;
		for(int j = i - 1; j >= 0; j--) {
			if(!harm(i, j)) {
				near[i] = j;
				break;
			}
		}
	}
	cin>>k;
	forn(tmp, k) {
		int l, r, found = false;
		scanf("%d%d", &l, &r);
		l--; r--;
		for(int i = l; i<=r; i++) {
			if(near[i] >= l) {
				printf("%d %d\n", near[i] + 1, i + 1);
				found = true;
				break;
			}
		}
		if(!found) {
			printf("0 0\n");
		}
	}
	return 0;
}