#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef pair<int, int> pii;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100000;
const int INF = 1000000000;

#define DONE -1

vector<int> type, ans, cnt;
int n, m, ki, id;

int main() {
	RedirectIO("theatre");
	cin>>n>>m;
	type.assign(n, 0);
	ans.assign(n, 0);
	cnt.assign(m + 1, 0);
	cnt[0] = n;
	forn(act, m) {
		scanf("%d", &ki);
		forn(i, ki) {
			scanf("%d", &id);
			id--;
			if(type[id] == DONE) continue;
			cnt[type[id]]--;
			type[id]++;
			cnt[type[id]]++;
		}
		forn(i, m + 1) {
			if(cnt[i] == 1) {
				for(int j = 0; j<n; j++) {
					if(type[j] == i) {
						type[j] = DONE;
						ans[j] = act + 1;
						cnt[i]--;
						break;
					}
				}
			}
		}
	}
	for(int i = 0; i<n; i++) {
		printf("%d ", ans[i]);
	}
	return 0;
}