#include <windows.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <cstdlib>
using namespace std;
 

#define j0 J0
#define i0 I0
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)
 
typedef pair<int, int> pii;
typedef vector<pii> vii;
void RedirectIO(string file) {
    freopen((file + ".in").c_str(), "r", stdin);
    freopen((file + ".out").c_str(), "w", stdout);
}
 
const int maxn = 100000;
const int INF = 1000000000;
 
#define DONE -1
 
int di[8] = {0, 0, 1, 1, 1, -1, -1, -1};
int dj[8] = {1, -1, 0, -1, 1, 0, 1, -1};

int n, m, i0, j0;
int hi1, hi2, hj1, hj2;

bool inside(int i, int j) {
	return(i >= hi1 && i<=hi2 && j >= hj1 && j <= hj2);
}

bool query() {
	int k, r, Di, Dj;
	while(true) {
		k = rand() % 8;
		if(inside(i0 + di[k], j0 + dj[k])) break;
	}
	printf("%d %d %d\n", i0 + di[k], j0 + dj[k], 1);
	scanf("%d%d%d", &r, &Dj, &Di);
	if(r == 0) return true;
	if(Dj == 1) hj1 = min(hj1 + 1, m), hj2 = min(hj2 + 1, m); 
	if(Dj == -1) hj1 = min(hj1 - 1, 1), hj2 = min(hj2 - 1, 1);
	if(Di == 1) hi1 = min(hi1 + 1, n), hi2 = min(hi2 + 1, n);
	if(Di == -1) hi1 = min(hi1 - 1, n), hi2 = min(hi2 - 1, m);
}

int main() {
    //RedirectIO("theatre");
    cin>>n>>m;
	cin>>j0>>i0;
	hi1 = 1; hj1 = 1; hi2 = n; hj2 = m;
	while(inside(i0, j0)) {
		if(query())break;
	}
    return 0;
}