#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "password.in";
const char * fout = "password.out";

const int cmax = 100500;

int n, m;
int s[cmax], t[cmax];
vector<int> pref;
char _[cmax];

int sz(int cur){
    if (cur == 0)
        return 1;
    int res = 0;
    while (cur > 0){
        ++res;
        cur /= 10;
    }
    return res;
}

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    scanf("%s", &_);
    n = strlen(_);
    for (int i = 0; i < n; i++)
        s[i+1] = _[i] - '0';
    scanf("%s", &_);
    m = strlen(_);
    for (int i = 0; i < m; i++)
        t[i+1] = _[i] - '0';
    pref.assign(n+1, 0);
    pref[0] = 0;
    for (int i = 1; i <= n; i++)
        pref[i] = pref[i-1] + s[i];
    for (int i = 1; i <= m; i++){
        int cur = 0;
        for (int j = 0; j < 6 && i+j <= m; j++){
            cur = cur * 10 + t[i+j];
            int al = sz(cur);
            if (pref[i+al+n-m-1]-pref[i-1] == cur){
                printf("%d %d\n", i, i+al+n-m-1);
                return 0;
            }
        }
    }
    printf("%d %d\n", 1, 1);
    return 0;
}
