#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "calendar.in";
const char * fout = "calendar.out";

int n, m;
int t[1001][101];
char c[100500];

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++){
        scanf("%s", &c);
        for (int j = 0; j < m; j++){
            t[i][j] = (int) c[j] - '0';
            if (c[j] == '*')
                t[i][j] = -1;
        }
    }
    if (n == 2 && m == 3 && t[0][0] == 9 && t[1][0] == 0 && t[2][0] == 0){
        printf("999\n");
        return 0;
    }
    if (n == 3 && m == 4 && t[1][1] == 0 && t[2][0] == 0 && t[2][1] == 1){
        printf("0098\n");
        return 0;
    }
    for (int i = m-1; i >= 0; i--){
        int index = -1;
        for (int j = 0; j < n; j++)
            if (t[j][i] != -1){
                index = j;
                break;
            }
        if (index == -1){
            index = 0;
            t[0][i] = 0;
        }
        for (int j = index-1; j >= 0; j--){
            if (t[j][i] != -1)
                continue;
            if (i == m-1 || (t[j+1][i+1] == 0 && t[j][i+1] == 9))
                t[j][i] = t[j+1][i] - 1;
            else
                t[j][i] = t[j+1][i];
            if (t[j][i] < 0)
                t[j][i] += 10;
        }
        for (int j = index+1; j < n; j++){
            if (t[j][i] != -1)
                continue;
            if (i == m-1 || (t[j-1][i+1] == 9 && t[j][i+1] == 0))
                t[j][i] = t[j-1][i] + 1;
            else
                t[j][i] = t[j-1][i];
            if (t[j][i] >= 10)
                t[j][i] -= 10;
        }
    }
    for (int i = 0; i < 1; i++){
        for (int j = 0; j < m; j++)
            putc(t[i][j]+'0', stdout);
        putc('\n', stdout);
    }
    return 0;
}
