#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "theatre.in";
const char * fout = "theatre.out";

const int cmax = 10000;

int n, m;
vector<vector<int> > p;
bitset<cmax> pr[cmax];
bitset<cmax> norm;

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        norm[i] = 1;
    p.resize(m);
    for (int i = 0; i < m; i++){
        int t; cin >> t; p[i].resize(t);
        for (int j = 0; j < t; j++)
            cin >> p[i][j], --p[i][j], pr[i][p[i][j]] = 1;
        sort(all(p[i]));
        pr[i] = pr[i] & norm;
    }
    for (int i = 0; i < n; i++){
        bitset<cmax> cur = norm;
        bool flag = false;
        for (int j = 0; j < m; j++){
            if (pr[j][i])
                cur = cur & pr[j];
            else
                cur = cur & (~pr[j]);
            if (cur.count() == 1){
                cout << j+1 << ' ';
                flag = true;
                break;
            }
        }
        if (!flag)
            cout << 0 << ' ';
    }
    return 0;
}
