#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define y1 y1_293293

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "input.txt";
const char * fout = "output.txt";

int n, m;
int x, y;
int x1, y1, x2, y2;

int dist[31][31];
int ql[100500], qr[100500];
int l = 0, r = 0;

const int cx[] = {-1, 0, 1, -1, 0, 1, -1, 0, 1};
const int cy[] = {-1, -1, -1, 0, 0, 0, 1, 1, 1};

vector<pair<int, int> > pos, npos;

void bfs(){
    l = r = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            dist[i][j] = inf;
    for (int i = 0; i < len(pos); i++)
        dist[pos[i].fs][pos[i].sc] = 0, ql[i] = pos[i].fs, qr[i] = pos[i].sc;
    r = len(pos);
    while (r > l){
        int x = ql[l], y = qr[l]; ++l;
        for (int i = 0; i < 8; i++){
            int nx = x + cx[i], ny = y + cy[i];
            if (nx < 0 || nx >= n || ny < 0 || ny >= m)
                continue;
            if (dist[nx][ny] > dist[x][y] + 1){
                dist[nx][ny] = dist[x][y] + 1;
                ql[r] = nx; qr[r] = ny; ++r;
            }
        }
    }
}

int main(){
    cin >> m >> n >> y >> x; --x; --y;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            pos.pb(mp(i, j));
    for (;;){
        bfs();
        int nx = -1, ny = -1;
        for (int i = 0; i < 8; i++)
            if ((x+cx[i] >= 0 && x + cx[i] < n && y + cy[i] >= 0 && y + cy[i] < m) && (nx == -1 || dist[nx][ny] > dist[x+cx[i]][y+cy[i]]))
                nx = x + cx[i], ny = y + cy[i];
        cout << nx - x << ' ' << ny - y << ' ';
        bool flag = false;
        for (int i = 0; i < len(pos); i++)
            if (pos[i].fs == nx && pos[i].sc == ny){
                flag = true;
                break;
            }
        if (flag)
            cout << 1 << endl;
        else
            cout << 0 << endl;
        cout.flush();
        x = nx; y = ny;
        int res, dx, dy; cin >> res >> dx >> dy;
        if (res == 1)
            return 0;
        for (int i = 0; i < len(pos); i++)
            pos[i].fs += dx, pos[i].sc += dy;
        npos.clear();
        for (int i = 0; i < len(pos); i++)
            if (pos[i].fs >= 0 && pos[i].fs < n && pos[i].sc >= 0 && pos[i].sc < m && (pos[i].fs != x || pos[i].sc != y))
                npos.pb(pos[i]);
        pos = npos;
        for (int i = 0; i < len(pos); i++)
            cout << pos[i].fs << ' ' << pos[i].sc << endl;
    }
    return 0;
}
