#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
#define FILE_NAME "password"
#define f first
#define s second
#define mp make_pair
#define pb push_back
typedef long long ll;
const int N = 1e5 + 5;
string s, t;
int n, m, sum[N];
int get(int l, int r)
{
  if (r < l) return -100;
  if (!l) return sum[r];
  return sum[r] - sum[l - 1];
}
int getPos(int beg, int z, int noFind)
{
  int l = 0, r = n - beg + 1, mid;
  while (l < r - 1)
  {
    mid = (l + r) / 2;
    if (z >= get(beg, beg + mid - 1)) l = mid;
    else r = mid;
  }
  if (get(beg, beg + l - 1) == z) return beg + l - 1;
  return -100;
}
int main()
{
  freopen(FILE_NAME".in", "r", stdin);
  freopen(FILE_NAME".out", "w", stdout);
  cin >> s >> t;
  if (s == t)
  {
    cout << "1 1";
    return 0;
  }
  n = s.size();
  m = t.size();
  int posBeg = 0, posEnd = m - 1, tt = n - 1;
  while (posBeg < m && s[posBeg] == t[posBeg]) posBeg++;
  while (posEnd >= 0 && s[tt] == t[posEnd]) posEnd--, tt--;
  posEnd++;
  tt++;
  sum[0] = s[0] - '0';
  for (int i = 1; i < n; i++)
    sum[i] = sum[i - 1] + s[i] - '0';

  for (int i = 0; i <= posBeg; i++)
  {
    int f = 0;
    if (t[i] == '0') continue;
    for (int j = i; j < min(m, i + 6); j++)
    {
      f = f * 10 + t[j] - '0';
      int p = getPos(i, f, tt);
      if (n - p - 1 <= m - j - 1)
      {
        int shift = m - j - 1 - (n - p - 1);
        if (get(i, p - shift) == f) p -= shift;
        else continue;
      }
      if (p >= tt - 1)
      {
        cout << i + 1 << " " << p + 1;
        return 0;
      }
    }
  }
  return 0;
  //ofogevove
  /*
  1002
  102

  198
  18

  10021
  13

  10991
  10181

  103291
  10141
  */
}
