#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 200100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "password"

using namespace std;

char s1[N], s2[N];
int n, m, k, cs[N]; 

void solve(int l, int r)
{
	int cnum, s;

	cnum = s = 0;

	for (int i = l; i <= min(l + 8, m); i++)
	{
		cnum = cnum * 10 + s2[l] - '0';
		s = cs[r + (i - l)]	- cs[l - 1];

		if (cnum > 0 && s2[l] - '0' == 0)
			return ;

		else if (cnum == s)
		{
			printf ("%d %d", l, r + i - l);
			exit(0);
		}			
	}
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	gets(s1 + 1), n = strlen(s1 + 1);
	gets(s2 + 1), m = strlen(s2 + 1);

	k = n - m + 1;

	for (int i = 1; i <= n; i++)
		cs[i] = cs[i - 1] + (int)(s1[i] - '0');

	for (int i = m; i >= 1; i--)
	{		
		solve(i, i + k - 1);
	}

	return 0;
}
