#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>
 
#define N 200100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "password"
 
using namespace std;
 
char s1[N], s2[N];
int n, m, k, cs[N]; 
int ans[N][2], t; 

void check(int l, int r)
{
	int cnum = 0;

	for (int i = l; i <= r; i++)
		cnum = cnum * 10 + (int)(s2[i] - '0');

	if (cnum > 0 && s2[l] - '0' == 0)
		return ;

	int s = cs[l];

	for (int i = l + k; i < r + k; i++)
		s += (int)s1[i] - '0';

	if (cnum == s)
	{
		printf ("%d %d", l + 1, r + k);
		exit(0); 
	} 
		 				
}

int main()
{
    freopen (FILE_NAME".in", "r", stdin);
    freopen (FILE_NAME".out", "w", stdout);
 
    gets(s1);
    n = strlen(s1);
    
    gets(s2);
    m = strlen(s2);
 
    k = n - m + 1;
    int cnum;
 
    for (int i = 0; i < k; i++)
        cs[0] += (int)(s1[i] - '0');
 
    for (int i = 1; i < m; i++)
        cs[i] = cs[i - 1] + (int)(s1[i + k - 1] - '0') - (int)(s1[i - 1] - '0');                        
 

	for (int i = 0; i < m; i++)
		for (int j = i; j < min(i + 8, m); j++)
			check(i, j);

    return 0;
}