#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 200100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "password"

using namespace std;

char s1[N], s2[N];
int n, m, k, cs[N]; 

void check(int cres, int pos, int fpos)
{
	int cnum = 0, i = pos;
	while (cnum < cres)
	{
		cnum = cnum * 10 + (s2[i] - '0');
		i++;
	}

	if (cnum == cres && fpos - pos + 1 == k + i - 1 - pos)
	{
		printf ("%d %d", pos, fpos);
		exit(0);		
	}	
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	gets(s1 + 1), n = strlen(s1 + 1);
	gets(s2 + 1), m = strlen(s2 + 1);

	k = n - m + 1;

	for (int i = 1; i <= n; i++)
		cs[i] = cs[i - 1] + (int)(s1[i] - '0');

	for (int i = 1; i <= n; i++)
	{		
	    for (int j = i; j <= n; j++)
	    	check(cs[j] - cs[i - 1], i, j);
	}    

	return 0;
}
