#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 100100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "virus"

using namespace std;

typedef long long ll;

int n, tin[2][N], tout[2][N], root[2], t;
int start[2][N], next[2][N], data[2][N], was[N];
ll d[N];

void addEdge(int a, int b, int gnum)
{	
	t++;
	next[gnum][t] = start[gnum][a];
	start[gnum][a] = t;
	data[gnum][t] = b;
}

void read(int gnum)
{
	int p;
	for (int i = 1; i <= n; i++)
	{
		scanf ("%d", &p);

		if (p != 0)
			addEdge(p, i, gnum);
		else
			root[gnum] = i;	
	}
}

void dfs(int k, int gnum)
{
	tin[gnum][k] = ++t;

	for (int i = start[gnum][k]; i != 0; i = next[gnum][i])
		dfs(data[gnum][i], gnum);

	tout[gnum][k] = ++t;
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	scanf ("%d", &n);
	
	read(0);
	t = 0;
	read(1);

	t = 0;	
	dfs(root[0], 0);
	
	t = 0;
	dfs(root[1], 1);

	int ans = 0;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			if (tin[0][j] > tin[0][i] && tout[0][i] > tout[0][j])
			{
				if (tin[1][j] > tin[1][i] && tout[1][i] > tout[1][j])
					ans++;
			}

	printf ("%d", ans);
	return 0;
}