#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 100100
#define M 1010
#define eps 1e-9
#define FILE_NAME "apricot"

using namespace std;

typedef long long ll;

const ll inf = (ll)1e18;

ll n, u, r;
ll d[N];

ll rec(int k)
{
	if (d[k] != inf)
		return  d[k];
	
	int i, j;

	for (i = 1; i <= k / 2; i++)
	{
		j = k - 2 * i;

		if (j == 0)
			d[k] = min(d[k], u + rec(k / 2));

		else		
			d[k] = min(d[k], max(u + rec(i), r + rec(j)));		                 	
	}

	cerr << k << ' ' << d[k] << endl;
	return d[k];
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	scanf ("%d %d %d", &n, &r, &u);

	for (int i = 2; i <= n; i++)	
		d[i] = inf;
			
	printf ("%I64d", rec(n));

	return 0;
}