#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 1010
#define M 101
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "calendar"

using namespace std;

char s[N][M], ans[M];
int n, m;

inline bool checkstr(int k, int i)
{
	for (int j = m; j > max(0, m - 4); j--)
	{			
		if (s[i][j] == '*')
		{
			k /= 10;
			continue;
		}
		if ((int)(s[i][j] - '0') != k % 10)
		{
			//cerr << (s[i][j] - '0') << ' ' << k % 10 << endl;
			return false;
		}

		k /= 10;
	}
	return true;
}

void check(int k)
{
	int ok = k;
	for (int i = 1; i <= n; i++)
	{
		if (!checkstr(k, i))
		{
			return;
		}
		k++;
	}

	int i, j;

	for (i = 1; i <= m - 4; i++)
	{
		for (j = 1; j <= n; j++)
			if (s[j][i] != '*')
			{
				putchar(s[j][i]);
				break;	
			}	
		if (j > n)
			putchar('1');
	}

	if (m == 1)
		printf ("%d", ok);
	else if (m == 2)
		printf ("%02d", ok);
	else if (m == 3)
		printf ("%03d", ok);
	else
		printf ("%04d\n", ok);
	printf ("\n");
	exit(0);
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j, cur;

	scanf ("%d %d\n", &n, &m);

	for (i = 1; i <= n; i++)
		gets (s[i] + 1);
	
	for (i = 0; i < 10000; i++)
	{
		check(i);
	}

	return 0;
}