#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "mosaic"

using namespace std;

typedef long long ll;

int x[N], y[N], n, k;
int cntx, cnty, cntboth, l, r, lastx, lasty;

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j;

	scanf ("%d", &n);
	for (i = 1; i <= n; i++)
		scanf ("%d %d", &x[i], &y[i]);

	scanf ("%d", &k);

	for (i = 1; i <= k; i++)
	{
		scanf ("%d %d", &l, &r);
		
		lastx = lasty = 0;

		for (j = l + 1; j <= r; j++)
		{
			if (x[l] != x[j] && y[l] != y[j])
			{
				printf ("%d %d\n", l, j);
				break;
			}

			if (x[l] != x[j])
				lastx = j;

			if (y[l] != y[j])
				lasty = j;				
		}

		if (j <= r)
			continue;

		if (lastx && lasty)
			printf ("%d %d\n", lastx, lasty);

		else
			printf ("0 0\n");			
	
	}	

	return 0;
}