program Prob1;

{$APPTYPE CONSOLE}
{$O-}

uses
  SysUtils;

type
  Long = record
    cnt: integer;
    a: array[1..100000] of integer;
  end;

const
  base = 10;
  baselen = 1;

var
  s, t, s1: string;
  i, j, k: integer;
  a, b: Long;
  p: array[1..300000]of integer;
  
function sum(a: Long; b: integer): Long;
var
  i: integer;
begin
  result.cnt := a.cnt;
  result.a[1] := b;
  for i := 1 to a.cnt do begin
    result.a[i] := result.a[i] + a.a[i];
    result.a[i+1] := result.a[i] div base;
    result.a[i] := result.a[i] mod base;
  end;
  if result.a[result.cnt+1] > 0 then
    inc(result.cnt);
end;

function check(l, r: integer): boolean;
var
  i, m: integer;
begin
  m := r - (length(s) - length(t));
  for i := m downto l do
    if strtoint(t[i]) <> b.a[m-i+1] then begin
      result := false;
      exit;
    end;
  result := true;
end;

procedure kmp;
var
  i, l: integer;
begin
  fillchar(p, sizeof(p), 0);
  l := 0;
  for i := 2 to length(s1) do begin
    l := p[i];
    if (i+1 <= length(s1)) and (s1[i+1] = s1[l+1]) then
      p[i+1] := l+1;
  end;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readln(s);
  readln(t);
  s1 := t + '#' + s;
  kmp;
  j := 0;
  for i := length(t) + 2 to length(s1) do
    if p[i] = 0 then begin
      j := i;
      break;
    end;
  if j <> 0 then
  j := j - 1 - length(t);
  s1 := '';
  for i := length(t) downto 1 do
    s1 := s1 + t[i];
  s1 := s1 + '#';
  for i := length(s) downto 1 do
    s1 := s1 + s[i];
  kmp;
  k := 0;
  for i := length(t) + 2 to length(s1) do
    if p[i] = 0 then begin
      k := i;
      break;
    end;
  if k <> 0 then
  k := k - 1 - length(t);
  if (j = 0) and (k = 0) then begin
    write('1 1');
    halt(0);
  end;
  fillchar(a, sizeof(a), 0);
  k := length(s) - k + 1;
  if k < j then begin
    for i := 1 to length(s) do 
      if s[i] = '0' then begin
        j := i;
        break;
      end;
    write(j, ' ', j+length(s)-length(t));
    halt(0);
  end;
  for i := j to k do
    a := sum(a, strtoint(s[i]));
  b := a;
  if check(j, k) then begin
    write(j, ' ', k);
    halt(0);
  end;
  if j <> 1 then begin
    b := sum(a, strtoint(s[j-1]));
    if check(j-1, k) then begin
      write(j-1, ' ', k);
      halt(0);
    end;
  end;
  if k <> length(s) then begin
    b := sum(a, strtoint(s[k+1]));
    if check(j, k+1) then begin
      write(j, ' ', k+1);
      halt(0);
    end;
  end;
  if (j <> 1) and (k <> length(s)) then begin
    b := sum(a, strtoint(s[j-1]));
    b := sum(b, strtoint(s[k+1]));
    if check(j-1, k+1) then begin
      write(j-1, ' ', k+1);
      halt(0);
    end;
  end;
end.
