program Prob2;

{$APPTYPE CONSOLE}
{$O-}

uses
  SysUtils;

type
  info = record
    v, i: integer;
  end;
  mass = array[1..2000] of info;

var
  n, i, j: integer;
  a: array[1..2000] of integer;
  za, zv: mass;
  ma, mv: array[1..2000, 1..2000] of integer;
  ans: int64;

function rec(i: integer): integer;
begin
  if i = 0 then
    result := -1
  else
    result := rec(a[i]) + 1;
end;

procedure qsort(l, r: integer; var a: mass);
var
  i, j: integer;
  x, t: info;
begin
  if r <= l then exit;
  i := l;
  j := r;
  x := a[l + random(r-l+1)];
  while i <= j do begin
    while a[i].v < x.v do inc(i);
    while a[j].v > x.v do dec(j);
    if i <= j then begin
      t := a[i];
      a[i] := a[j];
      a[j] := t;
      inc(i);
      dec(j);
    end;
  end;
  qsort(l, j, a);
  qsort(i, r, a);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  read(n);
  for i := 1 to n do
    read(a[i]);
  for i := 1 to n do begin
    za[i].i := i;
    if za[i].v = 0 then
      za[i].v := rec(a[i])+1;
  end;
  qsort(1, n, za);
  for i := 1 to n do
    for j := i+1 to n do
      if za[i].v <> za[j].v then
        ma[za[i].i, za[j].i] := 1;
  for i := 1 to n do
    read(a[i]);
  for i := 1 to n do begin
    zv[i].i := i;
    if zv[i].v = 0 then
      zv[i].v := rec(a[i])+1;
  end;
  qsort(1, n, zv);
  for i := 1 to n do
    for j := i+1 to n do
      if zv[i].v <> zv[j].v then
        mv[zv[i].i, zv[j].i] := 1;
  ans := 0;
  for i := 1 to n do
    for j := 1 to n do
      if (ma[i, j] = 1) and (mv[i, j] = 1) then
        inc(ans);
  write(ans);
end.

