#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int n;
int g[2000][2000];
int t[2000][2000];
int pred1[2000][2000];
int pred2[2000][2000];
int g_SIZE[2000], t_SIZE[2000], pred1_SIZE[2000], pred2_SIZE[2000];


int gone[2000], ptr;

void dfs1(int v)
{

    for(int i = 0; i < ptr; i++)
        pred1[v][pred1_SIZE[v]++]=gone[i];
    gone[ptr++] = v;
    for(int i = 0; i < g_SIZE[v]; i++)
        dfs1(g[v][i]);
    ptr--;
}

void dfs2(int v)
{
    for(int i = 0; i < ptr ;i++)
        pred2[v][pred2_SIZE[v]++]=gone[i];
    gone[ptr++] = v;
    for(int i = 0; i < t_SIZE[v]; i++)
        dfs2(t[v][i]);
    ptr--;
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    cin >> n;
    if( n > 2000) return 0;
    int stA, stB;
    for(int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        if(a!=0)
        {
            a--;
            g[a][g_SIZE[a]++]=(i);
        }
        else
            stA=i;
    }

    for(int i = 0; i < n; i++)
    {
        int b;
        cin >> b;
        if(b != 0)
        {
            b--;
            t[b][t_SIZE[b]++]=(i);
        }
        else
            stB=i;
    }
    dfs1(stA);
    dfs2(stB);
    for(int i = 0; i < n; i++)
    {
        sort(pred1[i], pred1[i]+pred1_SIZE[i]);
        sort(pred2[i], pred2[i]+pred2_SIZE[i]);
    }
    int ans = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
        {
            bool ok = false;
            int l = 0, r = pred1_SIZE[j]-1;
            while(l <= r)
            {
                int m = (l+r)/2;
                if(pred1[j][m] > i) r = m-1;
                else if(pred1[j][m] <  i) l = m+1;
                else
                {
                    ok = true;
                    break;
                }
            }
            if(!ok) continue;
            l = 0, r = pred2_SIZE[j]-1;
            while(l <= r)
            {
                int m = (l+r)/2;
                if(pred2[j][m] > i) r = m-1;
                else if(pred2[j][m] <  i) l = m+1;
                else
                {
                    ans++;
                    break;
                }
            }
        }
    cout << ans;

    return 0;
}
