#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int n;
int g[2000][2000];
int t[2000][2000];
int pred1[2000][2000];
int g_SIZE[2000], t_SIZE[2000], pred1_SIZE[2000];
int ans;
int gone[2000], ptr;

void dfs1(int v)
{

    for(int i = 0; i < ptr; i++)
        pred1[v][pred1_SIZE[v]++]=gone[i];
    gone[ptr++] = v;
    for(int i = 0; i < g_SIZE[v]; i++)
        dfs1(g[v][i]);
    ptr--;
}

void dfs2(int v)
{
    for(int i = 0; i < ptr ;i++)
    {
        int l = 0, r = pred1_SIZE[gone[i]];
        while(l <= r)
        {
            int m = (l+r)/2;
            int k = pred1[gone[i]][m];
            if(k > m) r = m-1;
            else if(k < m)l = m+1;
            else {ans++; break;}
        }
    }
    gone[ptr++] = v;
    for(int i = 0; i < t_SIZE[v]; i++)
        dfs2(t[v][i]);
    ptr--;
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    cin >> n;
    if( n > 2000) return 0;
    int stA, stB;
    for(int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        if(a!=0)
        {
            a--;
            g[a][g_SIZE[a]++]=(i);
        }
        else
            stA=i;
    }

    for(int i = 0; i < n; i++)
    {
        int b;
        cin >> b;
        if(b != 0)
        {
            b--;
            t[b][t_SIZE[b]++]=(i);
        }
        else
            stB=i;
    }
    dfs1(stA);
    for(int i = 0; i < n; i++)
        sort(pred1[i], pred1[i]+pred1_SIZE[i]);
    dfs2(stB);
    cout << ans;

    return 0;
}
