#include <fstream>
#include <vector>
#include <iostream>

using namespace std;

ifstream fin("virus.in");
ofstream fout("virus.out");

vector<vector<int> > Ga, Gb;
vector<int> tina, tinb, touta, toutb;
vector<bool> useda, usedb;
int n, ans = 0;
int roota, rootb;

void init()
{
	Ga.resize(n);
	Gb.resize(n);
	tina.resize(n);
	tinb.resize(n);
	touta.resize(n);
	toutb.resize(n);
	useda.resize(n, false);
	usedb.resize(n, false);
	return;
}

void Read()
{
	fin >> n;
	init();
	int p;
	for(int i = 0; i < n; ++i)
	{
		fin >> p;
		if(p == 0)
			roota = i; 
		else
			Ga[p - 1].push_back(i);
	}
	for(int i = 0; i < n; ++i)
	{
		fin >> p;
		if(p == 0)
			rootb = i;
		else
			Gb[p - 1].push_back(i);
	}
	return;
}

void bildTinToutA(int v, int &t)
{
	if(useda[v])
		return;
	useda[v] = true;
	tina[v] = t++;
	for(int i = 0; i < Ga[v].size(); ++i)
		bildTinToutA(Ga[v][i], t);

	touta[v] = t++;
	return;
}

void bildTinToutB(int v, int &t)
{
	if(usedb[v])
		return;
	usedb[v] = true;
	tinb[v] = t++;
	for(int i = 0; i < Gb[v].size(); ++i)
		bildTinToutB(Gb[v][i], t);

	toutb[v] = t++;
	return;
}

inline bool isPrevB(int p1, int p2)
{
	return (tinb[p1] < tinb[p2] && toutb[p2] < toutb[p1]);
}

inline bool isPrevA(int p1, int p2)
{
	return (tina[p1] < tina[p2] && touta[p2] < touta[p1]); 
}

inline bool isGood(int p1, int p2)
{
	return (isPrevA(p1, p2) && isPrevB(p1, p2));
}

void Solve()
{
	int t = 0;
	bildTinToutA(roota, t);
	t = 0;
	bildTinToutB(rootb, t);
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			ans += isGood(i, j);
	return;
}

void Print()
{
	fout << ans;
	return;
}

int main()
{
	Read();
	Solve();
	Print();
	return 0;
}