{$APPTYPE CONSOLE}
{$DEFINE DEBUG}

uses SysUtils, Math;

type int = longint;
     integer = longint;

type pair = record
	fs,sc : int;
end;

const PROBLEMNAME = 'password';
const eps = 1e-7;
const MAXN = 1000*100;

var a : array [1..MAXN] of int;
	n,m : int;

procedure sort(l,r: longint);
  function less(a,b : int) : boolean;
  begin
    less := a < b;
  end;
var
   i,j : int;
   x,y : int;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2];
  repeat
    while a[i]<x do inc(i);
    while x<a[j] do dec(j);
    if i <= j then
      begin
        y:=a[i];
        a[i]:=a[j];
        a[j]:=y;
        inc(i);
        j:=j-1;
      end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure debug(s : string);
begin
{$IFDEF DEBUG} writeln(s) {$ENDIF}
end;

procedure answer(s : string);
begin
	writeln(s);
	halt;
end;

procedure answer_int(s : int64);
begin
	writeln(s);
	halt;
end;

var
	i,j,k,q : int;
	t1,t2,t3,t4,t5,t6,t7,t8,t9 : int;
	ans : int64;

  s1,s2 : string;
  feq, beq : integer;

  sum : array [0..100000] of int64;

procedure sol1000;
  function check(l,r : int) : boolean;
  begin

  end;
begin
//  for i := 1 to feq do
  //  for j := beq to length(s1) do
    //  if i <= j then
       // if sum[j] - sum[i-1] = strtoint(
end;

function check(l,r : int) : boolean;
var i,t : int;
    l1,r1 : int;
    function take_int(l,r : int) : int;
    var p,i : int;
    begin
      p := 0;
      for i := l to r do
        p := p*10 + ord(s2[i]) - ord('0');
      take_int := p;
    end;
begin
  check := false;
  if r > length(s2) then exit;
  if l > feq+1 then exit;
  if r < beq-1 then exit;
  l1 := l; r1 := length(s1) - length(s2) + r;
  check := take_int(l,r) = sum[r1]  - sum[l1-1];
end;

begin
  if PROBLEMNAME <> '' then
    begin
	  assign(input, PROBLEMNAME + '.in'); reset(input);
	  assign(output, PROBLEMNAME + '.out'); rewrite(output);
	end;
  readln(s1);
  readln(s2);
  feq := 0;
  while (feq < length(s2)) and (s1[feq+1] = s2[feq+1]) do inc(feq);
  beq := 0;
  while (beq < length(s2)) and (s1[length(s1)-beq] = s2[length(s2)-beq]) do inc(beq);
  beq := length(s2) - beq + 1;
//  if length(s1) < 1000 then
 //   sol1000;
  fillchar(sum, sizeof(sum), 0);
  for i := 1 to length(s1) do
    sum[i] := sum[i-1] + ord(s1[i]) - ord('0');
  for i := 1 to length(s2) do
    for j := i to i + 5 do
      if check(i,j) then
        begin
          writeln(i,' ',length(s1) - length(s2) + j);
          halt;
        end;
  sleep(10000);
end.
