{$APPTYPE CONSOLE}
{$DEFINE DEBUG}

uses SysUtils, Math;

type int = longint;
     integer = longint;

type pair = record
	fs,sc : int;
end;

const PROBLEMNAME = 'calendar';
const eps = 1e-7;
const MAXN = 1000*100;

var a : array [1..1000] of string;
	n,m : int;


procedure debug(s : string);
begin
{$IFDEF DEBUG} writeln(s) {$ENDIF}
end;

procedure answer(s : string);
begin
	writeln(s);
	halt;
end;

procedure answer_int(s : int64);
begin
	writeln(s);
	halt;
end;

var
	i,j,k,q : int;
	t1,t2,t3,t4,t5,t6,t7,t8,t9 : int;
	ans : int64;

procedure calc_col_m;
var i,an : integer;
begin
  for i := 1 to n do
    if a[i,m] <> '*' then
      begin an := i; break; end;
  for i := an-1 downto 1 do
    a[i,m] := chr(((ord(a[i+1,m])-ord('0')-1+10) mod 10) + ord('0'));
  for i := an+1 to n do
    a[i,m] := chr(((ord(a[i-1,m])-ord('0')+1) mod 10) + ord('0'));
end;

procedure calc_col(x : int);
var i,an : integer;
begin
  for i := 1 to n do
    if a[i,x] <> '*' then
      begin an := i; break; end;
  for i := an-1 downto 1 do
    if a[i,x+1] = '9' then
      a[i,x] := chr(((ord(a[i+1,x])-ord('0')-1+10) mod 10) + ord('0'))
    else
      a[i,x] := a[i+1,x];
  for i := an+1 to n do
    if a[i,x+1] = '0' then
      a[i,x] := chr(((ord(a[i-1,x])-ord('0')+1+10) mod 10) + ord('0'))
    else
      a[i,x] := a[i-1,x];
end;

var incs : int;

begin
  if PROBLEMNAME <> '' then
    begin
	  assign(input, PROBLEMNAME + '.in'); reset(input);
	  assign(output, PROBLEMNAME + '.out'); rewrite(output);
	end;
  readln(n,m);
  for i := 1 to n do readln(a[i]);
  calc_col_m;
  for i := m-1 downto 1 do
    calc_col(i);
  writeln(a[1]);
end.
