{$APPTYPE CONSOLE}
{$DEFINE DEBUG}
{$R+,Q+,S+}

uses SysUtils, Math;

type int = longint;
     integer = longint;

type pair = record
	fs,sc : int;
end;

const PROBLEMNAME = 'mosaic';
const eps = 1e-7;
const MAXN = 1000*100;

var a : array [1..MAXN] of int;
	n,m : int;

procedure debug(s : string);
begin
{$IFDEF DEBUG} writeln(s) {$ENDIF}
end;

procedure answer(s : string);
begin
	writeln(s);
	halt;
end;

procedure answer_int(s : int64);
begin
	writeln(s);
	halt;
end;

type
  pnode = ^tnode;
  tnode = record
    next : pnode;
    v : int;
  end;

var
	i,j,k,q : int;
	t1,t2,t3,t4,t5,t6,t7,t8,t9 : int;
	ans : int64;

  r1,r2 : integer;
  ch1, ch2 : array [1..2000] of pnode;

  mc : array [1..2000, 1..2000] of boolean;

  prev1, prev2 : array [1..100000] of integer;
  a1,a2 : array [1..100000] of integer;
  l1, l2 : integer;
  bad : integer;
  an1, an2, bp : integer;

  label next;

begin
  if PROBLEMNAME <> '' then
    begin
	  assign(input, PROBLEMNAME + '.in'); reset(input);
	  assign(output, PROBLEMNAME + '.out'); rewrite(output);
	end;
  read(n);
  for i := 1 to n do
    begin
      read(a1[i], a2[i]);
      if (i = 1) or (a1[i] <> a1[i-1]) then l1 := i;
      if (i = 1) or (a2[i] <> a2[i-1]) then l2 := i;
      prev1[i] := l1; prev2[i] := l2;
    end;
  read(m);
  for i := 1 to m do
    begin
      read(t1, t2);
      if prev1[t2] = prev2[t2] then
        begin
          if prev1[t2] <= t1 then
            writeln('0 0')
          else
            writeln(prev1[t2] - 1,' ',t2);
        end else
        begin
          if (prev1[t2] <= t1) or (prev2[t2] <= t1) then
            writeln('0 0')
          else
            begin
              if prev1[t2] < prev2[t2] then
                begin
                  if a2[t2] <> a2[prev1[t2]-1] then
                    writeln(prev1[t2]-1,' ', t2)
                  else
                    writeln(prev1[t2]-1,' ', prev2[t2]-1)
                end else
                begin
                  if a1[t2] <> a1[prev2[t2]-1] then
                    writeln(prev2[t2]-1,' ', t2)
                  else
                    writeln(prev2[t2]-1,' ', prev1[t2]-1)
                end;
            end;
        end;
    end;
end.
