import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class Main4 implements Runnable {
	public static void main(String[] args) throws IOException {
		new Main4().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;
	public int sum[];

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public String nextWord() throws IOException {
		return nextToken();
	}

	public boolean check(int l, int r, String s1, String s2, int cnt1,
			int cnt2, int len1, int len2, int sum[]) {
		if (r > s2.length() - 1)
			return false;
		if (r < cnt2 - 1)
			return false;
		if (l > cnt1 + 1)
			return false;
		int l1 = l;
		int r1 = len1 - len2 + r;
		return s2.substring(l, r + 1).compareTo(
				Integer.toString((sum[r1] - sum[l1 - 1]))) == 0;
	}

	public void solve() throws IOException {
		String s1 = "#" + nextWord(), s2 = "#" + nextToken();
		int cnt1 = 0;
		int len1 = s1.length() - 1;
		int len2 = s2.length() - 1;
		int cnt2 = 0;
		while ((cnt1 < len2) && (s1.charAt(cnt1 + 1) == s2.charAt(cnt1 + 1))) {
			++cnt1;
		}
		while ((cnt2 < len2)
				&& (s1.charAt(len1 - cnt2) == s2.charAt(len2 - cnt2))) {
			++cnt2;
		}
		cnt2 = len2 - cnt2 + 1;
		int[] sum = new int[len1 + 1];
		for (int i = 1; i <= len1; ++i) {
			sum[i] = sum[i - 1] + Character.digit(s1.charAt(i), 10);
		}
		for (int i = 1; i < s2.length(); ++i) {
			for (int j = i; j <= i + 5; ++j) {
				if (check(i, j, s1, s2, cnt1, cnt2, len1, len2, sum)) {
					out.printf("%d %d", i, len1 - len2 + j);
					return;
				}
			}

		}

	}

	@Override
	public void run() {
		try {
			// br = new BufferedReader(new InputStreamReader(System.in));
			br = new BufferedReader(new FileReader("password.in"));
			out = new PrintWriter(new File("password.out"));
			// out = new PrintWriter(new OutputStreamWriter(System.out));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {

			e.printStackTrace();
			System.exit(1);
		}
	}

}
