import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class Main1 implements Runnable {
	public static void main(String[] args) throws IOException {
		new Main1().run();
	}

	StringTokenizer in;
	BufferedReader br;
	PrintWriter out;
	public int sum[];

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens())
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public String nextWord() throws IOException {
		return nextToken();
	}

	int[] tin1, tout1, tin2, tout2;
	int timer = 0;

	public void dfs(List<Integer>[] g, int v, boolean flag) {
		++timer;
		if (flag)
			tin1[v] = timer;
		else
			tin2[v] = timer;
		for (int i : g[v]) {
			dfs(g, i, flag);
		}
		++timer;
		if (flag)
			tout1[v] = timer;
		else
			tout2[v] = timer;

	}

	public void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		tin1 = new int[n];
		tout1 = new int[n];
		tin2 = new int[n];
		tout2 = new int[n];

		int[] b = new int[n];
		List<Integer> g1[] = new List[n];
		List<Integer> g2[] = new List[n];
		for (int i = 0; i < n; ++i) {
			g1[i] = new ArrayList<Integer>();
			g2[i] = new ArrayList<Integer>();
		}
		int root1 = 0;
		for (int i = 0; i < n; ++i) {
			int v = nextInt();
			if (v == 0) {
				root1 = i;
				continue;
			}
			g1[v - 1].add(i);
		}
		int root2 = 0;
		for (int i = 0; i < n; ++i) {
			int v = nextInt();
			if (v == 0) {
				root2 = i;
				continue;
			}
			g2[v - 1].add(i);
		}
		dfs(g1, root1, true);
		dfs(g2, root2, false);
		int cnt = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (i == j)
					continue;
				if (tin1[i] < tin1[j] && tout1[i] > tout1[j]
						&& tin2[i] < tin2[j] && tout2[i] > tout2[j]) {
					++cnt;
				}
			}
		}
		out.print(cnt);
	}

	@Override
	public void run() {
		try {
			// br = new BufferedReader(new InputStreamReader(System.in));
			br = new BufferedReader(new FileReader("virus.in"));
			out = new PrintWriter(new File("virus.out"));
			// out = new PrintWriter(new OutputStreamWriter(System.out));
			solve();
			br.close();
			out.close();
		} catch (IOException e) {
			// ofisaxaza
			e.printStackTrace();
			System.exit(1);
		}
	}

}
