#include <iostream>
#include <cstdio>
#include <algorithm>
#include <string>
#include <cstring>
using namespace std;

typedef unsigned long long ull;
const ull hashbase = 1973;
const int maxn = 100005;

ull ha[maxn], hb[maxn], p[maxn];
int prea[maxn];

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	string sa, sb;
	cin >> sa >> sb;

	int n = sa.size(), m = sb.size();
	int nm = max(n, m) + 3;

	p[0] = hashbase;
	for (int i = 1; i < nm; ++i)
		p[i] = p[i-1] * hashbase;
	prea[0] = ha[0] = sa[0] - '0';
	for (int i = 1; i < n; ++i)
	{
		ha[i] = ha[i-1] * hashbase + sa[i] - '0';
		prea[i] = prea[i-1] + sa[i] - '0';
	}
	hb[0] = sb[0] - '0';
	for (int i= 1; i < m; ++i)
		hb[i] = hb[i-1] * hashbase + sb[i] - '0';

	for (int i = 0; i < m; ++i)
	{
		int x = 0;
		for (int j = 0; j < 7 && i+j < m; ++j)
		{
			x = x * 10 + sb[i+j] - '0';
			int r = n - m + i + j;
			if (prea[r] - (i?prea[i-1]:0) == x && 
				(r+1 ==n ||
				ha[n-1] - ha[r]*p[n-r-2] == hb[m-1] - hb[i+j] * p[m-i-j-2]))
			{
				cout << i+1 << ' ' << r+1 << endl;
				return 0;
			}
			if (!x)
				break;
		}
		if (sb[i] != sa[i])
			break;
	}

	return 0;
}