#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cassert>
using namespace std;

const int maxn = 200005;

int a[2][maxn];
int t[maxn];
int n;

int cnt[maxn];
pair<int,int> mn[maxn], mx[maxn];
void solve(int l, int r)
{
	for (int i = l; i <= r; ++i)
	{
		cnt[a[0][i]] = 0;
		mn[a[0][i]].first = 1 << 30;
		mx[a[0][i]].first = -1;
		if (i>l && a[0][i-1] != a[0][i] && a[1][i-1] != a[1][i])
		{
			cout << i << ' ' << i+1 << endl;
			return;
		}
	}
	for (int i = l; i <= r; ++i)
	{
		mn[a[0][i]] = min(mn[a[0][i]], make_pair(a[1][i], i));
		mx[a[0][i]] = max(mx[a[0][i]], make_pair(a[1][i], i));

		if (mn[a[0][i]].first == mx[a[0][i]].first)
			continue;

		for (int j = l; j <= r; ++j)
		{
			if (a[0][i] == a[0][j])
				continue;
			if (a[1][j] != mn[a[0][i]].first)
			{
				cout << j+1 << ' ' << mn[a[0][i]].second+1 << endl;
				return;
			}
			if (a[1][j] != mx[a[0][i]].first)
			{
				cout << j+1 << ' ' << mx[a[0][i]].second+1 << endl;
				return;
			}
		}
	}
	cout << "0 0" << endl;
}

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);

	cin >> n;
	assert(n < 5005);
	int m = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < 2; ++j)
		{
			cin >> a[j][i];
			t[m++] = a[j][i];
		}
	}
	sort(t, t + m);
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < 2; ++j)
			a[j][i] = lower_bound(t, t + m, a[j][i]) - t;
	}

	int k;
	cin >> k;
	assert(k < 5005);
	for (int i = 0; i < k; ++i)
	{
		int l, r;
		cin >> l >> r;
		solve(l-1, r-1);
	}

	return 0;
}
