#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cassert>
using namespace std;
 
const int maxn = 200005;
 
int a[2][maxn];
int t[maxn];
int n;
 
int cnt[maxn];
int minimum[maxn], minid[maxn], maximum[maxn], maxid[maxn];
void solve(int l, int r)
{
    for (int i = l; i <= r; ++i)
    {
        int c = a[0][i];
        cnt[c] = 0;
        minimum[c] = a[1][i];
        maximum[c] = a[1][i];
        if (i>l && a[0][i-1] != a[0][i] && a[1][i-1] != a[1][i])
        {
            cout << i << ' ' << i+1 << endl;
            return;
        }
    }
    for (int i = l; i <= r; ++i)
    {
        int c = a[0][i];
        if (a[1][i] < minimum[c])
        {
            minimum[c] = a[1][i];
            minid[c] = i;
        }
        if (a[1][i] > maximum[c])
        {
            maximum[c] = a[1][i];
            maxid[c] = i;
        }
 
        if (minimum[c] == maximum[c])
            continue;
 
        for (int j = l; j <= r; ++j)
        {
            if (c == a[0][j])
                continue;
            if (a[1][j] != minimum[c])
            {
                cout << j+1 << ' ' << minid[c]+1 << endl;
                return;
            }
            if (a[1][j] != maximum[c])
            {
                cout << j+1 << ' ' << maxid[c]+1 << endl;
                return;
            }
        }
    }
    cout << "0 0" << endl;
}
 
int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
 
    cin >> n;
    assert(n < 5005);
    int m = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < 2; ++j)
        {
            cin >> a[j][i];
            t[m++] = a[j][i];
        }
    }
    sort(t, t + m);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < 2; ++j)
            a[j][i] = lower_bound(t, t + m, a[j][i]) - t;
    }
 
    int k;
    cin >> k;
    assert(k < 5005);
    for (int i = 0; i < k; ++i)
    {
        int l, r;
        cin >> l >> r;
        solve(l-1, r-1);
    }
 
    return 0;
}