#include <cstdio>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;

int p[15], t[15];
int n, k;
int ans = 0;

int f[20];

inline void inc(int i, int val)
{
	for (i++; i < 20; i += i&(-i))
		f[i] = max(f[i], val);
}
inline int get(int i)
{
	int ret = 0;
	for (i++; i; i ^= i&(-i))
		ret = max(ret, f[i]);
	return ret;
}

int at[15];
inline void check()
{
	for (int i = 0; i < n; ++i)
		at[p[i]] = i;
	for (int i = 1; i < k; ++i)
		if (at[t[i]] < at[t[i-1]])
			return;

	memset(f, 0, sizeof f);
	for (int i = 0; i < n; ++i)
	{
		int here = 1+get(p[i]);
		inc(p[i], here);
		if (here > k)
			return;
	}
	ans++;
}

int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	cin >> n;
	if (n > 12)
		return 0;
	for (int i = 0; i < n; ++i)
		p[i] = i;
	cin >> k;
	for (int i = 0; i < k; ++i)
	{
		cin >> t[i];
		--t[i];
	}

	do
	{
		check();
	} while (next_permutation(p, p +n ));

	cout << ans << endl;

	return 0;
}