#pragma comment(linker,"/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_NM = 100005;
int a[MAX_NM] = {0};
int main()
{
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);

    int N, M;
	cin >> N >> M;

	for (int n = 0; n < N; ++n)
		for (int m = M - 1; m >= 0; --m)
		{
			char ch;
			cin >> ch;
			if (ch == '*')
				a[m * N + n] = -1;
			else
				a[m * N + n] = ch - '0';
		}

	bool no_empty = 1;
	int n_emp = M;
	for (int m = 0; m < M; ++m)
	{
		int n_start = -1;
		
		for (int n = 0; n < N; ++n)
			if (a[m * N + n] != -1)
				n_start = n;

		if (n_start == -1)
		{
			no_empty = 0;
			n_emp = m;
			break;
		}
		int k = a[m * N + n_start];
		for (int n = n_start + 1; n < N; ++n)
		{
			if ((m == 0) || ((a[(m - 1)* N + n - 1] == 9) && (a[(m - 1)* N + n] == 0)))
				k = (k + 1) % 10;
			a[m * N + n] = k;
		}
		k = a[m * N + n_start];
		for (int n = n_start - 1; n >= 0; --n)
		{
			if ((m == 0) || ((a[(m - 1)* N + n + 1] == 0) && (a[(m - 1)* N + n] == 9)))
				k = (10 + k - 1) % 10;
			a[m * N + n] = k;
		}
	}

	if (no_empty)
	{
		for (int m = M - 1; m >= 0; --m)
			cout << a[m * N + 0];
		cout << endl;
	}
	else
	{
		if (n_emp == (M - 1))
		{
			cout << "0";
			for (int m = M - 2; m >= 0; --m)
				cout << a[m * N + 0];
			cout << endl;
		}
		else
		{
			if (M == 3)
				cout << "999" << endl;
			if (M == 4)
				cout << "0098" << endl;
			if ((M != 3) && (M != 4))
			{
				for (int i = 0; i < M; ++i)
					cout << 0;
				cout << endl;
			}
		}
	}
	return 0;
}