#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 100005;
int binsearch(int L, int R, int x, int a[MAX_N])
{
	int l = L;
	int r = R;
	while ((r - l) > 1)
	{
		int m = (l + r + 1) / 2;
		if (a[m] < x)
			l = m;
		else
			r = m;
	}
	return r;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

	int N;
	cin >> N;
	int a[MAX_N] = {0};
	int prea = 0;
	int b[MAX_N] = {0};
	int preb = 0;
	for (int n = 1; n <= N; ++n)
	{
		int ta, tb;
		cin >> ta >> tb;
		if (ta == prea)
			a[n] = a[n - 1];
		else
			a[n] = a[n - 1] + 1;
		prea = ta;
		if (tb == preb)
			b[n] = b[n - 1];
		else
			b[n] = b[n - 1] + 1;
		preb = tb;
	}
	int K;
	cin >> K;
	for (int k = 0; k < K; ++k)
	{
		int l, r;
		cin >> l >> r;
		if ((a[l] == a[r]) || (b[l] == b[r]))
			cout << 0 << " " << 0 << endl;
		else
			cout << l << " " << max(binsearch(l, r, a[l] + 1, a), binsearch(l, r, b[l] + 1, b)) << endl;
	}

    return 0;
}