#pragma comment(linker, "/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>


using namespace std;
const int MAX_N = 100005;

int a[MAX_N] = {0};
int b[MAX_N] = {0};

int find_n1(int x, int l, int r)
{
	 while ((r - l) > 1)
	 {
		 int m = (l + r + 1) / 2;
		 if ((a[m] == a[x]) || (b[m] == b[x]))
			 l = m;
		 else
			 r = m;
	 }
	 return r;
}

int find_n2(int x, int l, int r)
{
	while ((r - l) > 1)
	 {
		 int m = (l + r) / 2;
		 if ((a[m] == a[x]) || (b[m] == b[x]))
			 r = m;
		 else
			 l = m;
	 }
	 return l;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

	int N;
	cin >> N;
	int preva = -1;
	int prevb = -1;
	a[0] = 0;
	b[0] = 0;
	for (int n = 1; n <= N; ++n)
	{
		int ta, tb;
		cin >> ta >> tb;
		if (ta == preva)
			a[n] = a[n - 1];
		else
			a[n] = a[n - 1] + 1;
		preva = ta;
		if (tb == prevb)
			b[n] = b[n - 1];
		else
			b[n] = b[n - 1] + 1;
		prevb = tb;
	}

	int K;
	cin >> K;
	for (int k = 0; k < K; ++k)
	{
		int l, r;
		cin >> l >> r;
		if ((a[l] == a[r]) || (b[l] == b[r]))
			cout << 0 << " " << 0 << endl;
		else
		{
			int n1 = find_n1(l, l, r);
			int n2 = find_n2(n1, l, n1);
			cout << n1 << " " << n2 << endl;
		}
	}

    return 0;
}