#pragma comment(linker, "/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>


using namespace std;
const int MAX_N = 1000005;

int a[MAX_N] = {0};
int b[MAX_N] = {0};

int find_n1(int x, int l, int r)
{
	 while ((r - l) > 1)
	 {
		 int m = (l + r + 1) / 2;
		 if ((a[m] == a[x]) || (b[m] == b[x]))
			 l = m;
		 else
			 r = m;
	 }
	 return r;
}

int find_n2(int x, int l, int r)
{
	while ((r - l) > 1)
	 {
		 int m = (l + r) / 2;
		 if ((a[m] == a[x]) || (b[m] == b[x]))
			 r = m;
		 else
			 l = m;
	 }
	 return l;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

	int N;
	scanf_s("%d", &N);
	int preva = -1;
	int prevb = -1;
	a[0] = 0;
	b[0] = 0;
	for (int n = 1; n <= N; ++n)
	{
		int ta, tb;
		scanf_s("%d%d", &ta, &tb);
		if (ta == preva)
			a[n] = a[n - 1];
		else
			a[n] = a[n - 1] + 1;
		preva = ta;
		if (tb == prevb)
			b[n] = b[n - 1];
		else
			b[n] = b[n - 1] + 1;
		prevb = tb;
	}

	int K;
	cin >> K;
	for (int k = 0; k < K; ++k)
	{
		int L, R;
		scanf_s("%d%d", &L, &R);
		if ((a[L] == a[R]) || (b[L] == b[R]))
			printf("0 0\n");
		else
		{
			int r, l, x;
			r = R;
			l = L;
			x = l;
			while ((r - l) > 1)
			{
				 int m = (l + r + 1) / 2;
				 if ((a[m] == a[x]) || (b[m] == b[x]))
					 l = m;
				 else
					 r = m;
			}
	        int n1 = r;

			l = L;
			r = n1;
			x = n1;
			while ((r - l) > 1)
			{
				 int m = (l + r) / 2;
				 if ((a[m] == a[x]) || (b[m] == b[x]))
					 r = m;
				 else
					 l = m;
			}
			int n2 = l;

			printf("%d %d\n", n1, n2);
		}
	}

    return 0;
}