#pragma comment(linker, "/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 1005;
const int MAX_M = 1005;
int lenpre[MAX_N] = {0};
bool s[MAX_N][MAX_M] = {0};

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

	int N;
	cin >> N;
	int M;
	cin >> M;
	for (int m = 0; m < M; ++m)
	{
		int K;
		cin >> K;
		for (int k = 0; k < K; ++k)
		{
			int n;
			cin >> n;
			s[n][m] = 1;
		}
	}

	for (int n1 = 1; n1 <= N; ++n1)
	    for (int n2 = n1 + 1; n2 <= N; ++n2)
		{
			int len = 0;
			while ((len < M) && (s[n1][len] == s[n2][len]))
				++len;
			if (len > lenpre[n1])
				lenpre[n1] = len;
			if (len > lenpre[n2])
				lenpre[n2] = len;
		}
	for (int n = 1; n <= N; ++n)
	{
		if (lenpre[n] >= M)
			cout << 0 << " ";
		else
			cout << (lenpre[n] + 1) << " ";
	}
	cout << endl;
    return 0;
}