#pragma comment(linker, "/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 30005;
int a[MAX_N] = {0};
int temp[MAX_N] = {0};

struct Vertex
{
	int start;
	int finish;
	Vertex()
	{
		start = 0;
		finish = 0;
	}
	Vertex(int new_start, int new_finish)
	{
		start = new_start;
		finish = new_finish;
	}
};

Vertex q[MAX_N];
bool used[MAX_N] = {0};
int ans[MAX_N] = {0};

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

	int N;
	scanf("%d", &N);
	int M;
	scanf("%d", &M);
	for (int i = 0; i < N; ++i)
		a[i] = i + 1;
	q[0].start = 0;
	q[0].finish = N;
	int first = 0;
	int last = 1;
	for (int m = 1; m <= M; ++m)
	{
		for (int n = 1; n <= N; ++n)
			used[n] = 0;
		int K;
		scanf("%d", &K);
		for (int k = 0; k < K; ++k)
		{
			int t;
			scanf("%d", &t);
			used[t] = 1;
		}
		int end_of_layer = last;
		while (first != end_of_layer)
		{
			Vertex v = q[first++];
			if (first == MAX_N)
				first = 0;
			if ((v.finish - v.start) == 1)
				ans[a[v.start]] = m - 1;
			else
			{
				int p1 = 0;
				for (int i = v.start; i < v.finish; ++i)
				{
					if (used[a[i]])
						temp[v.start + (p1++)] = a[i];
				}
				int p2 = 0;
				for (int i = v.start; i < v.finish; ++i)
				{
					if (!used[a[i]])
						temp[v.start + p1 + (p2++)] = a[i];
				}
				for (int i = v.start; i < v.finish; ++i)
					a[i] = temp[i];
				if (p1 != 0)
				{
					q[last++] = Vertex(v.start, (v.start + p1));
					if (last == MAX_N)
						last = 0;
				}
				if (p2 != 0)
				{
					q[last++] = Vertex((v.start + p1), v.finish);
					if (last == MAX_N)
						last = 0;
				}
			}
		}
	}
	while (first != last)
		{
			Vertex v = q[first++];
			if (first == MAX_N)
				first = 0;
			if ((v.finish - v.start) == 1)
				ans[a[v.start]] = M;
		}
	for (int n = 1; n <= N; ++n)
		printf("%d ", ans[n]);
    return 0;
}