#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>


using namespace std;

const int MAX_N = 16;
int a[MAX_N];
int ANS = 0;
bool used[MAX_N] = {0};
bool is_good[MAX_N] = {0};

int count_len(int N)
{
	int dp[MAX_N] = {0};
	for (int i = 0; i < N; ++i)
		dp[i] = 1;
	for (int i = 1; i < N; ++i)
		for (int j = 0; j < i; ++j)
			if (((dp[j] + 1) > dp[i]) && (a[i] > a[j]))
				dp[i] = dp[j] + 1;
	int ans = 0;
	for (int i = 0; i < N; ++i)
		if (dp[i] > ans)
			ans = dp[i];
	return ans;
}
bool check(int N)
{
	bool ans = 1;
	int prev = 0;
	for (int i = 0; i < N; ++i)
	{
		if (is_good[a[i]]&& (a[i] < prev))
			ans = 0;
		if (is_good[a[i]])
			prev = a[i];
	}
	return ans;
}
void gen(int m, int N, int K)
{
	if (m == N)
	{
		if (check(N) && (count_len(N) == K))
			++ANS;
		return;
	}
	for (int i = 1; i <= N; ++i)
	{
		if (!used[i])
		{
			used[i] = 1;
			a[m] = i;
			gen(m + 1, N, K);
			used[i] = 0;
		}
	}
}


int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

	int N;
	cin >> N;
	int K;
	cin >> K;
	for (int i = 0; i < K; ++i)
	{
		int t;
		cin >> t;
		is_good[t] = 1;
	}
	if (K == 1)
		cout << 1 << endl;
	else
	{
		gen(0, N, K);
		cout << ANS << endl;
	}
    return 0;
}