#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>
#include <assert.h>
#define N 100000
#define NN (1 << 17)
struct list { struct list * next; int value; };

typedef struct list * list;

list new(list next, int value) {
	list cre;
	cre = malloc(sizeof(*cre));
	cre->next = next;
	cre->value = value;
	return cre;
};

struct time { int income, outcome; };

void walkietalkie(int now, list edges[], struct time times[], int * time) {
	list head = edges[now];
	times[now].income = (*time) ++;
	while (head) {
		walkietalkie(head->value, edges, times, time);
		head = head->next;
	};
	times[now].outcome = (*time) ++;
};

int inline isparent(int parent, int child, struct time times[]) {
	return ((times[parent].income < times[child].income) &&
			(times[parent].outcome > times[child].outcome));
};

struct stack {
	int size;
	int values[];
};

typedef struct stack * stack;

void hihihello(int now, list edges[], struct time times[], stack vertices, int64_t * answer) {
	int low, high, mid;
	list head = edges[now];
	//low = 0;
	//high = vertices->size;
	//while (low < high) {
	//	mid = (low + high) >> 1;
	//	if (isparent(vertices->values[mid], now, times))
	//		high = mid;
	//	else
	//		low = mid + 1;
	//};
	for (low = 0; low < vertices->size; low ++)
		(*answer) += isparent(vertices->values[low], now, times);
	vertices->values[vertices->size++] = now;
	while (head) {
		hihihello(head->value, edges, times, vertices, answer);
		head = head->next;
	};
	vertices->size--;
};


int main (void) {
	int n, i, j;
	stack vertices;
	list * antivirus, * virus;
	struct time * times;
	int time = 0;
	FILE * in, * out;
	int boss, cardinal;
	int64_t answer;
	in = fopen("virus.in", "r");
	fscanf(in, "%d", &n);
	antivirus = calloc(sizeof(list), n);
	virus = calloc(sizeof(list), n);
	times = malloc(sizeof(struct time) * n);
	vertices = calloc(sizeof(struct stack) + sizeof(int) * (n + 1), 1);

	for (i = 0; i < n; i ++) {
		fscanf(in, "%d", &j);
		if (j)
			antivirus[j - 1] = new(antivirus[j - 1], i);
		else
			boss = i;
	};
	for (i = 0; i < n; i ++) {
		fscanf(in, "%d", &j);
		if (j)
			virus[j - 1] = new(virus[j - 1], i);
		else
			cardinal = i;
	};
	fclose(in);
	walkietalkie(boss, antivirus, times, &time);
	vertices->size = 0;
	answer = 0;
	hihihello(cardinal, virus, times, vertices, &answer);
	out = fopen("virus.out", "w");
	fprintf(out, "%" PRId64 "\n", answer);
	fclose(out);
	return 0;
};
