#include <stdio.h>
#include <stdlib.h>

struct piece {
	int w, h;
};

int main(void) {
	FILE * in, * out;
	int n;
	struct piece * field;
	int i, j, k;

	in = fopen("mosaic.in", "r");
	fscanf(in, "%d", &n);
	field = malloc(sizeof(struct piece) * n);
	for (i = 0; i < n; i ++)
		fscanf(in, "%d%d", &field[i].w, &field[i].h);
	fscanf(in, "%d", &k);
	out = fopen("mosaic.out", "w");
	for (i = 0; i < k; i ++) {
		int lo, hi;
		int winco = -1, hinco = -1;
		fscanf(in, "%d%d", &lo, &hi);
		for (j = lo; j < hi; j ++) {
			if (field[j].w != field[lo-1].w) {
				if (field[j].h != field[lo-1].h) {
					fprintf(out, "%d %d\n", lo, j + 1);
					break;
				} else {
					winco = j;
					if (hinco != -1) {
						fprintf(out, "%d %d\n", winco + 1, hinco + 1);
						break;
					};
				};
			} else if (field[j].h != field[lo-1].h) {
				hinco = j;
				if (winco != -1) {
					fprintf(out, "%d %d\n", winco + 1, hinco + 1);
					break;
				};
			};
		};
		if (j == hi) {
			fputs("0 0\n", out);
		};
	};
	fclose(in);
	fclose(out);
	return 0;
};
