#include <stdio.h>
#include <memory.h>

#define N 100000
#define MAXSET (2 * N - 1)
#define SETS (MAXSET + 1)

int sets[N];
int resets[SETS];
int counts[SETS];
int answers[N];

int main(void) {
	FILE * in, * out;
	int n, m, i;
	size_t ssize;
	int unowen;
	in = fopen("theatre.in", "r");
	fscanf(in, "%d", &n);
	ssize = n * sizeof(int);
	memset(sets, 0, ssize);
	memset(answers, 0, ssize);
	fscanf(in, "%d", &m);
	ssize *= 2;
	unowen = n;
	for (i = 0; i < m; i ++) {
		int k, j, p, q;
		fscanf(in, "%d", &k);
		memset(counts, -1, ssize);
		for (j = 0; j < k; j ++) {
			fscanf(in, "%d", &p);
			sets[p - 1] += n;
		};
		for (j = 0; j < n; j ++) {
			resets[sets[j]] = j;
			counts[sets[j]] ++;
		};
		for (j = 0; j < n; j ++) {
			if ((!answers[j]) && (!counts[sets[j]])) {
				answers[j] = i + 1;
				unowen --;
			};
			sets[j] = resets[sets[j]];
		};
		if (!unowen)
			break;
	};
	fclose(in);
	out = fopen("theatre.out", "w");
	for (i = 0; i < n; i ++)
		fprintf(out, "%d ", answers[i]);
	putc('\n', out);
	fclose(out);
	return 0;
};
