#include<iostream>
#include<vector>
#include<string>
using namespace std;

const int N = 1e5 + 10;

string str1, str2;
bool niceL [N], niceR [N];
int partSum [N];

int main ()
{
	freopen("password.in", "r", stdin); freopen("password.out", "w", stdout);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	getline(cin, str1);
	getline(cin, str2);

	int uk1 = 0, uk2 = 0;
	while (uk1 < (int)str1.length() && uk2 < (int)str2.length())
	{
		if (str1 [uk1] == str2 [uk2])
			niceL [uk1] = 1;
		else
			break;
		uk1++;
		uk2++;
	}

	uk1 = (int)str1.length() - 1;
	uk2 = (int)str2.length() - 1;
	while (uk1 >= 0 && uk2 >= 0)
	{
		if (str1 [uk1] == str2 [uk2])
			niceR [uk1] = 1;
		else
			break;
		uk1--;
		uk2--;
	}

	partSum [0] = str1 [0] - '0';
	for (int i = 1; i < (int)str1.length(); i++)
		partSum [i] = partSum [i - 1] + (str1 [i] - '0');

	int minLen = min(str1.length(), str2.length());
	for (int l = 0; l < minLen; l++)
	{
		for (int numLen = 1; numLen <= 6; numLen++)
		{
			if (l + numLen > (int)str2.length())
				break;

			int lastLen = (int)str2.length() - l - numLen;
			if (lastLen < 0)
				break;
			int uk1 = (int)str1.length() - lastLen;
			int uk2 = (int)str2.length() - lastLen;

			if (uk1 <= l || uk2 <= l)
				continue;

			if (uk1 < (int)str1.length() && !niceR [uk1])
				continue;

			int sum1 = partSum [uk1 - 1];
			if (l != 0)
				sum1 -= partSum [l - 1];

			int sum2;
			sscanf(str2.substr(l, numLen).c_str(), "%d", &sum2);

			if (sum1 == sum2)
			{
				printf("%d %d\n", l + 1, uk1);
				return 0;
			}
		}
	}

	return 0;
}