#include<iostream>
#include<vector>
#include<string>
using namespace std;
 
const int N = 1100;
const int M = 110;
int n, m;
vector<vector<int> > list (N, vector<int> (M));
vector<int> start (N, -1);
 
void nextLine ()
{
    string str;
    getline(cin, str);
}
 
void solve1 (int uk)
{
    int vol = list [uk][0];
 
    for (int i = uk; i < n; i++)
    {
        list [i][0] = vol;
        vol++;
        if (vol == 10)
        {
            vol = 0;
        }
    }
 
    vol = list [uk][0];
    for (int i = uk; i >= 0; i--)
    {
        list [i][0] = vol;
        vol--;
        if (vol < 0)
            vol = 9;
    }
}
 
void solve2 (int line, int uk)
{
    int vol = list [uk][line];
 
    for (int i = uk + 1; i < n; i++)
    {
        if (list [i][line - 1] == 0 && list [i - 1][line - 1] == 9)
        {
            vol++;
            if (vol == 10)
                vol = 0;
        }
 
        list [i][line] = vol;
    }
 
    vol = list [uk][line];
    for (int i = uk - 1; i >= 0; i--)
    {
        if (list [i][line - 1] == 9 && list [i + 1][line - 1] == 0)
        {
            vol--;
            if (vol == -1)
                vol = 9;
 
        }
        list [i][line] = vol;
    }
}
 
int main ()
{
    freopen("calendar.in", "r", stdin); freopen("calendar.out", "w", stdout);
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
 
    scanf("%d%d", &n, &m);
    nextLine ();
    for (int i = 0; i < n; i++)
    {
        for (int j = m - 1; j >= 0; j--)
        {
            char c;
            cin >> c;
            if (c == '*')
                list [i][j] = -1;
            else
            {
                list [i][j] = c - '0';
                start [j] = i;
            }
        }
        nextLine();
    }
 
    if (start [0] == -1)
    {
        if (n == 3)
            puts("0098");
        else
            puts("999");
        return 0;
    }
    solve1(start[0]);
    for (int i = 1; i < m; i++)
    {
        if (start [i] == -1)
        {
            if (n == 3)
            puts("0098");
        else
            puts("999");
            return 0;
        }
         
        solve2(i, start[i]);
    }
 
    for (int i = m - 1; i >= 0; i--)
        cout << list [0][i];
 
    return 0;
}