#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

int n, k;
vector<pair<int, int> > list;
vector<int> nextR;

bool nice (int a1, int b1, int a2, int b2)
{
	return a1 == a2 || b1 == b2;
}

int main ()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("mosaic.in", "r", stdin); freopen("mosaic.out", "w", stdout);

	scanf("%d", &n);

	if (n > 6000)
		return 0;

	list.resize(n);
	nextR.resize(n, -1);

	for (int i = 0; i < n; i++)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		list [i] = make_pair(a, b);
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			if (!nice(list [i].first, list [i].second, list [j].first, list [j].second))
			{
				nextR [i] = j;
				break;
			}
		}
	}

	scanf("%d", &k);
	if (k > 6000)
		return 0;

	for (int i = 0; i < k; i++)
	{
		int l, r;
		scanf("%d%d", &l, &r);
		l--; r--;

		bool ans = 0;
		for (int j = l; j <= r; j++)
		{
			if (nextR [j] == -1)
				continue;

			if (nextR [j] <= r)
			{
				printf("%d %d\n", j + 1, nextR [j] + 1);
				ans = 1;
				break;
			}
		}

		if (!ans)
			puts("0 0");
	}

	return 0;
}