#include<iostream>
#include<vector>
#include<algorithm>
#include<cstdio>
using namespace std;
 
vector<int> save1, save2;
void myIntersect (vector<int> & list1, vector<int> & list2, vector<int> & inList)
{
    int i = 0;
    int j = 0;
    save1.resize(0);
    save2.resize(0);
 
    while (i < (int)list1.size() && j < (int)list2.size())
    {
        if (list1 [i] == list2 [j])
        {
            inList.push_back(list1 [i]);
            i++;
            j++;
        }
        else if (list1 [i] > list2 [j])
        {
            save2.push_back(list2 [j]);
            j++;
        }
        else
        {
            save1.push_back(list1 [i]);
            i++;
        }
    }

	if (inList.empty())
		return;
 
    for (;i < (int)list1.size(); i++)
        save1.push_back(list1 [i]);
    for (;j < (int)list2.size(); j++)
        save2.push_back(list2 [j]);
     
    list1 = save1;
    list2 = save2;
}
 
const int N = 1e4 + 200;
int n, m;
vector<vector<int> > set;
int ans [N];
int mark [N];
 
void solve (vector<int> & scanList, int i)
{
    if (scanList.size() == 1)
        ans [scanList [0]] = i + 1;
    else
    {
        vector<int> per;
        for (int j = 0; j < (int)set.size(); j++)
        {
            if (set [j].empty())
                continue;
 
            per.resize(0);
            myIntersect(set [j], scanList, per);
 
            if (set [j].size() == 1)
            {
                ans [set [j][0]] = i + 1;
                set [j].clear();
            }
 
            if (scanList.size() == 1)
            {
                ans [scanList [0]] = i + 1;
                scanList.clear();
            }
 
            if (per.empty())
                continue;
 
            if (per.size() == 1)
                ans [per[0]] = i + 1;
            else
                set.push_back(per);
        }
 
        if (!scanList.empty())
            set.push_back(scanList);
    }
}
 
int main ()
{
    freopen("theatre.in", "r", stdin); freopen("theatre.out", "w", stdout);
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	
	for (int i = 0; i < n; i++)
		ans [i] = -1;

    save1.reserve(N);
    save2.reserve(N);
 
    scanf("%d%d", &n, &m);
    if (n > 11000)
        return 0;
    for (int i = 0; i < m; i++)
    {
        int k;
        scanf("%d", &k);
        vector<int> scanList;
        for (int j = 0; j < k; j++)
        {
            int num;
            scanf("%d", &num);
            if (ans [num] == -1)
            {
                scanList.push_back(num);
                mark [num] = i + 1;  
            }
        }
 
        sort(scanList.begin(), scanList.end());
        solve(scanList, i);
         
        scanList.clear();
        for (int j = 1; j <= n; j++)
            if (ans [j] == -1 && mark [j] != i + 1)
                scanList.push_back(j);
 
        solve(scanList, i);
    }
 
    for (int i = 1; i <= n; i++)
    {
        if (ans [i] == -1)
            printf("0 ");
        else
            printf("%d ", ans [i]);
    }
 
    return 0;
}