program Z_A;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  w: array [1 .. 10000, 1 .. 10000] of boolean;
  r: array [1 .. 10000] of boolean;
  res: array [1 .. 10000] of integer;
  num: array [1 .. 10000] of integer;
  e: array [1 .. 10000] of integer;
  s: array [1 .. 10000] of integer;
  n, m, i, k, j, a, z, q, t: integer;
procedure tryadd(a, b: integer);
var
  q, t: integer;
begin
  if not w[a, b] then begin
    w[a, b] := true;
    inc(num[a]);
    if num[a] = n - 1 then
      for q := 1 to n do
        if not w[a, q] then begin
          res[a] := i;
          for t := 1 to n do
            tryadd(t, q);
          break;
        end;
  end;
end;
procedure swap(var a, b: integer);
var
  c: integer;
begin
  c := a;
  a := b;
  b := c;
end;
procedure qsort(left, right: integer);
var
  i, j, x: integer;
begin
  i := left;
  j := right;
  x := e[i + random(j - i)];
  while i <= j do begin
    while e[i] < x do inc(i);
    while e[j] > x do dec(j);
    if i <= j then begin
      swap(e[i], e[j]);
      inc(i);
      dec(j);
    end;
  end;
  if i < right then qsort(i, right);
  if j > left then qsort(left, j); 
end;
begin
  reset(input, 'theatre.in');
  rewrite(output, 'theatre.out');
  fillchar(w, sizeof(w), false);
  fillchar(num, sizeof(num), 0);
  fillchar(res, sizeof(res), 0);

  read(n, m);
  for i := 1 to m do begin
    read(k);
    fillchar(r, sizeof(r), 0);
    for j := 1 to k do begin
      read(e[j]);
      r[e[j]] := true;
    end;
    if k <> 1 then
      qsort(1, k);
    z := 0;
    for j := 1 to n do
      if not r[j] then begin
        inc(z);
        s[z] := j;
      end;

    for j := 1 to k do
      for z := 1 to n - k do begin
        tryadd(e[j], s[z]);
        tryadd(s[z], e[j]);
      end;
  end;

  for i := 1 to n do
    write(res[i], ' ');
end.

