#include <fstream>
#include <string>

using namespace std;

const int MAXN = 100005;
int sa[MAXN];
string a, b;

int fdig(int d) {
	int res = 0;
	while (d) {
		d /= 10;
		res++;
	}
	return res;
}

int cnsum(int st, int fi) {
	int res = 0;
	for (int i = st; i <= fi; i++) {
		res = res * 10 + b[i] - '0';
	}
	return res;
}

int main() {
	ifstream cin("password.in");
	ofstream cout("password.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	cin >> a >> b;
	sa[0] = a[0] - '0';
	for (int i = 1; i < a.size(); i++) {
		sa[i] = sa[i - 1] + a[i] - '0';
	}
	int i = 0, j = 0, ii = a.size() - 1, jj = b.size() - 1;
	while (true) {
		int suma = sa[ii];
		if (fdig(suma) >= jj + 1) {
			break;
		}
		ii--;
		jj--;
	}
	int suma = sa[ii], sumb = cnsum(0, jj);
	if (suma == sumb) {
		cout << i + 1 << " " << ii + 1 << endl;
		return 0;
	}
	ii--;
	jj--;
	suma = sa[ii];
	sumb = cnsum(0, jj);
	if (suma == sumb) {
		cout << i + 1 << " " << ii + 1 << endl;
		return 0;
	}
	i++;
	j++;
	while (a[i - 1] == b[j - 1]) {
		while (true) {
			suma = sa[ii] - sa[i - 1];
			if (fdig(suma) <= jj - j + 1) {
				break;
			}
			ii++;
			jj++;
		}
		suma = sa[ii] - sa[i - 1];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			cout << i + 1 << " " << ii + 1 << endl;
			return 0;
		}
		ii++;
		jj++;
		suma = sa[ii] - sa[i - 1];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			cout << i + 1 << " " << ii + 1 << endl;
			return 0;
		}
		i++;
		j++;
	}
	cin.close();
	cout.close();
}