#include <fstream>

using namespace std;

const int MAXN = 2005;
int n, a[MAXN][MAXN], b[MAXN][MAXN], tina[MAXN], touta[MAXN], tinb[MAXN], toutb[MAXN];
int ta = 1, tb = 1;

void dfsa(int d) {
	tina[d] = ta++;
	for (int i = 0; i < n; i++) {
		if (!tina[i] && a[d][i]) {
			dfsa(i);
		}
	}
	touta[d] = ta++;
}

void dfsb(int d) {
	tinb[d] = tb++;
	for (int i = 0; i < n; i++) {
		if (!tinb[i] && b[d][i]) {
			dfsb(i);
		}
	}
	toutb[d] = tb++;
}

int main() {
	ifstream cin("virus.in");
	ofstream cout("virus.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int ma, mb;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int c;
		cin >> c;
		if (c) {
			c--;
			a[i][c] = a[c][i] = 1;
		} else {
			ma = i;
		}
	}
	for (int i = 0; i < n; i++) {
		int c;
		cin >> c;
		if (c) {
			c--;
			b[i][c] = b[c][i] = 1;
		} else {
			mb = i;
		}
	}
	dfsa(ma);
	dfsb(mb);
	int res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (tina[i] < tina[j] && touta[i] > touta[j] &&
				tinb[i] < tinb[j] && toutb[i] > toutb[j]) {
				res++;
			}
		}
	}
	cout << res << endl;
	cin.close();
	cout.close();
}