#include <fstream>
#include <algorithm>
#include <vector>
#define V(T) vector <T>
#define P(T) pair <T, T>
#define mpa make_pair
#define xx first
#define yy second

using namespace std;

V(P(int)) mos;
V(V(int)) nohar;

int main() {
	ifstream cin("mosaic.in");
	ofstream cout("mosaic.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n;
	cin >> n;
	mos.resize(n);
	nohar.resize(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		mos[i] = mpa(a, b);
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = i + 1; j < n; j++) {
			if (mos[i].xx != mos[j].xx && mos[i].yy != mos[j].yy) {
				nohar[i].push_back(j);
			}
		}
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		int resa = -1, resb = -1;
		for (int j = a; j < b; j++) {
			if (nohar[j].empty()) {
				continue;
			}
			int c = lower_bound(nohar[j].begin(), nohar[j].end(), b + 1) - nohar[j].begin();
			if (c > 0) {
				resa = a;
				resb = nohar[j][c - 1];
				break;
			}
		}
		cout << resa + 1 << " " << resb + 1 << endl;
	}
	cin.close();
	cout.close();
}