#include <fstream>
#include <algorithm>
#include <vector>
#define V(T) vector <T>
#define P(T) pair <T, T>
#define mpa make_pair
#define xx first
#define yy second

using namespace std;

V(P(int)) mos;
V(V(int)) nohar;

int bin(int a, int b) {
	int l = -1, r = nohar[b].size();
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (nohar[b][m] <= a) {
			l = m;
		} else {
			r = m;
		}
	}
	return l;
}

int main() {
	ifstream cin("mosaic.in");
	ofstream cout("mosaic.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n;
	cin >> n;
	mos.resize(n);
	nohar.resize(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		mos[i] = mpa(a, b);
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = i + 1; j < n; j++) {
			if (mos[i].xx != mos[j].xx && mos[i].yy != mos[j].yy) {
				nohar[i].push_back(j);
			}
		}
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		int resa = -1, resb = -1;
		for (int j = a; j < b; j++) {
			int c = bin(b, j);
			if (c != -1) {
				resa = a;
				resb = nohar[j][c];
				break;
			}
		}
		cout << resa + 1 << " " << resb + 1 << endl;
	}
	cin.close();
	cout.close();
}