#include <fstream>
#include <algorithm>
#include <vector>
#define V(T) vector <T>
#define P(T) pair <T, T>
#define mpa make_pair
#define i64 long long

using namespace std;

const int INF = 100;
V(bool) us;
V(int) pe, perm, dyn, pl, d01;

int mx(int n) {
	dyn.assign(n + 1, INF);
	dyn[0] = 0;
	for (int i = 0; i < n; i++) {
		int a = upper_bound(dyn.begin(), dyn.end(), pl[i]) - dyn.begin();
		dyn[a] = min(dyn[a], pl[i]);
	}
	int res = n;
	while (dyn[res] == INF) {
		res--;
	}
	return res;
}

int main() {
	ifstream cin("army.in");
	ofstream cout("army.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n, k;
	cin >> n >> k;
	us.resize(n + 1);
	pe.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> pe[i];
		us[pe[i]] = true;
	}
	d01.resize(n);
	for (int i = n - k; i < n; i++) {
		d01[i] = 1;
	}
	perm.resize(n - k);
	pl.resize(n);
	i64 res = 0;
	do {
		int c = 0;
		for (int i = 1; i <= n; i++) {
			if (!us[i]) {
				perm[c++] = i;
			}
		}
		do {
			c = 0;
			int d = 0;
			for (int i = 0; i < n; i++) {
				pl[i] = (d01[i] ? pe[d++] : perm[c++]);
			}
			int a = mx(n);
			res += (a == k);
		} while (next_permutation(perm.begin(), perm.end()));
	} while (next_permutation(d01.begin(), d01.end()));
	cout << res << endl;
	cin.close();
	cout.close();
}