//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

using namespace std;

const long maxn=1e6+5;

string s1,s2;

bool suff[maxn];
bool pref[maxn];

long get_sum(long s,long f)
{
	long ret=0;
	for (long j=s;j<=f;j++)
		ret+=(s1[j]-'0');
	return(ret);
}

long get_num(long s,long f)
{
	long ret=0;
	for (long j=s;j<=f;j++)
		ret=ret*10+(s2[j]-'0');
	return(ret);
}

void prepare()
{
	pref[0]=true;
	for (long j=1;j<s2.length();j++)
	{
		if (s1[j-1]!=s2[j-1])
			break;
		pref[j]=true;
	}

	suff[0]=true;
	for (long j=s2.length()-1;j>=0;j--)
	{
		if (s2[j]!=s1[s1.length()-(s2.length()-j)])
			break;
		suff[s2.length()-j]=true;
	}
}

int main()
{
	/*freopen("password.in","w",stdout);
	for (long j=1;j<=100000;j++)
		printf("9");
	printf("\n900000");
	fclose(stdout);*/
	freopen("password.in","r",stdin);
	freopen("password.out","w",stdout);
	cin>>s1;
	cin>>s2;
	prepare();
	bool found=false;
	for (long start=0;start<s2.length();start++) if (pref[start])
		for (long len=1;len<=6;len++)
		{
			if ((s2[start]=='0')&&(len!=1)) continue;
			long tmp=s2.length()-(start+len);
			if (tmp<0) continue;
			if (!suff[tmp]) continue;
			long sum=get_sum(start,s1.length()-tmp-1);
			long num=get_num(start,start+len-1);
			if (sum==num)
			{
				printf("%ld %ld\n",start+1,s1.length()-tmp);
				exit(0);
			}
		}
}