//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

#define LL long long

using namespace std;

const long maxn=1e6+5;
const LL inf=1e18;

LL a[maxn];
LL n,r,u;

inline void trying(long j,long x)
{
	if ((x<1)||(2*x>n)||(x>j)) return;

	long z=j-2*x;
	LL tmp;
	if (z>0)
		tmp=max(r+a[z],u+a[x]);
	else tmp=u+a[x];
	a[j]=min(a[j],tmp);
}

inline void another_sol()
{
	a[0]=0;
	a[1]=0;
	a[2]=u;
	for (long j=3;j<=n;j++)
	{
		a[j]=inf;
		for (long i=j/2-1;i<=j/2+1;i++)
			trying(j,i);

		long start=1;
		long finish=j/2;
		while(start<finish)
		{
			long middle=(start+finish)/2+1;
			long z=j-2*middle;
			if (r+a[z]>u+a[middle])
				start=middle;
			else finish=middle-1;
		}
		for (long i=start-1;i<=start+1;i++)
			trying(j,i);
	}
	cout<<a[n]<<endl;
}

int main()
{
	freopen("apricot.in","r",stdin);
	freopen("apricot.out","w",stdout);
	cin>>n>>r>>u;
	/*n=1e6;
	r=3000;
	u=50000;*/
	/*a[0]=0;
	a[1]=0;
	a[2]=u;
	for (LL j=3;j<=n;j++)
	{
		a[j]=inf;
		for (LL x=1;(2*x<=n)&&(x<j);x++)
		//for (LL x=1;x<=j/2;x++)
		{
			LL z=j-2*x;
			LL tmp;
			if (z>0)
				tmp=max(r+a[z],u+a[x]);
			else tmp=u+a[x];
			a[j]=min(a[j],tmp);
		}
	}
	printf("%ld\n",a[n]);*/
	another_sol();
}