//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

#define LL long long

using namespace std;

const long maxn=1e6+5;

long prec[maxn];
pair <long,long> a[maxn];
long n,m;

void prepare()
{
	for (long choice=1;choice<=n;choice++)
	{
		prec[choice]=choice;
		for (long j=choice+1;j<=n;j++)
		{
			if ((a[j].first!=a[choice].first)&&(a[j].second!=a[choice].second))
				break;
			prec[choice]++;
		}
	}
}

int main()
{
	freopen("mosaic.in","r",stdin);
	freopen("mosaic.out","w",stdout);
	scanf("%ld",&n);
	if (n>5000) exit(-1);
	long q;
	for (q=1;q<=n;q++)
		scanf("%ld%ld",&a[q].first,&a[q].second);
	prepare();
	scanf("%ld",&m);
	for (long it=1;it<=m;it++)
	{
		long s,f;
		scanf("%ld%ld",&s,&f);
		bool fail=false;
		for (long choice=s;choice<=f;choice++)
			if (prec[choice]<f)
			{
				printf("%ld %ld\n",choice,prec[choice]+1);
				fail=true;
				break;
			}
		if (!fail) printf("0 0\n");
	}
}