#include <iostream>   
#include <fstreAM>
#include <cstdio>

#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <cmath>

#include <cassert>
#include <ctime>
#include <cstdlib>

using namespace std;

const int N = (int) 1e6;;
const int INF = (int) 1e9 + 1;
const int MAX_D = (int) 100;

int n, u, r, dp[N];
bool was[N + 1];

int Solve ( int cnt ) {
    if ( cnt == 1 )
        return 0;      
    if ( was[cnt] )
        return dp[cnt];

    was[cnt] = true;
    dp[cnt] = INF;

    for ( int d = 0; d < MAX_D && cnt / 2 - d > 0; d++ ) {
        int c1 = cnt / 2 - d, c2 = cnt - (cnt / 2 - d) * 2;

        if ( c2 > 0 ) 
            dp[cnt] = min(dp[cnt], max(Solve(c1) + u, Solve(c2) + r));     
        else 
            dp[cnt] = min(dp[cnt], Solve(c1) + u);                 
    }

    return dp[cnt];
}

int main () {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    cin >> n >> r >> u;
    cout << Solve(n);

    return 0;
}

