#include <iostream>   
#include <fstreAM>
#include <cstdio>

#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <cmath>

#include <cassert>
#include <ctime>
#include <cstdlib>

using namespace std;

const int N = (int) 1e6;;
const int INF = (int) 1e9 + 1;
const int MAX_D = (int) 100;

int n, u, r, dp[N + 1];

int main () {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    cin >> n >> r >> u;
    
    dp[1] = 0;
    for ( int i = 2; i <= n; i++ ) {
        dp[i] = INF;

        for ( int c1 = n / 2, c2 = n - (n / 2) * 2; c1; c1--, c2 += 2 ) 
                if ( c2 > 0 ) 
                    dp[i] = min(dp[i], max(dp[c1] + u, dp[c2] + r));     
                else 
                    dp[i] = min(dp[i], dp[c1] + u);                 
    }

    cout << dp[n] << endl;

    return 0;
}

