#include <iostream>   
#include <fstreAM>
#include <cstdio>

#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <cmath>

#include <cassert>
#include <ctime>
#include <cstdlib>

using namespace std;

const int N = (int) 1e6;

int n, u, r;
long long dp[N + 1];

void Update ( long long & val, long long new_val ) {
    if ( val == -1 || new_val < val )
        val = new_val;
}

int main () {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    cin >> n >> r >> u;
    
    dp[1] = 0;
    for ( int i = 2; i <= n; i++ ) {
        dp[i] = -1;

        for ( int c1 = i / 2, c2 = i % 2; c1; c1--, c2 += 2 ) {
            if ( c2 > 0 ) 
                Update(dp[i], max(dp[c1] + u, dp[c2] + r));     
            else 
                Update(dp[i], dp[c1] + u);
        }

        assert(dp[i] == -1);
    }

    cout << dp[n] << endl;

    return 0;
}

