#include <iostream>
#include <cstdio>

const int N = (int) 1e6 + 2;

using namespace std;

long long n, u, r, dp[N];

void Update ( long long & val, long long new_val ) {
    if ( val == -1 || new_val < val ) 
        val = new_val;
}

int main () {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    cin >> n >> r >> u;

    dp[0] = dp[1] = 0;
    for ( int i = 2; i <= n + 1; i++ ) {
        dp[i] = -1;
        for ( int j = i / 2; j; j-- ) {
            int x = i - j * 2;

            if ( x > 0 )
                Update(dp[i], max(dp[j] + u, dp[x] + r));
            else
                Update(dp[i], dp[j] + u);
        }
    }

    cout << dp[n] << endl;

    return 0;
}