#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <bitset>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

typedef unsigned long long ULL;

const int N = (int) 1e2;
const ULL P = 239017;

struct node {
    ULL h;
    int num;

    node () { }
    node ( ULL h, int num ) {
        node :: h = h;
        node :: num = num;
    }
};

bool comp ( node a, node b ) {
    return (a.h < b.h);
}

int n, m, ans[N];
ULL h[N];
node have[N];

bool Test ( int num ) {
    if ( num && have[num - 1].h == have[num].h )
        return false;
    else if ( num < n && have[num + 1].h == have[num].h )
        return false;
    else
        return true;
}

int main () {
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d%d", &n, &m);
    
    for ( int i = 0; i < m; i++ ) {
        int cnt;
        scanf("%d", &cnt);
    
        for ( int j = 0; j < cnt; j++ ) {
            int num;
            scanf("%d", &num);

            h[num - 1] = h[num - 1] * P + i + 1;
        }

        cnt = 0;
        for ( int j = 0; j < n; j++ )
            if ( !ans[j] ) 
                have[cnt++] = node(h[j], j);

        sort(have, have + cnt, comp);

        for ( int j = 0; j < cnt; j++ ) 
            if ( Test(j) ) {
                ans[have[j].num] = i + 1;      
            } 
    }

    for ( int i = 0; i < n; i++ )
        cout << ans[i] << ' ';

    return 0;
}