#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <bitset>
#include <set>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

typedef unsigned long long ULL;

const int N = (int) 1e5;
const ULL P = 239017;

struct node {
    int c;
    int num;

    node () { }
    node ( int c, int num ) {
        node :: c = c;
        node :: num = num;
    }
};

bool comp ( node a, node b ) {
    return (a.c < b.c);
}

int n, m, c, color[N], ans[N];
node have[N];
set <int> s[N];

inline void Rape ( int c, int val ) {
    if ( s[c].size() == 1 ) {
        int num = *s[c].begin();
        if ( !ans[num] )
            ans[num] = val + 1; 
    }
}

inline void ChangeColor ( int num, int next ) {
    int last = color[num];
    color[num] = next;

    s[last].erase(s[last].find(num));
    s[next].insert(num);
}

int main () {
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d%d", &n, &m);

    for ( int i = 0; i < n; i++ )
        s[0].insert(i);

    for ( int i = 0; i < m; i++ ) {
        int m_cnt;
        scanf("%d", &m_cnt);
    
        for ( int j = 0; j < m_cnt; j++ ) {
            int num;
            scanf("%d", &num);
            
            have[j] = node(color[num - 1], num - 1);
        }

        sort(have, have + m_cnt, comp);

        for ( int j = 0, k = 0; j < m_cnt; j = k ) { 
            while ( k < m_cnt && have[j].c == have[k].c )
                k++;

            int last = have[j].c, next = ++c;

            for ( int l = j; l < k; l++ )
                ChangeColor(have[l].num, next);
            
            Rape(last, i);
            Rape(next, i);                
        }             
    }

    for ( int i = 0; i < n; i++ )
        printf("%d ", ans[i]);

    return 0;
}