#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

#include <cassert>
#include <cstdlib>
#include <ctime>

#define x first
#define y second 

using namespace std;

typedef pair <int, int> point;

point operator += ( point & a, point b ) {
    a.x += b.x;
    a.y += b.y;
}

int n, m, x, y;
point h, cur;
vector <point> h_moov, our_pos;
 
bool Test ( point p ) {
    return (p.x >= 0 && p.x < m && p.y >= 0 && p.y < n);
}

point RecalcHoursePosition ( int x, int y ) {
    point res = point(x, y);

    for ( int i = 0; i < h_moov.size(); i++ ) {
        if ( !Test(res) || res == our_pos[i] )
            return point(-1, -1); 
    
        res += h_moov[i];
    }

    if ( !Test(res) )
        return point(-1, -1);
    else
        return res; 
}

void GoTo ( point p ) {
    //cerr << "Try to go to " << p.x << ' ' << p.y << endl;
    point res;
    if ( p.x < cur.x )
        res.x = -1;
    else if ( p.x > cur.x )
        res.x = 1;
    if ( p.y < cur.y )
        res.y = -1;
    else if ( p.y > cur.y )
        res.y = 1;

    cur += res;
    our_pos.push_back(res);

    cout << res.x << ' ' << res.y << ' ' << 1 << endl;
    cout.flush();
}

point ScanDelta () {
    point res;
    cin >> res.x >> res.y;

    return res;
}

int main () {
    cin >> n >> m >> cur.x >> cur.y;
    cur.x--, cur.y--;

    for ( int x_pos = 0; x_pos < m; x_pos++ )
        for ( int y_pos = 0; y_pos < m; y_pos++ ) {
            point h = RecalcHoursePosition(x_pos, y_pos);

            //cerr << "MayBe : " << h.x << ' ' << h.y << endl;

            while ( true ) {
                if ( !Test(h) )
                    break;                
                
                GoTo(h);
                
                int res;
                cin >> res;
                
                if ( res ) {
                    return 0;
                }
                else {
                    point d = ScanDelta();
                    h_moov.push_back(d);
                
                    if ( h == cur )
                        break; 
                
                    h += d;
                }
            }
        } 
    
    cerr << "LOOL" << endl;
    assert(0);

    return 0;
}