#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

const int N = (int) 15;

int n, k, p[N], dp[N];
bool need[N];

bool Test () {
    memset(dp, 0, sizeof(dp));
    int res = 0;

    int last = -1;
    for ( int i = 0; i < n; i++ )
        if ( need[p[i]] ) {
            if ( last > p[i] ) 
                return false;
            
            last = p[i];        
        } 

    for ( int i = 0; i < n; i++ ) {
        dp[i] = 1;
        for ( int j = 0; j < i; j++ )
            if ( p[j] < p[i] && dp[i] < dp[j] + 1 ) 
                dp[i] = dp[j] + 1;
    
        res = max(res, dp[i]);
    }

    return (res == k);
}

int main () {
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

    cin >> n >> k;
    for ( int i = 0; i < k; i++ ) {
        int num;
        cin >> num;

        need[num - 1] = true;
    }

    for ( int i = 0; i < n; i++ )    
        p[i] = i;

    int ans = 0;

    do { 
        if ( Test() )
            ans++;
    } while ( next_permutation(p, p + n) );

    cout << ans << endl;

    return 0;
}