#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

const int N = (int) 15;

int n, k, ans, need[N], p[N], dp[N];
bool cant[N], used[N];

bool Recalc ( int pos, int val ) {
    if ( used[val] )
        return false;

    p[pos] = val;
    dp[pos] = 1;
    
    for ( int i = 0; i < pos; i++ ) 
        if ( p[i] < val )
            dp[pos] = max(dp[pos], dp[i] + 1);

    if ( dp[pos] <= k )
        return true;
    else
        return false;                 
}


void Brute ( int pos, int next ) {
    if ( pos == n ) {
        ans++;
        return;
    }

    if ( next < k && Recalc(pos, need[next]) ) {
        used[need[next]] = true;
        Brute(pos + 1, next + 1);
        used[need[next]] = false;
    }

    for ( int i = 0; i < n; i++ )
        if ( !cant[i] && Recalc(pos, i) ) {
            used[i] = true;
            Brute(pos + 1, next);
            used[i] = false;          
        }
}

int main () {
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

    cin >> n >> k;
    
    for ( int i = 0; i < k; i++ ) {
        cin >> need[i];
        need[i]--;
        cant[need[i]] = true;
    }

    Brute(0, 0);
    
    cout << ans << endl;

    return 0;
}