#include <stdio.h>
#include <string.h>

char a[100001], b[100001];
int a_len, b_len, a_sums[100001];

int find_correct_end(int sub_beg, int sub_end_max) {
	int i, real = 0, sum = 0, len_diff = a_len - b_len;
	
	if (sub_beg + sub_end_max + 1 >= a_len)
		sub_end_max = a_len - sub_beg - 2;
	real = a_sums[a_len - sub_end_max - 1] - a_sums[sub_beg];
	for (i = sub_beg; i < b_len - sub_end_max - 1; i++) {
		sum = sum * 10 + (b[i] - '0');
		if (sum > real)
			return -1;
	}
	for (; i < b_len; i++) {
		sum = sum * 10 + (b[i] - '0');
		real += a[i + len_diff] - '0';
		if (sum == real)
			return i + len_diff;
		if (sum > real)
			return -1;
	}
	return -1;
}

int main() {
	int i, j, diff_beg, diff_end, res;
	
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	
	gets(a);
	a_len = strlen(a);
	gets(b);
	b_len = strlen(b);

	for (i = 0; i < b_len; i++)
		if (a[i] != b[i]) {
			diff_beg = i;
			break;
		}
	if (i == b_len && a_len == b_len) { // No diff
		printf("1 1\n");
		return 0;
	}
	if (i == b_len) { // a starts with b
		printf("%d %d\n", b_len, a_len);
		return 0;
	}
	for (i = 0; i < b_len; i++)
		if (a[a_len - 1 - i] != b[b_len - 1 - i]) {
			diff_end = i;
			break;
		}

	a_sums[0] = 0;
	for (i = 0; i < a_len; i++) {
		a_sums[i + 1] = a_sums[i] + (a[i] - '0');
	}
	
	for (i = diff_beg; i != -1; i--) {
		res = find_correct_end(i, diff_end);
		if (res != -1) {
			printf("%d %d\n", i + 1, res + 1);
			return 0;
		}
	}
	return 0;
}