#include <stdio.h>

int arr[16], N, K, protects[16];

int max_sorted(int pos, int current) {
	int i, res = 0, local_res;

	for (i = pos; i < N; i++) {
		if (arr[i] > current) {
			local_res = max_sorted(i + 1, arr[i]) + 1;
			if (local_res > res)
				res = local_res;
		}
	}
	return res;
}

int used[16];

int check_protects() {
	int pos = 0, i;

	for (i = 0; i < N; i++)
		if (arr[i] == protects[pos])
			pos++;
	return pos == K;
}

int check() {
	if (!check_protects())
		return 0;
	return max_sorted(0, -1) == K;
}

long long unsigned count = 0;

void comb(int pos) {
	int i;
	
	if (pos == N) { // Combination ready
		if (check())
			count++;
		return;
	}
	for (i = 0; i < N; i++)
		if (!used[i]) {
			used[i] = 1;
			arr[pos] = i;
			comb(pos + 1);
			used[i] = 0;
		}
}

int main() {
	int i;
	
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	scanf("%d%d", &N, &K);
	for (i = 0; i < N; i++)
		used[i] = 0;
	for (i = 0; i < K; i++) {
		scanf("%d", &protects[i]);
		protects[i]--;
	}

	comb(0);

	printf("%llu\n", count);
	return 0;
}