program Project1;
{$O-}
{$R+}
{$MAXSTACKSIZE 1000000000}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

var
  beg1, beg2, next1, next2, data1, data2, tin1, tout1, tin2, tout2 : array[1..2000] of integer;
  i, j, n, t, l1, l2, x, v1, v2 : integer;
  ans : int64;
  
procedure add1(a, b : integer);
begin
  inc(l1);
  data1[l1] := b;
  next1[l1] := beg1[a];
  beg1[a] := l1;
end;
procedure add2(a, b : integer);
begin
  inc(l2);
  data2[l2] := b;
  next2[l2] := beg2[a];
  beg2[a] := l2;
end;

procedure dfs1(u : integer);
var
  v : integer;
begin
  inc(t);
  tin1[u] := t;
  v := beg1[u];
  while v <> -1 do begin
    dfs1(data1[v]);
    v := next1[v];
  end;
  inc(t);
  tout1[u] := t;
end;
procedure dfs2(u : integer);
var
  v : integer;
begin
  inc(t);
  tin2[u] := t;
  v := beg2[u];
  while v <> -1 do begin
    dfs2(data2[v]);
    v := next2[v];
  end;
  inc(t);
  tout2[u] := t;
end;

function boss1(a, b : integer) : boolean;
begin
  boss1 := (tin1[a] < tin1[b]) and (tout1[a] > tout1[b]);
end;
function boss2(a, b : integer) : boolean;
begin
  boss2 := (tin2[a] < tin2[b]) and (tout2[a] > tout2[b]);
end;

begin
  assign(input, 'virus.in');
  assign(output, 'virus.out');
  reset(input);
  rewrite(output);

  l1 := 0; l2 := 0;
  readln(n);
  for i := 1 to n do begin
    beg1[i] := -1;
    beg2[i] := -1;
  end;

  for i := 1 to n do begin
    read(x);
    if x <> 0 then
      add1(x, i);
    if x = 0 then v1 := i;
  end;
  for i := 1 to n do begin
    read(x);
    if x <> 0 then
      add2(x, i);
    if x = 0 then v2 := i;
  end;

  t := 0;
  dfs1(v1);
  t := 0;
  dfs2(v2);

  ans := 0;
  for i := 1 to n do
    for j := 1 to n do
      if boss1(i, j) and boss2(i, j) then
        inc(ans);

  writeln(ans);

  close(input);
  close(output);
end.
 