program task1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  hn = 23;

type
  tarr = array [0..110000] of integer;
  tarr1 = array [0..110000] of int64;

var
  n, m, i, diff, len: integer;
  a, b: string;
  sum: tarr;
{  ha, hb, }bha, bhb, pow: tarr1;

procedure FillSum;
var
  i: integer;
begin
  sum[0] := 0;
  for i := 1 to n do
    sum[i] := sum[i - 1] + ord(a[i]) - ord('0');
end;

function GetSum(const l, r: integer): string;
begin
  Result := IntToStr(sum[r] - sum[l - 1]);
end;

procedure FillPow;
var
  i: integer;
begin
  pow[0] := 1;
  for i := 1 to n do
    pow[i] := pow[i - 1] * hn;
end;

procedure CalcHash(var h: tarr1; const s: string);
var
  i: integer;
begin
  h[0] := 0;
  for i := 1 to length(s) do
    h[i] := h[i - 1] * hn + ord(s[i]) - ord('0');
end;

procedure CalcBHash(var h: tarr1; const s: string);
var
  i: integer;
begin
  h[length(s) + 1] := 0;
  for i := length(s) downto 1 do
    h[i] := h[i + 1] * hn + ord(s[i]) - ord('0');
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readln(a);
  readln(b);
  if a = b then begin
    writeln('1 1');
    halt(0);
  end;
  n := length(a);
  m := length(b);
  FillSum;
  FillPow;
  //CalcHash(ha, a);
  //CalcHash(hb, b);
  CalcBHash(bha, a);
  CalcBHash(bhb, b);
  for i := 1 to m do
    for len := 1 to 6 do begin
      diff := n - (m - len);
      if i + len - 1 > m then break;
      if i + diff - 1 > n then break;
      if (bha[i + diff] = bhb[i + len]) and
         (GetSum(i, i + diff - 1) = copy(b, i, len)) then begin
        writeln(i,' ',i + diff - 1);
        halt(0);
      end;
    end;
end.
 