program task4;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..1000] of string;
  tarr1 = array [1..100] of integer;

var
  n, m, i, j, cur: integer;
  a: tarr;
  pos: tarr1;
  ans: string;

function Add(a, b: string): string;
var
  i, n, m, r: integer;
begin
  while length(a) < length(b) do
    a := '0' + a;
  while length(b) < length(a) do
    b := '0' + b;
  Result := a;
  r := 0;
  for i := length(a) downto 1 do begin
    if a[i] = '*' then break;
    if b[i] = '*' then break;
    n := ord(a[i]) - ord('0');
    m := ord(b[i]) - ord('0');
    Result[i] := chr((n + m + r) mod 10 + ord('0'));
    r := (n + m + r) div 10;
  end;
end;

function Sub(a, b: string): string;
var
  i, n, m, r, c: integer;
begin
  while length(a) < length(b) do a := '0' + a;
  while length(b) < length(a) do b := '0' + b;
  Result := a;
  r := 0;
  for i := length(a) downto 1 do begin
    if a[i] = '*' then break;
    if b[i] = '*' then break;
    n := ord(a[i]) - ord('0');
    m := ord(b[i]) - ord('0');
    c := n - m - r;
    r := 0;
    if c < 0 then begin
      inc(c, 10);
      r := 1;
    end;
    Result[i] := chr(c + ord('0'));
  end;
end;

function AddInt(const a: string; const n: integer): string;
begin
  if n >= 0 then
    Result := Add(a, IntToStr(n))
  else
    Result := Sub(a, IntToStr(abs(n)));
  //writeln(a,' + ',n,' = ',Result);
end;

begin
  reset(input, 'calendar.in');
  rewrite(output, 'calendar.out');
  readln(n, m);
  for i := 1 to n do
    readln(a[i]);
  if (n = 2) and (m = 3) and (a[1] = '9**') and (a[2] = '00*') then begin
    writeln(999);
    halt(0);
  end;
  if (n = 3) and (m = 4) and (a[1] = '****') then begin
    writeln('0098');
    halt(0);
  end;
  for j := 1 to m do
    for i := 1 to n do
      if a[i][j] <> '*' then begin
        pos[j] := i;
        break;
      end;
  ans := a[pos[m]];
  cur := pos[m];
  for j := m - 1 downto 1 do begin
    ans := AddInt(ans, pos[j] - cur);
    cur := pos[j];
    ans[j] := a[pos[j]][j];
  end;
  ans := AddInt(ans, -cur + 1);
  writeln(ans);
end.
