program task8;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

type
  tarr = array [0..30] of integer;
  tarr1 = array [0..30] of boolean;

var
  n, k, i: integer;
  a, t: tarr;
  d: tarr;
  free, freepos: tarr1;
  ans: int64;

function GetMaxLen(const a: tarr; const n: integer): integer;
var
  i, j: integer;
begin
  d[1] := 1;
  for i := 2 to n do begin
    d[i] := 1;
    for j := 1 to i - 1 do
      if a[i] > a[j] then
        d[i] := max(d[i], d[j] + 1);
  end;
  Result := 1;
  for i := 2 to n do
    if d[i] > Result then
      Result := d[i];
end;

procedure genRest(pos: integer);
var
  i: integer;
begin
  while not freepos[pos] do
    inc(pos);
  if pos > n then begin
    if GetMaxLen(a, n) = k then inc(ans);
    exit;
  end;
  for i := 1 to n do
    if free[i] then begin
      free[i] := false;
      a[pos] := i;
      genRest(pos + 1);
      free[i] := true;
    end;
end;

procedure genT(const d, prev: integer);
var
  i: integer;
begin
  if d > k then begin
    genRest(1);
    exit;
  end;
  for i := prev + 1 to n - (k - d) do begin
    a[i] := t[d];
    freepos[i] := false;
    genT(d + 1, i);
    freepos[i] := true;
  end;
end;

begin
  reset(input, 'army.in');
  rewrite(output, 'army.out');
  readln(n);
  readln(k);
  for i := 1 to k do
    read(t[i]);
  fillchar(free, sizeof(free), true);
  for i := 1 to k do
    free[t[i]] := false;
  fillchar(freepos, sizeof(freepos), true);
  ans := 0;
  genT(1, 0);
  writeln(ans);
  readln;
  readln;
end.
 