#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define vint vector<int>
#define ll long long

const int maxn = 1e5 + 5;
int tin1[maxn], tout1[maxn], k1;
int tin2[maxn], tout2[maxn], k2;
int us[maxn], t;

vint g1[maxn], g2[maxn];

void dfs1(int u)
{
   tin1[u] = t++;
   us[u] = 1;
   for(int i = 0; i < g1[u].size(); i++)
   {
      int to = g1[u][i];
      if(us[to] == 0)
      {
         dfs1(to);
      }
   }
   tout1[u] = t++;
}

void dfs2(int u)
{
   tin2[u] = t++;
   us[u] = 1;
   for(int i = 0; i < g2[u].size(); i++)
   {
      int to = g2[u][i];
      if(us[to] == 0)
      {
         dfs2(to);
      }
   }
   tout2[u] = t++;
}

int main()
{
   ifstream cin("virus.in");
   ofstream cout("virus.out");
   int n;
   cin >> n;
   for(int i = 0, a; i < n; i++)
   {
      cin >> a;
      if(a == 0)
         k1 = i;
      else
         g1[a - 1].push_back(i);
   }
   for(int i = 0, a; i < n; i++)
   {
      cin >> a;
      if(a == 0)
         k2 = i;
      else
         g2[a - 1].push_back(i);
   }
   dfs1(k1);
   t = 0;
   for(int i = 0; i < n; i++)
      us[i] = 0;
   dfs2(k2);
   ll ans = 0;
   for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
      {
         if(tin1[i] > tin1[j] && tout1[i] < tout1[j] && tin2[i] > tin2[j] && tout2[i] < tout2[j])
            ans++;
      }
   cout << ans;
}
