#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define vint vector<int>
#define ll long long

const int maxn = 1e6 + 5;
const ll INF = 1e18;

ll d[maxn];

int main()
{
   ifstream cin("apricot.in");
   ofstream cout("apricot.out");
   int n, r, u;
   cin >> n >> r >> u;
   d[0] = -INF; d[1] = 0;
   for(int i = 2; i <= n; i++)
      d[i] = INF;
   for(int i = 2; i <= n; i++)
   {
      for(int j = 1; 2 * j <= i; j++)
      {
         d[i] = min(d[i], max(d[j] + u, d[i - 2 * j] + r));
      }
      if(i % 2 == 0)
         d[i] = min(d[i], (ll)i / 2 * u);
   }
//   for(int i = 0; i < n; i++)
//      cout << i << " " << d[i] << endl;
   cout << d[n] << endl;
}
