// zzz.cpp : Defines the entry point for the console application.
//
#include <stdio.h>
#include <tchar.h>
#include <algorithm>
#include <math.h>
#include <vector>
#include <bitset>
#include <assert.h>

using namespace std;

int tSwitch[100000];
vector<int> restY[100000];
vector<int> restN[100000];


int* info;

int n, m;

void doSolve(int cm, int k, int swAt, int period)
{
	int ii = restY[cm].front();
	int* cdst = info + ii * m + cm;
	int nSwat;
	if (k == 1)
	{
		nSwat = n;
		int v = restN[cm].front();
		for (int i = ii; i>=0; i--, cdst -= m)
		{
			*cdst = v;
			v--;
			if (v < 0)
			{
				v += 10;
			}
			if (v == 0)
			{
				if (i-1 < nSwat) nSwat = i-1;
			}
		}
		cdst = info + ii * m + cm;
		v = restN[cm].front();
		for (int i = ii; i<n; i++, cdst += m)
		{
			*cdst = v;
			v++;
			if (v >= 10) v -= 10;
			if (v == 0)
			{
				if (i+1 < nSwat) nSwat = i+1;
			}
		}
	} else {
		nSwat = n;
		int v = restN[cm].front();
		for (int i = ii; i>=0; i--, cdst -= m)
		{
			*cdst = v;
			if (abs(swAt - i) % period == 0)
			{
				v--;
				if (v < 0) v += 10;
				if (v == 0)
				{
					if (i < nSwat) nSwat = i;
				}
			}
		}
		cdst = info + ii * m + cm;
		v = restN[cm].front();
		for (int i = ii; i<n; i++, cdst += m)
		{
			*cdst = v;
			if (abs(swAt - i) % period == 0)
			{
				v++;
				if (v >= 10) v -= 10;
				if (v == 0)
				{
					if (i < nSwat) nSwat = i;
				}
			}
		}

	}
	int np = period * 10;
	if (np > 100000) np = 100000;
	if (cm) doSolve(cm-1, k+1, nSwat, np);
}

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	
	scanf("%d%d", &n, &m);
	info = new int[n*m];
	int* infoP = info;

	char buff[100001];
	for (int i = 0; i < n ; i++)
	{
		scanf("%s", buff);
		for (int j = 0; j < m; j++, infoP++)
		{
			if (buff[j] == '*')
			{
				*infoP = -1;
			} else {
				*infoP = buff[j] - '0';
				restY[j].push_back(i);
				restN[j].push_back(*infoP);
			}
		}
	}
	doSolve(m-1, 1, 0, 1);
	for (int i = 0; i < m ; i++) printf("%c", char(info[i] + '0'));
	fclose(stdin); fclose(stdout);
	return 0;
}

