
#include <stdio.h>
#include <tchar.h>
#include <math.h>
#include <string.h>
#include <vector>
#include <map>
using namespace std;



struct CONode
{
	int lb, rb;
	CONode* l, *r;
	int v;
	int cmax;
	int maxi;
	
	void makeL()
	{
		int c = (lb + rb) >> 1;
		l = new CONode();
		l->lb = lb;
		l->rb = c;
	}
	void makeR()
	{
		int c = (lb + rb) >> 1;
		r = new CONode();
		r->lb = c+1;
		r->rb = rb;
	}

	void insert(int ik, int iv)
	{
		if ( (ik < lb) || (ik > rb) ) return;
		if (lb == rb)
		{
			if (iv > cmax) 
			{
				cmax = iv;
				maxi = ik;
			}
			return;
		}
		int c = (lb + rb) / 2;
		if (ik > c)
		{
			if (!r) makeR();
			r->insert(ik, iv);
		} else {
			if (!l) makeL();
			l->insert(ik, iv);
		}
		if (iv > cmax) 
		{
			cmax = iv;
			maxi = ik;
		}
	}

	int getMax(int gl, int gr, int& out_i)
	{
		if ( (gl <= lb) && (gr >= rb) )
		{
			out_i = maxi;
			return cmax;
		} else {
			int c = (lb + rb) >> 1;
			int a = -99;
			if (gr > c && (r != NULL))
			{
				a = r->getMax(gl, gr, out_i);
			} 
			if (gl <= c && (l != NULL))
			{
				int c;
				int b = l->getMax(gl, gr, c);
				if (b > a)
				{
					a = b;
					out_i = c;
				}
			}
			return a;
		}
	}

	CONode()
	{
		l = NULL; r = NULL; cmax = -99;
	}
};

typedef map<int,int> mpp ;
typedef pair<int,int> mppk;
typedef pair<int,mpp*> mppkl;
typedef vector<int> vri;
typedef vector<mppkl> ipvr;

//typedef map<int,int> mppp ;

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	
	int n, m;

	scanf("%d%d", &n, &m);
	//mpp *exrows = new mpp[n];
	//mpp *cols = new mpp[n];

	//mpp excols;

	int *kbuff = new int[100000];

	//ipvr* overexr = new ipvr[n];
	ipvr *excolsi = new ipvr[n];

	int* solved = new int[n];
	memset(solved, 0xFFFFFFFF, 4 * n);


	for (int i = 0; i < m; i++)
	{
		int kn;
		scanf("%d", &kn);

	

		mpp* nm = new mpp;

		for (int j = 0; j < kn; j++) 
		{
			scanf("%d", &kbuff[j]);
			kbuff[j]--;
			nm->insert(mppk(kbuff[j], 0));
		}
		if (kn == 1)
		{
			solved[kbuff[0]] = i;
		}

		for (int j = 0; j < kn; j++)
		{
			excolsi[kbuff[j]].push_back(mppkl(i, nm));
		}
	}


	for (int i = 0; i < n; i++)
	{
		int maxm = -1;

		if (solved[i] >= 0)
		{
			maxm = solved[i];
		} else 
		for (int j = 0; j < n; j++)
		{
			if (i == j) continue;
			int cEx = 0; int cm = -1; 
			for (ipvr::iterator ev = excolsi[j].begin(); ev != excolsi[j].end(); ev++)
			{
				if (ev->second->find(i) == ev->second->end())
				{
					cm = ev->first;
					break;
				}
			}
			if (cm < 0)
			{
				for (ipvr::iterator ev = excolsi[i].begin(); ev != excolsi[i].end(); ev++)
				{
					if (ev->second->find(j) == ev->second->end())
					{
						cm = ev->first;
						break;
					}
				}
			}
			if (cm < 0)
			{
				maxm = -2;
				break;
			}
			if (cm > maxm) maxm = cm; 
		}
		if (n == 1)
		{
			printf("1 ");
		}
		if (maxm == -2)
		{
			printf("0 ");
		} else {
			printf("%d ", maxm+1);
		}
	}

	fclose(stdin); fclose(stdout);
	return 0;
}

