#include <iostream>
#include <cstdio>


using namespace std;
#define forn(i, n) for(i = 0; i < n; i++)
#define forab(i, a, b) for(i = a; i < b; i++)
const int inf = 1000;
struct pnt{
	int x, y, q;
	pnt(){}
	pnt(int _x, int _y, int _q = 0){
		x = _x;
		y = _y;
		q = _q;
	}
	int len(pnt a){
		return max(abs(x - a.x), abs(y - a.y));
	}
	pnt operator + (const pnt & a) const{
		return pnt(x + a.x, y + a.y, 0);
	}
	void print(){
		printf("%d %d %d\n", x, y, q); 
	}
};
const int maxn = 30;
const int maxm = 30;


bool use[maxn][maxm];
bool use1[maxn][maxm];

int n, m;
pnt hod(pnt p){
	int len = inf;
	int i, j;
	pnt hd = pnt(0, 0, 0);
	forn(i, n)
		forn(j, m){
			if (!use[i][j] && len > pnt(i, j).len(p)){
				hd = pnt(0, 0, 0);
				if (j > p.x)
					hd.x = 1;
				if (j < p.x)
					hd.x = -1;
				if (i > p.y)
					hd.y = 1;
				if (i < p.y)
					hd.y = -1;
				len = pnt(j, i).len(p);
				if (len <= 1){
					hd.q = 1;
					return hd;
				}
			}
		}
	return hd;
}

void modif(int x, int y){
	int i, j;
	memset(use1, 1, sizeof(use1));
	forn(i, n)
		forn(j, m)
			if (i + y < n && j + x < m && i + y >= 0 && j + x >= 0)
				use1[i + y][j + x] = use[i][j];
	forn(i, n)
		forn(j, m)
			use[i][j] = use1[i][j]; 
}

void pmap(){
	int i, j;
	cout << "map\n";
	for(i = n - 1; i >= 0; i--){
		forn(j, m)
			cout << use[i][j] << " ";
		cout << "\n";
	}
	cout << "\n";
}

int main(){
//	freopen("in", "r", stdin);
//	freopen("out", "w", stdout);
	pnt p0, p1, ph;
	int i, j;
	cin >> n >> m;
	cin >> p0.x >> p0.y;
	p0.x--;
	p0.y--;
	//pmap();
	i = 0;
	while(true){
		i++;
	//	cout << "hod" << i << "\n";
		p1 = hod(p0);
		p1.print();
		fflush(stdout);
		p0 = p1 + p0;
		//cout << "x:" <<p0.x << "y:" <<p0.y << "\n";//
		fflush(stdout);
		use[p0.y][p0.x] = true;
		scanf("%d%d%d", &ph.q, &ph.x, &ph.y);
		if (ph.q == 1)
			return 0;
		modif(ph.x, ph.y);
	//	pmap();
			
	}

	return 0;
}