#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <stdlib.h>
#include <string>
using namespace std;
const int maxn = 100009;

char buffer[maxn];

int as[maxn];
int asCount = 0;
int bs[maxn];
int bsCount = 0;

int samePref = 0;
int sameSuff = 0;

int asSums[maxn];

void preCount()
{
	scanf("%s", buffer);
	asCount = strlen(buffer);
	for (int i = 0; i < asCount; i++)
		as[i] = buffer[i] - '0';

	scanf("%s", buffer);
	bsCount = strlen(buffer);
	for (int i = 0; i < bsCount; i++)
		bs[i] = buffer[i] - '0';

	asSums[0] = 0;
	for (int i = 0; i < asCount; i++)
		asSums[i + 1] = asSums[i] + as[i];

	for (samePref = 0; samePref < bsCount && as[samePref] == bs[samePref]; samePref++) ;
	for (sameSuff = 0; sameSuff < bsCount && as[asCount - 1 - sameSuff] == bs[bsCount - 1 - sameSuff]; sameSuff++) ;
}

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	preCount();

	for (int rd = 1; rd <= 6; rd++)
		for (int rb = 0; rb + rd <= bsCount; rb++)
		{
			if (rd > 1 && bs[rb] == 0) continue;
			if (rb > samePref) continue;
			int wasLen = asCount - bsCount + rd;
			int suffLen = bsCount - rb - rd;
			if (suffLen > sameSuff) continue;

			int checkNum = 0;
			for (int i = 0; i < rd; i++)
			{
				checkNum *= 10;
				checkNum += bs[rb + i];
			}

			if (asSums[rb + wasLen] - asSums[rb] == checkNum)
			{
				cout << rb + 1 << ' ' << rb + wasLen << endl;
				exit(0);
			}
		}

	return 0;
}