#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 100009;

int n, boss;

vector<int> ga[maxn];
int gaRoot;
int gaIns[maxn];
int gaOuts[maxn];
int gaTime = 0;

vector<int> gb[maxn];
int gbRoot;
int gbIns[maxn];
int gbOuts[maxn];
int gbTime = 0;

long long answer = 0;

void dfsA(int v)
{
	gaIns[v] = gaTime++;
	
	for (int i = 0; i < ga[v].size(); i++)
		dfsA( ga[v][i] );

	gaOuts[v] = gaTime++;
}

void dfsB(int v)
{
	gbIns[v] = gbTime++;

	for (int i = 0; i < gb[v].size(); i++)
		dfsB( gb[v][i] );

	gbOuts[v] = gbTime++;
}

void preRead()
{
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &boss);
		boss--;
		if (boss >= 0) ga[boss].push_back(i);
		else gaRoot = i;
	}
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &boss);
		boss--;
		if (boss >= 0) gb[boss].push_back(i);
		else gbRoot = i;
	}

	dfsA(gaRoot);
	dfsB(gbRoot);
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	preRead();

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			bool aij, bij;

			if (gaIns[i] < gaIns[j] && gaOuts[j] < gaOuts[i]) aij = true;
			else if (gaIns[j] < gaIns[i] && gaOuts[i] < gaOuts[j]) aij = false;
			else continue;

			if (gbIns[i] < gbIns[j] && gbOuts[j] < gbOuts[i]) bij = true;
			else if (gbIns[j] < gbIns[i] && gbOuts[i] < gbOuts[j]) bij = false;
			else continue;

			if (aij == bij) answer++;
		}
	}

	cout << answer << endl;

	return 0;
}