#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 1000009;
const long long inf = 1000 * 1000 * 1009ll * 1000ll * 1000ll;

long long n, r, u;
long long d[maxn];

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	cin >> n >> r >> u;

	d[0] = d[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		long long nd = inf;
		if (i % 2 == 0) nd = d[i / 2] + u;

		long long ll = 1;
		long long rr = i / 2;

		while (ll < rr)
		{
			long long m = (ll + rr) / 2;

			if (d[m] + u < d[i - 2 * m] + r) ll = m + 1;
			else rr = m;
		}

		long long md1 = max(d[ll] + u, d[i - 2 * ll] + r);
		if (md1 < nd) nd = md1;

		if (ll > 1)
		{
			ll--;
			long long md2 = max(d[ll] + u, d[i - 2 * ll] + r);
			if (md2 < nd) nd = md2;
		}

		d[i] = nd;
	}

	cout << d[n] << endl;

	return 0;
}