#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 100009;

int n, k;
int vs[maxn], hs[maxn];
int rl, rr;
//int veCount = 0, heCount = 0;
int ves[maxn], hes[maxn];

int bpr[maxn]; // Best Pair Right
int crs[maxn]; // Current RighteSt

int main()
{
	for (int i = 0; i < maxn; i++)
		crs[i] = -1;
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &vs[i], &hs[i]);
		if (i == 0)
		{
			bpr[i] = 0;
			crs[i] = -1;
			ves[i] = hes[i] = 1;

			continue;
		}

		if (vs[i] != vs[i - 1]) ves[i] = 1;
		else ves[i] = ves[i - 1] + 1;

		if (hs[i] != hs[i - 1]) hes[i] = 1;
		else hes[i] = hes[i - 1] + 1;

		int leftBorder = crs[ bpr[i - 1] ] + 1;

		int past = i - max(ves[i], hes[i]);
		while (past >= leftBorder)
		{
			if (vs[past] != vs[i] && hs[past] != hs[i]) break;

			int nvp = maxn * 10;
			if (vs[past] == vs[i]) nvp = past - ves[past];
			if (hs[past] == hs[i]) nvp = min(nvp, past - hes[past]);
			past = nvp;
		}
		if (past >= leftBorder)
		{
			crs[i] = past;
			bpr[i] = i;
		}
		else
		{
			crs[i] = -1000;
			bpr[i] = bpr[i - 1];
		}
	}
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		scanf("%d%d", &rl, &rr);
		rl--, rr--;
		int cBp = bpr[rr];
		int cLeft = crs[cBp];

		if (cLeft >= rl) printf("%d %d\n", cLeft + 1, cBp + 1);
		else printf("0 0\n");
	}

	return 0;
}