#include <fstream>
#include <vector>

using namespace std;

ifstream cin("virus.in");
ofstream cout("virus.out");

int tin1[100500], tin2[100500];
int tout1[100500], tout2[100500];
long long ans = 0;
long long cnt[100500];
int t = 0;
vector<int> g1[100500], g2[100500];

void dfs1(int v)
{
    t++;
    tin1[v] = t;
    for (int i = 0; i < g1[v].size(); i++)
    {
        int u = g1[v][i];
        dfs1(u);
    }
    t++;
    tout1[v] = t;
}

void dfs2(int v)
{
    t++;
    tin2[v] = t;
    for (int i = 0; i < g2[v].size(); i++)
    {
        int u = g2[v][i];
        dfs2(u);
    }
    t++;
    tout2[v] = t;
}

int main()
{
    int n;
    cin >> n;
    int st1 = 1;
    for (int i = 1; i <= n; i++)
    {
        int k;
        cin >> k;
        if (k == 0)
            st1 = i;
        else
            g1[k].push_back(i);
    }
    int st2 = 1;
    for (int i = 1; i <= n; i++)
    {
        int k;
        cin >> k;
        if (k == 0)
            st2 = i;
        else
            g2[k].push_back(i);
    }
    dfs1(st1);
    t = 0;
    dfs2(st2);
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
        {
            if (tin1[i] <= tin1[j] && tout1[i] >= tin1[j] && tin2[i] <= tin2[j] && tout2[i] >= tin2[j])
                ans++;
            if (tin1[j] <= tin1[i] && tout1[j] >= tin1[i] && tin2[j] <= tin2[i] && tout2[j] >= tin2[i])
                ans++;
        }
    cout << ans;
    return 0;
}
