#include <iostream>
#include <string>
#include <vector>
#include <deque>
using namespace std;

vector <int> a, b;
vector <deque <char>> sufa, sufb;
vector <vector <int>> sums;

void main () {
	freopen ("password.in", "r", stdin);
	freopen ("password.out", "w", stdout);

	string t;
	cin >> t;
	int as = t.size();
	a.resize (as);
	for (int i = 0; i < as; ++i)
		a[i] = t[i] - '0';
	cin >> t;
	int bs = t.size();
	b.resize (bs);
	for (int i = 0; i < bs; ++i)
		b[i] = t[i] - '0';
	sufa.resize (as + 1);
	sufa[as].push_back(0);
	sufa[as-1].push_back(a[as-1] + '0');
	for (int i = as - 2; i >= 0; --i) {
		sufa[i] = sufa[i+1];
		sufa[i].push_front (a[i] + '0');
	}
	sufb.resize (bs + 1);
	sufb[bs].push_back(0);
	sufb[bs-1].push_back(b[bs-1] + '0');
	for (int i = bs - 2; i >= 0; --i) {
		sufb[i] = sufb[i+1];
		sufb[i].push_front (b[i] + '0');
	}
	if (a == b) {
		cout << "1 1";
		return;
	}
	if (a.size() == b.size()) {
		int i = 0;
		while (a[i] == b[i]) ++i;
		cout << i+1 << " " << i + 2;
		return;
	}
	int dif = as - bs;
	sums.resize (bs, vector <int> (5));
	for (int i = 0; i < bs; ++i) {
		sums[i][0] = b[i];
		for (int k = max (0, i-4); k < min(i, 5); ++k)
			sums[k][i-k] = sums[k][i-k-1] * 10 + b[i];
	}
	int sum1 = 0;
	for (int i = 0; i < dif + 1; ++i)
		sum1 += a[i];
	int sum2 = sum1 + a[dif + 1];
	for (int i = dif + 1; i < as; ++i) {
		for (int j = 0; j < 5; ++j) {
			if (sum1 == sums[i - dif - 1][j] && sufa[i + 1] == sufb[i - dif  + j]) {
				cout << i - dif + 1 << " " << i + 1;
				return;
			}
			if (sum2 == sums[i - dif - 1][j] && sufa[i + 1]  == sufb[i - dif + j]) {
				cout << i - dif << " " << i + 1;
				return;
			}
		}
		sum1 += a[i] - a[i - dif - 1];
		sum2 += a[i + 1] - a[i - dif - 1];
	}
}