#include <iostream>
#include <vector>
using namespace std;

int n, u, r;

vector <int> find (int k) {
	vector <int> ans;
	vector <bool> used (k + 1);
	for (int i = 2; i <= sqrt(double(k)); ++i) {
		if (!used[i] && !(k % i)) ans.push_back(i);
		for (int j = i; j <= sqrt(double(k)); j += i)
			used[j] = true;
	}
	return ans;
}

int solve (int k) {
	if (k == 1) return 0;
	if (k == 2) return u;
	if (k % 2) return min (max (r, solve (k - 1)), max (u, r + solve(k-2)));
	return u + solve (k / 2);
}

void main () {
	freopen ("apricot.in", "r", stdin);
	freopen ("apricot.out", "w", stdout);

	cin >> n >> r >> u;
	vector <int> del = find (n);
	int ans = solve (n);
	for (int i = 0; i < del.size(); ++i) {
		ans = min (ans, solve (del[i]) + solve (n / del[i]));
	}
	cout << ans;
}