#include <iostream>
#include <vector>
using namespace std;

int n, k;

vector <vector <bool>> gar;
vector <pair <int, int>> a;

void main () {
	freopen ("mosaic.in", "r", stdin);
	freopen ("mosaic.out", "w", stdout);

	cin >> n;
	gar.resize (n, vector<bool> (n));
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		a.push_back (make_pair (x, y));
		for (int j = 0; j < i; ++j)
			if (a[j].first == a[i].first || a[j].second == a[i].second) gar[i][j] = gar[j][i] = true;
	}
	cin >> k;
	for (int i = 0; i < k; ++i) {
		bool find = false;
		int l, r;
		cin >> l >> r;
		--l; --r;
		for (int x = l; x <= r; ++x) {
			for (int y = l; y <= r; ++y) {
				if (x == y) continue;
				if (!gar[x][y]) {
					cout << x + 1 << " " << y + 1 << endl;
					find = true;
					break;
				}
			}
			if (find) break;
		}
		if (!find) cout << "0 0" << endl;
	}
}