#include <iostream>
#include <vector>
using namespace std;

const int N = 100000;

int n, k;

vector <pair <int, int>> a;
vector <vector <pair <int, int>>> gar;

void main () {
	freopen ("mosaic.in", "r", stdin);
	freopen ("mosaic.out", "w", stdout);

	cin >> n;
	a.resize (n);
	gar.resize (n, vector<pair<int,int>> (n));
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
		bool f = false;
		pair <int, int> cur = make_pair(0,0);
		int pos = -1;
		for (int j = i-1; j >= 0; --j) {
			if (f) gar[j][i] = cur;
			else if (a[j].first != a[i].first && a[j].second != a[i].second) {
				f = true;
				cur = make_pair(j + 1, i + 1);
				pos = j;
				gar[j][i] = cur;
			}
		}
		if (!f) continue;
		for (int x = i + 1; x < n; ++x)
			gar[pos][x] = cur;
	}
	cin >> k;
	for (int i = 0; i < k; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		cout << gar[l][r].first << " " << gar[l][r].second << endl;
	}
}