#include <iostream>
#include <vector>
using namespace std;

int n, m;

vector <vector <int>> acts;
vector <char> used;
vector <int> ans;

void main () {
	freopen ("theatre.in", "r", stdin);
	freopen ("theatre.out", "w", stdout);

	cin >> n >> m;
	used.resize (n);
	ans.resize (n);
	acts.resize (n);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int t;
			cin >> t;
			--t;
			if (!used[t])
				acts[t].push_back(i + 1);
		}
		vector <bool> yes (n, false);
		for (int x = 0; x < n; ++x)
			for (int y = 0; y < x; ++y)
				if (acts[x] == acts[y]) yes[x] = yes[y] = true;
		for (int j = 0; j < n; ++j)
			if (!used[j] && !yes[j]) {
				ans[j] = i + 1;
				used[j] = true;
			}
	}
	for (int i = 0; i < n; ++i)
		cout << ans[i] << " ";
}