#include <iostream>
#include <vector>
#include <set>
using namespace std;

const int INF = 2000000000;

int n, k;

set <int> t;
vector <int> a;

int solve (int spos, int pos, vector<int> v, set<int> s) {
	vector <int> curv = v;
	set <int> curs = s;
	int curans = 0;
	int prev = (pos == 0 ? 0 : v[pos-1]),
		next = (pos >= v.size() ? INF : v[pos]);
	for (int i = 1; i <= n; ++i)
		if (!s.count(i)) {
			curs.insert(i);
			curv.insert(curv.begin() + pos, i);
			if (curv.size() == n) {
				vector <int> d (n, 1);
				int mx = 1;
				for (int j = 1; j < n; ++j) {
					d[j] = 1;
					for (int x = 0; x < j; ++x)
						if (curv[j] > curv[x]) d[j] = max (d[j], d[x] + 1);
					mx = max (mx, d[j]);
				}
				if (mx <= a.size()) ++curans;
			}
			else
				for (int j = pos + 1; j <= curv.size(); ++j)
					curans += solve (j - (curv.size() - a.size()), j, curv, curs);
			curs = s;
			curv = v;
		}
	return curans;
}

void main () {
	freopen ("army.in", "r", stdin);
	freopen ("army.out", "w", stdout);

	cin >> n >> k;
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		t.insert(x);
		a.push_back(x);
	}
	int ans = 0;
	for (int i = 0; i <= (int)a.size(); ++i)
		ans += solve (i, i, a, t);
	cout << (n == k ? 1 : ans);
}