#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

using namespace std;

const int N = int(1e6 + 5);
const LL INF = LL(1e13);

int n, R, U;
LL dp[N];

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	while (scanf("%d%d%d", &n, &R, &U) != -1) {

    	for (int i = 2; i <= n; i++)
    		dp[i] = INF;
    	dp[1] = 0;
    	dp[2] = U;

    	for (int i = 3; i <= n; i++) {
    		if (i < n || i % 2 == 0)
    			dp[i] = min(dp[i], dp[ (i + 1) / 2 ] + U);

    		if (dp[1] + U > dp[i - 2] + R) {
				dp[i] = min(dp[i], dp[1] + U);    			
    			continue;
    		}

    		int l = 1, r = i / 2 + 1;
      		while (l + 1 < r) {
      			int mid = (l + r) / 2;
      			if (dp[mid] + U <= dp[i - 2 * mid] + R)
      				l = mid;
      			else
      				r = mid;
      		}
      		dp[i] = min(dp[i], dp[i - 2 * l] + R);
      		if (r < (i + 1) / 2)
      			dp[i] = min(dp[i], dp[l + 1] + U);
    	}
    	printf("%I64d\n", dp[n]);

/*		for (int i = 1; i <= n; i++)
    		cerr << dp[i] << " ";
    	cerr << endl;	*/
	}

	return 0;
}
