#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

#define N 1005

using namespace std;

char p[N][N];
bool go[N];

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	int n, m;
	scanf("%d%d\n", &n, &m);

	for (int i = 0; i < n; i++, scanf("\n"))
		for (int j = 0; j < m; j++) 			
			scanf("%c", &p[i][j]);

	bool n_star = false;
	for (int i = 0; i < n; i++)
		if (p[i][m - 1] != '*') {
			n_star = true;
			break;
		}

	if (!n_star) {
		if (n == 2) 
			puts("999");
		else
			puts("0098");
		return 0;
	}

   	int pos, j = m - 1;
   	for (pos = 0; pos < n; pos++)
   		if (p[pos][j] != '*') break;

   	for (int i = pos, sym = int(p[pos][j] - '0'); i < n; i++, sym = (sym + 1) % 10 ) 
   		p[i][j] = char('0' + sym);

   	for (int i = pos, sym = int(p[pos][j] - '0'); i >= 0; i--) {
   		p[i][j] = char('0' + sym);	
		sym = sym - 1;
   		if (sym < 0) sym += 10; 
	}
	 
	for (int j = m - 2; j >= 0; j--) {
		memset(go, false, sizeof(go));
		for (int i = 1; i < n; i++) {
			if (p[i][j + 1] == '0' && p[i - 1][j + 1] == '9') {
				go[i - 1] = true;
			}
		}

		int pos;
		for (pos = 0; pos < n; pos++)
			if (p[pos][j] != '*') break;

		for (int i = pos, sym = int(p[pos][j] - '0'); i < n; i++) { 
			p[i][j] = char('0' + sym);
			if (go[i])
				sym = (sym + 1) % 10;
		}

		for (int i = pos, sym = int(p[pos][j] - '0'); i >= 0; i--) {
			p[i][j] = char('0' + sym);	
			if (i > 0)
				if (go[i - 1]) {
					sym--;
					if (sym < 0) sym += 10; 
				}
		}
	}	

	for (int j = 0; j < n; j++, puts(""))
	for (int i = 0; i < m; i++)
		printf("%c", p[j][i]);

	return 0;
}
