#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

#define N 1005

using namespace std;

char p[N][N], mem[N][N];
bool go[N], n_star[N];
int n, m;

void check() {
   	int pos, j = m - 1;
   	for (pos = 0; pos < n; pos++)
   		if (p[pos][j] != '*') break;

   	for (int i = pos, sym = int(p[pos][j] - '0'); i < n; i++, sym = (sym + 1) % 10 ) 
   		p[i][j] = char('0' + sym);

   	for (int i = pos, sym = int(p[pos][j] - '0'); i >= 0; i--) {
   		if (p[i][j] != char('0' + sym) && p[i][j] >= '0' && p[i][j] <= '9')
   			return;
   		p[i][j] = char('0' + sym);	
		sym = sym - 1;
   		if (sym < 0) sym += 10; 
	}
	 
	for (int j = m - 2; j >= 0; j--) {
		memset(go, false, sizeof(go));
		for (int i = 1; i < n; i++) {
			if (p[i][j + 1] == '0' && p[i - 1][j + 1] == '9') {
				go[i - 1] = true;
			}
		}

		int pos;
		for (pos = 0; pos < n; pos++)
			if (p[pos][j] != '*') break;

		for (int i = pos, sym = int(p[pos][j] - '0'); i < n; i++) { 
			if (p[i][j] != char('0' + sym) && p[i][j] >= '0' && p[i][j] <= '9')
   				return;
   		
			p[i][j] = char('0' + sym);
			if (go[i])
				sym = (sym + 1) % 10;
		}

		for (int i = pos, sym = int(p[pos][j] - '0'); i >= 0; i--) {
			if (p[i][j] != char('0' + sym) && p[i][j] >= '0' && p[i][j] <= '9')
   				return;
   		
			p[i][j] = char('0' + sym);	
			if (i > 0)
				if (go[i - 1]) {
					sym--;
					if (sym < 0) sym += 10; 
				}
		}
	}	

	for (int i = 0; i < m; i++)
		printf("%c", p[0][i]);
	exit(0);
}

void dfs(int step) {
	if (step == m) {
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				mem[i][j] = p[i][j];
		check();
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				p[i][j] = mem[i][j];
		return;
	}
	if (n_star[step])
		dfs(step + 1);
	else {
		for (char i = '0'; i <= '9'; i++) {
			p[0][step] = i;
			dfs(step + 1);
			p[0][step] = 0;
		}
	}				
}

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	scanf("%d%d\n", &n, &m);

	for (int i = 0; i < n; i++, scanf("\n"))
		for (int j = 0; j < m; j++) 			
			scanf("%c", &p[i][j]);

	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
			if (p[i][j] != '*') {
				n_star[j] = true;
				break;
			}

	dfs(0);

	return 0;
}
