#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

#define N 1005

using namespace std;

char p[N][N], mem[N][N];
bool go[N], n_star[N];
int n, m;

bool check(int ver) {
   	int pos, j = ver;

   	if (j == m - 1) {
       	for (pos = 0; pos < n; pos++)
       		if (mem[pos][j] != '*') break;

       	for (int i = pos, sym = int(mem[pos][j] - '0'); i < n; i++, sym = (sym + 1) % 10 ) 
       		p[i][j] = char('0' + sym);

       	for (int i = pos, sym = int(mem[pos][j] - '0'); i >= 0; i--) {
       		if (mem[i][j] != char('0' + sym) && mem[i][j] >= '0' && mem[i][j] <= '9')
       			return false;
       		p[i][j] = char('0' + sym);	
    		sym = sym - 1;
       		if (sym < 0) sym += 10; 
    	}
	}
	else { 
  		memset(go, false, sizeof(go));
  		for (int i = 1; i < n; i++) {
  			if (p[i][j + 1] == '0' && p[i - 1][j + 1] == '9') {
  				go[i - 1] = true;
  			}
  		}

  		int pos;
  		for (pos = 0; pos < n; pos++)
  			if (mem[pos][j] != '*') break;

  		for (int i = pos, sym = int(mem[pos][j] - '0'); i < n; i++) { 
  			if (mem[i][j] != char('0' + sym) && mem[i][j] >= '0' && mem[i][j] <= '9')
     				return false;
     		
  			p[i][j] = char('0' + sym);
  			if (go[i])
  				sym = (sym + 1) % 10;
  		}

  		for (int i = pos, sym = int(mem[pos][j] - '0'); i >= 0; i--) {
  			if (mem[i][j] != char('0' + sym) && mem[i][j] >= '0' && mem[i][j] <= '9')
     				return false;
     		
  			p[i][j] = char('0' + sym);	
  			if (i > 0)
  				if (go[i - 1]) {
  					sym--;
  					if (sym < 0) sym += 10; 
  				}
  		}
	}
	return true;
}

void dfs(int step) {
	if (step == m) {
		for (int i = 0; i < m; i++)
			printf("%c", p[0][i]);
		exit(0);
	}
	if (n_star[m - step - 1]) {		
		if (check(m - step - 1)) {
			dfs(step + 1);
		}
	}
	else {
		for (char i = '0'; i <= '9'; i++) {			
			mem[0][m - step - 1] = i;
			if (check(m - step - 1))
				dfs(step + 1);
			mem[0][m - step - 1] = 0;
		}
	}				
}

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	scanf("%d%d\n", &n, &m);

	for (int i = 0; i < n; i++, scanf("\n"))
		for (int j = 0; j < m; j++) { 			
			scanf("%c", &p[i][j]);
			mem[i][j] = p[i][j];
		}

	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
			if (p[i][j] != '*') {
				n_star[j] = true;
				break;
			}

	dfs(0);

	return 0;
}
