#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

int num[20], perm[20], pos[20], dp[20];

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	int n, k, cnt = 0;
	cin >> n >> k;

	for (int i = 0; i < k; i++) 
		cin >> num[i];

	for (int i = 0; i < n; i++)
		perm[i] = i + 1;

	do {
		for (int i = 0; i < n; i++)
			pos[ perm[i] ] = i;
		bool ok = true;

		for (int i = 1; i < k; i++)
			if (pos[ num[i] ] < pos[ num[i - 1] ])
				ok = false;

		if (ok) {
			dp[0] = 1;
			for (int i = 1; i < n; i++) {
				dp[i] = 1;
				for (int j = 0; j < i; j++)
					if (perm[j] < perm[i]) {
						dp[i] = max(dp[i], dp[j] + 1);
						if (dp[i] > k) {
							ok = false;
							break;
						}
					}
				if (!ok) break;								
			}
		}		

		if (ok) cnt++;

	}
	while (next_permutation(perm, perm + n));		

	cout << cnt << endl;

	return 0;
}


