#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

bool used[20];
int num[20], perm[20], pos[20], dp[20], cnt, n, k;

void dfs(int step, int d) {
	if (step == n) {
		cnt++;
		return;
	}

	for (int i = 1; i <= n; i++)
		if (!used[i]) {
			dp[step] = 1;

			if (pos[i] && num[d] != i) continue;

			bool ok = true;

			for (int j = 0; j < step; j++) {
				if (i > perm[j]) {
					dp[step] = max(dp[step], dp[j] + 1);
					if (dp[step] > k) {
						ok = false;
						break;
					}
				}
			}

			if (!ok) continue;

			used[i] = true;
			perm[step] = i;
			dfs(step + 1, d + int(pos[i]));
			used[i] = false;
		}
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	cin >> n >> k;

	for (int i = 0; i < k; i++) {
		cin >> num[i];
		pos[ num[i] ] = 1;
	}

	dfs(0, 0);

	cout << cnt << endl;

	return 0;
}


