#include <set>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <vector>

#define INF 1e9
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 200000

using namespace std;

typedef long long ll;

string a, b;
int l[MAXN], r[MAXN];
int sum[MAXN];
int num[7][MAXN];

int getsum(int l, int r)
{
    if (l)
    {
        return sum[r] - sum[l - 1];
    }
    else
    {
        return sum[r];
    }
}

int len(int t)
{
    if (t == 0)
        return 1;
    int res = 0;
    while (t)
    {
        res++;
        t /= 10;
    }
    return res;
}

void solve(int k)
{
    for (int i = k - 1; i < b.size(); i++)
    {
        int left = i - k + 1, right = a.size() - b.size() + i;
        if (left)
        {
            if (!l[left - 1])
                continue;
        }
        if (right != a.size() - 1)
        {
            if (!r[right + 1])
                continue;
        }
        if (getsum(left, right) == num[k][i] && len(getsum(left, right)) == k)
        {
            printf("%d %d", left + 1, right + 1);
            exit(0);
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
    cin >> a >> b;
    if (a == b)
    {
        printf("1 1");
        return 0;
    }
    for (int i = 0; i < b.size(); i++)
    {
        if (a[i] == b[i])
        {
            l[i] = 1;
        }
        else
        {
            break;
        }
    }
    int j = a.size() - 1;
    for (int i = b.size() - 1; i >= 0; i--, j--)
    {
        if (a[j] == b[i])
        {
            r[j] = 1;
        }
        else
        {
            break;
        }
    }
    sum[0] = a[0] - '0';
    for (int i = 1; i < a.size(); i++)
    {
        sum[i] = sum[i - 1] + a[i] - '0';
    }
    for (int i = 0; i < b.size(); i++)
    {
        int t = b[i] - '0';
        for (int j = 1; j <= 6; j++)
        {
            if (i >= j - 1)
            {
                num[j][i] = num[j - 1][i - 1] * 10 + t;
            }
        }
    }
    for (int i = 1; i <= 6; i++)
    {
        solve(i);
    }
    return 0;
}

