#include <set>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <vector>

#define INF 1e9
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 200000

using namespace std;

typedef long long ll;

vector <int> g[2][MAXN];
int tin[2][MAXN], tout[2][MAXN];
int mark[2][MAXN];
int timer = 0;

void dfs(int v, int k)
{
    tin[k][v] = timer++;
    mark[k][v] = 1;
    for (int i = 0; i < g[k][v].size(); i++)
    {
        int u = g[k][v][i];
        if (!mark[k][u])
        {
            dfs(u, k);
        }
    }
    tout[k][v] = timer++;
}

int n;

bool isup(int i, int j, int k)
{
    return (tin[k][i] < tin[k][j] && tout[k][i] > tout[k][j]);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    cin >> n;
    int t;
    int a, b;
    forn (i, n)
    {
        scanf("%d", &t);
        if (t)
        {
            t--;
            g[0][t].pb(i);
        }
        else
        {
            a = i;
        }
    }
    forn (i, n)
    {
        scanf("%d", &t);
        if (t)
        {
            t--;
            g[1][t].pb(i);
        }
        else
        {
            b = i;
        }
    }
    timer = 0;
    dfs(a, 0);
    timer = 0;
    dfs(b, 1);
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (i == j)
                continue;
            if (isup(i, j, 0) && isup(i, j, 1))
                ans++;
        }
    }

    cout << ans;
    return 0;
}

