#include <set>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <vector>

#define INF (ll)1e15
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 1200000

using namespace std;

typedef long long ll;

ll dp[MAXN];

void init()
{
    forn (i, MAXN)
    {
        dp[i] = -1;
    }
}

ll r, u;

ll dyn(int n)
{
    if (dp[n] != -1)
        return dp[n];
    if (n <= 1)
        return 0;
    dp[n] = INF;
    for (int k = 1; 2 * k <= n; k++)
    {
        if (n != 2 * k)
            dp[n] = min(max(dyn(k) + u, dyn(n - 2 * k) + r), dp[n]);
        else
            dp[n] = min(dyn(k) + u, dp[n]);
    }
    return dp[n];
}

int n;


int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    init();
    cin >> n >> r >> u;
    cout << dyn(n);
    return 0;
}

