#include <set>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <vector>

#define INF (ll)1e18
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 1200000

using namespace std;

typedef long long ll;

ll dp[2][MAXN];

void init()
{
    forn (i, MAXN)
    {
        dp[0][i] = dp[1][i] = -1;
    }
}

ll r, u;

ll dyn(int n, int t)
{
    if (dp[t][n] != -1)
        return dp[t][n];
    if (n <= 1)
        return 0;
    if (n == 2)
    {
        return u;
    }
    dp[t][n] = INF;
    if (t == 0)
    {
        for (int k = 1; 2 * k <= n; k++)
        {
            if (n != 2 * k)
                dp[t][n] = min(max(dyn(k, 1) + u, dyn(n - 2 * k, 1) + r), dp[t][n]);
            else
                dp[t][n] = min(dyn(k, 1) + u, dp[t][n]);
        }
    }
    else
    {
        for (int k = 1; 2 * k <= n; k++)
        {
            if (n != 2 * k)
                dp[t][n] = min(max(dyn(k, 1) + u, dyn(n - 2 * k, 1) + r), dp[t][n]);
            else
                dp[t][n] = min(dyn(k, 1) + u, dp[t][n]);
        }
        if (n % 2 == 1)
        {
            int k = n / 2;
            dp[t][n] = min(max(dyn(k, 1) + u, dyn(k + 1, 1) + u), dp[t][n]);
        }
    }

    return dp[t][n];
}

int n;


int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    init();
    cin >> n >> r >> u;
    cout << dyn(n, 0);
    return 0;
}

