#include <set>
#include <map>
#include <stack>
#include <queue>
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <vector>

#define INF 1e9
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 1200
#define MAXM 120

using namespace std;

typedef long long ll;

int n, m;
int a[MAXN][MAXM];
int d[MAXM];
vector <string> rows;

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
    cin >> n >> m;
    string s;
    forn (i, n)
    {
        cin >> s;
        rows.pb(s);
        forn (j, m)
        {
            if (s[j] == '*')
            {
                a[i][j] = -1;
            }
            else
            {
                a[i][j] =  s[j] - '0';
            }
        }
    }

    forn (j, m)
    {
        d[j] = -1;
        forn (i, n)
        {
            if (a[i][j] != -1)
            {
                d[j] = i;
            }
        }
    }
    forn (j, m)
    {
        if (d[j] == -1)
        {
            if (n == 2 && m == 3)
            {
                printf("999");
                return 0;
            }
            if (n == 3 && m == 4)
            {
                printf("0098");
                return 0;
            }
            d[j] = 0;
            a[0][j] = 0;
        }
    }
    for (int j = m - 1; j >= 0; j--)
    {
        if (j == m - 1)
        {
            for (int i = d[j] + 1; i < n; i++)
            {
                a[i][j] = (a[i - 1][j] + 1) % 10;
            }
            for (int i = d[j] - 1; i >= 0; i--)
            {
                a[i][j] = (a[i + 1][j] - 1 + 10) % 10;
            }
        }
        else
        {
            for (int i = d[j] + 1; i < n; i++)
            {
                if (a[i][j + 1] != a[i - 1][j + 1] && !a[i][j + 1])
                    a[i][j] = (a[i - 1][j] + 1) % 10;
                else
                    a[i][j] = a[i - 1][j];
            }
            for (int i = d[j] - 1; i >= 0; i--)
            {
                if (a[i][j + 1] != a[i + 1][j + 1] && !a[i + 1][j + 1])
                    a[i][j] = (a[i + 1][j] - 1 + 10) % 10;
                else
                    a[i][j] = a[i + 1][j];
            }
        }
    }
//    forn (i, n)
//    {
//        forn (j, m)
//        {
//            printf("%d", a[i][j]);
//        }
//        printf("\n");
//    }
    forn (j, m)
    {
        printf("%d", a[0][j]);
    }
    return 0;
}
