#include <iostream>
#include <vector>

using namespace std;

#define hmax 100

struct sotr
{
    int ow;
    vector <int> ch[hmax];
};

int n,s=0;
vector <sotr> a,b;
sotr t;

void addme(int i, int ow, vector <sotr> &m)
{
    m[ow].ch[i%hmax].push_back(i);
    if (m[ow].ow!=0)
            addme(i,m[ow].ow,m);
}

bool hfind(int k, int j)
{
    for (int i=0; i<b[j].ch[k%hmax].size(); ++i)
        if (b[j].ch[k%hmax][i]==k)
            return true;
    return false;
}

int main()
{
    cin >>n;
    a.push_back(t);//ZERO
    b.push_back(t);//ZERO
    // TREE A - ANTIVIRUS
    for (int i=1; i<=n; ++i)
    {
        cin >>t.ow;
        a.push_back(t);
    }
    for (int i=1; i<=n; ++i)
    {
        if (a[i].ow!=0)
            addme(i,a[i].ow,a);
    }
    // TREE B - VIRUS
    for (int i=1; i<=n; ++i)
    {
        cin >>t.ow;
        b.push_back(t);
    }
    for (int i=1; i<=n; ++i)
    {
        if (b[i].ow!=0)
            addme(i,b[i].ow,b);
    }
    // HASH FINDER
    for (int i=1; i<=n; ++i)
    {
        for (int j=0; j<hmax; ++j)
            for (int k=0; k<a[i].ch[j].size(); ++k)
                if (hfind(a[i].ch[j][k],i))
                    ++s;
    }
    cout <<s;
}
