#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define hmax 10

struct sotr
{
    int ow,noch;
    vector <int> ch[hmax];
};

int n,s=0;
vector <sotr> a,b;
sotr t;

void addme(int i, int ow, vector <sotr> &m)
{
    m[ow].ch[i%hmax].push_back(i);
    m[ow].noch++;
    if (m[ow].ow!=0)
            addme(i,m[ow].ow,m);
}

bool hfind(int k, int j)
{
    for (int i=0; i<b[j].ch[k%hmax].size() && b[j].ch[k%hmax][i]<=k; ++i)
        if (b[j].ch[k%hmax][i]==k)
            return true;
    return false;
}

int main()
{
    t.noch=0;
    ifstream in;
    ofstream out;
    in.open("virus.in");
    out.open("virus.out");
    in >>n;
    a.push_back(t);//ZERO
    b.push_back(t);//ZERO
    // TREE A - ANTIVIRUS
    for (int i=1; i<=n; ++i)
    {
        in >>t.ow;
        a.push_back(t);
    }
    for (int i=1; i<=n; ++i)
    {
        if (a[i].ow!=0)
            addme(i,a[i].ow,a);
    }
    // TREE B - VIRUS
    for (int i=1; i<=n; ++i)
    {
        in >>t.ow;
        b.push_back(t);
    }
    for (int i=1; i<=n; ++i)
    {
        if (b[i].ow!=0)
            addme(i,b[i].ow,b);
    }
    // HASH FINDER
    for (int i=1; i<=n; ++i)
    {
        for (int j=0; j<hmax && a[i].noch!=0; ++j)
            for (int k=0; k<a[i].ch[j].size() && a[i].noch!=0; ++k)
            {
                if (hfind(a[i].ch[j][k],i))
                    ++s;
                a[i].noch--;
            }
    }
    out <<s;
}
