#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <vector>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

typedef long long int64;

int ain[100100], aout[100100], bin[100100], bout[100100];
int cnt;
vector<int> a[100100], b[100100];

void dfsa(int v) {
	ain[v] = cnt++;
	forv (i, a[v]) {
		dfsa(a[v][i]);
	}
	aout[v] = cnt++;
}

void dfsb(int v) {
	bin[v] = cnt++;
	forv (i, b[v]) {
		dfsb(b[v][i]);
	}
	bout[v] = cnt++;
}

int main() {
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	int n;
	cin >> n;
	int ra = 0;
	forn (i, n) {
		int x;
		cin >> x;
		if (x) {
			a[x - 1].pb(i);
		} else {
			ra = i;
		}
	}
	int rb = 0;
	forn (i, n) {
		int x;
		cin >> x;
		if (x) {
			b[x - 1].pb(i);
		} else {
			rb = i;
		}
	}
	cnt = 0;
	dfsa(ra);
	cnt = 0;
	dfsb(rb);
	int64 ans = 0;
	forn (i, n) {
		forn (j, n) {
			if (ain[i] < ain[j] && aout[j] < aout[i] &&
				bin[i] < bin[j] && bout[j] < bout[i]) {
				++ans;
			}
		}
	}
	cout << ans;
}
