#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <vector>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

typedef long long int64;

int in[100100], out[100100];
int cnt;
vector<int> a[100100], b[100100];
int64 ans = 0;
int t[1000100];
int n;

void dfsio(int v) {
	in[v] = cnt++;
	forv (i, a[v]) {
		dfsio(a[v][i]);
	}
	out[v] = cnt++;
}

int get(int v, int l, int r, int i) {
	if (l < r - 1) {
		t[v << 1] += t[v];
		t[(v << 1) + 1] += t[v];
		t[v] = 0;
		if (i < ((l + r) >> 1)) {
			return get(v << 1, l, ((l + r) >> 1), i);
		} else {
			return get((v << 1) + 1, ((l + r) >> 1), r, i);
		}
	}
	return t[v];
}

void add(int v, int L, int R, int l, int r, int x) {
	if (r <= L || R <= l) {
		return;
	}
	if (l <= L && R <= r) {
		t[v] += x;
		return;
	}
	add(v << 1, L, (L + R) >> 1, l, r, x);
	add((v << 1) + 1, (L + R) >> 1, R, l, r, x);
}

void dfs(int v) {
	ans += get(1, 0, 2 * n, in[v]);
	add(1, 0, 2 * n, in[v], out[v], 1);
	forv (i, b[v]) {
		dfs(b[v][i]);
	}
	add(1, 0, 2 * n, in[v], out[v], -1);
}

int main() {
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
	cin >> n;
	int ra = 0;
	forn (i, n) {
		int x;
		cin >> x;
		if (x) {
			a[x - 1].pb(i);
		} else {
			ra = i;
		}
	}
	int rb = 0;
	forn (i, n) {
		int x;
		cin >> x;
		if (x) {
			b[x - 1].pb(i);
		} else {
			rb = i;
		}
	}
	cnt = 0;
	dfsio(ra);
	forn (i, 1000100) {
		t[i] = 0;
	}
	dfs(rb);
	cout << ans;
}
