#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <ctime>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define mp make_pair
#define fs first
#define sc second
#define pb push_back

int a[100100], b[100100];
int n;
pair<pair<int, int>, int> mna[20][100100], mxa[20][100100], mnb[20][100100], mxb[20][100100];

void build() {
	forn (i, n) {
		mna[0][i] = mxa[0][i] = mp(mp(a[i], b[i]), i);
		mnb[0][i] = mxb[0][i] = mp(mp(b[i], a[i]), i);
	}
	int p = 1;
	forn (j, 17) {
		forn (i, n) {
			if (i + p < n) {
				mna[j + 1][i] = min(mna[j][i], mna[j][i + p]);
				mnb[j + 1][i] = min(mnb[j][i], mnb[j][i + p]);
				mxa[j + 1][i] = max(mxa[j][i], mxa[j][i + p]);
				mxb[j + 1][i] = max(mxb[j][i], mxb[j][i + p]);
			} else {
				mna[j + 1][i] = mna[j][i];
				mnb[j + 1][i] = mnb[j][i];
				mxa[j + 1][i] = mxa[j][i];
				mxb[j + 1][i] = mxb[j][i];
			}
		}
		p <<= 1;
	}
}

int main() {
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	scanf("%d", &n);
	forn (i, n) {
		scanf("%d %d", &a[i], &b[i]);
	}
	build();
	int k;
	scanf("%d", &k);
	forn (i, k) {
		int x, y;
		scanf("%d %d", &x, &y);
		--x;
		int lg = 0, pw = 1;
		while (y - x >= (pw << 1)) {
			++lg;
			pw <<= 1;
		}
		pair<pair<int, int>, int> p[4];
		p[0] = min(mna[lg][x], mna[lg][y - pw]);
		p[1] = min(mnb[lg][x], mnb[lg][y - pw]);
		p[2] = max(mxa[lg][x], mxa[lg][y - pw]);
		p[3] = max(mxb[lg][x], mxb[lg][y - pw]);
		swap(p[1].fs.fs, p[1].fs.sc);
		swap(p[3].fs.fs, p[3].fs.sc);
		bool was = false;
		forn (i, 4) {
			forn (j, i) {
				if (p[i].sc != p[j].sc && p[i].fs.fs != p[j].fs.fs && p[i].fs.sc != p[j].fs.sc) {
					printf("%d %d\n", p[i].sc + 1, p[j].sc + 1);
					was = true;
					break;
				}
			}
			if (was) {
				break;
			}
		}
		if (!was) {
			printf("0 0\n");
		}
	}
//	cerr << clock();
}
