#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

vector <int> c1[100100], c2[100100];
int uk;
int st[100100], ans[2100][2100];

void dfs1(int v)
{
    int q = c1[v].size();
    for (int i = 1; i <= uk; i++)
        ans[st[i]][v]++;
    for (int i = 0; i < q; i++)
    {
        uk++;
        st[uk] = v;
        dfs1(c1[v][i]);
        uk--;
    }
}

void dfs2(int v)
{
    int q = c2[v].size();
    for (int i = 1; i <= uk; i++)
        ans[st[i]][v]++;
    for (int i = 0; i < q; i++)
    {
        uk++;
        st[uk] = v;
        dfs2(c2[v][i]);
        uk--;
    }
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    int n, boss1, boss2;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int q;
        cin >> q;
        if (q == 0) boss1 = i;
        c1[q].push_back(i);
    }
    for (int i = 1; i <= n; i++)
    {
        int q;
        cin >> q;
        if (q == 0) boss2 = i;
        c2[q].push_back(i);
    }
    dfs1(boss1);
    dfs2(boss2);
    int anss = 0;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            if (ans[i][j] == 2) anss++;
    cout << anss;
    return 0;
}
