#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

vector <int> c;
int a[100100], b[100100], use1[100100], use2[100100];

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n, k;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i] >> b[i];
        c.push_back(a[i]);
        c.push_back(b[i]);
    }
    sort(c.begin(), c.end());
    c.erase(unique(c.begin(), c.end()), c.end());
    for (int i = 1; i <= n; i++)
    {
        a[i] = lower_bound(c.begin(), c.end(), a[i]) - c.begin();
        b[i] = lower_bound(c.begin(), c.end(), b[i]) - c.begin();
    }
    int ug = c.size();
    cin >> k;
    for (int i = 1; i <= k; i++)
    {
        int l, r, p = 0;
        cin >> l >> r;
        for (int j = 0; j < ug; j++)
            use1[j] = 0, use2[j] = 0;
        use1[a[l]] = 1, use2[b[l]] = 1;
        for (int j = l + 1; j <= r; j++)
            if (use1[a[j]] ==0 && use2[b[j]] == 0) p = j;
        if (!p) printf("0 0\n"); else printf("%d %d\n", l, p);
    }
    return 0;
}
