
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

vector <int> c;
int a[100100], b[100100], dp[100100];

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n, k;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i] >> b[i];
        c.push_back(a[i]);
        c.push_back(b[i]);
    }
    sort(c.begin(), c.end());
    c.erase(unique(c.begin(), c.end()), c.end());
    for (int i = 1; i <= n; i++)
    {
        a[i] = lower_bound(c.begin(), c.end(), a[i]) - c.begin();
        b[i] = lower_bound(c.begin(), c.end(), b[i]) - c.begin();
    }
    for (int i = 1; i <= n; i++)
        for (int j = i + 1; j <= n; j++)
            if (a[i] != a[j] && b[i] != b[j])
            {
                dp[i] = j;
                break;
            }
    cin >> k;
    for (int i = 1; i <= k; i++)
    {
        int l, r, p = 0;
        cin >> l >> r;
        for (int j = l; j <= r; j++)
            if (dp[j] <= r && !p && dp[j] != 0)
            {
                printf("%d %d\n", j, dp[j]);
                p = 1;
            }
        if (!p) printf("0 0\n");
    }
    return 0;
}
