#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <algorithm>
using namespace std;

string a, b;

int length(int x)
{
    int len = 0;
    if (x == 0)
        return 1;
    while (x != 0)
    {
        len++;
        x/=10;
    }
    return len;
}

string str(int x)
{
    if (x == 0)
      return ("0");
    string s = "";
    while (x != 0)
    {
        s += (x%10 + '0');
        x/=10;
    }
    reverse(s.begin(), s.end());
    return s;
}

bool is_eq(int L, int R, int sum)
{
    //for (int i = 0; i < L; ++i)
    //     if (a[i] != b[i]) return false;
    string s = str(sum);
    for (int i = L; i < L + s.size(); ++i)
        if (b[i] != s[i - L]) return false;
    for (int i = 0; i + R + 1 < a.size(); ++i)
        if (a[R + i + 1] != b[L + s.size() + i]) return false;
    return true;
}
int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);

    getline(cin, a);
    getline(cin, b);
    if (a == b)
    {
        printf("1 1");
        return 0;
    }
    int prev = 0;
    for (int i = 0; i < a.size(); ++i)
    {
        int sum = 0;
        int ten = 10;
        int sum_len = 1;
        for (int j = i; j < prev; ++j)
        {
            sum += a[j] - '0';
             if (sum >= ten)
             {
                 sum_len++;
                 ten*=10;
             }
        }
        int cprev = -1;
        for (int j = prev; j < a.size(); ++j)
        {
             sum += a[j] - '0';
             if (sum >= ten)
             {
                 sum_len++;
                 ten*=10;
             }
             if (b.size() < a.size() - (j - i + 1) + sum_len) continue;
             if (b.size() > a.size() - (j - i + 1) + sum_len) break;
             if (b.size() == a.size() - (j - i + 1) + sum_len)
             {
                 if (cprev == -1) cprev = j;
                 if (is_eq(i, j, sum))
                    {
                        printf("%d %d", i + 1, j + 1);
                        return 0;
                    }
             }
        }
        prev = cprev;
    }
    return 0;
}
