#include <iostream>
#include <cstdio>
#include <set>
#include <cstdlib>
#include <vector>
using namespace std;

const int maxN = 100000 + 100;
int p1[maxN], p2[maxN];
int ans;
set<int> used;
int n;
int root1;
vector<int> child[maxN];
void run2(int v)
{
    if (v == -1) return;
    if (used.find(v) != used.end()) ans++;
    run2(p2[v]);
}

void run1(int v)
{
    used.insert(v);
    for (int i = 0; i < child[v].size(); ++i)
    {
        int to = child[v][i];
        run2(to);
        run1(to);
    }
    used.erase(v);
}


int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &p1[i]);
        p1[i]--;
        if (p1[i] == -1)
             root1 = i;
        else
            child[p1[i]].push_back(i);

    }
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &p2[i]);
        p2[i]--;
    }
    run1(root1);
    printf("%d", ans);
    return 0;
}
