#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <map>
#include <vector>

using namespace std;

const int maxN = 100000 + 100;
vector<int> nh[maxN];
int n, k;
int h[maxN], w[maxN];
int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d%d", &h[i], &w[i]);

    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
        {
            if (h[i] != h[j] && w[i] != w[j])
            {
                nh[i].push_back(j);
                nh[j].push_back(i);
            }
        }

    scanf("%d", &k);
    for (int i = 0; i < k; ++i)
    {
        int L, R;
        scanf("%d%d", &L, &R);
        bool ok = true;
        for (int j = L - 1; j < R; ++j)
        {
            if (!ok) break;
            for (int it = 0; it < nh[j].size(); ++it)
            {
                if (nh[j][it] > L - 1 && nh[j][it] < R)
                {
                    ok = false;
                    printf("%d %d\n", j + 1, nh[j][it] + 1);
                    break;
                }
            }
        }
        if (ok)
            printf("0 0\n");
    }
    return 0;
}
