#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <map>
#include <vector>

using namespace std;

const int maxN = 100000 + 100;
int n, k;
int h[maxN], w[maxN];
int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d%d", &h[i], &w[i]);


    scanf("%d", &k);
    for (int it = 0; it < k; ++it)
    {
        int L, R;
        scanf("%d%d", &L, &R);
        L--, R--;
        bool ok1 = true, ok2 = true;
        int p1, p2;
        int he = h[L], we = w[L];
        for (int i = L; i <= R; ++i)
            if (h[i] != he)
            {
                ok1 = false;
                p1 = i;
                break;
            }
        for (int i = L; i <= R; ++i)
            if (w[i] != we)
            {
                ok2 = false;
                p2 = i;
                break;
            }
        if (ok1 || ok2)
            printf("0 0\n");
        else
        {
            bool printed = false;
            for (int i = L + 1; i <= R; ++i)
            {
                if (he != h[i] && we != w[i])
                {
                    printf("%d %d\n", L + 1, i + 1);
                    printed = true;
                    break;
                }
            }
            if (printed) continue;
            for (int i = L + 1; i <= R; ++i)
            {
                if (h[i] == he && w[i] != we)
                    p1 = i;
                if (h[i] != he && w[i] == we)
                    p2 = i;
            }
            printf("%d %d\n", p1 + 1, p2 + 1);
        }
    }
    return 0;
}
