#include <iostream>
#include <cstdio>

using namespace std;

const int maxN = 20;

bool used[maxN], u[maxN];
int d[maxN], a[maxN];
long long ans = 0;
int prev = -1;
int n, k;

void check()
{
    //   ,  ,    -- 
    int max_len = -1;
    for (int i = 0; i < n; ++i)
    {
        d[i] = 1;
        for (int j = 0; j < i; ++j)
        if (a[i] > a[j])
          d[i] = max(d[i], d[j] + 1);
        max_len = max(max_len, d[i]);
    }
    if (max_len > k) return;
    ans++;
}

void run(int pos)
{
    if (pos == n)
        check();
    else
    {
        for (int i = 0; i < n; ++i)
            if (!used[i])
            {
                if (prev != -1 && u[i] && prev > i) continue;
                int buf = prev;
                if (u[i]) prev = i;
                used[i] = true;
                a[pos] = i;
                run(pos + 1);
                prev = buf;
                used[i] = false;
            }
    }
}
int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
    scanf("%d%d", &n, &k);
    for (int i = 0; i < k; ++i)
    {
        int tmp;
         scanf("%d", &tmp);
         u[tmp - 1] = true;
    }
    //sort(tmp, tmp + k);
    run(0);
    cout << ans;
    return 0;
}
