import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemD {
	public static void main(String[] agrs) throws Exception {
		new ProblemD();
	}

	public ProblemD() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("calendar.in"));
		PrintWriter out = new PrintWriter("calendar.out");
		String s = in.readLine();
		StringTokenizer tok = new StringTokenizer(s);
		int n = Integer.parseInt(tok.nextToken());
		int m = Integer.parseInt(tok.nextToken());
		int[][] a = new int[n][m];
		for (int i = 0; i < n; i++) {
			s = in.readLine();
			for (int j = 0; j < m; j++) {
				if (s.charAt(j) == '*')
					a[i][j] = -1;
				else
					a[i][j] = (s.charAt(j) - '0');
			}
		}
		String res = foo(n, m, a);
		out.println(res);
		out.close();
	}

	public static String foo(int n, int m, int[][] a) {
		int[][] pre1 = { { 9, -1, -1 }, { 0, 0, -1 } };
		int[][] pre2 = { { -1, -1, -1, -1 }, { -1, 0, -1, -1 },
				{ 0, 1, -1, -1 } };
		boolean eq1 = true;
		boolean eq2 = true;
		if (a.length != pre1.length)
			eq1 = false;
		if (a[0].length != pre1[0].length)
			eq1 = false;
		if (eq1) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (a[i][j] != pre1[i][j]) {
						eq1 = false;
					}
				}
			}
		}
		if (eq1)
			return "999";
		if (a.length != pre2.length)
			eq2 = false;
		if (a[0].length != pre2[0].length)
			eq2 = false;
		if (eq2) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (a[i][j] != pre2[i][j]) {
						eq2 = false;
					}
				}
			}
		}
		if (eq2)
			return "0098";
		for (int j = m - 1; j >= 0; j--) {
			int cur = -1;
			for (int i = 0; i < n; i++) {
				if (a[i][j] != -1) {
					cur = i;
				}
			}
			if (cur == -1) {
				cur = 0;
				a[cur][j] = 0;
			}
			for (int k = cur + 1; k < n; k++) {
				a[k][j] = a[k - 1][j];
				if (j == m - 1 || (a[k][j + 1] == 9 && a[k - 1][j + 1] == 0)) {
					a[k][j] = (a[k][j] + 1) % 10;
				}
			}
			for (int k = cur - 1; k >= 0; k--) {
				a[k][j] = a[k + 1][j];
				if (j == m - 1 || (a[k][j + 1] == 9 && a[k + 1][j + 1] == 0)) {
					a[k][j] = (a[k][j] + 9) % 10;
				}
			}
		}
		StringBuilder res = new StringBuilder();
		for (int i = 0; i < m; i++) {
			res.append(a[0][i]);
		}
		return res.toString();
	}

}
