import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemB {
	public static void main(String[] args) throws Exception {
		new ProblemB();
	}

	public ProblemB() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("theatre.in"));
		PrintWriter out = new PrintWriter("theatre.out");
		StringTokenizer tok = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(tok.nextToken());
		int m = Integer.parseInt(tok.nextToken());
		int[][] aWas = new int[m][n];
		int[] aWasL = new int[m];
		int[][] aWasNt = new int[m][n];
		int[] aWasNtL = new int[m];
		boolean[][] was = new boolean[m][n];
		for (int i = 0; i < m; i++) {
			tok = new StringTokenizer(in.readLine());
			aWasL[i] = Integer.parseInt(tok.nextToken());
			aWasNtL[i] = n - aWasL[i];
			for (int j = 0; j < aWasL[i]; j++) {
				int v = Integer.parseInt(tok.nextToken()) - 1;
				aWas[i][j] = v;
				was[i][v] = true;
			}
			int next = 0;
			for (int j = 0; j < n; j++) {
				if (!was[i][j]) {
					aWasNt[i][next] = j;
					next++;
				}
			}
		}
		int[] res = new int[n];
		int[] deg = new int[n];
		Arrays.fill(deg, n);
		boolean[][] canntBe = new boolean[n][n];
		for (int i = 0; i < m; i++) {
//			System.out.println("scene " + (i + 1));
			for (int j = 0; j < aWasL[i]; j++) {
				int v = aWas[i][j];
//				System.out.println("man " + (v + 1) + " ");
				for (int k = 0; k < aWasNtL[i]; k++) {
					int u = aWasNt[i][k];
//					System.out.println("    man " + (u + 1));
					if (!canntBe[v][u]) {
//						System.out.println("    cannt be");
						deg[v]--;
						deg[u]--;
						canntBe[v][u] = true;
						canntBe[u][v] = true;
						if (deg[v] == 1) {
							res[v] = i + 1;
						}
						if (deg[u] == 1) {
							res[u] = i + 1;
						}
					}
				}
			}
		}
		for (int i = 0; i < n; i++) {
			out.print(res[i] + " ");
		}
		out.println();
		out.close();
	}
}
