#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define ll long long

int time;

void solve(vector<vector<int>> & g, vector<int> & start, vector<int> & end, int cur){
	start[cur] = time++;
	int len = g[cur].size();
	for(int i = 0; i < len; ++i)
		solve(g, start, end, g[cur][i]);
	end[cur] = time++;
}

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);
#endif
	int n, a;
	cin >> n;
	vector<vector<int>> g1(n, vector<int>()), g2(n, vector<int>());
	int root1, root2;
	for(int i = 0; i < n; ++i){
		cin >> a;
		if(a)
			g1[a - 1].push_back(i);
		else
			root1 = i;
	}
	for(int i = 0; i < n; ++i){
		cin >> a;
		if(a)
			g2[a - 1].push_back(i);
		else
			root2 = i;
	}
	vector<int> start1(n, -1), start2(n, -1), end1(n, -1), end2(n, -1);
	solve(g1, start1, end1, root1);
	solve(g2, start2, end2, root2);
	int ans = 0;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			if(start1[i] > start1[j] && start1[i] < end1[j] && start2[i] > start2[j] && start2[i] < end2[j])
				++ans;
	cout << ans;
	return 0;
}