#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define ll long long

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("apricot.in", "rt", stdin);
	freopen("apricot.out", "wt", stdout);
#endif
	ll n, r, u;
	cin >> n >> r >> u;
	vector<ll> dp(2 * n + 3, 0);
	dp[0] = 0;
	dp[1] = u;
	dp[2] = max(r, u);
	for(int i = 4; i <= n; ++i){
		dp[i - 1] = INT_MAX;
		for(int j = 1; 2 * j < i; ++j)
			dp[i - 1] = min(dp[i - 1], max(dp[j - 1] + u, ((i - 2 * j) ? dp[i - 2 * j - 1] + r : 0)));
	}
	cout << dp[n - 1];
	return 0;
}