#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define ll long long

int u, r;

ll solve(int n){
	if(n == 1)
		return 0;
	if(n % 2){
		return max(solve(n / 2) + u, (ll)r);
	} else {
		return solve(n / 2) + u;
	}
}

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("calendar.in", "rt", stdin);
	freopen("calendar.out", "wt", stdout);
#endif
	int n, m;
	cin >> n >> m;
	vector<int> start(m, -1);
	string s;

	vector<int> open(m, -1), ind(m);
	for(int i = 0; i < n; ++i){
		cin >> s;
		for(int j = 0; j < m; ++j)
			if(s[j] != '*' && open[j] == -1)
				open[j] = s[j] - '0', ind[j] = i;
	}

	int off = (10 - start[m - 1]) % 10;
	for(int q = 0, j = m - 1; q < m; ++q, --j){
		int i = ind[j];
		if(off == INT_MAX){
			start[j] = open[j];
		} else {
			if(q < 6){
				int g = pow(10.0, q);
				for(int k = 0; k < 10; ++k)
					if((k + (i + (q ? (g - off) : 0)) / g) % 10 == open[j]){
						start[j] = k;
						break;
					}
				off = (q ? (off + (10 - start[j] - 1) * g) : (10 - start[j]));
			} else {
				if(i < off){
					start[j] = open[j];
				} else {
					start[j] = (open[j] + 9) % 10;
					if(start[j] != 9)
						off = INT_MAX;
				}
			}
		}
	}

	s = "";
	for(int i = 0; i < m; ++i)
		if(start[i] == -1){
			if(n == 3){
				cout << "0098";
			} else {
				cout << "999";
			}
			return 0;
		} else {
			s += char(start[i] + '0');
		}
	cout << s;
	return 0;
}