#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);
#endif
	int n, m;
	scanf("%d%d", &n, &m);

	map<int, set<int>> plays_count;
	for(int i = 0; i < n; ++i)
		plays_count[0].insert(i);
	vector<int> played(n, 0);
	set<int> cur_one;
	vector<bool> used(n, 0);
	vector<int> ans(n, 0);

	for(int i = 0; i < m; ++i){
		cur_one.clear();
		int k, a;
		scanf("%d", &k);
		for(int j = 0; j < k; ++j){
			scanf("%d", &a), --a;
			if(used[a])
				continue;

			plays_count[played[a]].erase(a);
			if(plays_count[played[a]].size() == 1){
				cur_one.insert(*plays_count[played[a]].begin());
			} else if(plays_count[played[a]].size() == 0){
				cur_one.erase(a);
			}

			++played[a];
			plays_count[played[a]].insert(a);
			if(plays_count[played[a]].size() == 1){
				cur_one.insert(a);
			} else if(plays_count[played[a]].size() == 2){
				if(*plays_count[played[a]].begin() == a)
					cur_one.erase(*plays_count[played[a]].rbegin());
				else
					cur_one.erase(*plays_count[played[a]].begin());
			}
		}
		for(auto j = cur_one.begin(); j != cur_one.end(); ++j){
			ans[*j] = i + 1;
			used[*j] = 1;
			plays_count[played[*j]].erase(*j);
		}
	}
	
	for(int i = 0; i < n; ++i)
		printf("%d ", ans[i]);
	return 0;
}