#include <cstdio>
#include <iostream>

using namespace std;

int sum[100100];

int len(int a) {
	if (a==0) return 1;
	int x = 0;
	while(a>0) { a/= 10; x++; }
	return x;
}

int symb(int a, int pos) {
	for (int i = 0; i<pos; i++) a/= 10;
	return a%10;
}

int main() {
	freopen("password.in","r",stdin);
	freopen("password2.out","w",stdout);
	string s1,s2;
	cin >> s1 >> s2;
	int l1,l2;
	l1 = s1.length();
	l2 = s2.length();
	int l,r;
	sum[0] = s1[0]-'0';
	for (l = 1; l<l1; l++) {
		sum[l] = sum[l-1] + s1[l]-'0';
	}
	int tpos = -1;
	for (int i = 0; i<l1; i++) {
		if (s1[i]!=s2[i]) { tpos = i; break; }
	}                    

	int sum_x;
	int l_ans = 0;
	int r_ans = 0;
	for (l = 0; l<l2; l++) {
		int k = 0;
		for (r = 0; r<5; r++) {
			if (l+r>l2-1) break;
			k = k*10 + s2[l+r]-'0';
			if (r>0 && s2[l]=='0') break; 
			int tl = l-1;
			int tr = l1;
			while(tl<tr-1) {
				int tm = (tl+tr)/2;
				if (l>0) sum_x = sum[tm]-sum[l-1];
				else sum_x = sum[tm];
				if (sum_x > k) tr = tm;
				else tl = tm;
			}
			if (l>0) sum_x = sum[tl]-sum[l-1];
			else sum_x = sum[tl];
			tr = tl;
			while(s1[tr]=='0') {
				if (sum_x==k && l1-tr==l2-l-r && (tpos==-1 || (tpos>=l && tpos<=tr))) {
					cout << l+1 << " " << tr+1 << endl;
					//cout << "!";
					return 0;                                                 
				}
				tr--;
			}
			if (sum_x==k && l1-tr==l2-l-r && (tpos==-1 || (tpos>=l && tpos<=tr))) {
				cout << l+1 << " " << tr+1 << endl;
				//cout << "!";
				return 0;                                                 
			}
		}
	}

	cout << l_ans+1 << " " << r_ans+1 << endl;
	return 0;

}
