#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

#define N 1000010
#define INF (ll)(1e18)

int n, u, r;
ll dp[N];

void read() {
	scanf("%d%d%d", &n, &r, &u);
}

void count_it() {
	dp[0] = 0;
	dp[1] = 0;
	for (int i = 2; i <= n; i++) {
		dp[i] = INF;
		for (int num = 1; 2 * num <= i; num++) {
			int carr = i - 2 * num;
			if (carr == 0) {
				dp[i] = min(dp[i], u + dp[num]);
				continue;
			}
			ll ans = max(r + dp[carr], u + dp[num]);
			dp[i] = min(dp[i], ans);
		}
	}
	printf("%I64d\n", dp[n]);
//	for (int i = 0; i <= n; i++)
//		printf("%d ", dp[i]);
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	read();
	count_it();
	return 0;
}
