#include <cstdio>
#include <iostream>

using namespace std;

#define N 100010

struct pnt {
	int x, y;
	void read() {
		scanf("%d%d", &x, &y);
	}
	void write() {
		printf("%d %d\n", x, y);
	}

};

int n, k;
pnt ps[N];
int brcs[N], pref[N];

void read() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		ps[i].read();
}

int check(pnt &p1, pnt &p2, pnt &p3) {
	if (p1.x == p2.x && p3.x == p2.x)
		return 0;
	if (p1.y == p2.y && p3.y == p2.y)
		return 0;
	return 1;		 
}

void prec() {
	for (int i = 1; i < n - 1; i++)
		brcs[i] = check(ps[i - 1], ps[i], ps[i + 1]);
	for (int i = 1; i < n; i++)
		pref[i] = pref[i - 1] + brcs[i];
}

int bin_search(int l, int r) {
	while (r - l > 1) {
		int m = (r + l + 1) / 2;
		if (pref[r] - pref[m] > 0)
			l = m;
		else
			r = m;
	}
	return r;
}

void do_it() {
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		int l, r;
		scanf("%d%d", &l, &r);
		r -= 2, l--;
		if (pref[r] - pref[l] == 0) {
			printf("0 0\n");
			continue;
		}
		int c;
		c = bin_search(l, r);
		printf("%d %d\n", c, c + 2);
	}
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	read();
	prec();
	do_it();
	return 0;
}
