#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

struct pnt {
	int x, y;
	pnt() {}
	pnt(int mx, int my) {
		x = mx, y = my;
	}
	void read() {
		scanf("%d %d\n", &x, &y);
	}
};

struct area {
	pnt p1, p2;
};

struct horse {
	area cst, cbe;
	pnt d;
};

pnt operator + (pnt p1, pnt p2) {
	p1.x += p2.x;
	p1.y += p2.y;
	return p1;
}

pnt operator * (int l, pnt p) {
	p.x *= l;
	p.y *= l;
	return p;
}

area operator + (pnt p, area a) {
	a.p1 = a.p1 + p;
	a.p2 = a.p2 + p;
	return a;
}

bool operator == (pnt a, pnt b) {
	return a.x == b.x && a.y == b.y;
}

pnt get_aver(area a) {
	a.p1 = a.p1 + a.p2;
	a.p1.x /= 2;
	a.p1.y /= 2;
	return a.p1;
}

int n, m;
pnt e;
horse h;

area cut(area &a) {
	a.p1.x = max(1, a.p1.x);
	a.p1.x = min(m, a.p1.x);
	a.p2.x = max(1, a.p2.x);
	a.p2.x = min(m, a.p2.x);
	a.p1.y = max(1, a.p1.y);
	a.p1.y = min(n, a.p1.y);
	a.p2.y = max(1, a.p2.y);
	a.p2.y = min(n, a.p2.y);
}

int dist(pnt p1, pnt p2) {
	return max(abs(p1.x - p2.x), abs(p1.y - p2.y));
}

void read_n_init() {
	scanf("%d %d", &n, &m);
	scanf("%d %d", &e.x, &e.y);
	h.cst.p1.x = 1;
	h.cst.p2.x = m;
	h.cst.p1.y = 1;
	h.cst.p2.y = n;
	h.cbe = h.d + h.cst;
}


void do_horse(pnt dh, horse &h) {
	h.d = h.d + dh;
	h.cbe = h.d + h.cst;
	cut(h.cbe);
	h.cst = ((-1) * h.d) + h.cbe;
}

void do_it() {
	int luck;
	while (1) {
		pnt aver;
		aver = get_aver(h.cbe);
		pnt de;
		int mmin = -1;
		pnt ans;
		for (de.x = -1; de.x < 2; de.x++)
			for (de.y = -1; de.y < 2; de.y++) {
				if (mmin == -1 || dist(aver, de) < mmin) {
					mmin = dist(aver, de);
					ans = de;
				}
			}
		e = e + de;
		if (h.cbe.p1 == h.cbe.p2 && h.cbe.p1 == e)
			printf("%d %d 1\n", de.x, de.y);
		else
			printf("%d %d 0\n", de.x, de.y);
		fflush(stdout);
		
		pnt dh; 	
		scanf("%d %d %d", luck, dh.x, dh.y);
		if (luck)
			return;
		do_horse(dh, h);
	}
}

int main() {
    read_n_init();
    do_it();
	return 0;
}
