#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;

#define pb push_back
#define sz(a) (int)a.size()
#define zero(a) memset (a, 0, sizeof(a))
#define mp make_pair

#define taskname "sideslip"

long double solve (long double v, long double a, long double x)
{
  if (((long double)2.0)*x*a<=v*v)
    return sqrt(((long double)2.0)*x/a);
  return (v/a)+(x-(v*v/(((long double)2.0)*a)))/v;
}

int main (void)
{
  double v, x, y, a, b;
  assert(freopen(taskname".in", "r", stdin));
  freopen (taskname".out", "w", stdout);
  assert(scanf("%lf%lf%lf%lf%lf", &v, &x, &y, &a, &b)==5);
  assert(v>=1.0 && x>=1.0 && y>=1.0 && a>=1.0 && b>=1.0 && v<=1000000.0 && x<=1000000.0 && y<=1000000.0 && a<=1000000.0 && b<=1000000.0);
  printf("%.10lf\n", (double)(solve(v,b,x)+solve(v,a,y)));
  return 0;
}

