#include <iostream>
#include <vector>
using namespace std;

const int N = 30;
long long c[N + 1];
int res[N];

void restore(int p, int l, int r, long long k) {
	if (l > r) return;
	for (int q = l; q <= r; ++q) {
		long long cnt = c[q - l] * c[r - q];
		if (p == 0) cerr << cnt << endl;
		if (cnt <= k) k -= cnt; else {
			res[p] = q;
			restore(p + 1, l, q - 1, k / c[r - q]);
			restore(p + q - l + 1, q + 1, r, k % c[r - q]);
			break;
		}
	}
}

int main() {
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
	int n;
	long long k;
	cin >> n >> k;
	k--;
	c[0] = 1;
	for (int i = 1; i <= n; cerr << c[i] << " ", ++i)
		for (int j = 0; j < i; ++j)
			c[i] += c[j] * c[i - 1 - j];
	if (k >= c[n])
		printf("-1");
	else {
		restore(0, 0, n - 1, k);
		for (int i = 0; i < n; ++i)
			printf("%d ", res[i] + 1);
		printf("\n");
	}
	return 0;
}
