#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;

#define pb push_back
#define sz(a) (int)a.size()
#define zero(a) memset (a, 0, sizeof(a))
#define mp make_pair

#define taskname "trains"

int n;
ll k;
ll dp[35];


void gen(int n,int from,ll k){
	assert( k < dp[n]);
	if (n == 0)
		return;
	for (int i = 0; i < n; i++)
		if (k < dp[i] * dp[n-i-1]){
			 printf("%d ",i+from);
			 gen(i,from,k/dp[n-i-1]);
			 gen(n-i-1,from+i+1,k%dp[n-i-1]);
			 return;
		}
		else
			k -= dp[i] * dp[n-i-1];
	assert(false);
}

int main (void)
{
  assert(freopen (taskname".in", "r", stdin));
  freopen (taskname".out", "w", stdout);

  assert(cin >> n >> k);
  assert(1 <= n && n <= 30);
  assert(1 <= k && k <= 1000000LL*1000000LL*1000000LL);

  dp[0] = 1;
  dp[1] = 1;
  for (int i = 2; i <= n; i++){
      for (int j = 0; j < i; j++)
      	dp[i] += dp[j] * dp[i-j-1];
 	}

 	--k;


 	if (dp[n] <= k){
 		printf("-1\n");
 		return 0;
 	}

 	gen(n,1,k);
  return 0;
}

