#include <iostream>
#include <cassert>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "pisa"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;

void Load()
{
	assert(scanf("%d", &n) == 1);
	assert(1 <= n && n <= 40);
}

int dp[41][3][3];

int f(int n, int from, int to)
{
	if (dp[n][from][to] != -1) return dp[n][from][to];
	if (n == 0) return 0;
	if (n == 1) return !(from == to);
	int temp = 3 - from - to;
	int res = f(n - 1, from, temp) + 1 + f(n - 1, temp, to);
	if (from == 1)
		res = min(res, 1);
	return dp[n][from][to] = res;	
}

void Solve()
{
	memset(dp, -1, sizeof(dp));
	cout << f(n, 0, 2);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
