#include <iostream>
#include <cstdio>     
#include <utility>
#include <algorithm>
#include <vector>

#define c first
#define p second

using namespace std;

typedef pair <int, int> node;

const int N = (int) 1e5;
const int INF = (int) 2e9 + 1;

int n, k, min_ans = INF;
node a[N];
vector <node> v;

void perebor ( int num, int cnt, int ans ) {
	if ( num == -1 ) {
		if ( cnt != 0 || ans > min_ans )
			return;
			
		min_ans = ans;

		return;
	}

	if ( ans > min_ans )
		return;
	
	for ( int i = cnt / v[num].c; i >= max(cnt / v[num].c - 10, 0); i-- ) {
		perebor(num - 1, cnt - i * v[num].c, ans + v[num].p * i);		  
	}
	perebor(num - 1, cnt, ans);
}

int main () {
	freopen("printing.in", "r", stdin);
	freopen("printing.out", "w", stdout);

	cin >> n >> k;
	for ( int i = 0; i < n; i++ )
		cin >> a[i].p >> a[i].c;

	sort(a, a + n);

	for ( int i = 0, j = 0; i < n; i = j ) {
		v.push_back(a[i]);
		while ( j < n && a[j].c == a[i].c )
			j++;
	}		

	perebor (v.size() - 1, k, 0);

    if ( min_ans < INF )
    	cout << min_ans;
	else
		cout << -1;

	return 0;
}