#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

struct node {
	int num, t;
};

bool operator < ( node a, node b ) {
	return (a.t > b.t);
}

const int N = (int) 1e5;

int n, k, ans[N];
node a[N];

int main () {
	freopen("swords.in", "r", stdin);
	freopen("swords.out", "w", stdout);

	cin >> n >> k;
	for ( int i = 0; i < n; i++ ) {
		cin >> a[i].t;
		a[i].num = i + 1;
	}	

	sort(a, a + n );

	int last = 0, cnt = 0;
	for ( int i = 1; i < n; i++ ) {
		if ( a[i].t < a[last].t ) {
			ans[a[i].num - 1] = a[last].num;
			cnt++;

			if ( cnt == 2 ) {
				last++;
				cnt = 0;
			}
		}
		else {
			cout << -1;
			return 0;
		}
	}

	for ( int i = 0; i < n; i++ )
		cout << ans[i] << ' ';

	return 0;
}