import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class Chronicle
{
	static BufferedReader in;
	static BufferedWriter out;
	static StringTokenizer st;
	static int kol=0;
	static boolean p[][][];
	static String nextToken()
	{
		while (st==null|| !st.hasMoreTokens())
		{
			try
			{
				st=new StringTokenizer(in.readLine());
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	static int nextInt()
	{
		return Integer.parseInt(nextToken());
	}
	static void trace(String s)
	{
		System.out.println(s);
	}
	static void trace(int s)
	{
		System.out.println(s);
	}
	static String ch(int a)
	{
		if (a<10)
			return "0"+a;
		else
			return a+"";
	}
	static boolean ok(int d,int m,int y)
	{
		boolean vis=(y%4==0&&y%100!=0)||(y%400==0);
		int dm[]=new int[13];
		Arrays.fill(dm, 30);
		dm[1]=31;
		dm[3]=31;
		dm[5]=31;
		dm[7]=31;
		dm[8]=31;
		dm[10]=31;
		dm[12]=31;
		dm[2]=(vis?29:28);
		if (m>12 || m<1)
		{
			return false;
		}
		//trace("M "+m);
		return (d<=dm[m] && y<100 && d>0);
	}
	static void pr(int d,int m,int y) throws Exception
	{
		if (ok(d,m,y) && !p[d][m][y])
		{
			out.write(ch(d)+"/"+ch(m)+"/"+ch(y)+"\n");
			p[d][m][y]=true;
			kol++;
		}
	}
	public static void main(String args[])
	{
		try
		{
			in=new BufferedReader(new FileReader("chronicle.in"));
			out=new BufferedWriter(new FileWriter("chronicle.out"));
			String str=in.readLine();
			StringTokenizer st=new StringTokenizer(str,"/");
			p=new boolean[100][100][100];
			int a=Integer.parseInt(st.nextToken());
			int b=Integer.parseInt(st.nextToken());
			int c=Integer.parseInt(st.nextToken());
			//trace(a+" "+b+" "+c);
			pr(a,b,c);
			pr(a,c,b);
			pr(b,a,c);
			pr(b,c,a);
			pr(c,a,b);
			pr(c,b,a);
			if (kol==0)
			{
				out.write("No such date");
			}
			in.close();
			out.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
