import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.PriorityQueue;
import java.util.StringTokenizer;
import java.util.Vector;


public class Swords
{
	static class Node implements Comparable<Node>
	{
		public int i;
		public int c;
		public Node(int i, int c)
		{
			this.i=i;
			this.c=c;
		}
		@Override
		public int compareTo(Node o)
		{
			return (this.c<o.c?1:(this.c>o.c?-1:0));
		}
		public String toString()
		{
			return "["+this.i+" "+this.c+"]";
		}
	}
	static BufferedReader in;
	static BufferedWriter out;
	static StringTokenizer st;
	static PriorityQueue<Node> q;
	static int p[];
	static int mas[];
	static int n;
	static int k;
	static boolean ok=true;
	static String nextToken()
	{
		while (st==null|| !st.hasMoreTokens())
		{
			try
			{
				st=new StringTokenizer(in.readLine());
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	static int nextInt()
	{
		return Integer.parseInt(nextToken());
	}
	static void trace(String s)
	{
		System.out.println(s);
	}
	static void trace(int s)
	{
		System.out.println(s);
	}
	static void rec(int x)
	{
		//trace("V="+(x+1));
		if (!q.isEmpty())
		{
			Node p1=q.poll();
			p[p1.i]=x+1;
			if (!q.isEmpty())
			{
				Node p2=q.poll();
				p[p2.i]=x+1;
				//trace((p1.i+1)+" "+(p2.i+1));
				if (p1.c==mas[x] || p2.c==mas[x]) ok=false;
				rec(p1.i);
				rec(p2.i);
			}
			else
			{
				if (p1.c==mas[x]) ok=false;
				if (p1.c>=k)
				{
					rec(p1.i);
				}
				else
				{
					//trace("Return "+(p1.i+1));
					q.add(p1);
				}
			}
		}
		else
		{
			//trace("Empty");
		}
	}
	public static void main(String args[])
	{
		try
		{
			in=new BufferedReader(new FileReader("swords.in"));
			out=new BufferedWriter(new FileWriter("swords.out"));
			n=nextInt();
			k=nextInt();
			mas=new int[n];
			p=new int[n];
			q=new PriorityQueue<Node>();
			for (int i=0;i<n;i++)
			{
				int c=nextInt();
				Node node=new Node(i,c);
				mas[i]=c;
				q.add(node);
			}
			Node max=q.poll();
			p[max.i]=0;
			rec(max.i);
			if (ok)
			{
				for (int i=0;i<n;i++)
				{
					out.write((p[i])+" ");
				}
			}
			else
			{
				out.write("-1");
			}
			in.close();
			out.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
