import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.Vector;


public class Weights
{
	static BufferedReader in;
	static BufferedWriter out;
	static StringTokenizer st;
	static String nextToken()
	{
		while (st==null|| !st.hasMoreTokens())
		{
			try
			{
				st=new StringTokenizer(in.readLine());
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	static int nextInt()
	{
		return Integer.parseInt(nextToken());
	}
	static void trace(String s)
	{
		System.out.println(s);
	}
	static void trace(int s)
	{
		System.out.println(s);
	}
	public static void main(String args[])
	{
		try
		{
			in=new BufferedReader(new FileReader("weights.in"));
			out=new BufferedWriter(new FileWriter("weights.out"));
			int n=nextInt();
			int sum=0;
			int cel=0;
			//int mas[]=new int[n];
			boolean p[]=new boolean[n+1];
			Vector<Integer> u[]=new Vector[3];
			for (int i=0;i<3;i++)
			{
				u[i]=new Vector<Integer>();
			}
			for (int i=1;i<=n;i++)
			{
				sum+=i;
			}
			if (sum%3!=0)
			{
				//trace(sum);
				out.write("Impossible");
			}
			else
			{
				cel=sum/3;
				int r=n;
				int l=1;
				for (int i=0;i<3;i++)
				{
					int temp=0;
					//trace("USER = "+(i+1));
					while (temp<cel)
					{
						temp+=r;
						//trace("ADD "+r);
						u[i].add(r);
						r--;
					}
					if (temp>cel)
					{
						//trace("Too more");
						r++;
						temp-=r;
						//trace("DELETE "+r);
						u[i].remove(u[i].size()-1);
						int t=cel-temp;
						if (!p[t])
						{
							//trace("we have raz");
							p[t]=true;
							u[i].add(t);
						}
						else
						{
							while (temp<cel && l<r)
							{
								//trace(l);
								if (!p[l])
								{
									p[l]=true;
									temp+=l;
								}
								l++;
							}
						}
					}
				}
				if (u[0].size()==0 || u[1].size()==0 || u[2].size()==0 || (u[0].size()+u[1].size()+u[2].size()!=n))
				{
					out.write("Impossible");
				}
				else
				{
					for (int i=0;i<3;i++)
					{
						out.write(u[i].size()+"\n");
						for (int j=u[i].size()-1;j>=0;j--)
						{
							out.write(u[i].get(j)+" ");
						}
						out.write("\n");
					}
				}
			}
			in.close();
			out.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
