#include <cstdio>
#include <iostream>
#include <algorithm>

#define N int(1e5 + 5)

using namespace std;

pair<int, int> a[N];
int p[N];

int main() {
	freopen("swords.in", "r", stdin);
	freopen("swords.out", "w", stdout);

	int n, k;
	scanf("%d %d ", &n, &k);

	for (int i = 0; i < n; i++) {
		int y;
		scanf("%d", &y);		
		a[i] = make_pair(y, i + 1);
	}

	sort(a, a + n);
	reverse(a, a + n);
	p[ a[0].second ] = 0;

	for (int i = 1, j = 0; i < n; i++) {
		p[ a[i].second ] = a[j].second;
		if (a[j].first - a[i].first < k) {
			cout << -1;
			return 0;
		}
		if (i % 2 == 0) j++;
	}

	for (int i = 1; i <= n; i++)
		printf("%d ", p[i]);

	return 0;
}