import java.util.*;
import java.io.*;

public class twothousandtwelve {
	
	static class MyComp implements Comparator<int[]> {

		@Override
		public int compare(int[] o1, int[] o2) {
			if (o1[0] > o2[0]) 
			{
				return 1;
			}
			return 0;
		}
		
	}

	public static void main(String[] args)throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("swords.in"));
		PrintWriter out = new PrintWriter(new File("swords.out"));
		
		StringTokenizer st;
		MyComp mc = new MyComp();
		
		String s = in.readLine();
		st = new StringTokenizer(s);
		int n = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		
		int[][] a = new int[n][2];
		
		int[] link = new int[n];
		boolean[] full = new boolean[n];
		boolean[] sent = new boolean[n];
		boolean[] flag = new boolean[n];
		s = in.readLine();
		st = new StringTokenizer(s);
		for (int i = 0; i < n; i++) {
			a[i][0] = Integer.parseInt(st.nextToken());
			a[i][1] = i;
		}
		
		Arrays.sort(a, mc);
		
		boolean b;
		
		for (int i = n - 1; i >= 0; i--) {
			if (!full[i]) {
				b = false;
				
				for (int j = i - 1; j >= 0; j--) {
					if (!sent[j]) {
						link[j] = i;
						sent[j] = true;
						if (b) {
							break;
						}
						b = true;
					}
				}
				
				full[i] = true;
			}
		}
		
		for (int i = 0; i < n - 1; i++) {
			if (a[link[i]][0] - a[i][0] < k) {
				out.print(-1);
				
				in.close();
				out.close();
				return;
			}
		}
		
		for(int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if ((a[j][1] == i) && (!flag[j])) {
					if (j == n - 1) {
						out.print("0 ");
						break;
					}
					flag[j] = true;
					out.print((a[link[j]][1] + 1) + " ");
					break;
				}
			}
		}
		
		in.close();
		out.close();
	}

}
