#include <fstream>
#include <string>
#include <time.h>

#define TRY(a,b,c) 	if(goodS(a,b,c)){g=1; \
					toStr(a,sout);sout<<"/";\
					toStr(b,sout);sout<<"/";\
					toStr(c,sout);\
					sout<<std::endl;}


void toStr(int v,std::fstream &sout)
{
	if(v<10)
		sout<<"0"<<v;
	else
		sout<<v;
}

bool sYear(int yy)
{
	int y=2000+yy;
	if(yy==0)
		y=3000;

	return (y%4==0 && y%100!=0) || (y%400==0);
}
bool goodS(int d,int m,int y)
{
	if(d<1 || m<1 || m>12 || y<0)
		return false;

	bool sy=sYear(y);

	if(m==2)
	{
		if(sy && d>29)
			return false;
		else if(!sy && d>28)
			return false; 
	}
	else if(m==1 || m==3 || m==5 || m==7 || m==8 || m==10 || m==12)
	{
		if(d>31)
			return false;
	}
	else
	{
		if(d>30)
			return false;
	}
	return true;
}

int main(int argc,char* argv[])
{
	int d1,d2,d3;
	char buf[3];
	buf[2]=0;

	std::fstream sin("chronicle.in",std::ios_base::in);
	sin.read(buf,2);
	d1=atoi(buf);
	sin.ignore(1);
	sin.read(buf,2);
	d2=atoi(buf);
	sin.ignore(1);
	sin.read(buf,2);
	d3=atoi(buf);
	sin.close();


	std::fstream sout("chronicle.out",std::ios_base::out | std::ios_base::trunc);
	bool g=0;

	if(d1!=d2 && d1!=d3)
	{
		if(d2!=d3)
		{
			TRY(d1,d2,d3);
			TRY(d1,d3,d2);
		}
		else
			TRY(d1,d2,d3);

		if(d1!=d3)
		{
			TRY(d2,d1,d3);
			TRY(d2,d3,d1);
		}
		else
			TRY(d2,d1,d3);

		if(d1!=d2)
		{
			TRY(d3,d1,d2);
			TRY(d3,d2,d1);
		}
		else
			TRY(d3,d1,d2);
	}
	else
		TRY(d1,d2,d3);

	if(!g)
		sout<<"No such date";

	sout.flush();
	sout.close();
	return 0;
}