#include <fstream>
#include <string>
#include <time.h>
#include <iostream>
#include <vector>


struct ansv
{
	int d,m,y;
	ansv(int a,int b,int c)
	{
		d=a;
		m=b;
		y=c;
	}

	bool cmp(ansv a)
	{
		return a.d==d && a.m==m && a.y==y;
	}
};

void toStr(int v,std::fstream &sout)
{
	if(v<10)
		sout<<"0"<<v;
	else
		sout<<v;
}
void toStr(ansv a,std::fstream &sout)
{
	toStr(a.d,sout);sout<<"/";
	toStr(a.m,sout);sout<<"/";
	toStr(a.y,sout);
}

bool sYear(int yy)
{
	int y=2000+yy;
	if(yy==0)
		y=3000;

	return (y%4==0 && y%100!=0) || (y%400==0);
}
bool goodS(int d,int m,int y)
{
	if(d<1 || m<1 || m>12 || y<0)
		return false;

	bool sy=sYear(y);

	if(m==2)
	{
		if(sy && d>29)
			return false;
		else if(!sy && d>28)
			return false; 
	}
	else if(m==1 || m==3 || 
			m==5 || m==7 || 
			m==8 || m==10 || 
			m==12)
	{
		if(d>31)
			return false;
	}
	else
	{
		if(d>30)
			return false;
	}
	return true;
}

void addIt(std::vector<ansv> &h,ansv a)
{
	if(!goodS(a.d,a.m,a.y))
		return;

	int len=h.size();
	for(int i=0;i<len;i++)
	{
		if(h[i].cmp(a))
			return;
	}
	h.push_back(a);
}
int main(int argc,char* argv[])
{
	int d1,d2,d3;
	char buf[3];
	buf[2]=0;

	std::fstream sin("chronicle.in",std::ios_base::in);
	sin.read(buf,2);
	d1=atoi(buf);
	sin.ignore(1);
	sin.read(buf,2);
	d2=atoi(buf);
	sin.ignore(1);
	sin.read(buf,2);
	d3=atoi(buf);
	sin.close();

	std::vector<ansv> an;
	addIt(an,ansv(d1,d2,d3));
	addIt(an,ansv(d1,d3,d2));

	addIt(an,ansv(d2,d1,d3));
	addIt(an,ansv(d2,d3,d1));

	addIt(an,ansv(d3,d1,d2));
	addIt(an,ansv(d3,d2,d1));

	std::fstream sout("chronicle.out",std::ios_base::out | std::ios_base::trunc);
	int len=an.size();
	if(len==0)
		sout<<"No such date";
	else
	{
		for(int i=0;i<len-1;i++)
		{
			toStr(an[i],sout);
			sout<<std::endl;
		}
		toStr(an[len-1],sout);
	}
	sout.flush();
	sout.close();
	return 0;
}


