#define FNAME "chronicle"

#include<cstdio>
#include<algorithm>
#include<vector>
using namespace std;

#define forn(i,N) for(int i=0;i<(N);++i)


int DAYS[12]={31,0,31,30,31,30,31,31,30,31,30,31};

inline bool isLeap(int k){
	return (!(k%4)&&k%100) || !(k%400);
}

struct Day{
	int a,b,c;
	Day(){};
	Day(int a,int b,int c):a(a),b(b),c(c){};
};
bool operator <(Day a,Day b){
	return a.a<b.a || a.a==b.a && a.b<b.b || a.a==b.a && a.b==b.b && a.c<b.c;
}
bool operator ==(Day a,Day b){
	return a.a==b.a && a.b==b.b && a.c==b.c;
}
vector<Day> Answer;

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int a[3];
	scanf("%d/%d/%d",&a[0],&a[1],&a[2]);

	for(int i=0;i<6;++i){
		DAYS[1]=isLeap(a[2])?29:28;
		if(1<=a[1] && a[1]<=12 && a[0]<=DAYS[a[1]-1])
			Answer.push_back(Day(a[0],a[1],a[2]));
		next_permutation(a,a+3);
	}

	if(!Answer.size())
		puts("No such date");
	else{
		sort(Answer.begin(),Answer.end());
		int k=unique(Answer.begin(),Answer.end())-Answer.begin();
		for(int i=0;i<k;++i)
			printf("%02d/%02d/%02d\n",Answer[i].a,Answer[i].b,Answer[i].c);
	}


	return 0;
}