#include <fstream>
#include <iostream>
#include <string>
#include <stdlib.h>
#include <vector>
#include <sstream>

bool correct_date(int day, int month, int year)
{
    int num_of_days;
    if(((year % 4) == 0) && ((year % 100) != 0) )
    {
    switch(month)
            {
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 10:
                case 12:
                    num_of_days = 31;
                    break;
                case 2:
                    num_of_days = 29;
                    break;
                case 4:
                case 6:
                case 9:
                case 11:
                    num_of_days = 30;
                    break;
                default:
                    num_of_days = -1;
                    break;
            }
    }
    else
    {
        switch(month)
        {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
            case 12:
                num_of_days = 31;
                break;
            case 2:
                num_of_days = 28;
                break;
            case 4:
            case 6:
            case 9:
            case 11:
                num_of_days = 30;
                break;
            default:
                num_of_days = -1;
                break;
        }
    }
    return (day <= num_of_days);
}

template <typename T>
bool is_there(std::vector<T> vec, T elem)
{
    for(int i = 0; i < vec.size(); i++)
    {
        if(vec[i] == elem)
            return true;
    }
    return false;
}

int main()
{
    std::ifstream in("chronicle.in");
    std::ofstream out("chronicle.out");
    int arr[3];
    std::string str_arr[3];
    //std::cin >> a >> b >> c;
    std::string date;
    in >> date;
    in.close();
    str_arr[0] = date.substr(0,2);
    str_arr[1] = date.substr(3,2);
    str_arr[2] = date.substr(6,2);
    arr[0] = atoi(str_arr[0].c_str());
    arr[1] = atoi(str_arr[1].c_str());
    arr[2] = atoi(str_arr[2].c_str());
    std::vector<std::string> vec;
    bool done = false;
    for(int day = 0; day < 3; day++)
    {
        for(int month = 0; month < 3; month++)
        {
            if((month==day))
                continue;
            for(int year = 0; year < 3; year++)
            {
                if((year==day) || (year==month))
                    continue;
                std::cout <<"Here I am! "<< day << ' ' << month << ' ' << year <<std::endl;
                if(correct_date(arr[day], arr[month], arr[year]))
                {
                    std::ostringstream cur_out;
                    cur_out << str_arr[day] << '/' << str_arr[month] << '/'<< str_arr[year];
                    if(!is_there<std::string>(vec, cur_out.str()))
                    {
                        out << cur_out.str() << std::endl;
                        vec.push_back(cur_out.str());
                    }
                    done = true;
                }
            }
        }
    }
    if(!done)
        out << "No such date";
    out.close();
    //std::cout <<"date " << a << '/' << b << '/' << c << " : " << correct_date(a,b,c)<<std::endl;
   //
}

