import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemD {

	String fileName = "pisa";
	boolean debugOn = false;

	public void start() throws Exception {
		int n = nextInt();
		int[] dyn = new int[n + 10];
		dyn[1] = 1;
		dyn[2] = 3;
		for (int i = 3; i <= n; i++) {
			dyn[i] = dyn[i - 1] * 2 + 3;
			println(dyn[i] + "");
		}
		if (n == 1)
			out.println(1);
		else {
			out.println(dyn[n - 1] + 2);
		}
	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemD();
	}

	public ProblemD() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String delim = " ";
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
