import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

public class ProblemG {

	String fileName = "swords";
	boolean debugOn = false;

	public void start() throws Exception {
		int n = nextInt();
		int k = nextInt();
		Sh[] a = new Sh[n];
		for (int i = 0; i < n; i++)
			a[i] = new Sh(100101010 - nextInt(), i + 1);
		Arrays.sort(a, new Comparator<Sh>() {

			@Override
			public int compare(Sh o1, Sh o2) {
				if (o1.y > o2.y)
					return 1;
				if (o1.y < o2.y)
					return -1;
				return 0;
			}
		});
		int next = 1;
		a[0].par = 0;
		for (int i = 0; i < n; i++) {
			int minY = a[i].y + k;
			if (next < n) {
				if (a[next].y >= minY) {
					a[next].par = a[i].ind;
					next++;
				}
			}
			if (next < n) {
				if (a[next].y >= minY) {
					a[next].par = a[i].ind;
					next++;
				}
			}
		}

		Arrays.sort(a, new Comparator<Sh>() {

			@Override
			public int compare(Sh o1, Sh o2) {
				if (o1.ind > o2.ind)
					return 1;
				if (o1.ind < o2.ind)
					return -1;
				return 0;
			}
		});
		boolean bad = false;
		for (int i = 0; i < n; i++) {
			if (a[i].par == -1)
				bad = true;
		}
		if (bad)
			out.println(-1);
		else
			for (int i = 0; i < n; i++) {
				out.print(a[i].par + " ");
			}
	}

	class Sh {
		public Sh(int y, int ind) {
			this.y = y;
			this.ind = ind;
		}

		int y;
		int ind;
		int par = -1;
	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemG();
	}

	public ProblemG() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String delim = " ";
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
