import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemI {

	String fileName = "weights";
	boolean debugOn = false;

	public void start() throws Exception {
		long n = nextLong();
		boolean[] was = new boolean[(int) n];
		int[] a1 = new int[(int) n];
		int[] a2 = new int[(int) n];
		int[] a3 = new int[(int) n];
		int next1 = 0;
		int next2 = 0;
		int next3 = 0;
		long sum1 = 0;
		long sum2 = 0;
		long sum3 = 0;
		long s = (n + 1) * n / 2;
		if (s % 3 != 0)
			out.println("Impossible");
		else {
			long sum = s / 3;
			// System.out.println(n + " " + s + " " + sum);
			int cur = (int) n;
			while (sum1 != sum) {
				while (cur > 1 && (sum1 + cur > sum || was[cur - 1])) {
					cur--;
				}
				if (sum1 + cur <= sum) {
					// System.out.println(cur);
					a1[next1] = cur;
					sum1 += cur;
					was[cur - 1] = true;
					next1++;
				}
				if (cur == 1)
					break;
			}

			cur = (int) n;
			while (sum2 != sum) {
				while (cur > 1 && (sum2 + cur > sum || was[cur - 1])) {
					cur--;
				}
				if (sum2 + cur <= sum && !was[cur - 1]) {
					// System.out.println(cur);
					a2[next2] = cur;
					sum2 += cur;
					was[cur - 1] = true;
					next2++;
				}
				if (cur == 1)
					break;
			}

			cur = (int) n;
			while (sum3 != sum) {
				while (cur > 1 && (sum3 + cur > sum || was[cur - 1])) {
					cur--;
				}
				if (sum3 + cur <= sum && !was[cur - 1]) {
					// System.out.println(cur);
					a3[next3] = cur;
					sum3 += cur;
					was[cur - 1] = true;
					next3++;
				}
				if (cur == 1)
					break;
			}
			if (sum1 + sum2 + sum3 != s) {
				out.println("Impossible");
			} else {
				out.println(next1);
				for (int i = 0; i < next1; i++) {
					out.print(a1[i] + " ");
				}
				out.println();
				out.println(next2);
				for (int i = 0; i < next2; i++) {
					out.print(a2[i] + " ");
				}
				out.println();
				out.println(next3);
				for (int i = 0; i < next3; i++) {
					out.print(a3[i] + " ");
				}
				out.println();
			}
		}

	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemI();
	}

	public ProblemI() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			// System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			// System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String delim = " ";
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
