
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;


public class C implements Runnable {
	
	private void Solution() throws IOException {
		String s = in.readLine();
		int count = 0, place = 0;
		for (int i = 1; i < s.length()-1; i ++) {
			BigInteger a = new BigInteger(s.substring(0,i)), b = new BigInteger(s.substring(i,s.length()));
			if (a.compareTo(b) != -1) {
				place = i;
				break;
			}
			count ++;
		}
		for (int i = 1; i < place; i ++) {
			if (s.charAt(i) == '0')
				count --;
		}
		out.print(count);
	}
	
	public static void main(String args[]) {
		new C().run();
	}
	
	BufferedReader in;
	StringTokenizer tokenizer;
	PrintWriter out;
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File("number.in")));
			tokenizer = null;
			out = new PrintWriter(new File("number.out"));
			Solution();
			in.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreElements())
			tokenizer = new StringTokenizer(in.readLine());
		return tokenizer.nextToken();
	}
}
