program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  t1 = record
    val, nom, res: integer;
  end;

var
  i, k, n: integer;
  a: array[1..100000] of t1;
  b: array[1..100000] of integer;

procedure qsort(l, r: integer);
var
  x, i, j: integer;
  w: t1;
begin
  i := l;
  j := r;
  x := a[(l + r) div 2].val;
  repeat
    while (a[i].val > x) do inc(i);
    while (a[j].val < x) do dec(j);
    if (i <= j) then begin
      w := a[i];
      a[i] := a[j];
      a[j] := w;
      inc(i);
      dec(j);
    end;
  until (i > j);
  if (l < j) then qsort(l, j);
  if (i < r) then qsort(i, r);
end;

begin
  reset(input, 'swords.in');
  rewrite(output, 'swords.out');

  readln(n, k);

  for i := 1 to n do begin
    read(a[i].val);
    a[i].nom := i;
  end;

  qsort(1, n);


  for i := 1 to n do begin
    b[a[i].nom] := i;
  end;

  for i := 2 to n do begin
    a[i].res := a[i div 2].nom;
    if (abs(a[i].val -  a[i div 2].val) < k) then begin
      writeln(-1);
      close(input);
      close(output);
      halt(0);
    end;
  end;

  for i := 1 to n do
    write(a[b[i]].res, ' ');

  close(input);
  close(output);
end.
