#include <stdlib.h>
#include <stdio.h>
#include <utility>
#include <algorithm>
using namespace std;

#define x first
#define y second

const int N = 100000;
int size = 1;

pair <int,int> heap[N];

void add(pair <int,int> a)
{
	int i = size;
	heap[size] = a;
	while( (heap[i].x  > heap[i/2].x) && i > 1)
	{
		swap(heap[i],heap[i/2]);
		i /= 2;
	}
	++size;
}

pair <int,int> arr[N];
int ans[N];

int main()
{
    freopen("swords.in", "rt", stdin);
    freopen("swords.out", "wt", stdout);

	int n, k,v; scanf("%d %d", &n, &k);
	for(int i = 0; i < n; ++i)
	{
		scanf("%d", &v);
		arr[i] = make_pair(v,i);
	}

    sort(arr, arr + n);


    for(int i = 0; i < n; ++i)
        add(arr[i]);

	for(int i = 1; i < size; ++i)
	{
		if(2*i < size)
		{

		    if(heap[i].x - heap[2*i].x >= k)
                ans[heap[2*i].y] = heap[i].y;
            else
            {
                printf("-1");
                return 0;
            }

		}



		if(2*i+1 < size)
        {
            if(heap[i].x - heap[2*i+1].x >= k)
                ans[heap[2*i+1].y] = heap[i].y;
            else
            {
                printf("-1");
                return 0;
            }
        }

	}

	for(int i = 0; i < n; ++i)
		printf("%d ", ans[i] ? ans[i] + 1 : ans[i]);

	return 0;


}
