#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

const int MaxN = 100500;

struct tt {
  long long x, ind;

};

tt a[MaxN];

int random(int n) {
  return rand() % n;
}

void qsort(int l, int r) {
  int i = l;
  int j = r;
  int x1 = a[l+random(r-l)].x;

  while (i <= j) {
    while (x1 < a[i].x) i++;
    while (x1 > a[j].x) j--;
    if(i <= j) {
      swap(a[i].x, a[j].x);
      swap(a[i].ind, a[j].ind);
      i++;
      j--;
    }
  }

  if (i < r) qsort(i, r);
  if (l < j) qsort(l, j);
}

int ans[MaxN];

int main() {

  long long n, k, i;

  freopen("swords.in", "r", stdin);
  freopen("swords.out", "w", stdout);

  cin >> n >> k;
  for (i = 0; i < n; i++) {
    cin >> a[i].x;
    a[i].ind = i;
    ans[i] = 0;
  }

  qsort(0, n-1);

  ans[a[0].ind] = -1;
  int num = 0;

  for (i = 0; i < n; i++) {
    num++;
    if (num >= n) {
      break;
    }
    if (a[i].x-a[num].x < k) {
      break;
    }
    else {
      ans[a[num].ind] = a[i].ind;
    }

    num++;
    if (num >= n) {
      break;
    }
    if (a[i].x-a[num].x < k) {
      break;
    }
    else {
      ans[a[num].ind] = a[i].ind;
    }

  }



  if (num < n) {
    cout << -1 << endl;
    return 0;
  }
  for (i = 0; i < n; i++) {
    cout << ans[i]+1 << ' ';
  }
  cout << endl;
}
