#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "garden"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n, m, h;
  while (scanf("%d%d%d", &n, &m, &h) >= 1) {
		int cnt = 0;
		ll mn = (ll)2e18;
		for (int i = 0; i < n; i++) {
			int a1, b1;
			scanf("%d%d", &a1, &b1);
			ll end = a1 + ll(m - 1) * b1;
			if (mn == end)
				cnt++;
			if (mn > end)
				mn = end, cnt = 1;
   	} 

   	if (mn < h)
   		printf("-1\n");
   	else
   		printf("%d\n", !(mn == h && cnt == n));
  }
  return 0;
}
