import java.io.*;
import java.util.*;

public class garden implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new garden()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("garden.in"));
			out = new PrintWriter(new FileWriter("garden.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		int m = nextInt();
		int h = nextInt();
		for(int i = 0; i < n; i++) {
			int a = nextInt();
			int b = nextInt();
			if ((a + (m - 1) * b) < h) {
				out.print(-1);
				return;
			}
		}
		out.print(1);
	}
}
