program sort;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type
  sword = record
    ol, num, p: integer;
  end;
var
  i, n, t, h, j, k, left: integer;
  now: sword;
  a, q: array [1..2000000] of sword;
  used : array [1..2000000] of boolean;

procedure push(a: sword);
begin
  q[t] := a;
  inc(t);
end;

function pop: sword;
begin
  result := q[h];
  inc(h);
end;

procedure qsort(l, r: integer);
var
  x, i, j: integer;
  v: sword;
begin
  i := l;
  j := r;
  x := a[random(r + l - 1) + l].ol;
  while i < j do
  begin
    while a[i].ol < x do
      inc(i);
    while a[j].ol > x do
      dec(j);
    if i <= j then
    begin
      v := a[i];
      a[i] := a[j];
      a[j] := v;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then
    qsort(i, r);
  if j > l then
    qsort(l, j);
end;

procedure qsort2(l, r: integer);
var
  x, i, j: integer;
  v: sword;
begin
  i := l;
  j := r;
  x := a[random(r + l - 1) + l].num;
  while i < j do
  begin
    while a[i].num < x do
      inc(i);
    while a[j].num > x do
      dec(j);
    if i <= j then
    begin
      v := a[i];
      a[i] := a[j];
      a[j] := v;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then
    qsort2(i, r);
  if j > l then
    qsort2(l, j);
end;


begin
  reset(input, 'swords.in');
  rewrite(output, 'swords.out');
  randomize;
  h := 1;
  t := 1;
  read(n, k);
  left := n - 1;
  for i := 1 to n do
    read(a[i].ol);
  for i := 1 to n do
    a[i].num := i;
  qsort(1, n);
  push(a[n]);
  for i := 1 to n do
    used[i] := false;
  used[n] := true;
  while h < t do
  begin
    now := pop;
    if left > 0 then
    begin
      if now.ol - k < a[left].ol then
      begin
        write(-1);
        halt(0);
      end;
      push(a[left]);
      a[left].p := now.num;
      dec(left);
    end;
    if left > 0 then
    begin
      if now.ol - k < a[left].ol then
      begin
        write(-1);
        halt(0);
      end;
      push(a[left]);
      a[left].p := now.num;
      dec(left);
    end;
    {for j := n downto 1 do
    begin
      if not used[j] and (now.ol - k >= a[j].ol) then
      begin
        a[j].p := now.num;
        push(a[j]);
        used[j] := true;
        break;
      end;
      if not used[j] and not (now.ol - k >= a[j].ol) then
      begin
        write(-1);
        halt(0);
      end;
    end;
    for j := n downto 1 do
    begin
      if not used[j] and (now.ol - k >= a[j].ol) then
      begin
        a[j].p := now.num;
        push(a[j]);
        used[j] := true;
        break;
      end;
      if not used[j] and not (now.ol - k >= a[j].ol) then
      begin
        write(-1);
        halt(0);
      end;
    end;   }
  end;
  qsort2(1, n);
  for i := 1 to n do
    write(a[i].p, ' ');
  readln;
  readln;
end.
