#include <iostream>
#include <cmath>
#include <cassert>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "swords"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));
const int maxn = 100005;

struct Sword
{
	int age, id;

	Sword() {};
	Sword(int age_, int id_): age(age_), id(id_) {};
};

bool operator < (const Sword &a, const Sword &b)
{
	return a.age > b.age;
}

int n, k;
Sword a[maxn];

void Load()
{
	assert(scanf("%d%d", &n, &k) == 2);
	assert(1 <= n && n <= 100000);
	assert(1 <= k && k <= 100000000);
	for (int i = 0; i < n; i++)
	{
		assert(scanf("%d", &a[i].age) == 1);
		a[i].id = i;
		assert(0 <= a[i].age && a[i].age <= 1000000000);
	}
}

int ans[maxn];
void Solve()
{
	sort(a + 0, a + n);
	ans[a[0].id] = -1;
	for (int i = 1; i < n; i++)
	{
		if (a[i].age + k <= a[(i - 1) / 2].age)
			ans[a[i].id] = a[(i - 1) / 2].id;
		else
		{
			printf("-1");
			return;
		}
	}

	for (int i = 0; i < n; i++)
		printf("%d ", ans[i] + 1);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
