import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class swords_vd {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};

	class spaga implements Comparable<spaga> {
		int old;
		int num;

		public spaga(int a, int b) {
			old = a;
			num = b;
		}

		@Override
		public int compareTo(spaga o) {
			return old - o.old;
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		spaga[] a = new spaga[n];
		int k = nextInt();
		int max = 0;
		for (int i = 0; i < n; i++) {
			a[i] = new spaga(nextInt(), i);
			max = Math.max(max, a[i].old);
		}
		for (int i = 0; i < n; i++)
			a[i].old = k - a[i].old;
		Arrays.sort(a);
		int tek = 1;
		int res[] = new int[n];
		for (int i = 0; tek < n; i++) {
			if (a[i].old + k > a[tek].old) {
				out.println(-1);
				return;
			}
			res[a[tek].num] = a[i].num + 1;
			tek++;
			if (tek == n)
				continue;
			if (a[i].old + k > a[tek].old) {
				out.println(-1);
				return;
			}
			res[a[tek].num] = a[i].num + 1;
			tek++;
		}
		for (int i=0; i<n; i++)
			out.print(res[i]+" ");
		out.println();

	};

	void run() throws IOException {

		in = new BufferedReader(new FileReader("swords.in"));
		out = new PrintWriter("swords.out");
		solve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new swords_vd().run();
	}

}
