import java.io.*;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class weights_vd {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};

	void print(int a[], int n) {
		ArrayList<Integer> res[] = new ArrayList[3];
		for (int t = 0; t < 3; t++)
			res[t] = new ArrayList<Integer>();
		for (int i = 1; i <= n; i++)
			res[a[i]].add(i);
		for (int t = 0; t < 3; t++) {
			int k = res[t].size();
			out.println(k);
			for (int j : res[t])
				out.print(j + " ");
			out.println();
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		int col[] = new int[n + 1];
		if (n % 6 == 0) {
			for (int i = 1; i <= n / 2; i++) {
				col[i] = i % 3;
				col[n - i + 1] = col[i];
			}
			print(col, n);
			return;
		}
		if ((n + 1) % 6 == 0) {
			int k = n / 6;
			for (int i = 0; i <= n / 2; i++) {
				col[i] = i % 3;
				col[n - i] = col[i];
			}
			print(col, n);
			return;
		}
		if ((n > 7) && (n - 8) % 6 == 0) {
			for (int i = 9; i <= n; i++) {
				int dv = n - (i - 9);
				if (dv < i)
					break;
				col[i] = (i % 3);
				col[dv] = col[i];
			}
			col[4] = 1;
			col[8] = 1;
			col[7] = 2;
			col[5] = 2;
			print(col, n);
			return;
		}
		if ((n > 8) && (n - 9) % 6 == 0) {
			for (int i = 10; i <= n; i++) {
				int dv = n - (i - 10);
				if (dv < i)
					break;
				col[i] = (i % 3);
				col[dv] = col[i];
			}
			col[9] = 1;
			col[6] = 1;
			col[7] = 2;
			col[8] = 2;
			print(col, n);
			return;
		}

		out.println("Impossible");
	};

	void run() throws IOException {

		in = new BufferedReader(new FileReader("weights.in"));
		out = new PrintWriter("weights.out");
		solve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new weights_vd().run();
	}

}
