#include <stdio.h>

#define NMAX 71
#define DIFMAX 12
#define TRYMAX 6

int usable[NMAX], csol[NMAX], sol[NMAX][NMAX], Mmax[NMAX];
int N, M, i, j, d, nusable_left;

void bkt() {
	int x, y, ntry = 0;
	
	if (M > Mmax[N]) {
		Mmax[N] = M;
		for (x = 1; x <= M; x++)
			sol[N][x] = csol[x];
	}
	
	for (x = csol[M] + 1; x <= N && ntry < TRYMAX; x++)
		if (usable[x] > 0) {
			ntry++;
			
			M++;
			csol[M] = x;
			for (y = M - 1; y >= 1; y--) {
				d = x - csol[y];
				if (x + 2 * d <= N)
					usable[x + 2 * d]--;
				else
					break;
			}

			nusable_left = 0;
			for (y = x + 1; y <= N; y++)
				if (usable[y])
					nusable_left++;
			
			if (M + nusable_left > Mmax[N])
				bkt();
			
			for (y = M - 1; y >= 1; y--) {
				d = x - csol[y];
				if (x + 2 * d <= N)
					usable[x + 2 * d]++;
				else
					break;
			}
			
			M--;
		}
}

int main() {
	for (N = 1; N < NMAX; N++) {
		for (i = 1; i <= N; i++)
			usable[i] = 1;
		
		M = 1;
		csol[1] = 1;
		
		Mmax[N] = 0;
		bkt();
	
		fprintf(stderr, "%d: %d\n", N, Mmax[N]);
		for (i = 1; i <= Mmax[N]; i++) {
			if (i > 1)
				fprintf(stderr, " ");
			fprintf(stderr, "%d", sol[N][i]);
		}
		fprintf(stderr, "\n");	
	}
	
	for (i = 1; i < NMAX; i++)
		printf("%d,", Mmax[i]);
	printf("\n");
	
	for (i = 1; i < NMAX; i++) {
		printf("{");
		for (j = 1; j <= Mmax[i]; j++)
			printf("%d,", sol[i][j]);
		printf("}\n");
	}
	
	return 0;
}
