function dv_findWindowDepth(currWin) {
    var i = 0;
    while (i < 10 && currWin != window.top) {
        i++;
        currWin = currWin.parent;
    }
    return i;
}

function dv_findAddUrl(tpWin) {
    try {
        if (tpWin.depth <= 1)
            return { url: '', depth: '' };
        var len;
        var q = new Array();
        q.push({ win: window.top, depth: 0 });
        var curr;
        var queueSize = 1;
        var loopCounter = 0;
        while (queueSize > 0 && loopCounter < 100) {
            try {
                loopCounter++;
                curr = q.shift();
                queueSize--;
                var loc = curr.win.location.toString();
                if (loc.length > 0 && curr.win != tpWin) {
                    if (curr.win.document.referrer.length == 0 || curr.depth == 0) {
                        return { url: curr.win.location, depth: curr.depth };
                    }
                    else {
                        return { url: curr.win.document.referrer, depth: curr.depth - 1 };
                    }
                }
            }
            catch (e) {
            }

            len = curr.win.frames.length;
            for (var idx = 0; idx < len; idx++) {
                q.push({ win: curr.win.frames[idx], depth: curr.depth + 1 });
                queueSize++;
            }
        }
        return { url: '', depth: '' };
    }
    catch (e) {
        return { url: '', depth: '' };
    }
}

function DvVerify(redirect, dvurl) {
    var thisVerify = this;
    this.redirect = redirect;
    this.callbackName = '__verify_callback_' + this.redirect.rand;

    window[this.callbackName] = function(allow) {
		var src = allow != 1 ? thisVerify.redirect.tagsrc : thisVerify.redirect.altsrc;
		document.write(src);
    }
	
	if (this.redirect.dvregion == undefined) this.redirect.dvregion = 0;

	var protocol = "http:";
	var ssl = '0';
	if (window.location.toString().match("^https") == "https") {
	    protocol = "https:";
	    ssl = '1';
	}

    try {
        window.DVCurWin.depth = dv_findWindowDepth(window.DVCurWin);
        var dv_additionalUrl = dv_findAddUrl(window.DVCurWin);
        var dv_additionalUrlParam = '&aUrl=' + encodeURIComponent(dv_additionalUrl.url) + '&aUrlD=' + dv_additionalUrl.depth;
        var dv_referrerDepth = window.DVCurWin.depth + dv_referrerOffset;
        if (dv_minus) {
            window.DVCurWin.depth--;
        }
    }
    catch (e) {
        window.DVCurWin.depth = '';
        var dv_additionalUrlParam = '';
        var dv_referrerDepth = '';
    }

    var verifysrc = protocol + '//rtb' + this.redirect.dvregion + '.doubleverify.com/rtb.ashx/verifyc?' + this.redirect.dvparams + '&num=5&ver=2&dv_url=' + encodeURIComponent(dvurl) + '&srcurlD=' + window.DVCurWin.depth + '&callback=' + this.callbackName + '&ssl=' + ssl + '&refD=' + dv_referrerDepth;
	if (false == (/MSIE (\d+\.\d+);/.test(navigator.userAgent) && (new Number(RegExp.$1) <= 8) && (dv_additionalUrlParam.length + verifysrc.length > 2000))) {
	    verifysrc += dv_additionalUrlParam;
	}
	document.write('<scr' + 'ipt language="javascript" src="' + verifysrc + '"></scr' + 'ipt>');
}

try {
    window.parentIsPermitted = false;
    window.DVCurWin = window;
    var dv_referrerOffset = 0;
	var dv_minus = false;
    try {
        for (dv_i = 0; dv_i <= 10; dv_i++) {
            if ((window.DVCurWin.parent != null) && (window.DVCurWin.parent != window.DVCurWin)) {
                var dv_loc = window.DVCurWin.parent.location.toString();
                var dv_x = dv_loc.length;
                if (dv_x > 0) {
                    window.DVCurWin = window.DVCurWin.parent;
                    dv_referrerOffset++;
                    window.parentIsPermitted = true;
                }
                else {
                    window.parentIsPermitted = false;
                    break;
                }
            }
            else {
                if (dv_i == 0) { window.parentIsPermitted = true; }
                break;
            }
        }
    }
    catch (e)
    { window.parentIsPermitted = false; }

    if (window.DVCurWin.document.referrer.length == 0) {
        window.DVURL = window.DVCurWin.location;
    }
    else {
        if (window.parentIsPermitted) {
            window.DVURL = window.DVCurWin.location;
        }
        else {
            window.DVURL = window.DVCurWin.document.referrer;
			dv_minus = true;
        }
    }

	var scripts = document.getElementsByTagName('script');
	for (dv_i in scripts) {
        var dv_src = scripts[dv_i].src;
		var dv_callback = dv_src && dv_src.match(/bsredirect5(_plain)?\.js\?callback=/) ? dv_src.replace(/^.+?callback=(.+?)(&|$)/, '$1') : null;
		if (dv_callback) {
			var dv_redirect = eval(dv_callback + '()');
			if (dv_redirect && !dv_redirect.done) {
			    dv_redirect.done = true;    
                new DvVerify(dv_redirect, DVURL);
                break;
			}
		}
	}
}
catch (ex) { }    
