#include <stdio.h>

#define NMAX 111

char smin[NMAX], smax[NMAX];
int N, i, nmin, nmax;

int main() {
	freopen("rle-size.in", "r", stdin);
	freopen("rle-size.out", "w", stdout);
	
	scanf("%d %s", &N, smin + 1);

	if (smin[1] == '+') {
		smin[0] = '+';
		smax[0] = '-';
	} else if (smin[1] == '-') {
		smin[0] = '-';
		smax[0] = '+';
	} else {
		for (i = 2; i <= N; i++)
			if (smin[i] != '?')
				break;
			
		if (i <= N) {
			smin[0] = smin[i];
			if (i % 2 == 0)
				smax[0] = smin[0];
			else if (smin[0] == '+')
				smax[0] = '-';
			else
				smax[0] = '+';
		} else
			smin[0] = smax[0] = '+';
	}
	
	nmin = 1;
	nmax = 0;
	for (i = 1; i <= N; i++) {
		smax[i] = smin[i];

		if (smin[i] == '?') {
			smin[i] = smin[i - 1];
		} else if (smin[i] != smin[i - 1]) {
			nmin++;
		}
	
		if (smax[i] == '?') {
			if (smax[i - 1] == '+')
				smax[i] = '-';
			else
				smax[i] = '+';
			nmax++;
		} else if (smax[i] != smax[i - 1]) {
			nmax++;
		}
	}
	
	fprintf(stderr, "%s\n%s\n", smin + 1, smax + 1);
	
	printf("%d %d\n", nmin, nmax);
	return 0;
}
