#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 100100

vector<pair<int, int> > v;
vector<int> *g[2];
int l[NMAX], p[NMAX], num[2], total[2], assigned[2], half[NMAX];
int N, K, i, j, np, next[2];

int main() {
	freopen("students.in", "r", stdin);
	freopen("students.out", "w", stdout);

	scanf("%d %d", &K, &N);
	for (i = 1; i <= 2 * K * N; i++)
		scanf("%d", &l[i]);
	
	num[0] = num[1] = 0;
	for (i = 1; i <= 2 * K * N; i++) {
		scanf("%d", &p[i]);
		num[p[i]]++;
	}
	
	for (i = 1; i <= 2 * K * N; i++)
		v.push_back(make_pair(l[i], p[i]));
	
	sort(v.begin(), v.end());
	g[0] = new vector<int>[N];
	g[1] = new vector<int>[N];
	next[0] = next[1] = 0;
	
	total[0] = total[1] = assigned[0] = assigned[1] = np = 0;
	for (i = 0; i < 2 * K * N; i++) {
		if (v[i].second == 0) {
			if (assigned[0] < K * N) {
				half[i] = 0;
				np++;
			} else
				half[i] = 1;
		} else {
			int num_needed = (assigned[1] + 1) / K;
			if ((assigned[1] + 1) % K > 0)
				num_needed++;
			num_needed *= K;
			if (assigned[0] >= num_needed) {				
				half[i] = 1;
				np++;
			} else
				half[i] = 0;
		}
			
		total[v[i].second]++;
		assigned[half[i]]++;
		g[half[i]][next[half[i]]].push_back(v[i].first);
		if (g[half[i]][next[half[i]]].size() == K)
			next[half[i]]++;
	}
	
	printf("%d\n", np);
	
	for (i = 0; i < N; i++) {
		for (j = 0; j < g[0][i].size(); j++) {
			if (j > 0)
				printf(" ");
			printf("%d", g[0][i][j]);
		}
		for (j = 0; j < g[1][i].size(); j++) {
			printf(" %d", g[1][i][j]);
		}
		printf("\n");
	}
	
	return 0;
}
