
const
	MAXN = 1000;
	alphabet = 'abcdefghijklmnopqrstuvwxyz/<>';

var
	c : array [0 .. MAXN] of char;
	stack : array [0 .. MAXN] of string;
	ch : char;
	n : integer;

function checkXML(var s : string) : boolean;
var
	cur, p, curPos, i : integer;
	t : string;
	begin
		curPos := 1;
		result := true;
		cur := 0;
		while (curPos <= n) do begin
			if (s[curPos] <> '<') then begin
				result := false;
				exit;
			end;
			p := 0;
			for i := curPos + 1 to n do begin
				if (s[i] = '>') then begin
					p := i;
					break;
				end;
			end;
			if (p = 0) then begin
				result := false;
				exit;
			end;
			if (p - curPos < 2) or (p - curPos < 3) and (s[curPos + 1] = '/') then begin
				result := false;
				exit;
			end;
			for i := curPos + 1 to p - 1 do begin
				if (not (s[i] in ['a' .. 'z'])) and ((i > curPos + 1) or (s[i] <> '/')) then begin
					result := false;
					exit;
				end;
			end;
			if (s[curPos + 1] = '/') then begin
    			t := copy(s, curPos + 2, p - curPos - 2);
    			dec(cur);
    			if (cur < 0) or (stack[cur] <> t) then begin
					result := false;
					exit;
    			end;
			end else begin
				t := copy(s, curPos + 1, p - curPos - 1);
				stack[cur] := t;
				inc(cur);
			end;
			curPos := p + 1;
		end;
		if (cur <> 0) then begin
			result := false;
			exit;
		end;
	end;


procedure printIt;
var
	i : integer;
	begin
		for i := 1 to n do begin
			write(c[i]);
		end;
		writeln;
		close(input);
		close(output);
		halt(0);
	end;

var
	i, j : integer;
	old : char;
	s : string;
begin
	reset(input, 'xml.in');
	rewrite(output, 'xml.out');
	n := 0;
	read(ch);
	while not (ch in [#13, #10]) do begin
		assert (ch in ['a'..'z', '/', '<', '>']);
		inc(n);
		c[n] := ch;
		read(ch);
	end;
	s := '';
	for i := 1 to n do begin
		s := s + c[i];
	end;
	assert ((n <= MAXN) and (n >= 7));
	for i := 1 to n do begin
		old := s[i];
		for j := 1 to length(alphabet) do begin
			s[i] := alphabet[j];
			if (checkXML(s)) then begin
				c[i] := alphabet[j];
				printIt;
			end;
		end;
		s[i] := old;
	end;
	halt(1 div (n xor n));
end.
