#include <cstdlib>
#include <cstdio>
#include <fstream>
#include <iostream>
#include <cmath>

using namespace std;

//long long abs(long long t)
//{
//    if (t >= 0)
//        return t;
//    else
//        return -t;
//}

bool check(long long x, long long y, long long A, long long B, long long C, long long r)
{
    double t = abs(x * A + y * B + C) / sqrt((double)A * A + B * B);
    if (t * 1000 > r)
        return false;
    else
        return true;
}

int main()
{
    freopen("spacepin.in", "r", stdin);
    
    long long r, n;
    cin >> r >> n;
    long long ballR;
    cin >> ballR;
    long long ballX, ballY;
    cin >> ballX >> ballY;
    long long vX, vY;
    cin >> vX >> vY;

    double rOnX = (ballR + r) / (double) vY * sqrt((double)vX * vX + vY * vY) / 1000;
		double a = -vY;
		double b = vX;
		double c = -a * ballX - b * ballY;
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			double x = (-b * i - c) / a;
			double lX = x - rOnX - 1e-7;
			double rX = x + rOnX + 1e-7;
			
			int leftKilled = (int) floor(lX);
			int rightKilled = (int) floor(rX);
			if (abs(leftKilled) % 2 != i % 2)
				leftKilled++;
			if (abs(rightKilled) % 2 != i % 2)
				rightKilled++;
			
			while (leftKilled >= lX + 1e-7)
				leftKilled -= 2;
			while (leftKilled <= lX - 1e-7)
				leftKilled += 2;
			while (rightKilled <= rX - 1e-6)
				rightKilled += 2;
			while (rightKilled >= rX + 1e-6)
				rightKilled -= 2;
			
			if (leftKilled < -i)
				leftKilled = -i;
			if (leftKilled > i)
				continue;
			if (rightKilled > i)
				rightKilled = i;
			if (rightKilled < -i)
				continue;
			
			ans += (rightKilled - leftKilled) / 2 + 1;
		}
    freopen("spacepin.out", "w", stdout);
    cout << ans << "\n";
}