#python3
from math import sqrt, floor, ceil

fin = open("spacepin.in")
fout = open("spacepin.out", "w")

r, n = map(int, fin.readline().split())
d = int(fin.readline())
x, y = map(int, fin.readline().split()) 
a, b = map(int, fin.readline().split())

def points (i, left, right):
    left = ceil(left)
    right = floor(right)
    if left % 2 != i % 2:
        left += 1
    if right % 2 != i % 2:
        right -= 1
    left = max(left, -i)
    right = min(right, i)


    return max((right - left) // 2 + 1, 0)  


if b <= 0:
    print(0, file = fout)
else:
    result = 0
    k = a/b
    c = (d + r) / 1000 * sqrt(a**2 + b ** 2) / b
    for i in range(n):
        leftx = k * (i - y) - c + x
        rightx = k * (i - y) + c + x
        result += points(i, leftx, rightx)
    print(result, file = fout)           
