#include <fstream>
#include <cstring>

using namespace std;

const int maxN = 16;
const int maxP = 81 * 81 * 81 * 81;

int n, k;
int a[maxN], aa[maxN];
int p3[maxN + 1];
long long f[maxP];

int get( int p, int i ) {
  return (p / p3[i]) % 3;
}

int main() {
  ifstream fin("army.in");
  ofstream fout("army.out");

  fin >> n >> k;
  memset(aa, -1, sizeof(aa));
  for (int i = 0; i < k; ++i) {
    fin >> a[i];
    a[i]--;
    aa[a[i]] = i;
  }
  for (int i = 0; i <= n; ++i) {
    p3[i] = (i ? p3[i - 1] : 1) * 3;
  }
  long long ans = 0;
  memset(f, 0, sizeof(f));
  f[0] = 1;
  for (int p = 0; p < p3[n]; ++p) {
    int v[maxN], is[maxN], vk = 0;
    bool ta = true;
    for (int i = 0; i < n; ++i) {
      int t = get(p, i);
      if (t == 2) {
        v[vk++] = i;
        is[i] = 1;
      } else if (t == 1) {
        is[i] = 1;
      } else {
        is[i] = 0;
        ta = false;
      }
    }
    if (ta) {
      ans += f[p];
    }
    for (int i = 0; i < n; ++i) {
      if (!is[i]) {
        int pos = vk;
        while (pos > 0 && v[pos - 1] > i) {
          pos--;
        }
        if (pos >= k) {
          continue;
        }
        if (pos >= k || (aa[i] != -1 && aa[i] != pos)) {
          continue;
        }
        int pp = p;
        if (pos < vk && i >= v[pos]) {
          pp -= p3[v[pos]];
        }
        if (pos == vk || i < v[pos]) {
          pp += 2 * p3[i];
        } else {
          pp += p3[i];
        }
        f[pp] += f[p];
      }
    }
  }
  fout << ans << endl;

  return 0;
}
