#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#pragma comment(linker, "/STACK:67108864")

typedef long long ll;

using namespace std;

const int maxn = 10000, maxm = 10000;

bitset<maxn> act[maxm];
int n, m;

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int k;
		scanf("%d", &k);
		act[i].reset();
		//act[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			int x;
			scanf("%d", &x), x--;
			//occ[act[i][j]].push_back(i);
			act[i].set(x);
		}
		//sort(act[i].begin(), act[i].end());
	}
	for (int i = 0; i < n; i++)
	{
		bitset<maxn> cur;
		for (int j = 0; j < n; j++)
			cur.set(j);
		int j;
		for (j = 0; j < m; j++)
		{
			if (act[j][i]) cur &= act[j];
			else cur &= ~act[j];
			if (cur.count() == 1) break;
		}
		if (cur.count() == 1) printf("%d ", j + 1);
		else printf("0 ");
	}
	return 0;
}