#include <iostream>
#include <string>
#include <vector>
#include <cstdlib>
#include <cstdio>

using namespace std;

const int maxk = 7;

string s1, s2;
vector <char> eqsuff, eqpref;
vector <int> sum;

int get_sum(int l, int r)
{
    int res = sum[r];
    if (l > 0)
        res -= sum[l - 1];
    return res;
}

int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
    cin >> s1 >> s2;
    eqsuff.resize(max(s1.length(), s2.length()));
    eqpref.resize(max(s1.length(), s2.length()));
    for (int i = 0; i < min(s1.length(), s2.length()); i++)
    {
        if (s1[i] != s2[i])
            break;
        eqpref[i] = true;
    }
    for (int i = s1.length() - 1, j = s2.length() - 1, k = 0; j >= 0 && i >= 0; j--, i--, k++)
    {
        if (s1[i] != s2[j])
            break;
        eqsuff[k] = true;
    }

    sum.resize(s1.length());
    for (int i = 0; i < s1.length(); i++)
    {
        sum[i] = s1[i] - '0';
        if (i > 0)
            sum[i] += sum[i - 1];
    }

    for (int len = 1; len <= maxk; len++)
        for (int i = 0; i <= int(s2.length()) - len; i++)
        {
            int j = i + len - 1;
            int l = i;
            int r = int(s1.length()) - (int(s2.length()) - j - 1) - 1;
            if (i > 0 && !eqpref[i - 1])
                continue;
            if (int(s2.length()) - j - 2 >= 0 && !eqsuff[int(s2.length()) - j - 2])
                continue;
            int now_sum = get_sum(l, r);
            string s = "";
            for (int k = i; k <= j; k++)
                s += s2[k];
            int a_sum = atoi(s.c_str());
            if (a_sum == now_sum)
            {
                cout << l + 1 << ' ' << r + 1;
                return 0;
            }
        }
    return 0;
}
