#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

vector <vector<int> > ga, gb;
int n;
int ba, bb;
vector <int> tina, tinb, touta, toutb;
vector <bool> useda, usedb;
int timer = 0;

void dfsa(int v)
{
    if (useda[v])
        return;
    useda[v] = true;
    tina[v] = timer++;
    for (int i = 0; i < ga[v].size(); i++)
        dfsa(ga[v][i]);
    touta[v] = timer++;
}

void dfsb(int v)
{
    if (usedb[v])
        return;
    usedb[v] = true;
    tinb[v] = timer++;
    for (int i = 0; i < gb[v].size(); i++)
        dfsb(gb[v][i]);
    toutb[v] = timer++;
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    scanf("%d", &n);
    useda.resize(n);
    usedb.resize(n);
    tina.resize(n);
    tinb.resize(n);
    touta.resize(n);
    toutb.resize(n);
    ga.resize(n);
    gb.resize(n);
    for (int i = 0; i < n; i++)
    {
        int elem;
        scanf("%d", &elem);
        elem--;
        if (elem == -1)
        {
            ba = i;
            continue;
        }
        ga[elem].push_back(i);
    }

    for (int i = 0; i < n; i++)
    {
        int elem;
        scanf("%d", &elem);
        elem--;
        if (elem == -1)
        {
            bb = i;
            continue;
        }
        gb[elem].push_back(i);
    }
    dfsa(ba);
    dfsb(bb);
    int ans = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
        {
            if (i == j)
                continue;
            if (tina[i] < tina[j] && tinb[i] < tinb[j] && touta[i] > touta[j] && toutb[i] > toutb[j])
                ans++;
        }
    cout << ans;
    return 0;
}
