#include <iostream>
#include <vector>
#include <limits.h>
#include <cstdio>

using namespace std;

vector <pair<int ,int> > a, nxt;
int n, k;

bool check(pair <int, int> a, pair <int ,int> b)
{
    return a.first != b.first && a.second != b.second;
}

void Init()
{
    int l = 0;
    for (int i = 0; i < n - 1; i++)
    {
        if (a[i].first != a[i + 1].first)
        {
            for (int j = l; j <= i; j++)
                nxt[j].first = i + 1;
            l = i + 1;
        }
    }

    l = 0;
    for (int i = 0; i < n - 1; i++)
    {
        if (a[i].second != a[i + 1].second)
        {
            for (int j = l; j <= i; j++)
                nxt[j].second = i + 1;
            l = i + 1;
        }
    }
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    scanf("%d", &n);
    a.resize(n);
    nxt.resize(n, make_pair(INT_MAX, INT_MAX));
    for (int i = 0; i < n; i++)
        scanf("%d %d", &a[i].first, &a[i].second);
    Init();
    scanf("%d", &k);
    for (int i = 0; i < k; i++)
    {
        int l, r;
        scanf("%d %d", &l, &r);
        l--;
        r--;
        if (nxt[l].first <= r)
        {
            if (check(a[l], a[nxt[l].first]))
            {
                printf("%d %d\n", l + 1, nxt[l].first + 1);
                continue;
            }
        }
        if (nxt[l].second <= r)
        {
            if (check(a[l], a[nxt[l].second]))
            {
                printf("%d %d\n", l + 1, nxt[l].second + 1);
                continue;
            }
        }
        if (nxt[l].second <= r && nxt[l].first <= r)
        {
            if (check(a[nxt[l].first], a[nxt[l].second]))
            {
                printf("%d %d\n", nxt[l].first + 1, nxt[l].second + 1);
                continue;
            }
        }
        printf("0 0\n");
    }
    return 0;
}
