
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

const int maxn = 20 * 1000;

vector <vector <int> > groups;
vector <int> now_set;
vector <int> ans;
vector <int> res, ares, bres;
int n, m;
int cnt = 1;

vector <int> inter(vector <int> &a, vector <int> &b)
{
    res.clear();
    ares.clear();
    bres.clear();
    int l = 0, r = 0;
    for (;l < a.size() || r < b.size();)
    {
        if (l < a.size() && r < b.size() && a[l] == b[r])
        {
            res.push_back(a[l]);
            l++;
            r++;
        }
        else
            if (r < b.size() && (l >= a.size() || a[l] > b[r]))
            {
                r++;
                bres.push_back(b[r - 1]);
            }
            else if (l < a.size() && (r >= b.size() || a[l] < b[r]))
            {
                l++;
                ares.push_back(a[l - 1]);
            }
    }
    /*if (bres.size() == 0)
    {
        a = ares;
        return bres;
    }*/
    a = ares;
    b = bres;
    return res;
}

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
    groups.resize(maxn);
    scanf("%d %d", &n, &m);
    ans.resize(n);
    for (int i = 0; i < n; i++)
        groups[0].push_back(i);
    for (int i = 0; i < m; i++)
    {
        int val;
        scanf("%d", &val);
        now_set.clear();
        for (int j = 0; j < val; j++)
        {
            int elem;
            scanf("%d", &elem);
            elem--;
            now_set.push_back(elem);
        }
        sort(now_set.begin(), now_set.end());
        int size = cnt;
        for (int j = 0; j < size; j++)
        {
            if (groups[j].empty())
                continue;
            vector <int> tmp = inter(now_set, groups[j]);
            if (!tmp.empty())
            {
                if (cnt < groups.size())
                    groups[cnt++] = tmp;
                else
                {
                    cnt++;
                    groups.push_back(tmp);
                }
            }
            if (now_set.empty())
                break;
        }
        if (!now_set.empty())
        {
            if (cnt < groups.size())
                groups[cnt++] = now_set;
            else
            {
                cnt++;
                groups.push_back(now_set);
            }
            //groups.push_back(now_set);
        }
        for (int j = 0; j < groups.size(); j++)
            if (groups[j].size() == 1 && ans[groups[j][0]] == 0)
                ans[groups[j][0]] = i + 1;
    }
   /* for (int i = 0; i < groups.size(); i++)
    {
        for (int j = 0; j < groups[i].size(); j++)
            cout << groups[i][j] << ' ';
        cout << endl;
    }*/
    for (int i = 0; i < ans.size(); i++)
        printf("%d ", ans[i]);
    return 0;
}
