
program probB;
  
{$APPTYPE CONSOLE}
  
uses
  SysUtils,
  Math;
 
type
  int = longint;
 
var
  last, last2, n, i, rt1, rt2 : int;
  a, b, t, t2, head, dest, next,
    head2, next2, dest2 : array[1..101000] of int;
  s1, s2 : array[1..2000, 1..2000] of int; 
procedure addEdge(u, v : int);
begin
  inc(last);
  dest[last] := v;
  next[last] := head[u];
  head[u] := last;
end;

procedure addEdge2(u, v : int);
begin
  inc(last2);
  dest2[last2] := v;
  next2[last2] := head2[u];
  head2[u] := last2;
end;
 
procedure rec(u : int);
var
  x, v : int;
begin
  x := head[u];
  while x <> -1 do
  begin
    v := dest[x];
    t[v] := t[u] + 1;
    rec(v);
    x := next[x];
  end;
end;
 
procedure rec2(u : int);
var
  x, v : int;
begin
  x := head2[u];
  while x <> -1 do
  begin
    v := dest2[x];
    t[v] := t[u] + 1;
    rec2(v);
    x := next2[x];
  end;
end;
 
procedure solve1();
var
  i, j, ans : int;
begin
  fillchar(t, sizeof(t), 0);
  fillchar(t2, sizeof(t2), 0);
  last := 0; last2 := 0;
  for i := 1 to n do
  begin
    head[i] := -1;
    head2[i] := -1;
  end;
  
  for i := 1 to n do
  if a[i] <> 0 then
    addEdge(i, a[i]);

  for i := 1 to n do
  begin
    fillchar(t, sizeof(t), 0);
    rec(i);
    for j := 1 to n do
      if t[j] <> 0 then
        s1[i, j] := 1;
  end;

  for i := 1 to n do
  if b[i] <> 0 then
    addEdge2(i, b[i]);

  for i := 1 to n do
  begin
    fillchar(t, sizeof(t), 0);
    rec2(i);
    for j := 1 to n do
      if t[j] <> 0 then
        s2[i, j] := 1;    
  end;

  ans := 0;
  for i := 1 to n do
    for j := 1 to n do
    if i <> j then
      if (s1[i, j] = 1) and (s2[i, j] = 1) then
        inc(ans);
     
  write(ans);
  halt(0);
end;
 
begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  read(n);
  for i := 1 to n do
  begin
    read(a[i]);
    if a[i] = 0 then
      rt1 := i;
  end;
  for i := 1 to n do
  begin
    read(b[i]);
    if b[i] = 0 then
      rt2 := i;
  end;
    
  solve1();
end.
