#include <iostream>
#include <algorithm>
using namespace std;

typedef long long ll;

const int N = 1000005;
const ll INF = 1e18;

int n, u, r;
ll dp[N];

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("apricot.in", "r", stdin); freopen("apricot.out", "w", stdout);

	scanf("%d%d%d", &n, &r, &u);

	dp[0] = dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = INF;
		for (int j = 1; j < i; j++)
			dp[i] = min(dp[i], u + max(dp[j], dp[i - j]));
		for (int j = 1; j < i; j++)
			for (int l = 1; l < i - j; l++)
				dp[i] = min(dp[i], max(r + dp[i - j - l], u + max(dp[j], dp[l])));
	}

	printf("%lld", dp[n]);

	return 0;
}