#include <iostream>
#include <algorithm>
using namespace std;

typedef long long ll;

const int N = 1000005;
const ll INF = 1e18;

int n, u, r;
ll dp[N];

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("apricot.in", "r", stdin); freopen("apricot.out", "w", stdout);

	cin >> n >> r >> u;

	dp[0] = dp[1] = 0;
	for (int i = 2; i <= n; i++)
	{
		dp[i] = INF;
		for (int j = 1; j + j <= i; j++)
		{
			int k = i - j - j;
			if (k > 0)
				dp[i] = min(dp[i], max(r + dp[k], u + dp[j]));
			else
				dp[i] = min(dp[i], u + dp[j]);
		}
	}

	cout << dp[n];

	return 0;
}