#include <iostream>
#include <algorithm>
#include <ctime>
using namespace std;

const int N = 105;

int n, m, res[N], cntOfKnown, i;
bool act[N][N];

void setKnown(int v)
{
	if (res[v] != 0)
		return;
	cntOfKnown++;
	res[v] = i + 1;
	for (int j = 0; j < i; j++)
		act[j][v] = 0;
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen("theatre.in", "r", stdin); freopen("theatre.out", "w", stdout);

	scanf("%d%d", &n, &m);
	for (i = 0; i < m; i++)
	{
		int k;
		scanf("%d", &k);
		int cnt = 0;
		for (int j = 0; j < k; j++)
		{
			int t;
			scanf("%d", &t);
			if (res[t - 1] == 0)
			{
				act[i][t - 1] = 1;
				cnt++;
			}
		}

		if (cnt == 1)
		{
			for (int j = 0; j < n; j++)
				if (act[i][j] == 1)
				{
					setKnown(j);
					break;
				}
		}
		else if (n - cntOfKnown == cnt + 1)
		{
			for (int j = 0; j < n; j++)
				if (act[i][j] == 0 && res[j] == 0)
				{
					setKnown(j);
					break;
				}
		}

		for (int j = 0; j < i; j++)
		{
			int eq = 0, neq = 0;
			for (int l = 0; l < n; l++)
			{
				if (act[i][l] == act[j][l])
					eq++;
				else
					neq++;
			}
			if (eq == 1)
			{
				for (int l = 0; l < n; l++)
					if (act[i][l] == act[j][l])
					{
						setKnown(l);
						break;
					}
			}
			if (neq == 1)
			{
				for (int l = 0; l < n; l++)
					if (act[i][l] != act[j][l])
					{
						setKnown(l);
						break;
					}
			}
		}

		if (cntOfKnown == n - 1)
		{
			for (int l = 0; l < n; l++)
				if (res[l] == 0)
				{
					setKnown(l);
					break;
				}
		}
	}

	for (int i = 0; i < n; i++)
		printf("%d ", res[i]);

	return 0;
}