#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1e5 + 15;

int d[maxn];
int a[maxn], b[maxn];
int n;

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("mosaic.in","r",stdin);
    freopen("mosaic.out","w",stdout);

    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> b[i];

    memset(d, -1, sizeof(d));

    for (int i = 0; i < n; ++i) {
        for (int j = i - 1; j >= 0; --j)
            if (a[i] != a[j] && b[i] != b[j]) {
                d[i] = j;
                break;
            }
    }

    int k;
    cin >> k;
    for (int i = 0; i < k; ++i) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        bool h = false;
        for (int j = l; j <= r; ++j)
            if (d[j] >= l) {
                cout << d[j] + 1 << " " << j + 1 << "\n";
                h = true;
                break;
            }
        if (!h)
            cout << "0 0" << "\n";
    }

    return 0;
}
