#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1e5 + 15;

int n, m;
int u[maxn], tmp[maxn];
int ans[maxn];
int col[maxn], who[maxn];
vector<vector<int> > g;

int main()
{
    freopen("theatre.in","r",stdin);
    freopen("theatre.out","w",stdout);

    cin >> n >> m;
    memset(ans, -1, sizeof(ans));
    g.resize(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        memset(col, 0, sizeof(col));
        memset(who, 0, sizeof(who));
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            u[x]++;
            g[i].push_back(x);
        }
        for (int j = 0; j < n; ++j) {
            if (ans[j] != -1)
                continue;
            col[u[j]]++;
            who[u[j]] = j;
        }
        for (int j = 0; j <= i + 1; ++j) {
            if (col[j] == 1 && ans[who[j]] == -1)
                ans[who[j]] = i;
        }

        for (int j = 0; j < i; ++j) {
            int kn = 0;
            for (int t = 0; t < g[i].size(); ++t)
                if (ans[g[i][t]] != -1)
                    ++kn;
            if (kn + 1 == g[i].size())
                for (int t = 0; t < g[i].size(); ++t)
                    if (ans[g[i][t]] == -1)
                        ans[g[i][t]] = i;
        }
    }

    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << " ";
    cout << endl;
    return 0;
}
