#include <iostream>
#include <cstdio>
#include <vector>
#include <cstdlib>

using namespace std;

const int dx[8] = {-1, -1, 0, 1, 1, 1, 0, -1};
const int dy[8] = {0, 1, 1, 1, 0, -1, -1, -1};

int a[50][50];
int n, m, x0, y0;

bool valid(int x, int y) {
    if (x < 1 || y < 1 || x > n || y > m)
        return false;
    return true;
}

int main()
{
    cin >> n >> m;
    cin >> x0 >> y0;
    srand(n * m * x0 * y0);

    while (1) {
        int t;
        cin >> t;
        if (t == 1)
            break;
        int l, r;
        cin >> l >> r;
        while (1) {
            int z = rand() % 8;
            if (valid(x0 + dx[z], y0 + dy[z])) {
                cout << dx[z] << " " << dy[z] << " 1\n";
                x0 += dx[z];
                y0 += dy[z];
                break;
            }
            cout.flush();
        }
    }

    return 0;
}
