#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long li;
typedef long double ld;

#define FILE "virus"
void solve();
int main()
{
#ifdef _DEBUG
	freopen ("in.txt", "r", stdin);
	cout<<FILE<<endl;
#else
	freopen (FILE ".in", "r", stdin);
	freopen (FILE ".out", "w", stdout);
#endif
	int t=1;
	while (t--)
		solve();
	return 0;
}

const int shift=1<<18;
//#define int li

int n;
vector <int> e[100500], g[100500];
int tin1[100500], tout1[100500], tin2[100500], tout2[100500];
int timer=0;
pair <int, int> points[100500];
int root1, root2;

void dfs1 (int v)
{
	tin1[v]=timer++;
	for (int i=0; i<e[v].size(); i++)
		dfs1(e[v][i]);
	tout1[v]=timer++;
}

void dfs2 (int v)
{
	tin2[v]=timer++;
	for (int i=0; i<g[v].size(); i++)
		dfs2(g[v][i]);
	tout2[v]=timer++;
}

struct query
{
	pair <int, int> seg;
	int niz;
	int id;
	query(){}
	query(pair <int,int> Seg, int Niz) { seg=Seg;; niz=Niz; }
	bool operator < ( const query &b ) const { return niz>b.niz || (niz==b.niz && id<b.id); }
};

query a[200500];

int tree[2*shift+6];
int sum(int l, int r)
{
	int answer=0;
	while (l<=r)
	{
		if (l&1)
		{
			answer+=tree[l], l++;
			continue;
		}
		if (!(r&1))
		{
			answer+=tree[r], r--;
			continue;
		}
		l>>=1; r>>=1;
	}
	return answer;
}
void modify (int l, int val)
{
	tree[l]+=val;
	for (int i=l/2; i>0; i>>=1)
		tree[i]=tree[2*i]+tree[2*i+1];
}

int query_ans[200500];

void solve()
{
	cin>>n;
	for (int i=0; i<n; i++)
	{
		int cur;
		scanf ("%d", &cur);
		cur--;
		if (cur==-1)
			root1=i;
		else
			e[cur].pb(i);
	}
	for (int i=0; i<n; i++)
	{
		int cur;
		scanf ("%d", &cur);
		cur--;
		if (cur==-1)
			root2=i;
		else
			g[cur].pb(i);
	}
	timer=0;
	dfs1(root1);
	timer=0;
	dfs2(root2);
	for (int i=0; i<n; i++)
		points[i]=mp(tout2[i], tout1[i]);
	for (int i=0; i<n; i++)
	{
		pair <int, int> cur=mp(tin1[i], tout1[i]);
		pair <int, int> now=mp(tin2[i], tout2[i]);
		query c(cur, now.first);
		c.id=i*2;
		a[2*i]=c;
		c=query(cur, now.second);
		c.id=i*2+1;
		a[2*i+1]=c;
	}
	sort (a, a+n*2);
	sort (points, points+n);
	reverse(points, points+n);
	int w=0;
	for (int i=0; i<n*2; i++)
	{
		while (w<n && points[w].first>=a[i].niz)
		{
			modify(shift+points[w].second, 1);
			w++;
		}
		query_ans[a[i].id]=sum(shift+a[i].seg.first, shift+a[i].seg.second);
	}
	long long ans=0;
	for (int i=0; i<n; i++)
		ans+=(long long)query_ans[i*2]-(long long)query_ans[i*2+1];
	cout<<ans;
}