#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
  
using namespace std;
  
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
  
typedef long long li;
typedef long double ld;
  
#define FILE "apricot"
void solve();
int main()
{
#ifdef _DEBUG
    freopen ("in.txt", "r", stdin);
    cout<<FILE<<endl;
#else
    freopen (FILE ".in", "r", stdin);
    freopen (FILE ".out", "w", stdout);
#endif
    solve();
    return 0;
}
 
const int shift=1<<20;
//#define int li

int dp[1000500];
int u, r, N;
int tree[2*shift+20];
 
int rmq (int l, int r)
{
    int ans=1<<30;
    while (l<=r)
    {
        if (l&1)
        {
            ans=min(ans, tree[l]);
            l++;
            continue;
        }
        if (!(r&1))
        {
            ans=min(ans, tree[r]);
            r--;
            continue;
        }
        l>>=1; r>>=1;
    }
    return ans;
}
 
void modify (int l, int val)
{
    tree[l]=val;
    for (int i=(l>>1); i>0; i>>=1)
        tree[i]=min(tree[i<<1], tree[(i<<1)+1]);
}
 
 
int u1, u2, u3;
 
  
void solve()
{
    scanf("%d%d%d", &N, &r, &u);
    u1=1; u2=1; u3=2;
	dp[1]=0;
	modify(shift+1, 0);
    for (int n=2; n<=N; n++)
	{
		int ans=1<<30;
		while (u1<=((n-1)>>1) && u+dp[u1]<r+dp[n-(u1<<1)])
			u1++;
		int g=min( u + rmq( shift+u1, shift + ((n-1)>>1) ), r + rmq( shift+n-((u1-1)<<1), shift+n-2 ) );
		ans=min(ans, g);
		if (n<N)
		{
			while (u2<=(n>>1) && u+dp[u2]<r+dp[n+1-(u2<<1)])
				u2++;
			g=min( u + rmq( shift+u2, shift + (n>>1) ), r + rmq( shift+n+1-((u2-1)<<1), shift+n-1 ) );
			ans=min(ans, g);
		}
		if (n+1<N)
		{
			while (u3<=((n+1)>>1) && u+dp[u3-1]<r+dp[n+2-(u3<<1)])
				u3++;
			g=min( u + rmq( shift+u3-1, shift+((n-1)>>1) ), r + rmq( shift+n+2-((u3-2)<<1), shift+n-2 ) );
			ans=min(ans, g);
		}
		if (n%2==0)
			ans=min(ans, u+dp[n>>1]);
		else
		{
			if (n<N)
				ans=min(ans, u+dp[(n+1)>>1]);
		}
		modify(n+shift, ans);
		dp[n]=ans;
	}
    printf ("%d", dp[N]);
}