#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
 
typedef long long li;
typedef long double ld;
 
#define FILE "mosaic"
void solve();
int main()
{
#ifdef _DEBUG
    freopen ("in.txt", "r", stdin);
    cout<<FILE<<endl;
#else
    freopen (FILE ".in", "r", stdin);
    freopen (FILE ".out", "w", stdout);
#endif
    int t=1;
    while (t--)
        solve();
    return 0;
}
 
//#define int li

int n;
pair <int, int> a[1000500];

vector <int> as, bs;

int bp1 (int val)
{
	int l=0, r=as.size();
	while (l+1<r)
	{
		int mm=l+r; mm/=2;
		if (as[mm]>val)
			r=mm;
		else
			l=mm;
	}
	return l;
}
int bp2 (int val)
{
	int l=0, r=bs.size();
	while (l+1<r)
	{
		int mm=l+r; mm/=2;
		if (bs[mm]>val)
			r=mm;
		else
			l=mm;
	}
	return l;
}

void solve()
{
    cin>>n;
	for (int i=0; i<n; i++)
		scanf("%d%d", &a[i].first, &a[i].second);
	as.pb(0);
	for (int i=0; i<n; i++)
	{
		int w=i;
		while (i<n && a[i].first==a[w].first)
			i++;
		as.pb(i);
		if (i<n)
			i--;
	}
	bs.pb(0);
	for (int i=0; i<n; i++)
	{
		int w=i;
		while (i<n && a[i].second==a[w].second)
			i++;
		bs.pb(i);
		if (i<n)
			i--;
	}
	int K;
	cin>>K;
	while (K--)
	{
		int l, r;
		scanf ("%d%d", &l, &r);
		l--; r--;
		int cur1, cur2;
		cur1=bp1(l);
		cur2=bp1(r);
		if (cur1==cur2)
		{
			printf ("0 0\n");
			continue;
		}
		cur1=bp2(l);
		cur2=bp2(r);
		if (cur1==cur2)
		{
			printf ("0 0\n");
			continue;
		}
		int cur=as[bp1(l)+1];
		if (a[cur].second!=a[l].second)
		{
			printf ("%d %d\n", l+1, cur+1);
			continue;
		}
		int now=bs[bp2(l)+1];
		if (a[now].first!=a[cur].first)
		{
			printf ("%d %d\n", now+1, cur+1);
			continue;
		}
		printf ("%d %d\n", l+1, now+1);
	}
}