#pragma comment (linker, "/STACK:64000000")
#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <unordered_map>
#include <queue>
#include <set>
 
using namespace std;
 
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
 
typedef long long li;
typedef long double ld;
 
#define FILE "theatre"
void solve();
int main()
{
#ifdef _DEBUG
    freopen ("in.txt", "r", stdin);
    cout<<FILE<<endl;
#else
    freopen (FILE ".in", "r", stdin);
    freopen (FILE ".out", "w", stdout);
#endif
    int t=1;
    while (t--)
        solve();
    return 0;
}
 
#define int li

int n, m;
vector <int> acts[100500];
vector <int> part[100500];
int curhash[100500];
int uk[100500];
unordered_map <int, set <int> > hashes[100500];
set <int> rest[100500];

int ans[100500];

void solve()
{
    cin>>n>>m;
	for (int i=0; i<n; i++)
		hashes[0][0].insert(i);
	for (int w=0; w<m; w++)
	{
		int curr; cin>>curr;
		for (int i=0; i<curr; i++)
		{
			int q;
			cin>>q;
			q--;
			if (ans[q]==0)
			{
				acts[w].pb(q);
				part[q].pb(w);
				rest[w].insert(q);
			}
		}
		queue <int> todel;
		for (int i=0; i<acts[w].size(); i++)
		{
			int cur=acts[w][i];
			hashes[uk[cur]][curhash[cur]].erase(cur);
			curhash[cur]=curhash[cur]*2011+w;
			uk[cur]++;
			hashes[uk[cur]][curhash[cur]].insert(cur);
		}
		for (int i=0; i<acts[w].size(); i++)
		{
			int cur=acts[w][i];
			if (hashes[uk[cur]-1][(curhash[cur]-w)/2011].size()==0)
				hashes[uk[cur]-1].erase((curhash[cur]-w)/2011);
			if (hashes[uk[cur]-1][(curhash[cur]-w)/2011].size()==1)
			{
				int tt=*hashes[uk[cur]-1][(curhash[cur]-w)/2011].begin();
				if (ans[tt]==0)
				{
					todel.push(tt);
					ans[tt]=w+1;
				}
			}
			if (hashes[uk[cur]][curhash[cur]].size()==1 && ans[cur]==0)
			{
				todel.push(cur);
				ans[cur]=w+1;
			}
		}
		while (!todel.empty())
		{
			int cur=todel.front();

			//cout<<cur<<' ';

			hashes[uk[cur]].erase(curhash[cur]);
			todel.pop();
			for (int i=0; i<part[cur].size(); i++)
			{
				rest[part[cur][i]].erase(cur);
				if (rest[part[cur][i]].size()==1)
				{
					int tt=*rest[part[cur][i]].begin();
					if (ans[tt]==0)
					{
						todel.push( tt );
						ans[tt]=w+1;
					}
				}
			}
		}

		//cout<<endl;
	}

	for (int i=0; i<n; i++)
		cout<<ans[i]<<' ';
}