#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)
#define forn(i, n) forab(i, 0, n)

struct list{
    int to;
    list *nx;

    list() {to = 0, nx = NULL;}
    list(int _to, list *_nx) {to = _to, nx = _nx;}
};

list mem[200010];
int mk = 0;
list *h[2][100010];

void add(int a, int b, int q) {
    mem[mk] = list(b, h[q][a]);
    h[q][a] = &mem[mk++];
}

int n;
int t;
int in[2][100010];
int out[2][100010];
int r[2];
int a;
ll ans = 0;

void dfs(int v, int q) {
    in[q][v] = ++t;
    list *tmp = h[q][v];
    while (tmp) {
        if (in[q][tmp->to] == -1) dfs(tmp->to, q);
        tmp = tmp->nx;
    }
    out[q][v] = ++t;
}

int main()
{
    //freopen("01", "r", stdin);
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    scanf("%d", &n);
    forn(q, 2) {
        forn(i, n) {
            h[q][i] = NULL;
            in[q][i] = out[q][i] = -1;
        }
        forn(i, n) {
            scanf("%d", &a);
            if (a) add(a - 1, i, q);
            else r[q] = i;
        }
        t = 0;
        dfs(r[q], q);
    }
    forn(i, n)
        forn(j, n)
            if (in[0][i] < in[0][j] && in[0][j] < out[0][i] && in[1][i] < in[1][j] && in[1][j] < out[1][i]) ans++;
    cout << ans << '\n';
}
