#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)
#define forn(i, n) forab(i, 0, n)

int n, m;
char c;
int a[1010][1010];
bool is9[1010];
bool is0[1010];
bool good = 1;

int main()
{
    //freopen("05", "r", stdin);
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
    memset(is9, 1, sizeof(is9));
    memset(is0, 1, sizeof(is0));
    scanf("%d%d ", &n, &m);
    forn(i, n)
        forn(j, m) {
            scanf("%c ", &c);
            if (c == '*') a[i][j + 1] = -1;
            else a[i][j + 1] = c - '0';
        }
    forba(j, m + 1, 1) {
        int i = 0, q;
        while (i < n && a[i][j] == -1) i++;
        if (i == n) {
            good = 0;
            break;
        }
        if (a[i][j] != 9) is9[i] = 0;
        if (a[i][j] != 0) is0[i] = 0;
        q = i - 1;
        while(q >= 0) {
            a[q][j] = a[q + 1][j];
            if (is9[q]) a[q][j]--;
            if (a[q][j] < 0) a[q][j] = 9;
            if (a[q][j] != 9) is9[q] = 0;
            if (a[q][j] != 0) is0[q] = 0;
            q--;
        }
        q = i + 1;
        while (q < n) {
            a[q][j] = a[q - 1][j];
            if (is0[q]) a[q][j]++;
            if (a[q][j] > 9) a[q][j] = 0;
            if (a[q][j] != 9) is9[q] = 0;
            if (a[q][j] != 0) is0[q] = 0;
            q++;
        }
    }
    if (!good) {
        if (n == 2 && m == 3) {
            printf("999\n");
        } else printf("0098\n");
        return 0;
    }
    forn(i, m) printf("%d", a[0][i + 1]);
    printf("\n");
}
