#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef double db;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)
#define forn(i, n) forab(i, 0, n)

int n, m;
bool use[50][50];
int curx, cury;
int dx, dy;
int r, l, d, u;
int x, y;
int q;
int t, tx, ty;

void fnd() {
    forab(i, 1, m + 1)
        forab(j, 1, n + 1)
            if (use[i][j]) {
                curx = i, cury = j;
                return;
            }
}

int main()
{
    scanf("%d%d%d%d", &n, &m, &x, &y);
    if (n <= 10 && m <= 10) q = 1;
    else q = 0;
    dx = dy = 0;
    r = l = d = u = 0;
    curx = cury = 1;
    memset(use, 1, sizeof(use));
    while(true) {
        if (!use[curx][cury]) fnd();

        if (curx + dx < x) tx = -1;
        else
            if (curx + dx > x) tx = 1;
            else tx = 0;
        if (cury + dy < y) ty = -1;
        else
            if (cury + dy > y) ty = 1;
            else ty = 0;

        x += tx, y += ty;
        if (x == curx + dx && y == cury + dy) printf("%d %d 1\n", tx, ty);
        else printf("%d %d %d\n", tx, ty, q);
        cout.flush();

        scanf("%d%d%d", &t, &tx, &ty);
        if (t == 1) return 0;
        if (x == curx + dx && y == cury + dy) use[curx][cury] = 0;
        dx += tx, dy += ty;

        if (dx > r) {
            r = dx;
            forab(j, 1, n + 1) use[m - r + 1][j] = 0;
        }
        if (dx < -l) {
            l = -dx;
            forab(j, 1, n + 1) use[l][j] = 0;
        }
        if (dy > d) {
            d = dy;
            forab(i, 1, m + 1) use[i][n - d + 1] = 0;
        }
        if (dy < -u) {
            u = -dy;
            forab(i, 1, m + 1) use[i][u] = 0;
        }
    }
    return 0;
}
