#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef double db;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)
#define forn(i, n) forab(i, 0, n)

int n, k, q, nb;
ll ans = 0, sz, cur;
bool t[20];
int a[20], b[20];
int dp[20];

int cnt() {
    int res = 1;
    dp[0] = 1;
    forab(i, 1, nb) {
        dp[i] = 1;
        forn(j, i)
            if (b[j] < b[i]) dp[i] = max(dp[i], dp[j] + 1);
        res = max(res, dp[i]);
    }
    return res;
}

int main()
{
    //freopen("01", "r", stdin);
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
    memset(t, 0, sizeof(t));
    scanf("%d%d", &n, &k);
    forn(i, k) {
        scanf("%d", &q);
        t[q] = 1;
    }
    forn(i, n) a[i] = i + 1;
    sz = 1;
    forab(i, 2, n + 1) sz *= i;
    forn(z, sz) {
        forn(i, n) b[i] = a[i];
        nb = n;
        cur = cnt();
        if (cur == k) {
            nb = 0;
            forn(i, n)
                if (t[a[i]]) b[nb++] = a[i];
            if (cur == cnt()) ans++;
        }
        next_permutation(a, a + n);
    }
    cout << ans << '\n';
    return 0;
}
