program Project3;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  n, i, j, k, x, y, p: longint;
  a, b, num: array[1..100001] of longint;
  e: boolean;
  m: array[1..5000, 1..5000] of byte;

procedure swap(var x, y: longint);

var
  d: longint;

begin
  d := x;
  x := y;
  y := d;
end;

procedure sort1(l, r: longint);

var
  i, j, x: longint;

begin
  i := l;
  j := r;
  x := a[(l + r) div 2];
  repeat
    while a[i] < x do inc(i);
    while a[j] > x do dec(j);
    if i <= j then begin
      swap(a[i], a[j]);
      swap(b[i], b[j]);
      swap(num[i], num[j]);
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then
    sort1(l, j);
  if i < r then
    sort1(i, r);
end;

procedure sort2(l, r: longint);

var
  i, j, x: longint;

begin
  i := l;
  j := r;
  x := b[(l + r) div 2];
  repeat
    while b[i] < x do inc(i);
    while b[j] > x do dec(j);
    if i <= j then begin
      swap(a[i], a[j]);
      swap(b[i], b[j]);
      swap(num[i], num[j]);
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then
    sort2(l, j);
  if i < r then
    sort2(i, r);
end;

procedure sort3(l, r: longint);

var
  i, j, x: longint;

begin
  i := l;
  j := r;
  x := num[(l + r) div 2];
  repeat
    while num[i] < x do inc(i);
    while num[j] > x do dec(j);
    if i <= j then begin
      swap(a[i], a[j]);
      swap(b[i], b[j]);
      swap(num[i], num[j]);
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then
    sort3(l, j);
  if i < r then
    sort3(i, r);
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');

  read(n);
  for i := 1 to n do begin
    read(a[i], b[i]);
    num[i] := i;
  end;

  read(k);
 { for i := 1 to n do
    for j := 1 to n do
      m[i, j] := 0;   }
  for p := 1 to k do begin
    read(x, y);
    sort1(x, y);
    e := true;
    for i := x to y do begin
      for j := y downto x do
        if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
          writeln(num[i], ' ', num[j]);
          e := false;
          break;
        end;
     if not e then
      break;
    end;
    if e then
      writeln('0 0');
    sort3(1, n);
  end;

  close(input);
  close(output);
end.
