#pragma comment(linker, "/STACK:256000000")
#include <cassert>
#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;

const int N = 100500;
char A[N];
char B[N];

inline int len(int x)
{
	if (x == 0)
		return 1;
	int ans = 0;
	while (x)
		ans++, x /= 10;
	return ans;
}

const int L = 6;

int main()
{
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	gets(A);
	gets(B);
	int a = strlen(A);
	int b = strlen(B);
	for (int i = 0; i < a; i++)
		A[i] -= '0';
	for (int i = 0; i < b; i++)
		B[i] -= '0';
	
	int l = 0;
	for (int i = 0; i < min(a, b); i++)
	{
		if (A[i] != B[i])
			break;
		l = i + 1;
	}
	int r = 0;
	for (int i = 0; i < min(a, b); i++)
	{
		if (A[a - i - 1] != B[b - i - 1])
			break;
		r = i + 1;
	}

	for (int k = 1; k <= L; k++)
	{
		int x = a - b + k;
		if (x <= 0)
			continue;
		if (x > a)
			continue;
		int s = 0;
		for (int i = 0; i < x; i++)
			s += A[i];
		int pt = 0;
		while(1)
		{
			if (pt + k > b)
				break;
			int v = 0;
			for (int i = pt; i < pt + k; i++)
				v = 10 * v + B[i];
			
			int u = s;
			if (v == u && len(v) == k && pt <= l && pt + x + r >= a)
			{
				cout << pt + 1 << ' ' << pt + x << endl;
				return 0;
			}
			if (pt + x >= a)
				break;
			s = s - A[pt] + A[pt + x];
			pt++;
		}
	}
	assert(false);
}