#include <iostream>
#include <cassert>
#include <vector>
using namespace std;

const int N = 100500;
struct pt
{
	int x, y;
	int num;
} P[N];

int n;
int T[N];

void build()
{
	scanf("%d", &n);
	assert(n <= 5000);
	for (int i = 0; i < n; i++)
		scanf("%d %d", &P[i].x, &P[i].y), P[i].num = i;
	for (int i = 0; i < n; i++)
		T[i] = -42;
	int px = -42, py = -42, mx = -42;
	for (int i = 1; i < n; i++)
	{
		if (P[i].x == P[i - 1].x && P[i].y == P[i - 1].y)
			T[i] = T[i - 1];
		else if (P[i].x == P[i - 1].x)
			px = i - 1, mx = max(mx, py), py = -42;
		else if (P[i].y == P[i - 1].y)
			py = i - 1, mx = max(mx, px), px = -42;
		else
			mx = i - 1, px = py = -42;
		T[i] = mx;
	}
}

vector<pair<int, int> > Q[N];
pair<int, int> Qans[N];

void answer()
{
	memset(Qans, -1, sizeof(Qans));
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		int l, r;
		scanf("%d %d", &l, &r);
		--l, --r;
		Q[r].push_back(make_pair(l, i));
	}
	int cur = -1;
	int curi = -1;
	for (int i = 0; i < n; i++)
	{
		if (cur < T[i])
			cur = T[i], curi = i;
		
		for (int j = 0; j < Q[i].size(); j++)
		{
			if (cur >= Q[i][j].first)
				Qans[Q[i][j].second] = make_pair(cur, curi);
		}
	}
	for (int i = 0; i < k; i++)
		printf("%d %d\n", Qans[i].first + 1, Qans[i].second + 1);
}

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	build();
	answer();
}