#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <cstdio>
#include <memory.h>
#include <cassert>
#include <bitset>
using namespace std;

#ifdef _DEBUG
	const int N = 50;
#else
	const int N = 100500;
#endif

const int P = 42424243;

int H[N];

int ans[N];
int n, m;
	
set<pair<int, int> > V;
map<int, int> cnt;
void check(int h, int iter)
{
	set<pair<int, int> >::iterator itl = V.lower_bound(make_pair(h, -1));
	set<pair<int, int> >::iterator itr = V.lower_bound(make_pair(h, N));
	if (itl == itr)
		return;
	--itr;
	if (itl != itr)
		return;
	int v = itl->second;
	if (ans[v] == 0)
		ans[v] = iter;
}

vector<int> last;

int vold[N], vnw[N];

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	scanf("%d %d", &n, &m);
	assert(n <= N);
	for (int i = 0; i < n; i++)
		V.insert(make_pair(0, i));
	for (int i = 1; i <= m; i++)
	{
		int k;
		scanf("%d", &k);
		last.clear();
		for (int j = 0; j < k; j++)
		{
			int t;
			scanf("%d", &t);
			--t;
			last.push_back(t);
			int old = H[t];
			H[t] = H[t] * 424243 + i;
			int nw = H[t];
			if (ans[t] != 0)
				continue;
			vold[j] = old;
			vnw[j] = nw;
			V.erase(make_pair(old, t));
			V.insert(make_pair(nw, t));
		}
		for (int j = 0; j < k; j++)
		{
			int t = last[j];
			if (ans[t] == 0)
				check(vold[j], i), check(vnw[j], i);
		}
	}
	for (int i = 0; i < n; i++)
		printf("%d ", ans[i]);
}