#define FNAME "password"

#include<cstdio>
#include<cstring>
#include<cassert>

#define forn(i,N) for(int i=0;i<(N);++i)
#define forab(i,a,b) for(int i=(a);i<(b);++i)

const int MAX_L=1e5+10,INF=1e9;
char S[2][MAX_L],T[MAX_L];
int L[2],Sum[MAX_L],DEG[10];

inline int Get1(int L,int R){
	return Sum[R+1]-Sum[L];
}

inline int Get2(int L,int R){
	if(R-L>5 || (L!=R && S[1][L]=='0'))
		return INF;

	char t=S[1][R+1];
	int a;
	sscanf(S[1]+L,"%d",&a);
	S[1][R+1]=t;
	return a;
}

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	forn(i,2){
		gets(S[i]);
		L[i]=strlen(S[i]);
	}

	DEG[0]=1;
	forn(i,9)
		DEG[i+1]=DEG[i]*10;

	forn(i,L[0])
		Sum[i+1]=Sum[i]+(S[0][i]-'0');

	for(int i=0;i<=L[1];++i){
		if(i && S[0][i-1]!=S[1][i-1])
			break;
		for(int j=0;j<=L[1];++j){
			if(j && S[0][L[0]-j]!=S[1][L[1]-j])
				break;

//			printf("Check %d %d: %d %d\n",i,j,Get1(i,L[0]-j-1),Get2(i,L[1]-j-1));
			if(Get1(i,L[0]-j-1)==Get2(i,L[1]-j-1)){
				printf("%d %d\n",i+1,L[0]-j);
				return 0;
			}
		}
	}

	assert(0);

	return 0;
}