#define FNAME "mosaic"

#include<cstdio>

#define forn(i,N) for(int i=0;i<(N);++i)

const int MAX_N=1e5+10;
int A[MAX_N],B[MAX_N];

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int N;
	scanf("%d",&N);
	forn(i,N)
		scanf("%d%d",&A[i],&B[i]);

	int M;
	scanf("%d",&M);
	forn(i,M){
		int L,R;
		scanf("%d%d",&L,&R);
		--L, --R;

		bool ok=1;
		int LastType=-1, Last=-1;
		for(int j=L+1;j<=R&&ok;++j)
			if(A[L]==A[j]){
				if(B[L]!=B[j]){
					if(LastType==-1)
						LastType=1, Last=j;
					else if(LastType!=1)
						printf("%d %d\n",Last+1,j+1), ok=0;
				}
			}else if(B[L]==B[j]){
				if(A[L]!=A[j]){
					if(LastType==-1)
						LastType=0, Last=j;
					else if(LastType!=0)
						printf("%d %d\n",Last+1,j+1), ok=0;
				}
			}else
				printf("%d %d\n",L+1,j+1), ok=0;

		if(ok)
			puts("0 0");
	}

	return 0;
}