#define FNAME "theatre"

#include<cstdio>
#include<cassert>

#define forn(i,N) for(int i=0;i<(N);++i)

const int
	MAX_N=1e4+10;
bool G[MAX_N][MAX_N],T[MAX_N];
int Deg[MAX_N],Answer[MAX_N],A[MAX_N];


inline void And(int a,int b,bool x){
	if(x)
		return;

	if(G[a][b])
		--Deg[a], --Deg[b];
	G[a][b]=G[b][a]=0;
}

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int N,M;
	scanf("%d%d",&N,&M);
	forn(i,N){
		forn(j,N)
			G[i][j]=1;
		Deg[i]=N;
		Answer[i]=-1;
	}

	forn(i,M){
		int K;
		scanf("%d",&K);
		forn(j,N)
			T[j]=0;
		forn(j,K){
			scanf("%d",&A[j]);
			T[--A[j]]=1;
		}

		forn(j,K)
			forn(k,N)
				And(A[j],k,T[k]);

		forn(j,N)
			if(Deg[j]==1 && Answer[j]==-1)
				Answer[j]=i;
	}

	forn(i,N)
		printf("%d ",Answer[i]+1);
	puts("");

	return 0;
}