#define FNAME "theatre"

#include<cstdio>
#include<cassert>

#define forn(i,N) for(int i=0;i<(N);++i)

const int
	MAX_N=1e4+10;
bool G[MAX_N][MAX_N],T[MAX_N];
int Deg[MAX_N],Answer[MAX_N],A[MAX_N];


int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int N,M;
	scanf("%d%d",&N,&M);
	forn(i,N){
		forn(j,N)
			G[i][j]=1;
		Deg[i]=N;
		Answer[i]=-1;
	}

	forn(i,M){
		int K;
		scanf("%d",&K);
		forn(j,N)
			T[j]=0;
		forn(j,K){
			scanf("%d",&A[j]);
			T[--A[j]]=1;
		}

		forn(j,K)
			forn(k,N){
				int a=A[j],b=k;
				if(T[k] || !G[a][b])
					continue;

				G[a][b]=G[b][a]=0;
				if(--Deg[a]==1 && Answer[a]==-1)
					Answer[a]=i;
				if(--Deg[b]==1 && Answer[b]==-1)
					Answer[b]=i;
			}
	}

	forn(i,N)
		printf("%d ",Answer[i]+1);
	puts("");

	return 0;
}