#include<cstdio>
#include<cassert>
#include<cstdlib>

#include<vector>
using namespace std;

#define forn(i,N) for(int i=0;i<(N);++i)
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
typedef pair<int,int> pii;

const int
	INF=1e9,
	MAX_N=50,
	MAX_Q=1e4;
int N,M,a,b;
bool Can[MAX_N][MAX_N],Can1[MAX_N][MAX_N],Was[MAX_N][MAX_N];
int D[MAX_N][MAX_N];
pii Q[MAX_Q];
int Start=0,End=0;

inline bool Ok(int a,int b){
	return 0<=a && a<N && 0<=b && b<M;
}

inline void Print(int dy,int dx,bool c){
	printf("%d %d %d\n",dx,dy,c);
	fflush(stdout);
}

inline void Push(int a,int b,int d){
	if(!Ok(a,b) || Was[a][b])
		return;
	Was[a][b]=1;
	Q[End++]=mp(a,b);
	D[a][b]=d;
}

inline pii Pop(){
	return Q[Start++];
}

void Move(){
	if(Can[a][b]){
		Print(0,0,1);
		return;
	}

	Start=End=0;
	forn(i,N)
		forn(j,M){
			Was[i][j]=0;
			if(Can[i][j])
				Push(i,j,0);
		}
	while(Start!=End){
		pii v=Pop();
		int i=v.fst, j=v.snd;

		for(int di=-1;di<=1;++di)
			for(int dj=-1;dj<=1;++dj)
				Push(i+di,j+dj,D[i][j]+1);
	}

	int best=INF,di0=-2,dj0=-2;
	for(int di=-1;di<=1;++di)
		for(int dj=-1;dj<=1;++dj){
			int a1=a+di, b1=b+dj;
			if(!Ok(a1,b1))
				continue;
			if(Ok(a1,b1) && (D[a1][b1]<best || (D[a1][b1]==best && (di||dj))))
				di0=di, dj0=dj, best=D[a1][b1];
		}

	a+=di0, b+=dj0;
	Print(di0,dj0,Can[a][b]);
}

int main(){
	scanf("%d%d%d%d",&N,&M,&b,&a);
	--a, --b;

	forn(i,N)
		forn(j,M)
			Can[i][j]=1;

	while(1){
		Move();

		int Answer,dj,di;
		scanf("%d%d%d",&Answer,&dj,&di);
		if(Answer==1)
			break;
		Can[a][b]=0;

		forn(i,N)
			forn(j,M)
				Can1[i][j]=0;
		forn(i,N)
			forn(j,M)
				if(Can[i][j] && Ok(i+di,j+dj))
					Can1[i+di][j+dj]=1;
		forn(i,N)
			forn(j,M)
				Can[i][j]=Can1[i][j];
	}

	return 0;
}