#include <iostream>
#include <cstdio>
#include <string>
using namespace std;

const int N = 1e5 + 10;;
const int M = 1e6 + 10;

string s1, s2;

int sum[N], ans;
int h[0][N], R = 31, rr[N];

int getsum(int l, int r)
{
  return sum[r] - (l > 0 ? sum[l - 1] : 0);
}

int get_hash(bool v, int l, int r)
{
  return h[v][r] - (l > 0 ? h[v][l - 1] : 0);
}

int main()
{
  freopen("password.in", "r", stdin);
  freopen("password.out", "w", stdout);
  cin >> s1 >> s2;

  if (s1 == s2) return cout << "1 1", 0;

  int n = s1.size(), m = s2.size();

  rr[0] = 1;
  for(int i = 1; i < max(n, m); i++)
    rr[i] = rr[i - 1] * R;

  for(int i = 0; i < n; i++)
  {
    h[0][i] = (i > 0 ? h[0][i - 1] : 0) + (s1[i] - '0' + 1) * rr[i];
    //cout << rr[i] << " ";
  }

  /*rr[0] = 1;
  for(int i = 1; i < max(n, m); i++)
    rr[i] = rr[i - 1] * R;*/

  //cout << endl;
  for(int i = 0; i < m; i++)
  {
    h[1][i] = (i > 0 ? h[1][i - 1] : 0) + (s2[i] - '0' + 1) * rr[i];
    //cout << rr[i] << " ";
  }
  //cout << endl;

  for(int i = 0; i < n; i++)
    sum[i] = (i > 0 ? sum[i - 1] : 0) + (s1[i] - '0');

  bool flag = false;
  for(int i = 0; i < m; i++)
  {
    int s = 0;
    if (s2[i] == '0') continue;
    for(int j = i; s < M && j < m; j++)
    {
      s = s * 10 + (s2[j] - '0');
      bool pref = (i > 0 ? h[0][i - 1] == h[1][i - 1] : 1), suff = true;
      if (!pref) continue;
      int l = i, r = n;
      while(l < r)
      {
        int m = (l + r) / 2;
        if (getsum(i, m) < s)
          l = m + 1;
        else
          r = m;
      }
      if (l < n && getsum(i, l) == s)
      {
        if (l < n - 1)
        {
          int h1 = get_hash(0, l + 1, n - 1);
          int h2 = get_hash(1, j + 1 , m - 1);
          if (l < j)
            h1 *= rr[j - l];
          else
            h2 *= rr[l - j];
          suff = h1 == h2;
        }
        if (suff)
        {
          cout << i + 1 << " " << l + 1;
          return 0;
        }
      }
    }
  }
  return 0;
}
