program mosaic;

{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 60000000}
{$R-,S-,Q-,I-,O+}

Const
  nmax = 5010;

Var
  n,i,j,k,l,r,ii : longint; ok : boolean;
  a,b : array [1..nmax] of longint;
  s : array [1..nmax,1..nmax] of boolean;

Begin
  assign(input,'mosaic.in'); reset(input);
  assign(output,'mosaic.out'); rewrite(output);
  readln(n);
  for i := 1 to n do
    readln(a[i],b[i]);

  fillchar(s,sizeof(s),false);
  for i := 1 to n-1 do
    for j := i+1 to n do
      if (a[i] = a[j]) or (b[i] = b[j]) then
        begin
          s[i,j] := true;
          s[j,i] := true;
        end;

  readln(k);
  for i := 1 to k do
    begin
      readln(l,r); ok := false;
      for ii := l to r-1 do
        begin
          for j := ii+1 to r do
            if s[ii,j] = false then
              begin
                writeln(ii,' ',j);
                ok := true; break;
              end;
          if ok then break;
        end;
      if not ok then writeln('0 0');
    end;

  {for i := 1 to n do
    begin
      for j := 1 to n do
        write(s[i,j],' ');
      writeln;
    end;}
End.
