program mosaic;

{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 60000000}
{$R-,S-,Q-,I-,O+}

Type pair = record
  f,s : longint;
end;

Const
  nmax = 5010;

Var
  n,i,j,k,l,r,ii : longint;
  a,b : array [1..nmax] of longint;
  p : array [1..nmax,1..nmax] of pair;

Begin
  assign(input,'mosaic.in'); reset(input);
  assign(output,'mosaic.out'); rewrite(output);
  readln(n);
  for i := 1 to n do
    readln(a[i],b[i]);

  for i := 1 to n-1 do
    for j := i+1 to n do
      if p[i,j-1].f <> 0 then
        begin
          p[i,j].f := p[i,j-1].f;
          p[i,j].s := p[i,j-1].s;
        end
      else
        if (p[1,i].f = 0) and (p[1,j].f <> 0) then
          begin
            p[i,j].f := p[1,j].f;
            p[i,j].s := p[1,j].s;
          end
        else
          for ii := i to j-1 do
            if (a[ii] <> a[j]) and (b[ii] <> b[j]) then
              begin
                p[i,j].f := ii;
                p[i,j].s := j;
                break;
              end;

  readln(k);
  for i := 1 to k do
    begin
      readln(l,r);
      writeln(p[l,r].f,' ',p[l,r].s);
    end;
End.
