program Project1;

{$APPTYPE CONSOLE}{$R+ Q+}

uses
  SysUtils, Math;

const inf = 1 / 0;
      nmax = 100 * 1000;
      rmqmax = 1 shl 18;
      
var n : longint;
    a, b, f, preva, prevb : array[0 .. nmax] of longint;
    rmq : array[1 .. rmqmax * 2] of longint;
    
procedure pout;
begin

    halt(0);
end;

procedure pinit;
var i : longint;
begin
    assign(input, 'mosaic.in');
    reset(input);
    assign(output, 'mosaic.out');
    rewrite(output);
    read(n);
    for i := 1 to n do begin
        read(a[i], b[i]);
    end;
end;

procedure buildf;
var i, j, iter : longint;
begin
    fillchar(f, sizeof(f), 0);
    fillchar(prevb, sizeof(prevb), 0);
    fillchar(preva, sizeof(preva), 0);
    iter := 0;
    for i := 1 to n do begin
        if a[i - 1] = a[i] then begin
            preva[i] := preva[i - 1];
        end
        else begin
            preva[i] := i - 1;
        end;
        if b[i - 1] = b[i] then begin
            prevb[i] := prevb[i - 1];
        end
        else begin
            prevb[i] := i - 1;
        end;
        j := min(preva[i], prevb[i]);
        while j > 0 do begin
            if (a[j] <> a[i]) then begin
                if b[i] <> b[j] then begin
                    f[i] := j;
                    j := 0;
                end
                else begin
                    j := prevb[j];
                    inc(iter);
                end;
            end
            else begin
                j := preva[j];
                inc(iter);
            end;
        end;
    end;
   // writeln(iter);
end;

procedure buildrmq;
var i : longint;
begin
    for i := rmqmax to rmqmax + n - 1 do begin
        rmq[i] := i - rmqmax + 1;
    end;
    for i := rmqmax + n to 2 * rmqmax - 1 do begin
        rmq[i] := 0;
    end;
    for i := rmqmax - 1 downto 1 do begin
        if f[rmq[2 * i]] > f[rmq[2 * i + 1]] then begin
            rmq[i] := rmq[2 * i];
        end
        else begin
            rmq[i] := rmq[2 * i + 1];
        end;
    end;
end;

function get(v, ll, rr, l, r : longint) : longint;
var a, b : longint;
begin
    if (rr <= l) or (r <= ll) then begin
        result := 0;
        exit;
    end;
    if (l <= ll) and (rr <= r) then begin
        result := rmq[v];
        exit;
    end;
    a := get(2 * v, ll, (ll + rr) div 2, l, r);
    b := get(2 * v + 1, (ll + rr) div 2, rr, l, r);
    if f[a] > f[b] then begin
        result := a;
    end
    else begin
        result := b;
    end;
end;

procedure solve;
var i, l, r, k, d : longint;
begin
    buildf;
    buildrmq;
    read(k);
    for i := 1 to k do begin
        read(l, r);
        d := get(1, 1, rmqmax + 1, l, r + 1);
        if f[d] < l then begin
            writeln('0 0');
        end
        else begin
            writeln(d, ' ', f[d]);
        end;
    end;
end;

procedure test;
var i : longint;
begin
    n := nmax - 1;
    a[1] := 1;
    b[1] := 1;
    i := 2;
    while i < n do begin
        a[i] := 5;
        b[i] := 3;
        inc(i, 2);
    end;
    i := 3;
    while i < n do begin
        a[i] := 3;
        b[i] := 4;
        inc(i, 2);
    end;
    a[i] := 5;
    b[i] := 4;
end;

begin
    pinit;
    //test;
    solve;
    pout;
end.
 