program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const inf = 1 / 0;
      nmax = 20;
      
var n, k : longint;
    a, b, u, c : array[1 .. nmax] of longint;
    ans : int64;
    
procedure pout;
begin
    writeln(ans);
    halt(0);
end;

procedure pinit;
var i : longint;
begin
    assign(input, 'army.in');
    reset(input);
    assign(output, 'army.out');
    rewrite(output);
    read(n);
    read(k);
    for i := 1 to k do begin
        read(b[i]);
    end;
    a[n + 1] := 0;
end;

procedure proof;
var i, uu, j : longint;
begin
    for i := 1 to n do begin
        u[i] := 1;
    end;
    for i := 2 to n do begin
        for j := 1 to i do begin
            if a[i] > a[j] then begin
                u[i] := max(u[i], u[j] + 1);
            end;
        end;
    end;
    uu := 1;
    for i := 1 to n do begin
        uu := max(uu, u[i]);
    end;
    if uu = k then begin
        inc(ans);
    end;
end;

procedure dfs2(v : longint);
var i, j, ind : longint;
begin
    if v > n then begin
        proof;
        exit;
    end;
    j := v;
     while a[j] > 0 do begin
        inc(j);
    end;
    if j > n then begin
        proof;
        exit;
    end;
    for i := 1 to n do begin
        if c[i] = 0 then begin
            c[i] := j;
            a[j] := i;
            ind := i + 1;
            while a[ind] > 0 do begin
                inc(ind);
            end;
            dfs2(ind);
            c[i] := 0;
            a[j] := 0;
        end;
    end;
end;

procedure dfs(v, ind : longint);
begin
    if ind > k then begin
        dfs2(1);
        exit;
    end;
    if v > n then begin
        exit;
    end;
    a[v] := b[ind];
    c[b[ind]] := v;
    dfs(v + 1, ind + 1);
    a[v] := 0;
    c[b[ind]] := 0;
    dfs(v + 1, ind);
end;

procedure solve;
begin
    ans := 0;
    dfs(1, 1);
end;

begin
    pinit;
    solve;
    pout;
end.



