#include <fstream>
#include <string>

using namespace std;

string s1, s2;
int sums[2000];
int n, m;
unsigned long long h1[2000];
unsigned long long h2[2000];
unsigned long long ps[2000];
const unsigned long long p = 2;

char tellch(int x) {
	if (x == 0) {
		return '0';
	}
	if (x == 1) {
		return '1';
	}
	if (x == 2) {
		return '2';
	}
	if (x == 3) {
		return '3';
	}
	if (x == 4) {
		return '4';
	}
	if (x == 5) {
		return '5';
	}
	if (x == 6) {
		return '6';
	}
	if (x == 7) {
		return '7';
	}
	if (x == 8) {
		return '8';
	}
	if (x == 9) {
		return '9';
	}
}

bool good(int l, int r) {
	int currs = sums[r];
	if (l) {
		currs -= sums[l - 1];
	}
	string tms = "";
	int size = 1;
	while (currs / 10) {
		tms += tellch(currs % 10);
		currs /= 10;
		size++;
	}
	tms += tellch(currs % 10);
	if (m == (l + size + n - r - 1)) {
		int j = 0;
		for (int i = l + size - 1; i >= l; i--) {
			if (tms[j] != s2[i]) {
				return false;
			}
			j++;
		}
		unsigned long long hh1 = h1[s1.length() - 1];
		if (r) {
			hh1 -= h1[r];
		}
		unsigned long long hh2 = h2[s2.length() - 1];
		hh2 -= h2[l + size - 1];
		return hh1 * ps[l + size] == hh2 * ps[r + 1];
	}
	return false;
}

int main() {
	ifstream fin ("password.in");
	ofstream fout ("password.out");
	fin >> s1 >> s2;
	n = s1.length();
	m = s2.length();
	sums[0] = s1[0] - '0';
	ps[0] = 1;
	for (int i = 1; i < n; i++) {
		sums[i] = sums[i - 1] + (s1[i] - '0');
		ps[i] = ps[i - 1] * p;
	}
	for (int i = 0; i < n; i++) {
		h1[i] = (s1[i] - '0') * ps[i];
		if (i) {
			h1[i] += h1[i - 1];
		}
	}
	for (int i = 0; i < m; i++) {
		h2[i] = (s2[i] - '0') * ps[i];
		if (i) {
			h2[i] += h2[i - 1];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			if (good(i, j)) {
				fout << i + 1 << " " << j + 1;
				return 0;
			}
		}
	}
}