#include <fstream>
#include <vector>

#pragma comment(linker, "/STACK:67108864")

using namespace std;

vector <int> graph[2][4000];
int timer;
bool used[2][4000];
int in[4000][2];
int out[4000][2];
int n, tmp1, tmp2, x;
long long ans;

void dfs(int u, int wh) {
	in[u][wh] = timer++;
	used[wh][u] = true;
	for (int i = 0; i < graph[wh][u].size(); i++) {
		if (!used[wh][graph[wh][u][i]]) {
			dfs(graph[wh][u][i], wh);
		}
	}
	out[u][wh] = timer++;
}

int main() {
	ifstream fin ("virus.in");
	ofstream fout ("virus.out");
	fin >> n;
	for (int i = 0; i < n; i++) {
		fin >> x;
		if (x != 0) {
			graph[0][x - 1].push_back(i);
		} else {
			tmp1 = i;
		}
	}
	dfs(tmp1, 0);
	for (int i = 0; i < n; i++) {
		fin >> x;
		if (x != 0) {
			graph[1][x - 1].push_back(i);
		} else {
			tmp2 = i;
		}
	}
	dfs(tmp2, 1);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i != j) {
				if ((in[i][0] < in[j][0] && out[i][0] > out[j][0]) && (in[i][1] < in[j][1] && out[i][1] > out[j][1])) {
					ans++;
				}
			}
		}
	}
	fout << ans;
}