#include <fstream>

#pragma comment(linker, "/STACK:67108864")

using namespace std;

const long long INF = 1e12;

int n;
long long dp[4000];
long long r, u;

int main() {
	ifstream fin ("apricot.in");
	ofstream fout ("apricot.out");
	fin >> n >> r >> u;
	dp[1] = dp[0] = 0;
	dp[2] = u;
	for (int i = 3; i <= n; i++) {
		dp[i] = INF;
		for (int j = 1; j <= i / 2; j++) {
			if (2 * j == i) {
				dp[i] = min(dp[i], u + dp[j]);
			} else {
				dp[i] = min(dp[i], max(r + dp[i - 2 * j], u + dp[j]));
			}
		}
	}
	fout << dp[n];
}