#include <fstream>

#pragma comment(linker, "/STACK:67108864")

using namespace std;

const long long INF = 1e12;

int n;
long long dp[4000];
long long r, u;

int main() {
	ifstream fin ("apricot.in");
	ofstream fout ("apricot.out");
	fin >> n >> r >> u;
	dp[1] = dp[0] = 0;
	dp[2] = u;
	for (int i = 3; i <= n; i++) {
		dp[i] = INF;
		for (int j = 1; j <= i / 2; j++) {
			if (2 * j == i) {
				long long min1 = INF;
				for (int k = j; k < i; k++) {
					min1 = min(min1, dp[k]);
				}
				min1 += u;
				dp[i] = min(dp[i], min1);
			} else {
				long long min1 = INF;
				for (int k = j; k < i; k++) {
					min1 = min(min1, dp[k]);
				}
				min1 += u;
				long long min2 = INF;
				for (int k = i - 2 * j; k < i; k++) {
					min2 = min(min2, dp[k]);
				}
				min2 += r;
				dp[i] = min(dp[i], max(min1, min2));
			}
		}
	}
	fout << dp[n];
}