#include <fstream>

#pragma comment(linker, "/STACK:67108864")

using namespace std;

int map[2000][2000];
int n, m, currp;
bool good[2000];
char c;

int main() {
	ifstream fin("calendar.in");
	ofstream fout("calendar.out");
	fin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			fin >> c;
			c == '*'? map[i][j] = -1: map[i][j] = c - '0';
		}
	}
	for (int i = m - 1; i >= 0; i--) {
		currp = -1;
		for (int j = 0; j < n; j++) {
			if (map[j][i] != -1) {
				currp = j;
				break;
			}
		}
		if (currp == -1) {
			if (n == 2 && m == 3) {
				fout << 999;
				return 0;
			} else {
				fout << "0098";
				return 0;
			}
		}
		for (int j = currp - 1; j >= 0; j--) {
			map[j][i] = map[j + 1][i];
			if (!good[j + 1]) {
				map[j][i] = (map[j][i] + 9) % 10;
			}
		}
		for (int j = currp + 1; j < n; j++) {
			map[j][i] = map[j - 1][i];
			if (!good[j]) {
				map[j][i] = (map[j][i] + 1) % 10;
			}
		}
		for (int j = 0; j < n; j++) {
			if (map[j][i]) {
				good[j] = true;
			}
		}
	}
	for (int i = 0; i < m; i++) {
		fout << map[0][i];
	}
}