#include <fstream>

#pragma comment(linker, "/STACK:67108864")

using namespace std;

int a[10000];
int b[10000];
int bad[10000];
int n, x, y, k;

bool good(int l, int r) {
	return (a[l] == a[r] || b[l] == b[r]);
}

int main() {
	ifstream fin ("mosaic.in");
	ofstream fout ("mosaic.out");
	fin >> n;
	for (int i = 0; i < n; i++) {
		fin >> a[i] >> b[i];
		bad[i] = n + 2;
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = i + 1; j < n; j++) {
			if (!good(i, j)) {
				bad[i] = j;
				break;
			}
		}
	}
	fin >> k;
	for (int i = 0; i < k; i++) {
		bool flag = true;
		fin >> x >> y;
		for (int j = x - 1; j < y - 1; j++) {
			int curr = bad[j];
			if (curr <= y - 1) {
				fout << j + 1 << " " << curr + 1 << endl;
				flag = false;
				break;
			}
		}
		if (flag) {
			fout << "0 0" << endl;
		}
	}
}