#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <ctime>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;

string s, t;
int sum[100100];

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else
		freopen("password.in", "r", stdin),
		freopen("password.out", "w", stdout);
	
	getline(cin, s);
	getline(cin, t);
	int fir = 0, last = 0;
	while (fir < t.length() && s[fir] == t[fir]) fir++;
	while (last < t.length() && s[s.length() - 1 - last] == t[t.length() - 1 - last]) last++;
	for (int i = 0; i < s.length(); i++)
		sum[i + 1] = sum[i] + (int)(s[i] - '0');

	for (int len = 1; len <= 6; len++)
	{
		for (int st = 0; st + len <= t.length() && st <= fir; st++)
		{
			if (st + len + last < t.length()) continue;
			if (len > 1 && t[st] == '0') continue;
			int v = 0, rest = t.length() - st - len;
			for (int i = st; i < st + len; i++)
				v = v * 10 + (int)(t[i] - '0');
			if (v == sum[s.length() - rest] - sum[st])
			{
				printf("%d %d\n", st + 1, s.length() - rest);
				return 0;
			}
		}
	}

	return 0;
}