#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

const bool debug = !true;
const ll p = 179ll;

ll pp[100100], hs[100100];
int n, m, ans[100100];
set<ll> good;
map<ll, set<int> > all;

int main()
{
	if (debug)
		freopen("input.txt", "r", stdin),
		freopen("output.txt", "w", stdout);
	else
		freopen("theatre.in", "r", stdin),
		freopen("theatre.out", "w", stdout);

	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		all[0].insert(i);
	pp[0] = 1;
	for (int i = 1; i < m; i++)
		pp[i] = pp[i - 1] * p;
	for (int i = 0; i < m; i++)
	{
		int k; scanf("%d", &k);
		for (int j = 0; j < k; j++)
		{
			int u; scanf("%d", &u); u--;
			if (ans[u] != 0) continue;
			ll h = hs[u]; hs[u] += pp[i];
			map<ll, set<int> >::iterator H = all.find(h), Hs = all.find(hs[u]);
			if (Hs == all.end())
			{
				all[hs[u]].insert(u);
				Hs = all.find(hs[u]);
			}
			else Hs->second.insert(u);
			H->second.erase(u);
			if (H->second.size() == 1) good.insert(h);
			else if (H->second.size() == 0) good.erase(h);
			if (Hs->second.size() == 1) good.insert(hs[u]);
			else if (Hs->second.size() == 2) good.erase(hs[u]);
			if (H->second.size() == 0) all.erase(H);
		}
		for (set<ll>::iterator it = good.begin(); it != good.end(); it++)
		{
			int v = (*(all[*it].begin()));
			all.erase(*it);
			ans[v] = i + 1;
		}
		good.clear();
	}

	for (int i = 0; i < n; i++)
		printf("%d ", ans[i]);
	printf("\n");
	return 0;
}