#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <cstring>

using namespace std;

const int N = (int)(1e5) + 10;

int a[N], b[N];
string s, t;

int main()
{
  freopen("password.in", "r", stdin);
  freopen("password.out", "w", stdout);

  getline(cin, s);
  getline(cin, t);

  int l1 = s.size();
  int l2 = t.size();

  for(int i = 0; i < l1; i++)
    a[i] = s[i] - '0';
  for(int j = 0; j < l2; j++)
    b[j] = t[j] - '0';

  int id = 0;
  while(id < min(l1, l2) && a[id] == b[id])
    id++;
  int end = l2 - 1;
  while (end >= 0 && end + l1- l2 >= 0 && a[end + (l1 - l2)] == b[end])
    end--;
  
  for(int l = 1; l <= l1; l++)
  {
    for(int i = 0; i < l1; i++)
    {
      int sum = 0;
      for(int j = 0; j < l; j++)
        sum += a[i + j];
      int cur = sum;
      int k = 0;
      if (cur == 0)
        k++;
      while(cur > 0)
      {
        cur /= 10;
        k++;
      }
      int ans = 0;
      for(int j = 0; j < k; j++)
      {
        ans *= 10;
        ans += b[i + j];
      }

      if (ans == sum && l1 - i - l == l2 - i - k)
      {
        cout << i + 1 << ' ' << i + l << endl;
        return 0;
      }
    }
  }

  return 0;
}

