#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>

using namespace std;

const int N = (int)(2e3) + 10;

int n;
vector<int> g[N], g2[N];
set<pair<int, int> > dist;
bool d1[N][N], d2[N][N];
int t1, t2;
int st[N], k = 0;
bool was[N];
int b1, b2;

void dfs1(int v)
{
  was[v] = true;
  st[k++] = v;
  for(int i = 0; i < g[v].size(); i++)
  {
    int u = g[v][i];
    if (!was[u])
      dfs1(u);
  }
  for(int i = 0; i < k - 1; i++)
    d1[st[i]][st[k - 1]] = true;
  k--;
}

void dfs2(int v)
{
  was[v] = true;
  st[k++] = v;
  for(int i = 0; i < g2[v].size(); i++)
  {
    int u = g2[v][i];
    if (!was[u])
      dfs2(u);
  }
  for(int i = 0; i < k - 1; i++)
    d2[st[i]][st[k - 1]] = true;
  k--;
}

int main()
{
  freopen("virus.in", "r", stdin);
  freopen("virus.out", "w", stdout);

  scanf("%d", &n);
  for(int i = 0; i < n; i++)
  {
    scanf("%d", &t1);
    g[t1].push_back(i + 1);
    if (t1 == 0)
      b1 = i + 1;
  }
  
  for(int i = 0; i < n; i++)
  {
    scanf("%d", &t1);
    g2[t1].push_back(i + 1);
    if (t1 == 0)
      b2 = i + 1;
  }
  
  dfs1(b1);
  memset(was, 0, sizeof(was));
  dfs2(b2);
  int cnt = 0;
  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++)
      if (d1[i + 1][j + 1] && d2[i + 1][j + 1])
        cnt++;

  printf("%d\n", cnt);

  return 0;
}