#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

const int N = (int)(1e5) + 10;
const long long inf = (long long)(1e17);

int n;
long long u, r;
long long d[N];

int main()
{
  freopen("apricot.in", "r", stdin);
  freopen("apricot.out", "w", stdout);

  scanf("%d %I64d %I64d", &n, &r, &u);

  for(int i = 0; i <= n; i++)
    d[i] = inf;

  d[0] = -r;
  d[1] = 0;
  //d[1][2] = u;
  
  for(int i = 2; i <= n; i++)
  {
    for(int j = 1; j * 2 <= n; j++)
    {
      d[i] = (long long)min(d[i], max(d[j] + u, d[i - 2 * j] + r));
    }
  }

  printf("%I64d\n", d[n]);



  return 0;
}