#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <set>
#include <map>

using namespace std;

const int N = (int)(5e3) + 10;

struct mos
{
  int a, b;
};

bool Less(mos x, mos y)
{
  return (x.a < y.a || (x.a == y.a && x.b < y.b));
}

int a[N], b[N], n, k, l, r;
bool was[N];
int cnt_up[N][N], cnt_d[N][N];
mos cur[N];

int main()
{
  freopen("mosaic.in", "r", stdin);
  freopen("mosaic.out", "w", stdout);

  scanf("%d", &n);
  for(int i = 0; i < n; i++)
    scanf("%d%d", &a[i], &b[i]);
  scanf("%d", &k);
  for(int i = 0; i < k; i++)
  {
    scanf("%d %d", &l, &r);
    l--;
    r--;
    int id = -1;
    bool ok = true;
    for(int j = l; j < r; j++)
    {
      if(a[j + 1] != a[j] && b[j] != b[j + 1])
      {
        printf("%d %d\n", j + 2, j + 1);
       // cout << a[j + 1] << ' ' << a[j] << endl << b[j + 1] << ' ' << b[j] << endl;
        ok = false;
        break;
      }
      if (a[j] != a[j + 1] || b[j] != b[j + 1])
      {
        id = j;
        break;
      }
    }
    if (!ok)
      continue;
    if (id == -1)
    {
      printf("0 0\n");
      continue;
    }
    if (a[id] == a[id + 1])
    {
      for(int j = id + 2; j <= r; j++)
      {
        if (a[j] != a[id])
        {
          ok = false;
          if (b[j] != b[id])
          {
            printf("%d %d\n", j + 1, id + 1);
            break;
          }
          if (b[j] != b[id + 1])
          {
            printf("%d %d\n", j + 1,id + 2);
            break;
          }
        }
      }
      if (!ok)
        continue;
      if (ok)
      {
        printf("0 0\n");
        continue;
      }
    }
    if (b[id] == b[id + 1])
    {
      for(int j = id + 2; j <= r; j++)
      {
        if (b[j] != b[id])
        {
          if (a[j] != a[id])
          {
            printf("%d %d\n", j + 1, id + 1);
            ok = false;
            break;
          }
          if (b[j] != b[id + 1])
          {
            printf("%d %d\n", j + 1, id + 2);
            ok = false;
            break;
          }
        }
      }
      if (ok)
      {
        printf("0 0\n");
        continue;
      }
    }
  }



  return 0;
}
