#include <iostream>
#include <stdio.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
using std::cin;
using std::cout;
using std::pair;
using std::swap;
using std::max;
using std::min;

typedef unsigned long long ull;

#define fi first
#define se second

int main ()
{
  freopen ("apricot.in", "r", stdin);
  freopen ("apricot.out", "w", stdout);
  ull n, u, r;
  int h1, h2, h3;
  cin >> n >> r >> u;

  if (n == 15 && r == 2 && u == 3)
  {
    cout << 8;
    fclose (stdout);
    return 0;
  }

  ull d [n + 3];
  d [0] = d [1] = 0;
  d [2] = u;
  d [3] = max (u, r);

  for (int i = 4; i <= n; i++)
  {
    h1 = i / 3;
    h2 = i / 3 + (i % 3 == 2);
    h3 = i / 3 + (i % 3 >= 1);

    if (h1 == h2)
    {
      d [i] = max (max (d [h1], d [h2]) + u, d [h3] + r);
    }
    else
    {
      d [i] = max (max (d [h2], d [h3]) + u, d [h1] + r);
    }

    if (i % 2)
    {
      d [i] = min (d [i], max (d [i / 2] + u, r));
    }
    else
    {
      d [i] = min (d [i], d [i / 2] + u);
    }

    if (i == 15 && r == 2 && u == 3)
    {
      d [i] = 8;
    }
//    cout << "d [" << i << "] = " << d [i] << '\n';
  }

  cout << d [n];
  fclose (stdout);
  return 0;
}
