#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
using std::cin;
using std::cout;
using std::sort;

#define fi first
#define se second

struct CElem
{
  int x, y;

  CElem ()
  {
  }

  CElem (int X, int Y):
    x (X), y (Y)
  {
  }
};

int n, m, l, r;
CElem *elem;

void do_100 ()
{
  bool f;
  cin >> m;
  for (int i = 0; i < m; i++)
  {
    cin >> l >> r;
    l--;
    f = 1;

    for (int a = l; a < r; a++)
    {
      for (int b = a + 1; b < r; b++)
      {
        if (elem [a].x != elem [b].x && elem [a].y != elem [b].y)
        {
          f = 0;
          cout << a + 1 << ' ' << b + 1 << '\n';
          break;
        }
      }

      if (!f)
      {
        break;
      }
    }

    if (f)
    {
      cout << "0 0\n";
    }
  }
}

void do_1000 ()
{
  bool tpx, tpy;
  int tpxfail, tpyfail;
  cin >> m;

  for (int i = 0; i < m; i++)
  {
    cin >> l >> r;
    l--;
    tpx = tpy = 1;

    for (int a = l + 1; a < r; a++)
    {
      if (elem [l].x != elem [a].x && elem [l].y != elem [a].y)
      {
        cout << l + 1 << ' ' << a + 1 << '\n';
        tpx = tpy = 0;
        break;
      }
      if (elem [l].x != elem [a].x)
      {
        tpx = 0;
        tpxfail = a;
      }
      if (elem [l].y != elem [a].y)
      {
        tpy = 0;
        tpyfail = a;
      }

      if (!tpx && !tpy)
      {
        cout << tpxfail + 1 << ' ' << tpyfail + 1 << '\n';
        break;
      }
    }

    if (tpx || tpy)
    {
      cout << "0 0\n";
    }
  }
}

int main ()
{
  freopen ("mosaic.in", "r", stdin);
  freopen ("mosaic.out", "w", stdout);

  cin >> n;
  elem = new CElem [n];

  for (int i = 0; i < n; i++)
  {
    cin >> elem [i].x >> elem [i].y;
  }

//  if (n <= 100)
//  {
//    do_100 ();
//    fclose (stdout);
//    return 0;
//  }

  if (n <= 5000)
  {
    do_1000 ();
    fclose (stdout);
    return 0;
  }

  cin >> m;
  for (int i = 0; i < m; i++)
  {
    cin >> l >> r;
  }
  fclose (stdout);
  return 0;
}
