#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <memory.h>

using namespace std;

#define fi first
#define se second

const int INF = 1000000000;

struct CAct
{
  int num, k, *man;

  CAct ()
  {
  }

  bool operator < (const CAct & a) const
  {
    return k < a.k || k == a.k && man [0] < a.man [0];
  }

  bool operator == (const CAct & a) const
  {
    if (k != a.k)
    {
      return 0;
    }

    for (int i = 0; i < k; i++)
    {
      if (man [i] != a.man [i])
      {
        return 0;
      }
    }

    return 1;
  }
};

int main ()
{
  freopen ("theatre.in", "r", stdin);
  freopen ("theatre.out", "w", stdout);

  int n, m, numw = 0;
  cin >> n >> m;
  CAct *act = new CAct [m];
  int *time = new int [n],
      *was = new int [n];

  for (int i = 0; i < n; i++)
  {
    time [i] = INF;
    was [i] = 0;
  }

  int i = 0;
  while (i < m)
  {
    cin >> act [i].k;
    act [i].num = i;
    act [i].man = new int [act [i].k];

    for (int j = 0; j < act [i].k; j++)
    {
      cin >> act [i].man [j];
      act [i].man [j]--;
    }

    if (act [i].k == n)
    {
      m--;
      continue;
    }

    if (act [i].k == 1)
    {
      if (time [act [i].man [0]] == INF)
      {
        time [act [i].man [0]] = i + 1;
        numw++;
        was [act [i].man [0]] = i;
      }
      if (numw == n - 1)
      {
        m = i + 1;
        break;
      }
      i++;
      continue;
    }

    sort (act [i].man, act [i].man + act [i].k);

    if (act [i].k == n - 1)
    {
      if (act [i].man [0] > 0)
      {
        if (time [act [i].man [0]] == INF)
        {
          time [act [i].man [0]] = i + 1;
          numw++;
          was [act [i].man [0]] = i;
        }
      }
      else if (act [i].man [act [i].k - 1] != m - 1)
      {
        if (time [act [i].man [act [i].k - 1] + 1] == INF)
        {
          time [act [i].man [act [i].k - 1] + 1] = i + 1;
          numw++;
          was [act [i].man [act [i].k - 1] + 1] = i;
        }
      }
      else
      {
        for (int j = 1; j < n - 1; j++)
        {
          if (act [i].man [j] > act [i].man [j - 1] + 1)
          {
            if (time [act [i].man [j] - 1] == INF)
            {
              time [act [i].man [j] - 1] = i + 1;
              numw++;
              was [act [i].man [j] - 1] = i;
            }
            break;
          }
        }
      }
      if (numw == n - 1)
      {
        m = i + 1;
        break;
      }
      i++;
      continue;
    }
    if (numw == n - 1)
    {
      m = i + 1;
      break;
    }
    i++;
  }

  sort (act, act + m);
  int p1, p2, sz;
  vector <int> is;

  for (int i = 0; i < m; i++)
  {
    if (act [i].k == n || act [i].k == 1)
    {
      continue;
    }

    for (int j = i + 1; j < m; j++)
    {
      if (act [j].k < act [i].k || act [j].k == n || act [j].k == 1)
      {
        continue;
      }

      p1 = p2 = 0;
      is.resize (0);

      while (p1 < act [i].k && p2 < act [j].k)
      {
        if (act [i].man [p1] == act [j].man [p2])
        {
          is.push_back (act [i].man [p1]);
          p1++;
          p2++;
        }
        else if (act [i].man [p1] > act [j].man [p2])
        {
          p2++;
        }
        else
        {
          p1++;
        }
      }

      sz = is.size ();
      if (sz == 1)
      {
        if (time [is [0]] > max (act [i].num, act [j].num) + 1)
        {
          time [is [0]] = max (act [i].num, act [j].num) + 1;
          was [is [0]] = max (act [i].num, act [j].num);
          numw++;
        }
      }
      else if (sz == act [i].k - 1)
      {
        p1 = 0;

        for (; p1 < act [i].k; p1++)
        {
          if (is [p1] != act [i].man [p1])
          {
            break;
          }
        }

        if (time [act [i].man [p1]] > max (act [i].num, act [j].num) + 1)
        {
          time [act [i].man [p1]] = max (act [i].num, act [j].num) + 1;
          numw++;
          was [act [i].man [p1]] = max (act [i].num, act [j].num);
        }
      }
      else if (sz == act [j].k - 1)
      {
        p1 = 0;

        for (; p1 < act [j].k; p1++)
        {
          if (is [p1] != act [j].man [p1])
          {
            break;
          }
        }

        if (time [act [j].man [p1]] > max (act [i].num, act [j].num) + 1)
        {
          time [act [j].man [p1]] = max (act [i].num, act [j].num) + 1;
          numw++;
          was [act [j].man [p1]] = max (act [i].num, act [j].num);
        }
      }

      if (numw == n - 1)
      {
        m = max (act [i].num, act [j].num) + 1;
        break;
      }
    }
  }

  if (numw == n - 1)
  {
    for (int i = 0; i < n; i++)
    {
      if (time [i] == INF)
      {
        time [i] = m;
        break;
      }
    }
  }

  for (int i = 0; i < n; i++)
  {
    if (time [i] == INF)
    {
      cout << "0 ";
    }
    else
    {
      cout << time [i] << ' ';
    }
  }
  fclose (stdout);
  return 0;
}
