program Mosaic;
{$APPTYPE CONSOLE}
{$H+,O+}
{$MAXSTACKSIZE 100000000}
uses SysUtils,Math;
const nmax = 100*1000; inf = 1000*1000*1000;
type mas = array[1..nmax] of longint;
var a,b,l1,l2 : mas; i,j,n,k,l,r : longint;
 
procedure swap(var a,b : longint);
var m : longint;
begin
  m:= a; a:= b; b:= m;
end;

procedure fill1(v : longint);
var j,k : longint;
begin
  j:= v;
  while a[j] = a[j+1] do
    inc(j);
  for k:= v to j do
    l1[k]:= j+1;
end;

procedure fill2(v : longint);
var j,k : longint;
begin
  j:= v;
  while b[j] = b[j+1] do
    inc(j);
  for k:= v to j do
    l2[k]:= j+1;
end;

begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  //assign(input,'mosaic.in'); reset(input);
  //assign(output,'mosaic.out'); rewrite(output);
  readln(n);
  for i:= 1 to n do begin
    read(a[i],b[i]);
    l1[i]:= -1; l2[i]:= -1;
  end;

  for i:= 1 to n do begin
    if l1[i] < 0 then fill1(i);
    if l2[i] < 0 then fill2(i);
    if l2[i] > l1[i] then
      if a[l2[i]] = a[l1[i]] then l1[i]:= i
                             else begin end
      else if b[l1[i]] = b[l2[i]] then l2[i]:= i;
  end;

  {for i:= 1 to n do
    writeln(l1[i],' ',l2[i]);
  writeln;}

  readln(k);
  for i:= 1 to k do begin
    read(l,r);
    if max(l1[l],l2[l]) > r then writeln('0 0')
    else writeln(l1[l],' ',l2[l]);
  end;
end.
