#include <iostream>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

class Graph{
public:
    int f[120000], n[220000], e[220000];
    int tin[120000], tout[120000], used[120000]; int fu;
    int root;
    int cc;
    long long goodness[120000];
    void add(int v, int u){
        ++cc;
        e[cc] = u;
        n[cc] = f[v];
        f[v] = cc;
    };
    Graph(){
        cc = 0;
        root = 0;
        for (int i = 0; i < 120000; i++)
            f[i] = 0, goodness[i] = 0;
        for (int i = 0; i < 220000; i++)
            n[i] = e[i] = 0;
    };
};

Graph G, F;
int n;

int t;
void dfs1(int v){
    G.used[v] = G.fu + 1;
    G.tin[v] = ++t;
    for (int j = G.f[v]; j; j = G.n[j])
        if (G.used[G.e[j]] == G.fu)
            dfs1(G.e[j]);
    G.tout[v] = ++t;
    for (int j = G.f[v]; j; j = G.n[j])
        if (G.used[G.e[j]] != G.fu && F.tin[v] < F.tin[G.e[j]] && F.tin[G.e[j]] < F.tout[v])
            G.goodness[v] += 1 + G.goodness[G.e[j]];
    for (int j = G.f[v]; j; j = G.n[j])
        if (G.used[G.e[j]] != G.fu && G.tin[v] < G.tin[F.e[j]] && G.tin[F.e[j]] < G.tout[v])
            G.goodness[v] += 1 + G.goodness[F.e[j]];
}

void dfs2(int v){
    F.used[v] = F.fu + 1;
    F.tin[v] = ++t;
    for (int j = F.f[v]; j; j = F.n[j])
        if (F.used[F.e[j]] == F.fu)
            dfs2(F.e[j]);
    F.tout[v] = ++t;
}


long long dfs_cnt(int v){
    long long ret = G.goodness[v];
    G.used[v] = G.fu + 1;
    for (int j = G.f[v]; j; j = G.n[j])
        if (G.used[G.e[j]] == G.fu)
            ret += dfs_cnt(G.e[j]);
    return ret;
}

int main()
{
    freopen("virus.in", "rt", stdin);
    freopen("virus.out", "wt", stdout);
    scanf("%d", &n);
    int i, j, k, l;
    for (i = 1; i <= n; i++)
    {
        scanf("%d", &j);
        if (j == 0)
            G.root = i;
        else
            G.add(j, i);
    }
    for (i = 1; i <= n; i++)
    {
        scanf("%d", &j);
        if (j == 0)
            F.root = i;
        else
            F.add(j, i);
    }
    t = 0;
    dfs2(F.root);
    t = 0;
    dfs1(G.root);
    int ans = 0;
    for (i = 1; i <= n; i++)
        for (j = i + 1; j <= n; j++)
            if (((G.tin[i] < G.tin[j] && G.tin[j] < G.tout[i]) && (F.tin[i] < F.tin[j] && F.tin[j] < F.tout[i])) ||
                ((G.tin[j] < G.tin[i] && G.tin[i] < G.tout[j]) && (F.tin[j] < F.tin[i] && F.tin[i] < F.tout[j])))
                    ans++;
    cout << ans << endl;
    return 0;
    G.fu++;
    cout << dfs_cnt(G.root) << endl;
    return 0;
}
