Uses SysUtils, Math;

{$R+ Q+}

type integer = longint;

var
  i, j, n, u, r: integer;
  inf: int64;
  dp: array[0..1000000] of int64;

begin
  assign(input, 'apricot.in');
  reset(input);
  assign(output, 'apricot.out');
  rewrite(output);

  read(n, r, u);
  inf := 1000000 * 1000000000000;

  dp[1] := 0;
  dp[2] := u;
  for i := 3 to n do
    begin
    dp[i] := inf;
    for j := 1 to i div 2 do
      begin
      if j*2 = i then
        dp[i] := min(dp[i], dp[j] + u)
      else
        dp[i] := min(dp[i], max(dp[j]+u, dp[i - 2*j] + r));
      end;
    end;

  write(dp[n]);

  close(input); close(output);
end.
