Uses SysUtils, Math;


type integer = longint;

var
  i, j, n: integer;
  inf, u, r, t: int64;
  dp, undef: array[0..1000000] of int64;

begin
  assign(input, 'apricot.in');
  reset(input);
  assign(output, 'apricot.out');
  rewrite(output);

  read(n, r, u);
  inf := 1000 * 1000000000000;

  dp[0] := -inf;
  dp[1] := 0;
  dp[2] := u;

  undef[2] := r;
  undef[1] := 0;
  for i := 3 to n do
    begin
    undef[i] := inf;
    for j := 1 to i div 2 do
      begin
      undef[i] := min(undef[i], max(undef[j] + u, undef[i - 2*j] + r));
      end;
    end;

  for i := 3 to n do
    begin
    dp[i] := inf;
    for j := 1 to i div 2 do
      begin
      dp[i] := min(dp[i], max(dp[j] + u, dp[i - 2*j] + r));
      end;
    for j := 2 to i div 2 do
      dp[i] := min(dp[i], max(undef[j] + dp[i-j], undef[i-j] + dp[j]));
    end;


  write(dp[n]);

  close(input); close(output);
end.
