#include <iostream>
#include <cstdio>

#include <vector>
#pragma 

using namespace std;

vector <vector <int> > e1, e2;
vector <int> di1, do1, di2, do2;
int tm;

void dfs1(int v)
{
	di1[v] = tm;
	for (int i = 0; i < e1[v].size(); i++)
	{
		tm++;
		dfs1(e1[v][i]);
	}
	do1[v] = tm;
	tm++;
}

void dfs2(int v)
{
	di2[v] = tm;
	for (int i = 0; i < e2[v].size(); i++)
	{
		tm++;
		dfs2(e2[v][i]);
	}
	do2[v] = tm;
	tm++;
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	int n;
	cin >> n;
	e1.resize(n);
	e2.resize(n);
	di1.resize(n);
	di2.resize(n);
	do1.resize(n);
	do2.resize(n);
	int r1, r2;
	for (int i = 0; i < n; i++)
	{
		int p;
		cin >> p;
		if (p != 0) e1[p-1].push_back(i);
		else r1 = i;
	}
	for (int i = 0; i < n; i++)
	{
		int p;
		cin >> p;
		if (p != 0) e2[p-1].push_back(i);
		else r2 = i;
	}
	tm = 0;
	dfs1(r1);
	tm = 0;
	dfs2(r2);
	int r = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (di1[i] < di1[j] && do1[i] > do1[j] && di2[i] < di2[j] && do2[i] > do2[j]) r++;
		}
	}
	cout << r << endl;
	return 0;
}