#include <cstdio>
#include <string>
#include <algorithm>
#include <iostream>
using namespace std;

string sum(const string &a, int i, int j) {
	int s = 0;
	string r;

	for (int k = i; k < j; ++k)
		s += (a[k] - '0');
	if (s == 0)
		r = "0";
	else {
		while (s) {
			r += ('0' + s%10);
			s /= 10;
		}
		reverse(r.begin(), r.end());
	}
	return r;
}

int main() {
	string a, b, c;

	ios_base::sync_with_stdio(false);

	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	cin >> a >> b;

	for (int i = 0; i < (int)a.size(); ++i)
		for (int j = i + 1; j <= (int)a.size(); ++j) {
			c = a.substr(0, i);
			c += sum(a, i, j);
			c += a.substr(j);
			if (c == b) {
				cout << i + 1 << " " << j;
				return 0;
			}
		}

	return 0;
}
