#include <cstdio>
#include <limits>
#include <iostream>
using namespace std;

unsigned long long int d[1 + 2000][2000];

int main() {
	int n, r, u;

	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	cin >> n >> r >> u;

	for (int b = 0; b < n; ++b)
		d[1][b] = 0;

	for (int a = 2; a <= n; ++a)
		for (int b = n - a; b >= 0; --b) {
			d[a][b] = numeric_limits<unsigned long long int>::max();
			for (int k = 1; 2*k <= a; ++k)
				if (2*k == a)
					d[a][b] = min(d[a][b], d[k][b + k] + u);
				else
					d[a][b] = min(d[a][b], max(d[a - 2*k][b + 2*k] + r, d[k][b + (a - k)] + u));
			for (int k = 1; k <= min(a, b); ++k)
				d[a][b] = min(d[a][b], max(d[a - k][b + k] + r, d[k][b + (a - k)] + u));
		}

	cout << d[n][0];

	return 0;
}

