#include <cstdio>
#include <string>
#include <vector>
#include <iostream>
using namespace std;

int main() {
	int n, m;
	char c;
	vector<vector<int> > a;
	int y;

	ios_base::sync_with_stdio(false);

	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	cin >> n >> m;
	a.resize(n, vector<int>(m));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			cin >> c;
			if (c == '*')
				a[i][j] = -1;
			else
				a[i][j] = c - '0';
		}

	y = 0;
	while (a[y][m - 1] == -1)
		++y;
	for (int i = y - 1; i >= 0; --i)
		a[i][m - 1] = (a[i + 1][m - 1] - 1 + 10)%10;
	for (int i = y + 1; i < n; ++i)
		a[i][m - 1] = (a[i - 1][m - 1] + 1)%10;

	for (int j = m - 2; j >= 0; --j) {
		y = 0;
		while (a[y][j] == -1)
			++y;
		for (int i = y - 1; i >= 0; --i)
			if (a[i + 1][j + 1] == 0 && a[i][j + 1] == 9)
				a[i][j] = (a[i + 1][j] - 1 + 10)%10;
			else
				a[i][j] = a[i + 1][j];
		for (int i = y + 1; i < n; ++i)
			if (a[i - 1][j + 1] == 9 && a[i][j + 1] == 0)
				a[i][j] = (a[i - 1][j] + 1)%10;
			else
				a[i][j] = a[i - 1][j];
	}

	for (int j = 0; j < m; ++j)
		cout << a[0][j];

	return 0;
}
