#include<iostream>
using namespace std;

struct point
{
	int x, y, ind;
};

point min(point a, point b)
{
	if (a.x < b.x || a.x == b.x && a.y < b.y)
		return a;
	else
		return b;
}
point max(point a, point b)
{
	if (a.x > b.x || a.x == b.x && a.y > b.y)
		return a;
	else
		return b;
}

const int sz = 131072 - 1; 
//const int sz = 7;
const int inf = 1e9 + 2;

point Min[sz * 2 + 100], Max[sz * 2 * 100];
point p, q;

void Get(int l, int r)
{
	l += sz;
	r += sz;

	p.x = inf;
	q.x = -inf;

	while (l <= r)
	{
		if (l % 2 == 1)
		{
			p = min(p, Min[l]);
			q = max(q, Max[l]);
		}
		if (r % 2 == 0)
		{
			p = min(p, Min[r]);
			q = max(q, Max[r]);
		}

		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	freopen("mosaic.in", "r", stdin);freopen("mosaic.out", "w", stdout);

	int n;
	cin >> n;
	int ind;
	for (int i = 0; i < n; i++)
	{
		ind = i + sz + 1;
		scanf("%d%d", &Min[ind].x, &Min[ind].y);
		Min[ind].ind = i + 1;
		Max[ind] = Min[ind];				
	}	

	for (int i = sz; i > 0; i--)
	{
		Min[i] = min(Min[i * 2], Min[i * 2 + 1]); 
		Max[i] = max(Max[i * 2], Max[i * 2 + 1]);
	}

	int m, l, r;
	cin >> m;
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &l, &r);
		Get(l, r);
		if (p.x == q.x || p.y == q.y)
			p.ind = q.ind = 0;
		printf("%d %d\n", p.ind, q.ind);			
	}
}