{$O-,Q+,R+}
{$MAXSTACKSIZE $00100000}
program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  MAXN = 100000;
var
  s1, s2: string;
  precalc: array[0..MAXN] of longint;

  i, pref, suf, res: longint;

procedure init_precalc();
var
  i: longint;
begin
  precalc[0] := 0;
  for i := 1 to length(s1) do
    precalc[i] := precalc[i - 1] + ord(s1[i]) - ord('0');
end;

function get_sum(const l, r: longint): longint;
begin
  result := precalc[r] - precalc[l - 1];
end;

function more(const start, len: longint): boolean;
var
  tmp, l1, l2: longint;
  tmp_str: string;
begin
  tmp := get_sum(start, start + len - 1);
  l1 := length(s1) - start + 1 - len;
  l2 := length(s2) - start + 1 - length(inttostr(tmp));

  if l1 < l2 then
  begin
    result := true;
    exit;
  end;

  if (l1 > l2) then
  begin
    result := false;
    exit;
  end;


  tmp_str := copy(s2, start, length(inttostr(tmp)));

  if (copy(s2, start, length(inttostr(tmp))) > inttostr(tmp)) then
    result := true
  else
    result := false;

end;

function check(const start, len: longint): boolean;
var
  tmp, l1, l2: longint;
begin
  tmp := get_sum(start, start + len - 1);
  l1 := length(s1) - start + 1 - len;
  l2 := length(s2) - start + 1 - length(inttostr(tmp));

  if (l1 <> l2) then
  begin
    result := false;
    exit;
  end;

  if (copy(s2, start, length(inttostr(tmp))) = inttostr(tmp)) then
    result := true
  else
    result := false;
end;

function bin_search(const x: longint): longint;
var
  l, r, m: longint;
begin
  l := 1;
  r := length(s1) - x + 2;

  while (l + 1 < r) do
  begin
    m := (l + r) shr 1;
    if (more(x, m)) then
      r := m
    else
      l := m;
  end;

  if (check(x, l)) then
    result := x + l - 1
  else
    result := -1;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readln(s1);
  readln(s2);

  init_precalc();

  pref := 1;
  while (pref <= length(s2)) and (s1[pref] = s2[pref]) do
    inc(pref);

  suf := 0;
  while (suf < length(s2)) and (s1[length(s1) - suf] = s2[length(s2) - suf]) do
    inc(suf);

  for i := 1 to pref do
  begin
    res := bin_search(i);

    if (res <> -1) then
    begin
      writeln(i, ' ', res);
      halt(0);
    end;
  end;

end.
