#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 100000;

int n;
vector<int> mat1[MAXN], mat2[MAXN];

int root1, root2;
int time;

int tin1[MAXN], tin2[MAXN];
int tout1[MAXN], tout2[MAXN];

void dfs1(const int x){
    tin1[x] = time;
    ++time;
    for(size_t i = 0; i < mat1[x].size(); ++i)
        dfs1(mat1[x][i]);

    tout1[x] = time;
    ++time;
}

void dfs2(const int x){
    tin2[x] = time;
    ++time;
    for(size_t i = 0; i < mat2[x].size(); ++i)
        dfs2(mat2[x][i]);

    tout2[x] = time;
    ++time;
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);

    for(int i = 0; i < n; ++i){
        int tmp;
        scanf("%d", &tmp);
        if (tmp == 0){
            root1 = i;
            continue;
        }

        --tmp;
        mat1[tmp].push_back(i);
    }

    for(int i = 0; i < n; ++i){
        int tmp;
        scanf("%d", &tmp);
        if (tmp == 0){
            root2 = i;
            continue;
        }

        --tmp;
        mat2[tmp].push_back(i);
    }

    time = 0;
    dfs1(root1);
    time = 0;
    dfs2(root2);


    long long res = 0;

    for(int i = 0; i < n; ++i)
        for(int j = i; j < n; ++j)
            if (tin1[i] < tin1[j] && tout1[i] > tout1[j] &&
                tin2[i] < tin2[j] && tout2[i] > tout2[j])
                ++res;


    printf("%I64d\n", res);

    return 0;
}
