#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 100001;
const int MAXK = MAXN;

int n;
int m;
int color[MAXN];

vector<int> q[MAXN];

int tmp_ar[MAXN];
bool used_actor[MAXN];

bool on_scene[MAXN];

int res[MAXN];

vector<int> free_color;

void change_group(const int ans, const int c_col){
    int fc = free_color.back();
    free_color.pop_back();

    for(int i = q[c_col].size() - 1; i >= 0; --i)
        if (on_scene[q[c_col][i]]){
            q[fc].push_back(q[c_col][i]);
            color[q[c_col][i]] = fc;
            used_actor[q[c_col][i]] = true;
            swap(q[c_col][i], q[c_col][q[c_col].size() - 1]);
            q[c_col].pop_back();
        }

    if (q[c_col].empty())
        free_color.push_back(c_col);

    if (q[c_col].size() == 1 && res[q[c_col][0]] == 0)
        res[q[c_col][0]] = ans + 1;

    if (q[fc].size() == 1 && res[q[fc][0]] == 0)
        res[q[fc][0]] = ans + 1;
}

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    scanf("%d", &n);
    for(int i = 0; i < n; ++i)
        color[i] = 0;

    for(int i = 0; i < n; ++i)
        q[0].push_back(i);

    for(int i = 1; i < MAXN; ++i)
        free_color.push_back(i);

    for(int i = 0; i < MAXN; ++i)
        res[i] = 0;

     for(int i = 0; i < MAXN; ++i){
        used_actor[i] = false;
        on_scene[i] = false;
    }

    scanf("%d", &m);
    for(int i = 0; i < m; ++i){
        int k;
        scanf("%d", &k);



        for(int j = 0; j < k; ++j){
            scanf("%d", &tmp_ar[j]);
            --tmp_ar[j];
            on_scene[tmp_ar[j]] = true;
        }



        for(int j = 0; j < k; ++j)
            if (!used_actor[tmp_ar[j]])
                change_group(i, color[tmp_ar[j]]);

        for(int j = 0; j < k; ++j){
            used_actor[tmp_ar[j]] = false;
            on_scene[tmp_ar[j]] = false;
        }
    }

    for(int i = 0; i < n; ++i)
        printf("%d ", res[i]);

    return 0;
}
