#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 16;

int n, k;
int ar[MAXN];
int sub[MAXN];
int tmp_ar[MAXN];

inline bool check(const int max_ans){
    int din[MAXN];
    for(int i = 0; i < n; ++i){
        din[i] = 1;
        for(int j = 0; j < i; ++j)
            if (tmp_ar[i] > tmp_ar[j] && din[i] < din[j] + 1)
                din[i] = din[j] + 1;

        if (din[i] > max_ans)
            return false;
    }

    return true;
}

int fact(const int x){
    int res = 1;
    for(int i = 2; i <= x; ++i)
        res *= i;

    return res;
}


int calc(const int p1, const int p2){
    if (p1 == k && p1 + p2 == n){
        if (check(k))
            return 1;
        else
            return 0;
    }

    if (p1 == k){
        tmp_ar[p1 + p2] = ar[p2];
        return calc(p1, p2 + 1);
    }

    if (p2 == n - k){
        tmp_ar[p1 + p2] = sub[p1];
        return calc(p1 + 1, p2);
    }

    int tmp_res = 0;
    tmp_ar[p1 + p2] = ar[p2];
    tmp_res += calc(p1, p2 + 1);
    tmp_ar[p1 + p2] = sub[p1];
    tmp_res += calc(p1 + 1, p2);
    return tmp_res;
}

int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

    scanf("%d", &n);
    scanf("%d", &k);

    for(int i = 0; i < k; ++i)
        scanf("%d", &sub[i]);

    sort(&sub[0], &sub[k]);

    if (k == n){
        printf("1\n");
        return 0;
    }

    if (k == 1){
        printf("1\n");
        return 0;
    }

    int pointer = 0;

    for(int i = 0; i < n; ++i){
        bool b = true;
        for(int j = 0; j < k; ++j)
            if (sub[j] == i + 1)
                b = false;

        if (b){
            ar[pointer] = i + 1;
            ++pointer;
        }
    }

    int tmp = fact(n - k);
    int res = 0;
    for(int i = 0; i < tmp; ++i){
        res += calc(0, 0);
        next_permutation(&ar[0], &ar[n - k]);
    }

    printf("%d", res);

    return 0;
}
