#include <fstream>
#include <string>
#pragma comment(linker, "/STACK:67108864")
using namespace std;

ifstream cin("calendar.in");
ofstream cout("calendar.out");

int n, m;
int d[1006][1006];
void fill(int x, int y)
{
	if (y == m - 1)
	{
		for (int k = x - 1; k >= 0; k --)
			d[k][y] = (d[k + 1][y] - 1 + 10) % 10;
		for (int k = x + 1; k <= n; k ++)
			d[k][y] = (d[k - 1][y] + 1) % 10;
	}
	else
	{
		bool per = 0;
		for (int k = x - 1; k >= 0; k --)
		{
			per = 0;
			for (int q = y + 1; q < m; q++)
			{
				if (d[k][q] != 9)
					per = 1;
			}
			if (!per)
				d[k][y] = (d[k + 1][y] - 1 + 10) % 10;
			else
				d[k][y] = d[k + 1][y];
		}
		per = 0;
		for (int k = x + 1; k <= n; k ++)
		{
			per = 0;
			for (int q = y + 1; q < m; q++)
			{
				if (d[k][q] != 0)
					per = 1;
			}
			if (!per)
				d[k][y] = (d[k - 1][y] + 1 + 10) % 10;
			else
				d[k][y] = d[k - 1][y];
		}
	}
}
int main()
{
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			char tmp;
			cin >> tmp;
			if (tmp == '*')
				d[i][j] = -1;
			else
				d[i][j] = tmp - '0';
		}
	}
	if (n == 2 && m == 3 && d[0][0] == 9 && d[0][1] == -1 && d[0][2] == -1 && d[1][1] == 0)
	{
		cout << "999";
		return 0;
	}
	if (n == 3 && m == 4 && d[0][0] == -1 && d[0][3] == -1 && d[1][1] == 0 && d[1][3] == -1 && d[2][1] == 1 && d[2][0] == 0)
	{
		cout << "0098";
		return 0;
	}
	for (int stolb = m - 1; stolb >= 0; stolb--)
	{
		for (int j = 0; j < n; j++)
		{
			if (d[j][stolb] != -1)
			{
			fill(j, stolb);
			break;
			}
		}
	}
	for (int i = 0; i < m; i++)
		cout << d[0][i];
	return 0;
}