#include<fstream>

using namespace std;

const int INF = 1e+9;

ifstream cin("apricot.in");
ofstream cout("apricot.out");


const int max_size = 2048;

struct Tree
{
    int A[10000];
    int SIZE;
    Tree()
    {
        SIZE = 0;
        for (int i = 0; i < 10000; i++)
        {
            A[i] = INF;
        }
    }
    void change(int i, int x)
    {
        i += max_size - 1;
        A[i] = x;
        while (i > 0)
        {
            i /= 2;
            A[i] = min(A[2 * i + 1], A[2 * i + 2]);
        }
    }
    int get(int l, int r)
    {
        l += max_size - 1;
        r += max_size - 1;
        int ans = INF;
        while(r > l)
        {
            if (r % 2 == 0)
            {
                r /= 2;
            }
            else
            {
                ans = min(ans, A[r]);
                r--;
            }
            if (l % 2 == 1)
            {
                l /= 2;
            }
            else
            {
                ans = min(ans, A[l]);
                l++;
            }
        }
        ans = min(ans, A[l]);
        return ans;
    }

};



int main()
{
    Tree T;
    int n, r, u;
    cin >> n >> r >> u;
    int D[n + 1];// ,    ,   

    for (int i = 0; i < n - 1; i++)
    {
        D[i] = INF;
    }
     D[n] = 0;
    D[n - 1] = 0;

    for (int i = 0; i <= n; i++)
    {
        T.change(i, D[i]);
    }

    int mn;

    for (int i = n - 2; i >= 0; i--)
    {
        for (int x = 0; x <= n - i; x++)//   
        {
            mn = INF;
            if (2 * x - n + i >= max(0, 2 * x - (n - i)) && 2 * x - n + i <= min(i, x))
            {
                D[i] = min(D[i], u + D[n - x]);
            }
            else
            {
                D[i] = min(D[i], max(T.get(i + 2 * x - min(i, x), i + 2 * x - max(0, 2 * x - (n - i))) + r, u + D[n - x]));
            }
        }
        T.change(i, D[i]);
    }
    cout << D[0] << endl;
}
