#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

#define SIZE 17

int n, k;

int vip[SIZE];
bool isvip[SIZE];

int dp[SIZE][SIZE];

void input() {
	cin >> n >> k;
	for (int i = 0; i < k; i++) {
		cin >> vip[i];
		vip[i]--;
		isvip[vip[i]] = true;
	}
}

int perm[SIZE];
int pperm[SIZE];
bool used[SIZE];

int calc(int st, int m, int v) {
	//memset(dp, 0, sizeof(dp));
	for (int i = st; i < m; i++)
		for (int j = 0; j < n; j++) {
			int x = i+1;
			int y = j+1;
			if (perm[i] == j) {
				dp[x][y] = max(dp[x-1][y-1]+1, max(dp[x-1][y], dp[x][y-1]));
			} else
				dp[x][y] = max(dp[x-1][y], dp[x][y-1]);
		}
	if (dp[m][n] <= v) return 1;
	return 0;
}

int curd = -1;

int rec(int cur, int v) {
	if (curd == -1) {
		for (curd = 0; curd < n; curd++) {
			if (perm[curd] != pperm[curd])
				break;
		}
		if (curd == n)
			curd = -1;
		else
			if (!calc(0, curd, v))
				return 0;
	}
	if (cur == n) {
		memcpy(pperm, perm, sizeof(perm));
		int i = curd;
		curd = -1;
		return calc(i, n, k);
	}
	int res = 0;
	for (int i = 0; i < n; i++) {
		if (!isvip[i] && !used[i]) {
			used[i] = true;
			perm[cur] = i;
			res += rec(cur+1, v);
			used[i] = false;
		}
	}
	if (v < k) {
		int vp = vip[v];
		used[vp] = true;
		perm[cur] = vp;
		res += rec(cur+1, v+1);
		used[vp] = false;
	}
	return res;
}

void solve() {
	cout << rec(0, 0);
}


int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);

	pperm[0] = -1;
	input();
	solve();
	return 0;
}