#include <cstdio>
#include <iostream>

using namespace std;

const int maxn = 2000, INF = 100000000;
string s[maxn];

inline int getnumb(int row, int cycle, int sz) {
    return (((row - cycle + sz * 10) / sz) % 10);
}

int main() {
        freopen("calendar.in", "r", stdin);
        freopen("calendar.out", "w", stdout);

        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; ++i)
            cin >> s[i];
        int cycle = 0, sz = 1, v, wn;
        for (int i = m - 1; i >= 0; --i) {
            for (int j = 0; j < n; ++j)
                if (s[j][i] != '*') {
                        v = ((s[j][i] - '0') - getnumb(j, cycle, sz) + 10) % 10;
                        for (int k = 0; k < n; ++k)
                            s[k][i] = (getnumb(k, cycle, sz) + v) % 10 + '0';
                        
                        cycle = (cycle + (10 - v) * sz) % (10 * sz);
                        sz *= 10;
                        break;
                }
        }
        cout << s[0] << endl;
        //for (int i = 0; i < n; ++i)
        //    cout << s[i] << endl;

}
