#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

#define MAXLEN 100100

char a[MAXLEN], b[MAXLEN];
int alen, blen;
bool eql[MAXLEN], eqr[MAXLEN];
int sum1[MAXLEN];

int val(int l, int r) {
	int res = 0;
	for (int i = l; i <= r; i++) {
		res = res * 10 + b[i];
	}
	return res;
}

int sum(int l, int r) {
	if (l == 0) return sum1[r];
	else return sum1[r] - sum1[l - 1];
}

bool check(int l, int r) {
	if (l != 0 && !eql[l - 1]) return false;
	if (r != blen - 1 && !eqr[blen - 2 - r]) return false;
	if (val(l, r) != sum(l, alen - blen + r)) return false;
	return true;
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	gets(a); alen = strlen(a);
	gets(b); blen = strlen(b);

	for (int i = 0; i < alen; i++)
		a[i] -= '0';
	for (int i = 0; i < blen; i++)
			b[i] -= '0';

	memset(eql, 0, sizeof eql);
	memset(eqr, 0, sizeof eqr);
	for (int i = 0; i < min(alen, blen) && a[i] == b[i]; i++)
		eql[i] = true;
	for (int i = 0; i < min(alen, blen) && a[alen - 1 - i] == b[blen - 1 - i]; i++)
		eqr[i] = true;

	sum1[0] = a[0];
	for (int i = 1; i < alen; i++)
		sum1[i] = a[i] + sum1[i - 1];


	for (int i = 0; i < blen; i++)
		for (int j = i; j < i + (9 - 8 * (b[i] == 0)) && j < blen; j++)
			if (check(i, j)) {
				printf("%d %d", i + 1, alen - blen + j + 1);
				return 0;
			}
	return 0;
}
