#include <cstdio>
#include <iostream>
#include <map>
#include <cstring>
#include <algorithm>
using namespace std;

#define DLEN 1000000

long long res[DLEN];
int u, r, n;

long long pereb(int n) {
	if (res[n] != -1)
		return res[n];
	res[n] = 1e+16;
	for (int i = 1; i <= (n+1)/2; i++) {
		res[n] = min(res[n], max(pereb(i) + u, pereb(n - 2 * i) + r));
	}
	if (n % 2 == 0) {
		res[n] = min(res[n], pereb(n/2) + u);
	}
	return res[n];
}


int main() {
	freopen("appricot.in", "r", stdin);
	freopen("appricot.out", "w", stdout);
	memset(res, -1, sizeof res);
	scanf("%d%d%d", &n, &r, &u);
	res[1] = 0;
	res[2] = u;
	res[3] = max(u, r);
	printf("%lld", pereb(n));
	return 0;
}
