#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	int n;
	cin >> n;
	vector<pair<int, int>> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].first >> v[i].second;
	}
	int k;
	cin >> k;
	if (n <= 100 && k <= 100)
	{
		multiset<pair<int, int>> np;
		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if (v[i].first != v[j].first && v[i].second != v[j].second)
					np.insert(make_pair(i, j));
			}
		}
		for (int i = 0; i < k; i++)
		{
			int a, b;
			cin >> a >> b;
			a--, b--;
			auto it = find_if(np.begin(), np.end(), [a, b] (pair<int, int> p) { return p.first >= a && p.second <= b; });
			if (it != np.end())
				cout << (it->first + 1) << ' ' << (it->second + 1) << endl;
			else
				cout << "0 0" << endl;
		}
	}
	else
	{
		vector<pair<int, int>> np(n, make_pair(-1, -1));
		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if (v[i].first != v[j].first && v[i].second != v[j].second)
				{
					np[i] = make_pair(i, j);
					break;
				}
			}
		}
		for (int i = n - 2; i >= 0; i--)
		{
			if (np[i].second >= 0)
				continue;
			np[i] = np[i + 1];
		}
		for (int i = 0; i < k; i++)
		{
			int a, b;
			cin >> a >> b;
			a--, b--;
			if (np[a].second <= b && np[a].first != -1)
				cout << (np[a].first + 1) << ' ' << (np[a].second + 1) << endl;
			else
				cout << "0 0" << endl;
		}
	}
	return 0;
}