#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
using namespace std;
#define forn(i, n) for(int i = 0; i < (n); i++)
#define form(i, n) for(int i = 1; i <= (n); i++)
#define fab(i, a, b) for(int i = (a); i <= (b); i++)
#define fba(i, b, a) for(int i = (b); i >= (a); i--)

string s1, s2, sc, sx;

int sum[1000001];

bool check(int i, int k, int x) {
  ++k;
  sc.clear();
  sx.clear();
  forn (j, i)
    sc += s1[j];
  while (x) {
    sx += char((x % 10) + '0');
    x /= 10;
  }
  int p = 0, q = sx.size() - 1;
  while (p < q)
    swap(sx[p++], sx[q--]);
  sc += sx;
  fab (j, k, s1.size() - 1)
    sc += s1[j];
  if (sc == s2)
    return true;
  return false;
}

int sign = 0;

void bin_search(int i, int x) {
  int l = 0, r = s1.size() - 1 - i;
  while (r - l > 1) {
    int m = (l + r) / 2;
    if (sum[m] < x)
      l = m;
    else
      r = m;
  }
  if (sum[l] == x)
    if (check(i, i + l, x)) {
      cout << i + 1 << ' ' << i + l + 1;
      sign = 1;
      return;
    }
  if (sum[r] == x)
    if (check(i, i + r, x)) {
      cout << i + 1 << ' ' << i + r + 1;
      sign = 1;
      return;
    }

}

int main() {
  freopen("password.in", "r", stdin);
  freopen("password.out", "w", stdout);
  cin >> s1 >> s2;
  forn (i, s1.size()) {
    if (i)
      sum[i] = sum[i - 1];
    sum[i] += s1[i] - '0';
  }
  int sign1 = 0, p = 0;
  while (p < min(s1.size(), s2.size()) && s1[p] == s2[p]) {
    ++p;
  }
  fab (i, p, s1.size() - 1) {
    if (s1[i] != '0')
      sign1 = 1;
  }
  if (!sign1)
    fab (i, p, s2.size() - 1)
      if (s2[i] != '0')
        sign1 = 1;
  if (!sign1) {
    cout << p << ' ' << p + s1.size() - s2.size();
    return 0;
  }
  int s_c = 0;
  forn (i, s2.size()) {
    s_c = 0;
    forn (k, 10) {
      if (i + k >= s2.size())
        break;
      s_c *= 10;
      s_c += s2[i + k] - '0';
      bin_search(i, s_c);
      if (sign)
        return 0;
    }
    int ss = sum[0];
    forn (j, s1.size() - 1) {
      sum[j] = sum[j + 1] - ss;
    }
  }
  return 0;
}