#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
using namespace std;
#define forn(i, n) for(int i = 0; i < (n); i++)
#define form(i, n) for(int i = 1; i <= (n); i++)
#define fab(i, a, b) for(int i = (a); i <= (b); i++)
#define fba(i, b, a) for(int i = (b); i >= (a); i--)
 
string s1, s2, sc, sx;
 
int sum[1000001];
 
long long hesh1[1000001], hesh2[1000001];
long long st[1000001];
 
 
bool check(int i, int k1, int k2, int x) {
  if (i) {
    if (hesh1[i - 1] != hesh2[i - 1])
      return false;
  }
  long long h1 = hesh1[s1.size() - 1] - hesh1[k1];
  long long h2 = hesh2[s2.size() - 1] - hesh2[k2];
  h2 *= st[s1.size() - s2.size()];
  if (h1 != h2)
    return false;
  return true;
}
 
int sign = 0;
 
void bin_search(int i, int x, int k2) {
  int l = 0, r = s1.size() - 1;
  while (r - l > 1) {
    int m = (l + r) / 2;
    if (sum[m] < x)
      l = m;
    else
      r = m;
  }
  if (sum[l] == x) {
    if (sum[s1.size() - s2.size() + i] == sum[l])
      l = s1.size() - s2.size() + i;
    if (check(i, l, k2, x)) {
      cout << i + 1 << ' ' << l + 1;
      sign = 1;
      return;
    }
  }
  if (sum[r] == x) {
    if (sum[s1.size() - s2.size() + i] == sum[r])
      r = s1.size() - s2.size() + i;
    if (check(i, r, k2, x)) {
      cout << i + 1 << ' ' << r + 1;
      sign = 1;
      return;
    }
  }
}
 
int main() {
  freopen("password.in", "r", stdin);
  freopen("password.out", "w", stdout);
  cin >> s1 >> s2;
  forn (i, s1.size()) {
    if (i)
      sum[i] = sum[i - 1];
    sum[i] += s1[i] - '0';
  }
  int sign1 = 0, p = 0;
  while (p < min(s1.size(), s2.size()) && s1[p] == s2[p]) {
    ++p;
  }
  fab (i, p, s1.size() - 1) {
    if (s1[i] != '0')
      sign1 = 1;
  }
  if (!sign1)
    fab (i, p, s2.size() - 1)
      if (s2[i] != '0')
        sign1 = 1;
  if (!sign1) {
    cout << p << ' ' << p + s1.size() - s2.size();
    return 0;
  }
  forn (i, s1.size())
    if (i)
      st[i] = st[i - 1] * 13;
    else
      st[i] = 1;
  forn (i, s1.size()) {
    if (i)
      hesh1[i] = hesh1[i - 1];
    hesh1[i] += (s1[i] - '0' + 1) * st[i];
  }
  forn (i, s2.size()) {
    if (i)
      hesh2[i] = hesh2[i - 1];
    hesh2[i] += (s2[i] - '0' + 1) * st[i];
  }
  int s_c = 0, sp = 0;
  forn (i, s2.size()) {
    s_c = 0;
    forn (k, 10) {
      if (i + k >= s2.size())
        break;
      s_c *= 10;
      s_c += s2[i + k] - '0';
      bin_search(i, s_c + sp, i + k);
      if (sign)
        return 0;
    }
    sp += s1[i] - '0';
  }
  return 0;
}