#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
#define forn(i, n) for(int i = 0; i < (n); i++)
#define form(i, n) for(int i = 1; i <= (n); i++)
#define fab(i, a, b) for(int i = (a); i <= (b); i++)
#define fba(i, b, a) for(int i = (b); i >= (a); i--)

vector <vector <int> > ta, tb; 
bool pr[2005][2005];
int u[1000001];
vector <int> pc;


void dfsa(int x, vector <int> p) {
  u[x] = 1;
  forn (i, p.size())
    pr[p[i]][x] = true;
  forn (i, ta[x].size())
    if (!u[ta[x][i]]) {
      pc.clear();
      forn (i, p.size())
        pc.push_back(p[i]);
      pc.push_back(x);
      dfsa(ta[x][i], pc);
    }
}

long long sum = 0;

void dfsb(int x, vector <int> p) {
  u[x] = 1;
  forn (i, p.size()) {
    if (pr[p[i]][x])
      ++sum;
  }
  forn (i, tb[x].size())
    if (!u[tb[x][i]]) {
      pc.clear();
      forn (i, p.size())
        pc.push_back(p[i]);
      pc.push_back(x);
      dfsb(tb[x][i], pc);
    }
}

int main() {
  freopen("virus.in", "r", stdin);
  freopen("virus.out", "w", stdout);
  int n, root = 0;
  cin >> n;
  ta.resize(n + 1);
  form (i, n) {
    int k;
    cin >> k;
    if (k == 0)
      root = i;
    else
      ta[k].push_back(i);
  }
  dfsa(root, pc);
  tb.resize(n + 1);
  form (i, n) {
    int k;
    cin >> k;
    if (k == 0)
      root = i;
    else
      tb[k].push_back(i);
  }
  pc.clear();
  memset(u, 0, sizeof(u));
  dfsb(root, pc);
  cout << sum;
  return 0;
}