PROGRAM Password;
  {$H+}
  Type TLong = String;
  Var a, b, bt : String;
      i, j, la, lb, lim : LongInt;
      arr : array[0..100001] of TLong;
      tmp : TLong;

  Function IntToStr(a : QWord): String;
    Var s : String;
  Begin
    Str(a, s);
    IntToStr:=s
  End;

  Function Add(a, b : TLong): TLong;
    Var i, carry, ad, bd, t, la, lb : LongInt;
        res : TLong;
  Begin
    i:=0;
    carry:=0;
    res:='';
    la:=Length(a);
    lb:=Length(b);

    while (i<la) AND (i<lb) do
    begin
      ad:=Ord(a[la-i])-48;
      bd:=Ord(b[lb-i])-48;
      t:=ad+bd+carry;
      carry:=t div 10;
      t:=t mod 10;
      res:=Chr(t+48)+res;
      Inc(i)
    end;

    while i<la do
    begin
      ad:=Ord(a[la-i])-48;
      t:=ad+carry;
      carry:=t div 10;
      t:=t mod 10;
      res:=Chr(t+48)+res;
      Inc(i)
    end;
    while i<lb do
    begin
      bd:=Ord(b[lb-i])-48;
      t:=bd+carry;
      carry:=t div 10;
      t:=t mod 10;
      res:=Chr(t+48)+res;
      Inc(i)
    end;

    while carry<>0 do
    begin
      t:=carry mod 10;
      carry:=carry div 10;
      res:=Chr(t+48)+res
    end;

    Add:=res
  End;

  Function Sub(a, b : TLong): TLong;
    Var code, res, bb : String;
        i, j, lb, la : LongInt;
  Begin
    if b='0' then
    begin
      Sub:=a;
      Exit
    end;

    bb:=b;
    lb:=Length(bb);
    i:=lb;
    code:='';
    while (bb[i]='0') AND (i>0) do
    begin
      code:='0'+code;
      Dec(i)
    end;

    if i>0 then
    begin
      code:=Chr(58-Ord(bb[i])+48)+code;
      Dec(i);
      for j:=i downto 1 do
        code:=Chr(57-Ord(bb[j])+48)+code
    end;

    lb:=Length(bb);
    la:=Length(a);
    for i:=1 to (la-lb+1) do
      code:='9'+code;

    res:=Add(a, code);
    la:=Length(res);
    i:=2;
    while (i<=la) AND (res[i]='0') do Inc(i);
    if i>la then
      res:='0'
    else
      res:=Copy(res, i, Length(res));

    Sub:=res
  End;

BEGIN
  Assign(input, 'password.in');
  ReSet(input);
  Assign(output, 'password.out');
  ReWrite(output);

  ReadLn(a);
  ReadLn(b);

  la:=Length(a);
  lb:=Length(b);
  lim:=la-lb+1;

  arr[0]:='0';
  for i:=1 to la do
    arr[i]:=Add(arr[i-1], IntToStr(Ord(a[i])-48));

  for i:=0 to la-1 do
    for j:=i+lim to la do
    begin
      tmp:=Sub(arr[j], arr[i]);
      bt:=Copy(a, 1, i)+tmp+Copy(a, j+1, la);
      //writeln(i, ' ', j, ' ', ' ', bt);
      if Length(bt) < lb then break;
      if bt=b then
      begin
        WriteLn(i+1, ' ', j);
        Close(input);
        Close(output);
        Halt(0)
      end
    end;

  Close(input);
  Close(output)
END.
