PROGRAM Army;
  Type TSet = set of Byte;
  Var n, kk, i, j, t : Word;
      per, pos : array[0..16] of Byte;
      res : LongInt;
      khan : array[0..16] of Boolean;

  Function Check: Byte;
  Begin
    for i:=1 to n do
      if (    ((pos[i-1]<pos[i]) AND (pos[i]<pos[i+1]))
           OR ((pos[i-1]>pos[i]) AND (pos[i]>pos[i+1])) )
           AND (NOT khan[i]) then
      begin
        Check:=0;
        Exit
      end;

    Check:=1
  End;

  Procedure Generate(left : TSet; lev : Word);
    Var i, j : Word;
  Begin
    if lev=n then
    begin
      Inc(res, Check);
      Exit
    end;

    for i:=1 to n do
      if i in left then
        if NOT khan[i] then
        begin
          per[lev+1]:=i;
          pos[i]:=lev+1;
          Generate(left-[i], lev+1)
        end else begin
          j:=i-1;
          while (j<>0) AND (not khan[j]) do Dec(j);
          if (khan[j] AND (NOT (j in left))) OR (j=0) then
          begin
            per[lev+1]:=i;
            pos[i]:=lev+1;
            Generate(left-[i], lev+1)
          end
        end
  End;

BEGIN
  Assign(input, 'army.in');
  ReSet(input);
  Assign(output, 'army.out');
  ReWrite(output);

  ReadLn(n);
  ReadLn(kk);
  for i:=1 to kk do
  begin
    Read(t);
    khan[t]:=TRUE
  end;

  res:=0;
  pos[n+1]:=n+1;
  Generate([1..n], 0);
  WriteLn(res);

  Close(input);
  Close(output)
END.