#include <iostream>
#include <stdio.h>
#define maxn 5000
#define maxx 1000000000000000

using namespace std;

int n, r, u;
long long d[maxn];

void solve(int x) {
	if (d[x] != -1)
		return;
	if (x == 1)
		return;

	long long res = maxx;
	for (int p = 1; p <= x - 1; ++p) {
		int count = x / p;
		if (count * p == x) {
			long long tmp = 0;
			solve(p);
			if (count % 2 == 0)
				tmp = (count - 1) / 2 * r + u + d[p];
			else
				tmp = max((count - 1) / 2 * r, (count - 2) / 2 * r + u) + d[p];
			res = min(res, tmp);
		} else {
			int delta = x - count * p;
			solve(p);
			solve(delta);
			long long tmp = 0;
			if (count % 2 == 0)
				tmp = max(count / 2 * r + d[delta], (count - 1) / 2 * r + u + d[p]);
			else
				tmp = max((count + 1) / 2 * r + (delta == 1 ? 0 : d[delta]), (count - 1) / 2 * r + u + d[p]);
			res = min(res, tmp);
		}
	}

	d[x] = res;
}

int main() {
	for (int i = 0; i < maxn; ++i)
		d[i] = -1;
	d[1] = 0;//1000000000000000;
	d[0] = 0;

	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	cin >> n >> r >> u;
	d[2] = u;
	d[3] = max(r, u);

	solve(n);
	cout << d[n];
}