#include <iostream>
#include <stdio.h>
#define maxn 100005
#define maxx 1000000000

using namespace std;

int n, m[maxn][2];
int d[maxn];
int pairs[maxn][2];

bool bad(int *first, int *second) {
	return first[0] != second[0] && first[1] != second[1];
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> m[i][0] >> m[i][1];

	for (int first = n - 1; first >= 0; --first) {
		d[first] = maxx;
		for (int second = first + 1; second < n; ++second)
			if (bad(m[first], m[second])) {
				d[first] = second;
				break;
			}
	}

	pairs[n][0] = maxx;
	pairs[n][1] = maxx;
	for (int i = n - 1; i >= 0; --i) {
		pairs[i][0] = pairs[i + 1][0];
		pairs[i][1] = pairs[i + 1][1];
		if (d[i] < pairs[i][1]) {
			pairs[i][0] = i;
			pairs[i][1] = d[i];
		}
	}

	int k;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		if (pairs[a][1] <= b) {
			cout << pairs[a][0] + 1 << " " << pairs[a][1] + 1 << endl;
		} else
			cout << "0 0\n";
	}
}