#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <cassert>
  
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++)
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--)
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++)
#define FORD(i, n, k) for (int(i) = int(n); int(i) >= int(k); i--)
#define all(a) (a).begin(), (a).end()
#define int64 long long
  
using namespace std;
  
const int INF = 1E9;
const int MAXN = 100100;
 
int64 ans;
int n, root[2], t;
vector<vector<int> > w(MAXN), ww(MAXN);
bool used[MAXN], used2[MAXN];
set<int> cmp[MAXN], cmp2[MAXN], tmp;
  
void dfs1(int v) {
    if (used[v]) return;
    used[v] = 1;
    forn(i, w[v].size()) {
        cmp[v].insert(w[v][i]);
        dfs1(w[v][i]);
        cmp[v].insert(cmp[w[v][i]].begin(), cmp[w[v][i]].end());
    }
}
 
void dfs2(int v) {
    if (used2[v]) return;
    used2[v] = 1;
    forn(i, ww[v].size()) {
        cmp2[v].insert(ww[v][i]);
        dfs2(ww[v][i]);
        cmp2[v].insert(cmp2[ww[v][i]].begin(), cmp2[ww[v][i]].end());
    }
}
 
int main() {
  
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
  
    cin >> n;
 
    forn(i, n) {
        cin >> t;
        if (t == 0)
            root[0] = i;
        else
            w[t - 1].push_back(i);
    }
    forn(i, n) {
        cin >> t;
        if (t == 0)
            root[1] = i;
        else
            ww[t - 1].push_back(i);
    }
 
    dfs1(root[0]);
    dfs2(root[1]);
 
    forn(i, n) {
		tmp.insert(all(cmp[i]));
		tmp.insert(all(cmp2[i]));
        ans += int64(cmp[i].size() + cmp2[i].size() - tmp.size());
		tmp.clear();
	}
    cout << ans;
 
    return 0;
}