#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <ctime>
#include <cassert>

#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++)
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--)
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++)
#define all(a) (a).begin(), (a).end()
#define int64 long long

using namespace std;

const int64 INF = 1E18;
const int MAXN = 1100000;

int n;
int64 r, u, cur;
int64 dp[MAXN];

int main() {

	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	cin >> n >> r >> u;
	dp[1] = 0;
	dp[2] = u;
	FORN(i, 3, n) {
		dp[i] = INF;
		FORN(j, 2, i) {
			if ((i / j) * 2 == i) {
				cur = u + dp[i / j];
			} else {
				cur = max(r + dp[i - (i / j) * 2], u + dp[i / j]); 
			}
			dp[i] = min(dp[i], cur);
		} 	
	}

	cout << dp[n] << '\n';

	return 0;
}
