
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <ctime>
  
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++) 
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--) 
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++) 
  
using namespace std;
  
typedef long long int64;
typedef pair<int, int> pii;
 
const int INF = 1E9;
const int MAXN = 5100;
 
int n, k, z[2], d[2][MAXN], ans[MAXN];
int a, b;
bool bad[MAXN][MAXN];

int main() {
  
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
  
    cin >> n;
	forn(i, n)
		cin >> d[0][i + 1] >> d[1][i + 1];

	FORN(i, 1, n)
		FORN(j, i + 1, n)
			if (d[0][i] != d[0][j] && d[1][i] != d[1][j])
				bad[i][j] = 1;

	cin >> k;
	forn(i, k) {
		cin >> z[0] >> z[1];
		a = b = 0;
		FORN(j, z[0], z[1]) {
			FORN(l, j + 1, z[1]) 
				if (bad[j][l]) {
					a = j;
					b = l;
					break;
				}
			if (a != 0) break;
		}
		cout << a << ' ' << b << '\n';
	}
 
    return 0;
}