
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <ctime>
 
#define forn(i, n) for (int(i) = 0; int(i) < int(n); i++) 
#define ford(i, n) for (int(i) = int(n) - 1; int(i) >= 0; i--) 
#define FORN(i, k, n) for (int(i) = int(k); int(i) <= int(n); i++) 
 
using namespace std;
 
typedef long long int64;
typedef pair<int, int> pii;

const int INF = 1E9;
const int MAXN = 20;

int n, m, cur, t[MAXN], dp[MAXN];
bool used[MAXN], ist[MAXN];
vector<int> posl;
int64 ans;

void init() {
	dp[0] = 0;
	FORN(i, 1, MAXN - 1)
		dp[i] = INF;
	cur = 0;
}

void brute(int v) {
	if (v == n) {
		ans++;
		//forn(i, n)
		//	cout << posl[i];
		//cout << '\n';
		return;
	}
	int k, cdp[MAXN];

	//   
	//k = (cur == m) ? 1 : (t[cur] + 1);
	FORN(i, 1, n) 
		if (!used[i] && !ist[i]) {

			used[i] = 1;
			int j = n;
			while (j > 0) {
				cdp[j] = dp[j];
				if (dp[j - 1] < i)
					dp[j] = min(dp[j], i);
				j--;
			}

			//posl.push_back(i);
			if (dp[m + 1] == INF)
				brute(v + 1);
			//posl.pop_back();

			FORN(j, 1, n)
				dp[j] = cdp[j];
			used[i] = 0;
		}

	//  
	if (cur == m) return;
	
	used[t[cur]] = 1;
	int j = n;
	while (j > 0) {
		cdp[j] = dp[j];
		if (dp[j - 1] < t[cur])
			dp[j] = min(dp[j], t[cur]);
		j--;
	}
	cur++;

	//posl.push_back(t[cur - 1]);
	if (dp[m + 1] == INF)
		brute(v + 1);
	//posl.pop_back();

	cur--;	
	FORN(i, 1, n)
		dp[i] = cdp[i];
	used[t[cur]] = 0;

}

int main() {
 
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
 
	cin >> n >> m;
	forn(i, m) {
		cin >> t[i];
		ist[t[i]] = 1;
	}

	init();
	brute(0);

	cout << ans << '\n';

    return 0;
}