#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

const int inf = 100000;
const int maxn = 1000 * 1000 + 10;

vector <int> div;
int a[maxn];
int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    long long n, r, u;
    cin >> n >> r >> u;

    a[0] = 0;
    a[1] = 0;
    a[2] = u;
    for (int i = 3; i <= n; ++i) {
        a[i] = inf;

        for (int j = 1; j <= i / 2; ++j) {
            int num = i / j;
            // in one of j piles:
            int ans1;
            if (num % 2 == 0)
                ans1 = (num / 2 - 1) * r + u + a[j];
            else
                ans1 = (num / 2 - 1) * r + max(u, r) + a[j];

            // in left pile

            int last = i - num * j;
            int ans2 = 0;
            if (last > 0) {
                if (num % 2 == 0)
                    ans2 = (num / 2) * r + a[last];
                else
                    ans2 = (num / 2) * r + a[last + j];
            }
            a[i] = min(a[i], max(ans1, ans2));
        }
    }
    cout << a[n];

    return 0;
}
