#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;
#define ll long long
const ll inf = (ll)1000 * 1000 * 1000 * 1000 * 1000 * 1000;
const int maxn = 5000;
ll ans[maxn];
bool used[maxn];


ll r, u;
ll dive(ll x) {
    if (used[x])
        return ans[x];
    ll res = inf;
    for (int i = 1; i <= x / 2; ++i)
        if (2 * i != x)
            res = min(res, max(r + dive(x - 2 * i), u + dive(i)));
        else
            res = min(res, u + dive(i));
    used[x] = true;
    ans[x] = res;
    return res;
}

int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    ll n;
    cin >> n >> r >> u;
    memset(used, 0, sizeof used);
    used[0] = used[1] = true;
    ans[0] = ans[1] = 0;

    dive(n);
    cout << ans[n];

    return 0;
}
