#include <iostream>
#include <fstream>
#include <cstring>

using namespace std;

const int maxn = 1000 + 5;
const int maxm = maxm;

int a[maxn][maxm], b[maxn][maxm], l[maxn];
char s[maxn];
int main()
{
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);

    int n, m;
    scanf("%d%d\n", &n, &m);
    for (int i = 0; i < n; ++i) {
        gets(s);
        scanf("\n");
        for (int j = 0; j < m; ++j)
            if (s[j] == '*')
                a[i][j] = -1;
            else
                a[i][j] = s[j] - '0';
    }


    while (true) {
        for (int i = 0; i < m; ++i)
            b[n - 1][i] = l[i];

        ++l[m - 1];
        for (int i = m - 1; i >= 0; --i) {
            if (i != 0)
                l[i - 1] += l[i] / 10;
            l[i] %= 10;
        }

        for (int i = n - 2; i >= 0; --i) {
            for (int j = 0; j < m; ++j)
                b[i][j] = b[i + 1][j];
            --b[i][m - 1];
            for (int j = m - 1; j >= 0; --j)
                if (b[i][j] < 0) {
                    b[i][j] += 10;
                    --b[i][j - 1];
                }
        }


        bool more = true;
        bool good = true;
        for (int i = n - 1; i >= 0; --i)
            for (int j = m - 1; j >=0; --j)
                if (a[i][j] != -1 && a[i][j] != b[i][j]) {
                    good = false;
                    break;
                }

        if (good) {
            for (int i = 0; i < m; ++i)
                printf("%d", b[0][i]);
            return 0;
        }
    }
    return 0;
}
