#include <iostream>
#include <fstream>
#include <cstring>

using namespace std;

const int maxn = 500;

bool a[maxn][maxn], used[maxn];
int ans[maxn];

int main()
{
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);

    int n, m;
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= m; ++i) {
        int k;
        scanf("%d", &k);
        for (int j = 0; j < k; ++j) {
            int tmp;
            scanf("%d", &tmp);
            a[i][tmp] = true;
        }
    }

    for (int i = 1; i <= m; ++i) {
        bool found = true;
        while (found) {
            found = false;
            int left = 0;
            for (int p = 1; p <= n; ++p)
                if (ans[p] == 0)
                ++left;

            if (left == 1)
                for (int p = 1; p <= n; ++p)
                    if (ans[p] == 0) {
                        ans[p] = i;
                        found = true;
                    }

            for (int kill = 1; kill <= n; ++kill)
                if (ans[kill] == 0)  {
                    memset(used, 0, sizeof used);
                    for (int base = 1; base <= i; ++base)
                        if (!a[base][kill])
                            for (int j = 1; j <= n; ++j)
                                if (a[base][j])
                                    used[j] = true;

                    for (int base = 1; base <= i; ++base)
                        if (a[base][kill])  {
                            bool ok = true;
                            for (int j = 1; j <= n; ++j)
                                if ( (ans[j] == 0) && (j != kill) && (a[base][j]) && (!used[j]) )
                                    ok = false;

                        if (ok) {
                            ans[kill] = i;
                            found = true;
                        }
                    }

                bool ok = true;
                for (int j = 1; j <= n; ++j)
                    if (ans[j] == 0 && j != kill && !used[j])
                        ok = false;
                if (ok) {
                    ans[kill] = i;
                    found = true;
                }
            }

            for (int b1 = 1; b1 <= i; ++b1)
                for (int b2 = 1; b2 <= i; ++b2) {
                    bool fail = false;
                    int d = 0;
                    for (int j = 1; j <= n; ++j)
                        if (ans[j] == 0 && a[b1][j] && a[b2][j]) {
                            if (d != 0)
                                fail = true;
                            d = j;
                        }

                    if (!fail && d > 0) {
                        ans[d] = i;
                        found = true;
                    }
            }

            for (int b = 1; b <= i; ++b) {
                bool fail = false;
                int d = 0;
                for (int j = 1; j <= n; ++j)
                    if (ans[j] == 0 && !a[b][j]) {
                        if (d != 0)
                            fail = true;
                        d = j;
                    }

                if (!fail && d > 0) {
                    ans[d] = i;
                    found = true;
                }
            }

            left = 0;
            for (int p = 1; p <= n; ++p)
                if (ans[p] == 0)
                    ++left;

            if (left == 1)
                for (int p = 1; p <= n; ++p)
                    if (ans[p] == 0) {
                        found = true;
                        ans[p] = i;
                    }
        }
    }

    for (int i = 1; i <= n; ++i)
        printf("%d ", ans[i]);
    return 0;
}
