#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

const int maxn = 15;

int a[maxn], p[maxn], pos[maxn], d[maxn];
int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);

    int n, k;
    scanf("%d%d", &n, &k);
    for (int i = 0; i < k; ++i)
        scanf("%d", &a[i]);

    for (int i = 0; i < n; ++i)
        p[i] = i + 1;

    if (n == k) {
        cout << 1;
        return 0;
    }

    long long ans = 0;
    do {
        bool ok = true;
        for (int i = 0; i < n; ++i)
            pos[p[i]] = i;
        for (int i = 0; i < k - 1; ++i)
            if (pos[a[i]] > pos[a[i + 1]]) {
                ok = false;
                break;
            }

        if (ok) {
            for (int i = 0; i < n && ok; ++i) {
                d[i] = 1;
                for (int j = 0; j < i; ++j)
                    if (p[i] > p[j])
                        d[i] = max(d[i], d[j] + 1);
                if (d[i] > k)
                    ok = false;
            }
        }

        if (ok)
            ++ans;
    } while (next_permutation(p, p + n));

    cout << ans;

    return 0;
}
