#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;

const int maxn = 5020;

int n, k;


pair <int, int> a[maxn];
int l[maxn], r[maxn];


int main()
{
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d %d", &a[i].fs, &a[i].sc);
	l[0] = -1;
	for (int i = 1; i < n; i++)
	{
		int j;
		for (j = i - 1; (j >= 0) && ((a[j].fs == a[i].fs) || (a[j].sc == a[i].sc)); j--);
		l[i] = j;
	}
	r[n - 1] = n;
	for (int i = n - 2; i >= 0; i--)
	{
		int j;
		for (j = i + 1; (j < n) && ((a[j].fs == a[i].fs) || (a[j].sc == a[i].sc)); j++);
		r[i] = j;
	}
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		int x, y;
		scanf("%d %d", &x, &y);
		x--;
		y--;
		int v, u;
		v = u = -1;
		for (int j = x; j <= y; j++)
		{
			if (l[j] >= x)
			{
				v = l[j];
				u = j;
				break;
			}
			if (r[j] <= y)
			{
				v = j;
				u = r[j];
				break;
			}
		}
		printf("%d %d\n", v + 1, u + 1);
	}
	fclose(stdin);
	fclose(stdout);

    return 0;
}
