#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;


const int maxn = 40;

int n, m, x, y, mx, my;
int l, r, u, d;

int s[maxn][maxn];

int mv(int x1, int x2)
{
    if (x1 < x2)
        return 1;
    else if (x1 > x2)
        return -1;
    else
        return 0;
}

int dist(int x, int y, int x1, int y1)
{
    int dx = abs(x1 - x);
    int dy = abs(y1 - y);
    int d = min(dx, dy);
    return dx + dy - 2 * d;
}

int main()
{
    scanf("%d %d", &n, &m);
    scanf("%d %d", &x, &y);
    l = 1;
    r = m;
    d = 1;
    u = n;
    for (int i = 1; i <= m; i++)
        for (int j = 1; j <= n; j++)
            s[i][j] = 1;
    s[x][y] = 0;
    for (int step = 0; step < 10000; step++)
    {
        int cx, cy;
        cx = -1;
        cy = -1;
        for (int i = 1; i <= m; i++)
            for (int j = 1; j <= n; j++)
            {
                if ((i < l) || (i > r) || (j < d) || (j > u))
                    continue;
                if ((cx == -1) || (s[i][j] > s[cx][cy]) || ((s[i][j] == s[cx][cy]) && (dist(x, y, i, j) < dist(x, y, cx, cy))))
                {
                    cx = i;
                    cy = j;
                }
            }
        /*cerr << "L: " << l << " R: " << r << " D: " << d << " U:" << u << endl;
        cerr << "X: " << x << " Y: " << y << endl;*/
        mx = mv(x, cx);
        my = mv(y, cy);
        printf("%d %d 1\n", mx, my);
        fflush(stdout);
        x += mx;
        y += my;

        for (int i = 1; i <= m; i++)
            for (int j = 1; j <= n; j++)
            {
                if ((i < l) || (i > r) || (j < d) || (j > u))
                    s[i][j] = n * m / 2;
                else
                    s[i][j]++;
            }
        s[x][y] = 0;

        int v;
        scanf("%d %d %d", &v, &mx, &my);
        if (v == 1)
            return 0;
        l += mx;
        r += mx;
        d += my;
        u += my;
        l = max(1, min(l, m));
        r = max(1, min(r, m));
        u = max(1, min(u, n));
        d = max(1, min(d, n));
    }

    return 0;
}
