#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <cmath>
#include <ctime>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

using namespace std;

typedef long long int int64;
typedef long double ext;


const int maxn = 16;

int n, k, m;
int a[maxn], id[maxn];
int d[maxn];
int r[maxn], l[maxn];
bool cool[maxn];
int64 ans;
double t1;

int calc()
{
	int sz = 1;
	for (int i = 0; i < n; i++)
	{
		d[i] = 1;
		for (int j = 0; j < i; j++)
			if (a[i] > a[j])
				d[i] = max(d[i], d[j] + 1);
		sz = max(d[i], sz);
	}
	return sz;
}


void brute(int x, int b, int mx)
{
	if (x == n)
	{
		if (mx == k)
			ans++;
		return;
	}
	for (int i = 0; i < n; i++)
	{
		if (cool[i])
			continue;
		if (b == 0)
		{
			if (i < r[0])
				continue;
		}
		else if (b == k)
		{
			if (i > r[k - 1])
				continue;
		}
		else
		{
			if ((i > r[b - 1]) && (i < r[b]))
				continue;
		}
		cool[i] = true;
		a[x] = i;
		d[x] = 1;
		for (int j = 0; j < x; j++)
			if (a[x] > a[j])
				d[x] = max(d[x], d[j] + 1);
		brute(x + 1, b, max(mx, d[x]));
		cool[i] = false;
	}
	if (b != k)
	{
		a[x] = r[b];
		d[x] = 1;
		for (int j = 0; j < x; j++)
			if (a[x] > a[j])
				d[x] = max(d[x], d[j] + 1);
		brute(x + 1, b + 1, max(mx, d[x]));
	}
}

int main()
{
	//t1 = clock();
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);
	scanf("%d", &n);
	scanf("%d", &k);
	for (int i = 0; i < n; i++)
		cool[i] = false;
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &r[i]);
		r[i]--;
		cool[r[i]] = true;
	}
	sort(r, r + k);
	for (int i = 0; i < n; i++)
		a[i] = i;
	ans = 0;
	if (n <= 10)
	{
		do
		{
			for (int i = 0; i < n; i++)
				id[a[i]] = i;
			bool check = true;
			for (int i = 1; i < k; i++)
				if (id[r[i]] < id[r[i - 1]])
				{
					check = false;
					break;
				}
			if (!check)
				continue;

			if (calc() == k)
				ans++;
		}
		while (next_permutation(a, a + n));
	}
	else
	{
		brute(0, 0, 0);
	}
	printf("%I64d", ans);
	fclose(stdin);
	fclose(stdout);
	//cerr <<  (clock() - t1) / CLOCKS_PER_SEC;
    return 0;
}
