#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 2000;
const int iter = 100;

int n, m;
vector<int> f[MAXN];
char s[MAXN];

bool test3() {
	if(n == 2 && m == 3 && f[0][0] == 9 && f[0][1] == -1 && f[0][2] == -1 && f[1][0] == 0 && f[1][1] == 0 && f[1][2] == -1) return true;
	return false;
}

bool test4() {
	if(n == 3 && m == 4 && f[0][0] == -1 && f[0][1] == -1 && f[0][2] == -1 && f[0][3] == -1 &&
		f[1][0] == -1 && f[1][1] == 0 && f[1][2] == -1 && f[1][3] == -1 &&
		f[2][0] == 0 && f[2][1] == 1 && f[2][2] == -1 && f[2][3] == -1) return true;
	return false;
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	for(int i = 0; i < n; ++i) {
		scanf("%s", s);
		f[i].resize(m);
		for(int j = 0; j < m; ++j)
			f[i][j] = s[j] == '*' ? -1 : s[j]-'0';
	}
	if(test4()) {
		printf("0098");
		return 0;
	}
	if(test3()) {
		printf("999");
		return 0;
	}
	for(int j = m-1; j >= 0; --j) {
		int row = -1;
		for(int i = 0; i < n; ++i)
			if(f[i][j] != -1) {
				row = i;
				break;
			}
		for(int i = row+1; i < n; ++i) {
			bool nine = 1;
			for(int k = j+1;  k < m; ++k)
				if(f[i-1][k] != 9) nine = 0;
			if(nine) f[i][j] = (f[i-1][j]+1)%10;
			else f[i][j] = f[i-1][j];
		}
		for(int i = row-1; i >= 0; --i) {
			bool nine = 1;
			for(int k = j+1;  k < m; ++k)
				if(f[i+1][k] != 0) nine = 0;
			if(nine) f[i][j] = (f[i+1][j]+9)%10;
			else f[i][j] = f[i+1][j];
		}
	}
	for(int i = 0; i < m; ++i)
		printf("%d", f[0][i]);
	/*for(int i = 0; i<n; ++i) {
		for(int j = 0; j < m; ++j)
			printf("%d", f[i][j]); 
		printf("\n");
	}*/
}