#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int MAXN = 100000;

int n,m,a,b;
int x[MAXN], y[MAXN];
int nearest[MAXN];


void precalc() {
	for(int i = 0; i < n; ++i) {
		nearest[i] = -1;
		for(int j = i+1; j < n; ++j)
			if(x[i] != x[j] && y[i] != y[j]) {
				nearest[i] = j;
				break;
			}
	}
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r" ,stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
#endif
	scanf("%d", &n);
	for(int i =0; i < n; ++i)
		scanf("%d%d", &x[i], &y[i]);
	precalc();
	scanf("%d", &m);
	for(int i = 0; i < m; ++i) {
		scanf("%d%d", &a, &b), --a, --b;
		bool found = 0;
		for(int i = a; i <= b; ++i)
			if(nearest[i] != -1 && nearest[i] <= b) {
				printf("%d %d\n", i+1, nearest[i]+1);
				found = 1;
				break;
			}
		if(!found) printf("0 0\n");
	}
}