#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

#define pb push_back

using namespace std;

typedef vector<int> vi;

const int MAXN = 100000;
const int inf = 1000000000;

int n, m;
int t;
vi a, full;
vector<vi> prv;
int out[MAXN];
int cnt, step;

void test(int who) {
	if(out[who] > step) out[who] = step, --cnt;
}

int w[MAXN], v[MAXN];
bool f[MAXN];

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w" ,stdout);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	cnt = n;
	for(int i = 0; i < n; ++i)
		out[i] = inf, full.pb(i);
	for(step = 1; step <= m && cnt; ++step) {
		scanf("%d", &t);
		a.resize(t);
		for(int j = 0; j < t; ++j)
			scanf("%d", &a[j]), a[j]--;
		for(int i = 0; i < a.size(); ++i) {
			w[a[i]] ++;
		}
		memset(v, 0, sizeof(v));
		for(int i = 0; i < n; ++i)
			v[w[i]] ++;
		for(int i = 0; i < n; ++i)
			if(v[w[i]] == 1) test(i);
		if(cnt == 1) {
			for(int i = 0; i < n; ++i)
				test(i);
		}
		if(a.size() == 1)
			test(a[0]);
		if(a.size() == n-1) {
			memset(f, 0, sizeof(f));
			for(int i = 0; i < a.size(); ++i)
				f[a[i]] = 1;
			for(int i = 0; i < n; ++i)
				if(!f[i]) test(i);
		}
	}
	for(int i = 0; i < n; ++i)
		if(out[i] == inf) printf("0 ");
		else printf("%d ", out[i]);
}