#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstdlib>

using namespace std;

typedef long long ll;

const int MAXN = 20;

int n, k;
int a[MAXN], p[MAXN];
int w[MAXN];
int d[MAXN][MAXN];

int len() {
	memset(d, 0, sizeof(d));
	d[0][0] = p[0] == w[0];
	for(int i = 1; i < n; ++i)
		d[i][0] = max(d[i-1][0], (int)(p[i] == w[0])),
		d[0][i] = max(d[0][i-1], (int)(p[0] == w[i]));
	for(int i = 1; i < n; ++i)
		for(int j = 1; j < n; ++j) {
			if(p[i] == w[j]) d[i][j] = d[i-1][j-1]+1;
			else d[i][j] = max(d[i-1][j], d[i][j-1]);
		}
	return d[n-1][n-1];
}

int main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
#endif
	scanf("%d%d", &n, &k);
	for(int i = 0; i < k; ++i)
		scanf("%d", &a[i]);
	for(int i = 0; i < n; ++i)
		p[i] = i+1, w[i] = i+1;
	ll res = 0;
	do {
		if(len() > k) continue;
		int q = 0;
		for(int i = 0; i < n; ++i)
			if(p[i] == a[q]) ++q;
		if(q == k) ++res;
	} while(next_permutation(p, p+n));
	cout << res;
}