program B_;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  a,b : array[1..100000] of integer;
  useda,usedb : array[1..100000] of boolean;
  pota,potb : array[0..100000] of array of integer;
  i,j,n : integer;
  res : int64;

procedure DFSa(x : integer);
var
  i : integer;
begin
  useda[x] := true;
  for i := 0 to length(pota[x])-1 do
    DFSa(pota[x][i]);
end;

procedure DFSb(x : integer);
var
  i : integer;
begin
  usedb[x] := true;
  for i := 0 to length(potb[x])-1 do
    DFSb(potb[x][i]);
end;

begin
  reset(input,'virus.in');
  rewrite(output,'virus.out');
  readln(n);

  for i := 1 to N do
    read(a[i]);
  for i := 1 to N do
    read(b[i]);

  for i := 1 to N do
  begin
    setlength(pota[a[i]],length(pota[a[i]])+1);
    pota[a[i]][length(pota[a[i]])-1] := i;
  end;

  for i := 1 to N do
  begin
    setlength(potb[b[i]],length(potb[b[i]])+1);
    potb[b[i]][length(potb[b[i]])-1] := i;
  end;
  res := 0;
  for i := 1 to N do
  begin
    for j := 1 to N do
    begin
      useda[j] := false;
      usedb[j] := false;
    end;
    DFSa(i);
    DFSb(i);
    useda[i] := false;
    usedb[i] := false;
    for j := 1 to N do
      if useda[j] and usedb[j] then
        inc(res);
  end;
  writeln(res);
end.
