import sys
sys.stdin = open('mosaic.in')
sys.stdout = open('mosaic.out', 'w')

n = int(input())

bigset = {0}
a = dict()
b = dict()
nearest = [None]

a0, b0 = map(int, input().split())
a[a0] = {0}
b[b0] = {0}

for i in range(1, n):
    bigset.add(i)
    
    ai, bi = map(int, input().split())
    if ai in a:
        a[ai].add(i)
    else:
        a[ai] = {i}
        
    if bi in b:
        b[bi].add(i)
    else:
        b[bi] = {i}    
    
    un = set.union(a[ai], b[bi])
    if len(un) == i + 1:
        nearest.append(nearest[-1])
    else:
        nearest.append( (max(set.difference(bigset, un)), i) )
    


k = int(input())
for i in range(k):
    first, second = map(int, input().split())
    first -= 1
    second -= 1
    if nearest[second] is None or nearest[second][0] < first:
        print(0, 0)
    else:
        print(nearest[second][0] + 1, nearest[second][1] + 1)