#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

#include <algorithm>

const int maxN = 1000000;

int detect[maxN];

int main() {
	freopen("apricot.in" , "r", stdin );
	freopen("apricot.out", "w", stdout);

	int N, U, R;

	scanf("%i %i %i", &N, &R, &U);

	detect[1] = 0;

	for(int i = 2; i <= N; i++) {
		// Calculate detect[i]

		int maxCmp = i / 2;

		for(int cmp = 1; cmp <= maxCmp; cmp++) {
			int rest = i - 2 * cmp;

			int maxU;

			if(rest != 0)
				maxU = std::max(detect[rest] + R, detect[cmp] + U);
			else
				maxU = detect[cmp] + U;

			if(detect[i] == 0 || detect[i] > maxU)
				detect[i] = maxU;
		}

		//printf("detect[%i] is %i\n", i, detect[i]);
	}

	printf("%i\n", detect[N]);

	return 0;
}
