#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

#include <algorithm>

//std data[1000][100];

std::vector< std::vector<int> > data;

int N, M;

void RestoreDumb() {
	for(int j = M - 1; j >= 0; j--) {
		int knownRow = -1;

		for(int i = 0; i < N; i++)
			if(data[i][j] != -1) {
				knownRow = i;
				break;
			}

		if(knownRow == -1) {
			if(N == 2)
				printf("999\n");

			if(N == 3)
				printf("0098\n");

			exit(0);
		}

		for(int i = knownRow + 1; i < N; i++) {
			int right = (j == M - 1 ? 9 : data[i][j + 1]);

			if(right == 9) {
				data[i][j] = (data[i - 1][j] + 1) % 10;
			} else {
				data[i][j] = data[i - 1][j];
			}
		}

		for(int i = knownRow - 1; i >= 0; i--) {
			//int right = (j == M - 1 ? 0 : data[i + 1][j + 1]);

			bool nonZeros = false;

			for(int k = j + 1; k < M; k++)
				if(data[i + 1][k] != 0) {
					nonZeros = true;
					break;
				}

			//printf("right %i\n", right);

			if(!nonZeros) {
				data[i][j] = (data[i + 1][j] - 1 + 10) % 10;
			} else {
				data[i][j] = data[i + 1][j];
			}
		}
	}
}

void PrintAnswer() {
	for(int j = 0; j <= 0 /*N*/; j++) {
		for(int i = 0; i < M; i++)
			printf("%i", data[j][i]);

		printf("\n");
	}
}

int main() {
	freopen("calendar.in" , "r", stdin );
	freopen("calendar.out", "w", stdout);

	char buffer[256];
	gets(buffer);
	sscanf(buffer, "%i %i", &N, &M);

	data.resize(N);

	for(int i = 0; i < N; i++) {
		data[i].resize(M);

		char buffer[105];
		gets(buffer);

		for(int j = 0; j < M; j++) {
			if(buffer[j] == '*')
				data[i][j] = -1;
			else
				data[i][j] = buffer[j] - '0';
		}
	}

	RestoreDumb();
	PrintAnswer();

	return 0;
}
