#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const int maxn = 2010;

int n, ans, t, nach[2][maxn];
char podch[2][maxn][maxn];

void setPodch(int n, int u, int v){
	if (v == 0) return;
	podch[n][u][v] = true;
	setPodch(n, u, nach[n][v]);
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
#endif
	cin >> n;
	for (int k = 0; k <= 1; k++){
		for (int i = 1; i <= n; i++){
			cin >> nach[k][i];
		}
		for (int i = 1; i <= n; i++){
			setPodch(k, i, nach[k][i]);
		}
	}
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			if (podch[0][i][j] && podch[1][i][j]) ans++;
	cout << ans;
	return 0;
}