#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

const int maxn = 100010;

int n, m, kir[2][maxn], left_[2][maxn], right_[2][maxn], a[2][maxn];

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
#endif
	cin >> n;
	for (int i = 0; i < 2; i++){
		for (int j = 0; j < n; j++){
			kir[i][j] = 0;
			left_[i][j] = right_[i][j] = 0;
		}
	}
	int c = 1;
	cin >> a[0][0] >> a[1][0];
	for (int i = 1; i < n; i++){
		for (int j = 0; j < 2; j++){
			cin >> a[j][i];
			if (a[j][i] == a[j][i - 1]){
				if (kir[j][i - 1] != 0){//   , 
					kir[j][i] = kir[j][i - 1];
					left_[j][i] = left_[j][i - 1];
				} else {// 
					kir[j][i] = kir[j][i - 1] = c++;
					left_[j][i - 1] = left_[j][i] = i - 1;
				}
			} else {
				if (kir[j][i - 1] != 0)
					right_[j][i - 1] = i - 1;
			}
		}
	}
	for (int j = 0; j < 2; j++){
		if (kir[j][n - 1] != 0){
			right_[j][n - 1] = n - 1;
		}
	}
	for (int i = n - 2; i >= 0; i--){
		for (int j = 0; j < 2; j++){
			if (right_[j][i + 1] != 0 && a[j][i] == a[j][i + 1])
				right_[j][i] = right_[j][i + 1];
		}
	}
	cin >> m;
	for (int i = 0; i < m; i++){
		int A, B;
		cin >> A >> B;
		A--, B--;
		int t1, t2;
		if ((kir[0][A] == kir[0][B] && kir[0][A] != 0) || (kir[1][A] == kir[1][B] && kir[1][A] != 0)){
			// 
			t1 = t2 = -1;
		} else {
			if (kir[0][A] == 0 && kir[1][A] == 0){
				t1 = A;
				t2 = A + 1;
			}
			
			for (int j = 0; j < 2; j++){
				if (kir[j][A] == 0 && kir[1 - j][A] != 0){
					t1 = right_[1 - j][A] + 1, t2;
					if (kir[j][t1] == 0)
						t2 = t1 - 1;
					else
						t2 = left_[j][t1] - 1;
				}
			}
			if (kir[0][A] != 0 && kir[1][A] != 0){
				 t1 = right_[1][A] + 1;
				 if (kir[0][t1] == 0)
					t2 = t1 - 1;
			     else {
					int x = right_[0][t1] + 1;
					int y = left_[0][t1] - 1;
					if (x < A || x > B)
						t2 = y;
					else{
						if (y < A || y > B){
							t2 = x;
						} else {
							if (a[0][x] == a[0][x] || a[1][x] == a[1][x])
								t2 = y;
							else
								t2 = x;
						}
					}
				 }
				 if (a[0][t1] == a[0][t2] || a[1][t1] == a[1][t2]){
					t1 = right_[0][A] + 1;
					if (kir[1][t1] == 0)
						t2 = t1 - 1;
					 else {
						int x = right_[1][t1] + 1;
						int y = left_[1][t1] - 1;
						if (x < A || x > B)
							t2 = y;
						else{
							if (y < A || y > B){
								t2 = x;
							} else {
								if (a[0][x] == a[0][x] || a[1][x] == a[1][x])
									t2 = y;
								else
									t2 = x;
							}
						}
					 }
				 }
			}
		}
		if (t2 < t1)
			swap(t1, t2);
		cout << t1 + 1 << " " << t2 + 1 << endl;
	}
	return 0;
}