#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
using namespace std;

#define TASK "virus"
typedef long long ll;
vector<int> tin[2], tout[2];
vector<vector<int> > g1, g2;
vector<char> used;
int timer1 = 0, timer2 = 0;

void dfs1(int v)
{
	used[v] = true;
	tin[0][v] = timer1++;
	for(vector<int>::iterator it = g1[v].begin(); it != g1[v].end(); ++it)
		if(!used[*it]) dfs1(*it);
	tout[0][v] = timer1++;
}

void dfs2(int v)
{
	used[v] = true;
	tin[1][v] = timer2++;
	for(vector<int>::iterator it = g2[v].begin(); it != g2[v].end(); ++it)
		if(!used[*it]) dfs2(*it);
	tout[1][v] = timer2++;
}

bool upper(int id, int a, int b)
{
	return tin[id][a] <= tin[id][b] && tout[id][a] >= tout[id][b];
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n;
	scanf("%d", &n);
	for(int i = 0; i < 2; ++i)
	{
		tin[i].resize(n);
		tout[i].resize(n);
	}
	g1.resize(n);
	g2.resize(n);
	int tmp, b1, b2;
	for(int i = 0; i < n; ++i)
	{
		scanf("%d", &tmp);
		if(tmp == 0) 
		{
			b1 = i;
			continue;
		}
		tmp--;
		g1[tmp].push_back(i);
	}
	for(int i = 0; i < n; ++i)
	{
		scanf("%d", &tmp);
		if(tmp == 0)
		{
			b2 = i;
			continue;
		}
		tmp--;
		g2[tmp].push_back(i);
	}
	used.assign(n, false);
	dfs1(b1);
	used.assign(n, false);
	dfs2(b2);

	int ans = 0;
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			if(i != j && upper(0, i, j) && upper(1, i, j))
				++ans;
	cout << ans;

	return 0;
}