#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
using namespace std;

#define TASK "apricot"
typedef long long ll;
const int INF = 1 << 30;
const int maxn = 1000005;
int d[maxn], r, u;

int solve(int x)
{
	int &ret = d[x];
	if(ret != -1)
		return ret;
	ret = INF;
	if(x&1)
	{
		for(int i = 1; x - i > 1; i += 2)
			ret = min(ret, max(solve(i)+r, solve((x - i)/2)+u));
	}
	else
	{
		ret = solve(x/2) + u;
		for(int i = 2; x - i > 1; i += 2)
			ret = min(ret, max(solve(i)+r, solve((x-i)/2)+u));
	}

	return ret;
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n;
	cin >> n >> r >> u;
	for(int i = 2; i <= n; ++i)
		d[i] = -1;
	d[0] = 0;
	d[1] = 0;
	cout << solve(n);

	return 0;
}