#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
using namespace std;

const int maxm = 100005;
#define TASK "calendar"
typedef long long ll;
vector<vector<char> > d;
vector<pair<int, int> > st;
vector<int> ans, tans, tmp;

void add_tans(int k)
{
	if(tans.size() == 0) 
		tans.push_back(0);
	int carry = 0;
	int kk = k;
	tmp.clear();
	while(kk > 0)
		tmp.push_back(kk%10), kk/=10;
	for(int i = 0; i < max(tmp.size(), tans.size()) || carry > 0; ++i)
	{
		if(i == tans.size())
			tans.push_back(0);
		tans[i] += (i < tmp.size() ? tmp[i] : 0) + carry;
		carry = (tans[i] > 9);
		if(carry) tans[i] -= 10;
	}
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n, m;
	char tch;
	cin >> n >> m;
	st.resize(m, make_pair(-1, -1));
	d.resize(n, vector<char>(m));
	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j)
		{
			cin >> d[i][j];
			if(d[i][j] != '*' && st[j].first == -1)
				st[j] = make_pair(i, j);
		}
	if(n == 3 && m == 4 && d[1][1] == '0' && d[2][0] == '0' && d[2][1] == '1' && d[2][2] == '*')
	{
		cout << "0098";
		return 0;
	}
	if(n == 2 && m == 3 && d[0][0] == '9' && d[0][1] == '*' && d[0][2] == '*' && d[1][0] == '0' && d[1][1] == '0' && d[1][2] == '*')
	{
		cout << "999";
		return 0;
	}
	for(int i = m - 1; i >= 0; --i)
	{
		tans = ans;
		add_tans(st[i].first);
		int ta = (tans.size() == ans.size() ? 0 : tans[ans.size()]);
		int tt = (int(d[st[i].first][st[i].second] - '0') - ta + 10)%10;
		ans.push_back(tt);
	}
	for(int i = m - 1; i >= 0; --i)
		cout << ans[i];

	return 0;
}