#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<map>
using namespace std;

const int INF = 1 << 30;
typedef long long ll;
typedef long double ld;

#define TASK "mosaic"
const int maxn = 100005;

struct ev
{
	int x, id;
	bool st;
	ev(){}
	ev(int _x, int _id, bool _st) : x(_x), id(_id), st(_st) {}
	bool operator <(const ev &t) const
	{
		return x < t.x;
	}
};

int a[maxn], b[maxn];
int x[maxn], y[maxn];
int t1[maxn], t2[maxn];
map<int, int> mp;
vector<ev> e1, e2;
int lst[maxn], tmp[maxn];
int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n, k;
	scanf("%d", &n);
	for(int i = 0; i < n; ++i)
		scanf("%d %d", &a[i], &b[i]);
	scanf("%d", &k);
	for(int i = 0; i < n; ++i)
	{
		scanf("%d %d", &x[i], &y[i]);
		x[i]--, y[i]--;
	}

	int last = 0;
	for(int i = 0; i < n; ++i)
		if(mp.find(a[i]) == mp.end())
			mp[a[i]] = last++;
	for(int i = 0; i < n; ++i)
		a[i] = mp[a[i]];
	last = 0;
	mp.clear();
	for(int i = 0; i < n; ++i)
		if(mp.find(b[i]) == mp.end())
			mp[b[i]] = last++;
	for(int i = 0; i < n; ++i)
		b[i] = mp[b[i]];
	for(int i = 0; i < k; ++i)
	{
		for(int j = 0; j < n; ++j)
			lst[j] = 0;
		int t1 = -1, t2 = -1;
		for(int j = x[i]; j <= y[i]; ++j)
		{
			lst[a[j]]++;
			tmp[a[j]] = j;
		}
		for(int j = 0; j < n && t1 == -1; ++j)
			if(lst[j] == 1)
				t1 = tmp[j];
		for(int j = 0; j < n; ++j)
			lst[j] = 0;
		for(int j = x[i]; j <= y[i]; ++j)
		{
			lst[b[j]]++;
			tmp[b[j]] = j;
		}
		for(int j = 0; j < n && t2 == -1; ++j)
			if(lst[j] == 1)
				t2 = tmp[j];
		if(t1 == -1 || t2 == -1)
			cout << 0 << ' ' << 0 << endl;
		else
		{
			if(t1 != t2)
				cout << t1 + 1 << ' ' << t2 + 1 << endl;
			else
			{
				if(t1 == x[i])
					cout << t1+1 << ' ' << y[i] + 1 << endl;
				else
					cout << t1 + 1 << ' ' << x[i] + 1 << endl;
			}
		}
	}


	return 0;
}