#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<map>
using namespace std;

const int INF = 1 << 30;
typedef long long ll;
typedef long double ld;

#define TASK "mosaic"
const int maxn = 100005;

struct ev
{
	int x, id;
	bool st;
	ev(){}
	ev(int _x, int _id, bool _st) : x(_x), id(_id), st(_st) {}
	bool operator <(const ev &t) const
	{
		return x < t.x;
	}
};

int a[maxn], b[maxn];
int x[maxn], y[maxn];
int t1[maxn], t2[maxn];
map<int, int> mp;
vector<ev> e1, e2;
int lst[maxn], tmp[maxn];
int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int n, k;
	scanf("%d", &n);
	for(int i = 0; i < n; ++i)
		scanf("%d %d", &a[i], &b[i]);
	scanf("%d", &k);
	for(int i = 0; i < k; ++i)
	{
		scanf("%d %d", &x[i], &y[i]);
		x[i]--, y[i]--;
		bool found = false;
		for(int j = x[i]; j <= y[i] && !found; ++j)
			for(int jj = x[i]; jj <= y[i] && !found; ++jj)
			{
				if(j != jj && a[j] != a[jj] && b[j] != b[jj])
					cout << j + 1 << ' ' << jj + 1 << endl, found = true;
			}
		if(!found)
			cout << 0 << ' ' << 0 << endl;
	}

	return 0;
}