#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<ctime>
#include<cassert>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<cstring>
#include<cmath>
using namespace std;

#define taskname "virus"
const int MAX = (int)2e5;

int n;
int a[MAX], b[MAX];
vector<int> g1[MAX], g2[MAX], s1[MAX], s2[MAX];
int b1, b2;

void dfs1(int v)
{
  for(int i = 0; i < (int)g1[v].size(); i++)
  {
    int u = g1[v][i];
    dfs1(u);
    s1[v].push_back(u);
    for(int j = 0; j < (int)s1[u].size(); j++)
      s1[v].push_back(s1[u][j]);
  }
  /*cerr << v << ": ";
  for(int i = 0; i < (int)s1[v].size(); i++)
    cerr << s1[v][i] << ' ';
  cerr << endl; */
}

void dfs2(int v)
{
  for(int i = 0; i < (int)g2[v].size(); i++)
  {
    int u = g2[v][i];
    dfs2(u);
    s2[v].push_back(u);
    for(int j = 0; j < (int)s2[u].size(); j++)
      s2[v].push_back(s2[u][j]);
  }
}

int main()
{
  freopen(taskname".in", "r", stdin);
  freopen(taskname".out", "w", stdout);
  scanf("%i", &n);
  for(int i = 1; i <= n; i++)
    scanf("%i", &a[i]);
  for(int i = 1; i <= n; i++)
    scanf("%i", &b[i]);
  for(int i = 1; i <= n; i++)
  {
    if(a[i] == 0)
      b1 = i;
    else
      g1[a[i]].push_back(i);
  }
  for(int i = 1; i <= n; i++)
  {
    if(b[i] == 0)
      b2 = i;
    else
      g2[b[i]].push_back(i);
  }
  dfs1(b1);
  dfs2(b2);
  for(int i = 1; i <= n; i++)
  {
    sort(s1[i].begin(), s1[i].end());
    sort(s2[i].begin(), s2[i].end());
  }
  /*for(int i = 1; i <= n; i++)
  {
    cout << i << ":";
    for(int j = 0; j < (int)s1[i].size(); j++)
      cout << s1[i][j] << ' ';
    cout << endl;
  } 
  cout << endl;
  for(int i = 1; i <= n; i++)
  {
    cout << i << ":";
    for(int j = 0; j < (int)s2[i].size(); j++)
      cout << s2[i][j] << ' ';
    cout << endl;
  }      */
  long long ans = 0;
  for(int i = 1; i <= n; i++)
  {
    int k1 = 0;
    int k2 = 0;
    while(k1 < (int)s1[i].size() && k2 < (int)s2[i].size())
    {
      if(s1[i][k1] < s2[i][k2])
        k1++;
      else
      {
        if(s1[i][k1] > s2[i][k2])
          k2++;
        else
          ans++, k1++, k2++;
      }
    }
  }
  cout << ans;
  return 0;
}