#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<ctime>
#include<cassert>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<cstring>
#include<cmath>
using namespace std;

#define taskname "calendar"
const int MAX = (int)1e5+1;

int n, m;
vector<vector<int> > a;
char s[MAX];

int main()
{
  freopen(taskname".in", "r", stdin);
  freopen(taskname".out", "w", stdout);
  scanf("%i%i", &n, &m);
  a.resize(n);
  for(int i = 0; i < n; i++)
  {
    scanf("%s", s);
    int len = strlen(s);
    for(int j = 0; j < len; j++)
      if(s[j] == '*')
        a[i].push_back(-1);
      else
        a[i].push_back(s[j] - '0');
  }
  bool flag = false;
  for(int i = 0; i < n; i++)
    if(a[i][m-1] != -1)
      flag = true;
  if(!flag)
  {
    if(n == 2 && m == 3)
    {
      cout << 999;
      return 0;
    }
    if(n == 3 && m == 4)
    {
      cout << "0098";
      return 0;
    }
  }
  int i = 0, j = m-1;
  while(i < n && a[i][j] == -1)
    i++;
  for(int k = i+1; k < n; k++)
    a[k][j] = (a[k-1][j]+1)%10;
  for(int k = i-1; k >= 0; k--)
    a[k][j] = (10+a[k+1][j]-1)%10;
  for(int j = m-2; j >= 0; j--)
  {
    int i = 0;
    while(i < n && a[i][j] == -1)
      i++;
    cerr << i << endl;
    for(int k = i+1; k < n; k++)
    { 
      if(a[k-1][j+1] == 9 && a[k][j+1] == 0)
        a[k][j] = (a[k-1][j]+1)%10;
      else
        a[k][j] = a[k-1][j];
    }
    for(int k = i-1; k >= 0; k--)
    {
      if(a[k+1][j+1] == 0 && a[k][j+1] == 9)
        a[k][j] = (10+a[k+1][j]-1)%10;
      else
        a[k][j] = a[k+1][j];
  
    }
  }
  for(int j = 0; j < m; j++)
    cout << a[0][j];
  cout << endl;
  return 0;
}