{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  prev1, prev2 : array [0.. 2000000] of integer;
  father : array [0.. 2000, 0.. 2000] of boolean;
  i, j, n, ans : integer;
  v : array [0.. 2000] of boolean;

procedure dfs1 (u : integer);
begin
  father[i, u] := true;
  if prev1[u] <> 0 then
    dfs1(prev1[u]);
end;

procedure dfs2 (u : integer);
begin
  if father[i, u] then
    inc(ans);
  if prev2[u] <> 0 then
    dfs2(prev2[u]);  
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  read(n);
  for i := 1 to n do
    read(prev1[i]);
  for i := 1 to n do
    read(prev2[i]);

  for i := 1 to n do
    for j := 1 to n do
     father[i, j] := false;

  for i := 1 to n do begin
    for j := 1 to n do
      v[j] := false;
    dfs1(i);
  end;

  ans := 0;
  for i := 1 to n do begin
    dfs2(i);
  end;

  write(ans - n);
end.
