program C_70;

{$APPTYPE CONSOLE}
{$O-}

function min(x, y: int64): int64;
begin
  if (x < y) then min := x else min := y;
end;

function max(x, y: int64): int64;
begin
  if (x > y) then max := x else max := y;
end;

const
  big = 1000000000000000000;

var
  dp: array[0..1000000] of int64;
  n, u, r, i, j: longint;
  cur: int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');
  readln(n, r, u);
  dp[0] := -r;
  dp[1] := 0;
  dp[2] := u;
  dp[3] := max(u, r);
  for i := 4 to n do dp[i] := big;
  for i := 4 to n do begin
    for j := 1 to i div 2 do begin
      cur := max(dp[j] + u, dp[i - 2 * j] + r);
      dp[i] := min(dp[i], cur);
    end;
  end;
  writeln(dp[n]);
end.
