program C_70;

{$APPTYPE CONSOLE}

function min(x, y: int64): int64;
begin
  if (x < y) then min := x else min := y;
end;

function max(x, y: int64): int64;
begin
  if (x > y) then max := x else max := y;
end;

function f(i: longint): longint;
begin
  if (i <= 1000) then begin
    f := 1;
  end else begin
    f := i - 2 * round(sqrt(i));
  end;
end;

const
  big = 1000000000000;

var
  dp: array[0..1000000] of int64;
  n, i, j, x: longint;
  r, u: int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');
  readln(n, r, u);
  dp[0] := -r;
  dp[1] := 0;
  dp[2] := u;
  dp[3] := max(u, r);
  for i := 4 to n do dp[i] := big;
  for i := 4 to n do begin
    x := f(i);
    for j := x to i div 2 do begin
      dp[i] := min(dp[i], max(dp[j] + u, dp[i - 2 * j] + r));
    end;
  end;
  writeln(dp[n]);
end.
