program C_70;

{$APPTYPE CONSOLE}

function min(x, y: int64): int64;
begin
  if (x < y) then min := x else min := y;
end;

function max(x, y: int64): int64;
begin
  if (x > y) then max := x else max := y;
end;


const
  big = 1000000000000;

var
  dp: array[0..1000000] of int64;
  n, i, j, x: longint;
  r, u: int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');
  readln(n, r, u);
  dp[1] := 0;
  dp[2] := u;
  dp[3] := max(u, r);
  for i := 4 to n do dp[i] := big;
  for i := 4 to n do begin
    for j := 1 to min(i - 1, n div 2) do begin
      if (i - 2 * j > 0) then begin
        dp[i] := min(dp[i], max(dp[j] + u, dp[i - 2 * j] + r));
      end else begin
        dp[i] := min(dp[i], dp[j] + u);
      end;
    end;
  end;
  writeln(dp[n]);
end.
