program E;

{$APPTYPE CONSOLE}

type
  ptree = ^tree;
  tree = record
    l, r, minx, min: longint;
    t1, t2: ptree;
  end;
  ans = record
    min, minx: longint;
  end;

function max(x, y: longint): longint;
begin
  if (x > y) then max := x else max := y;
end;

function min(x, y: longint): longint;
begin
  if (x < y) then min := x else min := y;
end;

var
  a: array[1..100000, 1..2] of longint;
  nextx, nexty, nextne: array[1..100000] of longint;
  n, i, k, lx, ly, l, r: longint;
  answer: ans;
  p: ptree;

procedure init(var p: ptree; l, r: longint);
begin
  new(p);
  p^.l := l;
  p^.r := r;
  if (l = r) then begin
    p^.min := nextne[l];
    p^.minx := l;
  end else begin
    init(p^.t1, l, (l + r) div 2);
    init(p^.t2, (l + r + 2) div 2, r);
    if (p^.t1^.min < p^.t2^.min) then begin
      p^.min := p^.t1^.min;
      p^.minx := p^.t1^.minx;
    end else begin
      p^.min := p^.t2^.min;
      p^.minx := p^.t2^.minx;
    end;
  end;
end;

function check(p: ptree; l, r: longint): ans;
var
  q, w: ans;

begin
  if (p^.l = l) and (p^.r = r) then begin
    q.min := p^.min;
    q.minx := p^.minx;
    check := q;
  end else begin
    if (p^.t1^.l <= l) and (p^.t1^.r >= r) then begin
      check := check(p^.t1, l, r);
    end else begin
      if (p^.t2^.l <= l) and (p^.t2^.r >= r) then begin
        check := check(p^.t2, l, r);
      end else begin
        q := check(p^.t1, l, p^.t1^.r);
        w := check(p^.t2, p^.t2^.l, r);
        if (q.min < w.min) then begin
          check := q;
        end else begin
          check := w;
        end;
      end;
    end;
  end;
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  readln(n);
  fillchar(nextx, sizeof(nextx), 0);
  fillchar(nexty, sizeof(nexty), 0);
  for i := 1 to n do begin
    readln(a[i, 1], a[i, 2]);
  end;
  lx := n;
  ly := n;
  for i := n - 1 downto 1 do begin
    if (a[i, 1] = a[lx, 1]) then begin
      nextx[i] := nextx[lx];
    end else begin
      nextx[i] := i + 1;
      lx := i;
    end;
    if (a[i, 2] = a[ly, 2]) then begin
      nexty[i] := nexty[ly];
    end else begin
      nexty[i] := i + 1;
      ly := i;
    end;
  end;
  for i := 1 to n do begin
    if (nextx[i] <> 0) and (nexty[i] <> 0) then begin
      nextne[i] := max(nextx[i], nexty[i]);
    end else begin
      nextne[i] := n + 1;
    end;
  end;
  init(p, 1, n);
  readln(k);
  for i := 1 to k do begin
    readln(l, r);
    answer := check(p, l, r);
    if (answer.min <= r) then begin
      writeln(answer.minx, ' ', answer.min);
    end else begin
      writeln('0 0');
    end;
  end;
end.
