program G;

{$APPTYPE CONSOLE}

const
  dir: array[1..8, 1..2] of longint = ((-1, -1), (-1, 1), (1, 1), (1, -1), (0, -1), (-1, 0), (0, 1), (1, 0));

type
  rec = record
    x, y: longint;
  end;

var
  can, new: array[0..31, 0..31] of boolean;
  n, m, i, j, x, y, x1, y1, found, color, head, fx, fy: longint;
  queue: array[1..900] of rec;
  used: array[1..30, 1..30] of longint;
  nf: boolean;

procedure add(x, y: longint);
begin
  if (x >= 1) and (x <= m) and (y >= 1) and (y <= n) and (used[x, y] <> color) then begin
    if can[x, y] then begin
      nf := false;
      fx := x;
      fy := y;
    end else begin
      inc(head);
      queue[head].x := x;
      queue[head].y := y;
      used[x, y] := color;
    end;
  end;
end;


begin
  readln(n, m);
  fillchar(can, sizeof(can), false);
  for i := 1 to m do for j := 1 to n do can[i, j] := true;
  readln(x, y);
  writeln('0 0 1');
  flush(output);
  readln(found, x1, y1);
  fillchar(used, sizeof(used), 0);
  color := 0;
  while (found <> 1) do begin
    can[x, y] := false;
    for i := 1 to m do begin
      for j := 1 to n do begin
        new[i, j] := can[i - x1, j - y1];
      end;
    end;
    for i := 1 to m do for j := 1 to n do can[i, j] := new[i, j];
    inc(color);
    head := 0;
    nf := true;
    add(x, y);
    i := 1;
    while (i <= head) and nf do begin
      for j := 8 downto 1 do begin
        add(queue[i].x + dir[j, 1], queue[i].y + dir[j, 2]);
      end;
      inc(i);
    end;
    if (fx > x) then begin
      x := x + 1;
      write('1 ');
    end else if (fx = x) then write('0 ');
    if (fx < x) then begin
      x := x - 1;
      write('-1 ');
    end;
    if (fy > y) then begin
      y := y + 1;
      write('1 ');
    end else if (fy = y) then write('0 ');
    if (fy < y) then begin
      y := y - 1;
      write('-1 ');
    end;
    if can[x, y] then writeln(1) else writeln(0);
    flush(output);
    readln(found, x1, y1);
  end;
end.
