#pragma comment(linker,"/STACK:64000000")
#include<stdlib.h>
#include<string.h>
#include<stdio.h>
#include<algorithm>
using namespace std;
const int maxn=1024*100;
char *a[maxn];
char *b[maxn];
int col[maxn];
const int maxd=1000*1000;
bool *c[maxn];
int n,m;
bool check(int i,int j){
	bool p=0;
	if(j==m-1)
		c[i][j]=a[i][j];
	else c[i][j]=a[i][j] || c[i][j+1];
	return c[i][j];
}
bool solve(){
	int i,j;
	for(i=0;i<n;i++){
		memset(c[i],0,sizeof(bool)*(m+2));
		memcpy(a[i],b[i],sizeof(char)*(m+2));
	}
	for(i=1;i<n;i++)
		for(j=0;j<m;++j){
			if(a[i][j]!=a[i-1][j] && a[i][j]!='*' && a[i-1][j]!='*' && j!=m-1){
				//for(int k=j+1;k<m && a[i][k]=='*' && a[i-1][k]=='*';k++)
				//	a[i][k]='0', a[i-1][k]='9';
				memset(a[i]  +j+1,'0',(m-j+1)*sizeof(char));
				memset(a[i-1]+j+1,'9',(m-j+1)*sizeof(char));
			}
		}
	memset(col,-1,sizeof(col));
	for(i=0;i<n;i++)
		for(j=0;j<m;j++){
			if(a[i][j]!='*')
				col[j]=i;			
			a[i][j]-='0';
		}
	for(i=0;i<m;i++)
		if(col[i]==-1)
			return 1;

	int d=a[col[m-1]][m-1];
	for(i=0;i<n;i++)
		a[i][m-1]=(d+(i-col[m-1]+maxd))%10;

	for(j=m-2;j>=0;--j){
		for(i=col[j]+1;i<n;i++){
			char c=check(i,j+1) ? a[i-1][j] : (a[i-1][j]+1)%10;
			if(a[i][j]!='*'-'0' && a[i][j]!=c)
				return 1;
			else a[i][j]=c;
		}
		for(i=col[j]-1;i>=0;i--){
			char c=check(i+1,j+1) ? a[i+1][j] : (a[i+1][j]+9)%10;
			if(a[i][j]!='*'-'0' && a[i][j]!=c)
				return 1;
			else a[i][j]=c;
		}
	}

	for(i=0;i<1;i++){
		for(j=0;j<m;j++)
			putchar('0'+a[i][j]=='*' ? '0' : '0'+a[i][j]);
		putchar('\n');
	}
	return 0;
}
int main(){
#ifdef _DEBUG
	freopen("in.txt","r",stdin);
	freopen("out.txt","w",stdout);
#else
	freopen("calendar.in","r",stdin);
	freopen("calendar.out","w",stdout);
#endif

	int i,j;
	scanf("%d%d\n",&n,&m);
	for(i=0;i<n;i++){
		a[i]=new char[m+2];
		b[i]=new char[m+2];
		c[i]=new bool[m+2];
		gets(b[i]);
	}
	if(!solve())
		return 0;


	return 0;
}