#include <iostream>
#include <math.h>
#include <time.h>
#include <algorithm>
#include <stdio.h>
using namespace std;

typedef long long ll;
#define txt "virus"
#define inf 1e9
#define eps 1.0e-9
#define N 30000500
#define M 200100

struct v
{
	int x, y, size;
	v *l, *r;
};
v tree[N];
int tsize;
int fb[M];
int nb[M];
int eb[M];
int b1[M];
int b2[M];
int fa[M];
int ea[M];
int na[M];
int a1[M];
int a2[M];

int a[M];
int b[M];
int tim, len, len2;
void dfs(int i)
{
	b1[i] = tim++;
	for (int u = fb[i]; u != -1; u = nb[u])
		dfs(eb[u]);
	b2[i] = tim++;
}
void dfs2(int i)
{
	a1[i] = tim++;
	for (int u = fa[i]; u != -1; u = na[u])
		dfs2(ea[u]);
	a2[i] = tim++;
}


bool cmp(int i, int j)
{
	if (i == j) return false;
	return (b1[i] < b1[j] && b2[i] > b2[j]);
}
int Size(v *t)
{
	return (t ? t->size : 0);
}
void Update(v *t)
{
	if (t) t->size = 1 + Size(t->l) +Size(t->r);
}

void Copy(v *&t, v *ct)
{
	t = tree + tsize++;
	*t = *ct;
}

void Merge(v *&t, v *l, v *r)
{
	if (l == 0) t = r;
	else if (r == 0) t = l;
	else if (l->y < r->y)
	{
		Copy(t, l);
		Merge(t->r, l->r, r);
	}
	else
	{
		Copy(t, r);
		Merge(t->l, l, r->l);
	}
	Update(t);
}
void Split(v *t, v *&l, v *&r, int i)
{
	if (t == 0) l = r = 0;
	else if (cmp(t->x, i))//i in r
	{
		Copy(l, t);
		Split(t->r, l->r, r, i);
		Update(l);
	}
	else
	{
		Copy(r, t);
		Split(t->l, l, r->l, i);
		Update(r);
	}
}

v *Create(int i)
{
	v *a = tree + tsize++;
	a->x = i;
	a->y = rand();
	a->l = a->r = 0;
	a->size = 1;
	return a;
}
v *Add(v *t, int i)
{
	v *l, *m, *r, *nt, *st;
	Split(t, l, r, i);
	m = Create(i);
	Merge(st, l, m);
	Merge(nt, st, r);
	return nt;
}

v *trees[M];

ll res;
void Write(v *t)
{
	if (t == 0) return;
	Write(t->l);
	cout << '(' << t->x << ' ' << t->size << ')' << ' ';
	Write(t->r);
}


ll Sum(v *t, int i)
{
	if (t == 0) return 0;
	if (cmp(t->x, i)) return Sum(t->r, i) + Size(t->l) + 1;
	else return Sum(t->l, i);
}

bool cmp2(int i, int j)
{
	return a1[i] >= a1[j] && a2[i] <= a2[j];
}

void Make(int i)
{
	if (a[i] != -1 && trees[a[i]] == 0) Make(a[i]);
	if (a[i] != -1)
	{
		v *r;
		Split(trees[a[i]], trees[i], r, i);
		if (trees[i] != 0)
		{
			v *low = trees[i];
			
			while (low->r != 0) low = low->r;
			for (int j = i; j != low->x; j = b[j])
				if (cmp2(i, j)) trees[i] = Add(trees[i], j);
		}
		else   
			for (int j = i; j >= 0; j = b[j])
				if (cmp2(i, j)) trees[i] = Add(trees[i], j);                         
	}
	else trees[i] = Create(i);
	//cout << tsize << endl;
	//cout << i << ':';
	//Write(trees[i]);
	//cout << endl;
}

void calc(int i)
{      
	if (trees[i] == 0)
		Make(i);
	res += trees[i]->size - 1;
}
         
int main()
{
	freopen(txt".in", "r", stdin);
	freopen(txt".out", "w", stdout);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) fb[i] = fa[i] = -1;
	for (int i = 0; i < n; i++)
		cin >> a[i], a[i]--;
	int sb;
	for (int i = 0; i < n; i++)
	{
		cin >> b[i], b[i]--;
		if (b[i] == -1) sb = i;
		else
		{
        	nb[len] = fb[b[i]];
        	eb[len] = i;
        	fb[b[i]] = len++;
        }
	}     
	dfs(sb);
	int sa;
	for (int i = 0; i < n; i++)
	{
		if (a[i] == -1) sa = i;
		else
		{
        	na[len2] = fa[a[i]];
        	ea[len2] = i;
        	fa[a[i]] = len2++;
        }
	}     
	dfs2(sa);


	for (int i = 0; i < n; i++)
		calc(i);
	/*for (int i = 0; i < n; i++)
	{
		Write(trees[i]);
		cout << endl;
	}*/           
	cout << res;

	return 0;
}