
#include <iostream>
#include <stdio.h>
#include <math.h>
using namespace std;

#define txt "mosaic"

typedef long long ll;
#define N 400500

int x[N];
int y[N];

int t1[N];
int t2[N];
int t3[N];
int t4[N];

void Create(int *t, int cmp(int, int), int i, int l, int r)
{
	if (l == r) t[i] = l;
	else
	{
		int m = (l + r) / 2;
		Create(t, cmp, i * 2, l, m);
		Create(t, cmp, i * 2 + 1, m + 1, r);
		t[i] = cmp(t[i * 2], t[i * 2 + 1]);
	}
}
int Get(int *t, int cmp(int, int), int i, int l, int r, int s, int e)
{                                
	s = max(s, l);
	e = min(e, r);
	if (s > e) return 0;
	if (s == l && e == r)
		return t[i];
	else
	{
		int m = (l + r) / 2;
		int a1 = Get(t, cmp, i * 2, l, m, s, m);
		int a2 = Get(t, cmp, i * 2 + 1, m + 1, r, m + 1, e);
		return cmp(a1, a2);
	}	
}

int cmp1(int a, int b) //t
{
	if (b == 0 || a != 0 && (y[a] > y[b] || y[a] == y[b] && x[a] < x[b])) return a;
	else return b;  	
}
int cmp2(int a, int b) //l
{
	if (b == 0 || a != 0 && (x[a] < x[b] || x[a] == x[b] && y[a] > y[b])) return a;
	else return b;  	
}
int cmp3(int a, int b) //r
{
	if (b == 0 || a != 0 && (x[a] > x[b] || x[a] == x[b] && y[a] < y[b])) return a;
	else return b;  	
}
int cmp4(int a, int b) //d
{
	if (b == 0 || a != 0 && (y[a] < y[b] || y[a] == y[b] && x[a] > x[b])) return a;
	else return b;  	
}

int main()
{
	freopen(txt".in", "r", stdin);
	freopen(txt".out", "w", stdout);
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> x[i] >> y[i];
	int n2;
	for (n2 = 1; n2 < n; n2 *= 2);
	Create(t1, cmp1, 1, 1, n2);
	Create(t2, cmp2, 1, 1, n2);
	Create(t3, cmp3, 1, 1, n2);
	Create(t4, cmp4, 1, 1, n2);
	int k;
	cin >> k;
	int a, b;
	int t, d, l, r;
	for (int i = 0; i < k; i++)
	{
		cin >> a >> b;
		t = Get(t1, cmp1, 1, 1, n2, a, b);
		l = Get(t2, cmp2, 1, 1, n2, a, b);
		r = Get(t3, cmp3, 1, 1, n2, a, b);
		d = Get(t4, cmp4, 1, 1, n2, a, b);
		//cout << t << ' ' << l << ' ' << r << ' ' << d << endl;
		if (x[t] == x[l] && y[t] == y[l])
		{
			if (x[l] == x[r]) cout << 0 << ' ' << 0 << endl;
			else if (y[t] == y[d]) cout << 0 << ' ' << 0 << endl;
			else if (y[r] < y[l]) cout << l << ' ' << r << endl;
			else if (x[d] > x[t]) cout << d << ' ' << t << endl;
			else cout << d << ' ' << r << endl;
		}
		else
		{
			cout << l << ' ' << t << endl;
		}
		 
	}
	return 0;
}