#include <iostream>
#include <stdio.h>
#include <math.h>
using namespace std;

typedef long long ll;
#define N 100

bool mask[N][N];

struct p
{
	int x, y, tp;
};
p q[N * N];
bool was[N][N];
int n, m;

p endpos;

int bfs(int x, int y)
{
	if (!mask[x][y]) return 0;
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++)
			was[i][j] = 0;
	was[x][y] = 1;
	int s = 0, e = 0;
	int tp = 1;
	for (int dx = -1; dx <= 1; dx++)
		for (int dy  =-1; dy <= 1; dy++)
		{
			if (x + dx >= 0 && y + dy >= 0)
				if (x + dx < m && y + dy < n)
					if (dx != 0 || dy != 0)
				{
					q[e].x = x + dx;
					q[e].y = y + dy;
					q[e++].tp = tp;
					was[x + dx][y + dy] = 1;
				}
			tp++;
		}

	while (s != e)
	{
		p a = q[s++];
		if (!mask[a.x][a.y])
		{
			endpos = a;
			return a.tp;
		} 
		for (int dx = -1; dx <= 1; dx++)
			for (int dy = -1; dy <= 1; dy++)
			{
				if (a.x + dx >= 0 && a.x + dx < m)
					if (a.y + dy >= 0 && a.y + dy < n)
						if (!was[a.x + dx][a.y + dy])
						{       
							q[e].x = a.x + dx;
							q[e].y = a.y + dy;
							was[q[e].x][q[e].y] = 1;
							q[e++].tp = a.tp;
							if (!mask[a.x + dx][a.y + dy])
							{
								endpos = q[e - 1];
								return a.tp;
							}

						}
			}
	}	
}

bool m2[N][N];

int main()
{
	cin >> n >> m;
	int x, y;
	cin >> x >> y;
	x--, y--;
	int dx, dy;
	bool call;
	endpos.x = x;
	endpos.y = y;
	int nc;
	while (1)
	{
		call = false;
		if (endpos.x == x && endpos.y == y)
			nc = bfs(x, y);
			else
			{
				if (endpos.x < x)
					if (endpos.y < y) nc = 1;
					else if (endpos.y == y) nc = 2;
					else nc = 3;
				else if (endpos.x == x)
					if (endpos.y < y) nc = 4;
					else if (endpos.y == y) nc = 5;
					else nc = 6;
				else
					if (endpos.y < y) nc = 7;
					else if (endpos.y == y) nc = 8;
					else nc = 9;
 
			}
		if (nc == 0)
		{
			cout << 0 << ' ' << 0 << ' ' << (mask[x][y] ? 0 : 1) << endl;
			mask[x][y] = true;
			cout.flush();
		}
		else
		{
			if (nc < 4) dx = -1;
			else if (nc < 7) dx = 0;
			else dx = 1;
			if (nc % 3 == 1) dy = -1;
			else if (nc % 3 == 2) dy = 0;
			else dy = 1;
			x += dx;
			y += dy;
			cout << dx<< ' ' << dy <<  ' ' << (mask[x][y] ? 0 : 1) << endl;
			mask[x][y] = true;
			cout.flush();
		}          
		int dx1, dy1, ans;
		cin >> ans >> dx1 >> dy1;
		if (ans) return 0;
		for (int i = 0; i < m; i++)
			for (int j = 0; j < n; j++)
				if (i + dx1 >= 0 && i + dx1 <m && j + dy1 >= 0 && j + dy1 < n)
				m2[i][j] = mask[i + dx1][j + dy1];
				else
				m2[i][j] = 1;
		/*for (int i = 0; i < m; i++)
		{
			for (int j = 0; j < n; j++)
				mask[i][j] = m2[i][j], cout << m2[i][j];
			cout << endl;
		}	*/	
	}
	return 0;
}