#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>

using namespace std;

#define pb push_back
#define mp make_pair
#define y1 botva45
#define fir first
#define sec second
#define hash botva99;
typedef long long int64;
typedef long double ld;

const int inf = 2000000000;
const ld eps = 1e-08;
const int has = 997;

string s1, s2;
int h1[101000];
int h2[101000];
int p[101000];
int n, m;
int sumpref[101000];

void print(int x, int y) {
	printf("%d %d\n", x, y);
	exit(0);
}

int gethash1(int l, int r) {
	if (l > r)
		return 0;
	return h1[r] - h1[l - 1] * p[r - l + 1];
}

int gethash2(int l, int r) {
	if (l > r)
		return 0;
	return h2[r] - h2[l - 1] * p[r - l + 1];
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	getline(cin, s1);
	scanf(" ");
	getline(cin, s2);
	n = s1.size();
	m = s2.size();
	p[0] = 1;
	for (int i = 1; i <= 100100; ++i)
		p[i] = p[i - 1] * 997;
	for (int i = 1; i <= n; ++i) {
		h1[i] = h1[i - 1] * has + int(s1[i - 1] - '0');
		sumpref[i] = sumpref[i - 1] + int(s1[i - 1] - '0');
	}
	for (int i = 1; i <= m; ++i)
		h2[i] = h2[i - 1] * has + int(s2[i - 1] - '0');
	for (int l = 1; l <= m; ++l) 
		if (s2[l - 1] != '0') {
			int cur = 0;
			for (int r = l; r <= m; ++r) {
				if ((r - l + 1) > 6)
					break;
				cur = cur * 10 + int(s2[r - 1] - '0');
				if (l - 1 > n)
					continue;
				if (n - (m - r) + 1 <= 0)
					continue;
				
				if (gethash1(1, l - 1) != gethash2(1, l - 1))
					continue;
				if (gethash2(r + 1, m) != gethash1(n - (m - r) + 1, n))
					continue;
				if (sumpref[n - (m - r)] - sumpref[l - 1] == cur)
					print(l, n - (m - r));
			}
		}
	return 0;
}