#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <vector>
#include <cmath>

#define all(c) c.begin(), c.end()
#define INF 1000 * 1000 * 1000

using namespace std;

vector <int> ans;
int n, eq, di;

int getans_old(int x)
{
    if (ans[x] < INF)
        return ans[x];

    if (x % 2 == 0)
    {
        ans[x] = min(ans[x], getans_old(x / 2) + di);
    }
    else
    {
        ans[x] = min(ans[x], max(eq, di + getans_old(x / 2)));
    }

    if (x % 3 == 0)
    {
        ans[x] = min(ans[x], max(eq, di) + getans_old(x / 3));
    }
    if (x % 3 == 1)
    {
        ans[x] = min(ans[x], max(di + getans_old(x / 3), eq + getans_old((x / 3) + 1)));
    }

    return ans[x];
}

int get_div_mod(int a, int b)
{
    int ans = a / b;
    if (a % b)
        ans++;
    return ans;
}

void getans(int x)
{
    for (int i = 4; i <= x; i++)
        for (int j = 2; j <= min(i / 2, (int) floor(sqrt(i) + 10)); j++)
            ans[i] = min(ans[i], ans[j] + di + eq * (((i / j) / 2) - 1));
}

int main()
{
    freopen("apricot.in", "r+", stdin);
    freopen("apricot.out", "w+", stdout);
    cin >> n >> eq >> di;
    ans.clear();
    ans.resize(n + 1, INF);

    ans[0] = 0;
    ans[1] = 0;
    ans[2] = di;
    ans[3] = max(eq, di);
    ans[4] = 2 * di;

    getans(n);

    cout << ans[n];
    return 0;
}
