#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

struct item
{
    int x, y, n;
};

bool compare_number(item i1, item i2)
{
    return i1.n < i2.n;
}

bool compare_xy(item i1, item i2)
{
    if ((i1.x < i2.x) || ((i1.x == i2.x) && (i1.y < i2.y)))
        return true;
    return false;
}

vector <item> a;

void print()
{
    for (int i = 0; i < a.size(); i++)
        cout << a[i].x << " " << a[i].y << " " << a[i].n << ", ";
    cout << endl;
}

int main()
{
    freopen("mosaic.in", "r+", stdin);
    freopen("mosaic.out", "w+", stdout);

    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].x >> a[i].y;
        a[i].n = i + 1;
    }

    int k;
    cin >> k;
    for (int i = 0; i < k; i++)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        if (l == r)
        {
            cout << "0 0";
            continue;
        }
        sort(a.begin() + l, a.begin() + r + 1, compare_xy);
//        cout << "! " << l << " " << r << endl;
//        print();
        if (a[l].x != a[r].x && a[l].y != a[r].y)
            cout << a[l].n << " " << a[r].n << endl;
        else
            cout << "0 0" << endl;
        sort(a.begin() + l, a.begin() + r + 1, compare_number);
//        print();
    }

    return 0;
}
