#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>

#define all(c) c.begin(), c.end()

using namespace std;

vector <int> ans;
vector <int> a;

int find_nwp()
{
    int maxx = 0;
    ans.clear();
    ans.resize(a.size(), 1);
    for (int i = 0; i < a.size(); i++)
        for (int j = 0; j < i; j++)
            if (a[j] < a[i])
            {
                ans[i] = max(ans[i], ans[j] + 1);
                maxx = max(maxx, ans[i]);
            }

    return maxx;
}

void print()
{
    for (int i = 0; i < a.size(); i++)
        cout << a[i] << " ";
}

int main()
{
    freopen("army.in", "r+", stdin);
    freopen("army.out", "w+", stdout);

    int n, k, ans = 0;

    cin >> n;
    a.resize(n);
    for (int i = 1; i <= n; i++)
        a[i-1] = i;

    cin >> k;

    vector <int> bg(k);
    for (int i = 0; i < k; i++)
        cin >> bg[i];

    if (k == n)
    {
        cout << 1;
        return 0;
    }

    do
    {
//        print();
        int p = 0;
        for (int i = 0; i < a.size(); i++)
            if (p < bg.size() && a[i] == bg[p])
                p++;

        if (p < bg.size())
        {
//            cout << " - bg not nwp" << endl;
            continue;
        }
        if (find_nwp() == bg.size())
        {
//            cout << " - ans" << endl;
            ans++;
            continue;
        }
//        cout << endl;
    }
    while (next_permutation(all(a)));

    cout << ans;
    return 0;
}
