#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector<bool> used(0);
vector< vector<int> > a, c;
vector< vector<bool> > b, d;

void dfs1(int i) {
    int q = a[i].size();
    used[i] = true;
    for (int j = 0; j < q; j++) {
        dfs1(a[i][j]);
    }
}

void dfs2(int i) {
    int q = c[i].size();
    used[i] = true;
    for (int j = 0; j < q; j++) {
        dfs2(c[i][j]);
    }
}

int main() {
    ifstream in("virus.in");
    ofstream out("virus.out");
    int n, i, x;
    in >> n;
    a.resize(n, vector<int>(0));
    b.resize(n, vector<bool>(n, false));
    for (i = 0; i < n; ++i) {
        in >> x;
        if (x != 0) {
            a[x - 1].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        used = b[n - 1];
        dfs1(i);
        b[i] = used;
        b[i][i] = false;
    }
    c.resize(n, vector<int>(0));
    d.resize(n, vector<bool>(n, false));
    for (i = 0; i < n; ++i) {
        in >> x;
        if (x != 0) {
            c[x - 1].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        used = d[n - 1];
        dfs2(i);
        d[i] = used;
        d[i][i] = false;
    }
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (b[i][j] && d[i][j]) sum++;
        }
    }
    out << sum;
    in.close();
    out.close();
    return 0;
}
