#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define TASKNAME "army"

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int MAXN = 16;

int n, k;
int ids[MAXN];
bool isg[MAXN];
int was, lasg;

int cmlen[MAXN];
int curs[MAXN];

int ans;

void go(int pos) {
  if (pos == n) { ans++; return; }
  for (int v = 0; v < n; v++) if (!(was & (1 << v))) {
    if (isg[v]) {
      if (ids[lasg] != v) continue;
    }

    curs[pos] = v;
    cmlen[pos] = 0;
    for (int pr = 0; pr < pos; pr++)
      if (curs[pr] < v)
        cmlen[pos] = max(cmlen[pos], cmlen[pr]);

    cmlen[pos]++;
    if (cmlen[pos] > k)
      continue;

    was ^= 1 << v;
    if (isg[v]) lasg++;

    go(pos + 1);

    was ^= 1 << v;
    if (isg[v]) lasg--;
  }
}

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (scanf("%d%d", &n, &k) >= 1) {
    assert(n <= 12);
    for (int i = 0; i < k; i++)
      scanf("%d", &ids[i]), ids[i]--;
    ids[k] = -1;

    memset(isg, 0, sizeof isg);
    for (int i = 0; i < k; i++) isg[ids[i]] = true;

    ans = 0;
    was = 0; lasg = 0;
    memset(curs, 0, sizeof curs);
    go(0);
    printf("%d\n", ans);
  }
  return 0;
}
