{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $01000000}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  DEBUG = false;
  max_n = 200000;
  p = 41;

type
  int = integer;

var
  a, b, c : array[0..max_n] of int;
  ch : array[0..max_n] of boolean;
  i, n, m, l, r, x, j : int;
  s1, s2 : string;
  bool : boolean;

function bin(l, r, cur : int) : int;
var
  m, ll, sum : int;
begin
  ll := l - 1;
  while l <= r do begin
    m := (l + r) div 2;
    sum := b[m] - b[ll];
    if sum = cur then begin
      result := m;
      exit;
    end;
    if sum < cur then
      l := m + 1
    else
      r := m - 1;
  end;
  result := -1;
end;

function check(l, r : int) : int;
var
  i, cur, res : int;
begin
  cur := 0;
  for i := l to r do
    cur := cur * 10 + c[i];
  res := r + (n - m);
  if (res > n) then begin
    result := -1;
    exit;
  end;
  if b[res] - b[l - 1] <> cur then begin
    result := -1;
    exit;
  end;
  if ch[r + 1] then
    result := res
  else
    result := -1;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');

  readln(s1);
  n := length(s1);
  b[0] := 0;
  for i := 1 to n do begin
    a[i] := ord(s1[i]) - ord('0');
    b[i] := b[i - 1] + a[i];
  end;
  readln(s2);
  m := length(s2);
  for i := 1 to m do
    c[i] := ord(s2[i]) - ord('0');

  bool := true;
  if (n <> m) then
    bool := false
  else
    for i := 1 to n do
      if (s1[i] <> s2[i]) then begin
        bool := false;
        break;
      end;
  if bool then begin
    writeln('1 1');
    halt(0);
  end;

  j := n;
  for i := 1 to m do
    ch[i] := false;
  for i := m downto 1 do begin
    ch[i] := c[i] = a[j];
    j := j - 1;
    if not ch[i] then
      break;
  end;
  ch[m + 1] := true;

  for l := 1 to m do begin
    for r := l to min(m, l + 7) do begin
      x := check(l, r);
      if x <> -1 then begin
        write(l, ' ', x);
        halt(0);
      end;
    end;
    if a[l] <> c[l] then
      break;
  end;

  close(input);
  close(output);
end.
