{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $01000000}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  DEBUG = true;
  max_n = 3000;
  mx = 100000000000000000;

type
  int = integer;

var
  a : array[0..max_n] of int64;
  i, j, t, n : int;
  u, r, cur : int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(n, r, u);
  fillchar(a, sizeof(a), 0);
  a[1] := 0;
  a[2] := u;
  for i := 3 to n do begin
    a[i] := mx;
    for t := 0 to i - 2 do
      if (i - t) mod 2 = 0 then begin
        j := (i - t) div 2;
        if t = 0 then
          cur := a[j] + u
        else
          cur := max(a[j] + u, a[t] + r);
        if cur < a[i] then
          a[i] := cur;
      end;
  end;
  if DEBUG then begin
    for i := 1 to n do
      write(a[i], ' ');
    writeln;
  end;
  writeln(a[n]);

  close(input);
  close(output);
end.
