#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
using namespace std;

string s1;
string s2;
int a[100100], b[100100], sum[100100];

int getlen(int a) {
	int answer = 0;
	do {
		a /= 10;
		answer++;
	} while(a > 0);
	return answer;
}

int power10(int a) {
	if(a == 0) return 1;
	if(a == 1) return 10;
	if(a == 2) return 100;
	if(a == 3) return 1000;
	if(a == 4) return 10000;
	if(a == 5) return 100000;
	if(a == 6) return 1000000;
	if(a == 7) return 10000000;
	if(a == 8) return 100000000;
	if(a == 9) return 1000000000;
}

int main() {
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);
	getline(cin, s1);
	getline(cin, s2);
	int a_len = s1.size(), b_len = s2.size();
	for(int i = 0; i < a_len; i++) a[i] = ((int)(s1[i] - '0'));
	for(int i = 0; i < b_len; i++) b[i] = ((int)(s2[i] - '0'));
	if(a_len == b_len && s1 == s2) printf("1 1\n");
	else if(a_len == b_len) {
		for(int i = 0; i < a_len - 1; i++) {
			int sumA = a[i] + a[i+1];
			int sumB = b[i] * 10 + b[i+1];
			if(sumA == sumB) {
				printf("%d %d\n", i + 1, i + 2);
				break;
			}
		}
	}
	else {
		sum[0] = a[0];
		for(int i = 1; i < a_len; i++) sum[i] = sum[i-1] + a[i];
		int firstid = -1;
		for(int i = 0; i < a_len; i++) {
			if(a[i] != b[i]) {
				firstid = i;
				break;
			}
		}
		int sub = a_len - b_len;
		for(int i = firstid; i >= 0; i--) {
			int x;
			if(i != 0) x = sum[i - 1];
			else x = 0;
			for(int j = i; j < a_len; j++) {
				int sss = sum[j] - x;
				int lennn = getlen(sss);
				if(j - i + 1 - lennn > sub) break;
				if(j - i + 1 - lennn < sub) continue;
				int newsum = 0;
				for(int k = 0; k < lennn; k++) newsum += b[i+k] * power10(lennn-k-1);
				if(newsum == sss) {
					printf("%d %d\n", i + 1, j + 1);
					return 0;
				}
			}
		}
	}
	return 0;
}