#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
using namespace std;

int power10(int a) {
	if(a == 0) return 1;
	if(a == 1) return 10;
	if(a == 2) return 100;
	if(a == 3) return 1000;
	if(a == 4) return 10000;
	if(a == 5) return 100000;
	if(a == 6) return 1000000;
	if(a == 7) return 10000000;
	if(a == 8) return 100000000;
	if(a == 9) return 1000000000;
}

int main() {
	//freopen("calendar.in", "rt", stdin);
	//freopen("calendar.out", "wt", stdout);
	int N, M;
	scanf("%d %d", &N, &M);
	int **matrix = new int*[N];
	for(int i = 0; i < M; i++) matrix[i] = new int[M];
	int *line = new int[M];
	for(int i = 0; i < M; i++) line[i] = -1;
	for(int i = 0; i < N; i++) {
		scanf("\n");
		for(int j = 0; j < M; j++) {
			char sym;
			scanf("%c", &sym);
			if(sym == '*') matrix[i][j] = -1;
			else {
				line[j] = i;
				matrix[i][j] = ((int)(sym - '0'));
			}
		}
	}
	for(int i = 0; i < N - 1; i++) {
		for(int j = 0; j < M - 1; j++) {
			if(matrix[i][j] != -1 && matrix[i+1][j] != -1 && matrix[i+1][j] == (matrix[i][j] + 1) % 10) {
				for(int x = j + 1; x < M; x++) {
					matrix[i][x] = 9;
					matrix[i+1][x] = 0;
				}
			}
		}
	}
	for(int i = max(0, M - 7); i < M; i++) {
		if(line[i] != -1) {
			int val = matrix[line[i]][i];
			for(int j = line[i]; j >= 0; j -= power10(M-i-1)) {
				matrix[j][i] = val;
				if(val == 9 && i != 0) {
					int ii = j;
					while(matrix[ii][i-1] == -1 && ii < N) ii++;
					if(ii != N) {
						matrix[j][i-1] = (matrix[ii][i-1] - 1) % 10;
					}
				}
				val--;
				if(val < 0) val += 10;
			}
		}
	}
	for(int i = 0; i < N - 1; i++) {
		for(int j = 0; j < M - 1; j++) {
			if(matrix[i][j] != -1 && matrix[i+1][j] != -1 && matrix[i+1][j] == (matrix[i][j] + 1) % 10) {
				for(int x = j + 1; x < M; x++) {
					matrix[i][x] = 9;
					matrix[i+1][x] = 0;
				}
			}
		}
	}
	for(int i = 0; i < M; i++) {
		if(matrix[0][i] != -1) printf("%d", matrix[0][i]);
		else if(line[i] != -1) printf("%d", matrix[line[i]][i]);
		else printf("5");
	}
	printf("\n");
	return 0;
}