#include <fstream>
#include <string>

using namespace std;

bool check(string& s1, string& s2, int l1, int r1, int l2, int r2){
	string tmp, tmp2;
	tmp.assign(s1.begin() + l1, s1.begin() + r1);
	tmp2.assign(s2.begin() + l2, s2.begin() + r2);
	int need = atoi(tmp2.c_str());
	int cur = 0;
	for(int i = 0; i < tmp.size(); i++){
		cur += tmp[i] - '0';
		if(cur > need){
			return false;
		}
	}
	return cur == need;
}

int main(){
	using namespace std;
	ifstream fin("password.in");
	ofstream fout("password.out");
	string s1, s2;
	fin >> s1 >> s2;
	int l1 = s1.size();
	int l2 = s2.size();
	int d = l1 - l2;
	int i = d + 1;
	while(1){
		for(int j = 0; j < l1 - i + 1; j++){
			if(check(s1, s2, j, j + i, j, j + i - d)){
				fout << j + 1 << " " << j + i;
				return 0;
			}
		}
		i++;
	}
	return 0;
}