#include <fstream>
#include <vector>

using namespace std;

struct para{
	int x;
	int y;
	para(int xx, int yy) :x(xx), y(yy){}
	para(){}
};

int main(){
	ifstream fin("calendar.in");
	ofstream fout("calendar.out");
	int n, m;
	fin >> n >> m;
	vector<para> A(m);
	char ch;
	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			fin >> ch;
			if(ch != '*'){
				para tmp(i, ch - '0');
				A[j] = tmp;
			}
		}
	}
	vector<int> res(m);
	vector<int> plus(n);
	vector<int> oplus(n);
	for(int i = 0; i < n; i++){
		plus[i] = i;
	}
	for(int i = m - 1; i >= 0; i--){
		para cur = A[i];
		int ans = cur.y - plus[cur.x];
		if(ans < 0){
			ans %= 10;
			if(ans != 0){
				ans += 10;
			}
		}
		res[i] = ans;
		oplus = plus;
		plus.clear();
		plus.resize(n);
		plus[0] = 0;
		for(int j = 1; j < n; j++){
			plus[j] = plus[j - 1];
			if(oplus[j]){
				ans++;
			}
			if(ans == 10){
				ans = 0;
				plus[j]++;
			}
		}
	}
	for(int i = 0; i < m; i++){
		fout << res[i];
	}
	return 0;
}