#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int max_posl(vector<int>& A){
	vector<int> B(A.size() + 1);
	for(int i = 0; i < A.size() + 1; i++){
		if(i == 0){
			B[i] = -1000000000;
		} else {
			B[i] = 1000000000;
		}
	}
	for(int i = 0; i < A.size(); i++){
		*(upper_bound(B.begin(), B.end(), A[i])) = A[i];
	}
	for(int i = 1; i < B.size(); i++){
		if(B[i] == 1000000000){
			return i - 1;
		}
	}
	return B.size() - 1;
}

bool check(vector<int>& A, vector<int>& B){
	int max = max_posl(A);
	int q = B[0];
	int now = 0;
	for(int i = 0; i < A.size(); i++){
		if(now == B.size()){
			break;
		}
		if(A[i] == B[now]){
			now++;
		}
	}
	if(now != B.size()){
		return false;
	}
	if(max == B.size()){
		return 1;
	} else {
		return 0;
	}
}

int main(){
	ifstream fin("army.in");
	ofstream fout("army.out");
	int n, k;
	fin >> n >> k;
	int cnt = 0;
	vector<int> A(n);
	for(int i = 0; i < n; i++){
		A[i] = i + 1;
	}
	vector<int> B(k);
	for(int i = 0; i < k; i++){
		int tmp;
		fin >> tmp;
		B[i] = tmp;
	}
	cnt += check(A, B);
	while(next_permutation(A.begin(), A.end())){
		cnt += check(A, B);
	}
	fout << cnt;
	return 0;
}