#include <iostream>
#include <string>
#include <vector>

using namespace std;

#define maxn 100001

int n;

int s1;
int s2;

vector <int> g1[maxn];
vector <int> g2[maxn];

string p[maxn];

bool used[maxn];
bool was[maxn];

string its(int x) {
	string res = "";
	while (x != 0) {
		res = char(x % 10 + '0') + res;
		x /= 10;
	}
	if (res == "")
		res = '0';
	return res;
}

long long ans;

void DFS(int v, string way) {
	used[v] = true;
	for (int i = 0; i < g1[v].size(); i++) {
		int u = g1[v][i];
		if (!used[u]) {
			string r = way + 'x' + its(v);
			p[u] = r;
			DFS(u, r);
		}
	}
}

bool pred(int pr, int u) {
	string al = its(pr);
	int len = al.size();
	string dar = p[u];
	if (dar == "")
		return false;
	for (int i = 0; i < dar.size() - al.size() + 1; i++) {
		if (dar.substr(i, len) == al)
			return true;
	}
	return false;
}

void D(int v, int pr) {
	was[v] = true;
	for (int i = 0; i < g2[v].size(); i++) {
		int u = g2[v][i];
		if (pred(pr, u))
			ans++;
		if (!was[u])
			D(u, pr);
	}
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	cin >> n;

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		x--;
		if (x != -1)
			g1[x].push_back(i);
		else
			s1 = i;
	}

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		x--;
		if (x != -1)
			g2[x].push_back(i);
		else s2 = 0;
	}

	DFS(s1, "");

	for (int k = 0; k < n; k++) {
		for (int j = 0; j < n; j++)
			was[j] = false;
		D(k, k);
	}

	cout << ans;

	return 0;
}