#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <string>
using namespace std;

const int MAXN = 100008;

string s, t, cur_s;
int A[MAXN];

string toStr(int n)
{
	string res, ans;
	while(n)
	{
		res += n % 10 + '0';
		n /= 10;
	}
	for(int i = res.size() - 1; i >= 0; i--)
		ans += res[i];
	return ans;
}

int main()
{
	int cur;
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	cin >> s >> t;
	A[1] = s[0] - '0';
	for(int i = 2; i <= s.size(); i++)
	{
		A[i] = A[i - 1] + s[i - 1] - '0';
	}
	for(int i = 0; i < s.size(); i++)
	{
		for(int j = 0; j < s.size(); j++)
		{
			cur = A[j + 1] - A[i];
			cur_s = toStr(cur);
			/*if(t.substr(i - 1, cur_s.size()) == cur_s)
			{
				cout << i << " " << j;
				return 0;
			}*/
			if(s.substr(0, i) + cur_s + s.substr(j + 1) == t)
			{
				cout << i + 1 << " " << j + 1;
				return 0;
			}
		}
	}
	return 0;
}