#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100008;

vector <vector <int> > g1, g2;


int H1[MAXN], H2[MAXN];
bool vis1[MAXN], vis2[MAXN];

void dfs1(int v)
{
	int u;
	for(int i = 0; i < g1[v].size(); i++)
	{
		u = g1[v][i];
		vis1[u] = true;
		dfs1(u);
	}
}

void dfs2(int v)
{
	int u;
	for(int i = 0; i < g2[v].size(); i++)
	{
		u = g2[v][i];
		vis2[u] = true;
		dfs2(u);
	}
}


int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	int n, r1, r2, t;
	cin >> n;
	g1.resize(n);
	g2.resize(n);
	for(int i = 0; i < n; i++)
	{
		cin >> t;
		if(!t)
			r1 = i;
		else
			g1[t - 1].push_back(i);
	}
	for(int i = 0; i < n; i++)
	{
		cin >> t;
		if(!t)
			r2 = i;
		else
			g2[t - 1].push_back(i);
	}
	int ans = 0;
	for(int i = 0; i < n; i++)
	{
		dfs1(i);
		dfs2(i);
		for(int j = 0; j < n; j++)
		{
			if(vis1[j] && vis2[j])
				++ans;
		}
		memset(vis1, 0, sizeof(vis1));
		memset(vis2, 0, sizeof(vis2));
	}
	cout << ans;
	return 0;
}