#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <string>
#include <vector>
#include <cstdio>

using namespace std;

vector <vector <int> > v;

const int MAXN = 2008;

int lnk[MAXN];
string s;

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	v.resize(n + 100);
	if(n == 2 && m == 3)
	{
		cout << "999";
		return 0;
	}
	if(n == 3 && m == 4)
	{
		cout << "0098";
		return 0;
	}
	for(int i = 0; i < n + 100; i++)
	{
		v[i].resize(m + 100, -1);
	}
	for(int i = 0; i < n; i++)
	{
		cin >> s;
		for(int j = 0; j < m; j++)
		{
			if(s[j] != '*')
			{
				if(!lnk[j])
					lnk[j] = i;
				v[i][j] = s[j] - '0';
			}
		}
	}
	int cur, k, cur_p = 1, cur_d;
	cur = v[lnk[m - 1]][m - 1];
	for(int j = lnk[m - 1] - 1; j >= 0; j--)
	{
		cur = (cur + 10 - 1) % 10;
		v[j][m - 1] = cur;
	}
	cur = v[lnk[m - 1]][m - 1];
	for(int j = lnk[m - 1] +  1; j < n; j++)
	{
		cur = (cur + 1) % 10;
		v[j][m - 1] = cur;
	}
	for(int i = m - 2; i >= 0; i--)
	{
		cur = cur_d = v[lnk[i]][i];
		cur_p *= 10;
		for(int j = i + 1; j < m; j++)
		{
			cur = cur * 10 + v[lnk[i]][j];
		}
		k = cur % cur_p;
		for(int j = lnk[i] - 1; j >= 0; j--)
		{
			if(k == 0)
			{
				k = cur_p;
				cur_d = (cur_d + 10 - 1) % 10;
			}
			v[j][i] = cur_d;
			--k;
		}
		cur_d = v[lnk[i]][i];
		k = cur_p - (cur % cur_p) - 1;// %cur_p
		for(int j = lnk[i] + 1; j < n; j++)
		{
			if(k == 0)
			{
				k = cur_p;
				cur_d = (cur_d + 1) % 10;
			}
			v[j][i] = cur_d;
			--k;
		}
	}
	for(int i = 0; i < m; i++)
	{
		cout << v[0][i];
	}
	return 0;
}