#pragma comment(linker, "/STACK:67108864")

#include <iostream>

using namespace std;

const int MAXN = 5008;


struct 
{
	int a, b;
} A[MAXN];

int B[MAXN][MAXN];
int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	int n, a, b;
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		cin >> A[i].a >> A[i].b;
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++)
		{
			if(A[i].a == A[j].a || A[i].b == A[j].b)
			{
				B[i][j] = 1;
				B[j][i] = 1;
			}
		}
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = 1; j < n; j++)
		{
			B[i][j] = B[i][j - 1] + B[i][j];
		}
	}

	int k, ln, flag;
	cin >> k;
	for(int i = 0; i < k; i++)
	{
		flag = true;
		cin >> a >> b;
		--a;
		--b;
		ln = b - a + 1;
		for(int j = a; j <= b && flag; j++)
		{
			if(B[j][b] - (a - 1 >= 0 ? B[j][a - 1] : 0) < ln)
			{
				flag = false;
				if(a == 0)
				{
					if(B[j][a] == 0)
					{
						cout << j + 1 << " " << a + 1<< endl;
					}
				}
				else
				{
					for(int i = a; i <= b; i++)
					{
						if(B[j][i] == B[j][i - 1])
						{
							cout << j + 1 << " " << i + 1 << endl;
						}
					}
				}
			}
		}
		if(flag)
			cout << "0 0" << endl; 
	}
	return 0;
}