#pragma comment(linker, "/STACK:67108864")

#include <iostream>

using namespace std;

const int MAXN = 5008;


struct 
{
	int a, b;
} A[MAXN];

int B[MAXN][MAXN];
int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	int n, a, b;
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		cin >> A[i].a >> A[i].b;
	}
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++)
		{
			if(A[i].a == A[j].a || A[i].b == A[j].b)
			{
				B[i + 1][j + 1] = 1;
				B[j + 1][i + 1] = 1;
			}
		}
	}
	for(int i = 1; i <= n; i++)
	{
		for(int j = 2; j <= n; j++)
		{
			B[i][j] = B[i][j - 1] + B[i][j];
		}
	}

	int k, ln;
	bool flag;
	cin >> k;
	for(int i = 0; i < k; i++)
	{
		flag = true;
		cin >> a >> b;
		ln = b - a + 1;
		for(int j = a; j <= b && flag; j++)
		{
			if(B[j][b] - B[j][a - 1] < ln)
			{
				flag = false;
				for(int m = a; m <= b; m++)
				{
					if(B[j][m] == B[j][m - 1])
					{
						cout << j << " " << m << endl;
						break;
					}
				}
			}
		}
		if(flag)
			cout << "0 0" << endl; 
	}
	return 0;
}