#pragma comment(linker, "/STACK:67108864")

#include <iostream>

using namespace std;

const int MAXN = 22;
const int INF = 1e+9;
bool used[MAXN];
int in[MAXN];
int gen[MAXN];
int nvp[MAXN];
int A[MAXN];
int n, k, ans = 0;

int binsearch(int val)
{
	int m, l = 0, r = n + 1;
	while(r - l > 1)
	{
		m = (l + r) / 2;
		if(nvp[m] < val)
			l = m;
		else
			r = m;
	}
	return l;
}


bool check()
{
	int b;
	nvp[0] = -INF;
	for(int i = 1; i <= n + 10; i++)
	{
		nvp[i] = INF;
	}
	for(int i = 0; i < n; i++)
	{
		b = binsearch(gen[i]);
		nvp[b + 1] = min(nvp[b + 1], gen[i]);
	}
	if(nvp[k + 1] == INF)
		return true;
	return false;
}

void rec(int pos, int m)
{
	if(pos == n)
	{
		if(check())
			++ans;
	}
	else
	{
		for(int i = 1; i <= n; i++)
		{
			if(!used[i])
			{
				if(!in[i])
				{
					used[i] = 1;
					gen[pos] = i;
					rec(pos + 1, m);
					used[i] = 0;
				}
				else if(in[i] == m + 1)
				{
					used[i] = 1;
					gen[pos] = i;
					rec(pos + 1, m + 1);
					used[i] = 0;
				}
			}
		}
	}
}


int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	cin >> n >> k;
	for(int i = 0; i < k; i++)
	{
		cin >> A[i];
		in[A[i]] = i + 1;
	}
	if(k != 1)
	{
		rec(0, 0);
		cout << ans;
	}
	else
	{
		cout << "1";
	}
	return 0;
}