#include <cstdio>
#include <iostream>

#include <vector>

using namespace std;

#define sz(x) ((int)(x).size())
#define pb push_back

typedef long long ll;

const int maxn = 100 * 1000 + 5;

vector <int> A[maxn], B[maxn];
int tin_a[maxn], tout_a[maxn], tin_b[maxn], tout_b[maxn];
int tm = 0;

void dfs_a(int v)
{
	tin_a[v] = tm++;
	for (int i = 0; i < sz(A[v]); ++i) {
		dfs_a(A[v][i]);	
	}
	tout_a[v] = tm++;
}

void dfs_b(int v)
{
	//tin_b[v] = tm++;
	T.upd(tin_a[v], tout_a[v]);
	for (int i = 0; i < sz(B[v]); ++i) {
		dfs_b(B[v][i]);	
	}
	//tout_b[v] = tm++;
	T.upd(tin_a[v], -1);
}
int main()
{
	freopen("virus.in", "r", stdin);
	//freopen("virus.out", "w", stdout);
	
	int n; scanf("%d", &n);
	int root_a, root_b;
	for (int i = 0; i < n; ++i) {
		int p; scanf("%d", &p);
		if (p) { 
			A[p - 1].pb(i);
		}
		else {
			root_a = i;	
		}
	}
	for (int i = 0; i < n; ++i) {
		int p; scanf("%d", &p);
		if (p) {
			B[p - 1].pb(i);
		}
		else {
			root_b = i;	
		}
	}
	
	dfs_a(root_a);
	dfs_b(root_b);
	
	ll res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (tin_a[i] < tin_a[j] && tout_a[i] > tout_a[j] && tin_b[i] < tin_b[j] && tout_b[i] > tout_b[j]) {
				++res;	
			}
		}
	}
	
	cout << res << '\n';
	
	return 0;
}
