#include <cstdio>
#include <iostream>

using namespace std;

typedef long long ll;

const ll linf = 1LL << 60;
const int maxn = 1000 * 1000 + 5;

ll F[maxn];
bool used[maxn];

ll U, R;

ll find(int n)
{
	if (n <= 1) {
		return 0;	
	}
	if (used[n]) {
		return F[n];	
	}
	used[n] = 1;
	
	ll res = linf;
	for (int a = 1; a * 2 <= n; ++a) {
		ll res1 = U + find(a);
		ll res2 = R + find(n - a * 2);
		if (a * 2 < n) {
			res1 = max(res1, res2);
		}
		res = min(res, res1);
	}
	
	return F[n] = res;
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	
	int n; cin >> n >> R >> U;
	
	ll res = find(n);
	cout << res << '\n';
	
	return 0;
}
