#include <cstdio>
#include <iostream>
#include <cstring>

#include <vector>

using namespace std;

#define sz(x) ((int)(x).size())

const int maxn = 10000 + 5;
const int maxm = 10000 + 5;

vector <int> A[maxn];
int K[maxm];
int ans[maxn];
bool used[maxn], used2[maxn];

int n, m;
int N;

void erase(int x)
{
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < sz(A[i]); ++j) {
			if (A[i][j] == x) {
				A[i].erase(A[i].begin() + j);
				
				break;
			}
		}	
	}
	--N;
}

int main()
{
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d", &K[i]);
		for (int j = 0; j < K[i]; ++j) {
			int x; scanf("%d", &x); --x;
			//add(i, x);
			A[i].push_back(x);
		}
	}
	
	N = n;

	for (int i = 0; i < m; ++i) {
		
		while (1) {
			/*cerr << "## " << i << " " << N << "\n";
			for (int j = 0; j < m; ++j) {
				for (int l = 0; l < sz(A[j]); ++l) {
					cerr << A[j][l] + 1 << " ";
				}
				cerr << "\n";
			}*/
	
		
			if (sz(A[i]) == 1) {
				ans[A[i][0]] = i + 1;
				erase(A[i][0]);
				//break;
			}
			
			if (sz(A[i]) == N - 1) {
				memset(used, 0, sizeof(used));
				for (int j = 0; j < sz(A[i]); ++j) {
					used[A[i][j]] = 1;
				}
				for (int j = 0; j < n; ++j) {
					if (!used[j] && !ans[j]) {
						ans[j] = i + 1;
						erase(j);
						break;
					}
				}	
			}	
			
			memset(used, 0, sizeof(used));
			for (int j = 0; j < sz(A[i]); ++j) {
				used[A[i][j]] = 1;
			}
			
			bool er = 0;
			
			for (int j = 0; j < i; ++j) {
				int cnt_all = 0;
				for (int l = 0; l < sz(A[j]); ++l) {
					if (used[A[j][l]]) {
						++cnt_all;
					}
				}
				
				bool good = 0;
				if (cnt_all == 1) {
					for (int l = 0; l < sz(A[j]); ++l) {
						if (used[A[j][l]]) {
							ans[A[j][l]] = i + 1;
							erase(A[j][l]);
							er = good = 1;
							break;
						}
					}
				}
				if (good) {
					continue;
				}
				
				if (sz(A[j]) - 1 == sz(A[i]) && cnt_all == sz(A[i])) {
					for (int l = 0; l < sz(A[j]); ++l) {
						if (!used[A[j][l]]) {
							ans[A[j][l]] = i + 1;
							erase(A[j][l]);
							er = good = 1;
							break;
						}
					}
				}
				
				if (good) {
					continue;
				}
				
				if (sz(A[j]) + 1 == sz(A[i]) && cnt_all == sz(A[j])) {
					for (int l = 0; l < sz(A[j]); ++l) {
						used[A[j][l]] = 0;
					}
					
					for (int l = 0; l < n; ++l) {
						if (used[l]) {
							ans[l] = i + 1;
							erase(l);
							er = good = 1;
							break;
						}
					}
					
					for (int l = 0; l < sz(A[j]); ++l) {
						used[A[j][l]] = 1;
					}
				}
				
				if (good) {
					continue;
				}
				
				if (sz(A[j]) == 1) {
					ans[A[j][0]] = i + 1;
					erase(A[j][0]);
					good = er = 1;
				}
				
				if (!good) {
					continue;
				}
				
				if (sz(A[j]) == N - 1) {
					memset(used2, 0, sizeof(used2));
					for (int l = 0; l < sz(A[j]); ++l) {
						used2[A[j][l]] = 1;
					}
					for (int l = 0; l < n; ++l) {
						if (!used2[l] && !ans[l]) {
							ans[l] = i + 1;
							erase(l);
							er = good = 1;
						}
					}
				}
			}
			
			if (!er) {
				break;
			}
		}
	}
	
	for (int i = 0; i < n; ++i) {
		printf("%d ", ans[i]);
	}

	return 0;
}
