#include <iostream>
#include <cstdio>
#include <string>
#include <vector>

using namespace std;
vector < vector < int > > matr(3000), matr2(3000);
int in1[3000], in2[3000], out1[3000], out2[3000];
int n, tt = 0;

void dfs1(int v) {
    in1[v] = tt;
    ++tt;
    for (size_t i = 0; i < matr[v].size(); ++i) {
        dfs1(matr[v][i]);
    }
    out1[v] = tt;
    ++tt;
}

void dfs2(int v) {
    in2[v] = tt;
    ++tt;
    for (size_t i = 0; i < matr2[v].size(); ++i) {
        dfs2(matr2[v][i]);
    }
    out2[v] = tt;
    ++tt;
}



bool p1(int i, int j) {
    return ((in1[i] <= in1[j]) && (out1[i] >= out1[j]));
}

bool p2(int i, int j) {
    return ((in2[i] <= in2[j]) && (out2[i] >= out2[j]));
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    cin >> n;
    int x;
    int b1 = 0, b2 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> x;
        if (!x) {
            b1 = i;
        } else {
            matr[x - 1].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> x;
        if (!x) {
            b2 = i;
        } else {
            matr2[x - 1].push_back(i);
        }
    }
    dfs1(b1);
    tt = 0;
    dfs2(b2);
    int sum = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if ((p1(i, j) && p2(i, j)) || (p1(j, i) && p2(j, i))) ++sum;
        }
    }
    cout << sum;
    return 0;
}
