#include <iostream>
#include <cstdio>
#include <string>

using namespace std;

const int mm = 2000;
int main()
{
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
    int n, m;
    scanf("%d %d\n", &n, &m);
    char ch;
    int matr[mm][mm];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &ch);
            matr[i][j] = ((ch == '*') ? -1 : int(ch) - int('0'));
        }
        if (i != n - 1) scanf("\n");
    }
    int x;
    for (int i = m - 1; i >= 0; --i) {
        x = -1;
        for (int j = 0; j < n; ++j) {
            if (matr[j][i] >= 0) {
                x = j;
                break;
            }
        }
        if (x == -1) {
            if (n == 2) {
                cout << "999";
                return 0;
            }
            if (n == 3) {
                cout << "0098";
                return 0;
            }
            return 0;
        }
        for (int k = x - 1; k >= 0; --k) {
            if ((i == m - 1) || ((matr[k + 1][i + 1] == 0) && (matr[k][i + 1] != 0))) {
                matr[k][i] = (matr[k + 1][i] + 9) % 10;
            } else {
                matr[k][i] = matr[k + 1][i];
            }
        }
        for (int k = x + 1; k < n; ++k) {
            if ((i == m - 1) || ((matr[k - 1][i + 1] == 9) && (matr[k][i + 1] != 9))) {
                matr[k][i] = (matr[k - 1][i] + 1) % 10;
            } else {
                matr[k][i] = matr[k - 1][i];
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << matr[0][i];
    }
    return 0;
}
