#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

void solve1(vector <int> &a, vector <int> &b)
{
	int answer = 0;
	for (int i = 0; i < a.size(); i++)
	{
		set <int> a_set, b_set;
		int a_cur = a[i], b_cur = b[i];
		
		while (a_cur != -1)
		{
			a_set.insert(a_cur);
			a_cur = a[a_cur];
		}

		while (b_cur != -1)
		{
			b_set.insert(b_cur);
			b_cur = b[b_cur];
		}

		if (a_set.size() > b_set.size())
			swap(a_set, b_set);

		for (set <int>::iterator it = a_set.begin(); it != a_set.end(); it++)
			if (b_set.find(*it) != b_set.end())
			{
				answer++;
#ifdef CUCUMBER
				cerr << "for " << i + 1 << " found " << 1 + *it << "\n";
#endif
			}
	}
	
	cout << answer << "\n";
	return void();
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w+", stdout);
#endif

	int n;
	cin >> n;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; i++)
		cin >> a[i], a[i]--;
	for (int i = 0; i < n; i++)
		cin >> b[i], b[i]--;

	solve1(a, b);

	return 0;
}