#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

int int_log(int n)
{
	return (int) floor(log((double)n) / log(2.0L));
}

void solve1(int n, int r, int u)
{
	int answer = 0;
	if (n % 2 == 0)
		answer = int_log(n) * u;
	else
		answer = int_log(n) * u + r - u;

	cout << answer << "\n";
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w+", stdout);
#endif

	int n, r, u;
	cin >> n >> r >> u;

	solve1(n, r, u);

	return 0;
}