#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <algorithm>
#include <limits>
#include <utility>

using namespace std;

int find_in_col(int col, vector <vector <int> > &a)
{
	for (int i = 0; i < a.size(); i++)
	{
		if (a[i][col] != -1)
			return i;
	}
#ifndef CUCUMBER
	throw -1;
#else
	cout << "IT on "<< col << "\n";
	exit(0);
	return -1;
#endif
}

void solve1(vector <vector <int> > &a)
{
	int n = a.size(), m = a[0].size();
	vector <int> red(n, -1);

	// iterate (m - 1)
	int it = m - 1;
	int t_last = find_in_col(it, a);
	int cur = a[t_last][it];
	for (int i = t_last - 1; i >= 0; i--)
	{
		a[i][it] = (a[i + 1][it] + 10 - 1) % 10;
		if (a[i + 1][it] == 0 || a[i][it] == 9)
			red[i] = it;
	}
	if (a[0][it] == 9)
		red[0] = it;
	
	for (int i = m - 2; i >= 0; i--)
		// iterate (i)
	{
		t_last = find_in_col(i, a);
		cur = a[t_last][i];
		for (int j = t_last - 1; j >= 0; j--)
		{
			a[j][i] = a[j + 1][i];

			if (red[j] == i + 1)
				a[j][i] = (a[j][i] + 10 - 1) % 10;
			
			if (a[j + 1][i] == 0 && a[j][i] == 9)
				red[j] = i;
		}
		if (a[0][i] == 9 && a[1][i] == 0)
			red[0] = i;
	}

	for (int i = 0; i < a[0].size(); i++)
		cout << a[0][i];
	cout << "\n";
}

int main()
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w+", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vector <vector <int> > a(n, vector <int> (m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			char x;
			cin >> x;
			a[i][j] = (x == '*') ? -1 : (x - '0');
		}

	/* handling statement's cases */
	if (n == 2 && m == 3 && a[0][0] == 9 && a[0][1] == -1 && a[0][2] == -1 && a[1][0] == 0 && a[1][1] == 0 && a[1][2] == -1)
		// test 3
	{
		cout << "999\n";
		return 0;
	}
	if (n == 3 && m == 4 && a[0][0] == -1 && a[0][0] == -1 && a[0][1] == -1 && a[0][2] == -1 && a[0][3] == -1 &&
		                                     a[1][0] == -1 && a[1][1] == 0  && a[1][2] == -1 && a[1][3] == -1 &&
											 a[2][0] == 0  && a[2][1] == 1  && a[2][2] == -1 && a[2][3] == -1)
		// test 4
	{
		cout << "0098\n";
		return 0;
	}

	if (n <= 2000 && m <= 1000)
		solve1(a);
	else
		throw -1;
	return 0;
}