#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

void die(pair <int, int> answer)
{
	cout << answer.first + 1 << " " << answer.second + 1 << "\n";
	exit(0);
}

bool harm(pair <int, int> &a, pair <int, int> &b)
{	return a.first == b.first || a.second == b.second; }

void solve_naive(vector <pair <int, int> > &a, pair <int, int> &q)
{
	for (int j = q.first; j <= q.second; j++)
		{
			for (int k = q.first; k < j; k++)
			{
				if (!harm(a[j], a[k]))
				{
					cout << j + 1 << " " << k + 1 << "\n";
					return void();
				}
			}
		}
	cout << "0 0\n";
}

void solve1(vector <pair <int, int> > &a, vector <pair <int, int> > &q)
{
	for (int i = 0; i < q.size(); i++)
	{
		solve_naive(a, q[i]);
	}
}

int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w+", stdout);
#endif

	int n;
	cin >> n;
	vector <pair <int, int> > a(n), q;
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	cin >> n;
	q.resize(n);
	for (int i = 0; i < n; i++)
		cin >> q[i].first >> q[i].second, q[i].first--, q[i].second--;

	solve1(a, q);
	return 0;
}