#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

#define oint string

oint p(int n)
{
	return "" + (char)(n);
}

vector <int> answer;
int guess = 0;
void marquee(vector <oint> &pers, int round)
{
	for (int i = 0; i < pers.size(); i++)
	{
		if (answer[i] != -1)
			continue;
		bool found = false;
		for (int j = 0; j < pers.size(); j++)
		{
			if (i == j || answer[j] != -1)
				continue;
			if (pers[i] == pers[j])
			{
				found = true;
				break;
			}
		}
		if (!found)
		{
			answer[i] = round;
			guess++;
		}
	}
}

void solve1(vector <vector <int> > &act, int n)
{
	answer.resize(n, -1);
	vector <oint> pers(n, "");
	for (int i = 0; i < act.size(); i++)
	{
		for (int j = 0; j < act[i].size(); j++)
		{
			pers[act[i][j]] = pers[act[i][j]] + (char)('0' + i);
		}
		marquee(pers, i);
		if (guess == n)
			break;
	}

	for (int i = 0; i < n; i++)
	{
		cout << answer[i] + 1 << " ";
	}
}

int main(void)
{
#ifdef CUCUMBER
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w+", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vector <vector <int> > act(m);
	for (int i = 0; i < m; i++)
	{
		int size;
		cin >> size;
		act[i].resize(size);
		for (int j = 0; j < size; j++)
			cin >> act[i][j], act[i][j]--;
	}

	solve1(act, n);

	return 0;
}