#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE

/* in code we trust */

#include <iostream>
#include <cstdio>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

const int max_calling = 10000;

int gen(void)
{
	bool st1 = rand() & 1, st2 = rand() & 1, st3 = rand() & 1;
	if (st1 == st2 && st3)
		return 1;
	else if (st1 ^ st2 && !st3)
		return -1;
	else 
		return 0;
}

void solve_rand(int maxx, int maxy, int x0, int y0)
{
	for (int i = 0; i < max_calling; i++)
	{
		int dx, dy, result;
		dx = gen();
		dy = gen(); 
		if (!(0 < x0 + dx && x0 + dx <= maxx))
			dx = 0;
		if (!(0 < y0 + dy && y0 + dy <= maxy))
			dy = 0;
		cout << dx << " " << dy << " 1\n";
		x0 += dx, y0 += dy;
		cout.flush();

		cin >> result >> dx >> dy;
		if (result == 1)
			exit(0);
	}
	throw -1;
}

int main(void)
{
#ifdef CUCUMBER
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w+", stdout);
	freopen("log.txt", "w+", stderr);
#else
	// pass
#endif

	int maxx, maxy;
	cin >> maxx >> maxy;
	int x0, y0;
	cin >> x0 >> y0;
	srand(maxx * maxy + maxx * x0 - maxy * y0);
	solve_rand(maxx, maxy, x0, y0);

	return 0;
}