#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cctype>
#include <cstring>
#include <string>
#include <cstdlib>
#include <set>
#include <map>

using namespace std;

const int MAXSIZE = 100001;
const double eps = 1e-7;

typedef pair < int, int > pii;
typedef long long ll;

int a[MAXSIZE], b[MAXSIZE];
int sumA[MAXSIZE], sumB[MAXSIZE];
char ss[MAXSIZE + 1];
int n, k;

inline int getVal(int L, int R)
{
    int ans = 0;
    for (int i = L; i <= R; i++)
    {
        ans = ans * 10 + b[i];
    }
    return ans;
}

int solve()
{
    scanf("%s\n", ss);
    n = strlen(ss);
    for (int i = 0; i < n; i++)
    {
        a[i] = int(ss[i] - '0');
        sumA[i] = (i ? sumA[i - 1] : 0) + a[i];
        //cerr << a[i] << " ";
    }
    scanf("%s\n", ss);
    k = strlen(ss);
    for (int i = 0; i < k; i++)
    {
        b[i] = int(ss[i] - '0');
        sumB[i] = (i ? sumB[i - 1] : 0) + b[i];
        //cerr << b[i] << " ";
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = i; j < n; j++)
        {
            if (sumA[j] - (i ? sumA[i - 1] : 0) == getVal(i, k - (n - j - 1) - 1))
            {
                printf("%d %d\n", i + 1, j + 1);
                return 0;
            }
        }
    }
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
#endif
    
    solve();
    
    return 0;
}
