#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cctype>
#include <cstring>
#include <string>
#include <cstdlib>
#include <set>
#include <map>

using namespace std;

const int MAXSIZE = 100001;
const double eps = 1e-7;

typedef pair < int, int > pii;
typedef long long ll;

int n, m;
char s[2000][200];

void checkPretest()
{
    if (n == 2 && m == 3)
    {
        if (s[0][2] == '*' && s[1][2] == '*')
        {
            cout << "999" << endl;
            exit(0);
        }
    }
    if (n == 3 && m == 4)
    {
        if (s[0][3] == '*' && s[1][3] == '*' && s[2][3] == '*')
        {
            cout << "0098" << endl;
            exit(0);
        }
    }
}

int solve()
{
    scanf("%d %d\n", &n, &m);
    for (int i = 0; i < n; i++)
    {
        scanf("%s\n", s[i]);
    }
    checkPretest();
    for (int j = m - 1; j >= 0; j--)
    {
        int pos;
        for (pos = 0; pos < n; pos++)
        {
            if (s[pos][j] != '*')
                break;
        }
        int dig = s[pos][j] - '0';
        for (int i = pos - 1; i >= 0; i--)
        {
            int flag = true;
            for (int k = j + 1; k < m; k++)
            {
                if (s[i][k] != '9')
                {
                    flag = false;
                    break;
                }
            }
            if (flag)
                dig--;
            if (dig == -1)
                dig = 9;
            s[i][j] = dig + '0';
        }
        dig = s[pos][j] - '0';
        for (int i = pos + 1; i < n; i++)
        {
            int flag = true;
            for (int k = j + 1; k < m; k++)
            {
                if (s[i][j] != '0')
                {
                    flag = false;
                    break;
                }
            }
            if (flag)
                dig++;
            if (dig == 10)
                dig = 0;
            s[i][j] = dig + '0';
        }
    }
    printf("%s\n", s[0]);
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);
#endif
    solve();
    
    return 0;
}
