#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <string>
#include <cstring>
#include <set>
#include <map>

using namespace std;

const int MAXSIZE = 1000;

typedef pair < int, int > pii;
typedef long long ll;

int n, m, k;
set < int > act[MAXSIZE];
bool cnt[MAXSIZE];
int ans[MAXSIZE];

int solve()
{
    scanf("%d%d", &n, &m);
    
    fill(ans, ans + n, -1);
    
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            act[i].insert(j);
    }
    
    for (int i = 0; i < m; i++)
    {
        scanf("%d", &k);
        vector < int > cur(k);
        fill(cnt, cnt + MAXSIZE, 0);
        for (int j = 0; j < k; j++)
        {
            scanf("%d", &cur[j]);
            cnt[cur[j] - 1] = true;
        }
        for (int j = 0; j < n; j++)
        {
            if (cnt[j])
            {
                for (int w = 0; w < n; w++)
                {
                    if (!cnt[w])
                        act[j].erase(w);
                }
            }
            else
            {
                for (int w = 0; w < n; w++)
                {
                    if (cnt[w])
                        act[j].erase(w);
                }
            }
        }
        vector < int > mList;
        for (int j = 0; j < n; j++)
        {
            if (act[j].size() == 1)
            {
                //ans[j] = i;
                mList.push_back(j);
            }
        }
        for (int j = 0; j < n; j++)
        {
            for (int w = 0; w < mList.size(); w++)
            {
                act[j].erase(mList[w]);
            }
            if (act[j].size() == 0 && ans[j] == -1)
            {
                ans[j] = i;
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        printf("%d ", ans[i] + 1);
    }
    return 0;
}

int main()
{
#ifdef OFFLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    freopen("theatre.in", "r", stdin);
    freopen("theatre.out", "w", stdout);
#endif

    solve();
    
    return 0;
}
