program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxK = 100000;

type
  long = record
    n: integer;
    a: array[1..MaxK] of integer;
  end;

var
  a, b: long;
  sum: array[0..MaxK] of integer;

procedure readlong(var a: long);
var
  i: integer;
  s: string;
begin
  readln(s);
  a.n := length(s);
  for i := 1 to a.n do
    a.a[i] := strtoint(s[i]);
end;

procedure init;
var
  i: integer;
begin
  sum[0] := 0;
  for i := 1 to a.n do
    sum[i] := sum[i - 1] + a.a[i];
end;

function check(l, r: integer): boolean;
var
  l1, r1, i: integer;
  s: string;
begin
  result := true;
  l1 := l;
  r1 := b.n - (a.n - r);
  s := inttostr(sum[r] - sum[l - 1]);
  if length(s) <> (r1 - l1 + 1) then begin
    result := false;
    exit;
  end;
  for i := l1 to r1 do
    if b.a[i] <> strtoint(s[i - l1 + 1]) then begin
      result := false;
      exit;
    end;
end;

procedure solve;
var
  i, j, l, r: integer;
begin
  l := 1; r := b.n;
  while (l <= b.n) and (a.a[l] = b.a[l]) do inc(l);
  while (r >= 1) and (a.a[a.n - (b.n - r)] = b.a[r]) do dec(r);
  if (l > b.n) and (r < 1) then begin
    writeln(1, ' ', 1);
    exit;
  end;
  r := a.n - (b.n - r);
  for i := l downto 1 do
    for j := r to a.n do
      if check(i, j) = true then begin
        writeln(i, ' ', j);
        exit;
      end;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readlong(a);
  readlong(b);
  init;
  solve;
end.
