program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 100000;

type
  list = array[1..MaxN] of integer;
  tar = record
    free: integer;
    first, next, data: array[1..MaxN] of integer;
  end;

var
  i, n, k, b1, t, b2: integer;
  a, b: tar;
  ta, tb: list;
  ans: array[1..MaxN] of int64;
  was, use: array[1..MaxN] of boolean;

procedure init0;
var
  i: integer;
begin
  for i := 1 to MaxN do begin
    a.first[i] := 0;
    b.first[i] := 0;
    was[i] := false;
    use[i] := false;
    ans[i] := 0;
  end;
  a.free := 0;
  b.free := 0;
end;

procedure init;
var
  i: integer;
begin
  k := n;
  for i := 1 to n do begin
    use[i] := false;
  end;
end;


procedure dfs0(v: integer; const a: tar; var ta: list);
var
  i: integer;
begin
  i := a.first[v];
  while i <> 0 do begin
    dfs0(a.data[i], a, ta);
    i := a.next[i];
  end;
  ta[k] := v;
  dec(k);
end;

function search(v: integer): int64;
var
  i, k1, k2: integer;
  tmp: array[1..MaxN] of integer;
  t: int64;
begin
  for i := 1 to n do
    tmp[i] := 0;
  init;
  dfs0(v, a, ta);
  k1 := k + 1;
  init;
  dfs0(v, b, tb);
  k2 := k + 1;
  t := 0;
  for i := k1 to n do
    if ta[i] <> 0 then
      inc(tmp[ta[i]]);
  for i := k2 to n do
    if tb[i] <> 0 then
      inc(tmp[tb[i]]);
  for i := 1 to n do
    if (tmp[i] = 2) and (i <> v) then
      inc(t);
  result := t;
end;

procedure solve;
var
  i, v, l, r: integer;
  t: int64;
  q: array[1..MaxN] of integer;
begin
  q[1] := b1;
  l := 1;
  r := 1;
  while (r - l) >= 0 do begin
    v := q[l];
    inc(l);
    i := a.first[v];
    ans[v] := ans[v] + search(v);
    while (i <> 0)  do begin
      inc(r);
      q[r] := a.data[i];
      i := a.next[i];
    end;
    was[v] := true;
  end;
  t := 0;
  for i := 1 to n do
    t := t + ans[i];
  writeln(t);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  readln(n);
  init0;
  for i := 1 to n do begin
    read(t);
    if t = 0 then
      b1 := i
    else begin
    inc(a.free);
    a.next[a.free] := a.first[t];
    a.first[t] := a.free;
    a.data[a.free] := i;
    end;
  end;
  for i := 1 to n do begin
    read(t);
    if t = 0 then
      b2 := i
    else begin
    inc(b.free);
    b.next[a.free] := b.first[t];
    b.first[t] := b.free;
    b.data[b.free] := i;
    end;
  end;
  solve;
end.
 