program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  MaxN = 5000;

type
  tar = array[1..MaxN] of integer;
  p = array[1..2] of integer;

var
  n, i, step, k, count, s, f, trc, j: integer;
  a, b: tar;
  ans: array[1..5000, 1..5000] of p;

procedure sort(var a, num: tar; l, r: integer);
var
  i, j, t, m: integer;
begin
  if l >= r then
    exit;
  i := l;
  j := r;
  t := a[(l + r) div 2];
  while (i < j) do begin
    while (t > a[i]) do inc(i);
    while (t < a[j]) do dec(j);
    if (i <= j) then begin
      m := a[i];
      a[i] := a[j];
      a[j] := m;
      m := num[i];
      num[i] := num[j];
      num[j] := m;
      inc(i);
      dec(j);
    end;
  end;
  sort(a, num, i, r);
  sort(a, num, l, j);
end;

procedure init(var a, numa, cola: tar);
var
  i, c: integer;
begin
  c := 1;
  cola[numa[1]] := c;
  for i := 2 to n do begin
    if (a[i] <> a[i - 1]) then begin
      inc(c);
      cola[numa[i]] := c;
    end else
      cola[numa[i]] := c;
  end;
end;

procedure proc(var x: p; k: integer);
var
  i, j, t1, t2: integer;
begin
  t1 := k * step + 1;
  t2 := (k + 1) * step;
  x[1] := 0;
  x[2] := 0;
  for i := t1 to t2 do
    for j := i + 1 to t2 do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
        x[1] := i;
        x[2] := j;
        exit;
      end;
end;

procedure privat(var x: p; l, r: integer);
var
  i, j: integer;
begin
  for i := l to r do
    for j := i + 1 to r do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then begin
          x[1] := i;x[2] := j;
          exit;
        end;
  x[1] := 0;
  x[2] := 0;
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  readln(n);
  for i := 1 to n do begin
    readln(a[i], b[i]);
  end;
  //step := trunc(sqrt(n));
  //solve;
  for i := 1 to n do
    for j := i + 1 to n do
      privat(ans[i, j], i, j);
  readln(k);
  for i := 1 to k do begin
    readln(s, f);
    writeln(ans[s, f, 1], ' ', ans[s, f, 2]);
  end;
end.
