#include <iostream>
#include <cstdio>

using namespace std;

typedef long long ll;

const int maxn=1000005;
const ll inf=1LL<<62;

ll ans[maxn],from[maxn];
ll n,r,u;

int main()
{
    freopen("apricot.in","r",stdin);
    freopen("apricot.out","w",stdout);
    cin >> n >> r >> u;
//    cout << inf << endl;
    ans[0]=-inf;
    ans[1]=0;
    if (n<=2000)
    {
        for (int i=2;i<=n;i++)
        {
            ans[i]=inf;
            for (int k=1;2*k<=n && k<i;k++)
            {
                if (ans[i]>max(ans[k]+u,ans[max(i-2*k,0)]+r)) from[i]=k;
                ans[i]=min(ans[i],max(ans[k]+u,ans[max(i-2*k,0)]+r));
            }
//            cout << i << ' ' << ans[i] << ' ' << from[i] << endl;
        }
        cout << ans[n];
        return 0;
    }
    int T1=max(1,(int)((n*n)/1e8));
    int T2=max(1,(int)((n*T1)/1e8));
    int T3=max(1,(int)((n*T2)/1e8));
    for (int i=2;i<=n;i++)
    {
        ans[i]=inf;
        for (int k=1;2*k<=n && k<i;k+=T1)
        {
            if (ans[i]>max(ans[k]+u,ans[max(i-2*k,0)]+r)) from[i]=k;
            ans[i]=min(ans[i],max(ans[k]+u,ans[max(i-2*k,0)]+r));
        }
        int mink=from[i]-T1;
        int maxk=from[i]+T1;
        for (int k=mink;2*k<=n && k<min(i,maxk);k+=T2)
        {
            if (ans[i]>max(ans[k]+u,ans[max(i-2*k,0)]+r)) from[i]=k;
            ans[i]=min(ans[i],max(ans[k]+u,ans[max(i-2*k,0)]+r));
        }
        mink=from[i]-T2;
        maxk=from[i]+T2;
        for (int k=mink;2*k<=n && k<min(i,maxk);k+=T3)
        {
            if (ans[i]>max(ans[k]+u,ans[max(i-2*k,0)]+r)) from[i]=k;
            ans[i]=min(ans[i],max(ans[k]+u,ans[max(i-2*k,0)]+r));
        }
//        cout << i << ' ' << ans[i] << ' ' << from[i] << endl;
    }
    cout << ans[n];
    return 0;
}
