#include <iostream>
#include <cassert>
#include <cmath>

using namespace std;

const int maxn=40;

int canst[maxn][maxn];
int n,m,curx,cury,curlx,curly,mindx,mindy,maxdx,maxdy;
bool was[maxn][maxn][maxn][maxn];

inline bool can(int x,int y)
{
    int stx=x-curlx;
    int sty=y-curly;
    if (stx>m || sty>n || stx<=0 || sty<=0) return false;
    return canst[stx][sty];
}

inline void tried(int x,int y)
{
    int stx=x-curlx;
    int sty=y-curly;
    if (stx>m || sty>n || stx<=0 || sty<=0) return;
    canst[stx][sty]=false;
}

void upd()
{
    for (int i=1;i<=m;i++)
    {
        for (int j=1;j<=n;j++)
        {
            if (j+mindy<=0 || j+maxdy>n) canst[i][j]=false;
            if (i+mindx<=0 || i+maxdx>m) canst[i][j]=false;
        }
    }
}

int main()
{
    cin >> n >> m;
    cin >> curx >> cury;
    mindx=0;
    maxdx=0;
    mindy=0;
    maxdy=0;
    curlx=0;
    curly=0;
    for (int i=1;i<=m;i++)
    {
        for (int j=1;j<=n;j++) canst[i][j]=true;
    }
    int kv=0;
    bool reached=true;
    int mintx,minty,mint;
    while(true)
    {
        kv++;
        if (kv>10000) return 234;
        int curdx=0,curdy=0,t=0;
        if (reached)
        {

        mint=5*(n+m);
        mintx=1;
        minty=1;
        for (int i=1;i<=m;i++)
        {
            for (int j=1;j<=n;j++) if (can(i,j))
            {
                if (max(abs(i-curx),abs(j-cury))<mint)
                {
                    mint=max(abs(i-curx),abs(j-cury));
                    mintx=i;
                    minty=j;
                }
            }
        }
        reached=false;

        }
        if (mintx>curx) curdx=1;
        if (mintx<curx) curdx=-1;
        if (minty>cury) curdy=1;
        if (minty<cury) curdy=-1;
//        if (curdx==0 && curdy==0 && (!can(curx+curdx,cury+curdy)))
//        {
//            if (wasx) curdx=-1;
//            if (wasy) curdy=-1;
//        }
        if (can(curx+curdx,cury+curdy)) t=1;
        else t=0;
        curx+=curdx;
        cury+=curdy;
        if (was[curx][cury][curlx][curly])
        {
            curx-=curdx;
            cury-=curdy;
            curdx=0;
            curdy=0;
        }
        was[curx][cury][curlx][curly]=true;
        if (curx==mintx && cury==minty) reached=true;
        if (!(curx>0 && curx<=m && cury>0 && cury<=n))
        {
            cout << "asdflkjh" << endl;
            cout.flush();
            return 234;
        }
        cout << curdx << ' ' << curdy << ' ' << t << endl;
        cout.flush();
        tried(curx,cury);
        int ans;
        cin >> ans >> curdx >> curdy;
        if (ans==1) return 0;
        curlx+=curdx;
        curly+=curdy;
        mintx+=curdx;
        minty+=curdy;
        if (mintx<1 || mintx>m || minty<1 || minty>n) reached=true;
        mindx=min(mindx,curlx);
        maxdx=max(maxdx,curlx);
        mindy=min(mindy,curly);
        maxdy=max(maxdy,curly);
        upd();
    }
    return 0;
}
