#include <iostream>
#include <cassert>
 
using namespace std;
 
const int maxn=40;
 
int canst[maxn][maxn];
int n,m,curx,cury,curlx,curly,mindx,mindy,maxdx,maxdy;
 
inline bool can(int x,int y)
{
    int stx=x-curlx;
    int sty=y-curly;
    if (stx>m || sty>n || stx<=0 || sty<=0) return false;
    return canst[stx][sty];
}
 
inline void tried(int x,int y)
{
    int stx=x-curlx;
    int sty=y-curly;
    if (stx>m || sty>n || stx<=0 || sty<=0) return;
    canst[stx][sty]=false;
}
 
void upd()
{
    for (int i=1;i<=m;i++)
    {
        for (int j=1;j<=n;j++)
        {
            if (j+mindy<=0 || j+maxdy>n) canst[i][j]=false;
            if (i+mindx<=0 || i+maxdx>m) canst[i][j]=false;
        }
    }
}
 
int main()
{
    cin >> n >> m;
    cin >> curx >> cury;
    mindx=0;
    maxdx=0;
    mindy=0;
    maxdy=0;
    curlx=0;
    curly=0;
    for (int i=1;i<=m;i++)
    {
        for (int j=1;j<=n;j++) canst[i][j]=true;
    }
    while(true)
    {
        int curdx=0,curdy=0,t=0;
        for (int i=1;i<=m;i++)
        {
            for (int j=1;j<=n;j++) if (can(i,j))
            {
                if (i>curx) curdx+=1;
                if (i<curx) curdx-=1;
                if (j>cury) curdy+=1;
                if (j<cury) curdy-=1;
            }
        }
        if (curdx>0) curdx=1;
        if (curdx<0) curdx=-1;
        if (curdy>0) curdy=1;
        if (curdy<0) curdy=-1;
        if (can(curx+curdx,cury+curdy)) t=1;
        else t=0;
        cout << curdx << ' ' << curdy << ' ' << t << endl;
        curx+=curdx;
        cury+=curdy;
        assert(curx>0 && curx<=m && cury>0 && cury<=n);
        cout.flush();
//        tried(curx,cury);
        int ans;
        cin >> ans >> curdx >> curdy;
        if (ans==1) return 0;
        curlx+=curdx;
        curly+=curdy;
        mindx=min(mindx,curlx);
        maxdx=max(maxdx,curlx);
        mindy=min(mindy,curly);
        maxdy=max(maxdy,curly);
        upd();
    }
    return 0;
}