{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbB;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 100000;

type
  int = longint;

var
  x, i, kol, n, root: int;
  ans: int;
  p, e, next, g, used: array[1..MaxN] of int;

procedure add_edge(i, j: int);
begin
  inc(kol);
  e[kol] := j;
  next[kol] := g[i];
  g[i] := kol;
end;

procedure dfs2(x: int);
begin
  while x <> 0 do begin
    if used[x] = 1 then
      inc(ans);
    x := p[x];
  end;
end;

procedure dfs(x: int);
var
  cur: int;
begin
  used[x] := 1;
  cur := g[x];
  while cur <> 0 do begin
    if used[e[cur]] = 0 then
      dfs(e[cur]);
    cur := next[cur];
  end;
  used[x] := 2;
  dfs2(x);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');

  read(n);
  kol := 0;
  for i := 1 to n do begin
    read(x);
    if x <> 0 then
      add_edge(x, i)
    else
      root := i;
  end;
  for i := 1 to n do
    read(p[i]);
  ans := 0;
  dfs(root);
  writeln(ans);
  close(input);
  close(output);
end.
 