{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 1000000;

type
  int = longint;

var
  r, u: int64;
  i, n, j: int;
  d: array[1..MaxN] of int64;
  
begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(n, r, u);
  d[1] := 0;
  d[2] := u;
  for i := 3 to n do begin
    d[i] := max(d[i - 2] + r, u);
    j := 2;
    while j + j <= i do begin
      if j + j < i then
        d[i] := min(d[i], max(d[i - j - j] + r, d[j] + u))
      else
        d[i] := min(d[i], d[j] + u);
      j := j + 1;
    end;
  end;
  writeln(d[n]);
  close(input);
  close(output);
end.
 