{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC_3;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 1000000;
  INF = int64(1000000000) * int64(1000000000);
type
  int = int64;

var
  i: integer;
  r, u: int;
  m: int;
  d: array[0..MaxN] of int;

procedure get(n: int);
var
  i, j, ii: int;
begin
  if n < 2 then begin
    d[n] := 0;
    exit;
  end;
  if d[n] <> INF then exit;
  d[n] := max(d[n - 2] + r, u);
  i := 2;
  while i * 2 <= m do begin
    j := max(0, i * 2 - n);
    //if j > 1 then break;
    if j = 0  then begin
      if i + i = n then
        d[n] := min(d[n], d[i] + u)
      else
        d[n] := min(d[n], max(d[n-i-i] + r, d[i] + u));
    end else begin
      ii := j div 2;
      //for ii := 0 to min(i, j) do begin
        if (i - ii >= 0) and (i - (j - ii) >= 0) then
          d[n] := min(d[n], max(d[i - ii], d[i - (j - ii)]) + u);
      //end;
    end;
    inc(i);
  end;
end;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(m, r, u);
  for i := 2 to m do
    d[i] := INF;
  for i := 2 to m do
    get(i);
  get(m);

  {for i := 1 to m do
    write(d[i], ' ');
  writeln;
   }
   
  writeln(d[m]);
  close(input);
  close(output);
end.
