{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program ProbC;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  MaxN = 1000000;

type
  int = longint;

var
  r, u: int64;
  i, n, j, jj, cj: int;
  d: array[1..MaxN] of int64;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(n, r, u);
  d[1] := 0;
  d[2] := u;
  for i := 3 to n do begin
    d[i] := max(d[i - 2] + r, u);
    j := 2;
    while j + j <= n do begin   //   ( j ) + ( j ) + (i - 2*j)
      if j + j < i then
        d[i] := min(d[i], max(d[i - j - j] + r, d[j] + u));
      if j + j = i then
        d[i] := min(d[i], d[j] + u);
      if j + j > i then begin
        cj := (j + j - i);
        jj := (j + j - i) div 2;
        d[i] := min(d[i], max(d[j - jj], d[j - (cj - jj)]) + u);
      end;
      j := j + 1;
    end;
  end;
  writeln(d[n]);
  close(input);
  close(output);
end.
 