#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

vector < long > p, d;
vector < long > xd;
vector < char > used;
long n, m;
long long ans = 0, sm = 0;

void step(long pos = 0, long t = 0) {
    long i, j;
    if(n - pos < m - t)
        return;
    if(pos == n) {
        ans++;
        return;
    }

    for(i = 0; i < n; i++) {
        if(!used[i]) {
            p[pos] = i;
            d[pos] = 0;
            for(j = 0; j < pos; j++)
                if(p[pos] > p[j])
                    d[pos] = max(d[pos], d[j] + 1);
            if(d[pos] >= m)
                break;
            used[i] = true;
            if(t < m && i + 1 == xd[t])
                step(pos + 1, t + 1);
            else
                step(pos + 1, t);
            used[i] = false;
        }
    }
}
int main()
{
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);
    long i;
    cin >> n >> m;
    p.assign(n, 0);
    d.assign(n, 0);
    xd.assign(m, 0);
    used.assign(n, false);
    for(i = 0; i < m; i++)
        cin >> xd[i];
    step();
    cout << ans << endl;
    return 0;
}
