#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 1005000

using namespace std;

int n;
long long res[maxn];
long long u, r;

int main(){
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    cin >> n >> r >> u;
    res[0] = 1000000;
    res[0] = res[0] * res[0];
    res[1] = 0;
    res[2] = u;
    for(int i = 3; i <= n; ++i){
        res[i] = max(res[1] + u, res[i - 2] + r);
        if(i != n || i % 2 == 0)res[i] = min(res[i], res[(i + 1) / 2] + u);
        int ll = 1, rr = i / 2;
        while(ll < rr - 1){
            int mm = (ll + rr) / 2;
            if(res[mm] + u > res[i - 2 * mm] + r)rr = mm; else ll = mm;
        }
        res[i] = min(res[i], min(max(res[ll] + u, res[i - 2 * ll] + r), max(res[rr] + u, res[i - 2 * rr] + r)));
    }
    for(int i = 0; i <= n; ++i)
        cout << "res[" << i << "] = " << res[i] << endl;

    cout << res[n] << endl;

    return 0;
}
