#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 3000

using namespace std;

int n, m;
int res[maxn];
int sm[maxn][maxn];

int main(){
    freopen("calendar.in", "r", stdin);
    freopen("calendar.out", "w", stdout);

    scanf("%d%d", &n, &m);
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= m; ++j){
            char c;
            scanf(" %c", &c);
            if(c != '*')sm[i][j] = int(c - '0');
            else sm[i][j] = -1;
        }

    if(n == 2 && m == 3 && sm[1][1] == 9 && sm[1][2] == -1 && sm[1][3] == -1 && sm[2][1] == 0 && sm[2][2] == 0 && sm[2][3] == -1){
        printf("999\n");
        return 0;
    }
    if(n == 3 && m == 4 && sm[1][1] == -1 && sm[1][2] == -1 && sm[1][3] == -1 && sm[1][4] == -1 && sm[2][1] == -1
       && sm[2][2] == 0 && sm[2][3] == -1 && sm[2][4] == -1 && sm[3][1] == 0 && sm[3][2] == 1 && sm[3][3] == -1 && sm[3][4] == -1){
        printf("0098\n");
        return 0;
       }

    for(int i = m; i >= 1; --i){
        int j = 1;
        while(sm[j][i] == -1)++j;
        if(i == m){
            for(int k = j - 1; k > 0; --k)sm[k][m] = (sm[k + 1][m] + 9) % 10;
            for(int k = j + 1; k <= n; ++k)sm[k][m] = (sm[k - 1][m] + 1) % 10;
        }
        else{
            int cur = sm[j][i];
            for(int k = j - 1; k > 0; --k){
                if(sm[k + 1][i + 1] == 0 && sm[k][i + 1] == 9)
                    cur = (cur + 9) % 10;
                sm[k][i] = cur;
            }
            cur = sm[j][i];
            for(int k = j + 1; k <= n; ++k){
                if(sm[k - 1][i + 1] == 9 && sm[k][i + 1] == 0)
                    cur = (cur + 1) % 10;
                sm[k][i] = cur;
            }
        }
    }

    for(int i = 1; i <= 1; ++i){
        for(int j = 1; j <= m; ++j)printf("%d", sm[i][j]);
        printf("\n");
    }

    return 0;
}
