#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 100500

using namespace std;

int n, k;
int a[maxn], b[maxn];
int a_r[maxn], b_r[maxn];
int pos[maxn];

bool not_ok(const int &a1, const int &a2){return(a[a1] != a[a2] && b[a1] != b[a2]);}

int find_no(const int &x, const int &y, const int &z){
    if(not_ok(x, y))printf("%d %d\n", x, y);
    else{
        if(not_ok(x, z))printf("%d %d\n", x, z);
        else{
            if(not_ok(y, z))printf("%d %d\n", y, z);
        }
    }
    return 0;
}

int main(){
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for(int i = 1; i <= n; ++i)scanf("%d%d", &a[i], &b[i]);
    int r_a = n, r_b = n;
    a_r[n] = b_r[n] = n;
    pos[n] = n;
    for(int i = n - 1; i >= 1; --i){
        if(a[i] != a[i + 1])r_a = i;
        if(b[i] != b[i + 1])r_b = i;
        a_r[i] = r_a;
        b_r[i] = r_b;
        pos[i] = max(a_r[i], b_r[i]);
    }

    /*for(int i = 1; i <= n; ++i){
        printf("a_r[%d] = %d, b_r[%d] = %d, pos[%d] = %d\n", i, a_r[i], i, b_r[i], i, pos[i]);
    }*/

    scanf("%d", &k);
    for(int i = 1; i <= k; ++i){
        int n1, n2;
        scanf("%d%d", &n1, &n2);
        if(n2 <= pos[n1])printf("0 0\n");
        else find_no(n1, min(a_r[n1] + 1, n), min(b_r[n1] + 1, n));
    }

    return 0;
}
