#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <functional>

#define maxn 32

using namespace std;

const int dx[9] = {0, 0, 1, 1, 1, -1, -1, -1, 0};
const int dy[9] = {1, -1, 0, 1, -1, 0, 1, -1, 0};

int cx, cy, cd, xd, yd, n, m, dc;
bool can[maxn][maxn], tmp[maxn][maxn];

bool ok(const int &x, const int &y){return(x > 0 && x <= m && y > 0 && y <= n);}

int flip(const int &dx, const int &dy){
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            tmp[i + dx][j + dy] = can[i][j];
    for(int i = 1; i <= m; ++i)
        for(int j = 1; j <= n; ++j)
            can[i][j] = tmp[i][j];
    return 0;
}

int main(){
    int tpx = time(NULL);
    srand(tpx);

    for(int i = 0; i < maxn; ++i)
        for(int j = 0; j < maxn; ++j)
            can[i][j] = true;

    cin >> n >> m;
    cin >> cx >> cy;
    cd = xd = yd = 0;
    while(!cd){
        flip(xd, yd);
        int i = 0;
        while(i < 9 && (!ok(cx + dx[i], cy + dy[i]) || !can[cx + dx[i]][cy + dy[i]]))++i;
        if(i >= 9){
            i = 0;
            while(!ok(cx + dx[i], cy + dy[i]))++i;
        }
        dc = 1;
        if(!can[cx + dx[i]][cy + dy[i]])dc = 0;
        cx += dx[i];
        cy += dy[i];
        cout << dx[i] << " " << dy[i] << " " << dc << endl;
        cout.flush();
        cin >> cd >> cx >> cy;
    }

    return 0;
}
