#define TASKNAME "apricot"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>
#include <string>
#include <cstring>
#include <ctime>
#include <cctype>
#include <fstream>
#include <windows.h>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define y1 dskjchkfjhf
#define y0 kjlasdkfjlk
#define zero(a) memset(a, 0, sizeof(a))
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e6) + 10;

int n;
int r, u;
int dp[MaxN];

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d%d%d", &n, &r, &u) >= 1)
  {
    dp[0] = 0;
    dp[1] = 0;
    for (int i = 2; i <= n; i++)
    {
      dp[i] = INF;
      for (int j = 1; j <= i / 2; j++)
      {
        if (!(i & 1) && 2 * j == i)
          dp[i] = min(dp[i], u + dp[j]);
        else
          dp[i] = min(dp[i], max(r + dp[i - 2 * j], u + dp[j]));
      }
    }
    printf("%d\n", dp[n]);
  }
  return 0;
}
