#define TASKNAME "theatre"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = int(1e6) + 100;

int n, m, cnt;
int q[MaxN];
set <int> groups[MaxN];
int num[MaxN];
bool was[MaxN], ok[MaxN];
int ans[MaxN];
vi gr[MaxN];
int last_num[MaxN];
int Count[MaxN], index[MaxN], not_was[MaxN];
                
int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d%d", &n, &m) >= 1)
  {
    for (int i = 0; i < n; i++)
      num[i] = 0, groups[0].insert(i), ans[i] = 0;
    int now_group = 1;
    for (int query = 1; query <= m; query++)
    {
      scanf("%d", &cnt);
      for (int i = 0; i < cnt; i++)
        scanf("%d", &q[i]), --q[i];

      if (cnt == 1)
        if (!ans[q[0]])
          ans[q[0]] = query;

      for (int i = 0; i < cnt; i++)
      {
        last_num[q[i]] = num[q[i]];
        gr[num[q[i]]].pb(i);
      }

      /*eprintf("%d\n", now_group);
      for (int i = 0; i < now_group; i++)
      {
        eprintf("%d: ", i);
        for (set <int>::iterator j = groups[i].begin(); j != groups[i].end(); j++)
          eprintf("%d ", *j);
        eprintf("\n");
      }
      eprintf("\n");*/

      int nn = now_group;

      for (int i = 0; i < nn; i++)
      {
        Count[i] = 0, index[i] = 0, not_was[i] = 0;
        for (int j = 0; j < sz(gr[i]); j++)
          if (!was[q[gr[i][j]]])
            ++Count[i], not_was[i] = q[gr[i][j]];
          else
            index[i] = q[gr[i][j]];
        
        if (Count[i] == 1)
          if (!ans[not_was[i]])
            ans[not_was[i]] = query;

        if (Count[i] == sz(gr[i]) - 1)
          if (!ans[index[i]])
            ans[index[i]] = query;

        for (int j = 0; j < sz(gr[i]); j++)
        {
          groups[i].erase(q[gr[i][j]]);
          groups[now_group].insert(q[gr[i][j]]);
          num[q[gr[i][j]]] = now_group;
        }
        ++now_group;
        //eprintf("Group %d: %d\n", i, sz(groups[i]));
        if (sz(groups[i]) == 1)
        {
          int p = *groups[i].begin();
          if (!ans[p])
            ans[p] = query;
          groups[i].clear();
        }
      }

      for (int i = 0; i < cnt; i++)
      {
        gr[last_num[q[i]]].clear();
        was[q[i]] = 1;
      }
    }
    for (int i = 0; i < n; i++)
      printf("%d%c", ans[i], " \n"[i == n - 1]);     
  }  
  return 0;
}

