#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

int n, m, x, y, xx, yy;
int dx[] = {0, 0, 1, -1, 1, 1, -1, -1};
int dy[] = {1, -1, 0, 0, 1, -1, 1, -1};
vpii turns;

inline int dist(int x1, int y1, int x2, int y2)
{
  return max(abs(x1 - x2), abs(y1 - y2));
}

inline void turn(int x1, int y1, int x2, int y2)
{
  int ansx = 0, ansy = 0;
  if (x1 < x2)
    ansx = 1, ansy = ((y1 < y2) ? 1 : ((y1 == y2) ? 0 : -1));
  else
  if (x1 == x2)
    ansy = ((y1 < y2) ? 1 : -1);
  else
    ansx = -1, ansy = ((y1 < y2) ? 1 : ((y1 == y2) ? 0 : -1));

  x += ansx, y += ansy;

  //eprintf("Now: %d %d\n", x, y);
  assert(x >= 1 && x <= m && y >= 1 && y <= n);
  printf("%d %d 1\n", ansx, ansy);
  fflush(stdout); 
}

inline bool can(int x, int y)
{
  for (int i = 0; i < sz(turns); i++)
  {
    x += turns[i].fst, y += turns[i].snd;  
    if (x < 1 || y < 1 || x > m || y > n)
      return 0;
  }
  return 1;
}

pii find_max_pt()
{
  int xx = 1, yy = 1;
  int Max = -1;
  //vpii v;
  for (int i = 1; i <= m; i++)
    for (int j = 1; j <= n; j++)  
    {
      if (!can(i, j))
        continue;
      //v.pb(mp(i, j));
      int tmp = dist(x, y, i, j);
      if (tmp > Max)
        Max = tmp, xx = i, yy = j;
    }
  //srand(time(NULL));
  //int index = rand() % sz(v);
  //return v[index];
  return mp(xx, yy);
}
                
int main()
{
  scanf("%d%d%d%d", &n, &m, &x, &y);
  pii t = find_max_pt();
  xx = t.fst, yy = t.snd;
  while (1)
  {
    turn(x, y, xx, yy);
    int ans, ansx, ansy;
    scanf("%d%d%d", &ans, &ansx, &ansy);
    turns.pb(mp(ansx, ansy));
    if (ans)
      return 0;
    xx += ansx, yy += ansy;
    if (xx < 1 || xx > m || yy < 1 || yy > n || !dist(x, y, xx, yy))
    {
      pii t = find_max_pt();
      xx = t.fst, yy = t.snd;
    }
  }
  return 0;
}

