#define TASKNAME "army"

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cctype>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <cstdlib>
#include <windows.h>
#include <fstream>

#define EPS 1e-9
#define INF (int)(1e9)
#define INFLONG (long long)(1e18)
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define sz(a) (int)a.size()
#define y1 smdsjdlaskdjl
#define y0 skjlkjljklkjl
#define mp make_pair
#define pb push_back
#define fst first
#define snd second
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
                       
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <ll> vll;
typedef vector <vll> vvll;
typedef vector <bool> vb;
typedef vector <vb> vvb;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <pii> vpii;
typedef vector <pll> vpll;

const int MaxN = 30;

int n, k;
int a[MaxN];
int dp[MaxN];
bool was[MaxN];
int ans = 0;
int taken[MaxN], size = 0;

inline void go(int pos, int index, bool found)
{
  /*printf("%d %d %d\n", pos, index, cnt);
  for (int i = 0; i < size; i++)
    printf("%d%c", taken[i], " \n"[i == sz(taken) - 1]);
  puts("");*/

  dp[size - 1] = 1;
  for (int i = 0; i < size - 1; i++)
  {
    if (taken[i] < taken[size - 1] && dp[size - 1] < dp[i] + 1)
      dp[size - 1] = dp[i] + 1;
    if (dp[size - 1] > k)
      return;
  }

  bool new_found = (found | (dp[size - 1] == k));

  if (pos == n && index == k)
  {
    if (new_found)
      ++ans;
    return;                                         
  }
  if (n - pos < k - index)
    return;
  if (index < k)
  {
    taken[size++] = a[index];
    go(pos + 1, index + 1, new_found);
    --size;
  }
  for (int i = 1; i <= n; ++i)
  {
    if (!was[i])
    {
      was[i] = 1;
      taken[size++] = i;
      go(pos + 1, index, new_found);
      --size;
      was[i] = 0;
    }
  }
}
                
int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  while (scanf("%d%d", &n, &k) >= 1)
  {
    for (int i = 0; i < k; i++)
      scanf("%d", &a[i]);
    for (int i = 0; i < k; i++)
      was[a[i]] = 1; 
    go(0, 0, 0);
    printf("%d\n", ans);
    break;
  }
  return 0;
}

