#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <memory.h>
#include <limits>

using namespace std;

#define vv vector
#define in cin
#define out cout
#define px first
#define py second
#define mp make_pair

int main() {
	ios_base::sync_with_stdio(false);
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);

	string ss, st;
	in >> ss >> st;
	int n = ss.length(), m = st.length();
	vv<int> s(n), t(m), ssum(n);
	for (int i = 0; i < n; ++i) {
		s[i] = ss[i] - '0';
	}
	for (int i = 0; i < m; ++i) {
		t[i] = st[i] - '0';
	}
	ssum[0] = s[0];
	for (int i = 1; i < n; ++i) {
		ssum[i] = ssum[i - 1] + s[i];
	}

	int len;
	for (len = 0; len < m; ++len) {
		if (s[n - len - 1] != t[m - len - 1]) {
			break;
		}
	}

	for (int i = 0; i < m; ++i) {
		/*if (s[i] != t[i]) {
			abort();
		}*/
		int border = min(i + 7, m);
		if (t[i] == 0) {
			border = min(i + 1, border);
		}
		int sum = 0;
		for (int j = i; j < border; ++j) {
			sum = sum * 10 + t[j];
			int l = i, r = n - 1;
			while (l <= r) {
				int mid = (l + r) / 2;
				int res = ssum[mid];
				if (i > 0) {
					res -= ssum[i - 1];
				}
				if (res < sum) {
					l = mid + 1;
				} else if (res > sum) {
					r = mid - 1;
				} else {
					if (m - j - 1 <= len && n - mid - 1 <= len) {
						out << i + 1 << ' ' << mid + 1 << endl;
						return 0;
						//break;
					} else {
						break;
					}
				}
			}
		}
	}

	return 0;
}