#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <memory.h>
#include <limits>

using namespace std;

#define vv vector
#define in cin
#define out cout
#define px first
#define py second
#define mp make_pair

int n;
vv<int> c[2], first[2], last[2];
vv< vv<int> > g[2];
int root[2], time;

void dfs(int k, int v) {
	c[k][time] = v;
	first[k][v] = time++;
	for (size_t i = 0; i < g[k][v].size(); ++i) {
		int u = g[k][v][i];
		dfs(k, u);
	}
	c[k][time] = v;
	last[k][v] = time++;
}

int main() {
	ios_base::sync_with_stdio(false);
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);

	in >> n;
	for (int k = 0; k < 2; ++k) {
		g[k].resize(n);
		c[k].resize(2 * n);
		first[k].resize(n);
		last[k].resize(n);
	}

	int p;
	for (int k = 0; k < 2; ++k) {
		for (int i = 0; i < n; ++i) {
			in >> p;
			--p;
			if (p == -1) {
				root[k] = i;
			} else {
				g[k][p].push_back(i);
			}
		}
		time = 0;
		dfs(k, root[k]);
	}

	int ans = 0;
	vv<int> rel(2 * n);
	for (int i = 0; i < 2 * n; ++i) {
		rel[i] = first[1][c[0][i]];
	}
	for (int v = 0; v < n; ++v) {
		int l[2], r[2];
		for (int k = 0; k < 2; ++k) {
			l[k] = first[k][v] + 1;
			r[k] = last[k][v] - 1;
		}
		if (l[0] > r[0] || l[1] > r[1]) {
			continue;
		}
		for (int i = l[0]; i <= r[0]; ++i) {
			if (rel[i] >= l[1] && rel[i] <= r[1]) {
				++ans;
			}
		}
	}
	out << ans / 2;

	return 0;
}