#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <memory.h>
#include <limits>
#include <cassert>

using namespace std;

#define vv vector
#define in cin
#define out cout
#define px first
#define py second
#define mp make_pair

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	freopen("apricot.in", "rt", stdin);
	freopen("apricot.out", "wt", stdout);

	int n; ll r, u;
	in >> n >> r >> u;
	assert(n <= 2000);
	vv<ll> dp(max(3, n + 1));
	dp[2] = u;
	for (int i = 3; i <= n; ++i) {
		dp[i] = numeric_limits<ll>::max();
		if (i % 2 == 0) {
			dp[i] = min(dp[i], u + dp[i / 2]);
		}
		for (int k = 2; k <= i; ++k) {
			ll res = (k - 2) * r + max(u, (i == k ? 0 : (r + dp[i - k])));
			dp[i] = min(dp[i], res);
		}
		for (int k = 1; i - 2 * k >= 1; ++k) {
			ll res = max(dp[k] + u, r + dp[i - 2 * k]);
			dp[i] = min(dp[i], res);
		}
	}
	out << dp[n];

	return 0;
}