#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

struct query {
	int l, r, i;
};

bool operator <(const query &a, const query &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);

	int n;
	in >> n;
	vv< pair<int, int> > a(n);
	for (int i = 0; i < n; ++i) {
		in >> a[i].px >> a[i].py;
	}
	int k;
	in >> k;
	vv<query> q(k);
	vv< pair<int, int> > ans(k);
	for (int i = 0; i < k; ++i) {
		in >> q[i].l >> q[i].r;
		q[i].l--;
		q[i].r--;
		q[i].i = i;
	}
	sort(q.begin(), q.end());

	for (int z = 0; z < k; ++z) {
		for (int i = q[z].l; i <= q[z].r; ++i) {
			for (int j = i + 1; j <= q[z].r; ++j) {
				if (a[i].px != a[j].px && a[i].py != a[j].py) {
					ans[q[z].i] = mp(i + 1, j + 1);
				}
			}
		}
	}

	for (int i = 0; i < k; ++i) {
		out << ans[i].px << ' ' << ans[i].py << endl;
	}

	return 0;
}