#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

struct query {
	int l, r, i;
};

bool operator <(const query &a, const query &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);

	int n;
	in >> n;
	vv< pair<int, int> > a(n);
	for (int i = 0; i < n; ++i) {
		in >> a[i].px >> a[i].py;
	}
	int k;
	in >> k;
	vv<query> q(k);
	vv< pair<int, int> > ans(k, mp(-1, -1));
	for (int i = 0; i < k; ++i) {
		in >> q[i].l >> q[i].r;
		q[i].l--;
		q[i].r--;
		q[i].i = i;
	}
	sort(q.begin(), q.end());

	/*int z = 0;
	map<int, int> last_x, last_y;
	vv<int> h(n, -1);
	for (int i = 0; i < n; ++i) {
		h[i] = -1 + max(last_x[a[i].px], last_y[a[i].py]);
		last_x[a[i].px] = i + 1;
		last_y[a[i].py] = i + 1;
	}*/

	int z = 0, l = 0, i = l;
	pair<int, int> res;

	while (z < k) {
		if (l != q[z].l) {
			l = q[z].l;
			i = l;
		}
		if (res.px >= q[z].l && res.py <= q[z].r) {
			ans[q[z].i] = res;
		} else {
			bool ok = false;
			for (i; i <= q[z].r && !ok; ++i) {
				for (int j = q[z].l; j < i; ++j) {
					if (a[i].px != a[j].px && a[i].py != a[j].py) {
						res = mp(i, j);
						ok = true;
						break;
					}
				}
			}
			if (res.px >= q[z].l && res.py <= q[z].r) {
				ans[q[z].i] = res;
			}
		}
		++z;
	}

	for (int i = 0; i < k; ++i) {
		out << ans[i].px + 1 << ' ' << ans[i].py + 1 << endl;
	}

	return 0;
}