#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

struct query {
	int l, r, i;
};

bool operator <(const query &a, const query &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);

	int n;
	in >> n;
	vv< pair<int, int> > a(n);
	for (int i = 0; i < n; ++i) {
		in >> a[i].px >> a[i].py;
	}
	int k;
	in >> k;

	vv<query> q(k);
	vv< pair<int, int> > ans(k, mp(-1, -1));
	for (int i = 0; i < k; ++i) {
		in >> q[i].l >> q[i].r;
		q[i].l--;
		q[i].r--;
		q[i].i = i;
	}
	sort(q.begin(), q.end());

	vv<int> h(n, -1);
	for (int i = 0; i < n; ++i) {
		for (int j = i - 1; j >= 0; --j) {
			if (a[i].px != a[j].px && a[i].py != a[j].py) {
				h[i] = j;
				break;
			}
		}
	}

	int z = 0, l = -1, i = 0;
	pair<int, int> res;
	for (int z = 0; z < k; ++z) {
		if (l != q[z].l) {
			l = q[z].l;
			i = l + 1;
			res = mp(-1, -1);
		}
		for (i; i <= q[z].r && res.px == -1; ++i) {
			if (h[i] >= q[z].l) {
				res = mp(h[i], i);
			}
		}
		ans[q[z].i] = res;
	}

	for (int i = 0; i < k; ++i) {
		out << ans[i].px + 1 << ' ' << ans[i].py + 1 << endl;
	}

	return 0;
}