#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <bitset>
#include <cassert>

using namespace std;

#define in cin
#define out cout
#define vv vector
#define mp make_pair
#define px first
#define py second

int n, k, ans = 0, maxmask;
vv<int> g, p, w;
vv<bool> used;

inline bool bit(int mask, int k) {
	return (mask & (1 << k)) != 0;
}

int bits(int x) {
	int r = 0;
	while (x) {
		if (x & 1) {
			++r;
		}
		x >>= 1;
	}
	return r;
}

void go(int pos = 0, int gnext = 0) {
	if (pos == n) {
		assert(gnext == k);
		bool ok = true;
		/*p[0] = 0;
		p[1] = 2;
		p[2] = 1;
		p[3] = 4;
		p[4] = 3;*/
		for (int mask = 0; mask < maxmask; ++mask) {
			if (bits(mask) <= k) {
				continue;
			}
			int last = -1;
			bool up = true;
			for (int i = 0; i < n; ++i) {
				if (bit(mask, i)) {
					if (last > p[i]) {
						up = false;
						break;
					}
					last = p[i];
				}
			}
			if (up) {
				ok = false;
				break;
			}
		}
		if (ok) {
			++ans;
		}
	} else {
		if (gnext != k) {
			p[pos] = g[gnext];
			go(pos + 1, gnext + 1);
		}
		for (int i = 0; i < w.size(); ++i) {
			if (used[w[i]]) {
				continue;
			}
			used[w[i]] = true;
			p[pos] = w[i];
			go(pos + 1, gnext);
			used[w[i]] = false;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);

	in >> n >> k;
	g.resize(k);
	for (int i = 0; i < k; ++i) {
		in >> g[i];
		g[i]--;
	}
	
	for (int i = 0; i < n; ++i) {
		if (find(g.begin(), g.end(), i) == g.end()) {
			w.push_back(i);
		}
	}
	
	used.resize(n);
	maxmask = 1 << n;
	p.assign(n, -1);
	go();

	out << ans;

	return 0;
}