#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

int n, m;
vector < pair < int, int > > point;

int MOD1 = 6583;
//int MOD2 = 913237;

vector < int > h1(MOD1, 0), h2(MOD1, 0);
vector < int > num1, num2;

int main(){
    freopen("mosaic.in", "rt", stdin);
    freopen("mosaic.out", "wt", stdout);
    int t1, t2;
    cin >> n;
    point.push_back(make_pair(0, 0));
    for(int i = 0; i < n; ++i){
        cin >> t1 >> t2;
        point.push_back(make_pair(t1, t2));
    }
    cin >> m;
    for(int i = 0; i < m; ++i){
        cin >> t1 >> t2;
        //h1.assign(MOD1, 0);
        //h2.assign(MOD1, 0);
        num1.resize(0);
        num2.resize(0);
        bool ex = true;
        for(int j = t1; j <= t2; ++j){
            int b = point[j].first, e = point[j].second;
            if(!h1[b % MOD1]){
                h1[b % MOD1] = j;
                num1.push_back(b);
                if(num1.size() > 1 && num2.size() > 1){
                    for(int k = 0; k < num2.size(); ++k){
                        //cout << "*";
                        if(num2[k] != e){
                            cout << j << " " << h2[num2[k] % MOD1] << endl;
                            ex = false;
                            break;
                        }
                    }
                    if(!ex)break;
                }
            }
            if(!h2[e % MOD1]){
                h2[e % MOD1] = j;
                num2.push_back(e);
                 if(num1.size() > 1 && num2.size() > 1){
                    for(int k = 0; k < num1.size(); ++k)
                        if(num1[k] != b){
                            cout << j << " " << h1[num1[k] % MOD1] << endl;
                            ex = false;
                            break;
                        }
                    if(!ex)break;
                }
            }
        }
        for(int j = 0; j < num1.size(); ++j)h1[num1[j] % MOD1] = 0;
        for(int j = 0; j < num2.size(); ++j)h2[num2[j] % MOD1] = 0;
        if(ex)cout << "0 0\n";
    }
    return 0;
}
