{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  aier,bier,a,b:array[1..2000] of integer;
  queue:array[1..1000000] of integer;
  N,i,j,fboss,sboss,ans:integer;
  used1,used2:array[1..2000] of boolean;
  matrix1,matrix2:array[1..2000,1..2000] of integer;

procedure bfs1(c:integer);
  var
    l,head,tail,v:integer;
  begin
    head:=1;
    tail:=1;
    aier[c]:=1;
    queue[1]:=c;
    used1[c]:=true;
    while head<=tail do
      begin
        v:=queue[head];
        inc(head);
        for l:=1 to N do
          if (matrix1[v][l]<>0) and (not used1[l]) then
            begin
              inc(tail);
              queue[tail]:=l;
              used1[l]:=true;
              aier[l]:=aier[v]+1;
            end;
      end;
  end;

procedure bfs2(c:integer);
  var
    l,head,tail,v:integer;
  begin
    head:=1;
    tail:=1;
    bier[c]:=1;
    queue[1]:=c;
    used2[c]:=true;
    while head<=tail do
      begin
        v:=queue[head];
        inc(head);
        for l:=1 to N do
          if (matrix2[v][l]<>0) and (not used2[l]) then
            begin
              inc(tail);
              queue[tail]:=l;
              used2[l]:=true;
              bier[l]:=bier[v]+1;
            end;
      end;
  end;

begin
reset(input,'virus.in');
rewrite(output,'virus.out');
  read(N);
  ans:=0;
  for i:=1 to N do
    for j:=1 to N do
      begin
        matrix1[i][j]:=0;
        matrix2[i][j]:=0;
      end;

  for i:=1 to N do
    begin
      read(a[i]);
      if a[i]<>0 then
        matrix1[a[i]][i]:=1
      else fboss:=i;
    end;

  for i:=1 to N do
    begin
      read(b[i]);
      if b[i]<>0 then
        matrix2[b[i]][i]:=1
      else sboss:=i;
    end;

  bfs1(fboss);
  bfs2(sboss);

  for i:=1 to N do
    for j:=1 to N do
      if (aier[i]<aier[j]) and (bier[i]<bier[j]) then inc(ans);

  writeln(ans);
readln;readln;
closefile(output);
end.
