#include <stdio.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

int n, m;
int known[100];
int data[100][100];
int datac[100];

bool dt1[100];
bool dt2[100];
int deltau(int i, int j)
{
	for (int k = 0; k < 100; k++)	
	{
		dt1[k] = false;
		dt2[k] = false;
	}
	for (int k = 0; k < datac[i]; k++)	
	{
		dt1[data[i][k]] = true;
	}
	for (int k = 0; k < datac[j]; k++)	
	{
		dt2[data[j][k]] = true;
	}
	int delta = -1;
	for (int k = 0; k < n; k++)
	{
		if (dt1[k] != dt2[k] && dt1[k] == false)
		{
			if (delta < 0)
		  	  delta = k;
			else
			  return -1;
		}
	}
	return delta;
}

bool was[100];
int ost(int i)
{
	for (int k = 0; k < 100; k++)
		was[k] = false;
	int un = -1;
	for (int k = 0; k < datac[i]; k++)
	{
		was[data[i][k]] = true;
	}
	for (int k = 0; k < n; k++)
		if (!was[k] && (known[k] == 0))
			if (un < 0)
			{
				un = k;
			}
			else
				return -1;
	return un;
}


int ost2(int i)
{
	for (int k = 0; k < 100; k++)
		was[k] = false;
	int un = -1;
	for (int k = 0; k < datac[i]; k++)
	{
		if (!known[data[i][k]])
		  was[data[i][k]] = true;
	}
	for (int k = 0; k < n; k++)
		if (was[k])
			if (un < 0)
			{
				un = k;
			}
			else
				return -1;
	return un;
}

int deltad(int i, int j)
{
	for (int k = 0; k < 100; k++)	
	{
		dt1[k] = false;
		dt2[k] = false;
	}
	for (int k = 0; k < datac[i]; k++)	
	{
		dt1[data[i][k]] = true;
	}
	for (int k = 0; k < datac[j]; k++)	
	{
		dt2[data[j][k]] = true;
	}
	int delta = -1;
	for (int k = 0; k < n; k++)
	{
		if (dt1[k] != dt2[k] && dt1[k] == false)
		{
			if (delta < 0)
		  	  delta = k;
			else
			  return -1;
		}
	}
	return delta;
}
bool wan[100];

int lazyb()
{
	int lz = -1;
	for (int i = 0; i < n; i++)
		if (!wan[i])
			if (lz < 0)
			{
				lz = i;
			}
			else
				return -1;
	return lz;
}

int main(void)
{
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);
	int nc;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		cin >> nc;
		for (int j = 0; j < nc; j++)
		{
			cin >> data[i][j];
			data[i][j]--;
		}
		datac[i] = nc;
	}
	for (int i = 0; i < n; i++)
		wan[i] = false;
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < datac[i]; j++)
		{
			if (data[i][j])
				wan[data[i][j]] = true;
		}
		
		{
			for (int j = 0; j < i; j++)
			{
				//if (datac[i] - datac[j] == -1 || datac[i] - datac[j] == 1)
				{
					int dt = deltau(i, j);
					if (dt >= 0)
					{
						if (known[dt] == 0)known[dt] = i + 1;
					}
					dt = deltad(i, j);
					if (dt >= 0)
					{
						if (known[dt] == 0)known[dt] = i + 1;
					}
				}
			}
			int uk = -1;
			for (int j = 0; j < datac[i]; j++)
			{
				if (known[j] < 0)
				{
					if (uk < 0)
						uk = j;
					else
					{
						uk = -1;
						break;
					}
				}
			}
			if (uk >= 0)
				if (known[uk] == 0)
					known[uk] = i + 1;
			int ostt = ost(i);
			if (ostt >= 0)
				if (known[ostt] == 0)known[ostt] = i + 1;
			int ostt2 = ost2(i);
			if (ostt2 >= 0)
				if (known[ostt2] == 0)known[ostt2] = i + 1;
			ostt = lazyb();
			if (ostt >= 0)
				if (known[ostt] == 0)known[ostt] = i + 1;
		}
	}
	for (int i = 0; i < n; i++)
		cout << known[i] << " ";
	cout << endl;
	//system("pause");
	return 0;
}