#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))

typedef long long ll;
const int MAXN = 100003;
const ll P = 997;

ll p[MAXN];
ll h1[MAXN];
ll h2[MAXN];
char s1[MAXN];
char s2[MAXN];
int pr[MAXN];


ll get(ll * h, int p1, int p2) {
    return h[p2] - h[p1] * p[p2 - p1];
}

int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
    scanf(" %s", &s1);
    scanf(" %s", &s2);
    int n1, n2;
    n1 = strlen(s1);
    n2 = strlen(s2);
    pr[0] = 0;
    FOR(i, n1)
        pr[i + 1] = pr[i] + s1[i] - '0';
    p[0] = 1;
    FOR(i, max(n1, n2)) {
        p[i + 1] = p[i] * P;
    }
    h1[0] = 0;
    FOR(i, n1)
        h1[i + 1] = h1[i] * P + s1[i];
    h2[0] = 0;
    FOR(i, n2)
        h2[i + 1] = h2[i] * P + s2[i];
    for (int c = 1; c <= 6; ++c) {
        FOR(i, n2 - c + 1) {
            if (get(h1, 0, i) == get(h2, 0, i) && get(h1, i + n1 - n2 + c, n1) == get(h2, i + c, n2)) {
                int sum1 = pr[i + n1 - n2 + c] - pr[i];
                int sum2 = 0;
                int st = 1;
                for (int j = i + c - 1; j >= i; --j) {
                    sum2 += st * (s2[j] - '0');
                    st *= 10;
                }
                if (sum1 == sum2) {
                    printf("%d %d\n", i + 1, i + n1 - n2 + c);
                    exit(0);
                }
            }
        }
    }
    return 0;
}
