#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>

using namespace std;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))

typedef long long ll;
const ll INF = ((ll)1000000000) * 1000000000;
const int MAXN = 1000003;

ll dp[MAXN];

int main() {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    ll n, R, U;
    cin >> n >> R >> U;
    dp[0] = -R;
    dp[1] = 0;
    for (int i = 2; i <= n; ++i) {
        dp[i] = INF;
        for (int j = 1; j <= i / 2; ++j)
            if (2 * j != i)
                dp[i] = min(dp[i], max(dp[j] + U, dp[i - 2 * j] + R));
            else dp[i] = min(dp[i], dp[j] + U);
        FOR(j, i)
            if (dp[j] > dp[i])
                dp[j] = dp[i];

        //if (i % 2 == 0)
        //    dp[i] = min(dp[i], dp[i / 2] + U);
        //if (r <= i / 2)
         //   dp[i] = min(dp[i], max(dp[r] + U, dp[i - 2 * r] + R));
    }
    //FOR(i, n + 1)
    //    cout << dp[i] << ' ';
    cout << dp[n];
    return 0;
}
