#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizoef(a))

const int MAXN = 100002;
const int MAXT = 131072;
const int INF = 1000000001;

struct strct{
    int a;
    int n;
};
int a[MAXN];
int b[MAXN];
strct ta1[2 * MAXT];
strct ta2[2 * MAXT];
strct tb1[2 * MAXT];
strct tb2[2 * MAXT];

void buildmin(strct * t, int v, int lx, int rx) {
    if (rx == lx + 1)
        return;
    buildmin(t, 2 * v + 1, lx, (lx + rx) / 2);
    buildmin(t, 2 * v + 2, (lx + rx) / 2, rx);
    strct w1 = t[2 * v + 1];
    strct w2 = t[2 * v + 2];
    if (w1.a < w2.a)
        t[v] = w1;
    else
        t[v] = w2;
}
void buildmax(strct * t, int v, int lx, int rx) {
    if (rx == lx + 1)
        return;
    buildmax(t, 2 * v + 1, lx, (lx + rx) / 2);
    buildmax(t, 2 * v + 2, (lx + rx) / 2, rx);
    strct w1 = t[2 * v + 1];
    strct w2 = t[2 * v + 2];
    if (w1.a > w2.a)
        t[v] = w1;
    else
        t[v] = w2;
}

strct getmin(strct * t, int v, int lx, int rx, int l, int r) {
    if (rx <= l || lx >= r) {
        strct w;
        w.a = INF;
        return w;
    }
    if (l <= lx && rx <= r) {
        return t[v];
    }
    strct w1 = getmin(t, 2 * v + 1, lx, (lx + rx) / 2, l, r);
    strct w2 = getmin(t, 2 * v + 2, (lx + rx) / 2, rx, l, r);
    if (w1.a < w2.a)
        return w1;
    else
        return w2;
}

strct getmax(strct * t, int v, int lx, int rx, int l, int r) {
    if (rx <= l || lx >= r) {
        strct w;
        w.a = 0;
        return w;
    }
    if (l <= lx && rx <= r) {
        return t[v];
    }
    strct w1 = getmax(t, 2 * v + 1, lx, (lx + rx) / 2, l, r);
    strct w2 = getmax(t, 2 * v + 2, (lx + rx) / 2, rx, l, r);
    if (w1.a > w2.a)
        return w1;
    else
        return w2;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n;
    scanf("%d", &n);
    FOR(i, n) {
        scanf("%d%d", &a[i], &b[i]);
    }
    FOR(i, n) {
        ta1[MAXT - 1 + i].a = a[i];
        ta2[MAXT - 1 + i].a = a[i];
        tb1[MAXT - 1 + i].a = b[i];
        tb2[MAXT - 1 + i].a = b[i];
        ta1[MAXT - 1 + i].n = i;
        ta2[MAXT - 1 + i].n = i;
        tb1[MAXT - 1 + i].n = i;
        tb2[MAXT - 1 + i].n = i;
    }
    for (int i = n; i < MAXT; ++i) {
        ta1[MAXT - 1 + i].a = INF;
        ta2[MAXT - 1 + i].a = 0;
        tb1[MAXT - 1 + i].a = INF;
        tb2[MAXT - 1 + i].a = 0;
    }
    buildmin(ta1, 0, 0, MAXT);
    buildmax(ta2, 0, 0, MAXT);
    buildmin(tb1, 0, 0, MAXT);
    buildmax(tb2, 0, 0, MAXT);
    int k;
    scanf("%d", &k);
    FOR(i, k) {
        int l, r;
        scanf("%d%d", &l, &r);
        l--;
        int c[4];
        c[0] = getmin(ta1, 0, 0, MAXT, l, r).n;
        c[1] = getmax(ta2, 0, 0, MAXT, l, r).n;
        c[2] = getmin(tb1, 0, 0, MAXT, l, r).n;
        c[3] = getmax(tb2, 0, 0, MAXT, l, r).n;
        bool ind = false;
        FOR(i, 4) {
            FOR(j, i) {
                if (a[c[i]] != a[c[j]] && b[c[i]] != b[c[j]]) {
                    printf("%d %d\n", c[i] + 1, c[j] + 1);
                    ind = true;
                    break;
                }
            }
            if (ind)
                break;
        }
        if (!ind)
            printf("%d %d\n", 0, 0);

    }

    return 0;
}
