
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <ctime>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

#define FOR(a, b) for(int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))
const int INF = 1000000000;
const int MAXN = 15;
int n, k;
int p1 = 0;
int a[MAXN];
int res[MAXN];
int dp[MAXN];
set<int> unused;
int ans = 0;

void rek(int p) {
    if (p == n) {
        ans++;
        return;
    }
    int s = 0;
    vector<int> tmp;
    tmp.resize(unused.size());
    for (set<int>::iterator it = unused.begin(); it != unused.end(); ++it) {
        tmp[s++] = *it;
    }
    int mx;
    FOR(i, s) {
        res[p] = tmp[i];
        unused.erase(tmp[i]);
        dp[p] = 1;
        mx = 1;
        FOR(j, p) {
            if (res[j] < res[p])
                dp[p] = max(dp[p], dp[j] + 1);
            mx = max(mx, dp[j]);
            if (p1 < k && res[j] < a[p1]) {
                if (dp[j] > p1)
                    mx = INF;
            }
        }
        mx = max(mx, dp[p]);

        if (mx <= k)
            rek(p + 1);
        unused.insert(tmp[i]);
    }
    if (p1 != k) {
        res[p] = a[p1++];
        dp[p] = 1;
        mx = 1;
        FOR(j, p) {
            if (res[j] < res[p])
                dp[p] = max(dp[p], dp[j] + 1);
            mx = max(mx, dp[j]);
            if (p1 < k && res[j] < a[p1]) {
                if (dp[j] > p1)
                    mx = INF;
            }
        }
        mx = max(mx, dp[p]);
        if (mx <= k)
            rek(p + 1);
        p1--;
    }
}


int main()
{
    freopen("army.in", "r", stdin);
    freopen("army.out", "w", stdout);
    scanf("%d%d", &n, &k);
    FOR(i, k)
        scanf("%d", &a[i]);
    sort(a, a + k);
    FOR(i, n)
        unused.insert(i + 1);
    FOR(i, k)
        unused.erase(a[i]);
    rek(0);
    cout << ans;
    return 0;
}
