#include <cstdio>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int maxn = 100020;

typedef vector <int> vi;

void read(vi &x){
	char s[maxn];
	gets(s);
	int j = 0;
	while (s[j] != 0){
		x.push_back(s[j] - '0');
		j++;
	}
}

int st[8];

int gen(vi &x, int l, int r){
	int res = 0;
	for (int i = r - 1; i >= l; i--){
		res += x[i]*st[r - 1 - i];
	}
	return res;
}

int main(){
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);

	vi a, b;

	read(a);
	read(b);

	vi p(a.size() + 1);
	p[0] = 0;
	for (int i = 1; i < a.size() + 1; i++){
		p[i] = p[i - 1] + a[i - 1];
	}

	int find = -1;
	for (int i = 0; i < b.size(); i++){
		if (a[i] != b[i]){
			find  = i;
			break;
		}
	}

	if (find == -1 && a.size() == b.size()){
		printf("1 1");
		return 0;
	}

	st[0] = 1;
	for (int i = 1; i < 8; i++){
		st[i] = st[i - 1]*10;
	}

	int k1;
	map <int, pair<int, int> > q;
	vector <pair < int, pair <int, int> > > d;

	if (find == -1){
		find = b.size() - 2;
	}
	for (int k2 = 7; k2 > 0; k2--){
		q.clear();
		d.resize(0);
		k1 = a.size() - b.size() + k2;
		for (int i = find - k2 + 1; i <= find; i++){
			if (i < 0) continue;
			if (i + k2 > b.size()) continue;
			d.push_back(make_pair(gen(b, i, i + k2), make_pair(i, i + k2)));
			q.insert(make_pair(gen(b, i, i + k2), make_pair(i, i + k2)));
		}
		for (int i = find - k1 + 1; i <= find; i++){
			if (i < 0) continue;
			if (i + k1 > a.size()) continue;
			int sum = p[i + k1] - p[i];
			for (int j = 0; j < d.size(); j++){
				if (d[j].first == sum){
					if (d[j].second.first == i && b.size() - d[j].second.second == a.size() - (i + k1)){
						printf("%d %d", i + 1, i + k1);
						return 0;
					}
				}
			}
		//	if (q.find(sum) != q.end()){
		//		printf("%d %d", i + 1, i + k1);
		//		return 0;
		//	}
		}
	}

	for (int i = find; i < a.size(); i++){
		if (a[i] == b[find]){
			printf("%d %d", find, i);  
		}
	}

	return 0;
}