#include <cstdio>
#include <vector>
#include <set>
#include <map>

using namespace std;

vector <vector <int>> gr1, gr2;
vector <pair<int, int>> time1, time2;
int tim;
int st1, st2;
vector <int> used;
int us = 1;

bool f(vector <pair<int, int>> &t, int a, int b){
	bool res = (t[a].first < t[b].first) && (t[b].second < t[a].second);
	return res;
}

void dfs(vector <vector <int>> &gr, vector <pair<int, int>> &t, int x){
	used[x] = us;
	t[x].first = tim;
	tim++;
	for (int i = 0; i < gr[x].size(); i++){
		if (used[gr[x][i]] != us){
			dfs(gr, t, gr[x][i]);
		}
	}
	t[x].second = tim;
	tim++;
}

int main(){
	freopen("virus.in", "rt", stdin);
	freopen("virus.out", "wt", stdout);

	int n;
	scanf("%d", &n);
	gr1.resize(n);
	gr2.resize(n);
	time1.resize(n);
	time2.resize(n);
	used.resize(n);
	
	for (int i = 0; i < n; i++){
		int temp;
		scanf("%d", &temp);
		if (temp == 0){
			st1 = i;
			continue;
		}
		temp--;
		gr1[temp].push_back(i);
	}
	
	for (int i = 0; i < n; i++){
		int temp;
		scanf("%d", &temp);
		if (temp == 0){
			st2 = i;
			continue;
		}
		temp--;
		gr2[temp].push_back(i);
	}

	tim = 1;
	dfs(gr1, time1, st1);
	us++;
	tim = 1;
	dfs(gr2, time2, st2);

	long long ans = 0;
	for (int i = 0; i < n; i++){
		for (int j = 0; j < n; j++){
			if (i == j) continue;
			if (f(time1, i, j) && f(time2, i, j)){
				ans++;
			}
		}
	}

	printf("%lld", ans);

	return 0;
}