#include <stdio.h>
#include <vector>
#include <map>

using namespace std;

bool comp(pair <int, int> x, pair <int, int> y){
	return (x.first != y.first) && (x.second != y.second);
}

int main(){
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);

	int n;
	scanf("%d", &n);

	vector <pair<pair <int, int>, int>> a(n);
	for (int i = 0; i < n; i++){
		scanf("%d%d", &a[i].first.first, &a[i].first.second);
	}
	for (int i = 0; i < n; i++){
		for (int j = i + 1; j < n + 1; j++){
			if (j == n || comp(a[i].first, a[j].first)){
				a[i].second = j;
				break;
			}
		}
	}

	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++){
		int l, r;
		scanf("%d%d", &l, &r);
		l--;
		r--;
		pair <int, int> ans;
		ans.first = ans.second = 0;
		for (int j = l; j < r; j++){
			if (a[j].second <= r){
				ans.first = j + 1;
				ans.second = a[j].second + 1;
				break;
			}
		}
		printf("%d %d\n", ans.first, ans.second);
	}

	return 0;
}