#include <stdio.h>
#include <vector>
#include <map>

const int maxn = 15000;
using namespace std;

struct actor{
	int num;
	int st;
	bool used[maxn];
};

vector <actor> d;

int main(){
	freopen("theatre.in", "rt", stdin);
	freopen("theatre.out", "wt", stdout);

	int n, m;
	scanf("%d%d", &n, &m);

	int us = 0;
	d.resize(n);
	vector <int> t(n);
	vector <int> act;
	vector <int> unact;

	for (int i = 0; i < m; i++){
		int k;
		scanf("%d", &k);

		us++;
		act.resize(k);
		unact.resize(0);

		for (int j = 0; j < k; j++){
			scanf("%d", &act[j]);
			act[j]--;
			t[act[j]] = us;
		}

		for (int j = 0; j < n; j++){
			if (t[j] != us){
				unact.push_back(j);
			}
		}

		for (int j = 0; j < act.size(); j++){
			for (int l = 0; l < unact.size(); l++){
				if (!d[act[j]].used[unact[l]]){
					d[act[j]].used[unact[l]] = true;
					d[act[j]].num++;
				}
				if (!d[unact[l]].used[act[j]]){
					d[unact[l]].used[act[j]] = true;
					d[unact[l]].num++;
				}
			}
			
		}

		for (int j = 0; j < n; j++){
			if (d[j].num == n - 1 && d[j].st == 0){
				d[j].st = i + 1;
			}
		}
	}

	for (int i = 0; i < n; i++){
		printf("%d ", d[i].st);
	}

	return 0;
}