#include <iostream>
#include <vector>
#include <algorithm>
#include <time.h>

using namespace std;

pair <int, int> a[8];

typedef pair <int, int> pii;

int n, m;

bool can_move(pii t, int x, int y){
	return x + t.first > 0 && x + t.first < m + 1 && y + t.second > 0 && y + t.second < n + 1;
}

int main(){

	srand(unsigned int(time(0)));

	a[0] = pii(1, 0);
	a[1] = pii(1, 1);
	a[2] = pii(0, 1);
	a[3] = pii(-1, 1);
	a[4] = pii(-1, 0);
	a[5] = pii(-1, -1);
	a[6] = pii(0, -1);
	a[7] = pii(1, -1);

	int x, y;
	cin >> n >> m >> x >> y;

	pair <int, int> ans, horse;
	int u = 0;
	int p = 0;

	while (u == 0){
		if (p == 0){
			cout << "0 0 1" << endl;
		}
		else{
			while (true){
				int q = rand()%8;
				if (can_move(a[q], x, y)){
					cout << a[q].first << ' ' << a[q].second << " 1" << endl; 
					x += a[q].first;
					y += a[q].second;
					break;
				}
			}
		}
		cout.flush();

		cin >> u >> horse.first >> horse.second;
		if (u == 1){
			 return 0;
		}

		p++;
	}

	return 0;
}