#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

int main(){
	freopen("army.in", "rt", stdin);
	freopen("army.out", "wt", stdout);

	int n, k;
	scanf("%d%d", &n, &k);

	vector <int> b(k);
	for (int i = 0; i < k; i++){
		scanf("%d", &b[i]);
	}
	sort(b.begin(), b.end());

	vector <int> a(n);
	for (int i = 0; i < n; i++){
		a[i] = n - i;
	}

	vector <int> f(n + 1);
	f[0] = 1;
	for (int i = 1; i < n + 1; i++){
		f[i] = f[i - 1]*i;
	}

	long long q = f[n];
	long long x = 0;
	vector <pair<int, int>> d(n);

	while (q > 0){
		q--;
		next_permutation(a.begin(), a.end());
		d[0].first = -1;
		d[0].second = 1;
		bool find = true;

		int w = 1;
		for (int i = 1; i < n; i++){
			pair <int, int> max;
			d[i].first = -1;
			d[i].second = 1;
			for (int j = 0; j < i; j++){
				if (a[j] < a[i] && (d[i].second < d[j].second + 1 || (d[j].second - 1 < k && d[i].second == d[j].second + 1 && a[j] == b[d[j].second - 1]))){
					d[i].first = j;
					d[i].second = d[j].second + 1;
				}
			}

			if (d[i].second > w){
				w = d[i].second;
			}
		}

		if (w != k){
			continue;
		}
		else{
			for (int i = 0; i < n; i++){
				if (d[i].second == k){
					find = true;
					int j = i, p = 0;
					while (j > -1){
						if (a[j] != b[k - p - 1]){
							find = false;
							break;
						}
						else{
							p++;
							j = d[j].first;
						}
					}
					if (find){
						break;
					}
				}
			}

			if (!find){
				continue;
			}

			x++;
		}
	}

	printf("%lld", x);

	return 0;
}