#include <iostream>
#include <cstdio>
#include <memory.h>
using namespace std;

const int MAXN = 3000;

int N, R, U;
int ans[MAXN];

int get(int u) {
	if (ans[u] != -1)
		return ans[u];

	if (u == 1) {
		ans[u] = 0;
		return 0;
	}

	ans[u] = 2e9;

	for (int i = 1; 2 * i < u; i++) {
		int rest = u - 2 * i;
		ans[u] = min(ans[u], max(get(i) + U, get(u - 2 * i) + R));
	}

	if (!(u & 1)) {
		ans[u] = min(ans[u], get(u >> 1) + U);
	}

	return ans[u];
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	scanf("%d%d%d", &N, &R, &U);
	memset(ans, -1, sizeof(ans));

	printf("%d\n", get(N));
}