#include <iostream>
#include <set>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>
using namespace std;

const int MAXN = 300100;

int N, M;
vector<int> v[MAXN];
int num;
int ans[MAXN];

int nxt[MAXN];
int sz = 1;
set<int> s[MAXN];
int cur[MAXN];
//int m[MAXN];
vector<int> e;

int main() {
	memset(nxt, -1, sizeof(nxt));
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	scanf("%d%d", &N, &M);
	for (int i = 0; i < M; i++) {
		scanf("%d", &num);
		v[i].resize(num);
		for (int j = 0; j < num; j++)
			scanf("%d", &v[i][j]);
	}

	for (int i = 1; i <= N; i++) {
		s[0].insert(i);	
		cur[i] = 0;
	}

	for (int i = 0; i < M; i++) {
		e.clear();
		for (int j = 0; j < v[i].size(); j++) {
			if (ans[v[i][j]])
				continue;
			int a = v[i][j];
			if (nxt[cur[a]] == -1) {
				nxt[cur[a]] = sz++;				
				e.push_back(cur[a]);				
			}
			s[cur[a]].erase(a);
			s[nxt[cur[a]]].insert(a);
			cur[a] = nxt[cur[a]];
		}

		for (int j = 0; j < v[i].size(); j++) {
			if (ans[v[i][j]])
				continue;
			if (s[cur[v[i][j]]].size() == 1)
				ans[v[i][j]] = i + 1;			
		}		

		for (int j = 0; j < e.size(); j++) {
			nxt[e[j]] = -1;
			if (s[e[j]].size() == 1) {
				int a = *s[e[j]].begin();
				ans[a] = i + 1;
			}
		}
	}

	for (int i = 1; i <= N; i++) {		
		printf("%d ", ans[i]);
	}
}