#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <iostream>

using namespace std;

void testgen();

unordered_map<long long,bool> bosscache;
int *hi1;
int *hi2;
int *chi;

inline bool is_boss(int a, int b)
{
	int orig_b = b;
	while(chi[b])
	{
		if(bosscache.find((b)|((long long)a<<33)) != bosscache.end())
		{
			return bosscache[(b)|((long long)a<<33)];
		}
		if(chi[b] == a)
		{
			bosscache[(b)|((long long)a<<33)] = true;
			bosscache[(orig_b)|((long long)a<<33)] = true;
			return true;
		}
		b = chi[b];
	}
	bosscache[(b)|((long long)a<<33)] = false;
	bosscache[(orig_b)|((long long)a<<33)] = false;
	return false;
}



int main()
{
	//testgen();

	int st = clock();
	ifstream in("virus.in");
	ofstream out("virus.out");

	int n;
	in >> n;

	//unordered_set<int> *hi1 = new unordered_set<int>[n+1], *hi2 = new unordered_set<int>[n+1];
	hi1 = new int[n+1];
	hi2 = new int[n+1];
	unordered_set<int> *bosses = new unordered_set<int>[n+1];
	for(int i = 0; i < n; i++)
	{
		int podc;
		in >> podc;
		hi1[i+1] = podc;
	}
	for(int i = 0; i < n; i++)
	{
		int podc;
		in >> podc;
		hi2[i+1] = podc;
	}
	chi = hi2;
	long long pairs = 0;
	for(int i = 1; i <= n; i++)
	{
		int other = hi1[i];
		while(other)
		{
			if(is_boss(other,i))
			{
				pairs++;
			}
			other = hi1[other];
		}
	}

	out << pairs;
	out.close();

	cout << clock()-st;
	cin.get();

	return 0;
}