#include <fstream>
#include <ctime>
#include <iostream>
#include <cmath>
#include <cstring>

using namespace std;

void testgen();

char **flagota;
int w,h;

bool restore_col_pk(int rn)
{ //restore a row if previous is known
	for(int i = 0; i < h; i++)
	{
		if(flagota[rn][i] != '*')
		{
			for(int j = i-1; j >= 0; j--)
			{
				if(flagota[rn+1][j] == '9' && flagota[rn+1][j+1] == '0')
				{
					flagota[rn][j] = flagota[rn][j+1]-1;
					if(flagota[rn][j] < '0')
						flagota[rn][j] = '9';
				} else
					flagota[rn][j] = flagota[rn][j+1];
			}
			for(int j = i+1; j < h; j++)
			{
				if(flagota[rn+1][j-1] == '9' && flagota[rn+1][j] == '0')
				{
					flagota[rn][j] = flagota[rn][j-1]+1;
					if(flagota[rn][j] > '9')
						flagota[rn][j] = '0';
				} else
					flagota[rn][j] = flagota[rn][j-1];
			}
			return true; //done here
		}
	}
	return false;
}

void restore_last_row(int av)
{
	for(int j = av-1; j >= 0; j--)
	{
		flagota[w-1][j] = flagota[w-1][j+1]-1;
		if(flagota[w-1][j] < '0')
			flagota[w-1][j] = '9';
	}
	for(int j = av+1; j < h; j++)
	{
		flagota[w-1][j] = flagota[w-1][j-1]+1;
		if(flagota[w-1][j] > '9')
			flagota[w-1][j] = '0';
	}
}

int main()
{
	//testgen();
	
	ifstream in("calendar.in");
	ofstream out("calendar.out");

	in >> h >> w;

	flagota = new char*[w];
	for(int i = 0; i < w; i++)
		flagota[i] = new char[h];

	for(int i = 0; i < h; i++)
	{
		for(int j = 0; j < w; j++)
			in >> flagota[j][i];
	}

	int fstars = 0;
	for(int i = 0; i < w; i++)
	{
		if(flagota[i][0] == '*')
			fstars++;
	}

	//now, restore
	while(fstars > 0)
	{
		fstars = 0;
		bool canhax = false;
		for(int i = 0; i < h; i++)
		{
			if(flagota[w-1][i] != '*')
			{
				restore_last_row(i);
				canhax = true;
				break;
			}
		}
		if(canhax)
		{
			for(int i = w-2; i >= 0; i--)
				if(!restore_col_pk(i))
					break;
			break;
		}

		for(int i = 0; i < w; i++)
		{
			for(int j = 0; j < h; j++)
			{
				if(i < w-1 && j < h-1)
				{
					if(flagota[i][j] != '*' && flagota[i][j+1] != '*' && flagota[i][j] != flagota[i][j+1] && (flagota[i+1][j] == '*' || flagota[i+1][j+1] == '*'))
					{
						flagota[i+1][j] = '9';
						flagota[i+1][j+1] = '0';
					}
				}
				if(i > 0 && j < h-1 && flagota[i][j] == '9' && flagota[i][j+1] == '0' && ((flagota[i-1][j]=='*')^(flagota[i-1][j+1]=='*')))
				{
					if(flagota[i-1][j] == '*')
					{
						flagota[i-1][j] = flagota[i-1][j+1] - 1;
						if(flagota[i-1][j] < '0')
							flagota[i-1][j] = '9';
					} else {
						flagota[i-1][j+1] = flagota[i-1][j] + 1;
						if(flagota[i-1][j] > '9')
							flagota[i-1][j] = '0';
					}
				}
				if(i < w-1 && flagota[i][j] != '*')
				{
					for(int k = j-((w-1-i)*10); k >= 0; k-=((w-1-i)*10))
					{
						flagota[i][k] = flagota[i][k+((w-1-i)*10)]-1;
						if(flagota[i][k] < '0')
							flagota[i][k] = '9';
					}
					for(int k = j+((w-1-i)*10); k < h-1; k+=(w-1-i)*10)
					{
						flagota[i][k] = flagota[i][k-((w-1-i)*10)]+1;
						if(flagota[i][k] > '9')
							flagota[i][k] = '0';
					}
				}
			}
		}

		fstars = 0;
		for(int i = 0; i < w; i++)
		{
			if(flagota[i][0] == '*')
				fstars++;
		}
	}

	for(int i = 0; i < w; i++)
		out << (flagota[i][0] == '*' ? '0' : flagota[i][0]);
	out.close();
	return 0;

	out.close();
	//cin.get(); cin.get();
	return 0;
}