#include <stdio.h>

using namespace std;

int n, x, y, a[200000][2], l, r, fx, fy;
int s[2][200000];

int bin_search(int * a, int x, int y)
{
    int l = x;
    int r = y;
    int m;
    while (l < r)
    {
        m = (l + r) / 2;
        if (a[m] - a[l] == m - l)
            l = m + 1;
        else
            r = m;
    }
    return l;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d", &a[i][0], &a[i][1]);
        if (i == 0)
        {
            s[0][0] = 1;
            s[1][0] = 1;
        }
        else
        {
            if (a[i][0] != a[i - 1][0])
                s[0][i] = 1;
            else
                s[0][i] = s[0][i - 1] + 1;
            if (a[i][1] != a[i - 1][1])
                s[1][i] = 1;
            else
                s[1][i] = s[1][i - 1] + 1;
        }
    }
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d%d", &x, &y);
        x--;
        y--;
        if (s[0][y] - s[0][x] != y - x && s[1][y] - s[1][x] != y - x)
        {
            fx = bin_search(s[0], x, y);
            fy = bin_search(s[1], x, y);
            if (a[fx][1] != a[fy][1])
                printf("%d %d\n", fx + 1, fy + 1);
            else
                printf("%d %d\n", x + 1, fx + 1);
        }
        else
            printf("0 0\n");
    }
}
