program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  inf = 9223372036854775807;

var
  n: integer;
  u, r: int64;
  ans: array[1..1000000] of int64;

function count(n: integer): int64;
var
  i: integer;
  now: int64;
begin
  if ans[n] > 0 then begin
    result := ans[n];
    exit;
  end;
  if n <= 1 then begin
    result := 0;
    exit;
  end;
  result := inf;
  for i := 1 to n div 2 do begin
    if n - 2 * i = 0 then
      now := u + count(i)
    else
      now := max(u + count(i), r + count(n - 2*i));
    result := min(result, now);
  end;
  ans[n] := result;
end;

begin
  reset(input, 'apricot.in');
  rewrite(output, 'apricot.out');

  read(n, r, u);
  fillchar(ans, sizeof(ans), 0);
  write(count(n));
end.
