program Project3;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  len = 262144;
  first = 131072;
  inf = maxlongint;

var
  n, k, i, l, r, j, m: integer;
  a: array[1..100000, 1..2] of integer;
  d: array[1..len, 1..2] of integer;

procedure init;
var
  i: integer;
begin
  for i := 1 to len do
    d[i][2] := inf;
  for i := first to first + n - 1 do
    d[i][1] := i - first + 1;
end;

procedure push(pos, val: integer);
begin
  pos := pos + first - 1;
  d[pos][2] := val; 
  while pos > 1 do begin
    pos := pos div 2;
    if d[pos * 2][2] < d[pos * 2 + 1][2] then
      d[pos] := d[pos * 2]
    else
      d[pos] := d[pos * 2 + 1];
  end;    
end;

procedure get(l, r: integer; var pos, val: integer);
begin
  l := l + first - 1;
  r := r + first - 1;
  val := inf;
  pos := d[l][1];
  while l <= r do begin
    if l mod 2 = 1 then begin
      if val > d[l][2] then begin
        pos := d[l][1];
        val := d[l][2]
      end;
      inc(l);
    end;
    if r mod 2 = 0 then begin
      if val > d[r][2] then begin
        pos := d[r][1];
        val := d[r][2]
      end;
      dec(r);
    end;
    l := l div 2;
    r := r div 2; 
  end;    
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');

  read(N);
  for i := 1 to n do
    read(a[i][1], a[i][2]);
  read(k);
    init();
    for i := 1 to N - 1 do
      for j := i + 1 to N do
        if(a[j][1] <> a[i][1])and(a[j][2] <> a[i][2]) then begin
          push(i, j);
          break;
        end;

    for i := 1 to k do begin
        read(l, r);
        get(l, r, j, m);
        if m = inf then
          writeln('0 0')
        else if m <= r then
          writeln(j, ' ', m)
        else
          writeln('0 0');
      end;
end.
