#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const int MAXN = 5050;
int n, ans = 0, t = 0, rv, rg;
vector <int> v[MAXN];
vector <int> g[MAXN];
vector <int> ting, tinv, toutg, toutv;

void read()
{
	int tmp;
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		cin >> tmp;
		if (tmp != 0)
			v[tmp].push_back(i + 1);
		else
			rv = i + 1;
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> tmp;
		if (tmp != 0)
			g[tmp].push_back(i + 1);
		else
			rg = i + 1;
	}
	ting.resize(n + 5);
	toutg.resize(n + 5);
	tinv.resize(n + 5);
	toutv.resize(n + 5);
}

void dfs1(int nowv)
{
	tinv[nowv] = t++;
	for (int i = 0; i < v[nowv].size(); ++i)
		dfs1(v[nowv][i]);
	toutv[nowv] = t++;
}

void dfs2(int nowv)
{
	ting[nowv] = t++;
	for (int i = 0; i < g[nowv].size(); ++i)
		dfs2(g[nowv][i]);
	toutg[nowv] = t++;
}

bool prev(int i, int j)
{
	return tinv[i] < tinv[j] && toutv[i] > toutv[j] && ting[i] < ting[j] && toutg[i] > toutg[j];
}

void solve()
{
	t = 0;
	dfs1(rv);
	t = 0;
	dfs2(rg);
	for (int i = 1; i <= n; ++i)
	{
		for (int j = i + 1; j <= n; ++j)
		{
			if (prev(i, j) || prev(j, i))
				ans++;
		}
	}
}

void print()
{
	cout << ans << endl;
}

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}