#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

const long long INF = (long long)1e15;
const int MAXN = 2012;
int n, r, u;
vector <long long> d;
long long mn[MAXN][MAXN];

void read()
{
	cin >> n >> r >> u;
	d.resize(n + 5);
}

void solve()
{
	d[1] = 0;
	mn[1][1] = d[1];
	d[2] = u;
	mn[2][2] = d[2];
	mn[1][2] = min(d[1], d[2]);
	for (int i = 3; i <= n; ++i)
	{
		d[i] = INF;
		for (int j = 1; j <= i / 2; ++j)
		{
			if (j * 2 == i)
				d[i] = min(d[i], mn[j][i - 1] + u); // min(d[j] + u, d[j + 1] + u));
			else
				d[i] = min(d[i], max(mn[j][i - 1] + u, mn[i - 2 * j][i - 1] + r));//min(d[i - 2 * j] + r, d[i - (2 * j) + 1] + r)));
		}
		mn[i][i] = d[i];
		for (int j = 1; j < i; ++j)
			mn[i - j][i] = min(mn[i - j][i - 1], d[i]);
	}
}

void print()
{
	cout << d[n] << endl;
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	read();
	solve();
	print();
	return 0;
}