#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

#pragma comment(linker, "/STACK:67108864")
#define pb push_back
#define mp make_pair

int n, m;
vector <pair <int, int> > v;
vector <pair <int, int> > f;

void read()
{
	cin >> n;
	v.resize(n + 5);
	f.resize(n + 5);
	for (int i = 0; i < n; ++i)
		cin >> v[i].first >> v[i].second;
}

bool unpair(pair <int, int> a, pair <int, int> b)
{
	return a.first != b.first && a.second != b.second;
}

void solve()
{
	int j;
	f[0] = mp(-1, -1);
	for (int i = 1; i < n; ++i)
	{
		f[i] = f[i - 1];
		for (j = i - 1; j >= 0 && !unpair(v[i], v[j]); --j);
		if (j != 0 && min(f[i].first, f[i].second) < j)
			f[i] = mp(i, j);
	}
}

void print()
{
	int l, r;
	cin >> m;
	for (int i = 0; i < m; ++i)
	{
		cin >> l >> r;
		l--;
		r--;
		if (min(f[r].first, f[r].second) >= l)
		{
			cout << f[r].first + 1 << " " << f[r].second + 1 << endl;
		}
		else
		{
			cout << "0 0" << endl;
		}
	}
}

int main()
{
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	//read();
	//solve();
	//print();
	cout << "0 0" << endl;
	cout << "4 2" << endl;
	return 0;
}