#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
using namespace std;

#pragma comment(linker, "/STACK:67108864")

int n, m;
int cx, cy;
int ans, tmp;

bool check()
{
	int tmp;
	cin >> ans >> tmp >> tmp;
	return ans;
}

bool mover()
{
	while (cx < m)
	{
		cx++;
		cout << "1 0 1" << endl;
		cout.flush();
		if (check())
			return true;
	}
	while (cx > 1)
	{
		cx--;
		cout << "-1 0 1" << endl;
		cout.flush();
		if (check())
			return true;
	}
	return false;
}

bool moveup()
{
	if (cy == 1)
		return false;
	cout << "0 -1 1" << endl;
	cy--;
	cout.flush();
	return true;
}

bool movedown()
{
	while (cy < n)
	{
		cy++;
		cout << "0 1 1" << endl;
		cout.flush();
		if (check())
			return true;
	}
	return false;
}

void solve()
{
	cin >> n >> m;
	cin >> cx >> cy;
	cout << "0 0 1" << endl;
	cout.flush();
	if (check())
		return;
	if (movedown())
		return;
	if (mover())
		return;
	while (1)
	{
		do
		{
			if (check())
				return;
			if (mover())
				return;
		}
		while (moveup());
		if (movedown())
			return;
	}
}

int main()
{
	srand(1141201);
	solve();
	return 0;
	//;)
}