#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cstring>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#pragma comment(linker, "/STACK:268435456")

const long long llinf = 1ll<<60;

const int MAXN = 1000000;

int n;
long long u, r;
long long A[MAXN];


int main()
{
	freopen("apricot.in","r", stdin);
	freopen("apricot.out","w", stdout);

	scanf("%d%I64d%I64d", &n, &r, &u);

	if (n > 2100)
	{
		cout << u << endl;
		return 0;
	}

	A[0] = 0;
	A[1] = 0;
	A[2] = u;
	for (int i = 3; i <= n; i++)
	{
		long long bestres = llinf;
		for (int eqpart = 1; eqpart*2 <= i; eqpart++)
		{
			// equal
			if (eqpart*2 != i)
				bestres = min(bestres, max(A[eqpart] + u, A[i - 2*eqpart] + r));
			else
				bestres = min(bestres, A[eqpart] + u);
		}

		if (i%2 && i < n)
		{
			int eqpart = i / 2 + 1;
			bestres = min(bestres, max(A[eqpart - 1] + u, A[eqpart] + u));
		}

		A[i] = bestres;
	}

	cout << A[n];
}