#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#include <map>
#include <set>
#include <stack>
#include <queue>

#pragma comment(linker,"/STACK:268435456")

using namespace std;

const int MAXN = 30;

int n, m;
int a[MAXN];

bool used[MAXN];
bool inArmy[MAXN];

int A[MAXN];
int curmaxOtr[MAXN];
int needArmy = 0;
int place[MAXN];

double start;
int counter = 0;

int ans = 0;

inline bool TL()
{
	if (counter == 10000)
	{
		if ((clock()-start)/CLOCKS_PER_SEC > 0.9)
			return true;
		counter = 0;
	}
	else
		counter++;
	return false;
};

inline void Rec(int x)
{
	if (TL())
	{
		cout << ans;
		exit(0);
	};

	if (x-1 >= 0 && curmaxOtr[x-1] > m)
		return;

	if (x-1 >= 0 && curmaxOtr[x-1] + n-x < m)
		return;

	if (x == n)
	{
		if (curmaxOtr[x-1] == m)
			ans++;
		return;
	}

	for (int willplace = 0; willplace < n; willplace++)
	{
		if (used[willplace])
			continue;

		if (inArmy[willplace] && a[needArmy] != willplace)
			continue;

		if (willplace < a[needArmy] && needArmy == 0)
			continue;

		if (needArmy > 0 && willplace > a[needArmy-1] && willplace < a[needArmy])
			continue;

		used[willplace] = true;
		place[x] = willplace;

		if (inArmy[willplace])
		{
			needArmy++;
		}

		A[x] = 1;
		for (int pred = 0; pred < x; pred++)
			if (place[pred] < willplace)
				A[x] = max(A[pred]+1, A[x]);

		if (x - 1 >= 0)
			curmaxOtr[x] = max(curmaxOtr[x-1], A[x]);
		else
			curmaxOtr[x] = A[x];

		Rec(x+1);

		used[willplace] = false;
		if (inArmy[willplace])
		{
			needArmy--;
		}
	}
}

int main()
{
	start = clock();
	freopen("army.in","r", stdin);
	freopen("army.out","w", stdout);
	scanf("%d%d", &n, &m);
	memset(a, 255, sizeof(a));
	for (int i = 0; i < m; i++)
	{
		scanf("%d", &a[i]);
		a[i]--;
		inArmy[a[i]] = true;
	}

	memset(used, 0, sizeof(used));

	Rec(0);
	cout << ans;
}