#pragma comment(linker, "/STACK:16777216")

#include <iostream>
#include <algorithm>

#define INF 1<<30;

using namespace std;

int main()
{
	freopen("apricot.in","r",stdin);
	freopen("apricot.out","w",stdout);

	int n, r, u;
	cin >> n >> r >> u;

	int din[1000001];
	din[1] = 0;

	for(int i=2; i<=n; i++)
	{
		din[i] = INF;

		int e = (i-1)/2;
		int b = 1;
		int o;

#define minus(x) ((din[x]+u) - (din[i-2*(x)]+r))

		while(abs(b-e)>1)
		{
			o = minus((b+e)/2);
			if(o>=0) e = (b+e)/2;
			else b = (b+e)/2;
		}

		int q = min(
			max(din[i-2*b] + r, din[b] + u),
			max(din[i-2*e] + r, din[e] + u)
			);
		if(din[i] > q) din[i] = q;

		/*for(int j=1; 2*j<i; j++)
		{
			int q = max(
				din[i-2*j] + r,
				din[j] + u
			);
			if(din[i] > q) din[i] = q;
		}*/

		din[i] = min(din[i], din[(i+1)/2] + u);
	}
		
	din[n] = INF;
	for(int j=1; 2*j<n; j++)
	{
		int q = max(
			din[n-2*j] + r,
			din[j] + u
		);
		if(din[n] > q) din[n] = q;
	}
	if(!(n&1))
		din[n] = min(din[n], din[n/2] + u);

	std::cout << din[n];

	return 0;
}