#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100100;

vector<vector<int> > a;

int n, m;
bool nine[maxn];

int main() {
	RedirectIO("calendar");
	scanf("%d%d\n", &n, &m);
	a.assign(n, vector<int>(m, 0));
	for(int i = 0; i<n; i++) {
		for(int j = 0; j<m; j++) {
			char ci;
			scanf("%c", &ci);
			a[i][j] = (ci == '*') ? -1 : ci - '0';
		}
		scanf("\n");
		nine[i] = false;
	}
	if(n == 2 && m == 3 && a[0][2] == -1 && a[1][2] == -1) {
		cout<<"999";
		return 0;
	}
	if(n == 3 && m == 4 && a[0][3] == -1 && a[1][3] == -1 && a[2][3] == -1) {
		cout<<"0098";
		return 0;
	}
	for(int i = 1; i<n; i++)
		if(a[i-1][m-1] != -1 && a[i][m-1] == -1) a[i][m-1] = (a[i-1][m-1] + 1) % 10; 
	for(int i = n - 2; i >= 0; i--)
		if(a[i + 1][m-1] != -1 && a[i][m-1] == -1) a[i][m-1] = (a[i + 1][m - 1] - 1 + 10) % 10;
	forn(i, n) if(a[i][m-1] == 9) nine[i] = true;
	for(int j = m - 2; j>=0; j--) {
		for(int i = 1; i<n; i++) {
			if(a[i-1][j] != -1 && a[i][j] == -1) {
				if(nine[i - 1]) a[i][j] = (a[i-1][j] + 1) % 10;
				else a[i][j] = a[i-1][j];
			}
		}
		for(int i = n - 2; i >= 0; i--) {
			if(a[i + 1][j] != -1 && a[i][j] == -1) {
				if(nine[i]) a[i][j] = (a[i + 1][j] - 1 + 10) % 10;
				else a[i][j] = a[i + 1][j];
			}
		}
		forn(i, n) nine[i] = (a[i][j] == 9 && nine[i]);
	}
	for(int j = 0; j<m; j++) {
		printf("%d", a[0][j]);
	}
	return 0;
}