#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)

typedef pair<int, int> pii;
typedef vector<pii> vii;
void RedirectIO(string file) {
	freopen((file + ".in").c_str(), "r", stdin);
	freopen((file + ".out").c_str(), "w", stdout);
}

const int maxn = 100000;
const int INF = 1000000000;

#define DONE -1

vector<int> type, ans, cnt;
int n, m, ki, id;
vii vp;
set<int> sp;

inline void del1(int n) {
	sp.erase(n);
}

inline void add1(int n) {
	sp.insert(n);
}

void changecnt(int n, int k) {
	if(cnt[n] == 1) del1(n);
	cnt[n] += k;
	if(cnt[n] == 1) add1(n);
}

int main() {
	RedirectIO("theatre");
	cin>>n>>m;
	type.assign(n, 0);
	ans.assign(n, 0);
	cnt.pb(n);
	if(n == 1) add1(0);
	forn(act, m) {
		scanf("%d", &ki);
		vp.clear();
		forn(i, ki) {
			scanf("%d", &id);
			id--;
			if(type[id] == DONE) continue;
			vp.pb(mp(type[id], id));
		}
		if(vp.size() == 0) continue;
		sort(vp.begin(), vp.end());
		changecnt(type[vp[0].second], -1);
		type[vp[0].second] = cnt.size();
		cnt.pb(1);
		add1(cnt.size()-1);
		for(int i = 1; i<vp.size(); i++) {
			changecnt(type[vp[i].second], -1);
			if(vp[i].first == vp[i-1].first) {
				type[vp[i].second] = cnt.size()-1;
				changecnt(cnt.size() - 1, 1);
			}
			else {
				type[vp[i].second] = cnt.size();
				cnt.pb(0);
				changecnt(cnt.size() - 1, 1);
			}
		}
		for(set<int>::iterator it = sp.begin(); it!=sp.end(); it++) {
			int i = *it;
			for(int j = 0; j<n; j++) {
				if(type[j] == i) {
					type[j] = DONE;
					ans[j] = act + 1;
					cnt[i]--;
					break;
				}
			}
			
		}
	}
	for(int i = 0; i<n; i++) {
		printf("%d ", ans[i]);
	}
	return 0;
}