
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
 
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)
 
typedef pair<int, int> pii;
typedef vector<pii> vii;
void RedirectIO(string file) {
    freopen((file + ".in").c_str(), "r", stdin);
    freopen((file + ".out").c_str(), "w", stdout);
}
 
const int maxn = 100000;
const int INF = 1000000000;
 
#define DONE -1
 
vector<int> type, ans, cnt;
vector<set<int> > pred;
int n, m, ki, id;
vii vp;
set<int> sp;
vector<int> vc;
 
inline void del1(int n) {
    sp.erase(n);
}
 
inline void add1(int n) {
    sp.insert(n);
}
 
void changecnt(int n, int k) {
    if(cnt[n] == 1) del1(n);
    cnt[n] += k;
    if(cnt[n] == 1) add1(n);
}
 
void changetype(int n, int k) {
	pred[type[n]].erase(n);
	type[n] = k;
	pred[k].insert(n);
}

int main() {
    RedirectIO("theatre");
    cin>>n>>m;
    type.assign(n, 0);
    ans.assign(n, 0);
    cnt.pb(n);
	pred.pb(set<int>());
	for(int i = 0; i<n; i++) pred[0].insert(i);
    if(n == 1) add1(0);
    forn(act, m) {
        scanf("%d", &ki);
        vp.clear();
        forn(i, ki) {
            scanf("%d", &id);
            id--;
            if(type[id] == DONE) continue;
            vp.pb(mp(type[id], id));
        }
        if(vp.size() == 0) continue;
        sort(vp.begin(), vp.end());
        changecnt(type[vp[0].second], -1);
        cnt.pb(1);
		pred.pb(set<int> ());
        add1(cnt.size()-1);
		changetype(vp[0].second, cnt.size() - 1);
		//type[vp[0].second] = cnt.size() - 1;
        for(int i = 1; i<vp.size(); i++) {
            changecnt(type[vp[i].second], -1);
            if(vp[i].first == vp[i-1].first) {
                changecnt(cnt.size() - 1, 1);
				changetype(vp[i].second, cnt.size() - 1);
				//type[vp[i].second] = cnt.size()-1;
            }
            else {
               
                cnt.pb(0);
				pred.pb(set<int> ());
                changecnt(cnt.size() - 1, 1);
				changetype(vp[i].second, cnt.size() - 1);
				//type[vp[i].second] = cnt.size() - 1;
            }
        }
		vc.clear();
        for(set<int>::iterator it = sp.begin(); it!=sp.end(); it++) 
            vc.pb(*it);
		for(vector<int>::iterator it = vc.begin(); it != vc.end(); it++) {
			int i = *it;
			int j = *pred[i].begin();
			type[j] = DONE;
            ans[j] = act + 1;
            changecnt(i, -1);
            pred[i].clear(); 
        }
    }
    for(int i = 0; i<n; i++) {
        printf("%d ", ans[i]);
    }
    return 0;
}