#include <windows.h>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <cstdlib>
using namespace std;
 

#define j0 J0
#define i0 I0
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)
 
typedef pair<int, int> pii;
typedef vector<pii> vii;
void RedirectIO(string file) {
    freopen((file + ".in").c_str(), "r", stdin);
    freopen((file + ".out").c_str(), "w", stdout);
}
 
const int maxn = 100000;
const int INF = 1000000000;
 
#define DONE -1
 
int di[8] = {0, 0, 1, 1, 1, -1, -1, -1};
int dj[8] = {1, -1, 0, -1, 1, 0, 1, -1};

int n, m, i0, j0;
int hi1, hi2, hj1, hj2;
int diri = 1, dirj = 1;
int MI, MJ;

inline bool inside(int i, int j) {
	return(i >= hi1 && i<=hi2 && j >= hj1 && j <= hj2);
}

void next(int &i0, int &j0) {
	MI = MJ = 0;
	if(!inside(i0, j0)) {
		int ci = (hi1 + hi2) / 2;
		int cj = (hj1 + hj2) / 2;
		int DI = ci - i0;
		int DJ = cj - j0;
		MI = ((DI != 0) ? DI / abs(DI): 0);
		MJ = ((DJ != 0) ? DJ / abs(DJ): 0);
		i0 += ((DI != 0) ? DI / abs(DI): 0);
		j0 += ((DJ != 0) ? DJ / abs(DJ): 0);
	}
	else {
		if(!inside(i0, j0 + dirj)) {
			dirj *= -1;
			if(!inside(i0 + diri, j0)) {
				diri *= -1;
			}
			i0 += diri;
			MI = diri;
		}
		else {
			MJ = dirj;
			j0 += dirj;
		}
	}			
}

bool query() {
	int r, Di, Dj;
	next(i0, j0);
	printf("%d %d %d\n", MJ, MI, 1);
	fflush(stdout);
	scanf("%d%d%d", &r, &Dj, &Di);
	if(r == 1) return true;
	if(Dj == 1) hj1 = min(hj1 + 1, m), hj2 = min(hj2 + 1, m); 
	if(Dj == -1) hj1 = min(hj1 - 1, 1), hj2 = min(hj2 - 1, 1);
	if(Di == 1) hi1 = min(hi1 + 1, n), hi2 = min(hi2 + 1, n);
	if(Di == -1) hi1 = min(hi1 - 1, n), hi2 = min(hi2 - 1, m);
	return false;
}

int main() {
    //RedirectIO("theatre");
    cin>>n>>m;
	cin>>j0>>i0;
	hi1 = 1; hj1 = 1; hi2 = n; hj2 = m;
	while(inside(i0, j0)) {
		if(query())break;
	}
    return 0;
}