#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;
 
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define forn(i, n) for(int i = 0; i<(n); i++)
 
typedef pair<int, int> pii;
 
void RedirectIO(string file) {
    freopen((file + ".in").c_str(), "r", stdin);
    freopen((file + ".out").c_str(), "w", stdout);
}
 
const int maxn = 100000;
const int INF = 1000000000;
 
#define DONE -1
 
vector<int> perm;
bool used[20];
int f[20][20];
int n, m, k;
int ans = 0;
 
int F() {
    forn(i, n + 1) forn(j, n + 1) f[i][j] = 0;
    forn(i, n) forn(j, n) {
        f[i + 1][j + 1] = max(f[i][j], max(f[i+1][j], f[i][j+1]));
        if(perm[j] == i) 
            f[i+1][j+1]++; 
    }
    return f[n][n];
}
 
void check() {
    //forn(i, n)
        //printf("%d", perm[i]);
 
    //cout<<" ";
    //cout<<F();
    //cout<<endl;
    if(F() == k) {
        int found = 0;
        forn(i, n) if(perm[i] == need[found]) found++;
        if(found == k) ans++; 
    }
}
 
void dfs(int N) {
    if(N == 0) {
        check();
    }
    else {
        for(int i = 0; i<n; i++) {
            if(!used[i]) {
                used[i] = true;
                perm[n - N] = i;
                dfs(N - 1);
                used[i] = false;
            }
        }
    }
}
 
int main() {
    RedirectIO("army");
    cin>>n>>k;
	for(int i = 0; i<k; i++) {
		cin>>need[i];
		need[i]--;
	}
    perm.assign(n, 0);
    dfs(n);
    cout<<ans;
    return 0;
}