#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "virus.in";
const char * fout = "virus.out";

#define tm tm_100500

int n, r1, r2;
vector<vector<int> > g1, g2;
vector<int> in1, out1, in2, out2;

bool cool(int l1, int r1, int l2, int r2, int l3, int r3, int l4, int r4){
    return (l1 <= l2 && r2 <= r1 && l3 <= l4 && r4 <= r3);
}

int tm = 0;

void dfs1(int v, int p = -1){
    in1[v] = ++tm;
    for (int i = 0; i < len(g1[v]); i++)
        if (g1[v][i] != p)
            dfs1(g1[v][i], v);
    out1[v] = ++tm;
}

void dfs2(int v, int p = -1){
    in2[v] = ++tm;
    for (int i = 0; i < len(g2[v]); i++)
        if (g2[v][i] != p)
            dfs2(g2[v][i], v);
    out2[v] = ++tm;
}

int main(){
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    cin >> n;
    g1.resize(n); g2.resize(n);
    for (int i = 0; i < n; i++){
        int t; cin >> t;
        if (t != 0)
            g1[--t].pb(i);
        else
            r1 = i;
    }
    for (int i = 0; i < n; i++){
        int t; cin >> t;
        if (t != 0)
            g2[--t].pb(i);
        else
            r2 = i;
    }
    in1.resize(n); out1.resize(n);
    dfs1(r1);
    in2.resize(n); out2.resize(n);
    dfs2(r2);
    int res = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j && cool(in1[i], out1[i], in1[j], in1[j], in2[i], out2[i], in2[j], out2[j]))
                ++res;
    cout << res << endl;
    return 0;
}
