#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define sqr(x) ((x)*(x))
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(x) ((int) (x).size())
#define last(x) ((x)[len(x)-1])
#define plast(x) ((x)[len(x)-2])
#define all(x) (x).begin(), (x).end()
using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = 1 << 30;
const int64 linf = 1ll << 61;

const char * fin = "army.in";
const char * fout = "army.out";

const int cmax = 20;

int n, k, res = 0;
vector<int> p;
bool used[cmax], cool[cmax];
int prev[cmax];
vector<int> stack;

void make(int x){
    if (x == n){
        if (len(p) <= k){
            ++res;
            for (int i = 0; i < len(stack); i++)
                cerr << stack[i]+1 << ' ';
            cerr << endl;
            for (int i = 0; i < len(p); i++)
                cerr << p[i] +1 << ' ';
            cerr << endl;
        }
        return;
    }
    for (int i = 0; i < n; i++)
        if (!used[i] && (!cool[i] || prev[i] == -1 || used[prev[i]])){
            int index = lower_bound(all(p), i) - p.begin();
            int val;
            if (index < len(p))
                val = p[index], p[index] = i;
            else
                val = -1, p.pb(i);
            used[i] = true;
            stack.pb(i);
            make(x+1);
            stack.pbk();
            used[i] = false;
            if (val != -1)
                p[index] = val;
            else
                p.pbk();
        }
}

int main()
{
    freopen(fin, "r", stdin);
    freopen(fout, "w", stdout);
    cin >> n >> k;
    for (int i = 0; i < k; i++){
        int t; cin >> t; --t;
        cool[t] = true;
    }
    prev[0] = -1;
    for (int i = 1; i < n; i++)
        if (cool[i-1])
            prev[i] = i-1;
        else
            prev[i] = prev[i-1];
    make(0);
    cout << res << endl;
    return 0;
}
