#include <iostream>
#include <cstdio>
using namespace std;
typedef long long ll;
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define FILE_NAME "mosaic"
typedef long long ll;
typedef pair <int, int> pii;
const int K = 20;
const int N = 1e5 + 5;

int lg[N], n;
pii mxa[K][N], mna[K][N];
pii mxb[K][N], mnb[K][N];
pii getMxA(int l, int r)
{
  int k = lg[r - l];
  return max(mxa[k][l], mxa[k][r - (1<<k)+1]);
}
pii getMxB(int l, int r)
{
  int k = lg[r - l];
  return max(mxb[k][l], mxb[k][r - (1<<k)+1]);
}
pii getMnA(int l, int r)
{
  int k = lg[r - l];
  return min(mna[k][l], mna[k][r - (1<<k)+1]);
}
pii getMnB(int l, int r)
{
  int k = lg[r - l];
  return min(mnb[k][l], mnb[k][r - (1<<k)+1]);
}
int main()
{
  freopen(FILE_NAME".in", "r", stdin);
  freopen(FILE_NAME".out", "w", stdout);
  cin >> n;
  int x, y;
  for (int i = 0; i < n; i++)
  {
    scanf("%d%d", &x, &y);
    mxa[0][i] = mna[0][i] = mp(x, i);
    mxb[0][i] = mnb[0][i] = mp(y, i);
  }
  int k = 0;
  for (int p = 1, i = 2; i <= n; i++)
  {
    if (p * 2 == i) k++, p *= 2;
    lg[i] = k;
  }
  for (int j = 1; j <= k; j++)
    for (int i = 0; i <= n - (1<<j); i++)
    {
      mxa[j][i] = max(mxa[j - 1][i], mxa[j - 1][i + (1<<(j-1))]);
      mxb[j][i] = max(mxb[j - 1][i], mxb[j - 1][i + (1<<(j-1))]);
      mna[j][i] = min(mna[j - 1][i], mna[j - 1][i + (1<<(j-1))]);
      mnb[j][i] = min(mnb[j - 1][i], mnb[j - 1][i + (1<<(j-1))]);
    }
  int m, l, r;
  cin >> m;
  for (int i = 0; i < m; i++)
  {
    scanf("%d%d", &l, &r);
    l--, r--;
    if (getMxA(l, r).f == getMnA(l, r).f || getMxB(l, r).f == getMnB(l, r).f)
    {
      printf("0 0\n");
      continue;
    }
    printf("%d %d\n", getMxA(l, r).s + 1,  getMnA(l, r).s + 1);
  }
/*
4
2 2
1 2
1 3
2 3
2
2 3
2 4

5
1 3
2 4
1 2
1 2
2 2
*/
  return 0;
}
