#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define FILE_NAME "theatre"
typedef long long ll;
typedef pair <int, int> pii;
typedef unsigned int uint;
const int T = 320;
const int K = 32;
const int N = 1e4 + 5;

uint a[N][T];
int n, m, ans[N], cnt[N], play[N], noPlay[N];
int use[N];

void add(int i, int j)
{
  j--;
  int w = j / K;
  int bit = j % K;
  a[i][w] |= (1LL<<bit);
}
void del(int i, int j)
{
  j--;
  int w = j / K;
  int bit = j % K;
  a[i][w] ^= (1LL<<bit);
}
bool tr(int i, int j)
{
  j--;
  int w = j / K;
  int bit = j % K;
  return (a[i][w]>>bit)%2;
}
int main()
{
  freopen(FILE_NAME".in", "r", stdin);
  freopen(FILE_NAME".out", "w", stdout);
  cin >> n >> m;
  for (int i = 1; i <= n; i++)
    for (int j = 1; j <= n; j++)
    {
      add(i, j);
      cnt[i]++;
    }
  for (int step = 1; step <= m; step++)
  {
    int ki;
    scanf("%d", &ki);
    for (int i = 1; i <= ki; i++)
    {
      scanf("%d", &play[i]);
      use[play[i]] = step;
    }
    int nki = 0, v, to;
    for (int j = 1; j <= n; j++)
      if (use[j] != step) noPlay[++nki] = j;

    for (int i = 1; i <= ki; i++)
      for (int j = 1; j <= nki; j++)
      {
        v = play[i];
        to = noPlay[j];
        if (tr(v, to))
        {
          del(v, to);
          del(to, v);
          cnt[v]--;
          cnt[to]--;
          if (!ans[v] && cnt[v] == 1) ans[v] = step;
          if (!ans[to] && cnt[to] == 1) ans[to] = step;
        }
      }
  }
  for (int i = 1; i <= n; i++)
    cout << ans[i] << " ";
  /*
  3 3
  2 1 2
  2 3 2
  2 1 2

  5 3
  3 1 2 3
  3 2 3 1
  2 1 3

  4 3
  1 1
  1 3
  1 2

  5 4
  3 1 2 3
  3 1 2 4
  2 1 3
  2 2 4
  3 3 2 2 2
  */
  return 0;
}
