#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>
 
#define N 200100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "password"
 
using namespace std;
 
char s1[N], s2[N];
int n, m, k, cs[N]; 
int ans[N][2], t; 

int main()
{
    freopen (FILE_NAME".in", "r", stdin);
    freopen (FILE_NAME".out", "w", stdout);
 
    gets(s1 + 1);
    n = strlen(s1 + 1);
    
    gets(s2 + 1);
    m = strlen(s2 + 1);
 
    k = n - m + 1;
    int cnum;
 
    for (int i = 1; i <= k; i++)
        cs[1] += (int)(s1[i] - '0');
 
    for (int i = 2; i <= m; i++)
        cs[i] = cs[i - 1] + (int)(s1[i + k - 1] - '0') - (int)(s1[i - 1] - '0');                        
 
    for (int i = m; i >= 1; i--)
    {       
        cnum = 0;
 
        for (int j = i; j <= min(i + 7, m); j++)
        {
            cnum = cnum * 10 + (int)(s2[j] - '0');
 
            if (cnum > 0 && (int)(s2[i] - '0') == 0)
                break;
         
            if (cnum == cs[i])
            {          
                t++;
                ans[t][0] = i, ans[t][1] = j + k - 1;
            }
 
            cs[i] += (int)(s1[j + k] - '0');
        }                       
                                 
    }   


    printf ("%d %d\n", ans[(t + 1) / 2][0], ans[(t + 1) /2][1]);

    return 0;
}