#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cctype>

#define N 200100
#define M 1010
#define eps 1e-9
#define inf (int)1e9 + 1
#define FILE_NAME "password"

using namespace std;

char s1[N], s2[N];
int n, m, k, cs[N]; 

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	gets(s1 + 1), n = strlen(s1 + 1);
	gets(s2 + 1), m = strlen(s2 + 1);

	k = n - m + 1;
	int cnum;

	for (int i = 1; i <= k; i++)
		cs[1] += (int)(s1[i] - '0');

	for (int i = 2; i <= n - k + 1; i++)
		cs[i] = cs[i - 1] + (int)(s1[i + k - 1] - '0') - (int)(s1[i - 1] - '0');		         		

	for (int i = 1; i <= n - k + 1; i++)
	{		
		cnum = 0;

		if (s2[i] == '0')
			continue;

		for (int j = i; j <= min(i + 8, m); j++)
		{
			cnum = cnum * 10 + (int)(s2[j] - '0');
			if (cnum == cs[i])
			{
				printf ("%d %d\n", i, j + k - 1);
				return 0;
			}

			cs[i] += (int)(s1[j + k] - '0');
		}	                    
								
	}	

	return 0;
}
