#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "mosaic"

using namespace std;

typedef long long ll;

int x[N], y[N], n, k;
int cx[N], cy[N], l, r, lastx, lasty;

bool check(int i, int j)
{
	return (x[i] != x[j] && y[i] != y[j]);
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j;

	scanf ("%d", &n);
	for (i = 1; i <= n; i++)
		scanf ("%d %d", &x[i], &y[i]);

	for (i = n; i > 0; i--)
	{
		if (x[i] == x[i + 1])
			cx[i] = cx[i + 1] + 1;
		else
			cx[i] = 1;		

		if (y[i] == y[i + 1])
			cy[i] = cy[i + 1] + 1;
		else
			cy[i] = 1;

		//cerr << cx[i] << ' ' << cy[i] << endl;
	}

	scanf ("%d", &k);

	int lastx, lasty;
	bool out;

	for (i = 1; i <= k; i++)
	{
		scanf ("%d %d", &l, &r);

		lastx = l + cx[l];
		lasty = l + cx[l];

		if (lastx <= r && lasty <= r)
		{
			if (lastx == lasty)
				lasty = l;

			if (check(lastx, lasty))
				printf ("%d %d\n", lastx, lasty);

			else if (check(l, lastx))
				printf ("%d %d\n", l, lastx);

			else
				printf ("%d %d\n", l, lasty);				
		}

		else
			printf ("0 0\n");	
	}	

	return 0;
}