#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "theatre"

using namespace std;

typedef long long ll;

int n, m, k;
int cnt[N], cur, cc[N], ans[N];

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j;

	scanf ("%d %d", &n, &m);

	cc[N - 1] = 2;
	for (i = 1; i <= m; i++)
	{
		scanf ("%d", &k);

		for (j = 1; j <= k; j++)
		{
			scanf ("%d", &cur);
			if (ans[cur] == 0)
				cnt[cur]++;		
		}

		for (j = 0; j < m; j++)
			cc[j] = 0;

		for (j = 1; j <= n; j++)
		{
			cc[cnt[j]]++;
			//cerr << cnt[j] << ' ';
		}
		//cerr << endl;
		for (j = 1; j <= n; j++)
			if (cc[cnt[j]] == 1)
			{
				ans[j] = i;
				cnt[j] = N - 1;		
			}				
	}

	for (i = 1; i <= n; i++)
		printf ("%d ", ans[i]);

	return 0;
}