
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>
 
#define N 5100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "theatre"
 
using namespace std;
 
typedef long long ll;
 
int n, m, k;
int cnt[N][N], cur, cc[N][N], ans[N];
 
void check(int an, int ansval)
{
	for (int i = 0; i <= m; i++)
		cc[an][i] = 0;

	for (int i = 1; i <= n; i++)
	{
		//cerr << cnt[an][i] << ' ';
		cc[an][cnt[an][i]]++;
	}
	//cerr << endl;

	bool rec = false;

    for (int i = 1; i <= n; i++)
    	if (cc[an][cnt[an][i]] == 1)
    	{
			ans[i] = ansval;
			rec = true;

    	    for (int j = 1; j <= m; j++)
    	    	cnt[j][i] = N - 1; 			
    	}
    
	if (rec && an > 1)
		check(an - 1, ansval);				
}

int main()
{
    freopen (FILE_NAME".in", "r", stdin);
    freopen (FILE_NAME".out", "w", stdout);
 
    int i, j;
 
    scanf ("%d %d", &n, &m);
 
    for (i = 1; i <= m; i++)
    	cc[i][N - 1] = 2;

    for (i = 1; i <= m; i++)
    {
        scanf ("%d", &k);

        for (j = 1; j <= n; j++)
        	cnt[i][j] = cnt[i - 1][j];
 
        for (j = 1; j <= k; j++)
        {
            scanf ("%d", &cur);
            if (ans[cur] == 0)
                cnt[i][cur]++;     
        }

        check(i, i);
	}
 
    for (i = 1; i <= n; i++)
        printf ("%d ", ans[i]);
 
    return 0;
}