#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 10100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "theatre"

using namespace std;

typedef long long ll;

int n, m, k;
int a[N][N], ans[N];

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j, l, cur;

	scanf ("%d %d", &n, &m);

	for (i = 1; i <= m; i++)
	{
		scanf ("%d", &k);

		for (j = 1; j <= k; j++)
		{
			scanf ("%d", &cur);
			a[cur][0]++;
			a[cur][a[cur][0]] = i;			
		}
	}

	for (i = 1; i <= n; i++)
		for (j = i + 1; j <= n; j++)
		{
			for (l = 1; l <= min(a[i][0], a[j][0]); l++)				
				if (a[i][l] != a[j][l])
					break;

			//cerr << i << ' ' << j << ' ' << l;// << endl;

			if (l > min(a[i][0], a[j][0]) && a[i][0] == a[j][0])
				l = inf;

			else
			{
				//cerr << " type 2 ";
				if (l > a[i][0])
					l = a[j][l];
				
				else if (l > a[j][0])
					l = a[i][l];

				else
					l = min(a[i][l], a[j][l]);				
			}

			//cerr << ' ' << l << endl;
			ans[i] = max(ans[i], l);
			ans[j] = max(ans[j], l);		
		}	

	for (i = 1; i <= n; i++)
		printf ("%d ", ans[i] == inf ? 0 : ans[i]);

	return 0;
}