#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 10100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "theatre"

using namespace std;

typedef long long ll;

int n, m, k;
int ans[N];

class perf{
	public:
		int a[N], num;
};

perf a[N];

bool cmp(const perf &A, const perf &B)
{
	for (int i = 1; i <= min(A.a[0], B.a[0]); i++)
		if (A.a[i] != B.a[i])
			return A.a[i] < B.a[i];

	return A.a[0] < B.a[0];
}

void check(int i, int j)
{
	int l;

	for (l = 1; l <= min(a[i].a[0], a[j].a[0]); l++)				
		if (a[i].a[l] != a[j].a[l])
			break;

	//cerr << i << ' ' << j << ' ' << l;// << endl;

	if (l > min(a[i].a[0], a[j].a[0]) && a[i].a[0] == a[j].a[0])
		l = inf;

	else
	{
		if (l > a[i].a[0])
			l = a[j].a[l];
				
		else if (l > a[j].a[0])
			l = a[i].a[l];

		else
			l = min(a[i].a[l], a[j].a[l]);				
	}

	//cerr << ' ' << l << endl;

	ans[a[i].num] = max(ans[a[i].num], l);
	ans[a[j].num] = max(ans[a[j].num], l);
}	

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j, l, cur;

	scanf ("%d %d", &n, &m);

	for (i = 1; i <= n; i++)
		a[i].num = i;

	for (i = 1; i <= m; i++)
	{
		scanf ("%d", &k);

		for (j = 1; j <= k; j++)
		{
			scanf ("%d", &cur);
			a[cur].a[0]++;
			a[cur].a[a[cur].a[0]] = i;			
		}
	}

	sort (a + 1, a + n + 1, cmp);


	for (i = 1; i < n; i++)
	{
		//printf ("%d ", a[i].num);
		//for (j = i + 1; j <= n; j++)
			check(i, i + 1);
	}

	for (i = 1; i <= n; i++)
		printf ("%d ", ans[i] == inf ? 0 : ans[i]);

	return 0;
}