#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "army"

using namespace std;

typedef long long ll;

int p[M], n, k, a[M], was[M];
int ans, d[M], position[M];

void check()
{
	for (int i = 1; i <= k; i++)
		if (position[a[i]] < position[a[i - 1]])
			return;

	for (int i = 1; i <= n; i++)
		d[i] = 0;

	int cmax = -1;
	for (int i = 1; i <= n; i++)
	{
		for (int j = i - 1; j >= 0; j--)
			if (p[j] < p[i])
				d[i] = max(d[i], d[j] + 1), cmax = max(cmax, d[i]);				
	}

	if (d[position[a[k]]] != cmax || d[position[a[k]]] != k)
		return ;


	/*for (int i = 1; i <= n; i++)
		cout << p[i] << ' ';
	cout << endl;						
	*/
	ans++;		
}

void rec(int pos)
{
	if (pos > n)
	{
		check();
		return ;
	}

	for (int i = 1; i <= n; i++)
		if (!was[i])
		{
			p[pos] = i;
			was[i] = 1;
			position[i] = pos;
			rec (pos + 1);
			was[i] = 0;
		}
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	scanf ("%d %d", &n, &k);

	for (int i = 1; i <= k; i++)
		scanf ("%d", &a[i]);

	rec(1);

	printf ("%d", ans);

	return 0;
}