#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cassert>

#define N 100100
#define M 1010
#define inf (int)1e9 + 1
#define eps 1e-9
#define FILE_NAME "army"

using namespace std;

typedef long long ll;

int p[M], n, k, a[M], was[M], prg[M], g[M];
int ans, position[M];

void check()
{
	int i, j;
	for (i = 0; i <= k; i++)
	{
		for (j = a[i] + 1; j < a[i + 1]; j++)
			if (position[j] > position[a[i]] && position[j] < position[a[i + 1]])
				return ; 
	}

	/*for (int i = 1; i <= n; i++)
		cout << p[i] << ' ';
	cout << endl;						
	*/
	ans++;		
}

void rec(int pos)
{
	if (pos > n)
	{
		check();
		return ;
	}

	int i;
	for (i = 1; i <= n; i++)
	{
		if (g[i] && was[prg[i]] == 0)
			continue;

		if (!was[i])
		{
			p[pos] = i;
			was[i] = 1;
			position[i] = pos;
			rec (pos + 1);
			was[i] = 0;
		}
	}
}

int main()
{
	freopen (FILE_NAME".in", "r", stdin);
	freopen (FILE_NAME".out", "w", stdout);

	int i, j;

	scanf ("%d %d", &n, &k);

	position[0] = 0, position[n + 1] = n + 1;
	a[0] = 0, a[k + 1] = n + 1;
	for (i = 1; i <= k; i++)
		scanf ("%d", &a[i]), g[a[i]] = 1;

	for (i = 1; i <= n; i++)
	{
		if (g[i] == 0)
			continue;

		for (j = 1; j < i; j++)
			if (g[j])
				prg[i] = j;
	}

	was[0] = 1;
	rec(1);

	printf ("%d", ans);

	return 0;
}