program Prob2;

{$APPTYPE CONSOLE}
{$R+}

uses
  SysUtils;

var
  n, i, j, size, free, q: integer;
  a: array[1..2000, 1..2000] of integer;
  m, head: array[1..2000] of integer;
  dest, next: array[1..4000] of integer;
  ans: int64;
  
procedure dfs(u: integer);
var
  i, j, v: integer;
begin
  for i := 1 to size do
    a[m[i], u] := 1;
  inc(size);
  m[size] := u;
  j := head[u];
  while j <> -1 do begin
    v := dest[j];
    dfs(v);
    j := next[j];
  end;
  dec(size);
end;

procedure check(u: integer);
var
  i, j, v: integer;
begin
  for i := 1 to size do
    if a[m[i], u] = 1 then
      inc(ans);
  inc(size);
  m[size] := u;
  j := head[u];
  while j <> -1 do begin
    v := dest[j];
    check(v);
    j := next[j];
  end;
  dec(size);
end;

procedure addedge(x, y: integer);
begin
  dest[free] := y;
  next[free] := head[x];
  head[x] := free;
  inc(free);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  read(n);
  free := 1;
  fillchar(head, sizeof(head), -1);
  for i := 1 to n do begin
    read(q);
    if q = 0 then
      j := i
    else
    addEdge(q, i);
  end;
  size := 0;
  dfs(j);
  free := 1;
  fillchar(head, sizeof(head), -1);
  for i := 1 to n do begin
    read(q);
    if q = 0 then
      j := i
    else
    addEdge(q, i);
  end;
  ans := 0;
  size := 0;
  check(j);
  write(ans);
end.

