program Prob6;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  p = 37;

type
  mass = array[0..100001] of integer;

var
  n, m, i, j, l, k, q: integer;
  prev, next, ans: mass;
  s: array[1..100000] of int64;
  was: boolean;

procedure check(ne, pr: mass);
var
  j, l: integer;
begin
  j := next[0];
  while j <= n do begin
    was := false;
    l := ne[0];
    while l <= n do begin
      if (j <> l) and (s[j] = s[l]) then begin
        was := true;
        ne[pr[l]] := ne[l];
        pr[ne[l]] := pr[l];
      end;
      l := next[l];
    end;
    if was then begin
      ne[pr[j]] := ne[j];
      pr[ne[j]] := pr[j];
    end;
    j := ne[j];
  end;
  j := ne[0];
  while j <= n do begin
    ans[j] := i;
    next[prev[j]] := next[j];
    prev[next[j]] := prev[j];
    j := ne[j];
  end;
end;
begin
  reset(input, 'theatre.in');
  rewrite(output, 'theatre.out');
  read(n, m);
  fillchar(ans, sizeof(ans), 0);
  fillchar(s, sizeof(s), 0);
  for i := 1 to n do begin
    next[i] := i+1;
    prev[i] := i-1;
  end;
  next[0] := 1;
  for i := 1 to m do begin
    read(k);
    for j := 1 to k do begin
      read(q);
      s[q] := s[q]*p + i;
    end;
    check(next, prev);
  end;
  for i := 1 to n do
    write(ans[i], ' ');
end.
 