#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int n;
vector < vector <int> > g(2000);
vector < vector <int> > t(2000);

vector < set <int> > pred1(2000);
vector < set <int> > pred2(2000);

int gone[2000], ptr;

void dfs1(int v)
{

    for(int i = 0; i < ptr; i++)
        pred1[v].insert(gone[i]);
    gone[ptr++] = v;
    for(int i = 0; i < g[v].size(); i++)
        dfs1(g[v][i]);
    ptr--;
}

void dfs2(int v)
{
    for(int i = 0; i < ptr ;i++)
        pred2[v].insert(gone[i]);
    gone[ptr++] = v;
    for(int i = 0; i < t[v].size(); i++)
        dfs2(t[v][i]);
    ptr--;
}

int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);
    cin >> n;
    if( n > 2000) return 0;
    int stA, stB;
    for(int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        if(a!=0)
        {
            a--;
            g[a].push_back(i);
        }
        else
            stA=i;
    }

    for(int i = 0; i < n; i++)
    {
        int b;
        cin >> b;
        if(b != 0)
        {
            b--;
            t[b].push_back(i);
        }
        else
            stB=i;
    }
    dfs1(stA);
    dfs2(stB);
    int ans = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            if(pred1[j].count(i) > 0 && pred2[j].count(i) > 0)
                ans++;
    cout << ans;

    return 0;
}
