#include <iostream>
#include <cstdio>

using namespace std;
pair <int, int> a[5000];
int near[5000];
pair <int, int> tree[5000*4];

void ins(int v, int tl, int tr, int pos, int val)
{
    if(tl == tr) tree[v] = make_pair(pos, val);
    else
    {
        int m = (tl+tr)/2;
        if(pos > m) ins(v*2+1, m+1, tr, pos, val);
        else ins(v*2, tl, m, pos, val);
        pair <int, int> p1, p2;
        p1 = tree[v*2];
        p2 = tree[v*2+1];
        if(p1.second == -1) tree[v] = p2;
        else tree[v] = p1;
    }
}

pair <int, int> get(int v, int tl, int tr, int l, int r)
{
    if(l > r) return make_pair(-1, -1);
    if(tl == l && tr == r) return tree[v];
    else
    {
        pair <int, int> p1, p2;
        int m = (tl + tr)/2;
        p1 = get(v*2, tl, m, l, min(m, r));
        p2 = get(v*2 + 1, m+1, tr, max(m+1, l), r);
        if(p1.second == -1) return p2;
        else return p1;
    }
}
int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    int n, k;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        int q, p;
        cin >> p >> q;
        a[i] = make_pair(p, q);
    }
    for(int i = 0; i < n; i++)
    {
        ins(1, 0, n-1, i, -1);
        for(int j = i+1; j < n; j++)
            if(a[i].first != a[j].first && a[i].second != a[j].second)
            {
                near[i] = j;
                ins(1, 0, n-1, i, j);
                break;
            }
    }
    cin >> k;
    for(int i = 0; i < k; i++)
    {
        int l, r;
        cin >> l >> r;l--, r--;

        pair <int, int> u = get(1, 0, n-1, l, r);
        if(n <= 100 && k <= 100)
        {
            for(int j = l; j <= r; j++)
                for(int p = j+1; p <= r; p++)
                if(a[j].first != a[p].first && a[j].second != a[p].second)
            {
                cout << j+1 << ' ' << p+1 << endl;
                goto nex;
            }
            cout << "0 0\n";
        }
        if(u.second <= r && u.second != -1)
        {
            cout << u.first+1 << ' ' << u.second+1 << endl;
        }
        else cout << "0 0\n";
        nex:;
    }
}
