program ProB;

{$APPTYPE CONSOLE}
{$R+O-}

uses
  SysUtils,
  Math;

var n, root1, root2: integer;
tin1, tin2, tout1, tout2: array [1..2000] of integer;
timer: integer;
us1, us2: array [1..2000] of boolean;
g1, g2: array [1..2000] of array of integer;

procedure r1;
var i, x: integer;
begin
  read(n);
  for i := 1 to n do
  begin
    read(x);
    if x <> 0 then
    begin
      setlength(g1[x], length(g1[x]) + 1);
      g1[x][length(g1[x]) - 1] := i;
    end
    else
      root1 := i;
  end;
  for i := 1 to n do
  begin
    read(x);
    if x <> 0 then
    begin
      setlength(g2[x], length(g2[x]) + 1);
      g2[x][length(g2[x]) - 1] := i;
    end
    else
      root2 := i;
  end;
end;

procedure dfs1(v: integer);
var i: integer;
begin
  inc(timer);
  us1[v] := true;
  tin1[v] := timer;
  for i := 0 to length(g1[v]) - 1 do
    if not (us1[g1[v][i]]) then
      dfs1(g1[v][i]);
  inc(timer);
  tout1[v] := timer;
end;

procedure dfs2(v: integer);
var i: integer;
begin
  inc(timer);
  us2[v] := true;
  tin2[v] := timer;
  for i := 0 to length(g2[v]) - 1 do
    if not (us2[g2[v][i]]) then
      dfs2(g2[v][i]);
  inc(timer);
  tout2[v] := timer;
end;

function upper1(x, y: integer): boolean;
begin
  upper1 := (tin1[x] > tin1[y]) and (tout1[x] < tout1[y]);
end;

function upper2(x, y: integer): boolean;
begin
  upper2 := (tin2[x] > tin2[y]) and (tout2[x] < tout2[y]);
end;

procedure ex1;
var i, j, ans: integer;
begin
  timer := 0;
  fillchar(us1, sizeof(us1), false);
  fillchar(us2, sizeof(us2), false);
  dfs1(root1);
  timer := 0;
  dfs2(root2);
  ans := 0;
  for i := 1 to n do
    for j := 1 to n do
      if (upper1(i, j)) and (upper2(i, j)) then
        inc(ans);
  write(ans);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  r1;
  ex1;
  close(input);
  close(output);
end.
