#include <fstream>
#include <vector>
#include <iostream>

using namespace std;

ifstream fin("apricot.in");
ofstream fout("apricot.out");

const int INF = 1e9;
int r, u, n;
vector<int> d;
void Read()
{
	fin >> n >> r >> u;
	return;
}

void init()
{
	d.resize(n + 5, 0);
	return;
}

void relax(int i)
{
	int pans1 = INF;
	if(i % 2 == 0)
		pans1 = min(pans1, d[i / 2] + u);
	int j;
	for(j = 1; j <= i / 2; ++j)
		pans1 = min(pans1, max(d[j] + u, d[i - 2*j] + r));
	for(; j < min(i, n / 2); ++j)
		pans1 = min(pans1, d[j] + u);
	d[i] = pans1;
	return;
}

void Solve()
{
	init();
	for(int i = 2; i <= n; ++i)
		relax(i);
	return;
}

void Print()
{
	fout << d[n];
	return;
}


int main()
{
	Read();
	Solve();
	Print();
	return 0;
}