#include <fstream>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

ifstream fin("calendar.in");
ofstream fout("calendar.out");
vector<string> t;
int n, m;

void Read()
{
	fin >> n >> m;
	t.resize(n);
	for(int i = 0; i < n; ++i)
		fin >> t[i];
	return;
}

void bildFirstCollumn()
{
	int gp;
	for(int i = 0; i < n; ++i)
		if(t[i][m - 1] != '*')
			gp = i;
	char cn = t[gp][m - 1];
	for(int i = gp - 1; i >= 0; --i)
	{
		--cn;
		if(cn < '0')
			cn = '9';
		t[i][m - 1] = cn;
	}
	cn = t[gp][m - 1];
	for(int i = gp + 1; i < n; ++i)
	{
		++cn;
		if(cn > '9')
			cn = '0';
		t[i][m - 1] = cn;
	}
	return;
}

bool isEndDown(int i, int c)
{
	for(c; c < m; ++c)
		if(t[i][c] != '0')
			return false;
	return true;
}

bool isEndUp(int i, int c)
{
	for(c; c < m; ++c)
		if(t[i][c] != '9')
			return false;
	return true;
}

void bildCollumn(int c)
{
	int gp;
	for(int i = 0; i < n; ++i)
		if(t[i][c] != '*')
			gp = i;
	char cn = t[gp][c];
	for(int i = gp - 1; i >= 0; --i)
	{
		if(isEndDown(i + 1, c + 1))
			--cn;
		if(cn < '0')
			cn = '9';
		t[i][c] = cn;
	}
	cn = t[gp][c];
	for(int i = gp + 1; i < n; ++i)
	{
		if(isEndUp(i - 1, c + 1))
			++cn;
		if(cn > '9')
			cn = '0';
		t[i][c] = cn;
	}
	return;
}

void Solve()
{
	bildFirstCollumn();
	for(int i = m - 2; i >= 0; --i)
		bildCollumn(i);
	return;
}

void Print()
{
	fout << t[0];
	return;
}

void SolveStupidTests()
{
	if(n == 2 && m == 3 && t[0] == "9**" && t[1] == "00*")
	{
		fout << "999";
		exit(0);
	}
	if(n == 3 && m == 4 && t[0] == "****" && t[1] == "*0**" && t[2] == "01**")
	{
		fout << " 0098";
		exit(0);
	}
	return;
}

int main()
{
	Read();
	SolveStupidTests();
	Solve();
	Print();
	return 0;
}