#include <fstream>
#include <set>
#include <vector>
using namespace std;

ifstream fin("theatre.in");
ofstream fout("theatre.out");

vector<set<int> > t;
vector<int> ans;
vector<bool> onSt;
int n, m;
void Read()
{
	fin >> n >> m;
	ans.resize(n, 0);
	t.resize(n);
	return;
}

void add(int a, bool st)
{
	for(int i = 0; i < n; ++i)
	{
		if(st != onSt[i])
			t[i].insert(a);
	}
	return;
}

void relax()
{
	for(int i = 0; i < n; ++i)
	{
		add(i, onSt[i]);
	}
	return;
}

void SolveCb()
{
	int k;
	for(int i = 0; i < m; ++i)
	{
		fin >> k;
		onSt.clear();
		onSt.resize(n, false);
		int a;
		for(int j = 0; j < k; ++j)
		{
			fin >> a;
			onSt[a - 1] = true;
		}
		relax();
		for(int j = 0; j < n; ++j)
		{
			if(ans[j] == 0 && t[j].size() == n - 1)
				ans[j] = i + 1;
		}
	}
	return;
}

void Print()
{
	for(int i = 0; i < n; ++i)
		fout << ans[i] << " ";
	return;
}

int main()
{
	Read();
	SolveCb();
	Print();
	return 0;
}