#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
ifstream fin("army.in");
ofstream fout("army.out");
int n, m;
vector<int> k, t, last;
vector<int> d;
set<int> ks;
int ans;
inline void Read()
{
	fin >> n >> m;
	k.resize(m);
	for(int i = 0; i < m; ++i)
	{	
		fin >> k[i];
		ks.insert(k[i]);
	}
	t.resize(n);
	last.resize(n);
	for(int i = 0; i < n; ++i)
		t[i] = i + 1;
	for(int i = n; i >= 1; --i)
		last[n - i] = i;
	return;
}

inline bool haveOtr()
{
	int cp = 0;
	for(int i = 0; i < n; ++i)
	{
		if(ks.count(t[i]))
		{
			if(t[i] != k[cp])
				return false;
			cp++;
		}
	}
	return true;
}

inline void relax(int cp)
{
	int pans = 1;
	for(int i = 0; i < cp; ++i)
		if(t[cp] > t[i])
			pans = max(pans, d[i] + 1);
	d[cp] = pans;
	return;
}

inline int getMaxLenOtr()
{
	d.clear();
	d.resize(n);
	d[0] = 1;
	for(int i = 1; i < n; ++i)
		relax(i);
	int ans = -1;
	for(int i = 0; i < n; ++i)
		ans = max(ans, d[i]);
	return ans;
}

inline bool isGood()
{
	bool gp1 = haveOtr();
	if(!gp1)
		return false;
	int maxLenOtr = getMaxLenOtr();
	return (gp1 && maxLenOtr <= m);
}

void SolveSlow()
{
	if(m == n)
	{
		ans = 1;
		return;
	}
	sort(k.begin(), k.end());
	while(t != last)
	{
		next_permutation(t.begin(), t.end());
		ans += isGood();
	}
	return;
}

void Print()
{
	fout << ans;
	return;
}

int main()
{
	Read();
	//if (n < 9)
		SolveSlow();
	//else
		//Solve();
	Print();
	return 0;
}