program Z1;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

var
  currsumA, currsumB : Integer;
  l, r, dl, dr : Integer;
  a, b : string;
  borderL, borderR : Integer;
  f : boolean;

procedure FindMinimalBorders;
begin
  l := 1;
  dl := 1;
  r := length(a);
  dr := length(b);
  while (l < length(b)) and (a[l] = b[l]) do begin
    l := l + 1;
    dl := dl + 1;
  end;
  while (r > 1) and (dr > 1) and (dr > dl) and (r > l) and (a[r] = b[dr]) do begin
    r := r - 1;
    dr := dr - 1;
  end;
end;

function getSum(str: string) : Integer;
var
  i : Integer;
begin
  Result := 0;
  for i := 1 to length(str) do
    Result := Result + (ord(str[i]) - 48);
end;

procedure TestMatch;
var
  w : boolean;
begin
  if f then Exit;
  if (currsumA = currsumB) then begin
    borderL := l;
    borderR := r;
    f := true;
    Exit;
  end;
  if l > 1 then begin
    l := l - 1;
    dl := dl - 1;
    currsumA := currsumA + (ord(a[l]) - 48);
    currsumB := currsumB + (ord(b[dl]) - 48) * round(power(10, dr - dl));
    TestMatch;
    currsumA := currsumA - (ord(a[l]) - 48);
    currsumB := currsumB - (ord(b[dl]) - 48) * round(power(10, dr - dl));
    l := l + 1;
    dl := dl + 1;
  end;
  if r < length(a) - 1 then begin
    r := r + 1;
    w := false;
    if (dr < length(b)) then begin
      dr := dr + 1;
      currsumB := currsumB + (ord(b[dr]) - 48) * 10;
      w := true;
    end;
    currsumA := currsumA + (ord(a[r]) - 48);
    TestMatch;
    currsumA := currsumA - (ord(a[r]) - 48);
    if w then begin
      dr := dr - 1;
      currsumB := currsumB - (ord(b[dr]) - 48) * 10;
    end;
    l := l - 1;
  end;
end;

begin
  Assign(input, 'password.in');
  Assign(output, 'password.out');
  borderL := -1;
  borderR := -1;
  Reset(input);
  Rewrite(output);
  ReadLn(a);
  ReadLn(b);
  if (length(a) = length(b)) and (a = b) then begin
    WriteLn('1 1');
    Exit;
  end;
  f:= false;
  FindMinimalBorders;
  currsumA := getSum(Copy(a, l, r - l + 1));
  currsumB := StrToInt(Copy(b, dl, dr - dl + 1));
  TestMatch;
  WriteLn(borderL, ' ', borderR);
  Close(input);
  Close(output);
end.
