program Z2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Classes;

type
  TMember = class
    Index : Integer;
    DarkChilds, LightChilds : TList;
    dieNumber : Integer;
    lieNumber : Integer;
    sPars : Integer;
    procedure CountSPars;
    function haveLightChild(aMember : TMember) : boolean;
    function haveDarkChild(aMember : TMember) : boolean;
    constructor Create(aIndex : Integer);
  end;

procedure TMember.CountSPars;
var
  i, f : Integer;
begin
  for i := 0 to LightChilds.Count - 1 do
    if DarkChilds.IndexOf(LightChilds[i]) <> -1 then begin
      sPars := sPars + 1 + TMember(LightChilds[i]).sPars;
    end;
end;

function TMember.haveLightChild(aMember : TMember) : boolean;
var
  i : Integer;
begin
  Result := false;
  if (LightChilds.IndexOf(aMember) <> - 1) then Result := true else
  for i := 0 to LightChilds.Count - 1 do begin
    Result := TMember(LightChilds[i]).haveLightChild(aMember);
    if Result then
      Exit;
  end;
end;

function TMember.haveDarkChild(aMember : TMember) : boolean;
var
  i : Integer;
begin
  Result := false;
  if (DarkChilds.IndexOf(aMember) <> - 1) then Result := true else
  for i := 0 to DarkChilds.Count - 1 do begin
    Result := TMember(DarkChilds[i]).haveDarkChild(aMember);
    if Result then
      Exit;
  end;
end;

constructor TMember.Create(aIndex : Integer);
begin
  inherited Create;
  LightChilds := TList.Create;
  DarkChilds := TList.Create;
  Index := aIndex;
  sPars := 0;
end;

var
  light: TMember;
  dark : TMember;
  members : TList;
  n : Integer;
  i, t, mdn, mln, res: Integer;
begin
  Assign(input, 'virus.in');
  Reset(input);
  Assign(output, 'virus.out');
  Rewrite(output);
  members := TList.Create;
  ReadLn(n);
  mdn := 0;
  mln := 0;
  for i := 0 to n - 1 do
    members.Add(TMember.Create(i));
  for i := 0 to n - 1 do begin
    Read(t);
    if (t = 0) then begin
      light := members[i];
      light.lieNumber := 0;
     end else begin
      TMember(members[t - 1]).LightChilds.Add(members[i]);
      TMember(members[i]).lieNumber := TMember(members[t - 1]).lieNumber + 1;
      if TMember(members[i]).lieNumber > mln then
        mln := TMember(members[i]).lieNumber;
     end;
  end;
  ReadLn;
  for i := 0 to n - 1 do begin
    Read(t);
    if (t = 0) then begin
      dark := members[i];
      dark.dieNumber := 0;
     end else begin
      TMember(members[t - 1]).DarkChilds.Add(members[i]);
      TMember(members[i]).dieNumber := TMember(members[t - 1]).dieNumber + 1;
      if TMember(members[i]).dieNumber > mdn then
        mdn := TMember(members[i]).dieNumber;
     end;
  end;
  res := 0;
  for i := 0 to members.Count - 1 do
    for n := 0 to members.Count - 1 do
      if (TMember(members[i]).haveLightChild(TMember(members[n]))) and (TMember(members[i]).haveDarkChild(TMember(members[n]))) then
        res := res + 1;
  WriteLn(res);
end.
