program Z5;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

type
  TA = array of TPoint;

  TNote = class
    L, R : Integer;
    Widthes, Heights : TA;
    updated : boolean;
  end;

var
  n, k, i, l1, r1, x, y, j, u : Integer;
  Notes : array of TNote;
  points, vta1, vta2 : TA;
  f : boolean;
  rr, ll : Integer;

procedure Update(ind : Integer); forward;
procedure getSum(ind, l, r : Integer; var arrW, arrH : TA); forward;

procedure AddATB(var a : TA; var b : TA);
var
  e, g : Integer;
  ff : boolean;
begin
  for e := 0 to length(a) - 1 do begin
    ff := false;
    for g := 0 to length(b) - 1 do
      if a[e].X = b[g].X then begin
        b[g].Y := b[g].Y + a[e].Y;
        ff := true;
        break;
      end;
    if not ff then begin
      SetLength(b, length(b) + 1);
      b[length(b) - 1].X := a[e].X;
      b[length(b) - 1].Y := a[e].Y;
    end;
  end;
end;

procedure BuildOne(ind, l, r : Integer);
begin
  Notes[ind - 1] := TNote.Create;
  Notes[ind - 1].updated := false;
  SetLength(Notes[ind - 1].Widthes, 0);
  SetLength(Notes[ind - 1].Heights, 0);
  Notes[ind - 1].L := l;
  Notes[ind - 1].R := r;
  if (l <> r) then begin
    BuildOne(ind * 2, l, (l + r) div 2);
    BuildOne(ind * 2 + 1, (l + r) div 2 + 1, r);
  end else begin
    SetLength(Notes[ind - 1].Widthes, 1);
    SetLength(Notes[ind - 1].Heights, 1);
    Notes[ind - 1].Widthes[0].X := points[l - 1].X;
    Notes[ind - 1].Widthes[0].Y := 1;
    Notes[ind - 1].Heights[0].X := points[l - 1].Y;
    Notes[ind - 1].Heights[0].Y := 1;
    Notes[ind - 1].updated := true;
  end;
end;

procedure Build;
var
  ind : Integer;
begin
  ind := 1;
  BuildOne(ind, 1, n);
  Update(ind);
end;

procedure Update(ind : Integer);
var
  tarr1, tarr2 : TA;
  t, z : Integer;
begin
  SetLength(tarr1, 0);
  SetLength(tarr2, 0);
  getSum(ind * 2, Notes[ind * 2 - 1].L, Notes[ind * 2 - 1].R, tarr1, tarr2);
  AddATB(tarr1, Notes[ind - 1].Widthes);
  AddATB(tarr2, Notes[ind - 1].Heights);
  SetLength(tarr1, 0);
  SetLength(tarr2, 0);
  getSum(ind * 2 + 1, Notes[ind * 2].L, Notes[ind * 2].R, tarr1, tarr2);
  AddATB(tarr1, Notes[ind - 1].Widthes);
  AddATB(tarr2, Notes[ind - 1].Heights);
  Notes[ind - 1].updated := true;
end;

procedure getSum(ind, l, r : Integer; var arrW, arrH : TA);
var
  tarr1, tarr2 : TA;
  z, t : Integer;
begin
  if (Notes[ind - 1].L = l) and (Notes[ind - 1].R = r) and (Notes[ind - 1].updated) then begin
    arrW := Notes[ind - 1].Widthes;
    arrH := Notes[ind - 1].Heights;
  end else
  if (Notes[ind - 1].L = l) and (Notes[ind - 1].R = r) and (not Notes[ind - 1].updated) then begin
    Update(ind);
  end else
  if (l >= Notes[ind * 2 - 1].L) and (r <= Notes[ind * 2 - 1].R) then begin
    SetLength(tarr1, 0);
    SetLength(tarr2, 0);
    getSum(ind * 2, l, r, tarr1, tarr2);
    AddATB(tarr1, arrW);
    AddATB(tarr2, arrH);
  end else
  if (l >= Notes[ind * 2].L) and (r <= Notes[ind * 2].R) then begin
    SetLength(tarr1, 0);
    SetLength(tarr2, 0);
    getSum(ind * 2 + 1, l, r, tarr1, tarr2);
    AddATB(tarr1, arrW);
    AddATB(tarr2, arrH);
  end else
  if (l >= Notes[ind * 2 - 1].L) and (r > Notes[ind * 2 - 1].R) then begin
    SetLength(tarr1, 0);
    SetLength(tarr2, 0);
    getSum(ind * 2, l, Notes[ind * 2 - 1].R, tarr1, tarr2);
    AddATB(tarr1, arrW);
    AddATB(tarr2, arrH);
    SetLength(tarr1, 0);
    SetLength(tarr2, 0);
    getSum(ind * 2 + 1, Notes[ind * 2].L, r, tarr1, tarr2);
    AddATB(tarr1, arrW);
    AddATB(tarr2, arrH);
  end;
end;

begin
  Assign(input, 'mosaic.in');
  Assign(output, 'mosaic.out');
  Reset(input);
  Rewrite(output);
  ReadLn(n);
  //SetLength(Notes, 4 * n);
  SetLength(points, n);
  for i := 0 to n - 1 do
    ReadLn(points[i].X, points[i].Y);
  ReadLn(k);
  //Build;
  for i := 0 to k - 1 do begin
    ReadLn(l1, r1);
    f := false;
    for ll := l1 - 1 to r1 - 1 do begin
      for rr := l1 - 1 to r1 - 1 do begin
        if (points[ll].X <> points[rr].X) and (points[ll].Y <> points[rr].Y) then begin
          f := true;
          break;
        end;
      end;
      if f then break;
    end;
    if f then
      WriteLn(ll + 1, ' ', rr + 1) else
      WriteLn('0 0');
    end;
    {SetLength(vta1, 0);
    SetLength(vta2, 0);
    f := false;
    rr := 0;
    ll := 0;
    getSum(1, l1, r1, vta1, vta2);
    for x := l1 - 1 to r1 - 1 do begin
      for y := 0 to length(vta1) - 1 do
        if (vta1[y].X = points[x].X) and (vta1[y].Y = 1) then begin
          for j := 0 to length(vta2) - 1 do
            if (vta2[j].X = points[x].Y) and (vta2[j].Y = 1) then begin
              f := true;
              ll := x + 1;
              for rr := l1 -1 to r1 - 1 do begin
                if (points[rr].X <> points[x].X) and (points[rr].Y <> points[x].Y) then
                  break;
              end;
            end;
          if f then break;
        end;
      if f then begin
        WriteLn(ll, ' ', rr);
        break;
      end;
    end;
    if (rr = 0) then
      WriteLn('0 0');   }
end.
 