{$APPTYPE CONSOLE}
//{$DEFINE DEBUG}

uses
  SysUtils, Math;

type int = longint;
     integer = longint;

type pair = record
	fs,sc : int;
end;

const PROBLEMNAME = 'apricot';
const eps = 1e-7;
const inf : int64 = 1000000000000000000;
const MAXN = 1000*100;

var a : array [1..MAXN] of int;
	n,m : int;

procedure sort(l,r: longint);
  function less(a,b : int) : boolean;
  begin
    less := a < b;
  end;
var
   i,j : int;
   x,y : int;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2];
  repeat
    while a[i]<x do inc(i);
    while x<a[j] do dec(j);
    if i <= j then
      begin
        y:=a[i];
        a[i]:=a[j];
        a[j]:=y;
        inc(i);
        j:=j-1;
      end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure debug(s : string);
begin
{$IFDEF DEBUG} writeln(s) {$ENDIF}
end;

procedure answer(s : string);
begin
	writeln(s);
	halt;
end;

procedure answer_int(s : int64);
begin
	writeln(s);
	halt;
end;

var
	i,j,k,q,u,r : int;
	t1,t2,t3,t4,t5,t6,t7,t8,t9 : int;
	ans : int64;

  dp : array [0..1000000] of int64;

begin
  if PROBLEMNAME <> '' then
    begin
	  assign(input, PROBLEMNAME + '.in'); reset(input);
	  assign(output, PROBLEMNAME + '.out'); rewrite(output);
	end;
  {$IFDEF DEBUG}
  while not eof do
  begin
  {$ENDIF}
  read(n,r,u);
  {$IFDEF DEBUG}
  fillchar(dp, sizeof(dp), 0);
  {$ENDIF}
  dp[0] := 0;
  dp[1] := 0;
  dp[2] := u;
  for i := 3 to n do
    begin
      dp[i] := inf;
      for j := 1 to i div 2 do
        if 2*j = i then
          dp[i] := min(dp[i], dp[j] + u)
        else
          dp[i] := min(dp[i], max(dp[j] + u, dp[i-2*j] + r));
 //     if i mod 3 = 0 then
 //       begin
 //         dp[i] := dp[i div 3] + max(u,r);
 //       end;
 //     if i mod 3 = 1 then
 //       begin
 //         dp[i] := max(dp[i div 3] + u, dp[i div 3 + 1] + r);
 //       end;
 //     if i mod 3 = 2 then
 //       begin
 //         dp[i] := max(dp[i div 3 + 1] + u, dp[i div 3] + r);
 //       end;
 //
 //     if i mod 2 = 0 then
 //       begin
 //         dp[i] := min(dp[i], dp[i div 2] + u);
 //       end;
    end;
  writeln(dp[n]);
  {$IFDEF DEBUG}
  end;
  {$ENDIF}
end.
