#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;

const int maxn = 1000005;
const long long inf = 1LL << 50;

long long dp[maxn];

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	int n;
	long long eqcost, diffcost;
	cin >> n >> eqcost >> diffcost;

	dp[0] = dp[1] = 0;
	dp[2] = diffcost;
	dp[3] = max(eqcost, diffcost);

	for (int i = 4; i <= n; ++i)
	{
		dp[i] = inf;
		for (int j = 1; j+j <= i; ++j)
			dp[i] = min(dp[i], max(j+j==i ? -1 : eqcost + dp[i-j-j], diffcost + dp[j]));
	}

	cout << dp[n] << endl;

	return 0;
}