#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
using namespace std;

const int maxn = 1000005;
const long long inf = 1LL << 50;

long long dp[maxn], diffcost, eqcost;
int cnt = 0;

vector< pair<int, int> > st;
void ans(int n)
{
	st.push_back(make_pair(0, n));
	while (!st.empty())
	{
		int type = st.back().first;
		int v = st.back().second;
		st.pop_back();
		if (type == 0 && dp[v] == inf)
		{
			st.push_back(make_pair(1, v));
			for (int j = 1; j+j <= v; ++j)
			{
				if (dp[j] == inf)
					st.push_back(make_pair(0, j));
				if (j+j != v && dp[v-j-j] == inf)
					st.push_back(make_pair(0, v-j-j));
			}
		}
		if (type == 1)
		{
			for (int j = 1; j+j <= v; ++j)
				dp[v] = min(dp[v], max( (j+j==v ? -1 : eqcost + dp[v-j-j]) , diffcost + dp[j]));
		}
	}
}

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	int n;
	cin >> n >> eqcost >> diffcost;

	dp[0] = dp[1] = 0;
	dp[2] = diffcost;
	dp[3] = max(eqcost, diffcost);

	for (int i = 4; i <= n; ++i)
		dp[i] = inf;

	ans(n);
	cout << dp[n] << endl;
//	cout << cnt << endl;
//	cout << inf << endl;

	return 0;
}