
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
 
const int maxn = 2005;
const long long inf = 1LL << 50;
 
long long dp[maxn];
long long segm[maxn][maxn];
 
int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
 
    int n;
    long long eqcost, diffcost;
    cin >> n >> eqcost >> diffcost;
 
    dp[0] = dp[1] = 0;
	segm[0][0] = segm[0][1] = segm[1][1] = 0;
//    dp[2] = diffcost;
//   dp[3] = max(eqcost, diffcost);
 
    for (int i = 2; i <= n; ++i)
    {
        dp[i] = inf;
        for (int j = 1; j+j <= i; ++j)
		{
			long long here = -1;
			if (j+j != i)
			{
//				for (int k = i-j-j; k < i; ++k)
					here = eqcost + segm[i-j-j][i-1];
			}
//			for (int k = j; k < i; ++k)
				here = max(here, diffcost + segm[j][i-1]);
			dp[i] = min(dp[i], here);
		}
		segm[i][i] = dp[i];
		for (int j = 0; j < i; ++j)
			segm[j][i] = min(dp[i], segm[j][i-1]);
    }
 
    cout << dp[n] << endl;
//	for (int i = 0; i <= n; ++i)
//		cout << dp[i] << ' ';
//	cout << endl;
 
    return 0;
}