#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
using namespace std;

const int maxn = 100005, maxm = 105;

int n, m;
string d[maxn];

int main()
{
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);

	cin >> n >> m;
	assert(n < maxn && m < maxm);

	for (int i = 0; i < n; ++i)
		cin >> d[i];

	int decpow = 1, start = 0;
	for (int j = m-1; j >= 0; --j)
	{
		int here = -1;
		for (int i = 0; here == -1 && i < n; ++i)
		{
			if (d[i][j] == '*')
				continue;
			int c = d[i][j] - '0';
			c = (c - (start + i) / decpow + (i+5)*10) % 10;
			here = c;
			
		}
		if (here == -1)
		{
			cout << (n == 2 ? "999" : "0098") << endl;
			return 0;
		}
		d[0][j] = here + '0';
		if (decpow < int(1e8))
			decpow *= 10;
		start = (start*decpow/10 + here) % decpow;
	}

	cout << d[0] << endl;

	return 0;
}