program P_2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

var l, r, i, j, n, m, k, a1, a2, w : longint;
    a, b, d, q1, q2, d1, d2 : array[1..200000] of longint;
    x, num, ans1, ans2 : array[1..300000] of longint;
    used : array[1..300000] of boolean;
procedure swap(var x, y : longint);
var z : longint;
begin
  z := x;
  x := y;
  y := z;
end;

procedure qsort(l, r : longint);
var w, i, j : longint;
begin
  w := x[(l + r) div 2];
  i := l;
  j := r;
  while i <= j do
    if x[i] < w then
      inc(i)
    else
      if x[j] > w then
        dec(j)
      else
      begin
        swap(x[i], x[j]);
        swap(num[i], num[j]);
        inc(i);
        dec(j);
      end;
  if i < r then qsort(i, r);
  if j > l then qsort(l, j);
end;
begin
  reset(input,'mosaic.in');
  rewrite(output,'mosaic.out');

  read(n);
  for i := 1 to n do
    read(a[i], b[i]);

  {for i := 1 to n do
  begin
    d[i] := 0;
    for j := i - 1 downto 1 do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then
      begin
        d[i] := j;
        break;
      end;
  end; }

  fillchar(d, sizeof(d), 0);
  d1[1] := 0;
  d2[1] := 0;
  for i := 2 to n do
  begin
    if a[i] = a[i - 1] then
      d1[i] := d1[i - 1]
    else
      d1[i] := i - 1;
    if b[i] = b[i - 1] then
      d2[i] := d2[i - 1]
    else
      d2[i] := i - 1;
  end;

  d[1] := 0;
  for i := 2 to n do
  begin
    w := min(d1[i], d2[i]);
    if w = 0 then
      continue;
    if d1[i] = d2[i] then
    begin
      d[i] := w;
      continue;
    end;
    for j := w downto 1 do
      if (a[i] <> a[j]) and (b[i] <> b[j]) then
      begin
        d[i] := j;
        break;
      end;
  end;
  read(m);
  k := 0;
  for i := 1 to m do
  begin
    read(l, r);
    q1[i] := l;
    q2[i] := r;
    inc(k);
    x[k] := l;
    num[k] := i;
    inc(k);
    x[k] := r;
    num[k] := i;
  end;

  if k > 1 then
    qsort(1, k);

  a1 := 0; a2 := 0;
  j := x[1]; l := x[1];
  for i := 1 to k do
  begin
    while j <= x[i] do
    begin
      if d[j] >= l then
      begin
        a1 := j;
        a2 := d[j];
      end;
      inc(j);
    end;

    if used[num[i]] then
    begin
      if (a1 >= q1[num[i]]) and (a2 >= q1[num[i]]) then
      begin
        ans1[num[i]] := a1;
        ans2[num[i]] := a2;
      end;

    end
    else
    begin
      l := x[i];
      used[num[i]] := true;
    end;
  end;
  for i := 1 to m do
    writeln(ans1[i],' ', ans2[i]);
end.
