#pragma comment(linker,"/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;
const int MAX_N = 100005;
vector <int> ga [MAX_N];
vector <int> gb [MAX_N];
int t_in_a[MAX_N];
int t_in_b[MAX_N];
int t_out_a[MAX_N];
int t_out_b[MAX_N];

int t = 0;

void dfs(int v, int t_in[], int t_out[], vector <int> g[])
{
	t_in[v] = ++t;
	for (int i = 0; i < g[v].size(); ++i)
		dfs(g[v][i], t_in, t_out, g);
	t_out[v] = ++t;
}
int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    int N;
	cin >> N;
	for (int i = 1; i <= N; ++i)
	{
		int p;
		cin >> p;
		ga[p].push_back(i);
	}

	for (int i = 1; i <= N; ++i)
	{
		int p;
		cin >> p;
		gb[p].push_back(i);
	}
	dfs(0, t_in_a, t_out_a, ga);
    dfs(0, t_in_b, t_out_b, gb);

	long long ans = 0;
	for (int u = 1; u <= N; ++u)
		for (int v = u + 1; v <= N; ++v)
			if (((t_in_a[v] < t_in_a[u]) && (t_in_b[v] < t_in_b[u]) && (t_out_a[v] > t_out_a[u]) && (t_out_b[v] > t_out_b[u])) ||
				((t_in_a[v] > t_in_a[u]) && (t_in_b[v] > t_in_b[u]) && (t_out_a[v] < t_out_a[u]) && (t_out_b[v] < t_out_b[u])))
				++ans;

	cout << ans << endl;

	return 0;
}