#pragma comment(linker,"/STACK:100000000")

#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 1000005;
long long dp[MAX_N] = {0};
const long long INF = 2000000007;
int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);

    long long N, R, U;
	cin >> N >> R >> U;
	dp[0] = 0;
	dp[1] = 0;
	dp[2] = U;
	for (long long i = 3; i <= N; ++i)
	{
		long long min_s = INF;
		for (long long j = 0; j < i; ++j)
		{
			long long s = INF;
			if ((i - j) % 2 == 0)
			{
				long long su = U + (dp[(i - j)/ 2]);
				long long sr = R + dp[j];
				if (j == 0)
					sr = 0;
				s = max(sr, su);
			}
			if (s < min_s)
				min_s = s;
		}
		dp[i] = min_s;
	}
	cout << dp[N] << endl;
    return 0;
}