#pragma comment(linker, "/STACK:100000000")
#include <cstdio>
#include <cmath>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int MAX_N = 100005;
int a[MAX_N] = {0};
int b[MAX_N] = {0};
int binsearch(int L, int R, int x, int c[MAX_N])
{
	int l = L;
	int r = R;
	while ((r - l) > 1)
	{
		int m = (l + r + 1) / 2;
		if (c[m] < x)
			l = m;
		else
			r = m;
	}
	return r;
}

int main()
{
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

	int N;
	cin >> N;
	
	int prea = -1;
	int preb = -1;
	for (int n = 1; n <= N; ++n)
	{
		int ta, tb;
		cin >> ta >> tb;
		if (ta == prea)
			a[n] = a[n - 1];
		else
			a[n] = a[n - 1] + 1;
		prea = ta;
		if (tb == preb)
			b[n] = b[n - 1];
		else
			b[n] = b[n - 1] + 1;
		preb = tb;
	}

	int K;
	cin >> K;
	for (int k = 0; k < K; ++k)
	{
		int l, r;
		cin >> l >> r;
		if ((a[l] == a[r]) || (b[l] == b[r]))
			printf("0 0\n");
		else
		{
			int an1 = binsearch(l, r, a[l] + 1, a);
			int bn1 = binsearch(l, r, b[l] + 1, b);
			if (an1 == bn1)
				printf("%d %d\n", l, an1);
			if (an1 > bn1)
			{
				bn1 = binsearch(l - 1, r, b[an1] - 1, b);
				printf("%d %d\n", bn1, an1);
			}
			else
			{
				an1 = binsearch(l - 1, r, a[bn1] - 1, a);
				printf("%d %d\n", bn1, an1);
			}
		}
	}

    return 0;
}