#include <iostream>
#include <math.h>
#include <vector>


using namespace std;

#define ll long long

const int maxn=100100;

int n,v1,v2;
ll ans=0;
vector<int> e1[maxn],e2[maxn];
vector<int> s;
pair<int,int> p[maxn];


void reading() {
	//scanf("%d",&n);
	cin >> n;
	for (int i=0; i<n; i++) {
		int x;
		//scanf("%d",&x);
		cin >> x;
		if (x==0) 
			v1=i;
		else
			e1[x-1].push_back(i);
	}
	for (int i=0; i<n; i++) {
		int x;
		//scanf("%d",&x);
		cin >> x;
		if (x==0) 
			v2=i;
		else
			e2[x-1].push_back(i);
	}
}

int t[17*maxn];

void upd(int v, int tl, int tr, int x) {
	if (tl==tr) {
		t[v]=1;
		return;
	}
	int tm=(tl+tr)>>1;
	if (x<=tm)
		upd(v*2,tl,tm,x);
	else 
		upd(v*2+1,tm+1,tr,x);
	t[v]=t[v*2]+t[v*2+1];
}

int get(int v, int tl, int tr, int l, int r) {
	if (l>r) return 0;
	if (l==tl && r==tr) {
		return t[v];
	}
	int tm=(tl+tr)>>1;
	return get(v*2,tl,tm,l,min(r,tm))
		 + get(v*2+1,tm+1,tr,max(l,tm+1),r);
}

void dfs(int v) {
	p[v].first=s.size();
	s.push_back(v);
	for (int i=0; i<e2[v].size(); i++) {
		dfs(e2[v][i]);
	}
	p[v].second=s.size();
	s.push_back(v);
}

void dfs2(int v) {
	for (int i=0; i<e1[v].size(); i++) {
		dfs2(e1[v][i]);
	}
	ans+=get(1,0,2*n-1,p[v].first,p[v].second);
	upd(1,0,2*n-1,p[v].first);
}

int main() {
	freopen("virus.in","r",stdin);
	freopen("virus.out","w",stdout);

	reading();
	dfs(v2);
	dfs2(v1);
	cout << ans;
	return 0;
}