#include <stdio.h>
#include <assert.h>

#define N 100000

const int p10[] = {1, 10, 100, 1000, 10000, 100000, 1000000};

#define MAXLEN 6

char num1[N], num2[N];
int psum[N + 1], dsum[N + 1];

int main(void) {
	int i, j, k;
	int head, tail;
	int l1, l2;
	char c;
	FILE * in, * out;
	in = fopen("password.in", "r");
	i = 0;
	psum[0] = 0;
	while ((c = getc(in)) != '\n') {
		num1[i] = c - '0';
		psum[i + 1] = num1[i] + psum[i];
		i += 1;
	};
	j = 0;
	dsum[0] = 0;
	while ((c = getc(in)) != '\n') {
		num2[j] = c - '0';
		dsum[j + 1] = num2[j] + dsum[j] * 10;
		j += 1;
	};
	fclose(in);
	l1 = i; l2 = j;
	for (head = 0; (head < l1) && (head < l2) && (num1[head] == num2[head]);
			head ++) ;
	for (tail = 0; (tail < l1) && (tail < l2) && (num1[l1 - 1 - tail] ==
				num2[l2 - 1 - tail]); tail ++) ;
	for (i = head; i >= 0; i --) {
		for (j = tail; j >= 0; j --) {
			int len = l2 - i - j;
			if (len <= 0) continue;
			if (len > MAXLEN) { j = -1; break; };
			int sum = psum[l1 - j] - psum[i];
			int dec = dsum[l2 - j] - dsum[i] * p10[len];
			if (sum == dec)
				break;
		};
		if (j >= 0) break;
	};
	out = fopen("password.out", "w");
	fprintf(out, "%d %d\n", i + 1, l1 - j);
	fclose(out);
	return 0;
};
