#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>

#define N 1000000
#define INF INT64_MAX
#define MINF INT64_MIN

int64_t minapri[N + 1];

int64_t inline min(int64_t a, int64_t b) { return (a < b) ? a : b; };
int64_t inline max(int64_t a, int64_t b) { return (a > b) ? a : b; };


int main(void) {
	int n, r, u, i;
	int alow, ahigh, aup, adown;
	FILE * in, * out;
	in = fopen("apricot.in", "r");
	fscanf(in, "%d%d%d", &n, &r, &u);
	fclose(in);
	minapri[1] = 0;
	for (i = 2; i <= n; i ++) {
		minapri[i] = INF;
		for (a = 1; a < (i >> 1); a ++) {
			int64_t val = max(u + minapri[a], r + minapri[i - (a << 1)]);
			if (val < minapri[i]) minapri[i] = val;
		};
		if (i % 2 == 0)
			minapri[i] = min(minapri[i], u + minapri[i >> 1]);
	};
	out = fopen("apricot.out", "w");
	fprintf(out, "%" PRId64 "\n", minapri[n]);
	fclose(out);
	return 0;
};
