#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

char chread(FILE * in) {
	char c = getc(in);
	if (c == '*')
		return -1;
	return c - '0';
};
#define N 100000
#define NM 100000

char memory[NM];
char * chart[N];

int main(void) {
	int n, m, i, j, k;
	FILE * in, * out;
	in = fopen("calendar.in", "r");
	fscanf(in, "%d%d", &n, &m);
	for (i = 0; i < m; i ++)
		chart[i] = &memory[i * n];
	while (getc(in) != '\n') ;
	for (i = 0; i < n; i ++) {
		for (j = 0; j < m; j ++) {
			chart[j][i] = chread(in);
		};
		assert(getc(in) == '\n');
	};
	for (i = 0; i < m - 1; i ++) {
		for (j = 0; j < n - 1; j ++) {
			if ((chart[i][j] != -1) && (chart[i][j + 1] != -1) &&
					(chart[i][j] != chart[i][j + 1])) {
				chart[i + 1][j] = 9;
				chart[i + 1][j + 1] = 0;
			};
		};
	};
	for (i = m - 1; i >= 0; i --) {
		for (j = 0; j < n; j ++)
			if (chart[i][j] != -1)
				break;
		if (j == n) {
			// TODO make better
			chart[i][0] = 0;
			j = 0;
		};
		for (k = j; k > 0; k --) {
			if ((i == m - 1) || ((chart[i + 1][k] == 0) &&
						(chart[i + 1][k - 1] == 9)))
				chart[i][k - 1] = (9 + chart[i][k]) % 10;
			else
				chart[i][k - 1] = chart[i][k];
		};
		for (k = j; k < n - 1; k ++) {
			if ((i == m - 1) || ((chart[i + 1][k] == 9) &&
						(chart[i + 1][k + 1] == 0)))
				chart[i][k + 1] = (9 + chart[i][k]) % 10;
			else
				chart[i][k + 1] = chart[i][k];
		};
	};
	out = fopen("calendar.out", "w");
	for (i = 0; i < m; i ++)
		putc(chart[i][0] + '0', out);
	putc('\n', out);
	fclose(out);
	return 0;
};
