#include <stdio.h>
#include <memory.h>

#define N 100000
#define MAXSET (2 * N - 1)
#define SETS (MAXSET + 1)

int sets[N];
int resets[SETS];
int answers[N];
int counts1[SETS], counts2[SETS];
int * countsnow, * countsnew, * countstmp;

int main(void) {
	FILE * in, * out;
	int n, m, i;
	in = fopen("theatre.in", "r");
	fscanf(in, "%d", &n);
	memset(sets, 0, n * sizeof(int));
	memset(answers, -1, n * sizeof(int));
	fscanf(in, "%d", &m);
	countsnow = counts1;
	counts1[0] = n;
	countsnew = counts2;
	for (i = 0; i < m; i ++) {
		int k, j, p, q;
		fscanf(in, "%d", &k);
		for (j = 0; j < k; j ++) {
			fscanf(in, "%d", &p);
			p -= 1;
			countsnow[sets[p]] -= 1;
			sets[p] += n;
			countsnow[sets[p]] += 1;
		};
		for (j = 0; j < n; j ++) {
			resets[sets[j]] = j;
		};
		for (j = 0; j < n; j ++) {
			if ((countsnow[sets[j]] == 1) && (answers[j] == -1))
				answers[j] = i;
			countsnew[resets[sets[j]]] = countsnow[sets[j]];
			sets[j] = resets[sets[j]];
		};
		countstmp = countsnow;
		countsnow = countsnew;
		countsnew = countstmp;
	};
	fclose(in);
	out = fopen("theatre.out", "w");
	for (i = 0; i < n; i ++)
		fprintf(out, "%d ", answers[i] + 1);
	putc('\n', out);
	fclose(out);
	return 0;
};
