#include <stdio.h>
#include <memory.h>
 
#define N 100000
#define MAXSET (2 * N - 1)
#define SETS (MAXSET + 1)
 
int sets[N];
int resets[SETS];
int counts[N];
int answers[N];
 
int main(void) {
    FILE * in, * out;
    int n, m, i;
 
    in = fopen("theatre.in", "r");
    fscanf(in, "%d", &n);
    memset(sets, 0, n * sizeof(int));
    memset(answers, -1, n * sizeof(int));
    fscanf(in, "%d", &m);
    for (i = 0; i < m; i ++) {
        int k, j, p, q;
        fscanf(in, "%d", &k);
        for (j = 0; j < k; j ++) {
            fscanf(in, "%d", &p);
            sets[p - 1] += n;
        };
        for (j = 0; j < n; j ++) {
            resets[sets[j]] = j;
        };
	memset(counts, 0, n * sizeof(int));
        for (j = 0; j < n; j ++) {
            sets[j] = resets[sets[j]];
            counts[sets[j]] ++;
        };
        for (j = 0; j < n; j ++)
            if ((counts[j] == 1) && (answers[j] == -1))
                answers[j] = i;
    };
    fclose(in);
    out = fopen("theatre.out", "w");
    for (i = 0; i < n; i ++)
        fprintf(out, "%d ", answers[i] + 1);
    putc('\n', out);
    fclose(out);
    return 0;
};
