program Z_A;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  h = 999999937;
var
  s, s1: string;
  r, r1: array [1 .. 100000] of integer;
  sum, sum1: array [0 .. 100000] of integer;
  hash, hash1: array [0 .. 100000] of int64;
  p: array [0 .. 100000] of int64;
  i, u1, u2, res: integer;

function ha(const hash: array of int64; left, right: integer): int64;
begin
  ha := hash[right] - hash[left - 1] * p[right - left + 1];
end;

function compare(a, b, c, d: integer): boolean;
begin
  compare := ha(hash, a, b) = ha(hash1, c, d);
end;

function len(a: integer): integer;
begin
  result := 0;
  while a > 0 do begin
    inc(result);
    a := a div 10;
  end;
end;

procedure tryfrom(a: integer);
var
  i, left, right, v: integer;
begin
  left := a - 1;
  right := length(s) + 1;
  while (left < right - 1) do begin
    v := (left + right) div 2;
    if len(sum[v] - sum[a - 1]) + length(s) - v + a - 1 > length(s1) then
      left := v
    else
      right := v;
  end;

  for v := right to length(s) do begin
    if len(sum[v] - sum[a - 1]) + length(s) - v + a - 1<> length(s1) then
      break;

    if length(s) - v <= res then begin
      writeln(a, ' ', v);
      close(output);
      halt(0);
    end;
  end;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  fillchar(sum, sizeof(sum), 0);
  fillchar(sum1, sizeof(sum1), 0);
  fillchar(hash, sizeof(hash), 0);
  fillchar(hash1, sizeof(hash1), 0);
  p[0] := 1;
  for i := 1 to 100000 do
    p[i] := p[i - 1] * h;

  readln(s);
  for i := 1 to length(s) do begin
    r[i] := ord(s[i]) - ord('0');
    sum[i] := r[i] + sum[i - 1];
    hash[i] := hash[i - 1] * h + r[i] + 1;
  end;

  readln(s1);
  for i := 1 to length(s1) do begin
    r1[i] := ord(s[i]) - ord('0');
    sum1[i] := sum1[i - 1] + r1[i];
    hash1[i] := hash1[i - 1] * h + r1[i] + 1;
  end;

  u1 := length(s);
  u2 := length(s1);
  for i := 1 to length(s1) do
    if s[u1] = s[u2] then begin
      dec(u1);
      dec(u2);
      res := i;
    end else break;

  for i := 1 to length(s) do
    tryfrom(i);
end.
