#include <fstream>
#include <string>

using namespace std;

const int MAXN = 1005;
int sa[MAXN];
string a, b;

int cndig(int d) {
	int res = 0;
	while (d) {
		d /= 10;
		res++;
	}
	return res;
}

int cnsum(int st, int fi) {
	int res = 0;
	for (int i = st; i <= fi; i++) {
		res = res * 10 + b[i] - '0';
	}
	return res;
}

int main() {
	ifstream cin("password.in");
	ofstream cout("password.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	cin >> a >> b;
	sa[0] = a[0] - '0';
	for (int i = 1; i < a.size(); i++) {
		sa[i] = sa[i - 1] + a[i] - '0';
	}
	a += "#";
	b += "#";
	int i = 0, j = 0, ii = a.size() - 2, jj = b.size() - 2, suma, sumb;
	while (jj >= j && a[ii + 1] == b[jj + 1] && cndig(sa[ii]) <= jj + 1) {
		ii--;
		jj--;
	}
	ii++;
	jj++;
	if (a[ii + 1] == b[jj + 1] && cndig(sa[ii]) == jj + 1) {
		suma = sa[ii];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			cout << "1 " << ii + 1 << endl;
			return 0;
		}
	}
	ii--;
	jj--;
	if (jj >= j && a[ii + 1] == b[jj + 1] && cndig(sa[ii]) == jj + 1) {
		suma = sa[ii];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			cout << "1 " << ii + 1 << endl;
			return 0;
		}
	}
	i++;
	j++;
	while (a[i - 1] == b[j - 1]) {
		ii = a.size() - 2;
		jj = b.size() - 2;
		while (jj >= j && a[ii + 1] == b[jj + 1] && cndig(sa[ii] - sa[i - 1]) <= jj - j + 1) {
			ii--;
			jj--;
		}
		ii++;
		jj++;
		if (a[ii + 1] == b[jj + 1] && cndig(sa[ii] - sa[i - 1]) <= jj - j + 1) {
			suma = sa[ii] - sa[i - 1];
			sumb = cnsum(j, jj);
			if (suma == sumb) {
				cout << i + 1 << " " << ii + 1 << endl;
				return 0;
			}
		}
		ii--;
		jj--;
		if (jj >= j && a[ii + 1] == b[jj + 1] && cndig(sa[ii] - sa[i - 1]) <= jj - j + 1) {
			suma = sa[ii] - sa[i - 1];
			sumb = cnsum(j, jj);
			if (suma == sumb) {
				cout << i + 1 << " " << ii + 1 << endl;
				return 0;
			}
		}
		i++;
		j++;
	}
	cin.close();
	cout.close();
}