#include <fstream>
#include <string>

using namespace std;

const int MAXN = 100005;
int sa[MAXN];
string a, b;

int cndig(int d) {
	int res = 0;
	while (d) {
		d /= 10;
		res++;
	}
	return res;
}

int cnsum(int st, int fi) {
	int res = 0;
	for (int i = st; i <= fi; i++) {
		res = res * 10 + b[i] - '0';
	}
	return res;
}

int main() {
	ifstream cin("password.in");
	ofstream cout("password.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	cin >> a >> b;
	sa[0] = a[0] - '0';
	for (int k = 1; k < a.size(); k++) {
		sa[k] = sa[k - 1] + a[k] - '0';
	}
	int ii = a.size() - 1, jj = b.size() - 1;
	while (jj >= 0 && a[ii] == b[jj]) {
		ii--;
		jj--;
	}
	if (jj == -1) {
		ii++;
		jj++;
	}
	int i = 0, j = 0, suma, sumb, rst, rfi;
	while (jj < b.size() && cndig(a[ii]) > jj + 1) {
		ii++;
		jj++;
	}
	if (jj == b.size()) {
		ii--;
		jj--;
	}
	suma = sa[ii];
	sumb = cnsum(j, jj);
	if (suma == sumb) {
		rst = i + 1;
		rfi = ii + 1;
	}
	ii++;
	jj++;
	if (jj < b.size()) {
		suma = sa[ii];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			rst = i + 1;
			rfi = ii + 1;
		}
	}
	ii--;
	jj--;
	i++;
	j++;
	while (j < b.size() && a[i - 1] == b[j - 1]) {
		while (jj < j) {
			ii++;
			jj++;
		}
		while (jj < b.size() && cndig(a[ii] - a[i - 1]) > jj - j + 1) {
			ii++;
			jj++;
		}
		if (jj == b.size()) {
			ii--;
			jj--;
		}
		suma = sa[ii] - sa[i - 1];
		sumb = cnsum(j, jj);
		if (suma == sumb) {
			rst = i + 1;
			rfi = ii + 1;
		}
		ii++;
		jj++;
		if (jj < b.size()) {
			suma = sa[ii] - sa[i - 1];
			sumb = cnsum(j, jj);
			if (suma == sumb) {
				rst = i + 1;
				rfi = ii + 1;
			}
		}
		ii--;
		jj--;
		i++;
		j++;
	}
	cout << rst << " " << rfi << endl;
	cin.close();
	cout.close();
}