#include <fstream>
#include <algorithm>

using namespace std;

const int MAXN = 2005;
long long dyn[MAXN];

int main() {
	ifstream cin("apricot.in");
	ofstream cout("apricot.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n, eq, neq;
	cin >> n >> eq >> neq;
	dyn[0] = dyn[1] = 0;
	dyn[2] = neq;
	for (int i = 3; i <= n; i++) {
		dyn[i] = max(eq + dyn[i - 2], (long long)neq);
		int j = 2;
		while (i - j - j > 0) {
			dyn[i] = min(dyn[i], max(eq + dyn[i - j - j], neq + dyn[j]));
			j++;
		}
		if (i % 2 == 0) {
			dyn[i] = min(dyn[i], neq + dyn[i / 2]);
		}
	}
	cout << dyn[n] << endl;
	cin.close();
	cout.close();
}