#include <fstream>
#include <algorithm>

using namespace std;

const int MAXN = 1000005;
const long long INF = 1000000000000000000;
long long dyn[MAXN];

int main() {
	ifstream cin("apricot.in");
	ofstream cout("apricot.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n, eq, neq;
	cin >> n >> eq >> neq;
	for (int i = 0; i <= n; i++) {
		dyn[i] = INF;
	}
	dyn[1] = 0;
	for (int i = 2; i <= n; i++) {
		int j = 1;
		while (i - j - j > 0) {
			dyn[i] = min(dyn[i], max(dyn[i - j - j] + eq, dyn[j] + neq));
			j++;
		}
		if (i % 2 == 0) {
			dyn[i] = min(dyn[i], dyn[i / 2] + neq);
		}
	}
	cout << dyn[n] << endl;
	cin.close();
	cout.close();
}