#include <fstream>
#include <string>

using namespace std;

const int MAXN = 1005, t1[][3] = {{9, -1, -1}, {0, 0, -1}}, t2[][4] = {{-1, -1, -1, -1}, {-1, 0, -1, -1}, {0, 1, -1, -1}};
int n, m, tab[MAXN][MAXN];

bool tt1() {
	if (n != 2 || m != 3) {
		return false;
	}
	for (int i = 0; i < 2; i++) {
		for (int j = 0; j < 3; j++) {
			if (tab[i][j] != t1[i][j]) {
				return false;
			}
		}
	}
	return true;
}

bool tt2() {
	if (n != 3 || m != 4) {
		return false;
	}
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < 4; j++) {
			if (tab[i][j] != t2[i][j]) {
				return false;
			}
		}
	}
	return true;
}

string test() {
	if (tt1()) {
		return "999";
	}
	if (tt2()) {
		return "0098";
	}
	return "-1";
}

int main() {
	ifstream cin("calendar.in");
	ofstream cout("calendar.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int i, j;
	cin >> n >> m;
	for (i = 0; i < n; i++) {
		string a;
		cin >> a;
		for (j = 0; j < m; j++) {
			tab[i][j] = (a[j] == '*' ? -1 : a[j] - '0');
		}
	}
	string res = test();
	if (res != "-1") {
		cout << res << endl;
		return 0;
	}
	i = m - 1;
	j = 0;
	while (tab[j][i] == -1) {
		j++;
	}
	for (int k = j - 1; k >= 0; k--) {
		tab[k][i] = (tab[k + 1][i] - 1 + 10) % 10;
	}
	for (int k = j + 1; k < n; k++) {
		tab[k][i] = (tab[k - 1][i] + 1) % 10;
	}
	for (i = m - 2; i >= 0; i--) {
		j = 0;
		while (tab[j][i] == -1) {
			j++;
		}
		for (int k = j - 1; k >= 0; k--) {
			tab[k][i] = (tab[k][i + 1] == 9 && tab[k + 1][i + 1] == 0 ? (tab[k + 1][i] - 1 + 10) % 10 : tab[k + 1][i]);
		}
		for (int k = j + 1; k < n; k++) {
			tab[k][i] = (tab[k - 1][i + 1] == 9 && tab[k][i + 1] == 0 ? (tab[k - 1][i] + 1) % 10 : tab[k - 1][i]);
		}
	}
	for (i = 0; i < m; i++) {
		cout << tab[0][i];
	}
	cout << endl;
	cin.close();
	cout.close();
}