#include <fstream>
#include <algorithm>
#include <vector>
#define V(T) vector <T>
#define P(T) pair <T, T>
#define mpa make_pair
#define i64 long long

using namespace std;

const int MAXM = 10005;
V(bool) p, pp;
V(int) cur, alr;
V(V(int)) tab[MAXM];

inline void dooo(int s1, int s2, int a, int b) {
	if (s1 < s2) {
		for (int k = 0; k < s1; k++) {
			int c = lower_bound(cur.begin(), cur.end(), tab[a][b][k]) - cur.begin();
			if (c == s2 || cur[c] != tab[a][b][k]) {
				continue;
			}
			p[k] = true;
			pp[c] = true;
		}
	} else {
		for (int k = 0; k < s2; k++) {
			int c = lower_bound(tab[a][b].begin(), tab[a][b].end(), cur[k]) - tab[a][b].begin();
			if (c == s1 || tab[a][b][c] != cur[k]) {
				continue;
			}
			p[c] = true;
			pp[k] = true;
		}
	}
}

inline void duck(int s1, int s2, int a, int b) {
	if (s1 < s2) {
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s1; k++) {
			if (!p[k]) {
				tab[a].back().push_back(tab[a - 1][b][k]);
			}
		}
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s1; k++) {
			if (p[k]) {
				tab[a].back().push_back(tab[a - 1][b][k]);
			}
		}
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s2; k++) {
			if (!pp[k]) {
				tab[a].back().push_back(cur[k]);
			}
		}
	} else {
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s2; k++) {
			if (!pp[k]) {
				tab[a].back().push_back(cur[k]);
			}
		}
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s2; k++) {
			if (pp[k]) {
				tab[a].back().push_back(cur[k]);
			}
		}
		tab[a].push_back(V(int)(0));
		for (int k = 0; k < s1; k++) {
			if (!p[k]) {
				tab[a].back().push_back(tab[a - 1][b][k]);
			}
		}
	}
}

int main() {
	ifstream cin("theatre.in");
	ofstream cout("theatre.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n, m;
	cin >> n >> m;
	alr.resize(n + 1);
	cur.resize(n);
	tab[0].resize(1, V(int)(n));
	for (int i = 0; i < n; i++) {
		tab[0][0][i] = i + 1;
	}
	for (int i = 1; i <= m; i++) {
		int ll;
		cin >> ll;
		cur.clear();
		for (int j = 0; j < ll; j++) {
			int a;
			cin >> a;
			if (!alr[a]) {
				cur.push_back(a);
			}
		}
		sort(cur.begin(), cur.end());
		int l = cur.size();
		for (int j = 0; j < tab[i - 1].size(); j++) {
			p.assign(tab[i - 1][j].size(), false);
			pp.assign(l, false);
			if (tab[i - 1][j].size() == 1) {
				continue;
			}
			dooo(tab[i - 1][j].size(), l, i - 1, j);
			duck(p.size(), pp.size(), i, j);
		}
		for (int j = 0; j < tab[i].size(); j++) {
			if (tab[i][j].size() == 1) {
				alr[tab[i][j].front()] = i;
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		cout << alr[i] << " ";
	}
	cout << endl;
	cin.close();
	cout.close();
}