#include <fstream>
#include <algorithm>
#include <vector>
#define V(T) vector <T>
#define P(T) pair <T, T>
#define mpa make_pair
#define i64 long long

using namespace std;

const int INF = 100;
V(int) pe, perm, dyn, pl;

int mx(int n) {
	dyn.assign(n + 1, INF);
	dyn[0] = 0;
	for (int i = 0; i < n; i++) {
		int a = upper_bound(dyn.begin(), dyn.end(), perm[i]) - dyn.begin();
		dyn[a] = min(dyn[a], perm[i]);
	}
	int res = n;
	while (dyn[res] == INF) {
		res--;
	}
	return res;
}

bool ok(int k) {
	for (int i = 0; i < k - 1; i++) {
		if (pl[i] > pl[i + 1]) {
			return false;
		}
	}
	return true;
}

int main() {
	ifstream cin("army.in");
	ofstream cout("army.out");
//	ifstream cin("input.txt");
//	ofstream cout("output.txt");
	int n, k;
	cin >> n >> k;
	pl.resize(k);
	pe.resize(k);
	perm.resize(n);
	for (int i = 0; i < k; i++) {
		cin >> pe[i];
	}
	for (int i = 0; i < n; i++) {
		perm[i] = i + 1;
	}
	i64 res = 0;
	do {
		int a = mx(n);
		if (a != k) {
			continue;
		}
		for (int i = 0; i < k; i++) {
			pl[i] = find(perm.begin(), perm.end(), pe[i]) - perm.begin();
		}
		res += ok(k);
	} while (next_permutation(perm.begin(), perm.end()));
	cout << res << endl;
	cin.close();
	cout.close();
}