//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

using namespace std;

const long maxn=2005;

bool mark[3][maxn];
bool spec[3][maxn][maxn];
long n,sz;
long stek[maxn];
vector <long> edges[3][maxn];

void dfs(long it,long v)
{
	mark[it][v]=true;
	sz++;
	stek[sz]=v;
	for (long j=0;j<edges[it][v].size();j++)
	{
		long u=edges[it][v][j];
		if (!mark[it][u])
		{
			for (long g=1;g<=sz;g++)
				spec[it][u][stek[g]]=true;
			dfs(it,u);
		}
	}
	sz--;
}

int main()
{
	freopen("virus.in","r",stdin);
	freopen("virus.out","w",stdout);
	scanf("%ld",&n);
	if (n>2000)
		exit(-1);
	long q,x,root1,root2;
	for (q=1;q<=n;q++)
	{
		scanf("%ld",&x);
		if (x==0)
			root1=q;
		else edges[1][x].push_back(q);
	}
	for (q=1;q<=n;q++)
	{
		scanf("%ld",&x);
		if (x==0)
			root2=q;
		else edges[2][x].push_back(q);
	}
	dfs(1,root1);
	dfs(2,root2);
	long answer=0;
	for (long choice=1;choice<=n;choice++)
	{
		for (long boss=1;boss<=n;boss++) if ((spec[1][choice][boss])&&(spec[2][choice][boss]))
		{
			//printf("%ld %ld\n",boss,choice);
			answer++;
		}
	}
	printf("%ld",answer);
}