//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

#define LL long long

using namespace std;

const long maxn=2e5+5;
typedef pair<long,long> mypair;

pair <long,long> a[maxn];
pair <long,long> m[maxn][22];
long n;
long dv[25];
long spec[maxn];
mypair tree[maxn*8];

void build(long i,long l,long r)
{
	if (l==r)
	{
		tree[i].first=spec[l];
		tree[i].second=l;
		return;
	}
	long middle=(l+r)/2;
	build(i*2,l,middle);
	build(i*2+1,middle+1,r);
	if (tree[i*2]<tree[i*2+1])
		tree[i]=tree[i*2];
	else tree[i]=tree[i*2+1];
}

mypair get_min(long i,long tl,long tr,long l,long r)
{
	if ((tl==l)&&(tr==r))
		return(tree[i]);
	long middle=(tl+tr)/2;
	if (r<=middle)
		return(get_min(i*2,tl,middle,l,r));
	else if (l>middle)
		return(get_min(i*2+1,middle+1,tr,l,r));
	else
	{
		mypair t1=get_min(i*2,tl,middle,l,middle);
		mypair t2=get_min(i*2+1,middle+1,tr,middle+1,r);
		if (t1<t2)
			return(t1);
		else return(t2);
	}
}

int main()
{
	freopen("mosaic.in","r",stdin);
	freopen("mosaic.out","w",stdout);
	scanf("%ld",&n);
	long q;
	for (q=1;q<=n;q++)
		scanf("%ld%ld",&a[q].first,&a[q].second);
	dv[0]=1;
	for (long j=1;j<=20;j++)
		dv[j]=dv[j-1]*2;
	for (long it=n;it>=1;it--)
	{
		m[it][0].first=a[it].first;
		m[it][0].second=a[it].second;
		for (long step=1;true;step++)
		{
			if (it+dv[step]-1<=n)
			{
				pair <long,long> tmp=m[it+dv[step-1]][step-1];
				if (tmp.first==m[it][step-1].first)
					m[it][step].first=tmp.first;
				else m[it][step].first=-1;

				if (tmp.second==m[it][step-1].second)
					m[it][step].second=tmp.second;
				else m[it][step].second=-1;
			}
			else break;
		}

		long now=it;
		for (long step=20;step>=0;step--)
		{
			if (now+dv[step]-1<=n)
			{
				if ((m[now][step].first==a[it].first)||(m[now][step].second==a[it].second))
					now=now+dv[step];
			}
		}
		spec[it]=now-1;
	}

	build(1,1,n);
	long m;
	scanf("%ld",&m);
	for (long it=1;it<=m;it++)
	{
		long s,f;
		scanf("%ld%ld",&s,&f);
		if (f-s<1000)
		{
			bool fail=false;
			for (long choice=s;choice<=f;choice++)
				if (spec[choice]<f)
				{
					fail=true;
					printf("%ld %ld\n",choice,spec[choice]+1);
					break;
				}
			if (!fail)
				printf("0 0\n");
			continue;
		}
		mypair tmp=get_min(1,1,n,s,f);
		if (tmp.first<f)
			printf("%ld %ld\n",tmp.second,tmp.first+1);
		else printf("0 0\n");
	}
}