//#include <stdafx.h>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>

#define LL long long

using namespace std;

const long maxn=15;

struct point
{
	long x;
	long y;
};
const long dx[9]={-1,-1,-1,0,0,0,1,1,1};
const long dy[9]={-1,0,1,-1,0,1,-1,0,1};

bool pos[maxn][maxn];
bool pos1[maxn][maxn];
long n,m;
point p,now,mid;

long dist(point p)
{
	return(max(abs(p.x-mid.x),abs(p.y-mid.y)));
}

bool norm(point p)
{
	return((p.x>=1)&&(p.x<=n)&&(p.y>=1)&&(p.y<=m));
}

int main()
{
	//srand(time(0));
	long q,k;
	scanf("%ld%ld",&m,&n);
	if ((n>10)||(m>10))
		exit(-1);
	scanf("%ld%ld",&now.x,&now.y);
	for (q=1;q<=n;q++)
		for (k=1;k<=m;k++)
			pos[q][k]=true;
	while(true)
	{
		long final=4;
		long sumx=0;
		long sumy=0;
		long cht=0;
		for (q=1;q<=n;q++)
			for (k=1;k<=m;k++)
				if (pos[q][k])
				{
					cht++;
					sumx+=q;
					sumy+=k;
				}
		mid.x=sumx/cht;
		mid.y=sumy/cht;
		point bestp=now;
		for (long move=0;move<=8;move++)
		{
			p.x=now.x+dx[move];
			p.y=now.y+dy[move];
			if (norm(p))
			{
				if (dist(p)<=dist(bestp))
				{
					final=move;
					bestp=p;
				}
				/*else if (rand() % 3==0)
				{
					final=move;
					bestp=p;
				}*/
				//break;
			}
		}
		printf("%ld %ld 1\n",dx[final],dy[final]);
		now.x+=dx[final];
		now.y+=dy[final];
		fflush(stdout);
		long tt,t1,t2;
		scanf("%ld%ld%ld",&tt,&t1,&t2);
		if (tt==1) exit(0);
		pos[now.x][now.y]=false;

		for (q=1;q<=n;q++)
			for (k=1;k<=m;k++)
				pos1[q][k]=false;

		for (q=1;q<=n;q++)
			for (k=1;k<=m;k++) if (pos[q][k])
			{
				p.x=q+t1;
				p.y=k+t2;
				if ((p.x>=1)&&(p.x<=n)&&(p.y>=1)&&(p.y<=m))
					pos1[p.x][p.y]=true;
			}
		for (q=1;q<=n;q++)
			for (k=1;k<=m;k++)
				pos[q][k]=pos1[q][k];
	}
}