#include <iostream>
#include <cstdio>

#include <vector>
#include <string>
#include <cstring>
#include <algorithm>

#include <cassert>
#include <cstdlib>
#include <ctime>

using namespace std;

struct rect {
    int w, h;
};

const int N = (int) 1e5;

int n, k;
rect r[N];

bool Test ( int a, int b ) {
    return (r[a].w == r[b].w || r[a].h == r[b].h);
}

int main () {
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);

    scanf("%d", &n);
    for ( int i = 0; i < n; i++ ) 
        scanf("%d%d", &r[i].w, &r[i].h);

    scanf("%d", &k);

    for ( int i = 0; i < k; i++ ) {
        int l, r;
        scanf("%d%d", &l, &r);

        bool flag = true;

        for ( int j = l - 1; j < r && flag; j++ )
            for ( int m = j + 1; m < r && flag; m++ )
                if ( !Test(j, m) ) {
                    printf("%d %d\n", j + 1, m + 1);
                    flag = false;
                } 

        if ( flag ) {
            printf("%d %d\n", 0, 0);
        }
    }    

    return 0;
}