program Project1;
{$O-}
{$R+}
{$MAXSTACKSIZE 1000000000}
{$APPTYPE CONSOLE}

uses
  SysUtils, Math;
var
  r, r1, r2, i, n : integer;
  s, s1, sum, s2 : string;
  a, c : array[1..400000] of int64;

function getsum(l, r, tl, tr, v : integer) : int64;
var
  m : integer;
begin
  if (l = tl) and (r = tr) then
    getsum := a[v]
  else if l > r then
    getsum := 0
  else begin
    m := (tl + tr) div 2;
    getsum := getsum(l, min(m, r), tl, m, 2 * v) + getsum(max(l, m + 1), r, m + 1, tr, 2 * v + 1);
  end;
end;

procedure build(l, r, v : integer);
var
  m : integer;
begin
  if l = r then
    a[v] := c[l]
  else begin
    m := (l + r) div 2;
    build(l, m, 2 * v);
    build(m + 1, r, 2 * v + 1);
    a[v] := a[2 * v] + a[2 * v + 1];
  end;
end;
  
begin
  assign(input, 'password.in');
  assign(output, 'password.out');
  reset(input);
  rewrite(output);

  readln(s1);
  readln(s);
  n := length(s1);
  for i := 1 to length(s1) do
    c[i] := strtoint(copy(s1, i, 1));
  if s = s1 then begin
    writeln('1 1');
    halt(0);
  end;
  r := length(s1) - length(s);
  r1 := r + 1;
  r2 := r1;
  while r2 - length(inttostr(9 * r2)) <= r do
    inc(r2);
  dec(r2);

  build(1, n, 1);
  for r := r1 to r2 do
    for i := 1 to n - r + 1 do begin
      sum := inttostr(getsum(i, i + r - 1, 1, n, 1));
      s2 := copy(s1, 1, i - 1) + sum + copy(s1, i + r, length(s1) - i - r + 1);
      if s = s2 then begin
        writeln(i, ' ', i + r - 1);
        halt(0);
      end;
    end;


  close(input);
  close(output);
end.
 