program Project1;
{$O-}
{$R+}
{$MAXSTACKSIZE 1000000000}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Math;

const
  inf = 1000000000;

var
  n, m, i : integer;
  s : array[1..1000] of string;
  s1 : string;

function canplus1(s : string) : boolean;
var
  i : integer;
begin
  for i := m downto 1 do begin
    if (s[i] <> '*') and (s[i] < '9') then begin
      canplus1 := true;
      exit;
    end;
    if (s[i] = '*') then begin
      canplus1 := false;
      exit;
    end;
  end;
  canplus1 := true;
end;

function plus1(s : string) : string;
var
  i : integer;
  s1 : string;
begin
  s1 := '';
  i := m;
  while (i > 0) and (s[i] = '9') do
    dec(i);
  if i = 0 then begin
    for i := 1 to m do
      s1 := s1 + '0';
  end else begin
    s1 := copy(s, 1, i-1) + inttostr(strtoint(s[i]) + 1);
    for i := i+1 to m do
      s1 := s1 + '0';
  end;
  plus1 := s1;
end;

function min1(s : string) : string;
var
  i : integer;
  s1 : string;
begin
  s1 := '';
  i := m;
  while (i > 0) and (s[i] = '0') do
    dec(i);
  if i = 0 then begin
    for i := 1 to m do
      s1 := s1 + '9';
  end else begin
    s1 := copy(s, 1, i-1) + inttostr(strtoint(s[i]) - 1);
    for i := i+1 to m do
      s1 := s1 + '9';
  end;
  min1 := s1;
end;

function eq(s1, s2 : string) : boolean;
var
  i : integer;
begin
  for i := 1 to m do
    if (s1[i] <> '*') and (s2[i] <> '*') and (s1[i] <> s2[i]) then begin
      eq := false;
      exit;
    end;
  eq := true;
end;



function p(s1 : string; k : integer) : string;
var
  i, j : integer;
  s2, p1 : string;
begin
  if k > n then begin
    p := s1;
    exit;
  end;
  if canplus1(s1) then begin
     s2 := plus1(s1);
     if not(eq(s2, s[k])) then begin
       p := '-';
       exit;
     end;
     for i := 1 to m do
       if (s2[i] = '*') then
        s2[i] := s[k][i];
     p1 := p(s2, k + 1);
     if p1 = '-' then
       p := '-'
     else
       p := min1(p1);
  end else begin
    i := m;
    while s1[i] <> '*' do
      dec(i);
    for j := 0 to 9 do
      if not((i = 1) and (j = 0)) then begin
        p1 := p(copy(s1, 1, i-1)+inttostr(j)+copy(s1, i+1, m-i), k);
        if p1 <> '-' then begin
          p := p1;
          exit;
        end;
      end;
  end;
end;

begin
  assign(input, 'calendar.in');
  assign(output, 'calendar.out');
  reset(input);
  rewrite(output);

  readln(n, m);
  for i := 1 to n do
    readln(s[i]);

  s1 := p(s[1], 2);
  for i := 1 to m do
    if s[i] = '*' then
      s[i] := '1';
  writeln(s1);

  close(input);
  close(output);
end.
