#include <iostream>
#include <deque>

using namespace std;

deque<int>* fstruct;
deque<int>* sstruct;

int n;
int tmp;
int answer = 0;

bool dfs(deque<int>* &arr, int ind, int search);

int main()
{
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	cin >> n;

	fstruct = new deque<int>[n+1];
	sstruct = new deque<int>[n+1];
	
	for(int i=0; i<n; i++)
	{
		cin >> tmp;
		fstruct[tmp].push_back(i+1);
	}

	for(int i=0; i<n; i++)
	{
		cin >> tmp;
		sstruct[tmp].push_back(i+1);
	}
	for(int i=1; i<n+1; i++)
		for(int j=1; j<n+1; j++)
			if(dfs(fstruct, i, j) && dfs(sstruct, i, j))
				answer++;
	cout << answer;
	return 0;
}

bool dfs(deque<int>* &arr, int ind, int search)
{
	for(unsigned int i=0; i<arr[ind].size(); i++)
	{
		if(arr[ind][i] == search)
			return true;
		if(dfs(arr, arr[ind][i], search))
			return true;
	}
	return false;
}