#include <iostream>
#include <algorithm>

using namespace std;

typedef signed long long ll;

int N, U, R;
ll* dp;

ll state(int numOfCoins);

int main()
{
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	cin >> N >> R >> U;
	dp = new ll[N+1];
	for(int i=0; i<N+1; i++)
		dp[i] = -1;

	dp[0] = 0;
	dp[1] = 0;
	dp[2] = U;
	dp[3] = max(U, R);

	cout << state(N);

	return 0;
}

ll state(int numOfCoins)
{
	ll answ = 0;
	if(dp[numOfCoins] != -1)
		return dp[numOfCoins];

	answ = max(answ, (numOfCoins % 2 != 0)? max(state(numOfCoins/2) + U, state(1) + R) : state(numOfCoins/2) + U); // bsearch

	for(int i=3; i<=numOfCoins/2; i++) // i - num of heaps
	{
		int sz = numOfCoins/i;
		int t = i/2;
		answ = min(answ, max( (i/2-1)*R + state(numOfCoins/i) + state(numOfCoins - sz*t*2), (numOfCoins != sz*i)? (i/2)*R + state(numOfCoins - sz*i) : 0 ));
	}

	dp[numOfCoins] = answ;
	return answ;
}