program mosaic;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  Element=record
          a,b,n:longint;
          end;

var
  e:array[1..100000] of element;
  p,q,n,k,i,l,r,j,uk1,uk2,a,b,x,y,w,v:longint;
  use:array[1..5000,1..5000] of longint;
  f:array[1..25000000,1..2] of longint;


procedure sorta(l,r:longint);
var
  i,j:longint;
  x,b:element;
begin
  i:=l;
  j:=r;
  x:=e[(l+r)div 2];
  while i<=j do
  begin
    while e[i].a<x.a do inc(i);
    while e[j].a>x.a do dec(j);
    if i<=j then
    begin
      b:=e[i]; e[i]:=e[j]; e[j]:=b;
      inc(i);
      dec(j);
    end;
  end;
  if i<r then sorta(i,r);
  if j>l then sorta(l,j);
end;

procedure sortb(l,r:longint);
var
  i,j:longint;
  x,b:element;
begin
  i:=l;
  j:=r;
  x:=e[(l+r)div 2];
  while i<=j do
  begin
    while e[i].b<x.b do inc(i);
    while e[j].b>x.b do dec(j);
    if i<=j then
    begin
      b:=e[i]; e[i]:=e[j]; e[j]:=b;
      inc(i);
      dec(j);
    end;
  end;
  if i<r then sortb(i,r);
  if j>l then sortb(l,j);
end;

begin
  reset(input,'mosaic.in');
  rewrite(output,'mosaic.out');
  read(n);
  for i:=1 to n do
  begin
    read(e[i].a,e[i].b);
    e[i].n:=i;
    use[i,i]:=1;
  end;


  sorta(1,n);
  uk1:=1;
  uk2:=1;
  for i:=2 to n do
  begin
    if e[i].a=e[uk1].a then inc(uk2) else
    begin
      for j:=uk1 to uk2-1 do
      for q:=j+1 to uk2 do
      begin
        use[e[j].n,e[q].n]:=1;
        use[e[q].n,e[j].n]:=1;
      end;
      uk1:=i;
      uk2:=i;
    end;
  end;
  for j:=uk1 to uk2-1 do
  for q:=j+1 to uk2 do
  begin
    use[e[j].n,e[q].n]:=1;
    use[e[q].n,e[j].n]:=1;
  end;

  sortb(1,n);
  uk1:=1;
  uk2:=1;
  for i:=2 to n do
  begin
    if e[i].b=e[uk1].b then inc(uk2) else
    begin
      for j:=uk1 to uk2-1 do
      for q:=j+1 to uk2 do
      begin
        use[e[j].n,e[q].n]:=1;
        use[e[q].n,e[j].n]:=1;
      end;
      uk1:=i;
      uk2:=i;
    end;
  end;
  for j:=uk1 to uk2-1 do
  for q:=j+1 to uk2 do
  begin
    use[e[j].n,e[q].n]:=1;
    use[e[q].n,e[j].n]:=1;
  end;

  uk1:=1;
  for i:=1 to n do
  for j:=i+1 to n do
  if use[i,j]=0 then
  begin
    f[uk1,1]:=i;
    f[uk1,2]:=j;
    inc(uk1);
  end;
  dec(uk1);
  read(k);
  for i:=1 to k do
  begin
    read(l,r);
    a:=0;
    b:=0;
    x:=0;
    y:=uk1;
    w:=0;
    v:=0;
    while y-x>1 do
    begin
      p:=(y+x) div 2;
      if f[p,1]>=l then y:=p else x:=p;
    end;
    //y-    
    if f[y,1]>=l then w:=y;

    x:=1;
    y:=uk1+1;

    while y-x>1 do
    begin
      p:=(y+x) div 2;
      if f[p,1]>r then y:=p else x:=p;
    end;
    //x-    
    if f[x,1]<=r then v:=x;

    if (v<>0) and (w<>0) then
    for j:=v to w do
    if (f[j,1]>=l) and (f[j,2]<=r) then begin a:=f[j,1]; b:=f[j,2];  break; end;
    writeln(a,' ',b);
  end;
end.
