program task2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..110000] of integer;
  tarr1 = array [1..110000] of array of integer;
  tarr2 = array [1..110000] of boolean;

var
  n, ta, tb, ans: integer;
  pa, pb: tarr;
  a, b: tarr1;
  va, vb: tarr2;

procedure AddEdge(var a: tarr1; const u, v: integer);
begin
  setlength(a[u], length(a[u]) + 1);
  a[u, length(a[u]) - 1] := v;
end;

procedure ReadTree(var pa: tarr; var a: tarr1; var ta: integer);
var
  i: integer;
begin
  for i := 1 to n do begin
    read(pa[i]);
    if pa[i] = 0 then
      ta := i
    else
      AddEdge(a, pa[i], i);
  end;
end;

procedure dfs(const a: tarr1; var v: tarr2; const u: integer);
var
  i: integer;
begin
  v[u] := true;
  for i := 0 to High(a[u]) do
    if not v[a[u, i]] then
      dfs(a, v, a[u, i]);
end;

procedure Solve50;
var
  i, j: integer;
begin
  ans := 0;
  for i := 1 to n do begin
    fillchar(va, sizeof(va), false);
    fillchar(vb, sizeof(vb), false);
    dfs(a, va, i);
    dfs(b, vb, i);
    for j := 1 to n do
      if (j <> i) and va[j] and vb[j] then
        inc(ans);
  end;
  writeln(ans);
  halt(0);
end;

begin
  reset(input, 'virus.in');
  rewrite(output, 'virus.out');
  readln(n);
  ReadTree(pa, a, ta);
  ReadTree(pb, b, tb);
  Solve50;
end.
