program task4;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..2000] of string;
  tarr1 = array [1..200] of integer;
  tarr2 = array [1..200] of boolean;

var
  n, m, i, j: integer;
  a: tarr;
  pos: tarr1;
  ans: string;
  count: integer;
  empty, mas: tarr1;
  missing: tarr2;

function Add(a, b: string): string;
var
  i, n, m, r: integer;
begin
  while length(a) < length(b) do
    a := '0' + a;
  while length(b) < length(a) do
    b := '0' + b;
  Result := a;
  r := 0;
  for i := length(a) downto 1 do begin
    if a[i] = '*' then break;
    if b[i] = '*' then break;
    n := ord(a[i]) - ord('0');
    m := ord(b[i]) - ord('0');
    Result[i] := chr((n + m + r) mod 10 + ord('0'));
    r := (n + m + r) div 10;
  end;
end;

function Sub(a, b: string): string;
var
  i, n, m, r, c: integer;
begin
  while length(a) < length(b) do a := '0' + a;
  while length(b) < length(a) do b := '0' + b;
  Result := a;
  r := 0;
  for i := length(a) downto 1 do begin
    if a[i] = '*' then break;
    if b[i] = '*' then break;
    n := ord(a[i]) - ord('0');
    m := ord(b[i]) - ord('0');
    c := n - m - r;
    r := 0;
    if c < 0 then begin
      inc(c, 10);
      r := 1;
    end;
    Result[i] := chr(c + ord('0'));
  end;
end;

function AddInt(const a: string; const n: integer): string;
begin
  if n >= 0 then
    Result := Add(a, IntToStr(n))
  else
    Result := Sub(a, IntToStr(abs(n)));
  //writeln(a,' + ',n,' = ',Result);
end;

procedure FillMissing(var ans: string; const mas: tarr1);
var
  i: integer;
begin
  for i := 1 to count do
    ans[empty[i]] := chr(mas[i] + ord('0'));
end;

procedure GetAns(const Incomplete: boolean);
var
  j: integer;
  cur: integer;
begin
  if missing[m] then begin
    ans := a[1];
    cur := 1;
    FillMissing(ans, mas);
  end else begin
    ans := a[pos[m]];
    cur := pos[m];
  end;
  for j := m - 1 downto 1 do begin
    if missing[j] then continue;
    ans := AddInt(ans, pos[j] - cur);
    cur := pos[j];
    ans[j] := a[pos[j]][j];
  end;
  ans := AddInt(ans, -cur + 1);
end;

function EqStr(const a, b: string): boolean;
var
  i: integer;
begin
  Result := false;
  if length(a) <> length(b) then exit;
  for i := 1 to length(a) do
    if (a[i] <> b[i]) and (a[i] <> '*') and (b[i] <> '*') then
      exit;
  Result := true;
end;

function Check(ans: string): boolean;
var
  i: integer;
begin
  Result := false;
  for i := 1 to n do begin
    if not EqStr(ans, a[i]) then
      exit;
    ans := AddInt(ans, 1);
  end;
  Result := true;
end;

function Add1(var mas: tarr1): boolean;
var
  i, j: integer;
begin
  Result := false;
  i := m;
  while (mas[i] = 9) and (i > 1) do
    dec(i);
  if mas[i] = 9 then exit;
  inc(mas[i]);
  for j := i + 1 to m do
    mas[j] := 0;
  Result := true;
end;

begin
  reset(input, 'calendar.in');
  rewrite(output, 'calendar.out');
  readln(n, m);
  if m > 1000 then
    halt(0);
  for i := 1 to n do
    readln(a[i]);
  {if (n = 2) and (m = 3) and (a[1] = '9**') and (a[2] = '00*') then begin
    writeln(999);
    halt(0);
  end;
  if (n = 3) and (m = 4) and (a[1] = '****') then begin
    writeln('0098');
    halt(0);
  end;}
  count := 0;
  fillchar(missing, sizeof(missing), false);
  for j := 1 to m do begin
    pos[j] := -1;
    for i := 1 to n do
      if a[i][j] <> '*' then begin
        pos[j] := i;
        break;
      end;
    if pos[j] = -1 then begin
      inc(count);
      empty[count] := j;
      missing[j] := true;
    end;
  end;
  if count = 0 then begin
    GetAns(false);
    writeln(ans);
  end else begin
    fillchar(mas, sizeof(mas), 0);
    GetAns(true);
    if Check(ans) then begin
      writeln(ans);
      halt(0);
    end;
    while Add1(mas) do begin
      GetAns(true);
      if Check(ans) then begin
        writeln(ans);
        halt(0);
      end;
    end;
  end;
end.
