program task5;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..5000] of integer;
  tarr1 = array [1..5000, 1..5000] of integer;

var
  n, i, k, l, r, u, v: integer;
  a, b: tarr;
  cnta, cntb: tarr;
  cntab: tarr1;

function f(const a1, b1, a2, b2: integer): boolean;
begin
  Result := (a1 = a2) or (b1 = b2);
end;

procedure FillCnt(const l, r: integer);
var
  i: integer;
begin
  fillchar(cnta, sizeof(cnta), 0);
  fillchar(cntb, sizeof(cntb), 0);
  fillchar(cntab, sizeof(cntab), 0);
  for i := l to r do begin
    inc(cnta[a[i]]);
    inc(cntb[b[i]]);
    inc(cntab[a[i], b[i]]);
  end;
end;

procedure GetIndex(const l, r: integer; out u: integer);
var
  i: integer;
begin
  u := 0;
  for i := l to r do
    if cnta[a[i]] + cntb[b[i]] - cntab[a[i], b[i]] <> r - l + 1 then begin
      u := i;
      exit;
    end;
end;

function FindPair(const l, r: integer; const u: integer): integer;
var
  i: integer;
begin
  Result := 0;
  for i := l to r do
    if not f(a[i], b[i], a[u], b[u]) then begin
      Result := i;
      exit;
    end;
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  readln(n);
  for i := 1 to n do
    readln(a[i], b[i]);
  readln(k);
  for i := 1 to k do begin
    readln(l, r);
    FillCnt(l, r);
    GetIndex(l, r, u);
    if u = 0 then
      v := 0
    else
      v := FindPair(l, r, u);
    writeln(u,' ',v);
  end;
end.
