program task5;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  tarr = array [1..1000] of integer;
  tarr1 = array [1..1000, 1..1000] of integer;

var
  n, i, k, l, r, u, v: integer;
  a, b, a1, b1: tarr;
  cnta, cntb: tarr;
  cntab: tarr1;

procedure swap(var a, b: integer);
var
  c: integer;
begin
  c := a;
  a := b;
  b := c;
end;

procedure QSort(var a: tarr; const l, r: integer);
var
  tl, tr, b, v: integer;
begin
  if l >= r then
    exit;
  tl := l;
  tr := r;
  v := random(r - l + 1) + l;
  b := a[v];
  while tl <= tr do begin
    while a[tl] < b do
      inc(tl);
    while b < a[tr] do
      dec(tr);
    if tl <= tr then begin
      swap(a[tl], a[tr]);
      inc(tl);
      dec(tr);
    end;
  end;
  QSort(a, l, tr);
  QSort(a, tl, r);
end;

function BinSearch(const a: tarr; const x: integer): integer;
var
  l, r, m: integer;
begin
  l := 1;
  r := n;
  while r - l > 1 do begin
    m := (l + r) div 2;
    if a[m] < x then
      l := m + 1
    else
      r := m;
  end;
  if a[l] = x then
    Result := l
  else
    Result := r;
end;

function f(const a1, b1, a2, b2: integer): boolean;
begin
  Result := (a1 = a2) or (b1 = b2);
end;

procedure FillCnt(const l, r: integer);
var
  i: integer;
begin
  fillchar(cnta, sizeof(cnta), 0);
  fillchar(cntb, sizeof(cntb), 0);
  fillchar(cntab, sizeof(cntab), 0);
  for i := l to r do begin
    inc(cnta[a[i]]);
    inc(cntb[b[i]]);
    inc(cntab[a[i], b[i]]);
  end;
end;

procedure GetIndex(const l, r: integer; out u: integer);
var
  i: integer;
begin
  u := 0;
  for i := l to r do
    if cnta[a[i]] + cntb[b[i]] - cntab[a[i], b[i]] <> r - l + 1 then begin
      u := i;
      exit;
    end;
end;

function FindPair(const l, r: integer; const u: integer): integer;
var
  i: integer;
begin
  Result := 0;
  for i := l to r do
    if not f(a[i], b[i], a[u], b[u]) then begin
      Result := i;
      exit;
    end;
end;

begin
  reset(input, 'mosaic.in');
  rewrite(output, 'mosaic.out');
  readln(n);
  for i := 1 to n do
    readln(a[i], b[i]);
  a1 := a;
  b1 := b;
  QSort(a1, 1, n);
  QSort(b1, 1, n);
  for i := 1 to n do begin
    a[i] := BinSearch(a1, a[i]);
    b[i] := BinSearch(b1, b[i]);
  end;
  readln(k);
  for i := 1 to k do begin
    readln(l, r);
    FillCnt(l, r);
    GetIndex(l, r, u);
    if u = 0 then
      v := 0
    else
      v := FindPair(l, r, u);
    writeln(u,' ',v);
  end;
end.
