program task7;

{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

type
  tarr = array [1..40, 1..40] of boolean;
  tarr1 = array [1..40] of integer;

var
  n, m, x, y, found, dx, dy, dirx, diry: integer;
  f, f1: tarr;
  listx, listy: tarr1;

procedure Print(const dx, dy, call: integer);
begin
  writeln(dx,' ',dy,' ',call);
  flush(output);
end;

function Dist(const x1, y1: integer; const x2, y2: integer): integer;
begin
  Result := min(abs(x1 - x2), abs(y1 - y2));
end;

function GetF1(const x, y: integer): boolean;
begin
  if (x >= 1) and (x <= m) and (y >= 1) and (y <= n) then
    Result := f1[x, y]
  else
    Result := false;
end;

procedure MoveHorse(const dx, dy: integer);
var
  x, y: integer;
begin
  f1 := f;
  for x := 1 to m do
    for y := 1 to n do
      f[x, y] := GetF1(x - dx, y - dy);
end;

procedure GetDirection(const stx, sty: integer; out dirx, diry: integer);
var
  x, y, t, tx, ty, tdist, listcnt: integer;
begin
  tdist := 230000;
  listcnt := 0;
  for x := 1 to m do
    for y := 1 to n do begin
      if not f[x, y] then continue;
      if Dist(x, y, stx, sty) < tdist then begin
        tdist := Dist(x, y, stx, sty);
        listcnt := 0;
      end;
      if Dist(x, y, stx, sty) = tdist then begin
        inc(listcnt);
        listx[listcnt - 1] := x;
        listy[listcnt - 1] := y;
      end;
    end;
  t := random(listcnt);
  tx := listx[t];
  ty := listy[t];
  dirx := Sign(tx - stx);
  diry := Sign(ty - sty);
end;

begin
  randomize;
  readln(n, m);
  readln(x, y);
  fillchar(f, sizeof(f), true);
  Print(0, 0, 1);
  readln(found, dx, dy);
  while found <> 1 do begin
    f[x, y] := false;
    MoveHorse(dx, dy);
    GetDirection(x, y, dirx, diry);
    Print(dirx, diry, 1);
    inc(x, dirx);
    inc(y, diry);
    readln(found, dx, dy);
  end;
end.
 