#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define vint vector<int>
#define ll long long

const int maxn = 1e6 + 5;
const ll INF = 1e9;

ll d[maxn];

int main()
{
   ifstream cin("apricot.in");
   ofstream cout("apricot.out");
   int n, r, u;
   cin >> n >> r >> u;
   d[0] = -INF; d[1] = 0; d[2] = u;
   for(int i = 3; i <= n; i++)
      d[i] = INF;
   for(int i = 3; i <= n; i++)
      for(int j = 1; 2 * j <= i; j++)
      {
         d[i] = min(d[i], max(d[j] + u, d[i - 2 * j] + r));
      }
   cout << d[n] << endl;
}
