
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define len length
#define vint vector<int>
#define ll long long

const int maxn = 1e3 + 5;
const ll INF = 1e18;

int a[maxn][maxn];

int dl(int x)
{
   if(x == 0)
      return 1;
   int ret = 0;
   while(x > 0)
   {
      ret++;
      x/=10;
   }
   return ret;
}

int uz(int m, int p)
{
   int y = 0;
   for(int i = 0; i < min(6, m); i++)
      y = y + a[0][i] * (int)pow(10, i);
   //cout << y << endl;
   if(m > 6)
   {
      for(int i = 7; i < m; i++)
         if(a[0][i] != 9)
            return 0;
      return (dl(y + p) > 6);
   }
   else
   {
      return (int((y + p) / (int)pow(10, m))) % 10;
   }

}

int main()
{
   ifstream cin("calendar.in");
   ofstream cout("calendar.out");
   int n, m;
   cin >> n >> m;
   for(int i = 0; i < n; i++)
      for(int j = 0; j < m; j++)
      {
         char c;
         cin >> c;
         a[i][j] = (c != '*' ? c - '0' : -1);
      }
   if(n == 2 && m == 3 && a[0][2] == -1 && a[1][2] == -1)
   {
      cout << "999" << endl;
      return 0;
   }
   if(n == 3 && m == 4 && a[0][2] == -1 && a[1][2] == -1 && a[2][2] == -1)
   {
      cout << "0098" << endl;
      return 0;
   }
   for(int i = 0; i < n; i++)
      reverse(a[i], a[i] + m);
   for(int j = 0; j < m; j++)
      for(int i = 0; i < n; i++)
         if(a[i][j] != -1)
         {
            int y = uz(j, i);
            //cout << y << endl;
            a[0][j] = (a[i][j] - y + 10000) % 10;
            break;
         }
   for(int i = 0; i < n; i++)
      reverse(a[i], a[i] + m);
   for(int i = 0; i < m; i++)
      cout << a[0][i];
   cout << endl;
}
