#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define m_p make_pair
#define fi first
#define se second

const int maxn = 5e3 + 5, INF = 1e9;

int n;
int a[maxn], b[maxn];
short int g[2][maxn][maxn], pr[2][maxn][maxn];

int main()
{
   ifstream cin("mosaic.in");
   ofstream cout("mosaic.out");
   cin >> n;
   for(int i = 0; i < n; i++)
   {
      cin >> a[i] >> b[i];
   }
   for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
         if((i != j))
         {
            if(a[i] == a[j])
               g[0][i][j] = 1;
            if(b[i] == b[j] && g[0][i][j] == 0)
               g[1][i][j] = 1;
         }
   for(int i = 0; i < n; i++)
   {
      pr[0][i][0] = g[0][i][0];
      for(int j = 0; j < n; j++)
         pr[0][i][j] = pr[0][i][j - 1] + g[0][i][j];
   }
   for(int i = 0; i < n; i++)
   {
      pr[1][i][0] = g[1][i][0];
      for(int j = 0; j < n; j++)
         pr[1][i][j] = pr[1][i][j - 1] + g[1][i][j];
   }
   int k;
   cin >> k;
   for(int i = 0, x, y; i < k; i++)
   {
      cin >> x >> y;
      x--; y--;
      bool t = 0;
      for(int i = x; i <= y; i++)
         if(pr[0][i][y] - (x == 0 ? 0 : pr[0][i][x - 1]) + pr[1][i][y] - (x == 0 ? 0 : pr[1][i][x - 1]) != y - x)
         {
            for(int j = x; j <= y; j++)
               if(i != j && g[0][i][j] != 1 && g[1][i][j] != 1)
               {
                  cout << i + 1 << " "  << j + 1 << endl;
                  break;
               }
            t = 1;
            break;
         }
      if(t == 0)
         cout << 0 << " " << 0 << endl;
   }
   return 0;
}
