#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#define len length
#define m_p make_pair
#define fi first
#define se second

const int maxn = 5e3 + 5, INF = 1e9;

int n, x, y;
int a[maxn], b[maxn];
unsigned short int g[2][maxn][maxn], pr[2][maxn][maxn];

int main()
{
   ifstream cin("mosaic.in");
   ofstream cout("mosaic.out");
   cin >> n;
   for(int i = 0; i < n; i++)
   {
      cin >> a[i] >> b[i];
   }
   for(int i = 0; i < n; i++)
   {
      pr[0][i][0] = (i != 0 && a[i] == a[0]);
      pr[1][i][0] = (i != 0 && b[i] == b[0] && a[i] != a[0]);
      for(int j = 1; j < n; j++)
      {
         if((i != j))
         {
            pr[0][i][j] = pr[0][i][j - 1] + (a[i] == a[j]);
            pr[1][i][j] = pr[1][i][j - 1] + (b[i] == b[j] && a[i] != a[j]);
         }
      }
   }
   int k;
   cin >> k;
   for(int i = 0; i < k; i++)
   {
      cin >> x >> y;
      x--; y--;
      bool t = 0;
      for(int i = x; i <= y && t != 1; i++)
         if(x == 0)
         {
            if(pr[0][i][y] + pr[1][i][y] != y - x)
            {
               for(int j = i + 1; j <= y && t != 1; j++)
                  if(a[i] != a[j] && b[i] != b[j])
                  {
                     cout << i + 1 << " "  << j + 1 << endl;
                     t = 1;
                  }
            }
         }
         else
         {
            if(pr[0][i][y] - pr[0][i][x - 1] + pr[1][i][y] - pr[1][i][x - 1] != y - x)
            {
               for(int j = i + 1; j <= y && t != 1; j++)
                  if(a[i] != a[j] && b[i] != b[j])
                  {
                     cout << i + 1 << " "  << j + 1 << endl;
                     t = 1;
                  }
            }
         }
      if(t == 0)
         cout << 0 << " " << 0 << endl;
   }
   return 0;
}
