#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;
#define forn(i, n) for(i = 0; i < n; i++)

const int maxn = 2e5;
struct node{
	int v;
	node * next;
};
struct tm1{
	int in, out;
};

node * head[2][maxn];
node c[maxn * 2];
tm1 t[2][maxn];
int uk = 0;
int t1 = 0;

void add(int v, int u, int z){
	node * q;
	q = & c[uk++];
	q->next = head[z][v];
	q->v = u;
	head[z][v] = q; 
}

void dfs(int v, int z){
	node * q;
	t[z][v].in = t1;
	t1++;
	for(q = head[z][v]; q != NULL; q = q->next){
		dfs(q->v, z);
	}
	t[z][v].out = t1;
	t1++;
}

int main(){
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);
	int n, i, x, j, s1, s2;
	long long ans = 0;
	memset(head, NULL, sizeof(head));
	cin >> n;
	forn(i, n){
		scanf("%d", &x);
		if (x != 0)
			add(x - 1, i, 0);
		else
			s1 = i;
	}
	forn(i, n){
		scanf("%d", &x);
		if (x != 0)
			add(x - 1, i, 1);
		else
			s2 = i;
	}
	dfs(s1, 0);
	dfs(s2, 1);
	forn(i, n)
		forn(j, n){
			if(t[0][i].in < t[0][j].in && t[0][i].out > t[0][j].in &&
				t[1][i].in < t[1][j].in && t[1][i].out > t[1][j].in)
				ans++;
		}
	cout << ans;


	return 0;
}