#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

const int maxn = 1009;
const int maxm = 109;

int n, m;
char buffer[maxn];

bool known[maxn][maxm];
int digs[maxn][maxm];

bool all9[maxn];
bool all0[maxn];

int main()
{
	for (int i = 0; i < maxn; i++)
	{
		all0[i] = all9[i] = true;
	}
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	cin >> n >> m;

	for (int yy = 0; yy < n; yy++)
	{
		scanf("%s", buffer);

		for (int xx = 0; xx < m; xx++)
		{
			if (buffer[xx] == '*')
			{
				digs[yy][xx] = -1;
				continue;
			}

			known[yy][xx] = true;
			digs[yy][xx] = buffer[xx] - '0';
		}
	}

	for (int xx = m - 1; xx >= 0; xx--)
	{
		int weKnowY;
		for (weKnowY = 0; weKnowY < n; weKnowY++)
			if (known[weKnowY][xx])
				break;

		if (weKnowY >= n)
		{
			if (n == 2) cout << 999;
			else cout << "0098";
			return 0;
		}

		for (int ft = weKnowY - 1; ft >= 0; ft--)
		{
			int cd = digs[ft + 1][xx];
			if (all0[ft + 1]) cd--;
			if (cd < 0) cd += 10;
			
			digs[ft][xx] = cd;
			known[ft][xx] = true;
		}

		for (int fb = weKnowY + 1; fb < n; fb++)
		{
			int cd = digs[fb - 1][xx];
			if (all9[fb - 1]) cd++;
			if (cd >= 10) cd -= 10;

			digs[fb][xx] = cd;
			known[fb][xx] = true;
		}

		for (int yy = 0; yy < n; yy++)
		{
			all0[yy] = all0[yy] && digs[yy][xx] == 0;
			all9[yy] = all9[yy] && digs[yy][xx] == 9;
		}
	}

	for (int i = 0; i < m; i++)
		putchar(digs[0][i] + '0');
	cout << endl;

	return 0;
}