#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 100009;

int n, k;
int vs[maxn], hs[maxn];
int rl, rr;
int veCount = 0, heCount = 0;

int bpr[maxn]; // Best Pair Right
int crs[maxn]; // Current RighteSt

int main()
{
	for (int i = 0; i < maxn; i++)
		crs[i] = -1;
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &vs[i], &hs[i]);
		if (i == 0)
		{
			bpr[i] = 0;
			crs[i] = -1;
			veCount = heCount = 1;
			continue;
		}

		if (vs[i] != vs[i - 1]) veCount = 1;
		else veCount++;

		if (hs[i] != hs[i - 1]) heCount = 1;
		else heCount++;

		int past = i - max(veCount, heCount);

		int cl = crs[ bpr[i - 1] ] + 1;
		for (; cl <= past; cl++)
			if (vs[cl] != vs[i] && hs[cl] != hs[i])
				crs[i] = cl;

		if (crs[i] > crs[ bpr[i - 1] ]) bpr[i] = i;
		else bpr[i] = bpr[i - 1];
	}
	cin >> k;
	for (int i = 0; i < k; i++)
	{
		scanf("%d%d", &rl, &rr);
		rl--, rr--;
		int cBp = bpr[rr];
		int cLeft = crs[cBp];

		if (cLeft >= rl) printf("%d %d\n", cLeft + 1, cBp + 1);
		else printf("0 0\n");
	}

	return 0;
}