﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Task6
{
    class Program
    {
        const int EasyY = 2000003;
        const int EasyN = 3000029;
        const int maxn = 100009;

        static void Main(string[] args)
        {
            long[] esy = new long[maxn];
            esy[0] = 1;
            for (int i = 1; i < maxn; i++)
                esy[i] = esy[i - 1] * EasyY;

            StreamReader sr = new StreamReader("theater.in");
            StreamWriter sw = new StreamWriter("theater.out");

            int n, m;
            String[] sa = sr.ReadLine().Split(' ');
            n = int.Parse(sa[0]);
            m = int.Parse(sa[1]);

            long[] ahs = new long[n]; // Actor -> Hash
            Dictionary<long, HashSet<int>> hToAs = new Dictionary<long, HashSet<int>>(); // Hash -> Set of Actors
            HashSet<int> hashOne = new HashSet<int>();
            hToAs[1] = hashOne;

            for (int i = 0; i < n; i++)
            {
                ahs[i] = 1;
                hashOne.Add(i);
            }

            int[] answer = new int[n];

            for (int i = 0; i < m; i++)
            {
                sa = sr.ReadLine().Split(' ');

                HashSet<long> hashesToCheck = new HashSet<long>();

                for (int j = 1; j < sa.Length; j++)
                {
                    int ap = int.Parse(sa[j]) - 1;
                    long caHash = ahs[ap]; // Current Actor Hash
                    hashesToCheck.Add(caHash);

                    hToAs[caHash].Remove(ap);
                    caHash += (esy[i] * (i + 12));
                    hashesToCheck.Add(caHash);

                    if (!hToAs.ContainsKey(caHash)) hToAs[caHash] = new HashSet<int>();
                    hToAs[caHash].Add(ap);
                    ahs[ap] = caHash;
                }

                foreach (long hash in hashesToCheck)
                {
                    if (!hToAs.ContainsKey(hash)) continue;
                    HashSet<int> hashActors = hToAs[hash];
                    if (hashActors.Count == 0) hToAs.Remove(hash);
                    else if (hashActors.Count == 1)
                    {
                        int knownActor = hashActors.First();
                        if (answer[knownActor] != 0) continue;
                        answer[knownActor] = i + 1;
                    }
                }
            }

            foreach (int i in answer)
            {
                sw.Write(i);
                sw.Write(' ');
            }

            sw.Close();
        }
    }
}
