#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxs = 32;

int n, m;
bool cb[maxs][maxs];
int ex, ey;

inline void makeStep()
{
	bool found = false;
	int yy, xx;
	for (yy = 0; yy < n; yy++)
	{
		for (xx = 0; xx < m; xx++)
			if (cb[xx][yy])
			{
				found = true;
				break;
			}
		if (found) break;
	}

	int dx, dy;
	if (xx < ex) dx = -1;
	else if (xx > ex) dx = 1;
	else dx = 0;
	ex += dx;

	if (yy < ey) dy = -1;
	else if (yy > ey) dy = 1;
	else dy = 0;
	ey += dy;

	printf("%d %d ", dx, dy);
	if (ex == xx && ey == yy) puts("1");
	else puts("0");

	fflush(stdout);
}

void getAnswer()
{
	int ans, dx, dy;
	scanf("%d%d%d", &ans, &dx, &dy);
	if (ans == 1) exit(0);
	cb[ex][ey] = false;

	if (dx == 1)
		for (int yy = 0; yy < n; yy++)
			for (int xx = m - 1; xx >= 0; xx--)
				if (xx == 0) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx - 1][yy];
	
	if (dx == -1)
		for (int yy = 0; yy < n; yy++)
			for (int xx = 0; xx < m; xx++)
				if (xx == m - 1) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx + 1][yy];

	if (dy == 1)
		for (int xx = 0; xx < m; xx++)
			for (int yy = n - 1; yy >= 0; yy--)
				if (yy == 0) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx][yy - 1];

	if (dy == -1)
		for (int xx = 0; xx < m; xx++)
			for (int yy = 0; yy < n; yy++)
				if (yy == n - 1) cb[xx][yy] = false;
				else cb[xx][yy] = cb[xx][yy + 1];
}

int main()
{
	for (int i = 0; i < maxs; i++)
		for (int j = 0; j < maxs; j++)
			cb[i][j] = true;

	cin >> n >> m;
	cin >> ex >> ey;
	ex--, ey--;

	while (true)
	{
		makeStep();
		getAnswer();
	}

	return 0;
}