#pragma comment(linker, "/STACK:250000000")
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;
const int maxn = 17;

int n, k;
int ss[maxn];
int d[maxn][maxn];

int main()
{
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	cin >> n >> k;
	for (int i = 0; i < maxn; i++)
	{
		ss[i] = -100;
		d[0][i] = 0;
		d[i][0] = 0;
	}
	for (int i = 0; i < k; i++)
	{
		cin >> ss[i];
		//ss[i]--;
	}

	vector<int> perm;
	for (int i = 0; i < n; i++)
		perm.push_back(i + 1);

	long long answer = 0;
	do
	{
		int ssIndex = 0;
		for (int i = 0; i < n; i++)
			if (perm[i] == ss[ssIndex])
				ssIndex++;
		if (ssIndex != k) continue;

		bool good = true;
		for (int i = 1; good && i <= n; i++)
		{
			int cv = perm[i - 1];
			for (int j = 1; good && j <= n; j++)
			{
				d[i][j] = d[i - 1][j];
				if (cv <= j && d[i][j] < d[i - 1][cv - 1] + 1)
					d[i][j] = d[i - 1][cv - 1] + 1;
				if (d[i][j] > k) good = false;
			}
		}

		if (good) answer++;
	}
	while (next_permutation(perm.begin(), perm.end())) ;

	cout << answer << endl;

	return 0;
}