{$R-,Q-}
program task5;

{$APPTYPE CONSOLE}

uses
  SysUtils,Math;

type TPair=record x,y:longint; end;                            
PTree=^TTree;

TTree=record
l,r:Ptree;
x,y:longint;
end;

TItem=record
SIG:longint;
Tree:PTree;
end;

procedure printTree(T:PTree);
begin
if T=nil then exit;
writeln(T^.x);
writeln('L:');  printtree(T^.l);
writeln('R:');
printtree(T^.r);
end;


procedure Merge(var T:Ptree; l,r:PTree);
begin
if l=nil then t:=r else
if r=nil then t:=l else
 begin
  if l^.y>r^.y then
   begin
    merge(l^.r,l^.r,r);   t:=l;
   end else
   begin
    merge(r^.l,l,r^.l);   t:=r;
   end;
 end;
end;

procedure Split(t:Ptree; var l,r:Ptree; x:longint);
begin
if t=nil then
 begin
  l:=nil; r:=nil; exit;
 end else
 begin
  if t^.x>=x then
   begin
    r:=t;
    split(r^.l,l,r^.l,x);
   end else
   begin
    l:=t;
    split(l^.r,l^.r,r,x);
   end;
 end;
end;

procedure insert(var t:Ptree; it:PTree);
begin
if t=nil then
 begin
  t:=it;
 end else
if it^.y>t^.y then
 begin
   split(t,it^.l,it^.r,it^.x); t:=it;
 end else
 begin
   if it^.x>=t^.x then insert(t^.r,it) else insert(t^.l,it);
 end;
end;

procedure Erase(var T:Ptree; x:longint);
begin
if T^.x=x then merge(t,t^.l,t^.r) else
if x>=T^.x then Erase(T^.r,x) else Erase(T^.l,x);
end;

var
n,m,i,j,k,x,w,qc,lo,fc:longint;
used:array [1..100000] of longint;
S:array [1..100000] of String;
add:string;
HM:array [0..100000] of array of TItem;
Q:array [1..100000] of longint;
F:array [1..200000] of TTree;
hsh,qsh:array [1..100000] of longint;

procedure AddQ(x:longint);
begin
inc(qc);
q[qc]:=x;
end;

procedure NewMy(var x:Ptree);
begin
inc(fc);
x:=@F[fc];
end;

function Create(x:Longint):PTree;
begin
newMy(result);
result^.x:=x;
result^.y:=random(1000*1000*1000);
result^.l:=nil;
result^.r:=nil;
end;

function hash(s:string):longint;
var
i,q:longint;
begin
q:=239;
result:=0;
for i:=1 to length(s) do
 begin
  inc(result,q*(ord(s[i])-32));
  q:=q*239;
 end;
result:=abs(result mod 100000);
end;

procedure initQ;
begin
qc:=0;
end;

procedure Erase2(x:longint; hash:longint);
var
ls,hs,i:longint;
begin
hs:=abs(hash mod 100000);
ls:=length(hm[hs]);
for i:=0 to ls-1 do
 begin
  if HM[hs][i].SIG=hash then
   begin
    AddQ(hash);
    Erase(HM[hs][i].Tree,x);
    exit;
   end;
 end;
end;

procedure insert2(x:longint; hash:longint);
var
ls,hs,i:longint;
begin
hs:=abs(hash mod 100000);
ls:=length(hm[hs]);
for i:=0 to ls-1 do
 begin
  if HM[hs][i].SIG=hash then
   begin
    AddQ(hash);
    Insert(HM[hs][i].Tree,Create(x));
    exit;
   end;
 end;
setlength(hm[hs],ls+1);
hm[hs][ls].SIG:=hash;
hm[hs][ls].Tree:=Create(x);
AddQ(hash);
end;

procedure lol(x:PTree; ll:longint);
begin
if x=nil then exit;
if (x^.l)=nil then
 if x^.r=nil then
  begin used[x^.x]:=ll; 
    Erase(x,x^.x);
  end;
end;


function FindTree(hash:longint):Ptree;
var
hs,ls,i:longint;
begin
hs:=abs(hash mod 100000);
ls:=length(hm[hs]);
for i:=0 to ls-1 do
 begin
  if hm[hs][i].SIG=hash then result:=hm[hs][i].Tree;
 end;
end;

procedure parseQ(ll:longint);
var
i:longint;
begin
for i:=1 to qc do
 begin
  lol(findTree(Q[i]),ll);
 end;
end;

function Compare(x:longint):string;
var
i:longint;
begin
setlength(result,6);
for i:=1 to 6 do
 begin
  result[6-i+1]:=chr(x mod 10+48);
  x:=x div 10;
 end;
end;

begin
assign(input,'theatre.in');
assign(output,'theatre.out');
//assign(input,'input.txt');
//assign(output,'output.txt');
reset(input);
rewrite(output);
fc:=0;
readln(n,m);
for i:=1 to n do used[i]:=0;
for i:=1 to n do S[i]:='';
for i:=1 to n do insert2(i,0);
for i:=1 to n do hsh[i]:=0;
for i:=1 to n do qsh[i]:=239;
for i:=1 to m do
 begin
  read(k);
  initQ;
  for j:=1 to k do
   begin     
    read(x);
    if used[x]>0 then continue;
    add:=compare(i);
    Erase2(x,hsh[x]);
    lo:=length(s[x]);
   // setlength(s[x],lo+length(add));
    for w:=1 to length(add) do
     begin
      inc(hsh[x],qsh[x]*(ord(add[w])-32));
      qsh[x]:=qsh[x]*239;
  //    s[x][lo+w]:=add[w];
     end;
    Insert2(x,hsh[x]);
   end;
  parseQ(i);
 end;             
for i:=1 to n do write(used[i], ' '); writeln;
  { TODO -oUser -cConsole Main : Insert code here }
end.
