#include <fstream>
#include <string>
#include <string.h>

using namespace std;

#define ull unsigned long long

ifstream cin("password.in");
ofstream cout("password.out");

long long m[100500];
ull s[100500];
ull hash1[100500];
ull p = 1231;
ull power[100500];

ull magic(ull a, int &l)
{
    ull result = 0;
    ull pk = 1;
    l = 0;
    if (a == 0)
        l = 1;
    while (a != 0)
    {
        l++;
        ull k = a % 10;
        result += k * pk;
        pk *= p;
        a /= 10;
    }
    return result;
}

int main()
{
    string s1;
    string s2;
    cin >> s1 >> s2;
    int l1 = s1.length();
    int l2 = s2.length();
    s[0] = s1[0] - '0';
    hash1[0] = s1[0] - '0';
    for (int i = 1; i < l1; i++)
    {
        s[i] = s[i - 1] + s1[i] - '0';
        hash1[i] = hash1[i - 1] * p + s1[i] - '0';
    }
    ull hash2 = 0;
    ull pk = 1;
    for (int i = l2 - 1; i >= 0; i--)
    {
        hash2 += (s2[i] - '0') * pk;
        power[l2 - 1 - i] = pk;
        pk *= p;
    }
    ull k = 0;
    ull p1 = 10;
    m[0] = 1;
    for (int i = 1; i <= l1; i++)
    {
        k += 9;
        m[i] = m[i - 1];
        if (k / p1 > 0)
        {
            p1 *= 10;
            m[i]++;
        }
    }
    int delta = l1 - l2;
    for (int i = 1; i <= l1; i++)
    {
        int Min = i - m[i];
        int Max = i - 1;
        if (delta >= Min && delta <= Max)
        {
            for (int j = i - 1; j < l1; j++)
            {
                ull sum = s[j];
                int l = 0;
                if (j >= i)
                    sum -= s[j - i];
                ull h = magic(sum, l);
                ull hs = 0;
                if (j >= i);
                    hs += hash1[j - i];
                hs = hs * power[l] + h;
                ull hp = hash1[l1 - 1] - hash1[j] * power[l1 - 1 - j];
                hs = hs * power[l1 - j - 1] + hp;
                if (hs == hash2)
                {
                    cout << j - i + 2 << " " << j + 1;
                    return 0;
                }
            }
        }
    }
    return 0;
}
