#include <fstream>
#include <string>
#include <string.h>

using namespace std;

#define ull unsigned long long

ifstream cin("calendar.in");
ofstream cout("calendar.out");

const ull inf = 10000000000000000LL;

string s[100500];
ull power[100500];
int change[100500];

int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
    }
    power[0] = 1;
    for (int i = 1; i <= m; i++)
    {
        power[i] = power[i - 1] * 10;
        if (power[i] > n)
            power[i] = inf;
    }
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (s[j][i] != '*')
            {
                int k = s[j][i] - '0';
                long long z = j + power[m - i - 1];
                while (z < n && s[z][i] == '*')
                {
                    k = (k + 1) % 10;
                    s[z][i] = '0' + k;
                    z = z + power[m - i - 1];
                }
                z = j - power[m - i - 1];
                k = s[j][i] - '0';
                while (z >= 0 && s[z][i] == '*')
                {
                    k--;
                    if (k < 0)
                        k = 9;
                    s[z][i] = '0' + k;
                    z = z - power[m - i - 1];
                }
            }
        }
    }
    for (int i = 0; i < m; i++)
        change[i] = -1;
    change[m - 1] = 0;
    bool ch = true;
    while (ch)
    {
        ch = false;
        for (int i = m - 1; i >= 0; i--)
        {
            for (int j = 1; j < n; j++)
            {
                if (change[i] == -1 && s[j][i] != s[j - 1][i] && s[j][i] != '*' && s[j - 1][i] != '*')
                {
                    for (int k = i; k < m; k++)
                    {
                        change[k] = (j - 1) % power[m - k - 1];
                        if (k != i)
                        {
                            s[j - 1][k] = '9';
                            s[j][k] = '0';
                        }
                    }
                }
                if (i != 0 && s[j][i] == '0' && s[j - 1][i] == '9')
                {
                    for (int k = i - 1; k < m; k++)
                    {
                        change[k] = (j - 1) % power[m - k - 1];
                        if (k != i - 1)
                        {
                            s[j - 1][k] = '9';
                            s[j][k] = '0';
                        }
                    }
                }
            }
        }
        for (int i = 0; i < m; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (change[i] != -1 && s[j][i] != '*')
                {
                    int z = j + 1;
                    int k = s[j][i] - '0';
                    if (i == m - 1)
                        k = (k + 1) % 10;
                    while (z < n && s[z][i] == '*')
                    {
                        s[z][i] = '0' + k;
                        if (z % power[m - i - 1] == change[i])
                            k = (k + 1) % 10;
                        z++;
                        ch = true;
                    }
                    z = j - 1;
                    k = s[j][i] - '0';
                    while (z >= 0 && s[z][i] == '*')
                    {
                        if (z % power[m - i - 1] == change[i])
                            k = k == 0 ? 9 : k - 1;
                        s[z][i] = k + '0';
                        z--;
                        ch = true;
                    }
                }
            }
        }
        if (!ch)
        {
            for (int i = 0; i < m; i++)
            {
                if (change[i] == -1)
                {
                    change[i] = n - 1;
                    ch = true;
                }
            }
        }
    }
    int l = s[0].length();
    for (int i = 0; i < l; i++)
        if (s[0][i] == '*')
            s[0][i] = '0';
    cout << s[0];
    return 0;
}
