#include <fstream>
#include <vector>

using namespace std;

ifstream cin("mosaic.in");
ofstream cout("mosaic.out");

vector<pair<int, int> > v;
int cw[100500], ch[100500];


int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int k1, k2;
        cin >> k1 >> k2;
        v.push_back(make_pair(k1, k2));
    }
    cw[0] = 0;
    ch[0] = 0;
    for (int i = 1; i < n; i++)
    {
        cw[i] = cw[i - 1];
        ch[i] = ch[i - 1];
        if (v[i].first != v[i - 1].first)
            cw[i] = i;
        if (v[i].second != v[i - 1].second)
            ch[i] = i;
    }
    int k;
    cin >> k;
    for (int i = 0; i < k; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        if (ch[l] == ch[r] || cw[l] == cw[r])
            cout << 0 << " " << 0 << endl;
        else
        {
            int j = max(ch[r], cw[r]) - 1;
            if (v[j].first != v[r].first && v[j].second != v[r].second)
                cout << j + 1 << " " << r + 1 << endl;
            else
            {
                int next;
                if (ch[r] == ch[j])
                {
                    next = ch[j] - 1;
                    if (v[next].first != v[r].first)
                        cout << next + 1 << " " << r + 1 << endl;
                    else
                        cout << next + 1 << " " << j + 1 << endl;
                }
                else
                {
                    next = cw[j] - 1;
                    if (v[next].second != v[r].second)
                        cout << next + 1 << " " << r + 1 << endl;
                    else
                        cout << next + 1 << " " << j + 1 << endl;
                }
            }
        }
    }
    return 0;
}
