#include <iostream>
#include <cstdlib>

using namespace std;

bool can[50][50], canbefore[50][50];
int n, m;

void setval(int x,int y, bool value)
{
    if (x > 0 && x <= m && y > 0 && y <= n)
        can[y][x] = value;
}

int main()
{
    cin >> n >> m;
    int x, y;
    cin >> x >> y;
    bool start = true;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            can[i][j] = true;
        }
    while (true)
    {
        if (start)
        {
            cout << "0 0 1" << endl;
            cout.flush();
            start = false;
        }
        int dx, dy, state;
        cin >> state >> dx >> dy;
        if (state == 1)
            break;
        can[y][x] = false;
        for (int i = 0; i <= n + 1; i++)
            for (int j = 0; j <= m + 1; j++)
                canbefore[i][j] = can[i][j];
        for (int i = 0; i <= n + 1; i++)
            for (int j = 0; j <= m + 1; j++)
            {
                setval(j + dx, i + dy, canbefore[i][j]);
            }
        int m = 1000000000, mx = 0, my = 0;
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= m; j++)
            {
                if (can[i][j])
                {
                    int dist = max(abs(y - i), abs(x - j));
                    if (dist < m)
                    {
                        mx = j;
                        my = i;
                        m = dist;
                    }
                }
            }
        dx = 0;
        dy = 0;
        state = 0;
        if (x > mx)
            dx = -1;
        if (x < mx)
            dx = 1;
        if (y > my)
            dy = -1;
        if (y < my)
            dy = 1;
        if (can[y + dy][x + dx])
            state = 1;
        x = x + dx;
        y = y + dy;
        cout << dx << " " << dy << " " << state << endl;
        cout.flush();
    }
    return 0;
}
