#include <fstream>
#include <vector>

using namespace std;

ifstream cin("army.in");
ofstream cout("army.out");

int maxc[20];
bool used[20];
int l = 0;
int c[20];
int n, cnt;
vector<int> a;
int ans = 0;
int last = 0;
int more = 0;
int first = 0, firstv = 0;

void solve(int pos)
{
    if (pos == n)
    {
        ans++;
        return;
    }
    if (c[pos] == -1)
    {
        for (int i = 1; i <= n; i++)
        {
            if (pos < first && i < firstv)
                continue;
            if (!used[i])
            {
                int k = i;
                c[pos] = k;
                used[k] = true;
                int le = 0;
                int ri = l + 1;
                while (ri - le > 1)
                {
                    int j = (ri + le) / 2;
                    if (maxc[j] >= k)
                        ri = j;
                    else
                        le = j;
                }
                int prev = maxc[le + 1];
                int prevl = l;
                if (le + 1 > l)
                {
                    l++;
                    if (l > cnt)
                    {
                        l--;
                        used[k] = false;
                        c[pos] = -1;
                        break;
                    }
                }
                maxc[le + 1] = k;
                if (k > c[last])
                    more++;
                solve(pos + 1);
                if (k > c[last])
                    more--;
                maxc[le + 1] = prev;
                l = prevl;
                used[k] = false;
                c[pos] = -1;
            }
        }
    }
    else
    {
        int k = c[pos];
        if (pos == last && more < n - c[last])
            return;
        int le = 0;
        int ri = l + 1;
        while (ri - le > 1)
        {
            int j = (ri + le) / 2;
            if (maxc[j] >= k)
                ri = j;
            else
                le = j;
        }
        int prev = maxc[le + 1];
        int prevl = l;
        if (le + 1 > l)
        {
            l++;
            if (l > cnt)
            {
                l--;
                return;
            }
        }
        maxc[le + 1] = k;
        solve(pos + 1);
        maxc[le + 1] = prev;
        l = prevl;
    }
}

void put(int index, int pos)
{
    if (index == cnt)
    {
        solve(0);
        return;
    }
    for (int i = pos; i + cnt - index <= n; i++)
    {
        if (index == 0)
            first = i;
        c[i] = a[index];
        last = i;
        put(index + 1, i + 1);
        c[i] = -1;
    }
}

int main()
{
    maxc[0] = -1;
    cin >> n >> cnt;
    for (int i = 0; i < n; i++)
    {
        c[i] = -1;
    }
    for (int i = 0; i < cnt; i++)
    {
        int k1;
        cin >> k1;
        used[k1] = true;
        a.push_back(k1);
    }
    firstv = a[0];
    put(0, 0);
    cout << ans;
    return 0;
}
