#include <iostream>
#include <vector>
using namespace std;
typedef long long int64;

int n;
int64 ans;

vector <vector <int>> g, vir;
vector <vector <short>> d, dv;

void dfs (int u, int p) {
	if (p != -1) {
		d[u][p] = true;
		for (int i = 0; i < n; ++i)
			d[u][i] = d[u][i] || d[p][i];
	}
	for (int i = 0; i < g[u].size(); ++i) {
		int v = g[u][i];
		dfs (v, u);
	}
}

void dfsv (int u, int p) {
	if (p != -1) {
		dv[u][p] = true;
		for (int i = 0; i < n; ++i) {
			dv[u][i] = (dv[u][i] || dv[p][i]);
			ans += (dv[u][i] && d[u][i]);
		}
	}
	for (int i = 0; i < vir[u].size(); ++i) {
		int v = vir[u][i];
		dfsv (v, u);
	}
}

void main () {
	freopen ("virus.in", "r", stdin);
	freopen ("virus.out", "w", stdout);

	cin >> n;
	g.resize (n);
	d.resize (n, vector<short> (n));
	int c = 0;
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t) g[t-1].push_back(i);
		else c = i;
	}
	dfs (c, -1);
	vir.resize (n);
	dv.resize (n, vector<short> (n));
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t) vir[t-1].push_back(i);
		else c = i;
	}
	dfsv (c, -1);
	cout << ans;
}