#include <iostream>
#include <vector>
using namespace std;

const int N = 100000;

int n, k;

vector <pair <int, int>> a;
vector <vector <pair <int, int>>> gar;

void main () {
	freopen ("mosaic.in", "r", stdin);
	freopen ("mosaic.out", "w", stdout);

	cin >> n;
	a.resize (n);
	gar.resize (n, vector<pair<int,int>> (n));
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
		for (int j = 0; j < i; ++j)
			if (a[j].first != a[i].first && a[j].second != a[i].second) gar[j][i] = make_pair(j + 1, i + 1);
	}
	for (int i = 0; i < n; ++i) {
		int j = 0;
		while (j < n && gar[i][j] == make_pair(0,0)) ++j;
		for (int x = j + 1; x < n; ++x)
			gar[i][x] = gar[i][j];
	}
	for (int j = 0; j < n; ++j) {
		int i = n-1;
		while (i >= 0 && gar[i][j] == make_pair(0,0)) --i;
		for (int x = i - 1; x >= 0; --x)
			gar[x][j] = gar[i][j];
	}
	cin >> k;
	for (int i = 0; i < k; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		cout << gar[l][r].first << " " << gar[l][r].second << endl;
	}
}