#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

using namespace std;

const int L = int(1e5 + 5);
const LL P = LL(1e9) + 7;

char s[2][L];
int l[2], pref[L];
LL hash[2][L], p[L];

void precalc() {
	p[0] = 1;
	for (int i = 1; i < L; i++)
		p[i] = p[i - 1] * P;

	for (int j = 0; j < 2; j++) {
		hash[j][0] = s[j][0];
		for (int i = 1; i < l[j]; i++)
			hash[j][i] = hash[j][i - 1] * P + s[j][i];
	}			

	pref[0] = int(s[0][0] - '0');
	for (int i = 1; i < l[0]; i++) 
		pref[i] = pref[i - 1] + int(s[0][i] - '0');		
}

LL count_hash(int num, int l, int r) {
	if (r < l) return 0;
	if (!l) return hash[num][r];
	return hash[num][r] - hash[num][l - 1] * p[r - l + 1];
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	for (int i = 0; i < 2; i++) {
		gets(s[i]);
		l[i] = strlen(s[i]);
	}

	precalc();

	for (int i = 0; i < l[1]; i++) {
		for (int j = 1; j < 7 && i + j <= l[1]; j++) {
			if (i == 0 || count_hash(0, 0, i - 1) == count_hash(1, 0, i - 1)) {
				int rest_len = l[1] - i - j;

				if (count_hash(0, l[0] - rest_len, l[0] - 1) == count_hash(1, l[1] - rest_len, l[1] - 1)) {
					int sum = pref[ l[0] - rest_len - 1];
					if (i > 0)
						sum -= pref[i - 1];

					int dig = 0;
					for (int k = i; k < i + j; k++)
						dig = dig * 10 + int(s[1][k] - '0');

					if (dig == sum) {
						printf("%d %d\n", i + 1, l[0] - rest_len);
						return 0;
					}	
				}			
			}
		}
	}

	return 0;
}