#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

using namespace std;

const int L = int(1e5 + 5);

char s[2][L];
int l[2], pref[L], common_suff;

void precalc() {
	pref[0] = int(s[0][0] - '0');
	for (int i = 1; i < l[0]; i++) 
		pref[i] = pref[i - 1] + int(s[0][i] - '0');		

	int i, j;
	for (i = l[0] - 1, j = l[1] - 1; i > 0 && j > 0; i--, j--)
		if (s[0][i] != s[1][i])
			break;
		else
			common_suff++;			
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);

	for (int i = 0; i < 2; i++) {
		gets(s[i]);
		l[i] = strlen(s[i]);
	}

	precalc();

	for (int i = 0; i < l[1]; i++) {
		if (i)
			if (s[0][i - 1] != s[1][i - 1]) 
				break;

		for (int j = 1; j < 7 && i + j <= l[1]; j++) {			
				int rest_len = l[1] - i - j;

				if (rest_len <= common_suff) {
					int sum = pref[ l[0] - rest_len - 1];
					if (i > 0)
						sum -= pref[i - 1];

					int dig = 0;
					for (int k = i; k < i + j; k++)
						dig = dig * 10 + int(s[1][k] - '0');

					if (dig == sum) {
						printf("%d %d\n", i + 1, l[0] - rest_len);
						return 0;
					}	
				}			
		}		
	}

	return 0;
}
