#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

using namespace std;

const int N = int(1e5 + 5);

int timer, t_in[2][N], t_out[2][N], root[2];
vector<int> graph[2][N];
LL res;

void dfs(int num, int v) {
	t_in[num][v] = ++timer;
	for (int i = 0; i < sz(graph[num][v]); i++) {
		int to = graph[num][v][i];
		if (!t_in[num][to])
			dfs(num, to);		
	}
	t_out[num][v] = ++timer;
}

int main() {
	freopen("virus.in", "r", stdin);
	freopen("virus.out", "w", stdout);

	int n;
	scanf("%d", &n);

	for (int i = 0; i < 2; i++)
		for (int j = 1; j <= n; j++) {
			int p;
			scanf("%d", &p);
			if (!p)
				root[i] = j;
			else
				graph[i][p].pb(j);
		}

	for (int i = 0; i < 2; i++) {
		timer = 0;
		dfs(i, root[i]);
	}

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++) {
			if (i != j) {
				if (t_in[0][i] < t_in[0][j] && t_out[0][j] < t_out[0][i])
					if (t_in[1][i] < t_in[1][j] && t_out[1][j] < t_out[1][i])
						res++;
			}			
		}

	printf("%I64d\n", res);

	return 0;
}
