#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size() 
#define pb push_back
#define mp make_pair
#define y1 Y1
#define y2 Y2

using namespace std;

const int N = int(1e6 + 5);
const LL INF = LL(1e13);

int n, r, u;
LL dp[N];

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);

	scanf("%d%d%d", &n, &r, &u);

	for (int i = 2; i <= n; i++)
		dp[i] = INF;
	dp[1] = 0;

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j * 2 <= i; j++) {
			if (i - 2 * j == 0)
				dp[i] = min(dp[i], dp[j] + u);
			else
				dp[i] = min(dp[i], max(dp[i - 2 * j] + r, dp[j] + u));
		}
	}

	printf("%I64d\n", dp[n]);

	return 0;
}