#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

const int N = int(1e5 + 5);

int a[N], b[N], n, q, L[N], R[N], near1[N], near2[N];

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 1; i <= n; i++) 
		scanf("%d%d", a + i, b + i);

	scanf("%d", &q);

	for (int i = 0; i < q; i++) 		
		scanf("%d%d", L + i, R + i);

	for (int i = 1; i <= n; i++) {
		for (int j = i + 1; j <= n + 1; j++) {
			if (a[i] != a[j] && b[i] != b[j]) {
				near2[i] = j;
				break;
			}
		}
		for (int j = i - 1; j >= 0; j--) {
			if (a[i] != a[j] && b[i] != b[j]) {
				near1[i] = j;
				break;
			}
		}
	}

	for (int i = 0; i < q; i++) {
		for (int j = L[i]; j <= R[i] + 1; j++) {
			if (j == R[i] + 1) {
				puts("0 0");
				break;
			}
			if (near1[j] >= L[i]) {
				printf("%d %d\n", j, near1[j]);
				break;
			}
			if (near2[j] <= R[i]) {
				printf("%d %d\n", j, near2[j]);
				break;
			}
		}
	}
		

	return 0;
}


