#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

const int N = int(1e4 + 5);
vector<int> act[N];
bool ok[N], in[N];
int ans[N];
bool play[N][N];     

int main() {
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	int n, m;
	scanf("%d%d", &n, &m);

	int unknown = n;

	for (int i = 0; i < m; i++) {
		int cnt;
		scanf("%d", &cnt);
		for (int j = 0; j < cnt; j++) {
			int a;
			scanf("%d", &a);
			act[i].pb(a);
			play[i][a] = true;
		}			
	}

	for (int i = 0; i < m; i++) { 
		int cnt = 0, ind;
		for (int j = 0; j < sz(act[i]); j++)
			if (!ok[ act[i][j] ]) {
				cnt++;
				ind = act[i][j];
				in[ act[i][j] ] = true;
			}

		if (unknown - cnt == 1) {
			for (int j = 1; j <= n; j++)
				if (!ok[j] && !in[j]) {
					ans[j] = i + 1;
					ok[j] = true;
					unknown--;
					break;					
				}
		}

		if (cnt == 1) { 
			ans[ind] = i + 1;
			ok[ind] = true;
			unknown--;	
		}

		for (int k = 0; k < i; k++) {
			int dif1 = 0, dif2 = 0;
			for (int j = 1; j <= n; j++) {
				if (!ok[j]) {
					if (play[k][j] && !play[i][j]) {
						if (!dif1)
							dif1 = j;
						else
							dif1 = -1;
					}
					if (!play[k][j] && play[i][j]) {
						if (!dif2)
							dif2 = j;
						else
							dif2 = -1;
					}

				}
			}
			if (dif1 != -1 && dif1) {
				ans[dif1] = i + 1;
				ok[dif1] = true;
				unknown--;
			}
			if (dif2 != -1 && dif2) {
				ans[dif2] = i + 1;
				ok[dif2] = true;
				unknown--;
			} 
		}

		cnt = 0;
		for (int j = 0; j < sz(act[i]); j++)
			if (!ok[ act[i][j] ]) 
				cnt++;				

		if (unknown - cnt == 1) {			
			for (int j = 1; j <= n; j++)
				if (!ok[j] && !in[j]) {
					ans[j] = i + 1;
					ok[j] = true;
					unknown--;
					break;					
				}
		}
				
		if (cnt == 1) { 
			ans[ind] = i + 1;
			ok[ind] = true;			
			unknown--;
		}

		for (int j = 0; j < sz(act[i]); j++)			
			in[ act[i][j] ] = false;
	}

	for (int i = 1; i <= n; i++)
		printf("%d ", ans[i]);

	return 0;
}


