#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

const int N = int(1e4 + 5);
vector<int> act[N];
bool ok[N];
int ans[N], con[N];
bool same[N][N], play[N][N];     

int main() {
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	int n, m;
	scanf("%d%d", &n, &m);

	for (int i = 0; i < m; i++) {
		int cnt;
		scanf("%d", &cnt);
		for (int j = 0; j < cnt; j++) {
			int a;
			scanf("%d", &a);
			act[i].pb(a);
			play[i][a] = true;
		}				
	}

	for (int i = 1; i <= n; i++) {
		con[i] = n - 1;
		for (int j = 1; j <= n; j++)
			same[i][j] = true;
	}

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < sz(act[i]); j++) {
			for (int k = 1; k <= n; k++)
				if (!play[i][k]) {
					if (same[ act[i][j] ][k]) {
						same[ act[i][j] ][k] = same[k][ act[i][j] ] = false;
						con[ act[i][j] ]--;
						con[k]--;
					}
				}
		}
		for (int j = 1; j <= n; j++)
			if (!ok[j] && con[j] == 0) {
				ans[j] = i + 1;
				ok[j] = true;
			}							
	}

	for (int i = 1; i <= n; i++)
		printf("%d ", ans[i]);

	return 0;
}


