#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <cstdio>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long LL;
typedef long double LD;

#define sz(A) (int)(A).size()
#define pb push_back
#define mp make_pair

const int N = int(1e5 + 5);
int ans[N], num[N], cnt[2 * N], tr[2 * N], qu[N], upd[2 * N];
set<int> h[2 * N], cands;

int main() {
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);

	int n, m;
	scanf("%d%d", &n, &m);

	for (int i = 1; i <= n; i++)
		num[i] = 1, cnt[1]++, h[1].insert(i);
	int cur = 1;

	for (int i = 0; i < m; i++) {
		int c;
		scanf("%d", &c);
		cands.clear();

		for (int j = 0; j < c; j++) {
			scanf("%d", &qu[j]);
			int a = qu[j];

			if (!tr[ num[a] ] || upd[ num[a] ] < i + 1) {
				cur++;
				tr[ num[a] ] = cur;
				upd[ num[a] ] = i + 1;				
			}
			cnt[ num[a] ]--;
			h[ num[a] ].erase(a);

			if (cnt[ num[a] ] == 1) 
				cands.insert(num[a]);
			if (cnt[ num[a] ] == 0)
				cands.erase(num[a]);

            num[a] = tr[ num[a] ];
			cnt[ num[a] ]++;
			if (cnt[ num[a] ] == 2)
				if (cands.count(num[a])) 
					cands.erase(num[a]);
			
			if (cnt[ num[a] ] == 1)
				cands.insert(num[a]);

			h[ num[a] ].insert(a);
		}				

		for (set<int>::iterator j = cands.begin(); j != cands.end(); j++) {
			int numb = *j;
			int a = *h[numb].begin();
			if (!ans[a])
				ans[a] = i + 1;
		}				           
	}

	for (int i = 1; i <= n; i++)
		printf("%d ", ans[i]);

	return 0;
}


