#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const int NMAX = 200000;

string s1, w1, s2, w2;
int ns, nw, k, t;
int sum[NMAX];
int num[NMAX][10];
int cmp1[NMAX];
int cmp2[NMAX];
int dig[1000000];

inline int num_dig(int k)
{
    if (k == 0)
        return 1;
    
    int ans = 0;
    
    while (k)
    {
        ans++;
        k /= 10;
    }
    
    return ans;
}

int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
    
    getline(cin, s1);
    getline(cin, w1);
    
       
    if (s1 == w1)
    {
        cout << "1 1";
        return 0;
    }
    
    ns = s1.size();
    nw = w1.size();
    
    s2 = s1;
    reverse(s2.begin(), s2.end());
    
    w2 = w1;
    reverse(w2.begin(), w2.end());
    
    sum[0] = s1[0] - '0';
    
    for (int i = 1; i < ns; i++)
        sum[i] = sum[i - 1] + s1[i] - '0';
        
    for (int i = 0; i < 1000000; i++)
        dig[i] = num_dig(i);
        
    for (int i = 0; i < nw; i++)
    {
        for (int j = 0; j < 6; j++)
        {
            if (i + j > nw)
                break;
            
            for (int l = i; l < i + j; l++)
                num[i][j] = num[i][j] * 10 + w1[l] - '0';
    
            //cout << num[i][j] << ' ';
        }
        
        //cout << endl;
    }
    
    for (int i = 0; i < min(ns, nw); i++)
        if (s1[i] == w1[i])
            cmp1[i] = (i ? cmp1[i - 1] : 0) + 1;
        else
            break;
        
    for (int i = 0; i < min(ns, nw); i++)
        if (s2[i] == w2[i])
            cmp2[i] = (i ? cmp2[i - 1] : 0) + 1;
        else
            break;
        
    for (int i = 0; i < ns; i++)
    {
        if (i && cmp1[i - 1] == 0)
            break;
        
        for (int j = ns - 1; j >= i; --j)
        {
            if (j < ns - 1 && cmp2[ns - j - 2] == 0)
                break;
            
            k = sum[j] - (i ? sum[i - 1] : 0);
            t = nw - (ns - (j - i + 1));
            
            //cout << k << ' ' << t << ' ' << i << endl;
            
            if (t > 0 && dig[k] == t && k == num[i][t])
            {
                cout << i + 1 << ' ' << j + 1 << endl;
                return 0;
            }
        }
    }
}
