#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;


const int INF = 1000000000;

int n, r, u, x, y;
int d[100001];
int w[100001];

void solve1()
{
    d[1] = 0;
    d[2] = u;
     
    for (int i = 3; i <= n; i++)
        d[i] = INF;
     
    for (int i = 3; i <= n; i++)
    {
        for (int j = 1; j < i; j++)
        {
            x = i / j;
            y = i % j;
             
            if (x == 2 && y == 0)
                d[i] = min(d[i], u + d[j]);
            else
                d[i] = min(d[i], max(r + d[i - j * 2], u + d[j]));
        }
    }
     
    cout << d[n];
    exit(0);
}

int main()
{
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    
    cin >> n >> r >> u;
    
    if (n <= 200)
        solve1();
    
    d[1] = 0;
    d[2] = u;
    
    w[1] = max(u, r);
    w[2] = max(u, r);
    
    for (int i = 3; i <= n; i++)
        d[i] = w[i] = INF;
    
    for (int i = 3; i <= n; i++)
    {
        for (int j = 1; j * 2 <= i; j++)
        {            
            if (j * 2 == i)
                d[i] = min(d[i], u + d[j]);
            else
                d[i] = min(d[i], max(r + d[i - j * 2], u + d[j]));
            //cout << i << ' ' << j << ' ' << d[i] << endl;
        }
        
        for (int j = 1; j * 2 <= i; j++)
        {            
            if (j * 2 == i)
                w[i] = min(w[i], max(r, u + d[j]));
            else
                w[i] = min(w[i], max(r + w[i - j * 2], u + d[j]));
            //cout << i << ' ' << j << ' ' << d[i] << endl;
        }
        
        for (int j = 1; j < i; j++)
            d[i] = min(d[i], d[i - j] + w[j]);
    }
    
    cout << d[n];
}
