
#include <set>
#include <map>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <cstdio>
#define INF 1e9
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < n; i++)
#define MAXN 120000

using namespace std;

typedef long long ll;

int n, k;
int d[2][MAXN];
int a[2][MAXN];

bool check(int i, int j)
{
    if (i == j)
        return false;
    if (a[0][i] == a[0][j])
        return true;
    if (a[1][i] == a[1][j])
        return true;
    return false;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("mosaic.in", "r", stdin);
    freopen("mosaic.out", "w", stdout);
    cin >> n;
    forn (i, n)
    {
        scanf("%d%d", &a[0][i], &a[1][i]);
    }
    for (int j = 0; j < 2; j++)
    {
        d[j][n - 1] = 1;
        for (int i = n - 2; i >= 0; i--)
        {
            if (a[j][i] == a[j][i + 1])
            {
                d[j][i] = d[j][i + 1] + 1;
            }
            else
            {
                d[j][i] = 1;
            }
        }
    }
//    forn (i, n)
//    {
//       printf("(%d)", d[0][i]);
//    }
    cin >> k;
    int l, r, len;
    forn (it, k)
    {
        scanf("%d%d", &l, &r);
        l--, r--;
        len = r - l + 1;
        //printf(">%d\n", len);
        if (d[0][l] >= len || d[1][l] >= len)
        {
            printf("0 0\n");
        }
        else
        {
            int i = l + d[0][l];
            int j = l + d[1][l];
            //printf("<%d %d>\n", i, j);
            if (check(i, j))
            {
                printf("%d %d\n", i + 1, j + 1);
                continue;
            }
            if (check(l, i))
            {
                printf("%d %d\n", i + 1, l + 1);
                continue;
            }
            if (check(l, j))
            {
                printf("%d %d\n", j + 1, l + 1);
                continue;
            }
        }
    }
    return 0;
}
