#include <cstdio>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

#define FN "army"
#define pb push_back

typedef long long ll;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(FN".in", "r", stdin);
	freopen(FN".out", "w", stdout);
#endif
	int n, m, p[16], cx = 0, d[16], mx = -1;
	ll f[16], ans = 0;
	f[0] = 1;
	for (int i = 1; i < 16; i++)
		f[i] = f[i - 1] * i;
	vector<int> a;
	scanf("%d", &n);
	scanf("%d", &m);
	for (int i = 0; i < m; i++)
		scanf("%d", p + i);
	for (int i = 0; i < n; i++)
		a.pb(i + 1);
	int kk = f[n];
	for (int _ = 0; _ < kk; _++) {
		cx = 0;
		for (int i = 0; i < n; i++)
			if (cx < m && a[i] == p[cx]) cx++;
		if (cx < m) {
			next_permutation(a.begin(), a.end());
			continue;
		}
		for (int i = 0; i < n; i++)
			d[i] = 1;
		mx = -1;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < i; j++)
				if (a[j] < a[i] && d[j] >= d[i]) d[i] = d[j] + 1;
		for (int i = 0; i < n; i++)
			mx = max(mx, d[i]);
		ans += (int)(mx == m);
		next_permutation(a.begin(), a.end());
	}
	printf("%d", ans);
}