#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

typedef long long int64;

const int64 p = 13;
string a, b;
int n, m;
int s[100100];
int64 ha[100100], hb[100100], ppow[100100];

int main() {
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);
	cin >> a >> b;
	n = a.size();
	m = b.size();
	forn (i, n) {
		a[i] -= '0';
	}
	forn (i, m) {
		b[i] -= '0';
	}
	s[0] = 0;
	ha[0] = 0;
	forn (i, n) {
		s[i + 1] = s[i] + a[i];
		ha[i + 1] = p * ha[i] + a[i];
	}
	hb[0] = 0;
	forn (i, m) {
		hb[i + 1] = p * hb[i] + b[i];
	}
	ppow[0] = 1;
	forn (i, 100010) {
		ppow[i + 1] = ppow[i] * p;
	}
	forab (len, 1, 7) {
		forn (i, m - len + 1) {
			if (b[i] == 0) {
				continue;
			}
			int cur = 0;
			forab (j, i, i + len) {
				cur *= 10;
				cur += b[j];
			}
			cur += s[i];
			int l = i, r = n;
			while (l < r - 1) {
				int mid = (l + r) >> 1;
				if (s[mid] >= cur) {
					r = mid;
				} else {
					l = mid;
				}
			}
			if (s[r] != cur || n - (r - i) != m - len) {
				continue;
			}
			if (ha[n] * ppow[n - r] - ha[r] != hb[m] * ppow[m - len - i] - hb[i + len]) {
				continue;
			}
			cout << i + 1 << " " << r << endl;
			return 0;
		}
	}
	int len = n - m + 1;
	forn (i, n) {
		if (a[i]) {
			continue;
		}
		if (ha[i] * ppow[len] == ha[i + len]) {
			cout << i + 1 << " " << i + len;
			return 0;
		}
	}
}
