#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

typedef long long int64;

string a, b;
int n, m;
int s[100100];
bool eq[100100];

int main() {
	freopen("password.in", "rt", stdin);
	freopen("password.out", "wt", stdout);
	cin >> a >> b;
	n = a.size();
	m = b.size();
	forn (i, n) {
		a[i] -= '0';
	}
	forn (i, m) {
		b[i] -= '0';
	}
	s[0] = 0;
	forn (i, n) {
		s[i + 1] = s[i] + a[i];
	}
	eq[0] = true;
	forn (i, m) {
		eq[i + 1] = eq[i];
		if (a[n - i - 1] != b[m - i - 1]) {
			eq[i + 1] = false;
		}
	}
	forab (len, 1, 7) {
		forn (i, m - len + 1) {
			if (b[i] == 0) {
				continue;
			}
			int cur = 0;
			forab (j, i, i + len) {
				cur *= 10;
				cur += b[j];
			}
			cur += s[i];
			int l = i, r = n;
			while (l < r - 1) {
				int mid = (l + r) >> 1;
				if (s[mid] >= cur) {
					r = mid;
				} else {
					l = mid;
				}
			}
			if (s[r] != cur || n - (r - i) != m - len || !eq[n - r]) {
				continue;
			}
			cout << i + 1 << " " << r << endl;
			return 0;
		}
	}
	int len = n - m + 1;
	forn (i, n) {
		if (b[i]) {
			continue;
		}
		if (s[i] == s[i + len] && eq[n - len - i]) {
			cout << i + 1 << " " << i + len;
			return 0;
		}
	}
}
