#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <ctime>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

typedef long long int64;

int d[1000100], t[4000100];
int l, r;

inline void upd(int v, int l, int r, int i) {
	if (l == r - 1) {
		t[v] = d[l];
		return;
	}
	int m = (l + r) >> 1, ls = v << 1, rs = ls | 1;
	if (i < m) {
		upd(ls, l, m, i);
	} else {
		upd(rs, m, r, i);
	}
	t[v] = min(t[ls], t[rs]);
}

inline int get1(int v, int L, int R) {
	if (r <= L || R <= l) {
		return 2000000000ll;
	}
	if (l <= L && R <= r) {
		return t[v];
	}
	int M = (L + R) >> 1;
	return min(get1(v << 1, L, M), get1((v << 1) | 1, M, R));
}

int get(int v, int L, int R, int l1, int r1) {
	l = l1;
	r = r1;
	return get1(v, L, R);
}

int main() {
	freopen("apricot.in", "rt", stdin);
	freopen("apricot.out", "wt", stdout);
	forn (i, 4000100) {
		t[i] = 2000000000ll;
	}
	int n, u, r;
	cin >> n >> r >> u;
	forn (i, n) {
		d[i + 1] = 2000000000ll;
	}
	d[0] = -d[1];
	upd(1, 0, n + 1, 0);
	d[1] = 0;
	upd(1, 0, n + 1, 1);
	int cur0 = 1, cur1 = 1;
	forab (i, 2, n + 1) {
		int &cur = (i % 2 ? cur1 : cur0);
		int last = max(get(1, 0, n + 1, cur, i) + u, get(1, 0, n + 1, i - (cur << 1), i) + r);
		while ((cur << 1) <= i - 2) {
			int curVal = max(get(1, 0, n + 1, cur + 1, i) + u, get(1, 0, n + 1, i - (cur << 1) - 2, i) + r);
			if (last < curVal) {
				break;
			}
			last = curVal;
			++cur;
		}
		d[i] = last;
		upd(1, 0, n + 1, i);
	}
//	cerr << clock();
	cout << d[n];
}
