#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

#define forab(i, a, b) for (int i = a; i < (int)(b); ++i)
#define fordab(i, a, b) for (int i = (int)(b) - 1; i >= (int)(a); --i)
#define forn(i, n) forab (i, 0, n)
#define ford(i, n) fordab (i, 0, n)
#define forv(i, a) forn (i, a.size())
#define mp make_pair
#define fs first
#define sc second
#define pb push_back

int a[100100], b[100100];
pair<pair<int, int>, int> mna[100100][20], mxa[100100][20], mnb[100100][20], mxb[100100][20];

int main() {
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
	int n;
	cin >> n;
	forn (i, n) {
		cin >> a[i] >> b[i];
	}
	forn (i, n) {
		mna[i][0] = mxa[i][0] = mp(mp(a[i], b[i]), i);
		mnb[i][0] = mxb[i][0] = mp(mp(b[i], a[i]), i);
	}
	int p = 1;
	forn (j, 17) {
		forn (i, n) {
			if (i + p < n) {
				mna[i][j + 1] = min(mna[i][j], mna[i + p][j]);
				mnb[i][j + 1] = min(mnb[i][j], mnb[i + p][j]);
				mxa[i][j + 1] = max(mxa[i][j], mxa[i + p][j]);
				mxb[i][j + 1] = max(mxb[i][j], mxb[i + p][j]);
			} else {
				mna[i][j + 1] = mna[i][j];
				mnb[i][j + 1] = mnb[i][j];
				mxa[i][j + 1] = mxa[i][j];
				mxb[i][j + 1] = mxb[i][j];
			}
		}
		p <<= 1;
	}
	int k;
	cin >> k;
	forn (i, k) {
		int x, y;
		cin >> x >> y;
		--x;
		int lg = 0, pw = 1;
		while (y - x >= (pw << 1)) {
			++lg;
			pw <<= 1;
		}
		pair<pair<int, int>, int> p[4];
		p[0] = min(mna[x][lg], mna[y - pw][lg]);
		p[1] = min(mnb[x][lg], mnb[y - pw][lg]);
		p[2] = max(mxa[x][lg], mxa[y - pw][lg]);
		p[3] = max(mxb[x][lg], mxb[y - pw][lg]);
		swap(p[1].fs.fs, p[1].fs.sc);
		swap(p[3].fs.fs, p[3].fs.sc);
		bool was = false;
		forn (i, 4) {
			forn (j, i) {
				if (p[i].sc != p[j].sc && p[i].fs.fs != p[j].fs.fs && p[i].fs.sc != p[j].fs.sc) {
					cout << p[i].sc + 1 << " " << p[j].sc + 1 << endl;
					was = true;
					break;
				}
			}
			if (was) {
				break;
			}
		}
		if (!was) {
			cout << "0 0\n";
		}
	}
}
