#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <vector>
#include <string>
#include <cstring>

using namespace std;

string s1, s2;
int a[200000], b[200000], sum[200000];

int main()
{
    freopen("password.in", "r", stdin);
    freopen("password.out", "w", stdout);
    cin >> s1;
    cin >> s2;
    int n = s1.length(), m = s2.length();
    for (int i = 1; i <= n; i++)
        a[i] = s1[i - 1] - '0';
    for (int i = 1; i <= m; i++)
        b[i] = s2[i - 1] - '0';
    for (int i = 1; i <= n; i++)
        sum[i] = sum[i - 1] + a[i];
    for (int i = 1; i <= m; i++)
    {
        for (int j = 1; j <= 6; j++)
        {
            int cur = 0;
            if (b[i] == 0 && j > 1) continue;
            if (i + j - 1 > n) continue;
            for (int k = i; k < i + j; k++)
                cur = cur * 10 + b[k];
            int l = i, r = n;
            while (l < r)
            {
                int q = (l + r) / 2;
                if (sum[q] - sum[i - 1] < cur) l = q + 1; else r = q;
            }
            if (sum[l] - sum[i - 1] == cur)
            {
                while ((n - l) != (m - i - j + 1) && (sum[l] - sum[i - 1] == cur))
                    l++;
                if ((n - l) == (m - i - j + 1) && (sum[l] - sum[i - 1] == cur))
                {
                    int p = 1;
                    for (int k = 1; k <= n - l; k++)
                        if (a[n - k + 1] != b[m - k + 1]) p = 0;
                    for (int k = 1; k < i; k++)
                        if (a[k] != b[k]) p = 0;
                    if (p)
                    {
                        cout << i << ' ' << l;
                        return 0;
                    }
                }
            }
        }
    }
    return 0;
}
