import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemC {
	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	private BufferedReader in;
	private PrintWriter out;
	private String fileName = "apricot";
	private StringTokenizer tok = null;

	public ProblemC() throws Exception {
		init();
		solve();
		finish();
	}

	private void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
	}

	long[] d;
	int n;
	long r, u;

	private void solve() throws Exception {
		n = nextInt();
		r = nextInt();
		u = nextInt();
		d = new long[n + 1];
		d[0] = 0;
		d[1] = 0;
		d[2] = u;
		for (int i = 3; i <= n; i++) {
			d[i] = Long.MAX_VALUE;
			for (int j = 1; 2 * j <= i; j++) {
				if (i == 2 * j) {
					d[i] = Math.min(d[i], u + d[j]);
				} else {
					d[i] = Math.min(d[i], Math.max(r + d[i - 2 * j], u + d[j]));
				}
			}
			for (int j = 1; j < i; j++) {
				d[i] = Math.min(d[i], Math.max(r + d[i - j], u + d[j]));
			}
			if (d[i] == Long.MAX_VALUE || d[i] <= 0) {
				int ML = 1000000;
				int[][] T = new int[ML][ML];
			}
		}
		out.print(d[n]);
	}
	

	private void finish() {
		out.close();
	}

	private String nextToken() throws Exception {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
}
