#include <iostream>
#include <cstdio>
#include <set>
#include <cstdlib>

using namespace std;

const int maxN = 100000 + 100;
int p1[maxN], p2[maxN];
int ans;
set<int> used;
int n;
void run1(int v, int start)
{
    if (v == -1) return;
    if (v != start)
        used.insert(v);
    run1(p1[v], start);
}

void run2(int v)
{
    if (v == -1) return;
    if (used.find(v) != used.end()) ans++;
    run2(p2[v]);
}
int main()
{
    freopen("virus.in", "r", stdin);
    freopen("virus.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &p1[i]);
        p1[i]--;
    }
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &p2[i]);
        p2[i]--;
    }
    for (int i = 0; i < n; ++i)
    {
        used.clear();
        run1(i, i);
        run2(i);
    }
    printf("%d", ans);
    return 0;
}
