import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class ProblemB {
	public static void main(String[] agrs) throws Exception {
		new ProblemB();
	}

	public ProblemB() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("virus.in"));
		PrintWriter out = new PrintWriter("virus.out");
		int n = Integer.parseInt(in.readLine());
		int[] par1 = new int[n];
		int[] par2 = new int[n];
		ArrayList<Integer>[] ma1 = new ArrayList[n];
		ArrayList<Integer>[] ma2 = new ArrayList[n];
		StringTokenizer tok = new StringTokenizer(in.readLine());
		for (int i = 0; i < n; i++) {
			ma1[i] = new ArrayList<Integer>();
			ma2[i] = new ArrayList<Integer>();
		}
		int root1 = -1;
		int root2 = -1;

		int[] deg1 = new int[n];
		for (int i = 0; i < n; i++) {
			par1[i] = Integer.parseInt(tok.nextToken()) - 1;
			if (par1[i] != -1) {
				ma1[par1[i]].add(i);
				deg1[par1[i]]++;
			} else {
				root1 = i;
			}
		}
		tok = new StringTokenizer(in.readLine());
		for (int i = 0; i < n; i++) {
			par2[i] = Integer.parseInt(tok.nextToken()) - 1;
			if (par2[i] != -1) {
				ma2[par2[i]].add(i);
			} else {
				root2 = i;
			}
		}
		int[] qu = new int[n];
		int next = 0;
		for (int i = 0; i < n; i++) {
			if (deg1[i] == 0) {
				qu[next] = i;
				next++;
			}
		}
		int[] t1 = getT(ma1, root1);
		int[] t2 = getT(ma2, root2);
		long[] count = new long[n];
		for (int i = 0; i < n; i++) {
			int u = qu[i];
			count[u] = 0;
			for (Integer v : ma1[u]) {
				count[u] += count[v];
				if (t1[v] > t1[u] && t2[v] > t2[u]) {
					++count[u];
				}
			}
			if (u != root1) {
				deg1[par1[u]]--;
				if (deg1[par1[u]] == 0) {
					qu[next] = par1[u];
					next++;
				}
			}
		}
		long res = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j && t1[i] < t1[j] && t2[i] < t2[j])
					++res;
			}
		}
		out.println(res);
		out.close();
	}

	int t;
	ArrayList<Integer>[] dfsMa;
	int[] res;

	private int[] getT(ArrayList<Integer>[] ma, int root) {
		t = 0;
		dfsMa = ma;
		res = new int[ma.length];
		dfs(root);
		return res;
	}

	private void dfs(int v) {
		res[v] = t;
		t++;
		for (Integer u : dfsMa[v]) {
			dfs(u);
		}
	}
}
