import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemB {
	public static void main(String[] agrs) throws Exception {
		new ProblemB();
	}

	public ProblemB() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("virus.in"));
		PrintWriter out = new PrintWriter("virus.out");
		int n = Integer.parseInt(in.readLine());
		int[] par1 = new int[n];
		int[] par2 = new int[n];
		ArrayList<Integer>[] ma1 = new ArrayList[n];
		ArrayList<Integer>[] ma2 = new ArrayList[n];
		StringTokenizer tok = new StringTokenizer(in.readLine());
		for (int i = 0; i < n; i++) {
			ma1[i] = new ArrayList<Integer>();
			ma2[i] = new ArrayList<Integer>();
		}
		int root1 = -1;
		int root2 = -1;

		int[] deg1 = new int[n];
		for (int i = 0; i < n; i++) {
			par1[i] = Integer.parseInt(tok.nextToken()) - 1;
			if (par1[i] != -1) {
				ma1[par1[i]].add(i);
				deg1[par1[i]]++;
			} else {
				root1 = i;
			}
		}
		tok = new StringTokenizer(in.readLine());
		for (int i = 0; i < n; i++) {
			par2[i] = Integer.parseInt(tok.nextToken()) - 1;
			if (par2[i] != -1) {
				ma2[par2[i]].add(i);
			} else {
				root2 = i;
			}
		}
		order = new int[2 * n];
		inO = new int[n];
		int[] t1 = getT(ma1, root1);
		int[] order1 = order;
		int[] inO1 = inO;
		int next1 = next;
		order = new int[2 * n];
		inO = new int[n];
		int[] t2 = getT(ma2, root2);
		int[] order2 = order;
		int next2 = next;
		int[] inO2 = inO;
		ST st1 = new ST(order1, next1, t1);
		ST st2 = new ST(order2, next2, t2);
		// System.out.println(Arrays.toString(t1));
		// System.out.println(Arrays.toString(t2));
		// System.out.println();
		// System.out.println(Arrays.toString(order1));
		// System.out.println(Arrays.toString(order2));
		// System.out.println();
		// System.out.println(Arrays.toString(inO1));
		// System.out.println(Arrays.toString(inO2));
		// System.out.println();
		// for (int i = 0; i < next1; i++) {
		// for (int j = i; j < next1; j++) {
		// System.out.println(i + " " + j + " " + st1.getMin(i, j));
		// }
		// }
		long res = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i != j) {
					// System.out.println(i + " " + j);
					// System.out.println(inO1[i] + " " + inO1[j]);
					// System.out.println(inO2[i] + " " + inO2[j]);
					int min1 = st1.getMin(inO1[i], inO1[j]);
					int min2 = st2.getMin(inO2[i], inO2[j]);
					if ((min1 == t1[i] && min2 == t2[i])
							|| (min1 == t1[j] && min2 == t2[j])) {
						res++;
//						System.out.println(i + " " + j);
					}
//					System.out.println();
				}
			}
		}
		out.println(res / 2);
		out.close();
	}

	static int[] log2 = new int[3000];
	static int[] pow2 = new int[100];
	static {
		log2[1] = 0;
		log2[2] = 1;
		log2[3] = 1;
		log2[4] = 2;
		int curPow = 4;
		int pow = 2;
		for (int i = 5; i < log2.length; i++) {
			if (2 * curPow <= i) {
				curPow *= 2;
				pow++;
			}
			log2[i] = pow;
		}
		pow2[0] = 1;
		for (int i = 1; i < pow2.length; i++) {
			pow2[i] = pow2[i - 1] * 2;
		}
	}

	class ST {
		int[][] st;
		int[] or;
		int[] ti;
		int orderN;

		int getMin(int l, int r) {
			if (l > r) {
				int tmp = l;
				l = r;
				r = tmp;
			}
			return Math.min(st[l][log2[r - l + 1]], st[r
					- pow2[log2[r - l + 1]] + 1][log2[r - l + 1]]);
		}

		public ST(int[] ord, int orderN, int[] time) {
			or = ord;
			ti = time;
			this.orderN = orderN;
			st = new int[orderN][log2[orderN] + 1];
			for (int i = 0; i < orderN; i++) {
				st[i][0] = ti[or[i]];
			}
			for (int j = 1; j < log2[orderN] + 1; j++) {
				for (int i = 0; i < orderN; i++) {
					if (i + pow2[j] - 1 - pow2[j - 1] + 1 < orderN)
						st[i][j] = Math.min(st[i][j - 1], st[i + pow2[j] - 1
								- pow2[j - 1] + 1][j - 1]);
					else
						st[i][j] = st[i][j - 1];
				}
			}
		}
	}

	int t;
	ArrayList<Integer>[] dfsMa;
	int[] res;
	int[] order;
	int next = 0;
	int[] inO;

	private int[] getT(ArrayList<Integer>[] ma, int root) {
		next = 0;
		t = 0;
		dfsMa = ma;
		res = new int[ma.length];
		dfs(root);
		return res;
	}

	private void dfs(int v) {
		res[v] = t;
		t++;
		for (Integer u : dfsMa[v]) {
			dfs(u);
			order[next] = v;
			inO[v] = next;
			next++;
		}
		if (dfsMa[v].size() == 0) {
			order[next] = v;
			inO[v] = next;
			next++;
		}
	}
}
