import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemD {
	public static void main(String[] agrs) throws Exception {
		new ProblemD();
	}

	public ProblemD() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("calendar.in"));
		PrintWriter out = new PrintWriter("calendar.out");
		String s = in.readLine();
		StringTokenizer tok = new StringTokenizer(s);
		int n = Integer.parseInt(tok.nextToken());
		int m = Integer.parseInt(tok.nextToken());
		int[][] a = new int[n][m];
		for (int i = 0; i < n; i++) {
			s = in.readLine();
			for (int j = 0; j < m; j++) {
				if (s.charAt(j) == '*')
					a[i][j] = -1;
				else
					a[i][j] = (s.charAt(j) - '0');
			}
		}
		for (int j = m - 1; j >= 0; j--) {
			int i = -1;
			for (i = 0; i < n; i++) {
				if (a[i][j] != -1) {
					break;
				}
			}
			if (i != n) {
				for (int k = i + 1; k < n; k++) {
					a[k][j] = (a[k - 1][j] + 1) % 10;
				}
				for (int k = i - 1; k >= 0; k--) {
//					System.out.println(k + " " + j + a[k + 1][j]);
					a[k][j] = (a[k + 1][j] + 9) % 10;
				}
			}
		}
		for (int i = 0; i < m; i++) {
			out.print(a[0][i]);
		}
		out.close();
	}
}
