import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemA {
	public static void main(String[] args) throws Exception {
		new ProblemA();
	}

	public ProblemA() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("mosaic.in"));
		PrintWriter out = new PrintWriter("mosaic.out");
		int n = Integer.parseInt(in.readLine());
		int[] a = new int[n];
		int[] b = new int[n];
		StringTokenizer tok;
		for (int i = 0; i < n; i++) {
			tok = new StringTokenizer(in.readLine());
			a[i] = Integer.parseInt(tok.nextToken());
			b[i] = Integer.parseInt(tok.nextToken());
		}
		int k = Integer.parseInt(in.readLine());
		int[] l = new int[k];
		int[] r = new int[k];
		for (int i = 0; i < k; i++) {
			tok = new StringTokenizer(in.readLine());
			l[i] = Integer.parseInt(tok.nextToken());
			r[i] = Integer.parseInt(tok.nextToken());
		}
		if (n <= 100 && k <= 100) {
			for (int ind = 0; ind < k; ind++) {
				int resl = 0;
				int resr = 0;
				for (int i = l[ind] - 1; i <= r[ind] - 1; i++) {
					for (int j = i + 1; j <= r[ind] - 1; j++) {
						if (a[i] != a[j] && b[i] != b[j]) {
							resl = i + 1;
							resr = j + 1;
						}
					}
				}
				out.println(resl + " " + resr);
			}
			out.close();
		} else {

			int[] nextNotA = new int[n];
			int[] nextNotB = new int[n];
			nextNotA[n - 1] = -1;
			nextNotB[n - 1] = -1;
			for (int i = n - 2; i >= 0; i--) {
				if (a[i + 1] == a[i]) {
					nextNotA[i] = nextNotA[i + 1];
				} else {
					nextNotA[i] = i + 1;
				}
				if (b[i + 1] == b[i]) {
					nextNotB[i] = nextNotB[i + 1];
				} else {
					nextNotB[i] = i + 1;
				}
			}
			// System.out.println(Arrays.toString(nextNotA));
			// System.out.println(Arrays.toString(nextNotB));
			int pow2 = 1;
			while (pow2 < n) {
				pow2 *= 2;
			}
			nextDif = new int[pow2 * 2];
			tree = new int[pow2 * 2];
			for (int i = n - 1; i >= 0; i--) {
				nextDif[i + pow2] = n;
				for (int j = n - 1; j > i; j--) {
					if (a[i] != a[j] && b[i] != b[j]) {
						nextDif[i + pow2] = j;
					}
				}
			}
			// for (int i = n - 1; i >= 0; i--) {
			// // System.out.println(i + 1);
			// int curI = i + 1;
			// nextDif[i + pow2] = n;
			// while (curI != n && curI != -1) {
			// int curA = a[curI];
			// int curB = b[curI];
			// if (curA == a[i] && curB == b[i]) {// found equals
			// nextDif[i + pow2] = nextDif[curI + pow2];
			// break;
			// } else if (curA != a[i] && curB != b[i]) {// found diff
			// nextDif[i + pow2] = curI;
			// break;
			// } else if (curA == a[i]) {
			// curI = nextNotA[curI];
			// } else {
			// curI = nextNotB[curI];
			// }
			// // System.out.println("  " + (curI + 1));
			// }
			// // System.out.println((i + 1) + " " + (nextDif[i + pow2] + 1));
			// }
			init(pow2, n);
			// System.out.println(Arrays.toString(nextDif));
			// System.out.println(Arrays.toString(tree));
			for (int i = 0; i < k; i++) {
				int le = l[i] - 1;
				int ri = r[i] - 1;
				le += pow2;
				ri += pow2;
				int resL = le;
				int best = nextDif[le];
				while (le < ri) {
					if (le % 2 == 1) {
						if (nextDif[tree[le]] < best) {
							resL = tree[le];
							best = nextDif[resL];
						}
						le++;
					}
					if (ri % 2 == 0) {
						if (nextDif[tree[ri]] < best) {
							resL = tree[ri];
							best = nextDif[resL];
						}
						ri--;
					}
					le /= 2;
					ri /= 2;
				}
				// System.out.println(l[i] + " " + r[i]);
				// System.out.println(" " + resL + " " + best);
				resL++;
				best++;
				resL -= pow2;
				// best -= pow2;
				if (best > r[i]) {
					out.println("0 0");
				} else {
					out.println(resL + " " + best);
				}
			}
			out.close();
		}
	}

	private void init(int pow2, int n) {
		for (int i = 0; i < n; i++) {
			tree[i + pow2] = i + pow2;
		}
		for (int i = pow2 - 1; i >= 1; i--) {
			if (nextDif[tree[2 * i]] <= nextDif[tree[2 * i + 1]]) {
				tree[i] = tree[2 * i];
			} else {
				tree[i] = tree[2 * i + 1];
			}
		}
	}

	int[] nextDif;
	int[] tree;
}
