import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class ProblemB {
	public static void main(String[] args) throws Exception {
		new ProblemB();
	}

	public ProblemB() throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("theatre.in"));
		PrintWriter out = new PrintWriter("theatre.out");
		StringTokenizer tok = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(tok.nextToken());
		int m = Integer.parseInt(tok.nextToken());
		int[][] aWas = new int[m][];
		// boolean[][] was = new boolean[m][n];
		for (int i = 0; i < m; i++) {
			tok = new StringTokenizer(in.readLine());
			int L = Integer.parseInt(tok.nextToken());
			aWas[i] = new int[L];
			for (int j = 0; j < L; j++) {
				int v = Integer.parseInt(tok.nextToken()) - 1;
				aWas[i][j] = v;
			}
		}
		int[] res = new int[n];
		int[] deg = new int[n];
		Arrays.fill(deg, n);
		boolean[][] canntBe = new boolean[n][n];

		for (int i = 0; i < m; i++) {
			// System.out.println("scene " + (i + 1));
			boolean[] was = new boolean[n];
			for (int v : aWas[i]) {
				was[v] = true;
			}
			int[] wasNt = new int[n - aWas[i].length];
			int next = 0;
			for (int u = 0; u < n; u++) {
				if (!was[u]) {
					wasNt[next] = u;
					next++;
				}
			}
			for (int v : aWas[i]) {
				// System.out.println("man " + (v + 1) + " ");
				for (int u : wasNt) {
					// System.out.println("    man " + (u + 1));
					if (!canntBe[v][u]) {
						// System.out.println("    cannt be");
						deg[v]--;
						deg[u]--;
						canntBe[v][u] = true;
						canntBe[u][v] = true;
						if (deg[v] == 1) {
							res[v] = i + 1;
						}
						if (deg[u] == 1) {
							res[u] = i + 1;
						}
					}
				}
			}
		}
		for (int i = 0; i < n; i++) {
			out.print(res[i] + " ");
		}
		out.println();
		out.close();
	}
}
