#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define mp make_pair
#define st first
#define nd second

int main(){
#ifdef Local
	freopen("in", "rt", stdin);
	freopen("out", "wt", stdout);
#else
	freopen("mosaic.in", "rt", stdin);
	freopen("mosaic.out", "wt", stdout);
#endif
	int n;
	cin >> n;
	vector<pair<int, int>> m(n), dp(n, mp(0, 0));
	for(int i = 0; i < n; ++i){
		cin >> m[i].st >> m[i].nd;
	}
	for(int i = 1; i < n; ++i){
		int cur = -1;
		for(int j = i -1; j >= 0; --j)
			if(m[i].st != m[j].st && m[j].nd != m[i].nd){
				cur = j;
				break;
			}
		if(cur == -1){
			dp[i] = dp[i - 1];
		} else {
			dp[i] = mp(i, cur);
			if(dp[i - 1].nd > dp[i].nd)
				dp[i] = dp[i - 1];
		}
	}

	int k, l, r;
	cin >> k;
	for(int i = 0; i < k; ++i){
		cin >> l >> r;
		--r, --l;
		if(dp[r].nd < l)
			cout << "0 0" << endl;
		else
			cout << dp[r].st + 1 << ' ' << dp[r].nd + 1 << endl;
	}
	return 0;
}