
#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <hash_map>
#include <hash_set>
 
using namespace std;
 
#define ll long long
#define mp make_pair
#define st first
#define nd second
 
int prime1 = 1e9 + 7;
int prime2 = 607;
 
const int MAX_SIZE = 1e5 + 10;
 
int p1[MAX_SIZE];
int p2[MAX_SIZE];
 
void make_p(){
    p1[0] = 1;
    for(int i = 1; i < MAX_SIZE; ++i)
        p1[i] = p1[i - 1] * prime1;
    p2[0] = 1;
    for(int i = 1; i < MAX_SIZE; ++i)
        p2[i] = p2[i - 1] * prime2;
}
 
int main(){
#ifdef Local
    freopen("in", "rt", stdin);
    freopen("out", "wt", stdout);
#else
    freopen("theatre.in", "rt", stdin);
    freopen("theatre.out", "wt", stdout);
#endif
    int n, m;
    scanf("%d%d", &n, &m);
 
    make_p();
    pair<int, int> hash[MAX_SIZE];
	for(int i = 0; i < MAX_SIZE; ++i)
		hash[i] = mp(0, 0);
    map<pair<int, int>, set<int>> played;
    for(int i = 0; i < n; ++i)
		played[mp(0, 0)].insert(i);
    bool used[MAX_SIZE];
	int count[MAX_SIZE], ans[MAX_SIZE];
	for(int i = 0; i < n; ++i)
		used[i] = 0, count[i] = 0, ans[i] = 0;
    hash_set<int> cur;
 
    for(int q = 0; q < m; ++q){
        cur.clear();
        int k, a;
        scanf("%d", &k);
        for(int i = 0; i < k; ++i){
            scanf("%d", &a), --a;
            if(used[a])
                continue;
 
            played[hash[a]].erase(a);
            if(played[hash[a]].size() == 1){
                cur.insert(*played[hash[a]].begin());
            } else if(played[hash[a]].size() == 0){
                cur.erase(a);
            }
 
            hash[a].st += p1[count[a]++] * (q + 1);
            hash[a].nd += p2[count[a]++] * (q + 1);
 
            played[hash[a]].insert(a);
            if(played[hash[a]].size() == 1){
                cur.insert(a);
            } else if(played[hash[a]].size() == 2){
				auto x1 = played[hash[a]].begin(), x2 = x1;
				++x2;
                if(*x1 == a)
                    cur.erase(*x2);
                else
                    cur.erase(*x1);
            }
        }
 
        for(auto j = cur.begin(); j != cur.end(); ++j){
            used[*j] = 1;
            played[hash[*j]].erase(*j);
            ans[*j] = q + 1;
        }
    }
 
    for(int i = 0; i < n; ++i)
        printf("%d ", ans[i]);
    return 0;
}