#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <hash_map>
#include <hash_set>
 
using namespace std;
 
#define ll long long
#define mp make_pair
#define st first
#define nd second
 
vector<ll> perm, elite;
set<ll> s;
ll n, ans = 0, temp1 = 0;

bool check(){
	vector<pair<ll, ll>> dp(n, mp(1, -1)), g;
	dp[0] = mp(1, -1);
	for(ll i = 1; i < n; ++i)
		for(ll j = 0; j < i; ++j)
			if(perm[j] < perm[i] && dp[j].st + 1 > dp[i].st){
				dp[i].st = dp[j].st + 1;
				dp[i].nd = j;
			}
	ll mx = 0, mx_i = 0;
	for(ll i = 0; i < n; ++i)
		if(dp[i].st > mx){
			mx = dp[i].st;
			mx_i = i;
		}
		
	if(mx != elite.size())
		return false;

	bool complete = 0;
	ll pos = 0;
	for(ll i = 0; pos < elite.size() && i < n; ++i){
		if(perm[i] == elite[pos])
			++pos;
	}
	if(pos == elite.size())
		complete = 1;
	return complete;
}

void permutation(){
	if(s.size() == 0){
		ans += check();
	} else {
		for(ll i = 0; i < n; ++i){
			if(s.count(i)){
				perm[n - s.size()] = i;
				s.erase(i);
				permutation();
				s.insert(i);
			}
		}
	}

}

int main(){
#ifdef Local
    freopen("in", "rt", stdin);
    freopen("out", "wt", stdout);
#else
    freopen("army.in", "rt", stdin);
    freopen("army.out", "wt", stdout);
#endif
	ll k;
	cin >> n >> k;
	elite = vector<ll>(k);
	perm = vector<ll>(n);
	for(ll i = 0; i < k; ++i)
		cin >> elite[i], elite[i]--;
	for(ll i = 0; i < n; ++i)
		s.insert(i);
	permutation();
	cout << ans;
    return 0;
}