program Project2;
{$Q-,R-}
{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

const
  base = 37;

var
  i, n, k : integer;
  h1, h2, st : array [0..100010] of int64;
  a : array [0..100000] of integer;
  s1, s2 : string;

procedure hesh;
var
  i : integer;
begin
  h1[0] := 0;
  h2[0] := 0;
  for i := 1 to n do
    h1[i] := h1[i - 1] * base + strtoint(s1[i]);
  for i := 1 to k do
    h2[i] := h2[i - 1] * base + strtoint(s2[i]);
  st[0] := 1;
  for i := 1 to max(n, k) do
    st[i] := st[i - 1] * base;
end;

function sr(l1, r1, l2, r2 : integer) : boolean;
begin
  result := (h1[r1] - h1[l1 - 1] * st[r1 - l1 + 1]) = (h2[r2] - h2[l2 - 1] * st[r2 - l2 + 1]);
end;

procedure tr(v : integer);
var
  p, i : integer;
  bool1, bool2 : boolean;
begin
  p := 0;
  for i := 1 to 6 do
    if v + i - 1 <= min(n, k) then begin
      p := p * 10 + strtoint(s2[v + i - 1]);
      bool1 := (v = 1) or sr(1, v - 1, 1, v - 1);
      bool2 := (v + i - 1 = k) or sr(n - (k - v - i + 1) + 1, n, v + i, k);
      if bool1 and bool2 then
        if (p = a[n - (k - v - i + 1)] - a[v - 1]) then begin
          writeln(v, ' ', n - (k - v - i + 1));
          halt(0);
        end;
    end
    else
      exit;
end;

begin
  reset(input, 'password.in');
  rewrite(output, 'password.out');
  readln(s1);
  readln(s2);
  if s1 = s2 then begin
    writeln('1 1');
    halt(0);
  end;
  n := length(s1);
  k := length(s2);
  a[0] := 0;
  for i := 1 to n do
    a[i] := a[i - 1] + strtoint(s1[i]);
  hesh;
  for i := 1 to k do
    tr(i);
end.
 