#include <cstdio>
#include <algorithm>

using namespace std;

typedef unsigned long long ull;

#define LEN 100010
#define P 239
#define MAG 6

int a[2][LEN];
int la[2];
int pref[2][LEN];
ull hash[2][LEN];
ull ps[LEN];
   
void read() {
	char c;
	scanf("%c", &c);
	la[0] = la[1] = 0;
	while ('0' <= c && c <= '9') {
		a[0][ ++la[0] ] = c - '0';
		scanf("%c", &c);
	}
	while (!('0' <= c && c <= '9')) 
		scanf("%c", &c);
	while ('0' <= c && c <= '9') {
		a[1][ ++la[1] ] = c - '0';
		scanf("%c", &c);
	}
//	for (int i = 0; i <= la[0]; i++)
//		printf("%d ", a[0][i]);
//	printf("\n");      
//	for (int i = 0; i <= la[1]; i++)
//		printf("%d ", a[1][i]);
//	printf("\n");
}

void precalc() {
	for (int t = 0; t < 2; t++) {
		pref[t][0] = 0;
		hash[t][0] = 0;
		for (int i = 1; i <= la[t]; i++) {
			pref[t][i] = pref[t][i - 1] + a[t][i];
			hash[t][i] = hash[t][i - 1] * P + a[t][i] + 1;
		}
	}
	ps[0] = 1;
	for (int i = 1; i < max(la[0], la[1]); i++)
		ps[i] = ps[i - 1] * P;
//	for (int t = 0; t < 2; t++) {
//		for (int i = 0; i <= la[t]; i++)
//			printf("%d ", pref[t][i]);
//		printf("\n");
//		for (int i = 0; i <= la[t]; i++)
//			printf("%I64u ", hash[t][i]);
//		printf("\n");
//	}
}

int do_it() {
	for (int i = 1; i <= la[1]; i++) {
		int sum = 0;
		for (int j = 1; i + j - 1 <= la[1] && (j <= (a[1][i] == 0) ? 1 : MAG); j++) {
			sum = sum * 10 + a[1][i + j - 1];
//			printf("%d\n", sum);
			ull p0, p1;
			int len, fin0, fin1;
			fin1 = la[1];
			fin0 = la[0];
			len = fin1 - (i + j - 1);
			p0 = hash[0][fin0] - hash[0][fin0 - len] * ps[len];
			p1 = hash[1][fin1] - hash[1][fin1 - len] * ps[len];
//			printf("%I64u %I64u\n", p0, p1);
//			printf("%d %d\n", fin0 - len,  i - 1);
//			printf("%d %d\n", sum, (pref[0][fin0 - len] - pref[0][i - 1]));
//			printf("%d %d\n", i, j);
//			printf("-----\n");
			if (sum == pref[0][fin0 - len] - pref[0][i - 1] && p0 == p1) {
				printf("%d %d\n", i, fin0 - len);
				return 0;
			}
		}
	}
}

int main() {
	freopen("password.in", "r", stdin);
	freopen("password.out", "w", stdout);
	read();
	precalc();
	do_it();
//	printf("Too bad(");
	return 0;
}
