#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

#define N 1000010
#define INF (ll)(1e18)

int n, u, r;
ll dp[N];
int prev[N];

void read() {
	scanf("%d%d%d", &n, &r, &u);
}

void count_it() {
	dp[0] = 0;
	dp[1] = 0;
	for (int i = 2; i <= n; i++) {
		int pret[3];
		pret[0] = 1;
		pret[1] = prev[i - 1];
		pret[2] = prev[i - 1] + 1;
		dp[i] = INF;
//		for (int num = 1; 2 * num <= i; num++) {
		for (int t = 0; t < 3; t++) {
			int num = pret[t];
			if (2 * num > i)
				continue;
			int carr = i - 2 * num;
			if (carr == 0) {
				if (dp[i] > u + dp[num])
					dp[i] = u + dp[num], prev[i] = num;
				continue;
			}
			ll ans = max(r + dp[carr], u + dp[num]);
			if (dp[i] > ans)
				dp[i] = ans, prev[i] = num;
		}
	}
	printf("%I64d\n", dp[n]);
//	for (int i = 0; i <= n; i++)
//		printf("%3d %3d %5I64d\n", i, prev[i], dp[i]);
}

int main() {
	freopen("apricot.in", "r", stdin);
	freopen("apricot.out", "w", stdout);
	read();
	count_it();
	return 0;
}
