#include <cstdio>
#include <algorithm>
#include <iostream>
 
using namespace std;
 
typedef long long ll;
 
#define N 1000010
#define INF (ll)(1e18)
 
int n, u, r;
ll dp[N];
 
void read() {
    scanf("%d%d%d", &n, &r, &u);
}
 
void count_it() {
    dp[0] = 0;
    dp[1] = 0;
    for (int i = 2; i <= n; i++) {
		dp[i] = INF;
		for (int num1 = 1; num1 < i; num1++)
        	for (int num2 = 0; (num2 <= num1) && (num1 + num2 <= i); num2++) {
//        		cerr << (num1 - num2) << " " << (n - i) << endl;
        		if ((num1 - num2) > (n - i))
        			continue;
				int carr = i - num1 - num2;
				if (carr == 0) {
					ll ans = (ll)(u) + max(dp[num1], dp[num2]);
				    dp[i] = min(dp[i], ans);
				}
				else {
                	ll ans = (ll)(u) + max(dp[num1], dp[num2]);
					ans = max(ans, (ll)(r) + dp[carr]);
					dp[i] = min(dp[i], ans);
				}
			}
	}
	printf("%I64d\n", dp[n]);
//	for (int i = 0; i <= n; i++)
//		printf("%d ", dp[i]);
}
 
int main() {
    freopen("apricot.in", "r", stdin);
    freopen("apricot.out", "w", stdout);
    read();
    count_it();
    return 0;
}