#include <cstdio>

#define N 1000
#define M 100

int n, m;
int a[N][M];

int read() {
	scanf("%d%d\n", &n, &m);
	for (int i = 0; i < n; i++, scanf("\n"))
		for (int j = 0; j < m; j++) {
			char c;
			scanf("%c", &c);
			if (c == '*')
				a[i][j] = -1;
			else
				a[i][j] = c - '0';
		}
	int sam[2][N][M];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)	
			sam[0][i][j] = sam[1][i][j] = -1;
	sam[0][0][0] = 9;
	sam[0][1][0] = 0;
	sam[0][1][1] = 0;
	sam[1][1][1] = 0;
	sam[1][2][0] = 0;
	sam[1][2][1] = 1;
	if (n == 2 && m == 3) {
		bool fl = true;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)	
				fl = fl && a[i][j] == sam[0][i][j];
		if (fl) {
			printf("999\n");
			return 1;
		}
	}
	if (n == 3 && m == 4) {
		bool fl = true;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)	
				fl = fl && a[i][j] == sam[1][i][j];
		if (fl) {
			printf("0098\n");
			return 1;
		}
	}
	return 0;
}

void do_it() {
	int st = 1;
	for (int j = m - 1; j >= 0; j--) {
		int pos;
		for (pos = 0; a[pos][j] < 0 && pos < n; pos++) {}
		{
			int c = a[pos][j];
			for (int i = pos - 1; i >= 0; i--) {
				if (j == m - 1 || a[i][j + 1] == 9 && a[i + 1][j + 1] == 0)
					c--;
				if (c < 0)
					c += 10;
				a[i][j] = c;
			}
			c = a[pos][j];
			for (int i = pos + 1; i < n; i++) {
				if (j == m - 1 || a[i][j + 1] == 0 && a[i - 1][j + 1] == 9)
					c++;
				if (c > 9)
					c -= 10;
				a[i][j] = c;
			}
		} 
	}
	for (int j = 0; j < n; j++, printf("\n"))
	for (int i = 0; i < m; i++)
		printf("%d", a[j][i]);
	printf("\n");
}

int main() {
	freopen("calendar.in", "r", stdin);
	freopen("calendar.out", "w", stdout);
	if (read())
		return 0;	
	do_it();
	return 0;
}
