#include <cstdio>
#include <iostream>
#include <algorithm>

using namespace std;

#define N 100010

struct pnt {
	int x, y;
	void read() {
		scanf("%d%d", &x, &y);
	}
	void write() {
		printf("%d %d\n", x, y);
	}

};

int n, k;
pnt ps[N];
int posin[N];
int brcs[N], pref[N];
pnt pn[N];
int spn;
int posout[N];

bool eq(pnt &p1, pnt &p2) {
	return p1.x == p2.x && p1.y == p2.y;
}

void read() {
	scanf("%d", &n);
	spn = 0;
	for (int i = 0; i < n; i++)
		ps[i].read();
	for (int i = 0; i < n; i++)
		if (i == 0 || !eq(ps[i - 1], ps[i])) {
			pn[spn] = ps[i];
			posout[spn] = i;
			posin[i] = spn++;
		}
		else
			posin[i] = spn - 1;
//	for (int i = 0; i < n; i++)
//		cerr << posin[i] << endl;
}

int check(pnt &p1, pnt &p2, pnt &p3) {
	if (p1.x == p2.x && p3.x == p2.x)
		return 0;
	if (p1.y == p2.y && p3.y == p2.y)
		return 0;
	return 1;		 
}

int check2(pnt &p1, pnt &p2) {
	if (p1.x == p2.x || p1.y == p2.y)
		return 1;
	return 0;		 
}

void prec() {
	for (int i = 1; i < spn - 1; i++)
		brcs[i] = check(pn[i - 1], pn[i], pn[i + 1]);
	for (int i = 1; i < spn; i++)
		pref[i] = pref[i - 1] + brcs[i];
//	for (int i = 0; i < spn; i++)
//		cerr << brcs[i] << " " << pref[i] << endl;
}

int bin_search(int l, int r) {
	while (r - l > 1) {
		int m = (r + l + 1) / 2;
		if (pref[r] - pref[m] > 0)
			l = m;
		else
			r = m;
	}
	return r;
}

void do_it() {
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		int l, r;
		scanf("%d%d", &l, &r);
		r--, l--;
		int ml = l, mr = r;
		l = posin[l];
		r = posin[r];
		if (r == l) {
			printf("0 0\n");
			continue;
		}
		if (r - l == 1) {
			if (check2(pn[l], pn[r]))
				printf("0 0\n");
			else
				printf("%d %d\n", ml + 1, mr + 1);
			continue;
		}
		r--;
		if (pref[r] - pref[l] == 0) {
			printf("0 0\n");
			continue;
		}
		int c;
		c = bin_search(l, r);
		printf("%d %d\n", max(posout[c - 1], ml) + 1, min(posout[c + 1], mr) + 1);
	}
}

int main() {
	freopen("mosaic.in", "r", stdin);
	freopen("mosaic.out", "w", stdout);
	read();
	prec();
	do_it();
	return 0;
}
