#include <cstdio>
#include <set>
#include <iostream>

using namespace std;

#define N 100010
#define M 100010

struct group {
	int l, r;
	int m;
};

struct artist {
	int g;
	int where;
	int act;
};

int n, m;
group gs[N];
int sgs = 1;
artist as[N];
int aing[N];
                
void read() {
	scanf("%d%d", &n, &m);
}

void add(int a) {
	int ind = as[a].where;
	int g = as[a].g;
	int l = gs[g].l;
	int m = gs[g].m;
	swap(as[ aing[m] ].where, as[a].where);
	swap(aing[m], aing[ind]);
	gs[g].m++;
}

void new_group(int l, int r, int act) {
	gs[sgs].m = gs[sgs].l = l;
    gs[sgs].r = r;
    if (r - l == 1)
    	as[ aing[l] ].act = act;
    for (int i = l; i < r; i++)
    	as[ aing[i] ].g = sgs;
    sgs++;
}

void check_group(int g, int act) {
	if (gs[g].m == gs[g].r) {
		gs[g].m = gs[g].l;
		return;
	}
	if (gs[g].m == gs[g].l)
		return;
	new_group(gs[g].l, gs[g].m, act);
	gs[g].l = gs[g].m;
	if (gs[g].r - gs[g].l == 1)
    	as[ aing[ gs[g].l ] ].act = act;
}

void do_it() {
	for (int i = 0; i < n; i++)
		as[i].g = 0, as[i].where = i, aing[i] = i, as[i].act = -1;
	gs[0].l = gs[0].m = 0;
	gs[0].r = n;
	for (int act = 0; act < m; act++) {
		if (sgs == n)
			break;
		int k;
		scanf("%d", &k);
		set<int> groops;
		groops.clear();
		for (int i = 0; i < k; i++) {
			int a;
			scanf("%d", &a);
			a--;
			groops.insert(as[a].g);
			add(a);
		}
//		cerr << "!";
//		for (int i = 0; i < sgs; i++)
//			cerr << gs[i].l << " " << gs[i].m << " " << gs[i].r << endl;
		while (groops.size() > 0) {
			int g = *groops.begin();
			groops.erase(g);
			check_group(g, act);
		}
//		for (int i = 0; i < n; i++)
//			cerr << as[i].g << " ";
//		cerr << endl;

	}
	for (int i = 0; i < n; i++)
		printf("%d ", as[i].act + 1);
}

int main() {
	freopen("theatre.in", "r", stdin);
	freopen("theatre.out", "w", stdout);
	read();
	do_it();
	return 0;
}
