#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

#define N 17

int n, k, nn;
int mas[N];
bool guard[N], was[N];
int gs[N], ngs[N];
int cnt = 0;

int maxlen() {
	int dp[N][N];
	for (int i = 0; i <= n; i++)
		for (int j = 0; j <= n; j++)
			dp[i][j] = 0;
	for (int i = 1; i <= n; i++) {
		int c = mas[i - 1];
		for (int j = 1; j <= n; j++)
			dp[i][j] = dp[i - 1][j];
		for (int j = 0; j < c; j++)
			dp[i][c] = max(dp[i][c], dp[i - 1][j] + 1);			
	}
	for (int j = 1; j <= n; j++)
		dp[n][0] = max(dp[n][0], dp[n][j]);
	return dp[n][0];
}

void read() {
	scanf("%d%d", &n, &k);
	for (int i = 0; i < k; i++) {
		scanf("%d", &gs[i]);
		guard[ --gs[i] ] = true;
	}
	nn = 0;
	for (int i = 0; i < n; i++)
		if (!guard[i])
			ngs[nn++] = i;
}

void go(int pos, int gnum) {
	if (pos == n) {
		if (maxlen() == k)
			cnt++;
		return;
	}
    if (gnum < k) {
    	mas[pos] = gs[gnum] + 1;
    	go(pos + 1, gnum + 1);
    }
    for (int i = 0; i < nn; i++)
    	if (!was[i]) {
    		was[i] = true;
    		mas[pos] = ngs[i] + 1;
    		go(pos + 1, gnum);
    		was[i] = false;
    	}
}

int main() {
	freopen("army.in", "r", stdin);
	freopen("army.out", "w", stdout);
	read();
	go(0, 0);
	printf("%d\n", cnt);
	return 0;
}