#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
using namespace std;

int n,m;
bool maybe[35][35];
bool maynbe[35][35];
bool tmp[35][35];
const int gox[8] = {0,1,-1,0,1,-1,1,-1};
const int goy[8] = {1,1,1,-1,-1,-1,0,0};
bool correct(int i, int j)
{
	return (i >= 0 && i < n && j >= 0 && j < n);
}
int maxx, maxy, minx, miny, dx, dy;
int posx, posy;

int hdist(int x1, int y1, int x2, int y2)
{
	return min(abs(x1-x2), abs(y1-y2));
}

int main()
{
	cin >> n >> m;
	cin >> posy >> posx;
	posx--; posy--;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			maybe[i][j] = 1, maynbe[i][j] = 0, tmp[i][j] = 0; 

	minx = 0;
	miny = 0;
	maxx = 0;
	maxy = 0;
	for (int i = 0; i < 8; i++) 
	if (correct(posx+gox[i], posy+goy[i]))
	{
		posx += gox[i]; posy += goy[i];
		cout << goy[i] << ' ' << gox[i] << ' ' << 1 << endl;
		cout.flush();
		break;
	}
	//maynbe[posx][posy] = 1;
	bool r = 1;
	int okx, oky;
	bool found = 0;
	while (1)
	{
		int ok, ddx, ddy;
		cin >> ok >> ddy >> ddx;
		if (ok) return 0;
		dx += ddx; dy += ddy;
		if (r) {maynbe[posx][posy] = 1; r = 0;}
		minx = min(minx,dx); maxx = max(maxx, dx);
		miny = min(miny,dy); maxy = max(maxy, dy);
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				tmp[i][j] = 0;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (correct(i+dx, j+dy)) tmp[i+dx][j+dy] = maynbe[i][j];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				maynbe[i][j] = tmp[i][j];
		
		int cnt = 0;
		int lx = dx - minx;
		int rx = n-1 - maxx + dx;
		int ly = dy - miny;
		int ry = m-1 - maxy + dy;

		for (int i = lx; i <= rx; i++)
			for (int j = ly; j <= ry; j++)
				if (!maynbe[i][j]) cnt++, okx = i, oky = j;

		if (cnt == 1) found = 1;
		if (!found)
		{
			for (int i = 0; i < 8; i++) 
			if (correct(posx+gox[i], posy+goy[i]))
			{
				posx += gox[i]; posy += goy[i];
				if (!maynbe[posx][posy] && (rand() & 1)) r = 1;
				cout << goy[i] << ' ' << gox[i] << ' ' << r << endl;
				cout.flush();
				break;
			}
		}
		else
		{
		   int curi = -1;
			for (int i = 0; i < 8; i++) 
			if (correct(posx+gox[i], posy+goy[i]) && 
			   (curi == -1 || hdist(posx+gox[i], posy+goy[i], okx, oky) < hdist(posx+gox[curi], posy + goy[curi], okx, oky)))
					curi = i;
			r = hdist(posx+gox[curi], posy + goy[curi], okx, oky) == 0;	
			posx += gox[curi]; posy += goy[curi];
			cout << goy[curi] << ' ' << gox[curi] << ' ' << r << endl; 			
		   cout.flush(); 		
			
		}
					 
	}

	return 0;
}