const
  maxn = 100000;
  attempts : longint = 100000000;

var
  cnt, x, y, n, m, i, l, r : longint;
  a, b : array[1..maxn] of longint;
  ca, cb : array[1..maxn] of longint;
  found : boolean;

function check(i, j : longint) : boolean;
begin
  check := false;
  if (i <> j) and (a[i] <> a[j]) and (b[i] <> b[j]) then
    check := true;
end;

begin
  assign(input, 'mosaic.in');
  assign(output, 'mosaic.out');
  reset(input);
  rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(a[i], b[i]);
  end;
  ca[1] := 1;
  cb[1] := 1;
  for i := 2 to n do begin
    if ca[i] <> ca[i - 1] then begin
      ca[i] := ca[i - 1] + 1;
    end else begin
      ca[i] := ca[i];
    end; 
    if cb[i] <> cb[i - 1] then begin
      cb[i] := cb[i - 1] + 1;
    end else begin
      cb[i] := cb[i - 1];
    end;
  end;
  read(m);
  for i := 1 to m do begin
    read(l, r);
    cnt := 0;
    found := false;
    if (ca[l] = ca[r]) or (cb[l] = cb[r]) then begin
      writeln('0 0');
      continue;
    end;
    while (cnt < attempts div (m - i + 1)) do begin
      x := random(r - l + 1) + l;
      y := random(r - l + 1) + l;
      if check(x, y) then begin
        writeln(x, ' ', y);
        found := true;
        break;
      end;
      cnt := cnt + 1;
      attempts := attempts - 1;
    end;
    if not found then
      writeln('0 0');
  end;
end.
