const
  maxn = 100000;
var
  n, k, i : integer;
  sum, ans : int64;
  a : array[1..maxn] of integer;

procedure qsort(l, r : integer);
var
  i, j, x, t : integer;
begin
  if (l >= r) then exit;
  i := l;
  j := r;
  x := a[random(r - l + 1)];
  while (i <= j) do begin
    while (a[i] < x) do i := i + 1;
    while (a[j] > x) do j := j - 1;
    if (i <= j) then begin
      t := a[i]; a[i] := a[j]; a[j] := t;
      i := i + 1;
      j := j - 1;
    end;
  end;
  qsort(l, j);
  qsort(i, r);
end;

begin
  reset(input, 'shop.in');
  rewrite(output, 'shop.out');
  read(n, k);
  assert((1 <= n) and (n <= maxn));
  assert((1 <= k) and (k <= 100));
  sum := 0;
  for i := 1 to n do begin
    read(a[i]);
    assert((1 <= a[i]) and (a[i] <= 10000));
    sum := sum + a[i];
  end;
  qsort(1, n);
  i := n - k + 1;
  ans := 0;
  while (i > 0) do begin
    ans := ans + a[i];
    i := i - k;
  end;
  writeln(sum - ans);
end.