#include <cstdio>
#include <iostream>
#include <cmath>
using namespace std;

const double eps = 1e-10;

double calc(double v, double x, double a) {
	double t = v / a, d = a * t * t / 2;
	if (d < x - eps) {
		cerr << "1";
		return t + (x - d) / v;
	} else {
		cerr << "2";
		return sqrt(2 * x / a);
	}
}

int main() {
	freopen("sideslip.in", "r", stdin);
	freopen("sideslip.out", "w", stdout);
	int v, x, y, a, b;
	scanf("%d%d%d%d%d", &v, &x, &y, &a, &b);
	printf("%.10lf\n", calc(v, x, b) + calc(v, y, a));
	return 0;
}
