#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(a) (int)a.size()
#define zero(a) memset (a, 0, sizeof(a))
#define mp make_pair

#define taskname "tea"

#define maxm 200000

int m, v, n, k;

struct jury
{
  int t, a, id;
}j[maxm];

bool check (jury x, jury y)
{
  return (x.t < y.t);
}

double ans[maxm];

int main (void)
{
  assert(freopen (taskname".in", "r", stdin));
  freopen (taskname".out", "w", stdout);

  assert(scanf("%d%d%d%d", &m, &v, &n, &k) == 4);
  assert(1 <= m && m <= 100000 && 1 <= v && 1 <= n && 1 <= k && v <= 1000 && n <= 1000 && k <= 1000);
  for (int i = 0; i < m; i++)
    assert(scanf("%d%d", &j[i].t, &j[i].a) == 2), j[i].id = i, assert(1 <= j[i].t && j[i].t <= 1000000 && 1 <= j[i].a && j[i].a <= v);

  ld curtime = (ld)0;
  ld curt = (ld)20;
  int curv = 0;

  sort (j, j + m, check);

  for (int i = 0; i < m; i++)
  {
    if (curtime < j[i].t)
      curt = max((ld)20, curt - (j[i].t - curtime) * k), curtime = j[i].t;

    if (curv < j[i].a)
    {
      curt = (curv * curt + (ld)20 * (v - curv)) / v;
      curv = v;
    }

    curtime += ((100 - curt) * (curv)) / n;
    curt = (ld)100;
    curv -= j[i].a;

    ans[j[i].id] = curtime;
  }

  for (int i = 0; i < m; i++)
    printf ("%.8lf\n", ans[i]);

  return 0;
}

