#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;

#define pb push_back
#define sz(a) (int)a.size()
#define zero(a) memset (a, 0, sizeof(a))
#define mp make_pair
#define inf ((int)1e9)

#define taskname "teams"

int e, Head[210], Next[210*210*2], Dest[210*210*2], V[210*210*2], C[210*210*2];
int D[210], Prev[210], PrevE[210];
bool u[210];
int Ans[210], n;
int A[210], P[110][2], E[110];
int bq, eq, Q[210*210*210];

void add2 (int v1, int v2, int v, int c)
{
  V[e]=v, C[e]=c, Dest[e]=v2;
  Next[e]=Head[v1];
  Head[v1]=e;
  e++;
}

void add (int v1, int v2, int v, int c)
{  
  add2(v1,v2,v,c), add2(v2,v1,0,-c);
}

int main (void)
{
  int i, j, flow, r, v;
  freopen (taskname".in", "r", stdin);
  freopen (taskname".out", "w", stdout);
  memset(Head,-1,sizeof(Head));
  assert(scanf("%d", &n)==1);
  for (i=0; i<2*n; i++)
    assert(scanf("%d", &A[i])==1), A[i]--;
  for (i=0; i<2*n; i++)
    P[A[i]][E[A[i]]]=i, E[A[i]]++;
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      add(i+1,j+1+n,1,abs(P[i][0]-j)+abs(P[i][1]-j-n));
  for (i=0; i<n; i++)
    add(0,i+1,1,0), add(i+n+1,2*n+1,1,0);
  for (flow=0; flow<n; flow++)
  {
    for (j=1; j<=2*n+1; j++)
      D[j]=inf;
    bq=0, eq=1;
    while (bq<eq)
    {
      v=Q[bq];
      for (r=Head[v]; r!=-1; r=Next[r])
        if (V[r]>0 && C[r]+D[v]<D[Dest[r]])
        {
          D[Dest[r]]=D[v]+C[r], Prev[Dest[r]]=v, PrevE[Dest[r]]=r;
          if (!u[Dest[r]])
            u[Dest[r]]=1, Q[eq]=Dest[r], eq++;
        }
      u[v]=0, bq++;                                           
    }
    assert(D[2*n+1]<inf);
    v=2*n+1;
    while (v!=0)
      V[PrevE[v]]--, V[PrevE[v]^1]++, v=Prev[v];
  }
  for (i=1; i<=n; i++)
    for (r=Head[i]; r!=-1; r=Next[r])
      if (V[r]==0 && Dest[r]>n)
        Ans[Dest[r]-1-n]=i, Ans[Dest[r]-1]=i;
  for (i=0; i<2*n; i++)
    printf("%d ", Ans[i]);
  printf("\n");
  return 0;
}

