#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <iomanip>
#define nextLine() { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define task "teams"
using namespace std;

#define pii pair<int,int>
#define mp make_pair
#define pb push_back
#define fi first
#define se second

typedef long long LL;
typedef long double ldb;

const int inf = (1 << 30) - 1;
const ldb eps = 1e-9;
const ldb pi = fabs(atan2(0.0, -1.0));

int n;
int a[205];

void Load()
{
	scanf("%d", &n);
	for (int i = 0; i < 2 * n; i++)
		scanf("%d", &a[i]);
}

const int maxIt = 800;

bool used[205];

void Solve()
{
	srand(1710923);
	int best = inf;
	vector <int> bp;

	vector <int> lp(n);
	for (int i = 0; i < n; i++)
		lp[i] = i + 1;

	for (int it = 0; it < maxIt; it++)
	{
		vector <int> p;
		for (int i = 0; i < 2; i++)
		{
			for (int j = 0; j < n; j++)
				p.pb(lp[j]);
		}

		memset(used, false, sizeof(used));
		int cur = 0;
		for (int i = 0; i < 2 * n; i++)
		{
			for (int j = 0; j < 2 * n; j++)
				if (p[j] == a[i] && !used[j])
				{
					cur += abs(j - i);
					used[j] = true;
					break;
				}
		}
		if (cur < best)
		{
			best = cur;
			bp = p;
		}
		
		if (it % 20 == 19)
			random_shuffle(lp.begin(), lp.end());
		else
			next_permutation(lp.begin(), lp.end());	
	}

	for (int i = 0; i < 2 * n; i++)
		printf("%d ", bp[i]);
}

int main()
{
	freopen(task".in","r",stdin);
	freopen(task".out","w",stdout);
	Load();
	Solve();
	return 0;
}
