import java.io.*;
import java.util.*;

public class pisa_av {

	void solve(int n) throws Exception {
		long[] ans = new long[n];
		if (n == 1) {
			out.println(1);
			return;
		}
		if (n == 2) {
			out.println(3);
			return;
		}
		ans[0] = 1;
		ans[1] = 3;
		for (int i = 2; i < n; i++) {
			ans[i] = ans[i - 1] + ans[i - 2] + 1;
		}
		out.println(ans[n - 1]);
	}
	
	void run() {
		try {
			in = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			//			in = new BufferedReader(new InputStreamReader(System.in));
			//			out = new PrintWriter(System.out);

			solve(nextInt());
			
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;
	final String filename = new String("Pisa").toLowerCase();

	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

	public static void main(String[] args) {
		new pisa_av().run();
	}

}
