import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class pisa_vd {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};
	
	long res[][];
	
	long count(int n,int hash)
	{
		if (res[n][hash]!=-1)
			return res[n][hash];
		if (hash/100==2)
			return 1;
		if (n==1)
			return 1;
		int a=hash/100;
		int b=hash/10%10;
		if (a==1 && b==3)
		{
			res[n][132]=count(n-1,123)+1+count(n-1,231);
			return res[n][132];
		}
		if (a==3 && b==1)
		{
			res[n][312]=count(n-1,321)+1+count(n-1,213);
			return res[n][312];
		}
		if (a==1 && b==2)
		{
			res[n][123]=count(n-1,132)+1+count(n-1,321);
			return res[n][123];
		}
		if (a==3 && b==2)
		{
			res[n][321]=count(n-1,312)+1+count(n-1,123);
			return res[n][321];
		}
		return 0;
	}

	void solve() throws IOException {
		int n=nextInt();
		res=new long[n+1][1000];
		for (int i=0; i<=n; i++)
		Arrays.fill(res[i], -1);
		out.println(count(n,132));
		
	};

	void run() throws IOException {

		in = new BufferedReader(new FileReader("pisa.in"));
		out = new PrintWriter("pisa.out");
		solve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new pisa_vd().run();
	}

}
