import java.io.*;
import java.util.StringTokenizer;

public class quadro_vd {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};

	char[][] a;

	int[] solve(int n, int stx, int sty) {
		if (n == 1) {
			int[] res = { 1 };
			return res;
		}
		int enx = stx + n;
		int eny = sty + n;
		int x[][] = new int[4][];
		x[0] = solve(n / 2, stx, sty);
		x[1] = solve(n / 2, stx + n / 2, sty);
		x[2] = solve(n / 2, stx, sty + n / 2);
		x[3] = solve(n / 2, stx + n / 2, sty + n / 2);
		int sum = 0;
		for (int i = stx; i < enx; i++)
			for (int j = sty; j < eny; j++)
				sum = sum + a[i][j] - '0';
		if (n * n - sum < sum)
			sum = n * n - sum;
		int res[] = new int[n * n];
		for (int i = sum; i < n * n; i++)
			res[i] = 1;
		int a[][] = new int[4][n * n];
		for (int i = 0; i < n * n / 4; i++)
			a[0][i] = x[0][i];
		for (int i=n*n/4; i<=sum; i++)
			a[0][i]=1;
		for (int i = 1; i < 4; i++)
		{
			for (int j = 0; j <= sum; j++) {
				a[i][j] = Integer.MAX_VALUE/2;
				for (int t = 0; t < n * n / 4; t++) {
					if (j < t)
						break;
					if (a[i][j] > a[i - 1][j - t] + x[i][t])
						a[i][j] = a[i - 1][j - t] + x[i][t];
				}
			}
		}
		for (int i = 0; i < sum; i++)
			res[i] = a[3][i] + 1;
		return res;

	}

	void solve() throws IOException {
		int n = nextInt();
		int k=nextInt();
		if (k==n*n) k--;
		a = new char[n][];
		for (int i = 0; i < n; i++)
			a[i] = next().toCharArray();
		out.println(solve(n, 0, 0)[k]);
	};

	void run() throws IOException {

		in = new BufferedReader(new FileReader("quadro.in"));
		out = new PrintWriter("quadro.out");
		solve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new quadro_vd().run();
	}

}
