#include <iostream>
#include <cstdio>
#include <set>
#include <algorithm>

using namespace std;

struct g {
	int t, num;
};

bool operator < ( g a, g b ) {
	return (a.t > b.t);
}

struct node {
	int num, next, cnt;

	node () {}
	node ( int num, int next, int cnt ) {
		node :: num = num;
		node :: next = next;
		node :: cnt = cnt;
	}
};

bool operator < ( node a, node b ) {
	return ( a.next > b.next );
}

const int N = (int) 1e5;

set <node> s;
int n, k, ans[N];
g t[N];

int main () {
	freopen("swords.in", "r", stdin);
	freopen("swords.out", "w", stdout);

	cin >> n >> k;
	
	for ( int i = 0; i < n; i++ ) {
		int a;
		cin >> a;

		t[i].t = a;
		t[i].num = i + 1;
	}

	sort(t, t + n);			 
	
	s.insert(node(t[0].num, t[0].t, 0));
	ans[t[0].num] = 0;
	  
	for ( int i = 1; i < n; i++ ) {
		set <node> :: iterator iter = s.begin();
		s.erase(s.begin());

		node m = *iter;

		if ( m.next >= t[i].t ) {
			ans[t[i].num - 1] = m.num;
			
			m.cnt++;
			m.next = t[i].t - k;

			s.insert(node(t[i].num, t[i].t - 1, 0));
			
			if ( m.cnt < 2 )
				s.insert(m);	
		}
		else {
			cout << -1 << endl;
			return 0;
		}
	}

	for ( int i = 0; i < n; i++ )
		cout << ans[i] << ' ';

	return 0;
}