import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;


public class Garden
{
	static BufferedReader in;
	static BufferedWriter out;
	static StringTokenizer st;
	static String nextToken()
	{
		while (st==null|| !st.hasMoreTokens())
		{
			try
			{
				st=new StringTokenizer(in.readLine());
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	static int nextInt()
	{
		return Integer.parseInt(nextToken());
	}
	static void trace(String s)
	{
		System.out.println(s);
	}
	static void trace(int s)
	{
		System.out.println(s);
	}
	public static void main(String args[])
	{
		try
		{
			in=new BufferedReader(new FileReader("garden.in"));
			out=new BufferedWriter(new FileWriter("garden.out"));
			int n=nextInt();
			int m=nextInt();
			int h=nextInt();
			int p[]=new int[n];
			int sum=0;
			boolean ok=true;
			for (int i=0;i<n;i++)
			{
				int a=nextInt();
				int b=nextInt();
				if ((a+b*(m-1))<h)
				{
					ok=false;
					break;
				}
				int c=1+(b*m)/h;
				p[i]=c;
				if (p[i]>sum)
				{
					sum=p[i];
				}
			}
			if (ok)
				out.write(sum+"");
			else
			{
				out.write("-1");
			}
			in.close();
			out.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
