#include <cstdio>
#include <iostream>
#include <vector>

using namespace std;

#define pb push_back
#define N int(1e5 + 5)

typedef long long LL;

vector<int> a[3];
bool used[N];

int main() {
	freopen("weights.in", "r", stdin);
	freopen("weights.out", "w", stdout);
	
	LL n;
	cin >> n;

	LL sum = n * (n + 1) / 2;

	if (sum % 3 || n <= 3) {
		cout << "Impossible\n";
		return 0;
	}	

	sum /= 3;

	a[0].pb(n);	
	LL s1 = n, s2 = 0;
	used[n] = true;

	for (int i = n - 1; i >= 1; i--) {
		if (s1 + i <= sum) {
			s1 += i;
			used[i] = true;
			a[0].pb(i);
		}
	}
	
	for (int  i = n; i >= 1; i--) {
		if (!used[i]) {
			if (s2 + i <= sum) {
				s2 += i;
				used[i] = true;
				a[1].pb(i);
			}
		}
	}

	if (s2 != sum) {	
		cout << "Impossible\n";
		return 0;		
	}

	for (int i = 1; i <= n; i++)
		if (!used[i])
			a[2].pb(i);

	for (int i = 0; i < 3; i++) {
		cout << a[i].size() << endl;
		for (int j = 0; j < a[i].size(); j++) {
			cout << a[i][j] << " ";		
		}
		cout << endl;
	}

	return 0;
}