#define FNAME "swords"

#include<cstdio>
#include<algorithm>
#include<vector>
#include<set>
using namespace std;

typedef long long LL;
#define forn(i,N) for(int i=0;i<(N);++i)

const int MAX_N=1e5+5;
pair<int,int> Z[MAX_N];
int Prev[MAX_N];
int Count[MAX_N];
set<pair<int,int> > Q;

int main(){
	freopen(FNAME".in","r",stdin);
	freopen(FNAME".out","w",stdout);

	int n,k,a;
	scanf("%d%d",&n,&k);
	forn(i,n){
		scanf("%d",&a);
		Z[i]=make_pair(-a,i);
	}
	sort(Z,Z+n);

	Q.insert(Z[0]);
	Prev[Z[0].second]=-1;
	for(int i=1;i<n;++i){
		if(Q.empty()){
			puts("-1");
			return 0;
		}
		pair<int,int> t=*Q.begin();
		if(Z[i].first-t.first<k){
			puts("-1");
			return 0;
		}

		Prev[Z[i].second]=t.second;
		++Count[t.second];
		if(Count[t.second]==2)
			Q.erase(t);
		Q.insert(Z[i]);
	}

	forn(i,n)
		printf("%d ",Prev[i]+1);
	puts("");

	return 0;
}