#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <map>

using namespace std;

struct node{
	int to0,to1,cnt;
	map<int,int> a;
	int mn(){
		return min(to0,to1);
	}
};

int t,k;
char a[128][128];
vector<node> tree;

void count(int i, int left, int top, int len){
	tree.resize(max(unsigned(i+1),tree.size()));
	if (len==1){
		if (a[left][top]=='0'){
			tree[i].to0=0;
			tree[i].to1=1;
		} else {
			tree[i].to0=1;
			tree[i].to1=0;
		}
		tree[i].cnt=1;
	} else {
		count(i*4+1,left,top,len/2);
		count(i*4+2,left+len/2,top,len/2);
		count(i*4+3,left,top+len/2,len/2);
		count(i*4+4,left+len/2,top+len/2,len/2);
		tree[i].to0=tree[i].to1=0;
		for (int j=i*4+1; j<=i*4+4; j++){
			tree[i].to0+=tree[j].to0;
			tree[i].to1+=tree[j].to1;
		}
		tree[i].cnt=0;
		for (int j=i*4+1; j<=i*4+4; j++)
			if (tree[j].mn()==0)
				tree[i].cnt++;
			else
				tree[i].cnt+=tree[j].cnt;
	}
}

int ans(int s, int n){
	if (s>=tree.size() || n<=0)
		return 0;
	if (tree[s].a.find(n)==tree[s].a.end())
		tree[s].a[n]=min(ans(s+1,n-(tree[s].cnt-1))+tree[s].mn(),ans(s+1,n));
	return tree[s].a[n];
}

int main(){
	freopen("quadro.in","r",stdin);
	freopen("quadro.out","w",stdout);
	scanf("%d%d\n",&t,&k);
	for (int i=0; i<t; i++)
		scanf("%s\n",a[i]);
	count(0,0,0,t);
	int L=0,R=tree[0].cnt;
	while (L<R-1){
		int M=(L+R)/2;
		if (ans(0,tree[0].cnt-M-1)>k)
			R=M;
		else
			L=M;
	}
	printf("%d\n",L);
	fclose(stdin);
	fclose(stdout);
	return 0;
}