import java.io.*;


public class garden {
	
	public static void main(String[] args) throws IOException {
		PrintWriter out = null;
		StreamTokenizer in = new StreamTokenizer(new BufferedReader(new InputStreamReader(new FileInputStream(new File("garden.in")))));
		try {
			out = new PrintWriter(new File("garden.out"));
		} catch (IOException e) {
			out = new PrintWriter(System.out);
		}
		in.nextToken();
		int n = (int) in.nval;
		in.nextToken();
		long days = (int) in.nval;
		in.nextToken();
		long required = (long) in.nval;
		Bamboo[] arr = new Bamboo[n];
		for(int i = 0; i < n; i++){
			in.nextToken();
			int a = (int) in.nval;
			in.nextToken();
			int b = (int) in.nval;
			arr[i] = new Bamboo(a, b);
		}
		for(int i = 1; i < days; i++)
			for(Bamboo x : arr)
				x.grow();
		if(required > minHeight(arr)){
			out.println(-1);
			out.close();
			return;
		}
		if(canSkip(arr, required)){
			out.println(0);
			out.close();
			return;
		}
		out.println(1);
		out.close();
	}

	private static long minHeight(Bamboo[] a){
		long result = Integer.MAX_VALUE;
		for(Bamboo i : a){
			long x = i.height();
			result = (x < result) ? x : result;
		}
		return result;
	}
	
	private static boolean canSkip(Bamboo[] a, long required){
		for(Bamboo i : a){
			if(i.height() != required){
				return false;
			}
		}
		return true;
	}
}

class Bamboo {
	private long height;
	private final int grow;
	
	Bamboo(int a, int b){
		height = a;
		grow = b;
	}
	
	public long height(){
		return height;
	}
	
	void grow(){
		height += grow;
	}
}