import java.io.*;
import java.util.*;


public class Number {
		public static void main(String[] args) {
			Scanner in = null;
			PrintWriter out = null;
			try {
				in = new Scanner(new File("number.in"));
				out = new PrintWriter(new File("number.out"));
			} catch (IOException e) {
				in = new Scanner(System.in);
				out = new PrintWriter(System.out);
			}
			String s = in.nextLine();
			long possible = 0; 
			for(int div = 1; div < s.length(); div++){
				String s1 = s.substring(0, div);
				String s2 = s.substring(div);
				if(s1.charAt(0) == '0' || s2.charAt(0) == '0')
					continue;
				if(compareTo(s1, s2) == 1)
					break;
				possible++;
//				System.out.println(" DEBUG " + compareTo(s1, s2) + " on " + s1 + " " + s2);
			}
			out.println(possible);
			in.close();
			out.close();
		}
		
		private static int compareTo(String a, String b){
			if(a.length() < b.length()){
				return -1;
			}
			if(a.length() > b.length()){
				return 1;
			}
			for(int i = 0; i < a.length();){
				if(num(a.charAt(i)) < num(b.charAt(i)))
					return -1;
				if(num(a.charAt(i)) > num(b.charAt(i)))
					return 1;
				i++;
			}
			return 0;
		}
		
		private static int num(char a){
			return a - '0';
		}
}
