import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemB {

	String fileName = "garden";
	boolean debugOn = false;

	public void start() throws Exception {
		int n = nextInt();
		long m = nextLong();
		long h = nextLong();
		long[] a = new long[n];
		long[] b = new long[n];
		long[] endH = new long[n];
		boolean good = true;
		boolean good2 = true;
		for (int i = 0; i < n; i++) {
			a[i] = nextLong();
			b[i] = nextLong();
			endH[i] = a[i] + b[i] * (m - 1);
			if (endH[i] < h) {
				good = false;
			}
			if (endH[i] != h) {
				good2 = false;
			}
		}
		if (good2) {
			out.println(0);
		} else if (good)
			out.println(1);
		else
			out.println(-1);

	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemB();
	}

	public ProblemB() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String delim = " ";
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
