import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class ProblemC {

	String fileName = "number";
	boolean debugOn = false;

	String s;

	public void start() throws Exception {
		int tmp = nextInt();
		s = getCurrentLine();
		if (s.charAt(0) == '0')
			out.println("0");
		else {
			int m = s.length() / 2;
			while (m >= 1 && s.charAt(m) == '0') {
				m--;
			}
			if (m == 0) {
				out.println(0);
			} else {
				int count = 0;
				for (int i = 1; i <= m; i++) {
					if (s.charAt(i) == '0') {
						count++;
					}
				}
				out.println(m - count);
			}
		}
	}

	public int sqr(int a) {
		return a * a;
	}

	public long sqr(long a) {
		return a * a;
	}

	public static void main(String[] args) throws Exception {
		new ProblemC();
	}

	public ProblemC() throws Exception {
		init();
		start();
		end();
	}

	public void print(String s) {
		if (debugOn) {
			System.out.print(s);
		}
	}

	public void println(String s) {
		if (debugOn) {
			System.out.println(s);
		}
	}

	public void end() {
		out.close();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	String delim = " ";
	String currentLine;

	public void init() throws Exception {
		in = new BufferedReader(new FileReader(fileName + ".in"));
		out = new PrintWriter(fileName + ".out");
		currentLine = in.readLine();
		tok = new StringTokenizer(currentLine, delim);
	}

	public String nextWord() throws Exception {
		while (!tok.hasMoreTokens()) {
			currentLine = in.readLine();
			tok = new StringTokenizer(currentLine);
		}
		return tok.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextWord());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextWord());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(tok.nextToken());
	}

	public String getCurrentLine() {
		return currentLine;
	}
}
