
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class B implements Runnable {
	
	private void Solution() throws IOException {
		int n = nextInt(), m = nextInt(), h = nextInt(), max = 0;
		int[] bamb = new int[n], rost = new int[n];
		for (int i = 0; i < n; i ++) {
			bamb[i] = nextInt();
			rost[i] = nextInt();
		}
		for (int i = 0; i < n; i ++) {
			int t = 0;
			boolean small = true;
			while (small) {
				bamb[i] += rost[i];
				t ++;
				if (bamb[i] >= h)
					small = false;
			}
			max = Math.max(max, t);
		}
		if (max < m) 
			out.print("1"); else
				out.print("-1");
	}
	
	public static void main(String args[]) {
		new B().run();
	}
	
	BufferedReader in;
	StringTokenizer tokenizer;
	PrintWriter out;
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader(new File("garden.in")));
			tokenizer = null;
			out = new PrintWriter(new File("garden.out"));
			Solution();
			in.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreElements())
			tokenizer = new StringTokenizer(in.readLine());
		return tokenizer.nextToken();
	}
}
