program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
  b : array[1..3, -1..100000] of int64;
  vis : array[1..100000] of boolean;
  sum, n, ans : int64;
  i, j : integer;

begin
  reset(input, 'weights.in');
  rewrite(output, 'weights.out');

  read(n);

  if (n * (n + 1) div 2) mod 3 <> 0 then begin
     Writeln('Impossible');
      close(input);
      close(output);
      halt;
  end;

  ans := n * (n + 1) div 6;

  for i := 1 to 3 do begin
    sum := 0;
    for j := n downto 1 do begin
      if (sum + j <= ans) and (not vis[j]) then begin
        vis[j] := true;
        sum := sum + j;
        inc(b[i][0]);
        b[i][b[i][0]] := j;
      end;
    end;
    if sum <> ans then begin
      Writeln('Impossible');
      close(input);
      close(output);
      halt;
    end;
    b[i][-1] := sum;
  end;

  for i := 1 to n do begin
    if not vis[i] then begin
      Writeln('Impossible');
      close(input);
      close(output);
      halt;
    end;
  end;

  for i := 1 to 3 do begin
    writeln(b[i][0]);
    for j := 1 to b[i][0] do
      write(b[i][j], ' ');
    writeln;
  end;


  close(input);
  close(output);
end.
