#include<cstdio>
#include<iostream>
using namespace std;
const int MAX = (int)1e6;
bool was[MAX];

bool is_good(int d, int m, int y)
{
  if(m > 12 || m < 1 || d < 1)
    return false;
  if(y%4 == 0 && y%100 != 0)
  {
    if(m == 2 && d > 29)
      return false;
  }
  else
  {
    if(m == 2 && d > 28)
      return false;
  }
  if(m == 4 || m == 6 || m == 9 || m == 11)
  {
    if(m > 30)
      return false;
  }
  else
  {
    if(m > 31)
      return false;
  }
  return true;
}

void print(int d, int m, int y)
{
  if(d < 10)
    printf("0");
  printf("%d/", d);
  if(m < 10)
    printf("0");
  printf("%d/", m);
  if(y < 10)
    printf("0");
  printf("%d\n", y);
}
int main()
{
  int d, m, y;
  bool flag = false;
  freopen("chronicle.in", "r", stdin);
  freopen("chronicle.out", "w", stdout);
  scanf("%d/%d/%d", &d, &m, &y);
  if(!was[d*1000+m*100+y])
  {
    was[d*1000+m*100+y] = true;
    if(is_good(d,m,y))
      flag = true, print(d, m, y);
  }
  if(!was[d*1000+y*100+m])
  {
    was[d*1000+y*100+m] = true;
    if(is_good(d,y,m))
      flag = true, print(d, y, m);
  }
  if(!was[m*1000+d*100+y])
  {
    was[m*1000+d*100+y] = true;
    if(is_good(m,d,y))
      flag = true, print(m, d, y);
  }
  if(!was[m*1000+y*100+d])
  {
    was[m*1000+y*100+d] = true;
    if(is_good(m,y,d))
      flag = true, print(m, y, d);
  }
  if(!was[y*1000+m*100+d])
  {
    was[y*1000+m*100+d] = true;
    if(is_good(y,m,d))
      flag = true, print( y, m, d);
  }
  if(!was[y*1000+d*100+m])
  {
    was[y*1000+d*100+m] = true;
    if(is_good(y,d,m))
      flag = true, print(y, d, m);
  }
  if(!flag)
    printf("No such date\n");
  return 0;
}