import java.io.*;
import java.util.StringTokenizer;
import java.util.Vector;


public class C {
	public static Vector<String> valids = new Vector<String>();
	
	public static boolean isValid(int day, int month, int year)
	{
		int[] dim = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
		if (year % 4 == 0)
			dim[2] ++;
		if (year % 100 == 0)
			dim[2] --;
		if (month > 12 || month < 1)
			return false;
		if (year > 99 || year <= 0)
			return false;
		if (day < 1 || day > dim[month])
			return false;
		return true;
	}
	
	public static void check(int day, int month, int year)
	{
		String ms = makeString(day, month, year);
		if (isValid(day, month, year))
			if (!valids.contains(ms))
			valids.add(ms);
	}
	
	public static String makeString(int a, int b, int c)
	{
		String s = "";
		if (a < 10)
			s += "0";
		s += a;
		s +=  "/";
		if (b < 10)
			s += "0";
		s += b;
		s +=  "/";
		if (c < 10)
			s += "0";
		s += c;
		return s;
	}
	
   public static void main(String[] argc) throws Exception
   {
	   BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(new File("chronicle.in"))));
	   BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("chronicle.out"))));
	   //BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	   //BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));
	   String s = in.readLine();
	   StringTokenizer st = new StringTokenizer(s, "/");
	   int a = Integer.parseInt(st.nextToken());
	   int b = Integer.parseInt(st.nextToken());
	   int c = Integer.parseInt(st.nextToken());
	   check(a, b, c);
	   check(a, c, b);
	   check(b, a, c);
	   check(b, c, a);
	   check(c, a, b);
	   check(c, b, a);
	   if (valids.size() > 0)
	   {
		   for (int i = 0; i < valids.size(); i++)
			   out.write(valids.get(i) + "\n");
	   }
	   else
		   out.write("No such date");
	   in.close();
	   out.close();
   }
}
