#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "number"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int cmp(char *s1, int l1, char *s2, int l2) {
  if (l1 < l2) return -1;
  if (l1 > l2) return 1;

  for (int i = 0; i < l1; i++) {
    if (s1[i] < s2[i]) return -1;
    if (s1[i] > s2[i]) return 1;
  }
  return 0;
}

const int MAXL = 2e5;
char s[MAXL + 1000];

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  while (scanf("%s", s) >= 1) {
    if (s[0] == '0') {
      printf("0\n");
      continue;
    }
    int l = strlen(s);

    int res = 0;
    for (int s2 = 1; s2 < l; s2++) {
      if (s[s2] == '0') continue;
      if (cmp(s + 0, s2, s + s2, l - s2) <= 0)
        res++;
    }
    printf("%d\n", res);
  }
  return 0;
}
