#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "pisa"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

const int maxn = 41;
ll d[maxn][2];
// 00 01

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  d[0][0] = d[0][1] = 0;
	for (int i = 1; i < maxn; i++) {
		d[i][0] = d[i - 1][1] + 1 + !!(i - 1);
 		d[i][1] = 2 * d[i - 1][0] + 1;
 	} 
  int n;
  while (scanf("%d", &n) >= 1) {
		printf("%I64d\n", d[n][0]);  	  
  }
  return 0;
}
