#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <vector>
#include <iostream>

using namespace std;

#define pb push_back
#define mp make_pair
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define sz(x) ((int)(x).size())
#define EPS (1e-8)
#define INF int(1e9)
#define TASKNAME "weights"

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef pair<int, int> pii;

int main() {
  freopen(TASKNAME ".in", "r", stdin);
  freopen(TASKNAME ".out", "w", stdout);

  int n;
  while (scanf("%d", &n) >= 1) {
		int m = n % 3;
		if (n <= 3 || m == 1) {
			printf("Impossible\n");
			continue;
		}
		int n0 = n;

		vi ans[3];
		if (!m) {
			for (; n - 6 > 3; n -= 6) {
				ans[0].pb(n); 
				ans[0].pb(n - 5);
				ans[1].pb(n - 1); 
				ans[1].pb(n - 4);
				ans[2].pb(n - 2); 
				ans[2].pb(n - 3);
			}
			if (n == 6) {
				ans[0].pb(1);
				ans[0].pb(6);
				ans[1].pb(2);
				ans[1].pb(5);
				ans[2].pb(3);
				ans[2].pb(4);
			} else {
				assert(n == 9);
				ans[0].pb(1);
				ans[0].pb(5);
				ans[0].pb(9);

				ans[1].pb(2);
				ans[1].pb(6);
				ans[1].pb(7);
				
				ans[2].pb(3);
				ans[2].pb(4);
				ans[2].pb(8);
			}
		} else {
			assert(m == 2);
			for (; n - 6 > 2; n -= 6) {
				ans[0].pb(n); 
				ans[0].pb(n - 5);
				
				ans[1].pb(n - 1); 
				ans[1].pb(n - 4);
				
				ans[2].pb(n - 2); 
				ans[2].pb(n - 3);
			}

			if (n == 5) {
				ans[0].pb(5);
				ans[1].pb(1);
				ans[1].pb(4);
				ans[2].pb(2);
				ans[2].pb(3);
			} else {
				assert(n == 8);
				ans[0].pb(1);
				ans[0].pb(2);
				ans[0].pb(3);
				ans[0].pb(6);

				ans[1].pb(4);
				ans[1].pb(8);
				ans[2].pb(5);
				ans[2].pb(7);
			}
		}

		for (int i = 0; i < 3; i++) {
		  int sz = ans[i].size();
			printf("%d\n", sz);
			for (int j = 0; j < sz; j++)
				printf("%d%c", ans[i][j], " \n"[j == sz - 1]);
		}

		//assert

		vb used(n0, 0);
		for (int i = 0; i < 3; i++) {
			ll sum = 0;
			for (int j = 0; j < (int)ans[i].size(); j++)
				used[ans[i][j] - 1] = 1, sum += ans[i][j];
			assert(sum == (ll(n0) * (n0 + 1) / 6));
		}

		for (int i = 0; i < n0; i++)
			assert(used[i]); 
  }
  return 0;
}
