fin = open("chronicle.in", "r")
fout = open("chronicle.out", "w")

x, y, z = map(int, fin.readline().split('/'))

longMonths = [1, 3, 5, 7, 8, 10, 12]

result = set([])
for (a, b, c) in ((x, y, z), (x, z, y), (y, x, z), (y, z, x), (z, x, y), (z, y, x)):
    if b == 0 or a == 0:
        continue
    if b > 12:
        continue
    if a <= 28:
        result.add((a, b, c))
        continue
    if a == 29:
        if b != 2:
            result.add((a, b, c))
            continue
        else:
            if c % 4 == 0 and c != 0:
                result.add((a, b, c))
            continue
    if a == 30:
        if b != 2:
            result.add((a, b, c))
        continue
    if a == 31:
        if b in longMonths:
            result.add((a, b, c))
            continue

if len(result) == 0:
    fout.write("No such date")
else:
    for elem in result:
        sa, sb, sc = map(lambda n: ("0" if n < 10 else "") + str(n), elem)
        fout.write("%s/%s/%s\n" % (sa, sb, sc))