import java.io.*;
import java.util.*;

public class number implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new number()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("number.in"));
			out = new PrintWriter(new FileWriter("number.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	int compareNums(String n1, String n2) {
		int len1 = n1.length();
		int len2 = n2.length();
		if (len1 > len2)
			return 1;
		else if (len1 < len2)
			return -1;
		else {
			int i = 0;
			for (; i < len1 && n1.charAt(i) == n2.charAt(i); i++) {}
			if (i == len1) {
				return 0;
			}
			else {
				return n1.charAt(i) > n2.charAt(i) ? 1 : -1;
			}
		}
	}
	
	void solve() throws NumberFormatException, IOException {
		String str = nextToken();
		if (str.charAt(0) == '0') {
			out.print(0);
			return;
		}
		int len = str.length();
		int result = 0;
		int lim = 0;
		if ((len % 2) == 0) {
			lim = len / 2 + 1;
		}
		else {
			lim = (len - 1) / 2 + 1;
		}
		for (int i = 1; i < lim; i++) {
			if (str.charAt(i) == '0') {
				continue;
			}
			if (compareNums(str.substring(0, i), str.substring(i)) <= 0) {
				result += 1;
			}
		}
		out.print(result);
	}
}
