import java.io.*;
import java.util.*;

public class pisa implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new pisa()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("pisa.in"));
			out = new PrintWriter(new FileWriter("pisa.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		long[] f = new long[n];
		long[] g = new long[n];
		f[0] = 1;
		g[0] = 1;
		for (int i = 1; i < n; i++) {
			f[i] = g[i-1] + 2;
			g[i] = f[i-1] + g[i-1] + 1;
		}
		out.print(f[n-1]);
	}
}
