import java.io.*;
import java.util.*;

public class weights implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new weights()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("weights.in"));
			out = new PrintWriter(new FileWriter("weights.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws NumberFormatException, IOException {
		int n = nextInt();
		boolean[] used = new boolean[n];
		if (n % 3 == 1 || n < 5) {
			out.print("Impossible");
			return;
		}
		for (int i = 0; i < n; i++) {
			used[i] = false;
		}
		int sum = n * (n + 1) / 6;
		int fstsum = 0;
		ArrayList<Integer> w1 = new ArrayList<Integer>();
		for (int i = n; i >= 1; i--) {
			if (fstsum + i > sum) continue;
			fstsum += i;
			used[i-1] = true;
			w1.add(i);
		}
		out.println(w1.size());
		for (int i = 0; i < w1.size(); i++) {
			out.print(w1.get(i) + " ");
		}
		out.print("\n");
		int sndsum = 0;
		ArrayList<Integer> w2 = new ArrayList<Integer>();
		for (int i = n; i >= 1; i--) {
			if (sndsum + i > sum || used[i-1]) continue;
			sndsum += i;
			used[i-1] = true;
			w2.add(i);
		}
		out.println(w2.size());
		for (int i = 0; i < w2.size(); i++) {
			out.print(w2.get(i) + " ");
		}
		out.print("\n");
		int trdnum = 0;
		for (int i = 0; i < n; i++) {
			if (!used[i])
				trdnum++;
		}
		out.println(trdnum);
		for (int i = 0; i < n; i++) {
			if (!used[i])
				out.print((i+1) + " ");
		}
	}
}
