import java.io.*;
import java.util.*;

public class weights implements Runnable{
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	public static void main(String[] args) {
		new Thread(new weights()).start();
	}
	
	public void run() {
		try {
			in = new BufferedReader(new FileReader("weights.in"));
			out = new PrintWriter(new FileWriter("weights.out"));
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(9000);
		} finally {
			out.flush();
			out.close();
		}
	}
	
	String nextToken() throws IOException {
		while(st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(nextToken());
	}
	
	void go(long n) {
		boolean[] used = new boolean[(int)n];
		if (n % 3 == 1 || n < 5) {
			out.println("Impossible");
			return;
		}
		for (int i = 0; i < n; i++) {
			used[i] = false;
		}
		long sum = n * (n + 1) / 6;
		long fstsum = 0;
		ArrayList<Long> w1 = new ArrayList<Long>();
		for (long i = n; i >= 1; i--) {
			if (fstsum + i > sum) continue;
			fstsum += i;
			used[(int)(i-1)] = true;
			w1.add(i);
		}
		out.println(w1.size());
		for (int i = 0; i < w1.size(); i++) {
			out.print(w1.get(i) + " ");
		}
		out.print("\n");
		long sndsum = 0;
		ArrayList<Long> w2 = new ArrayList<Long>();
		for (long i = n; i >= 1; i--) {
			if (sndsum + i > sum || used[(int)(i-1)]) continue;
			sndsum += i;
			used[(int)(i-1)] = true;
			w2.add(i);
		}
		if(sndsum != sum)
			throw new IllegalArgumentException(Long.toString(n) + " " + Long.toString(sndsum));
		out.println(w2.size());
		for (int i = 0; i < w2.size(); i++) {
			out.print(w2.get(i) + " ");
		}
		out.print("\n");
		int trdnum = 0;
		long trdsum = 0;
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				trdnum++;
				trdsum += i + 1;
			}
		}
		if(trdsum != sum)
			throw new IllegalArgumentException(Long.toString(n) + " " + Long.toString(trdsum));
		out.println(trdnum);
		for (int i = 0; i < n; i++) {
			if (!used[i])
				out.print((i+1) + " ");
		}
		out.print("\n");
	}
	
	void solve() throws NumberFormatException, IOException {
		long n = nextLong();
		go(n);
	}
}
